#!/usr/bin/env node
'use strict';

var events = require('events');
var F_ = require('path');
var jU = require('crypto');
var PO = require('os');
var yF = require('tls');
var Bne = require('readline');

function _interopDefault (e) { return e && e.__esModule ? e : { default: e }; }

var F___default = /*#__PURE__*/_interopDefault(F_);
var jU__default = /*#__PURE__*/_interopDefault(jU);
var PO__default = /*#__PURE__*/_interopDefault(PO);
var yF__default = /*#__PURE__*/_interopDefault(yF);
var Bne__default = /*#__PURE__*/_interopDefault(Bne);

/**
 * Tabby Agent
 * https://github.com/tabbyml/tabby/tree/main/clients/tabby-agent
 * Copyright (c) 2023-2024 TabbyML, Inc.
 * Licensed under the Apache License 2.0.
 */
var LU=Object.create;var ul=Object.defineProperty;var BU=Object.getOwnPropertyDescriptor;var FU=Object.getOwnPropertyNames;var qU=Object.getPrototypeOf,MU=Object.prototype.hasOwnProperty;var he=(e=>typeof require<"u"?require:typeof Proxy<"u"?new Proxy(e,{get:(t,r)=>(typeof require<"u"?require:t)[r]}):e)(function(e){if(typeof require<"u")return require.apply(this,arguments);throw Error('Dynamic require of "'+e+'" is not supported')}),yE=e=>t=>{var r=e[t];if(r)return r();throw new Error("Module not found in bundle: "+t)};var vE=(e,t)=>()=>(e&&(t=e(e=0)),t);var I=(e,t)=>()=>(t||e((t={exports:{}}).exports,t),t.exports),UU=(e,t)=>{for(var r in t)ul(e,r,{get:t[r],enumerable:!0});},_E=(e,t,r,n)=>{if(t&&typeof t=="object"||typeof t=="function")for(let i of FU(t))!MU.call(e,i)&&i!==r&&ul(e,i,{get:()=>t[i],enumerable:!(n=BU(t,i))||n.enumerable});return e};var ur=(e,t,r)=>(r=e!=null?LU(qU(e)):{},_E(t||!e||!e.__esModule?ul(r,"default",{value:e,enumerable:!0}):r,e)),$U=e=>_E(ul({},"__esModule",{value:!0}),e);var Vp=I((yae,EE)=>{var SE=Object.prototype.toString;EE.exports=function(t){var r=SE.call(t),n=r==="[object Arguments]";return n||(n=r!=="[object Array]"&&t!==null&&typeof t=="object"&&typeof t.length=="number"&&t.length>=0&&SE.call(t.callee)==="[object Function]"),n};});var NE=I((vae,PE)=>{var IE;Object.keys||(lu=Object.prototype.hasOwnProperty,Hp=Object.prototype.toString,wE=Vp(),Wp=Object.prototype.propertyIsEnumerable,CE=!Wp.call({toString:null},"toString"),xE=Wp.call(function(){},"prototype"),fu=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],fl=function(e){var t=e.constructor;return t&&t.prototype===e},TE={$applicationCache:!0,$console:!0,$external:!0,$frame:!0,$frameElement:!0,$frames:!0,$innerHeight:!0,$innerWidth:!0,$onmozfullscreenchange:!0,$onmozfullscreenerror:!0,$outerHeight:!0,$outerWidth:!0,$pageXOffset:!0,$pageYOffset:!0,$parent:!0,$scrollLeft:!0,$scrollTop:!0,$scrollX:!0,$scrollY:!0,$self:!0,$webkitIndexedDB:!0,$webkitStorageInfo:!0,$window:!0},AE=function(){if(typeof window>"u")return !1;for(var e in window)try{if(!TE["$"+e]&&lu.call(window,e)&&window[e]!==null&&typeof window[e]=="object")try{fl(window[e]);}catch{return !0}}catch{return !0}return !1}(),RE=function(e){if(typeof window>"u"||!AE)return fl(e);try{return fl(e)}catch{return !1}},IE=function(t){var r=t!==null&&typeof t=="object",n=Hp.call(t)==="[object Function]",i=wE(t),s=r&&Hp.call(t)==="[object String]",a=[];if(!r&&!n&&!i)throw new TypeError("Object.keys called on a non-object");var o=xE&&n;if(s&&t.length>0&&!lu.call(t,0))for(var c=0;c<t.length;++c)a.push(String(c));if(i&&t.length>0)for(var l=0;l<t.length;++l)a.push(String(l));else for(var u in t)!(o&&u==="prototype")&&lu.call(t,u)&&a.push(String(u));if(CE)for(var f=RE(t),h=0;h<fu.length;++h)!(f&&fu[h]==="constructor")&&lu.call(t,fu[h])&&a.push(fu[h]);return a});var lu,Hp,wE,Wp,CE,xE,fu,fl,TE,AE,RE;PE.exports=IE;});var hl=I((_ae,kE)=>{var WU=Array.prototype.slice,KU=Vp(),DE=Object.keys,dl=DE?function(t){return DE(t)}:NE(),OE=Object.keys;dl.shim=function(){if(Object.keys){var t=function(){var r=Object.keys(arguments);return r&&r.length===arguments.length}(1,2);t||(Object.keys=function(n){return KU(n)?OE(WU.call(n)):OE(n)});}else Object.keys=dl;return Object.keys||dl};kE.exports=dl;});var pl=I((bae,LE)=>{LE.exports=function(){if(typeof Symbol!="function"||typeof Object.getOwnPropertySymbols!="function")return !1;if(typeof Symbol.iterator=="symbol")return !0;var t={},r=Symbol("test"),n=Object(r);if(typeof r=="string"||Object.prototype.toString.call(r)!=="[object Symbol]"||Object.prototype.toString.call(n)!=="[object Symbol]")return !1;var i=42;t[r]=i;for(r in t)return !1;if(typeof Object.keys=="function"&&Object.keys(t).length!==0||typeof Object.getOwnPropertyNames=="function"&&Object.getOwnPropertyNames(t).length!==0)return !1;var s=Object.getOwnPropertySymbols(t);if(s.length!==1||s[0]!==r||!Object.prototype.propertyIsEnumerable.call(t,r))return !1;if(typeof Object.getOwnPropertyDescriptor=="function"){var a=Object.getOwnPropertyDescriptor(t,r);if(a.value!==i||a.enumerable!==!0)return !1}return !0};});var Kp=I((Sae,FE)=>{var BE=typeof Symbol<"u"&&Symbol,GU=pl();FE.exports=function(){return typeof BE!="function"||typeof Symbol!="function"||typeof BE("foo")!="symbol"||typeof Symbol("bar")!="symbol"?!1:GU()};});var UE=I((Eae,ME)=>{var qE={foo:{}},zU=Object;ME.exports=function(){return {__proto__:qE}.foo===qE.foo&&!({__proto__:null}instanceof zU)};});var VE=I((wae,jE)=>{var YU="Function.prototype.bind called on incompatible ",QU=Object.prototype.toString,XU=Math.max,ZU="[object Function]",$E=function(t,r){for(var n=[],i=0;i<t.length;i+=1)n[i]=t[i];for(var s=0;s<r.length;s+=1)n[s+t.length]=r[s];return n},JU=function(t,r){for(var n=[],i=r||0,s=0;i<t.length;i+=1,s+=1)n[s]=t[i];return n},e8=function(e,t){for(var r="",n=0;n<e.length;n+=1)r+=e[n],n+1<e.length&&(r+=t);return r};jE.exports=function(t){var r=this;if(typeof r!="function"||QU.apply(r)!==ZU)throw new TypeError(YU+r);for(var n=JU(arguments,1),i,s=function(){if(this instanceof i){var u=r.apply(this,$E(n,arguments));return Object(u)===u?u:this}return r.apply(t,$E(n,arguments))},a=XU(0,r.length-n.length),o=[],c=0;c<a;c++)o[c]="$"+c;if(i=Function("binder","return function ("+e8(o,",")+"){ return binder.apply(this,arguments); }")(s),r.prototype){var l=function(){};l.prototype=r.prototype,i.prototype=new l,l.prototype=null;}return i};});var gl=I((Cae,HE)=>{var t8=VE();HE.exports=Function.prototype.bind||t8;});var KE=I((xae,WE)=>{var r8=Function.prototype.call,n8=Object.prototype.hasOwnProperty,i8=gl();WE.exports=i8.call(r8,n8);});var Xn=I((Tae,XE)=>{var ft,Ha=SyntaxError,QE=Function,Va=TypeError,Gp=function(e){try{return QE('"use strict"; return ('+e+").constructor;")()}catch{}},zs=Object.getOwnPropertyDescriptor;var zp=function(){throw new Va},s8=zs?function(){try{return zp}catch{try{return zs(arguments,"callee").get}catch{return zp}}}():zp,$a=Kp()(),a8=UE()(),dr=Object.getPrototypeOf||(a8?function(e){return e.__proto__}:null),ja={},o8=typeof Uint8Array>"u"||!dr?ft:dr(Uint8Array),Ys={"%AggregateError%":typeof AggregateError>"u"?ft:AggregateError,"%Array%":Array,"%ArrayBuffer%":typeof ArrayBuffer>"u"?ft:ArrayBuffer,"%ArrayIteratorPrototype%":$a&&dr?dr([][Symbol.iterator]()):ft,"%AsyncFromSyncIteratorPrototype%":ft,"%AsyncFunction%":ja,"%AsyncGenerator%":ja,"%AsyncGeneratorFunction%":ja,"%AsyncIteratorPrototype%":ja,"%Atomics%":typeof Atomics>"u"?ft:Atomics,"%BigInt%":typeof BigInt>"u"?ft:BigInt,"%BigInt64Array%":typeof BigInt64Array>"u"?ft:BigInt64Array,"%BigUint64Array%":typeof BigUint64Array>"u"?ft:BigUint64Array,"%Boolean%":Boolean,"%DataView%":typeof DataView>"u"?ft:DataView,"%Date%":Date,"%decodeURI%":decodeURI,"%decodeURIComponent%":decodeURIComponent,"%encodeURI%":encodeURI,"%encodeURIComponent%":encodeURIComponent,"%Error%":Error,"%eval%":eval,"%EvalError%":EvalError,"%Float32Array%":typeof Float32Array>"u"?ft:Float32Array,"%Float64Array%":typeof Float64Array>"u"?ft:Float64Array,"%FinalizationRegistry%":typeof FinalizationRegistry>"u"?ft:FinalizationRegistry,"%Function%":QE,"%GeneratorFunction%":ja,"%Int8Array%":typeof Int8Array>"u"?ft:Int8Array,"%Int16Array%":typeof Int16Array>"u"?ft:Int16Array,"%Int32Array%":typeof Int32Array>"u"?ft:Int32Array,"%isFinite%":isFinite,"%isNaN%":isNaN,"%IteratorPrototype%":$a&&dr?dr(dr([][Symbol.iterator]())):ft,"%JSON%":typeof JSON=="object"?JSON:ft,"%Map%":typeof Map>"u"?ft:Map,"%MapIteratorPrototype%":typeof Map>"u"||!$a||!dr?ft:dr(new Map()[Symbol.iterator]()),"%Math%":Math,"%Number%":Number,"%Object%":Object,"%parseFloat%":parseFloat,"%parseInt%":parseInt,"%Promise%":typeof Promise>"u"?ft:Promise,"%Proxy%":typeof Proxy>"u"?ft:Proxy,"%RangeError%":RangeError,"%ReferenceError%":ReferenceError,"%Reflect%":typeof Reflect>"u"?ft:Reflect,"%RegExp%":RegExp,"%Set%":typeof Set>"u"?ft:Set,"%SetIteratorPrototype%":typeof Set>"u"||!$a||!dr?ft:dr(new Set()[Symbol.iterator]()),"%SharedArrayBuffer%":typeof SharedArrayBuffer>"u"?ft:SharedArrayBuffer,"%String%":String,"%StringIteratorPrototype%":$a&&dr?dr(""[Symbol.iterator]()):ft,"%Symbol%":$a?Symbol:ft,"%SyntaxError%":Ha,"%ThrowTypeError%":s8,"%TypedArray%":o8,"%TypeError%":Va,"%Uint8Array%":typeof Uint8Array>"u"?ft:Uint8Array,"%Uint8ClampedArray%":typeof Uint8ClampedArray>"u"?ft:Uint8ClampedArray,"%Uint16Array%":typeof Uint16Array>"u"?ft:Uint16Array,"%Uint32Array%":typeof Uint32Array>"u"?ft:Uint32Array,"%URIError%":URIError,"%WeakMap%":typeof WeakMap>"u"?ft:WeakMap,"%WeakRef%":typeof WeakRef>"u"?ft:WeakRef,"%WeakSet%":typeof WeakSet>"u"?ft:WeakSet};var u8=function e(t){var r;if(t==="%AsyncFunction%")r=Gp("async function () {}");else if(t==="%GeneratorFunction%")r=Gp("function* () {}");else if(t==="%AsyncGeneratorFunction%")r=Gp("async function* () {}");else if(t==="%AsyncGenerator%"){var n=e("%AsyncGeneratorFunction%");n&&(r=n.prototype);}else if(t==="%AsyncIteratorPrototype%"){var i=e("%AsyncGenerator%");i&&dr&&(r=dr(i.prototype));}return Ys[t]=r,r},zE={"%ArrayBufferPrototype%":["ArrayBuffer","prototype"],"%ArrayPrototype%":["Array","prototype"],"%ArrayProto_entries%":["Array","prototype","entries"],"%ArrayProto_forEach%":["Array","prototype","forEach"],"%ArrayProto_keys%":["Array","prototype","keys"],"%ArrayProto_values%":["Array","prototype","values"],"%AsyncFunctionPrototype%":["AsyncFunction","prototype"],"%AsyncGenerator%":["AsyncGeneratorFunction","prototype"],"%AsyncGeneratorPrototype%":["AsyncGeneratorFunction","prototype","prototype"],"%BooleanPrototype%":["Boolean","prototype"],"%DataViewPrototype%":["DataView","prototype"],"%DatePrototype%":["Date","prototype"],"%ErrorPrototype%":["Error","prototype"],"%EvalErrorPrototype%":["EvalError","prototype"],"%Float32ArrayPrototype%":["Float32Array","prototype"],"%Float64ArrayPrototype%":["Float64Array","prototype"],"%FunctionPrototype%":["Function","prototype"],"%Generator%":["GeneratorFunction","prototype"],"%GeneratorPrototype%":["GeneratorFunction","prototype","prototype"],"%Int8ArrayPrototype%":["Int8Array","prototype"],"%Int16ArrayPrototype%":["Int16Array","prototype"],"%Int32ArrayPrototype%":["Int32Array","prototype"],"%JSONParse%":["JSON","parse"],"%JSONStringify%":["JSON","stringify"],"%MapPrototype%":["Map","prototype"],"%NumberPrototype%":["Number","prototype"],"%ObjectPrototype%":["Object","prototype"],"%ObjProto_toString%":["Object","prototype","toString"],"%ObjProto_valueOf%":["Object","prototype","valueOf"],"%PromisePrototype%":["Promise","prototype"],"%PromiseProto_then%":["Promise","prototype","then"],"%Promise_all%":["Promise","all"],"%Promise_reject%":["Promise","reject"],"%Promise_resolve%":["Promise","resolve"],"%RangeErrorPrototype%":["RangeError","prototype"],"%ReferenceErrorPrototype%":["ReferenceError","prototype"],"%RegExpPrototype%":["RegExp","prototype"],"%SetPrototype%":["Set","prototype"],"%SharedArrayBufferPrototype%":["SharedArrayBuffer","prototype"],"%StringPrototype%":["String","prototype"],"%SymbolPrototype%":["Symbol","prototype"],"%SyntaxErrorPrototype%":["SyntaxError","prototype"],"%TypedArrayPrototype%":["TypedArray","prototype"],"%TypeErrorPrototype%":["TypeError","prototype"],"%Uint8ArrayPrototype%":["Uint8Array","prototype"],"%Uint8ClampedArrayPrototype%":["Uint8ClampedArray","prototype"],"%Uint16ArrayPrototype%":["Uint16Array","prototype"],"%Uint32ArrayPrototype%":["Uint32Array","prototype"],"%URIErrorPrototype%":["URIError","prototype"],"%WeakMapPrototype%":["WeakMap","prototype"],"%WeakSetPrototype%":["WeakSet","prototype"]},du=gl(),ml=KE(),c8=du.call(Function.call,Array.prototype.concat),l8=du.call(Function.apply,Array.prototype.splice),YE=du.call(Function.call,String.prototype.replace),yl=du.call(Function.call,String.prototype.slice),f8=du.call(Function.call,RegExp.prototype.exec),d8=/[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g,h8=/\\(\\)?/g,p8=function(t){var r=yl(t,0,1),n=yl(t,-1);if(r==="%"&&n!=="%")throw new Ha("invalid intrinsic syntax, expected closing `%`");if(n==="%"&&r!=="%")throw new Ha("invalid intrinsic syntax, expected opening `%`");var i=[];return YE(t,d8,function(s,a,o,c){i[i.length]=o?YE(c,h8,"$1"):a||s;}),i},g8=function(t,r){var n=t,i;if(ml(zE,n)&&(i=zE[n],n="%"+i[0]+"%"),ml(Ys,n)){var s=Ys[n];if(s===ja&&(s=u8(n)),typeof s>"u"&&!r)throw new Va("intrinsic "+t+" exists, but is not available. Please file an issue!");return {alias:i,name:n,value:s}}throw new Ha("intrinsic "+t+" does not exist!")};XE.exports=function(t,r){if(typeof t!="string"||t.length===0)throw new Va("intrinsic name must be a non-empty string");if(arguments.length>1&&typeof r!="boolean")throw new Va('"allowMissing" argument must be a boolean');if(f8(/^%?[^%]*%?$/,t)===null)throw new Ha("`%` may not be present anywhere but at the beginning and end of the intrinsic name");var n=p8(t),i=n.length>0?n[0]:"",s=g8("%"+i+"%",r),a=s.name,o=s.value,c=!1,l=s.alias;l&&(i=l[0],l8(n,c8([0,1],l)));for(var u=1,f=!0;u<n.length;u+=1){var h=n[u],p=yl(h,0,1),g=yl(h,-1);if((p==='"'||p==="'"||p==="`"||g==='"'||g==="'"||g==="`")&&p!==g)throw new Ha("property names with quotes must have matching quotes");if((h==="constructor"||!f)&&(c=!0),i+="."+h,a="%"+i+"%",ml(Ys,a))o=Ys[a];else if(o!=null){if(!(h in o)){if(!r)throw new Va("base intrinsic for "+t+" exists, but the property is not available.");return}if(zs&&u+1>=n.length){var _=zs(o,h);f=!!_,f&&"get"in _&&!("originalValue"in _.get)?o=_.get:o=o[h];}else f=ml(o,h),o=o[h];f&&!c&&(Ys[a]=o);}}return o};});var hu=I((Aae,ZE)=>{var m8=Xn(),Yp=m8("%Object.defineProperty%",!0),Qp=function(){if(Yp)try{return Yp({},"a",{value:1}),!0}catch{return !1}return !1};Qp.hasArrayLengthDefineBug=function(){if(!Qp())return null;try{return Yp([],"length",{value:1}).length!==1}catch{return !0}};ZE.exports=Qp;});var _l=I((Rae,JE)=>{var y8=Xn(),vl=y8("%Object.getOwnPropertyDescriptor%",!0);if(vl)try{vl([],"length");}catch{vl=null;}JE.exports=vl;});var bl=I((Iae,tw)=>{var v8=hu()(),Xp=Xn(),pu=v8&&Xp("%Object.defineProperty%",!0);if(pu)try{pu({},"a",{value:1});}catch{pu=!1;}var _8=Xp("%SyntaxError%"),Wa=Xp("%TypeError%"),ew=_l();tw.exports=function(t,r,n){if(!t||typeof t!="object"&&typeof t!="function")throw new Wa("`obj` must be an object or a function`");if(typeof r!="string"&&typeof r!="symbol")throw new Wa("`property` must be a string or a symbol`");if(arguments.length>3&&typeof arguments[3]!="boolean"&&arguments[3]!==null)throw new Wa("`nonEnumerable`, if provided, must be a boolean or null");if(arguments.length>4&&typeof arguments[4]!="boolean"&&arguments[4]!==null)throw new Wa("`nonWritable`, if provided, must be a boolean or null");if(arguments.length>5&&typeof arguments[5]!="boolean"&&arguments[5]!==null)throw new Wa("`nonConfigurable`, if provided, must be a boolean or null");if(arguments.length>6&&typeof arguments[6]!="boolean")throw new Wa("`loose`, if provided, must be a boolean");var i=arguments.length>3?arguments[3]:null,s=arguments.length>4?arguments[4]:null,a=arguments.length>5?arguments[5]:null,o=arguments.length>6?arguments[6]:!1,c=!!ew&&ew(t,r);if(pu)pu(t,r,{configurable:a===null&&c?c.configurable:!a,enumerable:i===null&&c?c.enumerable:!i,value:n,writable:s===null&&c?c.writable:!s});else if(o||!i&&!s&&!a)t[r]=n;else throw new _8("This environment does not support defining a property as non-configurable, non-writable, or non-enumerable.")};});var is=I((Pae,sw)=>{var b8=hl(),S8=typeof Symbol=="function"&&typeof Symbol("foo")=="symbol",E8=Object.prototype.toString,w8=Array.prototype.concat,rw=bl(),C8=function(e){return typeof e=="function"&&E8.call(e)==="[object Function]"},nw=hu()(),x8=function(e,t,r,n){if(t in e){if(n===!0){if(e[t]===r)return}else if(!C8(n)||!n())return}nw?rw(e,t,r,!0):rw(e,t,r);},iw=function(e,t){var r=arguments.length>2?arguments[2]:{},n=b8(t);S8&&(n=w8.call(n,Object.getOwnPropertySymbols(t)));for(var i=0;i<n.length;i+=1)x8(e,n[i],t[n[i]],r[n[i]]);};iw.supportsDescriptors=!!nw;sw.exports=iw;});var fw=I((Nae,lw)=>{var cw=Xn(),aw=bl(),T8=hu()(),ow=_l(),uw=cw("%TypeError%"),A8=cw("%Math.floor%");lw.exports=function(t,r){if(typeof t!="function")throw new uw("`fn` is not a function");if(typeof r!="number"||r<0||r>4294967295||A8(r)!==r)throw new uw("`length` must be a positive 32-bit integer");var n=arguments.length>2&&!!arguments[2],i=!0,s=!0;if("length"in t&&ow){var a=ow(t,"length");a&&!a.configurable&&(i=!1),a&&!a.writable&&(s=!1);}return (i||s||!n)&&(T8?aw(t,"length",r,!0,!0):aw(t,"length",r)),t};});var Qs=I((Dae,Sl)=>{var Zp=gl(),Ka=Xn(),R8=fw(),I8=Ka("%TypeError%"),hw=Ka("%Function.prototype.apply%"),pw=Ka("%Function.prototype.call%"),gw=Ka("%Reflect.apply%",!0)||Zp.call(pw,hw),gu=Ka("%Object.defineProperty%",!0),P8=Ka("%Math.max%");if(gu)try{gu({},"a",{value:1});}catch{gu=null;}Sl.exports=function(t){if(typeof t!="function")throw new I8("a function is required");var r=gw(Zp,pw,arguments);return R8(r,1+P8(0,t.length-(arguments.length-1)),!0)};var dw=function(){return gw(Zp,hw,arguments)};gu?gu(Sl.exports,"apply",{value:dw}):Sl.exports.apply=dw;});var Dn=I((Oae,vw)=>{var mw=Xn(),yw=Qs(),N8=yw(mw("String.prototype.indexOf"));vw.exports=function(t,r){var n=mw(t,!!r);return typeof n=="function"&&N8(t,".prototype.")>-1?yw(n):n};});var Jp=I((kae,ww)=>{var D8=hl(),Sw=pl()(),Ew=Dn(),_w=Object,O8=Ew("Array.prototype.push"),bw=Ew("Object.prototype.propertyIsEnumerable"),k8=Sw?Object.getOwnPropertySymbols:null;ww.exports=function(t,r){if(t==null)throw new TypeError("target must be an object");var n=_w(t);if(arguments.length===1)return n;for(var i=1;i<arguments.length;++i){var s=_w(arguments[i]),a=D8(s),o=Sw&&(Object.getOwnPropertySymbols||k8);if(o)for(var c=o(s),l=0;l<c.length;++l){var u=c[l];bw(s,u)&&O8(a,u);}for(var f=0;f<a.length;++f){var h=a[f];if(bw(s,h)){var p=s[h];n[h]=p;}}}return n};});var tg=I((Lae,Cw)=>{var eg=Jp(),L8=function(){if(!Object.assign)return !1;for(var e="abcdefghijklmnopqrst",t=e.split(""),r={},n=0;n<t.length;++n)r[t[n]]=t[n];var i=Object.assign({},r),s="";for(var a in i)s+=a;return e!==s},B8=function(){if(!Object.assign||!Object.preventExtensions)return !1;var e=Object.preventExtensions({1:2});try{Object.assign(e,"xy");}catch{return e[1]==="y"}return !1};Cw.exports=function(){return !Object.assign||L8()||B8()?eg:Object.assign};});var Tw=I((Bae,xw)=>{var F8=is(),q8=tg();xw.exports=function(){var t=q8();return F8(Object,{assign:t},{assign:function(){return Object.assign!==t}}),t};});var Pw=I((Fae,Iw)=>{var M8=is(),U8=Qs(),$8=Jp(),Aw=tg(),j8=Tw(),V8=U8.apply(Aw()),Rw=function(t,r){return V8(Object,arguments)};M8(Rw,{getPolyfill:Aw,implementation:$8,shim:j8});Iw.exports=Rw;});var Dw=I((qae,Nw)=>{var yu=function(){return typeof function(){}.name=="string"},mu=Object.getOwnPropertyDescriptor;yu.functionsHaveConfigurableNames=function(){if(!yu()||!mu)return !1;var t=mu(function(){},"name");return !!t&&!!t.configurable};var H8=Function.prototype.bind;yu.boundFunctionsHaveNames=function(){return yu()&&typeof H8=="function"&&function(){}.bind().name!==""};Nw.exports=yu;});var Lw=I((Mae,kw)=>{var Ow=bl(),W8=hu()(),K8=Dw().functionsHaveConfigurableNames(),G8=TypeError;kw.exports=function(t,r){if(typeof t!="function")throw new G8("`fn` is not a function");var n=arguments.length>2&&!!arguments[2];return (!n||K8)&&(W8?Ow(t,"name",r,!0,!0):Ow(t,"name",r)),t};});var rg=I((Uae,Bw)=>{var z8=Lw(),Y8=Object,Q8=TypeError;Bw.exports=z8(function(){if(this!=null&&this!==Y8(this))throw new Q8("RegExp.prototype.flags getter called on non-object");var t="";return this.hasIndices&&(t+="d"),this.global&&(t+="g"),this.ignoreCase&&(t+="i"),this.multiline&&(t+="m"),this.dotAll&&(t+="s"),this.unicode&&(t+="u"),this.unicodeSets&&(t+="v"),this.sticky&&(t+="y"),t},"get flags",!0);});var ng=I(($ae,Fw)=>{var X8=rg(),Z8=is().supportsDescriptors,J8=Object.getOwnPropertyDescriptor;Fw.exports=function(){if(Z8&&/a/mig.flags==="gim"){var t=J8(RegExp.prototype,"flags");if(t&&typeof t.get=="function"&&typeof RegExp.prototype.dotAll=="boolean"&&typeof RegExp.prototype.hasIndices=="boolean"){var r="",n={};if(Object.defineProperty(n,"hasIndices",{get:function(){r+="d";}}),Object.defineProperty(n,"sticky",{get:function(){r+="y";}}),r==="dy")return t.get}}return X8};});var Uw=I((jae,Mw)=>{var e6=is().supportsDescriptors,t6=ng(),r6=Object.getOwnPropertyDescriptor,n6=Object.defineProperty,i6=TypeError,qw=Object.getPrototypeOf,s6=/a/;Mw.exports=function(){if(!e6||!qw)throw new i6("RegExp.prototype.flags requires a true ES5 environment that supports property descriptors");var t=t6(),r=qw(s6),n=r6(r,"flags");return (!n||n.get!==t)&&n6(r,"flags",{configurable:!0,enumerable:!1,get:t}),t};});var Hw=I((Vae,Vw)=>{var a6=is(),o6=Qs(),u6=rg(),$w=ng(),c6=Uw(),jw=o6($w());a6(jw,{getPolyfill:$w,implementation:u6,shim:c6});Vw.exports=jw;});var Gw=I((Hae,Kw)=>{var Ww=Symbol.iterator;Kw.exports=function(t){if(t!=null&&typeof t[Ww]<"u")return t[Ww]()};});var Yw=I((Wae,zw)=>{zw.exports=he("util").inspect;});var gC=I((Kae,pC)=>{var hg=typeof Map=="function"&&Map.prototype,ig=Object.getOwnPropertyDescriptor&&hg?Object.getOwnPropertyDescriptor(Map.prototype,"size"):null,wl=hg&&ig&&typeof ig.get=="function"?ig.get:null,Qw=hg&&Map.prototype.forEach,pg=typeof Set=="function"&&Set.prototype,sg=Object.getOwnPropertyDescriptor&&pg?Object.getOwnPropertyDescriptor(Set.prototype,"size"):null,Cl=pg&&sg&&typeof sg.get=="function"?sg.get:null,Xw=pg&&Set.prototype.forEach,l6=typeof WeakMap=="function"&&WeakMap.prototype,_u=l6?WeakMap.prototype.has:null,f6=typeof WeakSet=="function"&&WeakSet.prototype,bu=f6?WeakSet.prototype.has:null,d6=typeof WeakRef=="function"&&WeakRef.prototype,Zw=d6?WeakRef.prototype.deref:null,h6=Boolean.prototype.valueOf,p6=Object.prototype.toString,g6=Function.prototype.toString,m6=String.prototype.match,gg=String.prototype.slice,as=String.prototype.replace,y6=String.prototype.toUpperCase,Jw=String.prototype.toLowerCase,uC=RegExp.prototype.test,eC=Array.prototype.concat,di=Array.prototype.join,v6=Array.prototype.slice,tC=Math.floor,ug=typeof BigInt=="function"?BigInt.prototype.valueOf:null,ag=Object.getOwnPropertySymbols,cg=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?Symbol.prototype.toString:null,Ga=typeof Symbol=="function"&&typeof Symbol.iterator=="object",kr=typeof Symbol=="function"&&Symbol.toStringTag&&(typeof Symbol.toStringTag===Ga||!0)?Symbol.toStringTag:null,cC=Object.prototype.propertyIsEnumerable,rC=(typeof Reflect=="function"?Reflect.getPrototypeOf:Object.getPrototypeOf)||([].__proto__===Array.prototype?function(e){return e.__proto__}:null);function nC(e,t){if(e===1/0||e===-1/0||e!==e||e&&e>-1e3&&e<1e3||uC.call(/e/,t))return t;var r=/[0-9](?=(?:[0-9]{3})+(?![0-9]))/g;if(typeof e=="number"){var n=e<0?-tC(-e):tC(e);if(n!==e){var i=String(n),s=gg.call(t,i.length+1);return as.call(i,r,"$&_")+"."+as.call(as.call(s,/([0-9]{3})/g,"$&_"),/_$/,"")}}return as.call(t,r,"$&_")}var lg=Yw(),iC=lg.custom,sC=fC(iC)?iC:null;pC.exports=function e(t,r,n,i){var s=r||{};if(ss(s,"quoteStyle")&&s.quoteStyle!=="single"&&s.quoteStyle!=="double")throw new TypeError('option "quoteStyle" must be "single" or "double"');if(ss(s,"maxStringLength")&&(typeof s.maxStringLength=="number"?s.maxStringLength<0&&s.maxStringLength!==1/0:s.maxStringLength!==null))throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');var a=ss(s,"customInspect")?s.customInspect:!0;if(typeof a!="boolean"&&a!=="symbol")throw new TypeError("option \"customInspect\", if provided, must be `true`, `false`, or `'symbol'`");if(ss(s,"indent")&&s.indent!==null&&s.indent!=="	"&&!(parseInt(s.indent,10)===s.indent&&s.indent>0))throw new TypeError('option "indent" must be "\\t", an integer > 0, or `null`');if(ss(s,"numericSeparator")&&typeof s.numericSeparator!="boolean")throw new TypeError('option "numericSeparator", if provided, must be `true` or `false`');var o=s.numericSeparator;if(typeof t>"u")return "undefined";if(t===null)return "null";if(typeof t=="boolean")return t?"true":"false";if(typeof t=="string")return hC(t,s);if(typeof t=="number"){if(t===0)return 1/0/t>0?"0":"-0";var c=String(t);return o?nC(t,c):c}if(typeof t=="bigint"){var l=String(t)+"n";return o?nC(t,l):l}var u=typeof s.depth>"u"?5:s.depth;if(typeof n>"u"&&(n=0),n>=u&&u>0&&typeof t=="object")return fg(t)?"[Array]":"[Object]";var f=B6(s,n);if(typeof i>"u")i=[];else if(dC(i,t)>=0)return "[Circular]";function h(me,Pe,W){if(Pe&&(i=v6.call(i),i.push(Pe)),W){var K={depth:s.depth};return ss(s,"quoteStyle")&&(K.quoteStyle=s.quoteStyle),e(me,K,n+1,i)}return e(me,s,n+1,i)}if(typeof t=="function"&&!aC(t)){var p=A6(t),g=El(t,h);return "[Function"+(p?": "+p:" (anonymous)")+"]"+(g.length>0?" { "+di.call(g,", ")+" }":"")}if(fC(t)){var _=Ga?as.call(String(t),/^(Symbol\(.*\))_[^)]*$/,"$1"):cg.call(t);return typeof t=="object"&&!Ga?vu(_):_}if(O6(t)){for(var E="<"+Jw.call(String(t.nodeName)),w=t.attributes||[],y=0;y<w.length;y++)E+=" "+w[y].name+"="+lC(_6(w[y].value),"double",s);return E+=">",t.childNodes&&t.childNodes.length&&(E+="..."),E+="</"+Jw.call(String(t.nodeName))+">",E}if(fg(t)){if(t.length===0)return "[]";var b=El(t,h);return f&&!L6(b)?"["+dg(b,f)+"]":"[ "+di.call(b,", ")+" ]"}if(S6(t)){var N=El(t,h);return !("cause"in Error.prototype)&&"cause"in t&&!cC.call(t,"cause")?"{ ["+String(t)+"] "+di.call(eC.call("[cause]: "+h(t.cause),N),", ")+" }":N.length===0?"["+String(t)+"]":"{ ["+String(t)+"] "+di.call(N,", ")+" }"}if(typeof t=="object"&&a){if(sC&&typeof t[sC]=="function"&&lg)return lg(t,{depth:u-n});if(a!=="symbol"&&typeof t.inspect=="function")return t.inspect()}if(R6(t)){var L=[];return Qw&&Qw.call(t,function(me,Pe){L.push(h(Pe,t,!0)+" => "+h(me,t));}),oC("Map",wl.call(t),L,f)}if(N6(t)){var V=[];return Xw&&Xw.call(t,function(me){V.push(h(me,t));}),oC("Set",Cl.call(t),V,f)}if(I6(t))return og("WeakMap");if(D6(t))return og("WeakSet");if(P6(t))return og("WeakRef");if(w6(t))return vu(h(Number(t)));if(x6(t))return vu(h(ug.call(t)));if(C6(t))return vu(h6.call(t));if(E6(t))return vu(h(String(t)));if(typeof window<"u"&&t===window)return "{ [object Window] }";if(t===global)return "{ [object globalThis] }";if(!b6(t)&&!aC(t)){var Z=El(t,h),G=rC?rC(t)===Object.prototype:t instanceof Object||t.constructor===Object,z=t instanceof Object?"":"null prototype",ee=!G&&kr&&Object(t)===t&&kr in t?gg.call(os(t),8,-1):z?"Object":"",U=G||typeof t.constructor!="function"?"":t.constructor.name?t.constructor.name+" ":"",ie=U+(ee||z?"["+di.call(eC.call([],ee||[],z||[]),": ")+"] ":"");return Z.length===0?ie+"{}":f?ie+"{"+dg(Z,f)+"}":ie+"{ "+di.call(Z,", ")+" }"}return String(t)};function lC(e,t,r){var n=(r.quoteStyle||t)==="double"?'"':"'";return n+e+n}function _6(e){return as.call(String(e),/"/g,"&quot;")}function fg(e){return os(e)==="[object Array]"&&(!kr||!(typeof e=="object"&&kr in e))}function b6(e){return os(e)==="[object Date]"&&(!kr||!(typeof e=="object"&&kr in e))}function aC(e){return os(e)==="[object RegExp]"&&(!kr||!(typeof e=="object"&&kr in e))}function S6(e){return os(e)==="[object Error]"&&(!kr||!(typeof e=="object"&&kr in e))}function E6(e){return os(e)==="[object String]"&&(!kr||!(typeof e=="object"&&kr in e))}function w6(e){return os(e)==="[object Number]"&&(!kr||!(typeof e=="object"&&kr in e))}function C6(e){return os(e)==="[object Boolean]"&&(!kr||!(typeof e=="object"&&kr in e))}function fC(e){if(Ga)return e&&typeof e=="object"&&e instanceof Symbol;if(typeof e=="symbol")return !0;if(!e||typeof e!="object"||!cg)return !1;try{return cg.call(e),!0}catch{}return !1}function x6(e){if(!e||typeof e!="object"||!ug)return !1;try{return ug.call(e),!0}catch{}return !1}var T6=Object.prototype.hasOwnProperty||function(e){return e in this};function ss(e,t){return T6.call(e,t)}function os(e){return p6.call(e)}function A6(e){if(e.name)return e.name;var t=m6.call(g6.call(e),/^function\s*([\w$]+)/);return t?t[1]:null}function dC(e,t){if(e.indexOf)return e.indexOf(t);for(var r=0,n=e.length;r<n;r++)if(e[r]===t)return r;return -1}function R6(e){if(!wl||!e||typeof e!="object")return !1;try{wl.call(e);try{Cl.call(e);}catch{return !0}return e instanceof Map}catch{}return !1}function I6(e){if(!_u||!e||typeof e!="object")return !1;try{_u.call(e,_u);try{bu.call(e,bu);}catch{return !0}return e instanceof WeakMap}catch{}return !1}function P6(e){if(!Zw||!e||typeof e!="object")return !1;try{return Zw.call(e),!0}catch{}return !1}function N6(e){if(!Cl||!e||typeof e!="object")return !1;try{Cl.call(e);try{wl.call(e);}catch{return !0}return e instanceof Set}catch{}return !1}function D6(e){if(!bu||!e||typeof e!="object")return !1;try{bu.call(e,bu);try{_u.call(e,_u);}catch{return !0}return e instanceof WeakSet}catch{}return !1}function O6(e){return !e||typeof e!="object"?!1:typeof HTMLElement<"u"&&e instanceof HTMLElement?!0:typeof e.nodeName=="string"&&typeof e.getAttribute=="function"}function hC(e,t){if(e.length>t.maxStringLength){var r=e.length-t.maxStringLength,n="... "+r+" more character"+(r>1?"s":"");return hC(gg.call(e,0,t.maxStringLength),t)+n}var i=as.call(as.call(e,/(['\\])/g,"\\$1"),/[\x00-\x1f]/g,k6);return lC(i,"single",t)}function k6(e){var t=e.charCodeAt(0),r={8:"b",9:"t",10:"n",12:"f",13:"r"}[t];return r?"\\"+r:"\\x"+(t<16?"0":"")+y6.call(t.toString(16))}function vu(e){return "Object("+e+")"}function og(e){return e+" { ? }"}function oC(e,t,r,n){var i=n?dg(r,n):di.call(r,", ");return e+" ("+t+") {"+i+"}"}function L6(e){for(var t=0;t<e.length;t++)if(dC(e[t],`
`)>=0)return !1;return !0}function B6(e,t){var r;if(e.indent==="	")r="	";else if(typeof e.indent=="number"&&e.indent>0)r=di.call(Array(e.indent+1)," ");else return null;return {base:r,prev:di.call(Array(t+1),r)}}function dg(e,t){if(e.length===0)return "";var r=`
`+t.prev+t.base;return r+di.call(e,","+r)+`
`+t.prev}function El(e,t){var r=fg(e),n=[];if(r){n.length=e.length;for(var i=0;i<e.length;i++)n[i]=ss(e,i)?t(e[i],e):"";}var s=typeof ag=="function"?ag(e):[],a;if(Ga){a={};for(var o=0;o<s.length;o++)a["$"+s[o]]=s[o];}for(var c in e)ss(e,c)&&(r&&String(Number(c))===c&&c<e.length||Ga&&a["$"+c]instanceof Symbol||(uC.call(/[^\w$]/,c)?n.push(t(c,e)+": "+t(e[c],e)):n.push(c+": "+t(e[c],e))));if(typeof ag=="function")for(var l=0;l<s.length;l++)cC.call(e,s[l])&&n.push("["+t(s[l])+"]: "+t(e[s[l]],e));return n}});var yC=I((Gae,mC)=>{var mg=Xn(),za=Dn(),F6=gC(),q6=mg("%TypeError%"),xl=mg("%WeakMap%",!0),Tl=mg("%Map%",!0),M6=za("WeakMap.prototype.get",!0),U6=za("WeakMap.prototype.set",!0),$6=za("WeakMap.prototype.has",!0),j6=za("Map.prototype.get",!0),V6=za("Map.prototype.set",!0),H6=za("Map.prototype.has",!0),yg=function(e,t){for(var r=e,n;(n=r.next)!==null;r=n)if(n.key===t)return r.next=n.next,n.next=e.next,e.next=n,n},W6=function(e,t){var r=yg(e,t);return r&&r.value},K6=function(e,t,r){var n=yg(e,t);n?n.value=r:e.next={key:t,next:e.next,value:r};},G6=function(e,t){return !!yg(e,t)};mC.exports=function(){var t,r,n,i={assert:function(s){if(!i.has(s))throw new q6("Side channel does not contain "+F6(s))},get:function(s){if(xl&&s&&(typeof s=="object"||typeof s=="function")){if(t)return M6(t,s)}else if(Tl){if(r)return j6(r,s)}else if(n)return W6(n,s)},has:function(s){if(xl&&s&&(typeof s=="object"||typeof s=="function")){if(t)return $6(t,s)}else if(Tl){if(r)return H6(r,s)}else if(n)return G6(n,s);return !1},set:function(s,a){xl&&s&&(typeof s=="object"||typeof s=="function")?(t||(t=new xl),U6(t,s,a)):Tl?(r||(r=new Tl),V6(r,s,a)):(n||(n={key:{},next:null}),K6(n,s,a));}};return i};});var vg=I((zae,_C)=>{var vC=function(e){return e!==e};_C.exports=function(t,r){return t===0&&r===0?1/t===1/r:!!(t===r||vC(t)&&vC(r))};});var _g=I((Yae,bC)=>{var z6=vg();bC.exports=function(){return typeof Object.is=="function"?Object.is:z6};});var EC=I((Qae,SC)=>{var Y6=_g(),Q6=is();SC.exports=function(){var t=Y6();return Q6(Object,{is:t},{is:function(){return Object.is!==t}}),t};});var TC=I((Xae,xC)=>{var X6=is(),Z6=Qs(),J6=vg(),wC=_g(),e5=EC(),CC=Z6(wC(),Object);X6(CC,{getPolyfill:wC,implementation:J6,shim:e5});xC.exports=CC;});var us=I((Zae,AC)=>{var t5=pl();AC.exports=function(){return t5()&&!!Symbol.toStringTag};});var PC=I((Jae,IC)=>{var r5=us()(),n5=Dn(),bg=n5("Object.prototype.toString"),Al=function(t){return r5&&t&&typeof t=="object"&&Symbol.toStringTag in t?!1:bg(t)==="[object Arguments]"},RC=function(t){return Al(t)?!0:t!==null&&typeof t=="object"&&typeof t.length=="number"&&t.length>=0&&bg(t)!=="[object Array]"&&bg(t.callee)==="[object Function]"},i5=function(){return Al(arguments)}();Al.isLegacyArguments=RC;IC.exports=i5?Al:RC;});var DC=I((eoe,NC)=>{var s5={}.toString;NC.exports=Array.isArray||function(e){return s5.call(e)=="[object Array]"};});var BC=I((toe,LC)=>{var kC=Function.prototype.toString,Ya=typeof Reflect=="object"&&Reflect!==null&&Reflect.apply,Eg,Rl;if(typeof Ya=="function"&&typeof Object.defineProperty=="function")try{Eg=Object.defineProperty({},"length",{get:function(){throw Rl}}),Rl={},Ya(function(){throw 42},null,Eg);}catch(e){e!==Rl&&(Ya=null);}else Ya=null;var a5=/^\s*class\b/,wg=function(t){try{var r=kC.call(t);return a5.test(r)}catch{return !1}},Sg=function(t){try{return wg(t)?!1:(kC.call(t),!0)}catch{return !1}},Il=Object.prototype.toString,o5="[object Object]",u5="[object Function]",c5="[object GeneratorFunction]",l5="[object HTMLAllCollection]",f5="[object HTML document.all class]",d5="[object HTMLCollection]",h5=typeof Symbol=="function"&&!!Symbol.toStringTag,p5=!(0 in[,]),Cg=function(){return !1};typeof document=="object"&&(OC=document.all,Il.call(OC)===Il.call(document.all)&&(Cg=function(t){if((p5||!t)&&(typeof t>"u"||typeof t=="object"))try{var r=Il.call(t);return (r===l5||r===f5||r===d5||r===o5)&&t("")==null}catch{}return !1}));var OC;LC.exports=Ya?function(t){if(Cg(t))return !0;if(!t||typeof t!="function"&&typeof t!="object")return !1;try{Ya(t,null,Eg);}catch(r){if(r!==Rl)return !1}return !wg(t)&&Sg(t)}:function(t){if(Cg(t))return !0;if(!t||typeof t!="function"&&typeof t!="object")return !1;if(h5)return Sg(t);if(wg(t))return !1;var r=Il.call(t);return r!==u5&&r!==c5&&!/^\[object HTML/.test(r)?!1:Sg(t)};});var MC=I((roe,qC)=>{var g5=BC(),m5=Object.prototype.toString,FC=Object.prototype.hasOwnProperty,y5=function(t,r,n){for(var i=0,s=t.length;i<s;i++)FC.call(t,i)&&(n==null?r(t[i],i,t):r.call(n,t[i],i,t));},v5=function(t,r,n){for(var i=0,s=t.length;i<s;i++)n==null?r(t.charAt(i),i,t):r.call(n,t.charAt(i),i,t);},_5=function(t,r,n){for(var i in t)FC.call(t,i)&&(n==null?r(t[i],i,t):r.call(n,t[i],i,t));},b5=function(t,r,n){if(!g5(r))throw new TypeError("iterator must be a function");var i;arguments.length>=3&&(i=n),m5.call(t)==="[object Array]"?y5(t,r,i):typeof t=="string"?v5(t,r,i):_5(t,r,i);};qC.exports=b5;});var $C=I((noe,UC)=>{var xg=["BigInt64Array","BigUint64Array","Float32Array","Float64Array","Int16Array","Int32Array","Int8Array","Uint16Array","Uint32Array","Uint8Array","Uint8ClampedArray"],S5=typeof globalThis>"u"?global:globalThis;UC.exports=function(){for(var t=[],r=0;r<xg.length;r++)typeof S5[xg[r]]=="function"&&(t[t.length]=xg[r]);return t};});var Pg=I((ioe,WC)=>{var Nl=MC(),E5=$C(),jC=Qs(),Rg=Dn(),Pl=_l(),w5=Rg("Object.prototype.toString"),HC=us()(),VC=typeof globalThis>"u"?global:globalThis,Ag=E5(),Ig=Rg("String.prototype.slice"),Tg=Object.getPrototypeOf,C5=Rg("Array.prototype.indexOf",!0)||function(t,r){for(var n=0;n<t.length;n+=1)if(t[n]===r)return n;return -1},Dl={__proto__:null};HC&&Pl&&Tg?Nl(Ag,function(e){var t=new VC[e];if(Symbol.toStringTag in t){var r=Tg(t),n=Pl(r,Symbol.toStringTag);if(!n){var i=Tg(r);n=Pl(i,Symbol.toStringTag);}Dl["$"+e]=jC(n.get);}}):Nl(Ag,function(e){var t=new VC[e],r=t.slice||t.set;r&&(Dl["$"+e]=jC(r));});var x5=function(t){var r=!1;return Nl(Dl,function(n,i){if(!r)try{"$"+n(t)===i&&(r=Ig(i,1));}catch{}}),r},T5=function(t){var r=!1;return Nl(Dl,function(n,i){if(!r)try{n(t),r=Ig(i,1);}catch{}}),r};WC.exports=function(t){if(!t||typeof t!="object")return !1;if(!HC){var r=Ig(w5(t),8,-1);return C5(Ag,r)>-1?r:r!=="Object"?!1:T5(t)}return Pl?x5(t):null};});var GC=I((soe,KC)=>{var A5=Pg();KC.exports=function(t){return !!A5(t)};});var Ng=I((aoe,JC)=>{var R5=Qs(),I5=Dn(),ZC=Xn(),P5=GC(),zC=ZC("ArrayBuffer",!0),YC=ZC("Float32Array",!0),Ol=I5("ArrayBuffer.prototype.byteLength",!0),QC=zC&&!Ol&&new zC().slice,XC=QC&&R5(QC);JC.exports=Ol||XC?function(t){if(!t||typeof t!="object")return !1;try{return Ol?Ol(t):XC(t,0),!0}catch{return !1}}:YC?function(t){try{return new YC(t).buffer===t&&!P5(t)}catch(r){return typeof t=="object"&&r.name==="RangeError"}}:function(t){return !1};});var t1=I((ooe,e1)=>{var N5=Date.prototype.getDay,D5=function(t){try{return N5.call(t),!0}catch{return !1}},O5=Object.prototype.toString,k5="[object Date]",L5=us()();e1.exports=function(t){return typeof t!="object"||t===null?!1:L5?D5(t):O5.call(t)===k5};});var a1=I((uoe,s1)=>{var Dg=Dn(),r1=us()(),n1,i1,Og,kg;r1&&(n1=Dg("Object.prototype.hasOwnProperty"),i1=Dg("RegExp.prototype.exec"),Og={},kl=function(){throw Og},kg={toString:kl,valueOf:kl},typeof Symbol.toPrimitive=="symbol"&&(kg[Symbol.toPrimitive]=kl));var kl,B5=Dg("Object.prototype.toString"),F5=Object.getOwnPropertyDescriptor,q5="[object RegExp]";s1.exports=r1?function(t){if(!t||typeof t!="object")return !1;var r=F5(t,"lastIndex"),n=r&&n1(r,"value");if(!n)return !1;try{i1(t,kg);}catch(i){return i===Og}}:function(t){return !t||typeof t!="object"&&typeof t!="function"?!1:B5(t)===q5};});var c1=I((coe,u1)=>{var M5=Dn(),o1=M5("SharedArrayBuffer.prototype.byteLength",!0);u1.exports=o1?function(t){if(!t||typeof t!="object")return !1;try{return o1(t),!0}catch{return !1}}:function(t){return !1};});var f1=I((loe,l1)=>{var U5=String.prototype.valueOf,$5=function(t){try{return U5.call(t),!0}catch{return !1}},j5=Object.prototype.toString,V5="[object String]",H5=us()();l1.exports=function(t){return typeof t=="string"?!0:typeof t!="object"?!1:H5?$5(t):j5.call(t)===V5};});var h1=I((foe,d1)=>{var W5=Number.prototype.toString,K5=function(t){try{return W5.call(t),!0}catch{return !1}},G5=Object.prototype.toString,z5="[object Number]",Y5=us()();d1.exports=function(t){return typeof t=="number"?!0:typeof t!="object"?!1:Y5?K5(t):G5.call(t)===z5};});var m1=I((doe,g1)=>{var p1=Dn(),Q5=p1("Boolean.prototype.toString"),X5=p1("Object.prototype.toString"),Z5=function(t){try{return Q5(t),!0}catch{return !1}},J5="[object Boolean]",e$=us()();g1.exports=function(t){return typeof t=="boolean"?!0:t===null||typeof t!="object"?!1:e$&&Symbol.toStringTag in t?Z5(t):X5(t)===J5};});var b1=I((hoe,Lg)=>{var t$=Object.prototype.toString,r$=Kp()();r$?(y1=Symbol.prototype.toString,v1=/^Symbol\(.*\)$/,_1=function(t){return typeof t.valueOf()!="symbol"?!1:v1.test(y1.call(t))},Lg.exports=function(t){if(typeof t=="symbol")return !0;if(t$.call(t)!=="[object Symbol]")return !1;try{return _1(t)}catch{return !1}}):Lg.exports=function(t){return !1};var y1,v1,_1;});var w1=I((poe,E1)=>{var S1=typeof BigInt<"u"&&BigInt;E1.exports=function(){return typeof S1=="function"&&typeof BigInt=="function"&&typeof S1(42)=="bigint"&&typeof BigInt(42)=="bigint"};});var T1=I((goe,Bg)=>{var n$=w1()();n$?(C1=BigInt.prototype.valueOf,x1=function(t){try{return C1.call(t),!0}catch{}return !1},Bg.exports=function(t){return t===null||typeof t>"u"||typeof t=="boolean"||typeof t=="string"||typeof t=="number"||typeof t=="symbol"||typeof t=="function"?!1:typeof t=="bigint"?!0:x1(t)}):Bg.exports=function(t){return !1};var C1,x1;});var R1=I((moe,A1)=>{var i$=f1(),s$=h1(),a$=m1(),o$=b1(),u$=T1();A1.exports=function(t){if(t==null||typeof t!="object"&&typeof t!="function")return null;if(i$(t))return "String";if(s$(t))return "Number";if(a$(t))return "Boolean";if(o$(t))return "Symbol";if(u$(t))return "BigInt"};});var D1=I((yoe,N1)=>{var Fg=typeof Map=="function"&&Map.prototype?Map:null,c$=typeof Set=="function"&&Set.prototype?Set:null,Ll;Fg||(Ll=function(t){return !1});var P1=Fg?Map.prototype.has:null,I1=c$?Set.prototype.has:null;!Ll&&!P1&&(Ll=function(t){return !1});N1.exports=Ll||function(t){if(!t||typeof t!="object")return !1;try{if(P1.call(t),I1)try{I1.call(t);}catch{return !0}return t instanceof Fg}catch{}return !1};});var B1=I((voe,L1)=>{var l$=typeof Map=="function"&&Map.prototype?Map:null,qg=typeof Set=="function"&&Set.prototype?Set:null,Bl;qg||(Bl=function(t){return !1});var O1=l$?Map.prototype.has:null,k1=qg?Set.prototype.has:null;!Bl&&!k1&&(Bl=function(t){return !1});L1.exports=Bl||function(t){if(!t||typeof t!="object")return !1;try{if(k1.call(t),O1)try{O1.call(t);}catch{return !0}return t instanceof qg}catch{}return !1};});var M1=I((_oe,q1)=>{var Fl=typeof WeakMap=="function"&&WeakMap.prototype?WeakMap:null,F1=typeof WeakSet=="function"&&WeakSet.prototype?WeakSet:null,ql;Fl||(ql=function(t){return !1});var Ug=Fl?Fl.prototype.has:null,Mg=F1?F1.prototype.has:null;!ql&&!Ug&&(ql=function(t){return !1});q1.exports=ql||function(t){if(!t||typeof t!="object")return !1;try{if(Ug.call(t,Ug),Mg)try{Mg.call(t,Mg);}catch{return !0}return t instanceof Fl}catch{}return !1};});var $1=I((boe,jg)=>{var f$=Xn(),U1=Dn(),d$=f$("%WeakSet%",!0),$g=U1("WeakSet.prototype.has",!0);$g?(Ml=U1("WeakMap.prototype.has",!0),jg.exports=function(t){if(!t||typeof t!="object")return !1;try{if($g(t,$g),Ml)try{Ml(t,Ml);}catch{return !0}return t instanceof d$}catch{}return !1}):jg.exports=function(t){return !1};var Ml;});var V1=I((Soe,j1)=>{var h$=D1(),p$=B1(),g$=M1(),m$=$1();j1.exports=function(t){if(t&&typeof t=="object"){if(h$(t))return "Map";if(p$(t))return "Set";if(g$(t))return "WeakMap";if(m$(t))return "WeakSet"}return !1};});var K1=I((Eoe,W1)=>{var y$=Dn(),H1=y$("ArrayBuffer.prototype.byteLength",!0),v$=Ng();W1.exports=function(t){return v$(t)?H1?H1(t):t.byteLength:NaN};});var Su=I((woe,mx)=>{var hx=Pw(),hi=Dn(),G1=Hw(),_$=Xn(),Qa=Gw(),b$=yC(),z1=TC(),Y1=PC(),Q1=DC(),X1=Ng(),Z1=t1(),J1=a1(),ex=c1(),tx=hl(),rx=R1(),nx=V1(),ix=Pg(),sx=K1(),ax=hi("SharedArrayBuffer.prototype.byteLength",!0),ox=hi("Date.prototype.getTime"),Vg=Object.getPrototypeOf,ux=hi("Object.prototype.toString"),$l=_$("%Set%",!0),Hg=hi("Map.prototype.has",!0),jl=hi("Map.prototype.get",!0),cx=hi("Map.prototype.size",!0),Vl=hi("Set.prototype.add",!0),px=hi("Set.prototype.delete",!0),Hl=hi("Set.prototype.has",!0),Ul=hi("Set.prototype.size",!0);function lx(e,t,r,n){for(var i=Qa(e),s;(s=i.next())&&!s.done;)if(Zn(t,s.value,r,n))return px(e,s.value),!0;return !1}function gx(e){if(typeof e>"u")return null;if(typeof e!="object")return typeof e=="symbol"?!1:typeof e=="string"||typeof e=="number"?+e==+e:!0}function S$(e,t,r,n,i,s){var a=gx(r);if(a!=null)return a;var o=jl(t,a),c=hx({},i,{strict:!1});return typeof o>"u"&&!Hg(t,a)||!Zn(n,o,c,s)?!1:!Hg(e,a)&&Zn(n,o,c,s)}function E$(e,t,r){var n=gx(r);return n??(Hl(t,n)&&!Hl(e,n))}function fx(e,t,r,n,i,s){for(var a=Qa(e),o,c;(o=a.next())&&!o.done;)if(c=o.value,Zn(r,c,i,s)&&Zn(n,jl(t,c),i,s))return px(e,c),!0;return !1}function Zn(e,t,r,n){var i=r||{};if(i.strict?z1(e,t):e===t)return !0;var s=rx(e),a=rx(t);if(s!==a)return !1;if(!e||!t||typeof e!="object"&&typeof t!="object")return i.strict?z1(e,t):e==t;var o=n.has(e),c=n.has(t),l;if(o&&c){if(n.get(e)===n.get(t))return !0}else l={};return o||n.set(e,l),c||n.set(t,l),x$(e,t,i,n)}function dx(e){return !e||typeof e!="object"||typeof e.length!="number"||typeof e.copy!="function"||typeof e.slice!="function"||e.length>0&&typeof e[0]!="number"?!1:!!(e.constructor&&e.constructor.isBuffer&&e.constructor.isBuffer(e))}function w$(e,t,r,n){if(Ul(e)!==Ul(t))return !1;for(var i=Qa(e),s=Qa(t),a,o,c;(a=i.next())&&!a.done;)if(a.value&&typeof a.value=="object")c||(c=new $l),Vl(c,a.value);else if(!Hl(t,a.value)){if(r.strict||!E$(e,t,a.value))return !1;c||(c=new $l),Vl(c,a.value);}if(c){for(;(o=s.next())&&!o.done;)if(o.value&&typeof o.value=="object"){if(!lx(c,o.value,r.strict,n))return !1}else if(!r.strict&&!Hl(e,o.value)&&!lx(c,o.value,r.strict,n))return !1;return Ul(c)===0}return !0}function C$(e,t,r,n){if(cx(e)!==cx(t))return !1;for(var i=Qa(e),s=Qa(t),a,o,c,l,u,f;(a=i.next())&&!a.done;)if(l=a.value[0],u=a.value[1],l&&typeof l=="object")c||(c=new $l),Vl(c,l);else if(f=jl(t,l),typeof f>"u"&&!Hg(t,l)||!Zn(u,f,r,n)){if(r.strict||!S$(e,t,l,u,r,n))return !1;c||(c=new $l),Vl(c,l);}if(c){for(;(o=s.next())&&!o.done;)if(l=o.value[0],f=o.value[1],l&&typeof l=="object"){if(!fx(c,e,l,f,r,n))return !1}else if(!r.strict&&(!e.has(l)||!Zn(jl(e,l),f,r,n))&&!fx(c,e,l,f,hx({},r,{strict:!1}),n))return !1;return Ul(c)===0}return !0}function x$(e,t,r,n){var i,s;if(typeof e!=typeof t||e==null||t==null||ux(e)!==ux(t)||Y1(e)!==Y1(t))return !1;var a=Q1(e),o=Q1(t);if(a!==o)return !1;var c=e instanceof Error,l=t instanceof Error;if(c!==l||(c||l)&&(e.name!==t.name||e.message!==t.message))return !1;var u=J1(e),f=J1(t);if(u!==f||(u||f)&&(e.source!==t.source||G1(e)!==G1(t)))return !1;var h=Z1(e),p=Z1(t);if(h!==p||(h||p)&&ox(e)!==ox(t)||r.strict&&Vg&&Vg(e)!==Vg(t))return !1;var g=ix(e),_=ix(t);if(g!==_)return !1;if(g||_){if(e.length!==t.length)return !1;for(i=0;i<e.length;i++)if(e[i]!==t[i])return !1;return !0}var E=dx(e),w=dx(t);if(E!==w)return !1;if(E||w){if(e.length!==t.length)return !1;for(i=0;i<e.length;i++)if(e[i]!==t[i])return !1;return !0}var y=X1(e),b=X1(t);if(y!==b)return !1;if(y||b)return sx(e)!==sx(t)?!1:typeof Uint8Array=="function"&&Zn(new Uint8Array(e),new Uint8Array(t),r,n);var N=ex(e),L=ex(t);if(N!==L)return !1;if(N||L)return ax(e)!==ax(t)?!1:typeof Uint8Array=="function"&&Zn(new Uint8Array(e),new Uint8Array(t),r,n);if(typeof e!=typeof t)return !1;var V=tx(e),Z=tx(t);if(V.length!==Z.length)return !1;for(V.sort(),Z.sort(),i=V.length-1;i>=0;i--)if(V[i]!=Z[i])return !1;for(i=V.length-1;i>=0;i--)if(s=V[i],!Zn(e[s],t[s],r,n))return !1;var G=nx(e),z=nx(t);return G!==z?!1:G==="Set"||z==="Set"?w$(e,t,r,n):G==="Map"?C$(e,t,r,n):!0}mx.exports=function(t,r,n){return Zn(t,r,n,b$())};});var wu=I((Roe,Cx)=>{var K$="2.0.0",G$=Number.MAX_SAFE_INTEGER||9007199254740991,z$=16,Y$=250,Q$=["major","premajor","minor","preminor","patch","prepatch","prerelease"];Cx.exports={MAX_LENGTH:256,MAX_SAFE_COMPONENT_LENGTH:z$,MAX_SAFE_BUILD_LENGTH:Y$,MAX_SAFE_INTEGER:G$,RELEASE_TYPES:Q$,SEMVER_SPEC_VERSION:K$,FLAG_INCLUDE_PRERELEASE:1,FLAG_LOOSE:2};});var Cu=I((Ioe,xx)=>{var X$=typeof process=="object"&&process.env&&process.env.NODE_DEBUG&&/\bsemver\b/i.test(process.env.NODE_DEBUG)?(...e)=>console.error("SEMVER",...e):()=>{};xx.exports=X$;});var Xa=I((Li,Tx)=>{var{MAX_SAFE_COMPONENT_LENGTH:Yg,MAX_SAFE_BUILD_LENGTH:Z$,MAX_LENGTH:J$}=wu(),ej=Cu();Li=Tx.exports={};var tj=Li.re=[],rj=Li.safeRe=[],ke=Li.src=[],Le=Li.t={},nj=0,Qg="[a-zA-Z0-9-]",ij=[["\\s",1],["\\d",J$],[Qg,Z$]],sj=e=>{for(let[t,r]of ij)e=e.split(`${t}*`).join(`${t}{0,${r}}`).split(`${t}+`).join(`${t}{1,${r}}`);return e},tt=(e,t,r)=>{let n=sj(t),i=nj++;ej(e,i,t),Le[e]=i,ke[i]=t,tj[i]=new RegExp(t,r?"g":void 0),rj[i]=new RegExp(n,r?"g":void 0);};tt("NUMERICIDENTIFIER","0|[1-9]\\d*");tt("NUMERICIDENTIFIERLOOSE","\\d+");tt("NONNUMERICIDENTIFIER",`\\d*[a-zA-Z-]${Qg}*`);tt("MAINVERSION",`(${ke[Le.NUMERICIDENTIFIER]})\\.(${ke[Le.NUMERICIDENTIFIER]})\\.(${ke[Le.NUMERICIDENTIFIER]})`);tt("MAINVERSIONLOOSE",`(${ke[Le.NUMERICIDENTIFIERLOOSE]})\\.(${ke[Le.NUMERICIDENTIFIERLOOSE]})\\.(${ke[Le.NUMERICIDENTIFIERLOOSE]})`);tt("PRERELEASEIDENTIFIER",`(?:${ke[Le.NUMERICIDENTIFIER]}|${ke[Le.NONNUMERICIDENTIFIER]})`);tt("PRERELEASEIDENTIFIERLOOSE",`(?:${ke[Le.NUMERICIDENTIFIERLOOSE]}|${ke[Le.NONNUMERICIDENTIFIER]})`);tt("PRERELEASE",`(?:-(${ke[Le.PRERELEASEIDENTIFIER]}(?:\\.${ke[Le.PRERELEASEIDENTIFIER]})*))`);tt("PRERELEASELOOSE",`(?:-?(${ke[Le.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${ke[Le.PRERELEASEIDENTIFIERLOOSE]})*))`);tt("BUILDIDENTIFIER",`${Qg}+`);tt("BUILD",`(?:\\+(${ke[Le.BUILDIDENTIFIER]}(?:\\.${ke[Le.BUILDIDENTIFIER]})*))`);tt("FULLPLAIN",`v?${ke[Le.MAINVERSION]}${ke[Le.PRERELEASE]}?${ke[Le.BUILD]}?`);tt("FULL",`^${ke[Le.FULLPLAIN]}$`);tt("LOOSEPLAIN",`[v=\\s]*${ke[Le.MAINVERSIONLOOSE]}${ke[Le.PRERELEASELOOSE]}?${ke[Le.BUILD]}?`);tt("LOOSE",`^${ke[Le.LOOSEPLAIN]}$`);tt("GTLT","((?:<|>)?=?)");tt("XRANGEIDENTIFIERLOOSE",`${ke[Le.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);tt("XRANGEIDENTIFIER",`${ke[Le.NUMERICIDENTIFIER]}|x|X|\\*`);tt("XRANGEPLAIN",`[v=\\s]*(${ke[Le.XRANGEIDENTIFIER]})(?:\\.(${ke[Le.XRANGEIDENTIFIER]})(?:\\.(${ke[Le.XRANGEIDENTIFIER]})(?:${ke[Le.PRERELEASE]})?${ke[Le.BUILD]}?)?)?`);tt("XRANGEPLAINLOOSE",`[v=\\s]*(${ke[Le.XRANGEIDENTIFIERLOOSE]})(?:\\.(${ke[Le.XRANGEIDENTIFIERLOOSE]})(?:\\.(${ke[Le.XRANGEIDENTIFIERLOOSE]})(?:${ke[Le.PRERELEASELOOSE]})?${ke[Le.BUILD]}?)?)?`);tt("XRANGE",`^${ke[Le.GTLT]}\\s*${ke[Le.XRANGEPLAIN]}$`);tt("XRANGELOOSE",`^${ke[Le.GTLT]}\\s*${ke[Le.XRANGEPLAINLOOSE]}$`);tt("COERCE",`(^|[^\\d])(\\d{1,${Yg}})(?:\\.(\\d{1,${Yg}}))?(?:\\.(\\d{1,${Yg}}))?(?:$|[^\\d])`);tt("COERCERTL",ke[Le.COERCE],!0);tt("LONETILDE","(?:~>?)");tt("TILDETRIM",`(\\s*)${ke[Le.LONETILDE]}\\s+`,!0);Li.tildeTrimReplace="$1~";tt("TILDE",`^${ke[Le.LONETILDE]}${ke[Le.XRANGEPLAIN]}$`);tt("TILDELOOSE",`^${ke[Le.LONETILDE]}${ke[Le.XRANGEPLAINLOOSE]}$`);tt("LONECARET","(?:\\^)");tt("CARETTRIM",`(\\s*)${ke[Le.LONECARET]}\\s+`,!0);Li.caretTrimReplace="$1^";tt("CARET",`^${ke[Le.LONECARET]}${ke[Le.XRANGEPLAIN]}$`);tt("CARETLOOSE",`^${ke[Le.LONECARET]}${ke[Le.XRANGEPLAINLOOSE]}$`);tt("COMPARATORLOOSE",`^${ke[Le.GTLT]}\\s*(${ke[Le.LOOSEPLAIN]})$|^$`);tt("COMPARATOR",`^${ke[Le.GTLT]}\\s*(${ke[Le.FULLPLAIN]})$|^$`);tt("COMPARATORTRIM",`(\\s*)${ke[Le.GTLT]}\\s*(${ke[Le.LOOSEPLAIN]}|${ke[Le.XRANGEPLAIN]})`,!0);Li.comparatorTrimReplace="$1$2$3";tt("HYPHENRANGE",`^\\s*(${ke[Le.XRANGEPLAIN]})\\s+-\\s+(${ke[Le.XRANGEPLAIN]})\\s*$`);tt("HYPHENRANGELOOSE",`^\\s*(${ke[Le.XRANGEPLAINLOOSE]})\\s+-\\s+(${ke[Le.XRANGEPLAINLOOSE]})\\s*$`);tt("STAR","(<|>)?=?\\s*\\*");tt("GTE0","^\\s*>=\\s*0\\.0\\.0\\s*$");tt("GTE0PRE","^\\s*>=\\s*0\\.0\\.0-0\\s*$");});var zl=I((Poe,Ax)=>{var aj=Object.freeze({loose:!0}),oj=Object.freeze({}),uj=e=>e?typeof e!="object"?aj:e:oj;Ax.exports=uj;});var Xg=I((Noe,Px)=>{var Rx=/^[0-9]+$/,Ix=(e,t)=>{let r=Rx.test(e),n=Rx.test(t);return r&&n&&(e=+e,t=+t),e===t?0:r&&!n?-1:n&&!r?1:e<t?-1:1},cj=(e,t)=>Ix(t,e);Px.exports={compareIdentifiers:Ix,rcompareIdentifiers:cj};});var Lr=I((Doe,kx)=>{var Yl=Cu(),{MAX_LENGTH:Nx,MAX_SAFE_INTEGER:Ql}=wu(),{safeRe:Dx,t:Ox}=Xa(),lj=zl(),{compareIdentifiers:Za}=Xg(),Zg=class e{constructor(t,r){if(r=lj(r),t instanceof e){if(t.loose===!!r.loose&&t.includePrerelease===!!r.includePrerelease)return t;t=t.version;}else if(typeof t!="string")throw new TypeError(`Invalid version. Must be a string. Got type "${typeof t}".`);if(t.length>Nx)throw new TypeError(`version is longer than ${Nx} characters`);Yl("SemVer",t,r),this.options=r,this.loose=!!r.loose,this.includePrerelease=!!r.includePrerelease;let n=t.trim().match(r.loose?Dx[Ox.LOOSE]:Dx[Ox.FULL]);if(!n)throw new TypeError(`Invalid Version: ${t}`);if(this.raw=t,this.major=+n[1],this.minor=+n[2],this.patch=+n[3],this.major>Ql||this.major<0)throw new TypeError("Invalid major version");if(this.minor>Ql||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>Ql||this.patch<0)throw new TypeError("Invalid patch version");n[4]?this.prerelease=n[4].split(".").map(i=>{if(/^[0-9]+$/.test(i)){let s=+i;if(s>=0&&s<Ql)return s}return i}):this.prerelease=[],this.build=n[5]?n[5].split("."):[],this.format();}format(){return this.version=`${this.major}.${this.minor}.${this.patch}`,this.prerelease.length&&(this.version+=`-${this.prerelease.join(".")}`),this.version}toString(){return this.version}compare(t){if(Yl("SemVer.compare",this.version,this.options,t),!(t instanceof e)){if(typeof t=="string"&&t===this.version)return 0;t=new e(t,this.options);}return t.version===this.version?0:this.compareMain(t)||this.comparePre(t)}compareMain(t){return t instanceof e||(t=new e(t,this.options)),Za(this.major,t.major)||Za(this.minor,t.minor)||Za(this.patch,t.patch)}comparePre(t){if(t instanceof e||(t=new e(t,this.options)),this.prerelease.length&&!t.prerelease.length)return -1;if(!this.prerelease.length&&t.prerelease.length)return 1;if(!this.prerelease.length&&!t.prerelease.length)return 0;let r=0;do{let n=this.prerelease[r],i=t.prerelease[r];if(Yl("prerelease compare",r,n,i),n===void 0&&i===void 0)return 0;if(i===void 0)return 1;if(n===void 0)return -1;if(n===i)continue;return Za(n,i)}while(++r)}compareBuild(t){t instanceof e||(t=new e(t,this.options));let r=0;do{let n=this.build[r],i=t.build[r];if(Yl("prerelease compare",r,n,i),n===void 0&&i===void 0)return 0;if(i===void 0)return 1;if(n===void 0)return -1;if(n===i)continue;return Za(n,i)}while(++r)}inc(t,r,n){switch(t){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",r,n);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",r,n);break;case"prepatch":this.prerelease.length=0,this.inc("patch",r,n),this.inc("pre",r,n);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",r,n),this.inc("pre",r,n);break;case"major":(this.minor!==0||this.patch!==0||this.prerelease.length===0)&&this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":(this.patch!==0||this.prerelease.length===0)&&this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":{let i=Number(n)?1:0;if(!r&&n===!1)throw new Error("invalid increment argument: identifier is empty");if(this.prerelease.length===0)this.prerelease=[i];else {let s=this.prerelease.length;for(;--s>=0;)typeof this.prerelease[s]=="number"&&(this.prerelease[s]++,s=-2);if(s===-1){if(r===this.prerelease.join(".")&&n===!1)throw new Error("invalid increment argument: identifier already exists");this.prerelease.push(i);}}if(r){let s=[r,i];n===!1&&(s=[r]),Za(this.prerelease[0],r)===0?isNaN(this.prerelease[1])&&(this.prerelease=s):this.prerelease=s;}break}default:throw new Error(`invalid increment argument: ${t}`)}return this.raw=this.format(),this.build.length&&(this.raw+=`+${this.build.join(".")}`),this}};kx.exports=Zg;});var Js=I((Ooe,Bx)=>{var Lx=Lr(),fj=(e,t,r=!1)=>{if(e instanceof Lx)return e;try{return new Lx(e,t)}catch(n){if(!r)return null;throw n}};Bx.exports=fj;});var qx=I((koe,Fx)=>{var dj=Js(),hj=(e,t)=>{let r=dj(e,t);return r?r.version:null};Fx.exports=hj;});var Ux=I((Loe,Mx)=>{var pj=Js(),gj=(e,t)=>{let r=pj(e.trim().replace(/^[=v]+/,""),t);return r?r.version:null};Mx.exports=gj;});var Vx=I((Boe,jx)=>{var $x=Lr(),mj=(e,t,r,n,i)=>{typeof r=="string"&&(i=n,n=r,r=void 0);try{return new $x(e instanceof $x?e.version:e,r).inc(t,n,i).version}catch{return null}};jx.exports=mj;});var Kx=I((Foe,Wx)=>{var Hx=Js(),yj=(e,t)=>{let r=Hx(e,null,!0),n=Hx(t,null,!0),i=r.compare(n);if(i===0)return null;let s=i>0,a=s?r:n,o=s?n:r,c=!!a.prerelease.length;if(!!o.prerelease.length&&!c)return !o.patch&&!o.minor?"major":a.patch?"patch":a.minor?"minor":"major";let u=c?"pre":"";return r.major!==n.major?u+"major":r.minor!==n.minor?u+"minor":r.patch!==n.patch?u+"patch":"prerelease"};Wx.exports=yj;});var zx=I((qoe,Gx)=>{var vj=Lr(),_j=(e,t)=>new vj(e,t).major;Gx.exports=_j;});var Qx=I((Moe,Yx)=>{var bj=Lr(),Sj=(e,t)=>new bj(e,t).minor;Yx.exports=Sj;});var Zx=I((Uoe,Xx)=>{var Ej=Lr(),wj=(e,t)=>new Ej(e,t).patch;Xx.exports=wj;});var eT=I(($oe,Jx)=>{var Cj=Js(),xj=(e,t)=>{let r=Cj(e,t);return r&&r.prerelease.length?r.prerelease:null};Jx.exports=xj;});var On=I((joe,rT)=>{var tT=Lr(),Tj=(e,t,r)=>new tT(e,r).compare(new tT(t,r));rT.exports=Tj;});var iT=I((Voe,nT)=>{var Aj=On(),Rj=(e,t,r)=>Aj(t,e,r);nT.exports=Rj;});var aT=I((Hoe,sT)=>{var Ij=On(),Pj=(e,t)=>Ij(e,t,!0);sT.exports=Pj;});var Xl=I((Woe,uT)=>{var oT=Lr(),Nj=(e,t,r)=>{let n=new oT(e,r),i=new oT(t,r);return n.compare(i)||n.compareBuild(i)};uT.exports=Nj;});var lT=I((Koe,cT)=>{var Dj=Xl(),Oj=(e,t)=>e.sort((r,n)=>Dj(r,n,t));cT.exports=Oj;});var dT=I((Goe,fT)=>{var kj=Xl(),Lj=(e,t)=>e.sort((r,n)=>kj(n,r,t));fT.exports=Lj;});var xu=I((zoe,hT)=>{var Bj=On(),Fj=(e,t,r)=>Bj(e,t,r)>0;hT.exports=Fj;});var Zl=I((Yoe,pT)=>{var qj=On(),Mj=(e,t,r)=>qj(e,t,r)<0;pT.exports=Mj;});var Jg=I((Qoe,gT)=>{var Uj=On(),$j=(e,t,r)=>Uj(e,t,r)===0;gT.exports=$j;});var em=I((Xoe,mT)=>{var jj=On(),Vj=(e,t,r)=>jj(e,t,r)!==0;mT.exports=Vj;});var Jl=I((Zoe,yT)=>{var Hj=On(),Wj=(e,t,r)=>Hj(e,t,r)>=0;yT.exports=Wj;});var ef=I((Joe,vT)=>{var Kj=On(),Gj=(e,t,r)=>Kj(e,t,r)<=0;vT.exports=Gj;});var tm=I((eue,_T)=>{var zj=Jg(),Yj=em(),Qj=xu(),Xj=Jl(),Zj=Zl(),Jj=ef(),eV=(e,t,r,n)=>{switch(t){case"===":return typeof e=="object"&&(e=e.version),typeof r=="object"&&(r=r.version),e===r;case"!==":return typeof e=="object"&&(e=e.version),typeof r=="object"&&(r=r.version),e!==r;case"":case"=":case"==":return zj(e,r,n);case"!=":return Yj(e,r,n);case">":return Qj(e,r,n);case">=":return Xj(e,r,n);case"<":return Zj(e,r,n);case"<=":return Jj(e,r,n);default:throw new TypeError(`Invalid operator: ${t}`)}};_T.exports=eV;});var ST=I((tue,bT)=>{var tV=Lr(),rV=Js(),{safeRe:tf,t:rf}=Xa(),nV=(e,t)=>{if(e instanceof tV)return e;if(typeof e=="number"&&(e=String(e)),typeof e!="string")return null;t=t||{};let r=null;if(!t.rtl)r=e.match(tf[rf.COERCE]);else {let n;for(;(n=tf[rf.COERCERTL].exec(e))&&(!r||r.index+r[0].length!==e.length);)(!r||n.index+n[0].length!==r.index+r[0].length)&&(r=n),tf[rf.COERCERTL].lastIndex=n.index+n[1].length+n[2].length;tf[rf.COERCERTL].lastIndex=-1;}return r===null?null:rV(`${r[2]}.${r[3]||"0"}.${r[4]||"0"}`,t)};bT.exports=nV;});var wT=I((rue,ET)=>{ET.exports=function(e){e.prototype[Symbol.iterator]=function*(){for(let t=this.head;t;t=t.next)yield t.value;};};});var xT=I((nue,CT)=>{CT.exports=Et;Et.Node=ea;Et.create=Et;function Et(e){var t=this;if(t instanceof Et||(t=new Et),t.tail=null,t.head=null,t.length=0,e&&typeof e.forEach=="function")e.forEach(function(i){t.push(i);});else if(arguments.length>0)for(var r=0,n=arguments.length;r<n;r++)t.push(arguments[r]);return t}Et.prototype.removeNode=function(e){if(e.list!==this)throw new Error("removing node which does not belong to this list");var t=e.next,r=e.prev;return t&&(t.prev=r),r&&(r.next=t),e===this.head&&(this.head=t),e===this.tail&&(this.tail=r),e.list.length--,e.next=null,e.prev=null,e.list=null,t};Et.prototype.unshiftNode=function(e){if(e!==this.head){e.list&&e.list.removeNode(e);var t=this.head;e.list=this,e.next=t,t&&(t.prev=e),this.head=e,this.tail||(this.tail=e),this.length++;}};Et.prototype.pushNode=function(e){if(e!==this.tail){e.list&&e.list.removeNode(e);var t=this.tail;e.list=this,e.prev=t,t&&(t.next=e),this.tail=e,this.head||(this.head=e),this.length++;}};Et.prototype.push=function(){for(var e=0,t=arguments.length;e<t;e++)sV(this,arguments[e]);return this.length};Et.prototype.unshift=function(){for(var e=0,t=arguments.length;e<t;e++)aV(this,arguments[e]);return this.length};Et.prototype.pop=function(){if(this.tail){var e=this.tail.value;return this.tail=this.tail.prev,this.tail?this.tail.next=null:this.head=null,this.length--,e}};Et.prototype.shift=function(){if(this.head){var e=this.head.value;return this.head=this.head.next,this.head?this.head.prev=null:this.tail=null,this.length--,e}};Et.prototype.forEach=function(e,t){t=t||this;for(var r=this.head,n=0;r!==null;n++)e.call(t,r.value,n,this),r=r.next;};Et.prototype.forEachReverse=function(e,t){t=t||this;for(var r=this.tail,n=this.length-1;r!==null;n--)e.call(t,r.value,n,this),r=r.prev;};Et.prototype.get=function(e){for(var t=0,r=this.head;r!==null&&t<e;t++)r=r.next;if(t===e&&r!==null)return r.value};Et.prototype.getReverse=function(e){for(var t=0,r=this.tail;r!==null&&t<e;t++)r=r.prev;if(t===e&&r!==null)return r.value};Et.prototype.map=function(e,t){t=t||this;for(var r=new Et,n=this.head;n!==null;)r.push(e.call(t,n.value,this)),n=n.next;return r};Et.prototype.mapReverse=function(e,t){t=t||this;for(var r=new Et,n=this.tail;n!==null;)r.push(e.call(t,n.value,this)),n=n.prev;return r};Et.prototype.reduce=function(e,t){var r,n=this.head;if(arguments.length>1)r=t;else if(this.head)n=this.head.next,r=this.head.value;else throw new TypeError("Reduce of empty list with no initial value");for(var i=0;n!==null;i++)r=e(r,n.value,i),n=n.next;return r};Et.prototype.reduceReverse=function(e,t){var r,n=this.tail;if(arguments.length>1)r=t;else if(this.tail)n=this.tail.prev,r=this.tail.value;else throw new TypeError("Reduce of empty list with no initial value");for(var i=this.length-1;n!==null;i--)r=e(r,n.value,i),n=n.prev;return r};Et.prototype.toArray=function(){for(var e=new Array(this.length),t=0,r=this.head;r!==null;t++)e[t]=r.value,r=r.next;return e};Et.prototype.toArrayReverse=function(){for(var e=new Array(this.length),t=0,r=this.tail;r!==null;t++)e[t]=r.value,r=r.prev;return e};Et.prototype.slice=function(e,t){t=t||this.length,t<0&&(t+=this.length),e=e||0,e<0&&(e+=this.length);var r=new Et;if(t<e||t<0)return r;e<0&&(e=0),t>this.length&&(t=this.length);for(var n=0,i=this.head;i!==null&&n<e;n++)i=i.next;for(;i!==null&&n<t;n++,i=i.next)r.push(i.value);return r};Et.prototype.sliceReverse=function(e,t){t=t||this.length,t<0&&(t+=this.length),e=e||0,e<0&&(e+=this.length);var r=new Et;if(t<e||t<0)return r;e<0&&(e=0),t>this.length&&(t=this.length);for(var n=this.length,i=this.tail;i!==null&&n>t;n--)i=i.prev;for(;i!==null&&n>e;n--,i=i.prev)r.push(i.value);return r};Et.prototype.splice=function(e,t,...r){e>this.length&&(e=this.length-1),e<0&&(e=this.length+e);for(var n=0,i=this.head;i!==null&&n<e;n++)i=i.next;for(var s=[],n=0;i&&n<t;n++)s.push(i.value),i=this.removeNode(i);i===null&&(i=this.tail),i!==this.head&&i!==this.tail&&(i=i.prev);for(var n=0;n<r.length;n++)i=iV(this,i,r[n]);return s};Et.prototype.reverse=function(){for(var e=this.head,t=this.tail,r=e;r!==null;r=r.prev){var n=r.prev;r.prev=r.next,r.next=n;}return this.head=t,this.tail=e,this};function iV(e,t,r){var n=t===e.head?new ea(r,null,t,e):new ea(r,t,t.next,e);return n.next===null&&(e.tail=n),n.prev===null&&(e.head=n),e.length++,n}function sV(e,t){e.tail=new ea(t,e.tail,null,e),e.head||(e.head=e.tail),e.length++;}function aV(e,t){e.head=new ea(t,null,e.head,e),e.tail||(e.tail=e.head),e.length++;}function ea(e,t,r,n){if(!(this instanceof ea))return new ea(e,t,r,n);this.list=n,this.value=e,t?(t.next=this,this.prev=t):this.prev=null,r?(r.prev=this,this.next=r):this.next=null;}try{wT()(Et);}catch{}});var PT=I((iue,IT)=>{var oV=xT(),ta=Symbol("max"),Fi=Symbol("length"),Ja=Symbol("lengthCalculator"),Au=Symbol("allowStale"),ra=Symbol("maxAge"),Bi=Symbol("dispose"),TT=Symbol("noDisposeOnSet"),hr=Symbol("lruList"),Jn=Symbol("cache"),RT=Symbol("updateAgeOnGet"),rm=()=>1,im=class{constructor(t){if(typeof t=="number"&&(t={max:t}),t||(t={}),t.max&&(typeof t.max!="number"||t.max<0))throw new TypeError("max must be a non-negative number");this[ta]=t.max||1/0;let n=t.length||rm;if(this[Ja]=typeof n!="function"?rm:n,this[Au]=t.stale||!1,t.maxAge&&typeof t.maxAge!="number")throw new TypeError("maxAge must be a number");this[ra]=t.maxAge||0,this[Bi]=t.dispose,this[TT]=t.noDisposeOnSet||!1,this[RT]=t.updateAgeOnGet||!1,this.reset();}set max(t){if(typeof t!="number"||t<0)throw new TypeError("max must be a non-negative number");this[ta]=t||1/0,Tu(this);}get max(){return this[ta]}set allowStale(t){this[Au]=!!t;}get allowStale(){return this[Au]}set maxAge(t){if(typeof t!="number")throw new TypeError("maxAge must be a non-negative number");this[ra]=t,Tu(this);}get maxAge(){return this[ra]}set lengthCalculator(t){typeof t!="function"&&(t=rm),t!==this[Ja]&&(this[Ja]=t,this[Fi]=0,this[hr].forEach(r=>{r.length=this[Ja](r.value,r.key),this[Fi]+=r.length;})),Tu(this);}get lengthCalculator(){return this[Ja]}get length(){return this[Fi]}get itemCount(){return this[hr].length}rforEach(t,r){r=r||this;for(let n=this[hr].tail;n!==null;){let i=n.prev;AT(this,t,n,r),n=i;}}forEach(t,r){r=r||this;for(let n=this[hr].head;n!==null;){let i=n.next;AT(this,t,n,r),n=i;}}keys(){return this[hr].toArray().map(t=>t.key)}values(){return this[hr].toArray().map(t=>t.value)}reset(){this[Bi]&&this[hr]&&this[hr].length&&this[hr].forEach(t=>this[Bi](t.key,t.value)),this[Jn]=new Map,this[hr]=new oV,this[Fi]=0;}dump(){return this[hr].map(t=>nf(this,t)?!1:{k:t.key,v:t.value,e:t.now+(t.maxAge||0)}).toArray().filter(t=>t)}dumpLru(){return this[hr]}set(t,r,n){if(n=n||this[ra],n&&typeof n!="number")throw new TypeError("maxAge must be a number");let i=n?Date.now():0,s=this[Ja](r,t);if(this[Jn].has(t)){if(s>this[ta])return eo(this,this[Jn].get(t)),!1;let c=this[Jn].get(t).value;return this[Bi]&&(this[TT]||this[Bi](t,c.value)),c.now=i,c.maxAge=n,c.value=r,this[Fi]+=s-c.length,c.length=s,this.get(t),Tu(this),!0}let a=new sm(t,r,s,i,n);return a.length>this[ta]?(this[Bi]&&this[Bi](t,r),!1):(this[Fi]+=a.length,this[hr].unshift(a),this[Jn].set(t,this[hr].head),Tu(this),!0)}has(t){if(!this[Jn].has(t))return !1;let r=this[Jn].get(t).value;return !nf(this,r)}get(t){return nm(this,t,!0)}peek(t){return nm(this,t,!1)}pop(){let t=this[hr].tail;return t?(eo(this,t),t.value):null}del(t){eo(this,this[Jn].get(t));}load(t){this.reset();let r=Date.now();for(let n=t.length-1;n>=0;n--){let i=t[n],s=i.e||0;if(s===0)this.set(i.k,i.v);else {let a=s-r;a>0&&this.set(i.k,i.v,a);}}}prune(){this[Jn].forEach((t,r)=>nm(this,r,!1));}},nm=(e,t,r)=>{let n=e[Jn].get(t);if(n){let i=n.value;if(nf(e,i)){if(eo(e,n),!e[Au])return}else r&&(e[RT]&&(n.value.now=Date.now()),e[hr].unshiftNode(n));return i.value}},nf=(e,t)=>{if(!t||!t.maxAge&&!e[ra])return !1;let r=Date.now()-t.now;return t.maxAge?r>t.maxAge:e[ra]&&r>e[ra]},Tu=e=>{if(e[Fi]>e[ta])for(let t=e[hr].tail;e[Fi]>e[ta]&&t!==null;){let r=t.prev;eo(e,t),t=r;}},eo=(e,t)=>{if(t){let r=t.value;e[Bi]&&e[Bi](r.key,r.value),e[Fi]-=r.length,e[Jn].delete(r.key),e[hr].removeNode(t);}},sm=class{constructor(t,r,n,i,s){this.key=t,this.value=r,this.length=n,this.now=i,this.maxAge=s||0;}},AT=(e,t,r,n)=>{let i=r.value;nf(e,i)&&(eo(e,r),e[Au]||(i=void 0)),i&&t.call(n,i.value,i.key,e);};IT.exports=im;});var kn=I((sue,kT)=>{var am=class e{constructor(t,r){if(r=cV(r),t instanceof e)return t.loose===!!r.loose&&t.includePrerelease===!!r.includePrerelease?t:new e(t.raw,r);if(t instanceof om)return this.raw=t.value,this.set=[[t]],this.format(),this;if(this.options=r,this.loose=!!r.loose,this.includePrerelease=!!r.includePrerelease,this.raw=t.trim().split(/\s+/).join(" "),this.set=this.raw.split("||").map(n=>this.parseRange(n.trim())).filter(n=>n.length),!this.set.length)throw new TypeError(`Invalid SemVer Range: ${this.raw}`);if(this.set.length>1){let n=this.set[0];if(this.set=this.set.filter(i=>!DT(i[0])),this.set.length===0)this.set=[n];else if(this.set.length>1){for(let i of this.set)if(i.length===1&&mV(i[0])){this.set=[i];break}}}this.format();}format(){return this.range=this.set.map(t=>t.join(" ").trim()).join("||").trim(),this.range}toString(){return this.range}parseRange(t){let n=((this.options.includePrerelease&&pV)|(this.options.loose&&gV))+":"+t,i=NT.get(n);if(i)return i;let s=this.options.loose,a=s?rn[Hr.HYPHENRANGELOOSE]:rn[Hr.HYPHENRANGE];t=t.replace(a,TV(this.options.includePrerelease)),Ht("hyphen replace",t),t=t.replace(rn[Hr.COMPARATORTRIM],fV),Ht("comparator trim",t),t=t.replace(rn[Hr.TILDETRIM],dV),Ht("tilde trim",t),t=t.replace(rn[Hr.CARETTRIM],hV),Ht("caret trim",t);let o=t.split(" ").map(f=>yV(f,this.options)).join(" ").split(/\s+/).map(f=>xV(f,this.options));s&&(o=o.filter(f=>(Ht("loose invalid filter",f,this.options),!!f.match(rn[Hr.COMPARATORLOOSE])))),Ht("range list",o);let c=new Map,l=o.map(f=>new om(f,this.options));for(let f of l){if(DT(f))return [f];c.set(f.value,f);}c.size>1&&c.has("")&&c.delete("");let u=[...c.values()];return NT.set(n,u),u}intersects(t,r){if(!(t instanceof e))throw new TypeError("a Range is required");return this.set.some(n=>OT(n,r)&&t.set.some(i=>OT(i,r)&&n.every(s=>i.every(a=>s.intersects(a,r)))))}test(t){if(!t)return !1;if(typeof t=="string")try{t=new lV(t,this.options);}catch{return !1}for(let r=0;r<this.set.length;r++)if(AV(this.set[r],t,this.options))return !0;return !1}};kT.exports=am;var uV=PT(),NT=new uV({max:1e3}),cV=zl(),om=Ru(),Ht=Cu(),lV=Lr(),{safeRe:rn,t:Hr,comparatorTrimReplace:fV,tildeTrimReplace:dV,caretTrimReplace:hV}=Xa(),{FLAG_INCLUDE_PRERELEASE:pV,FLAG_LOOSE:gV}=wu(),DT=e=>e.value==="<0.0.0-0",mV=e=>e.value==="",OT=(e,t)=>{let r=!0,n=e.slice(),i=n.pop();for(;r&&n.length;)r=n.every(s=>i.intersects(s,t)),i=n.pop();return r},yV=(e,t)=>(Ht("comp",e,t),e=bV(e,t),Ht("caret",e),e=vV(e,t),Ht("tildes",e),e=EV(e,t),Ht("xrange",e),e=CV(e,t),Ht("stars",e),e),Wr=e=>!e||e.toLowerCase()==="x"||e==="*",vV=(e,t)=>e.trim().split(/\s+/).map(r=>_V(r,t)).join(" "),_V=(e,t)=>{let r=t.loose?rn[Hr.TILDELOOSE]:rn[Hr.TILDE];return e.replace(r,(n,i,s,a,o)=>{Ht("tilde",e,n,i,s,a,o);let c;return Wr(i)?c="":Wr(s)?c=`>=${i}.0.0 <${+i+1}.0.0-0`:Wr(a)?c=`>=${i}.${s}.0 <${i}.${+s+1}.0-0`:o?(Ht("replaceTilde pr",o),c=`>=${i}.${s}.${a}-${o} <${i}.${+s+1}.0-0`):c=`>=${i}.${s}.${a} <${i}.${+s+1}.0-0`,Ht("tilde return",c),c})},bV=(e,t)=>e.trim().split(/\s+/).map(r=>SV(r,t)).join(" "),SV=(e,t)=>{Ht("caret",e,t);let r=t.loose?rn[Hr.CARETLOOSE]:rn[Hr.CARET],n=t.includePrerelease?"-0":"";return e.replace(r,(i,s,a,o,c)=>{Ht("caret",e,i,s,a,o,c);let l;return Wr(s)?l="":Wr(a)?l=`>=${s}.0.0${n} <${+s+1}.0.0-0`:Wr(o)?s==="0"?l=`>=${s}.${a}.0${n} <${s}.${+a+1}.0-0`:l=`>=${s}.${a}.0${n} <${+s+1}.0.0-0`:c?(Ht("replaceCaret pr",c),s==="0"?a==="0"?l=`>=${s}.${a}.${o}-${c} <${s}.${a}.${+o+1}-0`:l=`>=${s}.${a}.${o}-${c} <${s}.${+a+1}.0-0`:l=`>=${s}.${a}.${o}-${c} <${+s+1}.0.0-0`):(Ht("no pr"),s==="0"?a==="0"?l=`>=${s}.${a}.${o}${n} <${s}.${a}.${+o+1}-0`:l=`>=${s}.${a}.${o}${n} <${s}.${+a+1}.0-0`:l=`>=${s}.${a}.${o} <${+s+1}.0.0-0`),Ht("caret return",l),l})},EV=(e,t)=>(Ht("replaceXRanges",e,t),e.split(/\s+/).map(r=>wV(r,t)).join(" ")),wV=(e,t)=>{e=e.trim();let r=t.loose?rn[Hr.XRANGELOOSE]:rn[Hr.XRANGE];return e.replace(r,(n,i,s,a,o,c)=>{Ht("xRange",e,n,i,s,a,o,c);let l=Wr(s),u=l||Wr(a),f=u||Wr(o),h=f;return i==="="&&h&&(i=""),c=t.includePrerelease?"-0":"",l?i===">"||i==="<"?n="<0.0.0-0":n="*":i&&h?(u&&(a=0),o=0,i===">"?(i=">=",u?(s=+s+1,a=0,o=0):(a=+a+1,o=0)):i==="<="&&(i="<",u?s=+s+1:a=+a+1),i==="<"&&(c="-0"),n=`${i+s}.${a}.${o}${c}`):u?n=`>=${s}.0.0${c} <${+s+1}.0.0-0`:f&&(n=`>=${s}.${a}.0${c} <${s}.${+a+1}.0-0`),Ht("xRange return",n),n})},CV=(e,t)=>(Ht("replaceStars",e,t),e.trim().replace(rn[Hr.STAR],"")),xV=(e,t)=>(Ht("replaceGTE0",e,t),e.trim().replace(rn[t.includePrerelease?Hr.GTE0PRE:Hr.GTE0],"")),TV=e=>(t,r,n,i,s,a,o,c,l,u,f,h,p)=>(Wr(n)?r="":Wr(i)?r=`>=${n}.0.0${e?"-0":""}`:Wr(s)?r=`>=${n}.${i}.0${e?"-0":""}`:a?r=`>=${r}`:r=`>=${r}${e?"-0":""}`,Wr(l)?c="":Wr(u)?c=`<${+l+1}.0.0-0`:Wr(f)?c=`<${l}.${+u+1}.0-0`:h?c=`<=${l}.${u}.${f}-${h}`:e?c=`<${l}.${u}.${+f+1}-0`:c=`<=${c}`,`${r} ${c}`.trim()),AV=(e,t,r)=>{for(let n=0;n<e.length;n++)if(!e[n].test(t))return !1;if(t.prerelease.length&&!r.includePrerelease){for(let n=0;n<e.length;n++)if(Ht(e[n].semver),e[n].semver!==om.ANY&&e[n].semver.prerelease.length>0){let i=e[n].semver;if(i.major===t.major&&i.minor===t.minor&&i.patch===t.patch)return !0}return !1}return !0};});var Ru=I((aue,UT)=>{var Iu=Symbol("SemVer ANY"),lm=class e{static get ANY(){return Iu}constructor(t,r){if(r=LT(r),t instanceof e){if(t.loose===!!r.loose)return t;t=t.value;}t=t.trim().split(/\s+/).join(" "),cm("comparator",t,r),this.options=r,this.loose=!!r.loose,this.parse(t),this.semver===Iu?this.value="":this.value=this.operator+this.semver.version,cm("comp",this);}parse(t){let r=this.options.loose?BT[FT.COMPARATORLOOSE]:BT[FT.COMPARATOR],n=t.match(r);if(!n)throw new TypeError(`Invalid comparator: ${t}`);this.operator=n[1]!==void 0?n[1]:"",this.operator==="="&&(this.operator=""),n[2]?this.semver=new qT(n[2],this.options.loose):this.semver=Iu;}toString(){return this.value}test(t){if(cm("Comparator.test",t,this.options.loose),this.semver===Iu||t===Iu)return !0;if(typeof t=="string")try{t=new qT(t,this.options);}catch{return !1}return um(t,this.operator,this.semver,this.options)}intersects(t,r){if(!(t instanceof e))throw new TypeError("a Comparator is required");return this.operator===""?this.value===""?!0:new MT(t.value,r).test(this.value):t.operator===""?t.value===""?!0:new MT(this.value,r).test(t.semver):(r=LT(r),r.includePrerelease&&(this.value==="<0.0.0-0"||t.value==="<0.0.0-0")||!r.includePrerelease&&(this.value.startsWith("<0.0.0")||t.value.startsWith("<0.0.0"))?!1:!!(this.operator.startsWith(">")&&t.operator.startsWith(">")||this.operator.startsWith("<")&&t.operator.startsWith("<")||this.semver.version===t.semver.version&&this.operator.includes("=")&&t.operator.includes("=")||um(this.semver,"<",t.semver,r)&&this.operator.startsWith(">")&&t.operator.startsWith("<")||um(this.semver,">",t.semver,r)&&this.operator.startsWith("<")&&t.operator.startsWith(">")))}};UT.exports=lm;var LT=zl(),{safeRe:BT,t:FT}=Xa(),um=tm(),cm=Cu(),qT=Lr(),MT=kn();});var Pu=I((oue,$T)=>{var RV=kn(),IV=(e,t,r)=>{try{t=new RV(t,r);}catch{return !1}return t.test(e)};$T.exports=IV;});var VT=I((uue,jT)=>{var PV=kn(),NV=(e,t)=>new PV(e,t).set.map(r=>r.map(n=>n.value).join(" ").trim().split(" "));jT.exports=NV;});var WT=I((cue,HT)=>{var DV=Lr(),OV=kn(),kV=(e,t,r)=>{let n=null,i=null,s=null;try{s=new OV(t,r);}catch{return null}return e.forEach(a=>{s.test(a)&&(!n||i.compare(a)===-1)&&(n=a,i=new DV(n,r));}),n};HT.exports=kV;});var GT=I((lue,KT)=>{var LV=Lr(),BV=kn(),FV=(e,t,r)=>{let n=null,i=null,s=null;try{s=new BV(t,r);}catch{return null}return e.forEach(a=>{s.test(a)&&(!n||i.compare(a)===1)&&(n=a,i=new LV(n,r));}),n};KT.exports=FV;});var QT=I((fue,YT)=>{var fm=Lr(),qV=kn(),zT=xu(),MV=(e,t)=>{e=new qV(e,t);let r=new fm("0.0.0");if(e.test(r)||(r=new fm("0.0.0-0"),e.test(r)))return r;r=null;for(let n=0;n<e.set.length;++n){let i=e.set[n],s=null;i.forEach(a=>{let o=new fm(a.semver.version);switch(a.operator){case">":o.prerelease.length===0?o.patch++:o.prerelease.push(0),o.raw=o.format();case"":case">=":(!s||zT(o,s))&&(s=o);break;case"<":case"<=":break;default:throw new Error(`Unexpected operation: ${a.operator}`)}}),s&&(!r||zT(r,s))&&(r=s);}return r&&e.test(r)?r:null};YT.exports=MV;});var ZT=I((due,XT)=>{var UV=kn(),$V=(e,t)=>{try{return new UV(e,t).range||"*"}catch{return null}};XT.exports=$V;});var sf=I((hue,rA)=>{var jV=Lr(),tA=Ru(),{ANY:VV}=tA,HV=kn(),WV=Pu(),JT=xu(),eA=Zl(),KV=ef(),GV=Jl(),zV=(e,t,r,n)=>{e=new jV(e,n),t=new HV(t,n);let i,s,a,o,c;switch(r){case">":i=JT,s=KV,a=eA,o=">",c=">=";break;case"<":i=eA,s=GV,a=JT,o="<",c="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(WV(e,t,n))return !1;for(let l=0;l<t.set.length;++l){let u=t.set[l],f=null,h=null;if(u.forEach(p=>{p.semver===VV&&(p=new tA(">=0.0.0")),f=f||p,h=h||p,i(p.semver,f.semver,n)?f=p:a(p.semver,h.semver,n)&&(h=p);}),f.operator===o||f.operator===c||(!h.operator||h.operator===o)&&s(e,h.semver))return !1;if(h.operator===c&&a(e,h.semver))return !1}return !0};rA.exports=zV;});var iA=I((pue,nA)=>{var YV=sf(),QV=(e,t,r)=>YV(e,t,">",r);nA.exports=QV;});var aA=I((gue,sA)=>{var XV=sf(),ZV=(e,t,r)=>XV(e,t,"<",r);sA.exports=ZV;});var cA=I((mue,uA)=>{var oA=kn(),JV=(e,t,r)=>(e=new oA(e,r),t=new oA(t,r),e.intersects(t,r));uA.exports=JV;});var fA=I((yue,lA)=>{var eH=Pu(),tH=On();lA.exports=(e,t,r)=>{let n=[],i=null,s=null,a=e.sort((u,f)=>tH(u,f,r));for(let u of a)eH(u,t,r)?(s=u,i||(i=u)):(s&&n.push([i,s]),s=null,i=null);i&&n.push([i,null]);let o=[];for(let[u,f]of n)u===f?o.push(u):!f&&u===a[0]?o.push("*"):f?u===a[0]?o.push(`<=${f}`):o.push(`${u} - ${f}`):o.push(`>=${u}`);let c=o.join(" || "),l=typeof t.raw=="string"?t.raw:String(t);return c.length<l.length?c:t};});var yA=I((vue,mA)=>{var dA=kn(),hm=Ru(),{ANY:dm}=hm,Nu=Pu(),pm=On(),rH=(e,t,r={})=>{if(e===t)return !0;e=new dA(e,r),t=new dA(t,r);let n=!1;e:for(let i of e.set){for(let s of t.set){let a=iH(i,s,r);if(n=n||a!==null,a)continue e}if(n)return !1}return !0},nH=[new hm(">=0.0.0-0")],hA=[new hm(">=0.0.0")],iH=(e,t,r)=>{if(e===t)return !0;if(e.length===1&&e[0].semver===dm){if(t.length===1&&t[0].semver===dm)return !0;r.includePrerelease?e=nH:e=hA;}if(t.length===1&&t[0].semver===dm){if(r.includePrerelease)return !0;t=hA;}let n=new Set,i,s;for(let p of e)p.operator===">"||p.operator===">="?i=pA(i,p,r):p.operator==="<"||p.operator==="<="?s=gA(s,p,r):n.add(p.semver);if(n.size>1)return null;let a;if(i&&s){if(a=pm(i.semver,s.semver,r),a>0)return null;if(a===0&&(i.operator!==">="||s.operator!=="<="))return null}for(let p of n){if(i&&!Nu(p,String(i),r)||s&&!Nu(p,String(s),r))return null;for(let g of t)if(!Nu(p,String(g),r))return !1;return !0}let o,c,l,u,f=s&&!r.includePrerelease&&s.semver.prerelease.length?s.semver:!1,h=i&&!r.includePrerelease&&i.semver.prerelease.length?i.semver:!1;f&&f.prerelease.length===1&&s.operator==="<"&&f.prerelease[0]===0&&(f=!1);for(let p of t){if(u=u||p.operator===">"||p.operator===">=",l=l||p.operator==="<"||p.operator==="<=",i){if(h&&p.semver.prerelease&&p.semver.prerelease.length&&p.semver.major===h.major&&p.semver.minor===h.minor&&p.semver.patch===h.patch&&(h=!1),p.operator===">"||p.operator===">="){if(o=pA(i,p,r),o===p&&o!==i)return !1}else if(i.operator===">="&&!Nu(i.semver,String(p),r))return !1}if(s){if(f&&p.semver.prerelease&&p.semver.prerelease.length&&p.semver.major===f.major&&p.semver.minor===f.minor&&p.semver.patch===f.patch&&(f=!1),p.operator==="<"||p.operator==="<="){if(c=gA(s,p,r),c===p&&c!==s)return !1}else if(s.operator==="<="&&!Nu(s.semver,String(p),r))return !1}if(!p.operator&&(s||i)&&a!==0)return !1}return !(i&&l&&!s&&a!==0||s&&u&&!i&&a!==0||h||f)},pA=(e,t,r)=>{if(!e)return t;let n=pm(e.semver,t.semver,r);return n>0?e:n<0||t.operator===">"&&e.operator===">="?t:e},gA=(e,t,r)=>{if(!e)return t;let n=pm(e.semver,t.semver,r);return n<0?e:n>0||t.operator==="<"&&e.operator==="<="?t:e};mA.exports=rH;});var SA=I((_ue,bA)=>{var gm=Xa(),vA=wu(),sH=Lr(),_A=Xg(),aH=Js(),oH=qx(),uH=Ux(),cH=Vx(),lH=Kx(),fH=zx(),dH=Qx(),hH=Zx(),pH=eT(),gH=On(),mH=iT(),yH=aT(),vH=Xl(),_H=lT(),bH=dT(),SH=xu(),EH=Zl(),wH=Jg(),CH=em(),xH=Jl(),TH=ef(),AH=tm(),RH=ST(),IH=Ru(),PH=kn(),NH=Pu(),DH=VT(),OH=WT(),kH=GT(),LH=QT(),BH=ZT(),FH=sf(),qH=iA(),MH=aA(),UH=cA(),$H=fA(),jH=yA();bA.exports={parse:aH,valid:oH,clean:uH,inc:cH,diff:lH,major:fH,minor:dH,patch:hH,prerelease:pH,compare:gH,rcompare:mH,compareLoose:yH,compareBuild:vH,sort:_H,rsort:bH,gt:SH,lt:EH,eq:wH,neq:CH,gte:xH,lte:TH,cmp:AH,coerce:RH,Comparator:IH,Range:PH,satisfies:NH,toComparators:DH,maxSatisfying:OH,minSatisfying:kH,minVersion:LH,validRange:BH,outside:FH,gtr:qH,ltr:MH,intersects:UH,simplifyRange:$H,subset:jH,SemVer:sH,re:gm.re,src:gm.src,tokens:gm.t,SEMVER_SPEC_VERSION:vA.SEMVER_SPEC_VERSION,RELEASE_TYPES:vA.RELEASE_TYPES,compareIdentifiers:_A.compareIdentifiers,rcompareIdentifiers:_A.rcompareIdentifiers};});var pr=I(mm=>{mm.fromCallback=function(e){return Object.defineProperty(function(...t){if(typeof t[t.length-1]=="function")e.apply(this,t);else return new Promise((r,n)=>{t.push((i,s)=>i!=null?n(i):r(s)),e.apply(this,t);})},"name",{value:e.name})};mm.fromPromise=function(e){return Object.defineProperty(function(...t){let r=t[t.length-1];if(typeof r!="function")return e.apply(this,t);t.pop(),e.apply(this,t).then(n=>r(null,n),r);},"name",{value:e.name})};});var wA=I((Sue,EA)=>{var ls=he("constants"),VH=process.cwd,af=null,HH=process.env.GRACEFUL_FS_PLATFORM||process.platform;process.cwd=function(){return af||(af=VH.call(process)),af};try{process.cwd();}catch{}typeof process.chdir=="function"&&(ym=process.chdir,process.chdir=function(e){af=null,ym.call(process,e);},Object.setPrototypeOf&&Object.setPrototypeOf(process.chdir,ym));var ym;EA.exports=WH;function WH(e){ls.hasOwnProperty("O_SYMLINK")&&process.version.match(/^v0\.6\.[0-2]|^v0\.5\./)&&t(e),e.lutimes||r(e),e.chown=s(e.chown),e.fchown=s(e.fchown),e.lchown=s(e.lchown),e.chmod=n(e.chmod),e.fchmod=n(e.fchmod),e.lchmod=n(e.lchmod),e.chownSync=a(e.chownSync),e.fchownSync=a(e.fchownSync),e.lchownSync=a(e.lchownSync),e.chmodSync=i(e.chmodSync),e.fchmodSync=i(e.fchmodSync),e.lchmodSync=i(e.lchmodSync),e.stat=o(e.stat),e.fstat=o(e.fstat),e.lstat=o(e.lstat),e.statSync=c(e.statSync),e.fstatSync=c(e.fstatSync),e.lstatSync=c(e.lstatSync),e.chmod&&!e.lchmod&&(e.lchmod=function(u,f,h){h&&process.nextTick(h);},e.lchmodSync=function(){}),e.chown&&!e.lchown&&(e.lchown=function(u,f,h,p){p&&process.nextTick(p);},e.lchownSync=function(){}),HH==="win32"&&(e.rename=typeof e.rename!="function"?e.rename:function(u){function f(h,p,g){var _=Date.now(),E=0;u(h,p,function w(y){if(y&&(y.code==="EACCES"||y.code==="EPERM"||y.code==="EBUSY")&&Date.now()-_<6e4){setTimeout(function(){e.stat(p,function(b,N){b&&b.code==="ENOENT"?u(h,p,w):g(y);});},E),E<100&&(E+=10);return}g&&g(y);});}return Object.setPrototypeOf&&Object.setPrototypeOf(f,u),f}(e.rename)),e.read=typeof e.read!="function"?e.read:function(u){function f(h,p,g,_,E,w){var y;if(w&&typeof w=="function"){var b=0;y=function(N,L,V){if(N&&N.code==="EAGAIN"&&b<10)return b++,u.call(e,h,p,g,_,E,y);w.apply(this,arguments);};}return u.call(e,h,p,g,_,E,y)}return Object.setPrototypeOf&&Object.setPrototypeOf(f,u),f}(e.read),e.readSync=typeof e.readSync!="function"?e.readSync:function(u){return function(f,h,p,g,_){for(var E=0;;)try{return u.call(e,f,h,p,g,_)}catch(w){if(w.code==="EAGAIN"&&E<10){E++;continue}throw w}}}(e.readSync);function t(u){u.lchmod=function(f,h,p){u.open(f,ls.O_WRONLY|ls.O_SYMLINK,h,function(g,_){if(g){p&&p(g);return}u.fchmod(_,h,function(E){u.close(_,function(w){p&&p(E||w);});});});},u.lchmodSync=function(f,h){var p=u.openSync(f,ls.O_WRONLY|ls.O_SYMLINK,h),g=!0,_;try{_=u.fchmodSync(p,h),g=!1;}finally{if(g)try{u.closeSync(p);}catch{}else u.closeSync(p);}return _};}function r(u){ls.hasOwnProperty("O_SYMLINK")&&u.futimes?(u.lutimes=function(f,h,p,g){u.open(f,ls.O_SYMLINK,function(_,E){if(_){g&&g(_);return}u.futimes(E,h,p,function(w){u.close(E,function(y){g&&g(w||y);});});});},u.lutimesSync=function(f,h,p){var g=u.openSync(f,ls.O_SYMLINK),_,E=!0;try{_=u.futimesSync(g,h,p),E=!1;}finally{if(E)try{u.closeSync(g);}catch{}else u.closeSync(g);}return _}):u.futimes&&(u.lutimes=function(f,h,p,g){g&&process.nextTick(g);},u.lutimesSync=function(){});}function n(u){return u&&function(f,h,p){return u.call(e,f,h,function(g){l(g)&&(g=null),p&&p.apply(this,arguments);})}}function i(u){return u&&function(f,h){try{return u.call(e,f,h)}catch(p){if(!l(p))throw p}}}function s(u){return u&&function(f,h,p,g){return u.call(e,f,h,p,function(_){l(_)&&(_=null),g&&g.apply(this,arguments);})}}function a(u){return u&&function(f,h,p){try{return u.call(e,f,h,p)}catch(g){if(!l(g))throw g}}}function o(u){return u&&function(f,h,p){typeof h=="function"&&(p=h,h=null);function g(_,E){E&&(E.uid<0&&(E.uid+=4294967296),E.gid<0&&(E.gid+=4294967296)),p&&p.apply(this,arguments);}return h?u.call(e,f,h,g):u.call(e,f,g)}}function c(u){return u&&function(f,h){var p=h?u.call(e,f,h):u.call(e,f);return p&&(p.uid<0&&(p.uid+=4294967296),p.gid<0&&(p.gid+=4294967296)),p}}function l(u){if(!u||u.code==="ENOSYS")return !0;var f=!process.getuid||process.getuid()!==0;return !!(f&&(u.code==="EINVAL"||u.code==="EPERM"))}}});var TA=I((Eue,xA)=>{var CA=he("stream").Stream;xA.exports=KH;function KH(e){return {ReadStream:t,WriteStream:r};function t(n,i){if(!(this instanceof t))return new t(n,i);CA.call(this);var s=this;this.path=n,this.fd=null,this.readable=!0,this.paused=!1,this.flags="r",this.mode=438,this.bufferSize=64*1024,i=i||{};for(var a=Object.keys(i),o=0,c=a.length;o<c;o++){var l=a[o];this[l]=i[l];}if(this.encoding&&this.setEncoding(this.encoding),this.start!==void 0){if(typeof this.start!="number")throw TypeError("start must be a Number");if(this.end===void 0)this.end=1/0;else if(typeof this.end!="number")throw TypeError("end must be a Number");if(this.start>this.end)throw new Error("start must be <= end");this.pos=this.start;}if(this.fd!==null){process.nextTick(function(){s._read();});return}e.open(this.path,this.flags,this.mode,function(u,f){if(u){s.emit("error",u),s.readable=!1;return}s.fd=f,s.emit("open",f),s._read();});}function r(n,i){if(!(this instanceof r))return new r(n,i);CA.call(this),this.path=n,this.fd=null,this.writable=!0,this.flags="w",this.encoding="binary",this.mode=438,this.bytesWritten=0,i=i||{};for(var s=Object.keys(i),a=0,o=s.length;a<o;a++){var c=s[a];this[c]=i[c];}if(this.start!==void 0){if(typeof this.start!="number")throw TypeError("start must be a Number");if(this.start<0)throw new Error("start must be >= zero");this.pos=this.start;}this.busy=!1,this._queue=[],this.fd===null&&(this._open=e.open,this._queue.push([this._open,this.path,this.flags,this.mode,void 0]),this.flush());}}});var RA=I((wue,AA)=>{AA.exports=zH;var GH=Object.getPrototypeOf||function(e){return e.__proto__};function zH(e){if(e===null||typeof e!="object")return e;if(e instanceof Object)var t={__proto__:GH(e)};else var t=Object.create(null);return Object.getOwnPropertyNames(e).forEach(function(r){Object.defineProperty(t,r,Object.getOwnPropertyDescriptor(e,r));}),t}});var ro=I((Cue,bm)=>{var Jt=he("fs"),YH=wA(),QH=TA(),XH=RA(),of=he("util"),Ir,cf;typeof Symbol=="function"&&typeof Symbol.for=="function"?(Ir=Symbol.for("graceful-fs.queue"),cf=Symbol.for("graceful-fs.previous")):(Ir="___graceful-fs.queue",cf="___graceful-fs.previous");function ZH(){}function NA(e,t){Object.defineProperty(e,Ir,{get:function(){return t}});}var na=ZH;of.debuglog?na=of.debuglog("gfs4"):/\bgfs4\b/i.test(process.env.NODE_DEBUG||"")&&(na=function(){var e=of.format.apply(of,arguments);e="GFS4: "+e.split(/\n/).join(`
GFS4: `),console.error(e);});Jt[Ir]||(IA=global[Ir]||[],NA(Jt,IA),Jt.close=function(e){function t(r,n){return e.call(Jt,r,function(i){i||PA(),typeof n=="function"&&n.apply(this,arguments);})}return Object.defineProperty(t,cf,{value:e}),t}(Jt.close),Jt.closeSync=function(e){function t(r){e.apply(Jt,arguments),PA();}return Object.defineProperty(t,cf,{value:e}),t}(Jt.closeSync),/\bgfs4\b/i.test(process.env.NODE_DEBUG||"")&&process.on("exit",function(){na(Jt[Ir]),he("assert").equal(Jt[Ir].length,0);}));var IA;global[Ir]||NA(global,Jt[Ir]);bm.exports=vm(XH(Jt));process.env.TEST_GRACEFUL_FS_GLOBAL_PATCH&&!Jt.__patched&&(bm.exports=vm(Jt),Jt.__patched=!0);function vm(e){YH(e),e.gracefulify=vm,e.createReadStream=L,e.createWriteStream=V;var t=e.readFile;e.readFile=r;function r(z,ee,U){return typeof ee=="function"&&(U=ee,ee=null),ie(z,ee,U);function ie(me,Pe,W,K){return t(me,Pe,function(se){se&&(se.code==="EMFILE"||se.code==="ENFILE")?to([ie,[me,Pe,W],se,K||Date.now(),Date.now()]):typeof W=="function"&&W.apply(this,arguments);})}}var n=e.writeFile;e.writeFile=i;function i(z,ee,U,ie){return typeof U=="function"&&(ie=U,U=null),me(z,ee,U,ie);function me(Pe,W,K,se,Ae){return n(Pe,W,K,function(Me){Me&&(Me.code==="EMFILE"||Me.code==="ENFILE")?to([me,[Pe,W,K,se],Me,Ae||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}var s=e.appendFile;s&&(e.appendFile=a);function a(z,ee,U,ie){return typeof U=="function"&&(ie=U,U=null),me(z,ee,U,ie);function me(Pe,W,K,se,Ae){return s(Pe,W,K,function(Me){Me&&(Me.code==="EMFILE"||Me.code==="ENFILE")?to([me,[Pe,W,K,se],Me,Ae||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}var o=e.copyFile;o&&(e.copyFile=c);function c(z,ee,U,ie){return typeof U=="function"&&(ie=U,U=0),me(z,ee,U,ie);function me(Pe,W,K,se,Ae){return o(Pe,W,K,function(Me){Me&&(Me.code==="EMFILE"||Me.code==="ENFILE")?to([me,[Pe,W,K,se],Me,Ae||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}var l=e.readdir;e.readdir=f;var u=/^v[0-5]\./;function f(z,ee,U){typeof ee=="function"&&(U=ee,ee=null);var ie=u.test(process.version)?function(W,K,se,Ae){return l(W,me(W,K,se,Ae))}:function(W,K,se,Ae){return l(W,K,me(W,K,se,Ae))};return ie(z,ee,U);function me(Pe,W,K,se){return function(Ae,Me){Ae&&(Ae.code==="EMFILE"||Ae.code==="ENFILE")?to([ie,[Pe,W,K],Ae,se||Date.now(),Date.now()]):(Me&&Me.sort&&Me.sort(),typeof K=="function"&&K.call(this,Ae,Me));}}}if(process.version.substr(0,4)==="v0.8"){var h=QH(e);w=h.ReadStream,b=h.WriteStream;}var p=e.ReadStream;p&&(w.prototype=Object.create(p.prototype),w.prototype.open=y);var g=e.WriteStream;g&&(b.prototype=Object.create(g.prototype),b.prototype.open=N),Object.defineProperty(e,"ReadStream",{get:function(){return w},set:function(z){w=z;},enumerable:!0,configurable:!0}),Object.defineProperty(e,"WriteStream",{get:function(){return b},set:function(z){b=z;},enumerable:!0,configurable:!0});var _=w;Object.defineProperty(e,"FileReadStream",{get:function(){return _},set:function(z){_=z;},enumerable:!0,configurable:!0});var E=b;Object.defineProperty(e,"FileWriteStream",{get:function(){return E},set:function(z){E=z;},enumerable:!0,configurable:!0});function w(z,ee){return this instanceof w?(p.apply(this,arguments),this):w.apply(Object.create(w.prototype),arguments)}function y(){var z=this;G(z.path,z.flags,z.mode,function(ee,U){ee?(z.autoClose&&z.destroy(),z.emit("error",ee)):(z.fd=U,z.emit("open",U),z.read());});}function b(z,ee){return this instanceof b?(g.apply(this,arguments),this):b.apply(Object.create(b.prototype),arguments)}function N(){var z=this;G(z.path,z.flags,z.mode,function(ee,U){ee?(z.destroy(),z.emit("error",ee)):(z.fd=U,z.emit("open",U));});}function L(z,ee){return new e.ReadStream(z,ee)}function V(z,ee){return new e.WriteStream(z,ee)}var Z=e.open;e.open=G;function G(z,ee,U,ie){return typeof U=="function"&&(ie=U,U=null),me(z,ee,U,ie);function me(Pe,W,K,se,Ae){return Z(Pe,W,K,function(Me,ze){Me&&(Me.code==="EMFILE"||Me.code==="ENFILE")?to([me,[Pe,W,K,se],Me,Ae||Date.now(),Date.now()]):typeof se=="function"&&se.apply(this,arguments);})}}return e}function to(e){na("ENQUEUE",e[0].name,e[1]),Jt[Ir].push(e),_m();}var uf;function PA(){for(var e=Date.now(),t=0;t<Jt[Ir].length;++t)Jt[Ir][t].length>2&&(Jt[Ir][t][3]=e,Jt[Ir][t][4]=e);_m();}function _m(){if(clearTimeout(uf),uf=void 0,Jt[Ir].length!==0){var e=Jt[Ir].shift(),t=e[0],r=e[1],n=e[2],i=e[3],s=e[4];if(i===void 0)na("RETRY",t.name,r),t.apply(null,r);else if(Date.now()-i>=6e4){na("TIMEOUT",t.name,r);var a=r.pop();typeof a=="function"&&a.call(null,n);}else {var o=Date.now()-s,c=Math.max(s-i,1),l=Math.min(c*1.2,100);o>=l?(na("RETRY",t.name,r),t.apply(null,r.concat([i]))):Jt[Ir].push(e);}uf===void 0&&(uf=setTimeout(_m,0));}}});var Gr=I(qi=>{var DA=pr().fromCallback,Kr=ro(),JH=["access","appendFile","chmod","chown","close","copyFile","fchmod","fchown","fdatasync","fstat","fsync","ftruncate","futimes","lchmod","lchown","link","lstat","mkdir","mkdtemp","open","opendir","readdir","readFile","readlink","realpath","rename","rm","rmdir","stat","symlink","truncate","unlink","utimes","writeFile"].filter(e=>typeof Kr[e]=="function");Object.assign(qi,Kr);JH.forEach(e=>{qi[e]=DA(Kr[e]);});qi.exists=function(e,t){return typeof t=="function"?Kr.exists(e,t):new Promise(r=>Kr.exists(e,r))};qi.read=function(e,t,r,n,i,s){return typeof s=="function"?Kr.read(e,t,r,n,i,s):new Promise((a,o)=>{Kr.read(e,t,r,n,i,(c,l,u)=>{if(c)return o(c);a({bytesRead:l,buffer:u});});})};qi.write=function(e,t,...r){return typeof r[r.length-1]=="function"?Kr.write(e,t,...r):new Promise((n,i)=>{Kr.write(e,t,...r,(s,a,o)=>{if(s)return i(s);n({bytesWritten:a,buffer:o});});})};qi.readv=function(e,t,...r){return typeof r[r.length-1]=="function"?Kr.readv(e,t,...r):new Promise((n,i)=>{Kr.readv(e,t,...r,(s,a,o)=>{if(s)return i(s);n({bytesRead:a,buffers:o});});})};qi.writev=function(e,t,...r){return typeof r[r.length-1]=="function"?Kr.writev(e,t,...r):new Promise((n,i)=>{Kr.writev(e,t,...r,(s,a,o)=>{if(s)return i(s);n({bytesWritten:a,buffers:o});});})};typeof Kr.realpath.native=="function"?qi.realpath.native=DA(Kr.realpath.native):process.emitWarning("fs.realpath.native is not a function. Is fs being monkey-patched?","Warning","fs-extra-WARN0003");});var kA=I((Tue,OA)=>{var e9=he("path");OA.exports.checkPath=function(t){if(process.platform==="win32"&&/[<>:"|?*]/.test(t.replace(e9.parse(t).root,""))){let n=new Error(`Path contains invalid characters: ${t}`);throw n.code="EINVAL",n}};});var qA=I((Aue,Sm)=>{var LA=Gr(),{checkPath:BA}=kA(),FA=e=>{let t={mode:511};return typeof e=="number"?e:{...t,...e}.mode};Sm.exports.makeDir=async(e,t)=>(BA(e),LA.mkdir(e,{mode:FA(t),recursive:!0}));Sm.exports.makeDirSync=(e,t)=>(BA(e),LA.mkdirSync(e,{mode:FA(t),recursive:!0}));});var ei=I((Rue,MA)=>{var t9=pr().fromPromise,{makeDir:r9,makeDirSync:Em}=qA(),wm=t9(r9);MA.exports={mkdirs:wm,mkdirsSync:Em,mkdirp:wm,mkdirpSync:Em,ensureDir:wm,ensureDirSync:Em};});var ds=I((Iue,$A)=>{var n9=pr().fromPromise,UA=Gr();function i9(e){return UA.access(e).then(()=>!0).catch(()=>!1)}$A.exports={pathExists:n9(i9),pathExistsSync:UA.existsSync};});var Cm=I((Pue,jA)=>{var no=Gr(),s9=pr().fromPromise;async function a9(e,t,r){let n=await no.open(e,"r+"),i=null;try{await no.futimes(n,t,r);}finally{try{await no.close(n);}catch(s){i=s;}}if(i)throw i}function o9(e,t,r){let n=no.openSync(e,"r+");return no.futimesSync(n,t,r),no.closeSync(n)}jA.exports={utimesMillis:s9(a9),utimesMillisSync:o9};});var ia=I((Nue,KA)=>{var io=Gr(),gr=he("path"),VA=pr().fromPromise;function u9(e,t,r){let n=r.dereference?i=>io.stat(i,{bigint:!0}):i=>io.lstat(i,{bigint:!0});return Promise.all([n(e),n(t).catch(i=>{if(i.code==="ENOENT")return null;throw i})]).then(([i,s])=>({srcStat:i,destStat:s}))}function c9(e,t,r){let n,i=r.dereference?a=>io.statSync(a,{bigint:!0}):a=>io.lstatSync(a,{bigint:!0}),s=i(e);try{n=i(t);}catch(a){if(a.code==="ENOENT")return {srcStat:s,destStat:null};throw a}return {srcStat:s,destStat:n}}async function l9(e,t,r,n){let{srcStat:i,destStat:s}=await u9(e,t,n);if(s){if(Du(i,s)){let a=gr.basename(e),o=gr.basename(t);if(r==="move"&&a!==o&&a.toLowerCase()===o.toLowerCase())return {srcStat:i,destStat:s,isChangingCase:!0};throw new Error("Source and destination must not be the same.")}if(i.isDirectory()&&!s.isDirectory())throw new Error(`Cannot overwrite non-directory '${t}' with directory '${e}'.`);if(!i.isDirectory()&&s.isDirectory())throw new Error(`Cannot overwrite directory '${t}' with non-directory '${e}'.`)}if(i.isDirectory()&&xm(e,t))throw new Error(lf(e,t,r));return {srcStat:i,destStat:s}}function f9(e,t,r,n){let{srcStat:i,destStat:s}=c9(e,t,n);if(s){if(Du(i,s)){let a=gr.basename(e),o=gr.basename(t);if(r==="move"&&a!==o&&a.toLowerCase()===o.toLowerCase())return {srcStat:i,destStat:s,isChangingCase:!0};throw new Error("Source and destination must not be the same.")}if(i.isDirectory()&&!s.isDirectory())throw new Error(`Cannot overwrite non-directory '${t}' with directory '${e}'.`);if(!i.isDirectory()&&s.isDirectory())throw new Error(`Cannot overwrite directory '${t}' with non-directory '${e}'.`)}if(i.isDirectory()&&xm(e,t))throw new Error(lf(e,t,r));return {srcStat:i,destStat:s}}async function HA(e,t,r,n){let i=gr.resolve(gr.dirname(e)),s=gr.resolve(gr.dirname(r));if(s===i||s===gr.parse(s).root)return;let a;try{a=await io.stat(s,{bigint:!0});}catch(o){if(o.code==="ENOENT")return;throw o}if(Du(t,a))throw new Error(lf(e,r,n));return HA(e,t,s,n)}function WA(e,t,r,n){let i=gr.resolve(gr.dirname(e)),s=gr.resolve(gr.dirname(r));if(s===i||s===gr.parse(s).root)return;let a;try{a=io.statSync(s,{bigint:!0});}catch(o){if(o.code==="ENOENT")return;throw o}if(Du(t,a))throw new Error(lf(e,r,n));return WA(e,t,s,n)}function Du(e,t){return t.ino&&t.dev&&t.ino===e.ino&&t.dev===e.dev}function xm(e,t){let r=gr.resolve(e).split(gr.sep).filter(i=>i),n=gr.resolve(t).split(gr.sep).filter(i=>i);return r.every((i,s)=>n[s]===i)}function lf(e,t,r){return `Cannot ${r} '${e}' to a subdirectory of itself, '${t}'.`}KA.exports={checkPaths:VA(l9),checkPathsSync:f9,checkParentPaths:VA(HA),checkParentPathsSync:WA,isSrcSubdir:xm,areIdentical:Du};});var XA=I((Due,QA)=>{var Br=Gr(),Ou=he("path"),{mkdirs:d9}=ei(),{pathExists:h9}=ds(),{utimesMillis:p9}=Cm(),ku=ia();async function g9(e,t,r={}){typeof r=="function"&&(r={filter:r}),r.clobber="clobber"in r?!!r.clobber:!0,r.overwrite="overwrite"in r?!!r.overwrite:r.clobber,r.preserveTimestamps&&process.arch==="ia32"&&process.emitWarning(`Using the preserveTimestamps option in 32-bit node is not recommended;

	see https://github.com/jprichardson/node-fs-extra/issues/269`,"Warning","fs-extra-WARN0001");let{srcStat:n,destStat:i}=await ku.checkPaths(e,t,"copy",r);if(await ku.checkParentPaths(e,n,t,"copy"),!await zA(e,t,r))return;let a=Ou.dirname(t);await h9(a)||await d9(a),await YA(i,e,t,r);}async function zA(e,t,r){return r.filter?r.filter(e,t):!0}async function YA(e,t,r,n){let s=await(n.dereference?Br.stat:Br.lstat)(t);if(s.isDirectory())return _9(s,e,t,r,n);if(s.isFile()||s.isCharacterDevice()||s.isBlockDevice())return m9(s,e,t,r,n);if(s.isSymbolicLink())return b9(e,t,r,n);throw s.isSocket()?new Error(`Cannot copy a socket file: ${t}`):s.isFIFO()?new Error(`Cannot copy a FIFO pipe: ${t}`):new Error(`Unknown file: ${t}`)}async function m9(e,t,r,n,i){if(!t)return GA(e,r,n,i);if(i.overwrite)return await Br.unlink(n),GA(e,r,n,i);if(i.errorOnExist)throw new Error(`'${n}' already exists`)}async function GA(e,t,r,n){if(await Br.copyFile(t,r),n.preserveTimestamps){y9(e.mode)&&await v9(r,e.mode);let i=await Br.stat(t);await p9(r,i.atime,i.mtime);}return Br.chmod(r,e.mode)}function y9(e){return (e&128)===0}function v9(e,t){return Br.chmod(e,t|128)}async function _9(e,t,r,n,i){t||await Br.mkdir(n);let s=await Br.readdir(r);await Promise.all(s.map(async a=>{let o=Ou.join(r,a),c=Ou.join(n,a);if(!await zA(o,c,i))return;let{destStat:u}=await ku.checkPaths(o,c,"copy",i);return YA(u,o,c,i)})),t||await Br.chmod(n,e.mode);}async function b9(e,t,r,n){let i=await Br.readlink(t);if(n.dereference&&(i=Ou.resolve(process.cwd(),i)),!e)return Br.symlink(i,r);let s=null;try{s=await Br.readlink(r);}catch(a){if(a.code==="EINVAL"||a.code==="UNKNOWN")return Br.symlink(i,r);throw a}if(n.dereference&&(s=Ou.resolve(process.cwd(),s)),ku.isSrcSubdir(i,s))throw new Error(`Cannot copy '${i}' to a subdirectory of itself, '${s}'.`);if(ku.isSrcSubdir(s,i))throw new Error(`Cannot overwrite '${s}' with '${i}'.`);return await Br.unlink(r),Br.symlink(i,r)}QA.exports=g9;});var rR=I((Oue,tR)=>{var zr=ro(),Lu=he("path"),S9=ei().mkdirsSync,E9=Cm().utimesMillisSync,Bu=ia();function w9(e,t,r){typeof r=="function"&&(r={filter:r}),r=r||{},r.clobber="clobber"in r?!!r.clobber:!0,r.overwrite="overwrite"in r?!!r.overwrite:r.clobber,r.preserveTimestamps&&process.arch==="ia32"&&process.emitWarning(`Using the preserveTimestamps option in 32-bit node is not recommended;

	see https://github.com/jprichardson/node-fs-extra/issues/269`,"Warning","fs-extra-WARN0002");let{srcStat:n,destStat:i}=Bu.checkPathsSync(e,t,"copy",r);if(Bu.checkParentPathsSync(e,n,t,"copy"),r.filter&&!r.filter(e,t))return;let s=Lu.dirname(t);return zr.existsSync(s)||S9(s),ZA(i,e,t,r)}function ZA(e,t,r,n){let s=(n.dereference?zr.statSync:zr.lstatSync)(t);if(s.isDirectory())return P9(s,e,t,r,n);if(s.isFile()||s.isCharacterDevice()||s.isBlockDevice())return C9(s,e,t,r,n);if(s.isSymbolicLink())return O9(e,t,r,n);throw s.isSocket()?new Error(`Cannot copy a socket file: ${t}`):s.isFIFO()?new Error(`Cannot copy a FIFO pipe: ${t}`):new Error(`Unknown file: ${t}`)}function C9(e,t,r,n,i){return t?x9(e,r,n,i):JA(e,r,n,i)}function x9(e,t,r,n){if(n.overwrite)return zr.unlinkSync(r),JA(e,t,r,n);if(n.errorOnExist)throw new Error(`'${r}' already exists`)}function JA(e,t,r,n){return zr.copyFileSync(t,r),n.preserveTimestamps&&T9(e.mode,t,r),Tm(r,e.mode)}function T9(e,t,r){return A9(e)&&R9(r,e),I9(t,r)}function A9(e){return (e&128)===0}function R9(e,t){return Tm(e,t|128)}function Tm(e,t){return zr.chmodSync(e,t)}function I9(e,t){let r=zr.statSync(e);return E9(t,r.atime,r.mtime)}function P9(e,t,r,n,i){return t?eR(r,n,i):N9(e.mode,r,n,i)}function N9(e,t,r,n){return zr.mkdirSync(r),eR(t,r,n),Tm(r,e)}function eR(e,t,r){zr.readdirSync(e).forEach(n=>D9(n,e,t,r));}function D9(e,t,r,n){let i=Lu.join(t,e),s=Lu.join(r,e);if(n.filter&&!n.filter(i,s))return;let{destStat:a}=Bu.checkPathsSync(i,s,"copy",n);return ZA(a,i,s,n)}function O9(e,t,r,n){let i=zr.readlinkSync(t);if(n.dereference&&(i=Lu.resolve(process.cwd(),i)),e){let s;try{s=zr.readlinkSync(r);}catch(a){if(a.code==="EINVAL"||a.code==="UNKNOWN")return zr.symlinkSync(i,r);throw a}if(n.dereference&&(s=Lu.resolve(process.cwd(),s)),Bu.isSrcSubdir(i,s))throw new Error(`Cannot copy '${i}' to a subdirectory of itself, '${s}'.`);if(Bu.isSrcSubdir(s,i))throw new Error(`Cannot overwrite '${s}' with '${i}'.`);return k9(i,r)}else return zr.symlinkSync(i,r)}function k9(e,t){return zr.unlinkSync(t),zr.symlinkSync(e,t)}tR.exports=w9;});var ff=I((kue,nR)=>{var L9=pr().fromPromise;nR.exports={copy:L9(XA()),copySync:rR()};});var Fu=I((Lue,sR)=>{var iR=ro(),B9=pr().fromCallback;function F9(e,t){iR.rm(e,{recursive:!0,force:!0},t);}function q9(e){iR.rmSync(e,{recursive:!0,force:!0});}sR.exports={remove:B9(F9),removeSync:q9};});var hR=I((Bue,dR)=>{var M9=pr().fromPromise,uR=Gr(),cR=he("path"),lR=ei(),fR=Fu(),aR=M9(async function(t){let r;try{r=await uR.readdir(t);}catch{return lR.mkdirs(t)}return Promise.all(r.map(n=>fR.remove(cR.join(t,n))))});function oR(e){let t;try{t=uR.readdirSync(e);}catch{return lR.mkdirsSync(e)}t.forEach(r=>{r=cR.join(e,r),fR.removeSync(r);});}dR.exports={emptyDirSync:oR,emptydirSync:oR,emptyDir:aR,emptydir:aR};});var yR=I((Fue,mR)=>{var U9=pr().fromPromise,pR=he("path"),Mi=Gr(),gR=ei();async function $9(e){let t;try{t=await Mi.stat(e);}catch{}if(t&&t.isFile())return;let r=pR.dirname(e),n=null;try{n=await Mi.stat(r);}catch(i){if(i.code==="ENOENT"){await gR.mkdirs(r),await Mi.writeFile(e,"");return}else throw i}n.isDirectory()?await Mi.writeFile(e,""):await Mi.readdir(r);}function j9(e){let t;try{t=Mi.statSync(e);}catch{}if(t&&t.isFile())return;let r=pR.dirname(e);try{Mi.statSync(r).isDirectory()||Mi.readdirSync(r);}catch(n){if(n&&n.code==="ENOENT")gR.mkdirsSync(r);else throw n}Mi.writeFileSync(e,"");}mR.exports={createFile:U9($9),createFileSync:j9};});var ER=I((que,SR)=>{var V9=pr().fromPromise,vR=he("path"),hs=Gr(),_R=ei(),{pathExists:H9}=ds(),{areIdentical:bR}=ia();async function W9(e,t){let r;try{r=await hs.lstat(t);}catch{}let n;try{n=await hs.lstat(e);}catch(a){throw a.message=a.message.replace("lstat","ensureLink"),a}if(r&&bR(n,r))return;let i=vR.dirname(t);await H9(i)||await _R.mkdirs(i),await hs.link(e,t);}function K9(e,t){let r;try{r=hs.lstatSync(t);}catch{}try{let s=hs.lstatSync(e);if(r&&bR(s,r))return}catch(s){throw s.message=s.message.replace("lstat","ensureLink"),s}let n=vR.dirname(t);return hs.existsSync(n)||_R.mkdirsSync(n),hs.linkSync(e,t)}SR.exports={createLink:V9(W9),createLinkSync:K9};});var CR=I((Mue,wR)=>{var ps=he("path"),qu=Gr(),{pathExists:G9}=ds(),z9=pr().fromPromise;async function Y9(e,t){if(ps.isAbsolute(e)){try{await qu.lstat(e);}catch(s){throw s.message=s.message.replace("lstat","ensureSymlink"),s}return {toCwd:e,toDst:e}}let r=ps.dirname(t),n=ps.join(r,e);if(await G9(n))return {toCwd:n,toDst:e};try{await qu.lstat(e);}catch(s){throw s.message=s.message.replace("lstat","ensureSymlink"),s}return {toCwd:e,toDst:ps.relative(r,e)}}function Q9(e,t){if(ps.isAbsolute(e)){if(!qu.existsSync(e))throw new Error("absolute srcpath does not exist");return {toCwd:e,toDst:e}}let r=ps.dirname(t),n=ps.join(r,e);if(qu.existsSync(n))return {toCwd:n,toDst:e};if(!qu.existsSync(e))throw new Error("relative srcpath does not exist");return {toCwd:e,toDst:ps.relative(r,e)}}wR.exports={symlinkPaths:z9(Y9),symlinkPathsSync:Q9};});var AR=I((Uue,TR)=>{var xR=Gr(),X9=pr().fromPromise;async function Z9(e,t){if(t)return t;let r;try{r=await xR.lstat(e);}catch{return "file"}return r&&r.isDirectory()?"dir":"file"}function J9(e,t){if(t)return t;let r;try{r=xR.lstatSync(e);}catch{return "file"}return r&&r.isDirectory()?"dir":"file"}TR.exports={symlinkType:X9(Z9),symlinkTypeSync:J9};});var NR=I(($ue,PR)=>{var eW=pr().fromPromise,RR=he("path"),pi=Gr(),{mkdirs:tW,mkdirsSync:rW}=ei(),{symlinkPaths:nW,symlinkPathsSync:iW}=CR(),{symlinkType:sW,symlinkTypeSync:aW}=AR(),{pathExists:oW}=ds(),{areIdentical:IR}=ia();async function uW(e,t,r){let n;try{n=await pi.lstat(t);}catch{}if(n&&n.isSymbolicLink()){let[o,c]=await Promise.all([pi.stat(e),pi.stat(t)]);if(IR(o,c))return}let i=await nW(e,t);e=i.toDst;let s=await sW(i.toCwd,r),a=RR.dirname(t);return await oW(a)||await tW(a),pi.symlink(e,t,s)}function cW(e,t,r){let n;try{n=pi.lstatSync(t);}catch{}if(n&&n.isSymbolicLink()){let o=pi.statSync(e),c=pi.statSync(t);if(IR(o,c))return}let i=iW(e,t);e=i.toDst,r=aW(i.toCwd,r);let s=RR.dirname(t);return pi.existsSync(s)||rW(s),pi.symlinkSync(e,t,r)}PR.exports={createSymlink:eW(uW),createSymlinkSync:cW};});var MR=I((jue,qR)=>{var{createFile:DR,createFileSync:OR}=yR(),{createLink:kR,createLinkSync:LR}=ER(),{createSymlink:BR,createSymlinkSync:FR}=NR();qR.exports={createFile:DR,createFileSync:OR,ensureFile:DR,ensureFileSync:OR,createLink:kR,createLinkSync:LR,ensureLink:kR,ensureLinkSync:LR,createSymlink:BR,createSymlinkSync:FR,ensureSymlink:BR,ensureSymlinkSync:FR};});var df=I((Vue,UR)=>{function lW(e,{EOL:t=`
`,finalEOL:r=!0,replacer:n=null,spaces:i}={}){let s=r?t:"";return JSON.stringify(e,n,i).replace(/\n/g,t)+s}function fW(e){return Buffer.isBuffer(e)&&(e=e.toString("utf8")),e.replace(/^\uFEFF/,"")}UR.exports={stringify:lW,stripBom:fW};});var HR=I((Hue,VR)=>{var so;try{so=ro();}catch{so=he("fs");}var hf=pr(),{stringify:$R,stripBom:jR}=df();async function dW(e,t={}){typeof t=="string"&&(t={encoding:t});let r=t.fs||so,n="throws"in t?t.throws:!0,i=await hf.fromCallback(r.readFile)(e,t);i=jR(i);let s;try{s=JSON.parse(i,t?t.reviver:null);}catch(a){if(n)throw a.message=`${e}: ${a.message}`,a;return null}return s}var hW=hf.fromPromise(dW);function pW(e,t={}){typeof t=="string"&&(t={encoding:t});let r=t.fs||so,n="throws"in t?t.throws:!0;try{let i=r.readFileSync(e,t);return i=jR(i),JSON.parse(i,t.reviver)}catch(i){if(n)throw i.message=`${e}: ${i.message}`,i;return null}}async function gW(e,t,r={}){let n=r.fs||so,i=$R(t,r);await hf.fromCallback(n.writeFile)(e,i,r);}var mW=hf.fromPromise(gW);function yW(e,t,r={}){let n=r.fs||so,i=$R(t,r);return n.writeFileSync(e,i,r)}var vW={readFile:hW,readFileSync:pW,writeFile:mW,writeFileSync:yW};VR.exports=vW;});var KR=I((Wue,WR)=>{var pf=HR();WR.exports={readJson:pf.readFile,readJsonSync:pf.readFileSync,writeJson:pf.writeFile,writeJsonSync:pf.writeFileSync};});var gf=I((Kue,YR)=>{var _W=pr().fromPromise,Am=Gr(),GR=he("path"),zR=ei(),bW=ds().pathExists;async function SW(e,t,r="utf-8"){let n=GR.dirname(e);return await bW(n)||await zR.mkdirs(n),Am.writeFile(e,t,r)}function EW(e,...t){let r=GR.dirname(e);Am.existsSync(r)||zR.mkdirsSync(r),Am.writeFileSync(e,...t);}YR.exports={outputFile:_W(SW),outputFileSync:EW};});var XR=I((Gue,QR)=>{var{stringify:wW}=df(),{outputFile:CW}=gf();async function xW(e,t,r={}){let n=wW(t,r);await CW(e,n,r);}QR.exports=xW;});var JR=I((zue,ZR)=>{var{stringify:TW}=df(),{outputFileSync:AW}=gf();function RW(e,t,r){let n=TW(t,r);AW(e,n,r);}ZR.exports=RW;});var tI=I((Yue,eI)=>{var IW=pr().fromPromise,Yr=KR();Yr.outputJson=IW(XR());Yr.outputJsonSync=JR();Yr.outputJSON=Yr.outputJson;Yr.outputJSONSync=Yr.outputJsonSync;Yr.writeJSON=Yr.writeJson;Yr.writeJSONSync=Yr.writeJsonSync;Yr.readJSON=Yr.readJson;Yr.readJSONSync=Yr.readJsonSync;eI.exports=Yr;});var aI=I((Que,sI)=>{var PW=Gr(),rI=he("path"),{copy:NW}=ff(),{remove:iI}=Fu(),{mkdirp:DW}=ei(),{pathExists:OW}=ds(),nI=ia();async function kW(e,t,r={}){let n=r.overwrite||r.clobber||!1,{srcStat:i,isChangingCase:s=!1}=await nI.checkPaths(e,t,"move",r);await nI.checkParentPaths(e,i,t,"move");let a=rI.dirname(t);return rI.parse(a).root!==a&&await DW(a),LW(e,t,n,s)}async function LW(e,t,r,n){if(!n){if(r)await iI(t);else if(await OW(t))throw new Error("dest already exists.")}try{await PW.rename(e,t);}catch(i){if(i.code!=="EXDEV")throw i;await BW(e,t,r);}}async function BW(e,t,r){return await NW(e,t,{overwrite:r,errorOnExist:!0,preserveTimestamps:!0}),iI(e)}sI.exports=kW;});var fI=I((Xue,lI)=>{var uI=ro(),Im=he("path"),FW=ff().copySync,cI=Fu().removeSync,qW=ei().mkdirpSync,oI=ia();function MW(e,t,r){r=r||{};let n=r.overwrite||r.clobber||!1,{srcStat:i,isChangingCase:s=!1}=oI.checkPathsSync(e,t,"move",r);return oI.checkParentPathsSync(e,i,t,"move"),UW(t)||qW(Im.dirname(t)),$W(e,t,n,s)}function UW(e){let t=Im.dirname(e);return Im.parse(t).root===t}function $W(e,t,r,n){if(n)return Rm(e,t,r);if(r)return cI(t),Rm(e,t,r);if(uI.existsSync(t))throw new Error("dest already exists.");return Rm(e,t,r)}function Rm(e,t,r){try{uI.renameSync(e,t);}catch(n){if(n.code!=="EXDEV")throw n;return jW(e,t,r)}}function jW(e,t,r){return FW(e,t,{overwrite:r,errorOnExist:!0,preserveTimestamps:!0}),cI(e)}lI.exports=MW;});var hI=I((Zue,dI)=>{var VW=pr().fromPromise;dI.exports={move:VW(aI()),moveSync:fI()};});var mf=I((Jue,pI)=>{pI.exports={...Gr(),...ff(),...hR(),...MR(),...tI(),...ei(),...hI(),...gf(),...ds(),...Fu()};});var Mu=I((ece,_I)=>{var HW=he("path"),gi="\\\\/",gI=`[^${gi}]`,Ui="\\.",WW="\\+",KW="\\?",yf="\\/",GW="(?=.)",mI="[^/]",Pm=`(?:${yf}|$)`,yI=`(?:^|${yf})`,Nm=`${Ui}{1,2}${Pm}`,zW=`(?!${Ui})`,YW=`(?!${yI}${Nm})`,QW=`(?!${Ui}{0,1}${Pm})`,XW=`(?!${Nm})`,ZW=`[^.${yf}]`,JW=`${mI}*?`,vI={DOT_LITERAL:Ui,PLUS_LITERAL:WW,QMARK_LITERAL:KW,SLASH_LITERAL:yf,ONE_CHAR:GW,QMARK:mI,END_ANCHOR:Pm,DOTS_SLASH:Nm,NO_DOT:zW,NO_DOTS:YW,NO_DOT_SLASH:QW,NO_DOTS_SLASH:XW,QMARK_NO_DOT:ZW,STAR:JW,START_ANCHOR:yI},eK={...vI,SLASH_LITERAL:`[${gi}]`,QMARK:gI,STAR:`${gI}*?`,DOTS_SLASH:`${Ui}{1,2}(?:[${gi}]|$)`,NO_DOT:`(?!${Ui})`,NO_DOTS:`(?!(?:^|[${gi}])${Ui}{1,2}(?:[${gi}]|$))`,NO_DOT_SLASH:`(?!${Ui}{0,1}(?:[${gi}]|$))`,NO_DOTS_SLASH:`(?!${Ui}{1,2}(?:[${gi}]|$))`,QMARK_NO_DOT:`[^.${gi}]`,START_ANCHOR:`(?:^|[${gi}])`,END_ANCHOR:`(?:[${gi}]|$)`},tK={alnum:"a-zA-Z0-9",alpha:"a-zA-Z",ascii:"\\x00-\\x7F",blank:" \\t",cntrl:"\\x00-\\x1F\\x7F",digit:"0-9",graph:"\\x21-\\x7E",lower:"a-z",print:"\\x20-\\x7E ",punct:"\\-!\"#$%&'()\\*+,./:;<=>?@[\\]^_`{|}~",space:" \\t\\r\\n\\v\\f",upper:"A-Z",word:"A-Za-z0-9_",xdigit:"A-Fa-f0-9"};_I.exports={MAX_LENGTH:1024*64,POSIX_REGEX_SOURCE:tK,REGEX_BACKSLASH:/\\(?![*+?^${}(|)[\]])/g,REGEX_NON_SPECIAL_CHARS:/^[^@![\].,$*+?^{}()|\\/]+/,REGEX_SPECIAL_CHARS:/[-*+?.^${}(|)[\]]/,REGEX_SPECIAL_CHARS_BACKREF:/(\\?)((\W)(\3*))/g,REGEX_SPECIAL_CHARS_GLOBAL:/([-*+?.^${}(|)[\]])/g,REGEX_REMOVE_BACKSLASH:/(?:\[.*?[^\\]\]|\\(?=.))/g,REPLACEMENTS:{"***":"*","**/**":"**","**/**/**":"**"},CHAR_0:48,CHAR_9:57,CHAR_UPPERCASE_A:65,CHAR_LOWERCASE_A:97,CHAR_UPPERCASE_Z:90,CHAR_LOWERCASE_Z:122,CHAR_LEFT_PARENTHESES:40,CHAR_RIGHT_PARENTHESES:41,CHAR_ASTERISK:42,CHAR_AMPERSAND:38,CHAR_AT:64,CHAR_BACKWARD_SLASH:92,CHAR_CARRIAGE_RETURN:13,CHAR_CIRCUMFLEX_ACCENT:94,CHAR_COLON:58,CHAR_COMMA:44,CHAR_DOT:46,CHAR_DOUBLE_QUOTE:34,CHAR_EQUAL:61,CHAR_EXCLAMATION_MARK:33,CHAR_FORM_FEED:12,CHAR_FORWARD_SLASH:47,CHAR_GRAVE_ACCENT:96,CHAR_HASH:35,CHAR_HYPHEN_MINUS:45,CHAR_LEFT_ANGLE_BRACKET:60,CHAR_LEFT_CURLY_BRACE:123,CHAR_LEFT_SQUARE_BRACKET:91,CHAR_LINE_FEED:10,CHAR_NO_BREAK_SPACE:160,CHAR_PERCENT:37,CHAR_PLUS:43,CHAR_QUESTION_MARK:63,CHAR_RIGHT_ANGLE_BRACKET:62,CHAR_RIGHT_CURLY_BRACE:125,CHAR_RIGHT_SQUARE_BRACKET:93,CHAR_SEMICOLON:59,CHAR_SINGLE_QUOTE:39,CHAR_SPACE:32,CHAR_TAB:9,CHAR_UNDERSCORE:95,CHAR_VERTICAL_LINE:124,CHAR_ZERO_WIDTH_NOBREAK_SPACE:65279,SEP:HW.sep,extglobChars(e){return {"!":{type:"negate",open:"(?:(?!(?:",close:`))${e.STAR})`},"?":{type:"qmark",open:"(?:",close:")?"},"+":{type:"plus",open:"(?:",close:")+"},"*":{type:"star",open:"(?:",close:")*"},"@":{type:"at",open:"(?:",close:")"}}},globChars(e){return e===!0?eK:vI}};});var vf=I(nn=>{var rK=he("path"),nK=process.platform==="win32",{REGEX_BACKSLASH:iK,REGEX_REMOVE_BACKSLASH:sK,REGEX_SPECIAL_CHARS:aK,REGEX_SPECIAL_CHARS_GLOBAL:oK}=Mu();nn.isObject=e=>e!==null&&typeof e=="object"&&!Array.isArray(e);nn.hasRegexChars=e=>aK.test(e);nn.isRegexChar=e=>e.length===1&&nn.hasRegexChars(e);nn.escapeRegex=e=>e.replace(oK,"\\$1");nn.toPosixSlashes=e=>e.replace(iK,"/");nn.removeBackslashes=e=>e.replace(sK,t=>t==="\\"?"":t);nn.supportsLookbehinds=()=>{let e=process.version.slice(1).split(".").map(Number);return e.length===3&&e[0]>=9||e[0]===8&&e[1]>=10};nn.isWindows=e=>e&&typeof e.windows=="boolean"?e.windows:nK===!0||rK.sep==="\\";nn.escapeLast=(e,t,r)=>{let n=e.lastIndexOf(t,r);return n===-1?e:e[n-1]==="\\"?nn.escapeLast(e,t,n-1):`${e.slice(0,n)}\\${e.slice(n)}`};nn.removePrefix=(e,t={})=>{let r=e;return r.startsWith("./")&&(r=r.slice(2),t.prefix="./"),r};nn.wrapOutput=(e,t={},r={})=>{let n=r.contains?"":"^",i=r.contains?"":"$",s=`${n}(?:${e})${i}`;return t.negated===!0&&(s=`(?:^(?!${s}).*$)`),s};});var AI=I((rce,TI)=>{var bI=vf(),{CHAR_ASTERISK:Dm,CHAR_AT:uK,CHAR_BACKWARD_SLASH:Uu,CHAR_COMMA:cK,CHAR_DOT:Om,CHAR_EXCLAMATION_MARK:km,CHAR_FORWARD_SLASH:xI,CHAR_LEFT_CURLY_BRACE:Lm,CHAR_LEFT_PARENTHESES:Bm,CHAR_LEFT_SQUARE_BRACKET:lK,CHAR_PLUS:fK,CHAR_QUESTION_MARK:SI,CHAR_RIGHT_CURLY_BRACE:dK,CHAR_RIGHT_PARENTHESES:EI,CHAR_RIGHT_SQUARE_BRACKET:hK}=Mu(),wI=e=>e===xI||e===Uu,CI=e=>{e.isPrefix!==!0&&(e.depth=e.isGlobstar?1/0:1);},pK=(e,t)=>{let r=t||{},n=e.length-1,i=r.parts===!0||r.scanToEnd===!0,s=[],a=[],o=[],c=e,l=-1,u=0,f=0,h=!1,p=!1,g=!1,_=!1,E=!1,w=!1,y=!1,b=!1,N=!1,L=!1,V=0,Z,G,z={value:"",depth:0,isGlob:!1},ee=()=>l>=n,U=()=>c.charCodeAt(l+1),ie=()=>(Z=G,c.charCodeAt(++l));for(;l<n;){G=ie();let se;if(G===Uu){y=z.backslashes=!0,G=ie(),G===Lm&&(w=!0);continue}if(w===!0||G===Lm){for(V++;ee()!==!0&&(G=ie());){if(G===Uu){y=z.backslashes=!0,ie();continue}if(G===Lm){V++;continue}if(w!==!0&&G===Om&&(G=ie())===Om){if(h=z.isBrace=!0,g=z.isGlob=!0,L=!0,i===!0)continue;break}if(w!==!0&&G===cK){if(h=z.isBrace=!0,g=z.isGlob=!0,L=!0,i===!0)continue;break}if(G===dK&&(V--,V===0)){w=!1,h=z.isBrace=!0,L=!0;break}}if(i===!0)continue;break}if(G===xI){if(s.push(l),a.push(z),z={value:"",depth:0,isGlob:!1},L===!0)continue;if(Z===Om&&l===u+1){u+=2;continue}f=l+1;continue}if(r.noext!==!0&&(G===fK||G===uK||G===Dm||G===SI||G===km)===!0&&U()===Bm){if(g=z.isGlob=!0,_=z.isExtglob=!0,L=!0,G===km&&l===u&&(N=!0),i===!0){for(;ee()!==!0&&(G=ie());){if(G===Uu){y=z.backslashes=!0,G=ie();continue}if(G===EI){g=z.isGlob=!0,L=!0;break}}continue}break}if(G===Dm){if(Z===Dm&&(E=z.isGlobstar=!0),g=z.isGlob=!0,L=!0,i===!0)continue;break}if(G===SI){if(g=z.isGlob=!0,L=!0,i===!0)continue;break}if(G===lK){for(;ee()!==!0&&(se=ie());){if(se===Uu){y=z.backslashes=!0,ie();continue}if(se===hK){p=z.isBracket=!0,g=z.isGlob=!0,L=!0;break}}if(i===!0)continue;break}if(r.nonegate!==!0&&G===km&&l===u){b=z.negated=!0,u++;continue}if(r.noparen!==!0&&G===Bm){if(g=z.isGlob=!0,i===!0){for(;ee()!==!0&&(G=ie());){if(G===Bm){y=z.backslashes=!0,G=ie();continue}if(G===EI){L=!0;break}}continue}break}if(g===!0){if(L=!0,i===!0)continue;break}}r.noext===!0&&(_=!1,g=!1);let me=c,Pe="",W="";u>0&&(Pe=c.slice(0,u),c=c.slice(u),f-=u),me&&g===!0&&f>0?(me=c.slice(0,f),W=c.slice(f)):g===!0?(me="",W=c):me=c,me&&me!==""&&me!=="/"&&me!==c&&wI(me.charCodeAt(me.length-1))&&(me=me.slice(0,-1)),r.unescape===!0&&(W&&(W=bI.removeBackslashes(W)),me&&y===!0&&(me=bI.removeBackslashes(me)));let K={prefix:Pe,input:e,start:u,base:me,glob:W,isBrace:h,isBracket:p,isGlob:g,isExtglob:_,isGlobstar:E,negated:b,negatedExtglob:N};if(r.tokens===!0&&(K.maxDepth=0,wI(G)||a.push(z),K.tokens=a),r.parts===!0||r.tokens===!0){let se;for(let Ae=0;Ae<s.length;Ae++){let Me=se?se+1:u,ze=s[Ae],We=e.slice(Me,ze);r.tokens&&(Ae===0&&u!==0?(a[Ae].isPrefix=!0,a[Ae].value=Pe):a[Ae].value=We,CI(a[Ae]),K.maxDepth+=a[Ae].depth),(Ae!==0||We!=="")&&o.push(We),se=ze;}if(se&&se+1<e.length){let Ae=e.slice(se+1);o.push(Ae),r.tokens&&(a[a.length-1].value=Ae,CI(a[a.length-1]),K.maxDepth+=a[a.length-1].depth);}K.slashes=s,K.parts=o;}return K};TI.exports=pK;});var PI=I((nce,II)=>{var _f=Mu(),Sn=vf(),{MAX_LENGTH:bf,POSIX_REGEX_SOURCE:gK,REGEX_NON_SPECIAL_CHARS:mK,REGEX_SPECIAL_CHARS_BACKREF:yK,REPLACEMENTS:RI}=_f,vK=(e,t)=>{if(typeof t.expandRange=="function")return t.expandRange(...e,t);e.sort();let r=`[${e.join("-")}]`;return r},ao=(e,t)=>`Missing ${e}: "${t}" - use "\\\\${t}" to match literal characters`,Fm=(e,t)=>{if(typeof e!="string")throw new TypeError("Expected a string");e=RI[e]||e;let r={...t},n=typeof r.maxLength=="number"?Math.min(bf,r.maxLength):bf,i=e.length;if(i>n)throw new SyntaxError(`Input length: ${i}, exceeds maximum allowed length: ${n}`);let s={type:"bos",value:"",output:r.prepend||""},a=[s],o=r.capture?"":"?:",c=Sn.isWindows(t),l=_f.globChars(c),u=_f.extglobChars(l),{DOT_LITERAL:f,PLUS_LITERAL:h,SLASH_LITERAL:p,ONE_CHAR:g,DOTS_SLASH:_,NO_DOT:E,NO_DOT_SLASH:w,NO_DOTS_SLASH:y,QMARK:b,QMARK_NO_DOT:N,STAR:L,START_ANCHOR:V}=l,Z=ye=>`(${o}(?:(?!${V}${ye.dot?_:f}).)*?)`,G=r.dot?"":E,z=r.dot?b:N,ee=r.bash===!0?Z(r):L;r.capture&&(ee=`(${ee})`),typeof r.noext=="boolean"&&(r.noextglob=r.noext);let U={input:e,index:-1,start:0,dot:r.dot===!0,consumed:"",output:"",prefix:"",backtrack:!1,negated:!1,brackets:0,braces:0,parens:0,quotes:0,globstar:!1,tokens:a};e=Sn.removePrefix(e,U),i=e.length;let ie=[],me=[],Pe=[],W=s,K,se=()=>U.index===i-1,Ae=U.peek=(ye=1)=>e[U.index+ye],Me=U.advance=()=>e[++U.index]||"",ze=()=>e.slice(U.index+1),We=(ye="",Ve=0)=>{U.consumed+=ye,U.index+=Ve;},lt=ye=>{U.output+=ye.output!=null?ye.output:ye.value,We(ye.value);},Bt=()=>{let ye=1;for(;Ae()==="!"&&(Ae(2)!=="("||Ae(3)==="?");)Me(),U.start++,ye++;return ye%2===0?!1:(U.negated=!0,U.start++,!0)},Ct=ye=>{U[ye]++,Pe.push(ye);},pt=ye=>{U[ye]--,Pe.pop();},Be=ye=>{if(W.type==="globstar"){let Ve=U.braces>0&&(ye.type==="comma"||ye.type==="brace"),le=ye.extglob===!0||ie.length&&(ye.type==="pipe"||ye.type==="paren");ye.type!=="slash"&&ye.type!=="paren"&&!Ve&&!le&&(U.output=U.output.slice(0,-W.output.length),W.type="star",W.value="*",W.output=ee,U.output+=W.output);}if(ie.length&&ye.type!=="paren"&&(ie[ie.length-1].inner+=ye.value),(ye.value||ye.output)&&lt(ye),W&&W.type==="text"&&ye.type==="text"){W.value+=ye.value,W.output=(W.output||"")+ye.value;return}ye.prev=W,a.push(ye),W=ye;},Dt=(ye,Ve)=>{let le={...u[Ve],conditions:1,inner:""};le.prev=W,le.parens=U.parens,le.output=U.output;let Ie=(r.capture?"(":"")+le.open;Ct("parens"),Be({type:ye,value:Ve,output:U.output?"":g}),Be({type:"paren",extglob:!0,value:Me(),output:Ie}),ie.push(le);},Vt=ye=>{let Ve=ye.close+(r.capture?")":""),le;if(ye.type==="negate"){let Ie=ee;if(ye.inner&&ye.inner.length>1&&ye.inner.includes("/")&&(Ie=Z(r)),(Ie!==ee||se()||/^\)+$/.test(ze()))&&(Ve=ye.close=`)$))${Ie}`),ye.inner.includes("*")&&(le=ze())&&/^\.[^\\/.]+$/.test(le)){let Ke=Fm(le,{...t,fastpaths:!1}).output;Ve=ye.close=`)${Ke})${Ie})`;}ye.prev.type==="bos"&&(U.negatedExtglob=!0);}Be({type:"paren",extglob:!0,value:K,output:Ve}),pt("parens");};if(r.fastpaths!==!1&&!/(^[*!]|[/()[\]{}"])/.test(e)){let ye=!1,Ve=e.replace(yK,(le,Ie,Ke,nt,Ye,Rn)=>nt==="\\"?(ye=!0,le):nt==="?"?Ie?Ie+nt+(Ye?b.repeat(Ye.length):""):Rn===0?z+(Ye?b.repeat(Ye.length):""):b.repeat(Ke.length):nt==="."?f.repeat(Ke.length):nt==="*"?Ie?Ie+nt+(Ye?ee:""):ee:Ie?le:`\\${le}`);return ye===!0&&(r.unescape===!0?Ve=Ve.replace(/\\/g,""):Ve=Ve.replace(/\\+/g,le=>le.length%2===0?"\\\\":le?"\\":"")),Ve===e&&r.contains===!0?(U.output=e,U):(U.output=Sn.wrapOutput(Ve,U,t),U)}for(;!se();){if(K=Me(),K==="\0")continue;if(K==="\\"){let le=Ae();if(le==="/"&&r.bash!==!0||le==="."||le===";")continue;if(!le){K+="\\",Be({type:"text",value:K});continue}let Ie=/^\\+/.exec(ze()),Ke=0;if(Ie&&Ie[0].length>2&&(Ke=Ie[0].length,U.index+=Ke,Ke%2!==0&&(K+="\\")),r.unescape===!0?K=Me():K+=Me(),U.brackets===0){Be({type:"text",value:K});continue}}if(U.brackets>0&&(K!=="]"||W.value==="["||W.value==="[^")){if(r.posix!==!1&&K===":"){let le=W.value.slice(1);if(le.includes("[")&&(W.posix=!0,le.includes(":"))){let Ie=W.value.lastIndexOf("["),Ke=W.value.slice(0,Ie),nt=W.value.slice(Ie+2),Ye=gK[nt];if(Ye){W.value=Ke+Ye,U.backtrack=!0,Me(),!s.output&&a.indexOf(W)===1&&(s.output=g);continue}}}(K==="["&&Ae()!==":"||K==="-"&&Ae()==="]")&&(K=`\\${K}`),K==="]"&&(W.value==="["||W.value==="[^")&&(K=`\\${K}`),r.posix===!0&&K==="!"&&W.value==="["&&(K="^"),W.value+=K,lt({value:K});continue}if(U.quotes===1&&K!=='"'){K=Sn.escapeRegex(K),W.value+=K,lt({value:K});continue}if(K==='"'){U.quotes=U.quotes===1?0:1,r.keepQuotes===!0&&Be({type:"text",value:K});continue}if(K==="("){Ct("parens"),Be({type:"paren",value:K});continue}if(K===")"){if(U.parens===0&&r.strictBrackets===!0)throw new SyntaxError(ao("opening","("));let le=ie[ie.length-1];if(le&&U.parens===le.parens+1){Vt(ie.pop());continue}Be({type:"paren",value:K,output:U.parens?")":"\\)"}),pt("parens");continue}if(K==="["){if(r.nobracket===!0||!ze().includes("]")){if(r.nobracket!==!0&&r.strictBrackets===!0)throw new SyntaxError(ao("closing","]"));K=`\\${K}`;}else Ct("brackets");Be({type:"bracket",value:K});continue}if(K==="]"){if(r.nobracket===!0||W&&W.type==="bracket"&&W.value.length===1){Be({type:"text",value:K,output:`\\${K}`});continue}if(U.brackets===0){if(r.strictBrackets===!0)throw new SyntaxError(ao("opening","["));Be({type:"text",value:K,output:`\\${K}`});continue}pt("brackets");let le=W.value.slice(1);if(W.posix!==!0&&le[0]==="^"&&!le.includes("/")&&(K=`/${K}`),W.value+=K,lt({value:K}),r.literalBrackets===!1||Sn.hasRegexChars(le))continue;let Ie=Sn.escapeRegex(W.value);if(U.output=U.output.slice(0,-W.value.length),r.literalBrackets===!0){U.output+=Ie,W.value=Ie;continue}W.value=`(${o}${Ie}|${W.value})`,U.output+=W.value;continue}if(K==="{"&&r.nobrace!==!0){Ct("braces");let le={type:"brace",value:K,output:"(",outputIndex:U.output.length,tokensIndex:U.tokens.length};me.push(le),Be(le);continue}if(K==="}"){let le=me[me.length-1];if(r.nobrace===!0||!le){Be({type:"text",value:K,output:K});continue}let Ie=")";if(le.dots===!0){let Ke=a.slice(),nt=[];for(let Ye=Ke.length-1;Ye>=0&&(a.pop(),Ke[Ye].type!=="brace");Ye--)Ke[Ye].type!=="dots"&&nt.unshift(Ke[Ye].value);Ie=vK(nt,r),U.backtrack=!0;}if(le.comma!==!0&&le.dots!==!0){let Ke=U.output.slice(0,le.outputIndex),nt=U.tokens.slice(le.tokensIndex);le.value=le.output="\\{",K=Ie="\\}",U.output=Ke;for(let Ye of nt)U.output+=Ye.output||Ye.value;}Be({type:"brace",value:K,output:Ie}),pt("braces"),me.pop();continue}if(K==="|"){ie.length>0&&ie[ie.length-1].conditions++,Be({type:"text",value:K});continue}if(K===","){let le=K,Ie=me[me.length-1];Ie&&Pe[Pe.length-1]==="braces"&&(Ie.comma=!0,le="|"),Be({type:"comma",value:K,output:le});continue}if(K==="/"){if(W.type==="dot"&&U.index===U.start+1){U.start=U.index+1,U.consumed="",U.output="",a.pop(),W=s;continue}Be({type:"slash",value:K,output:p});continue}if(K==="."){if(U.braces>0&&W.type==="dot"){W.value==="."&&(W.output=f);let le=me[me.length-1];W.type="dots",W.output+=K,W.value+=K,le.dots=!0;continue}if(U.braces+U.parens===0&&W.type!=="bos"&&W.type!=="slash"){Be({type:"text",value:K,output:f});continue}Be({type:"dot",value:K,output:f});continue}if(K==="?"){if(!(W&&W.value==="(")&&r.noextglob!==!0&&Ae()==="("&&Ae(2)!=="?"){Dt("qmark",K);continue}if(W&&W.type==="paren"){let Ie=Ae(),Ke=K;if(Ie==="<"&&!Sn.supportsLookbehinds())throw new Error("Node.js v10 or higher is required for regex lookbehinds");(W.value==="("&&!/[!=<:]/.test(Ie)||Ie==="<"&&!/<([!=]|\w+>)/.test(ze()))&&(Ke=`\\${K}`),Be({type:"text",value:K,output:Ke});continue}if(r.dot!==!0&&(W.type==="slash"||W.type==="bos")){Be({type:"qmark",value:K,output:N});continue}Be({type:"qmark",value:K,output:b});continue}if(K==="!"){if(r.noextglob!==!0&&Ae()==="("&&(Ae(2)!=="?"||!/[!=<:]/.test(Ae(3)))){Dt("negate",K);continue}if(r.nonegate!==!0&&U.index===0){Bt();continue}}if(K==="+"){if(r.noextglob!==!0&&Ae()==="("&&Ae(2)!=="?"){Dt("plus",K);continue}if(W&&W.value==="("||r.regex===!1){Be({type:"plus",value:K,output:h});continue}if(W&&(W.type==="bracket"||W.type==="paren"||W.type==="brace")||U.parens>0){Be({type:"plus",value:K});continue}Be({type:"plus",value:h});continue}if(K==="@"){if(r.noextglob!==!0&&Ae()==="("&&Ae(2)!=="?"){Be({type:"at",extglob:!0,value:K,output:""});continue}Be({type:"text",value:K});continue}if(K!=="*"){(K==="$"||K==="^")&&(K=`\\${K}`);let le=mK.exec(ze());le&&(K+=le[0],U.index+=le[0].length),Be({type:"text",value:K});continue}if(W&&(W.type==="globstar"||W.star===!0)){W.type="star",W.star=!0,W.value+=K,W.output=ee,U.backtrack=!0,U.globstar=!0,We(K);continue}let ye=ze();if(r.noextglob!==!0&&/^\([^?]/.test(ye)){Dt("star",K);continue}if(W.type==="star"){if(r.noglobstar===!0){We(K);continue}let le=W.prev,Ie=le.prev,Ke=le.type==="slash"||le.type==="bos",nt=Ie&&(Ie.type==="star"||Ie.type==="globstar");if(r.bash===!0&&(!Ke||ye[0]&&ye[0]!=="/")){Be({type:"star",value:K,output:""});continue}let Ye=U.braces>0&&(le.type==="comma"||le.type==="brace"),Rn=ie.length&&(le.type==="pipe"||le.type==="paren");if(!Ke&&le.type!=="paren"&&!Ye&&!Rn){Be({type:"star",value:K,output:""});continue}for(;ye.slice(0,3)==="/**";){let $r=e[U.index+4];if($r&&$r!=="/")break;ye=ye.slice(3),We("/**",3);}if(le.type==="bos"&&se()){W.type="globstar",W.value+=K,W.output=Z(r),U.output=W.output,U.globstar=!0,We(K);continue}if(le.type==="slash"&&le.prev.type!=="bos"&&!nt&&se()){U.output=U.output.slice(0,-(le.output+W.output).length),le.output=`(?:${le.output}`,W.type="globstar",W.output=Z(r)+(r.strictSlashes?")":"|$)"),W.value+=K,U.globstar=!0,U.output+=le.output+W.output,We(K);continue}if(le.type==="slash"&&le.prev.type!=="bos"&&ye[0]==="/"){let $r=ye[1]!==void 0?"|$":"";U.output=U.output.slice(0,-(le.output+W.output).length),le.output=`(?:${le.output}`,W.type="globstar",W.output=`${Z(r)}${p}|${p}${$r})`,W.value+=K,U.output+=le.output+W.output,U.globstar=!0,We(K+Me()),Be({type:"slash",value:"/",output:""});continue}if(le.type==="bos"&&ye[0]==="/"){W.type="globstar",W.value+=K,W.output=`(?:^|${p}|${Z(r)}${p})`,U.output=W.output,U.globstar=!0,We(K+Me()),Be({type:"slash",value:"/",output:""});continue}U.output=U.output.slice(0,-W.output.length),W.type="globstar",W.output=Z(r),W.value+=K,U.output+=W.output,U.globstar=!0,We(K);continue}let Ve={type:"star",value:K,output:ee};if(r.bash===!0){Ve.output=".*?",(W.type==="bos"||W.type==="slash")&&(Ve.output=G+Ve.output),Be(Ve);continue}if(W&&(W.type==="bracket"||W.type==="paren")&&r.regex===!0){Ve.output=K,Be(Ve);continue}(U.index===U.start||W.type==="slash"||W.type==="dot")&&(W.type==="dot"?(U.output+=w,W.output+=w):r.dot===!0?(U.output+=y,W.output+=y):(U.output+=G,W.output+=G),Ae()!=="*"&&(U.output+=g,W.output+=g)),Be(Ve);}for(;U.brackets>0;){if(r.strictBrackets===!0)throw new SyntaxError(ao("closing","]"));U.output=Sn.escapeLast(U.output,"["),pt("brackets");}for(;U.parens>0;){if(r.strictBrackets===!0)throw new SyntaxError(ao("closing",")"));U.output=Sn.escapeLast(U.output,"("),pt("parens");}for(;U.braces>0;){if(r.strictBrackets===!0)throw new SyntaxError(ao("closing","}"));U.output=Sn.escapeLast(U.output,"{"),pt("braces");}if(r.strictSlashes!==!0&&(W.type==="star"||W.type==="bracket")&&Be({type:"maybe_slash",value:"",output:`${p}?`}),U.backtrack===!0){U.output="";for(let ye of U.tokens)U.output+=ye.output!=null?ye.output:ye.value,ye.suffix&&(U.output+=ye.suffix);}return U};Fm.fastpaths=(e,t)=>{let r={...t},n=typeof r.maxLength=="number"?Math.min(bf,r.maxLength):bf,i=e.length;if(i>n)throw new SyntaxError(`Input length: ${i}, exceeds maximum allowed length: ${n}`);e=RI[e]||e;let s=Sn.isWindows(t),{DOT_LITERAL:a,SLASH_LITERAL:o,ONE_CHAR:c,DOTS_SLASH:l,NO_DOT:u,NO_DOTS:f,NO_DOTS_SLASH:h,STAR:p,START_ANCHOR:g}=_f.globChars(s),_=r.dot?f:u,E=r.dot?h:u,w=r.capture?"":"?:",y={negated:!1,prefix:""},b=r.bash===!0?".*?":p;r.capture&&(b=`(${b})`);let N=G=>G.noglobstar===!0?b:`(${w}(?:(?!${g}${G.dot?l:a}).)*?)`,L=G=>{switch(G){case"*":return `${_}${c}${b}`;case".*":return `${a}${c}${b}`;case"*.*":return `${_}${b}${a}${c}${b}`;case"*/*":return `${_}${b}${o}${c}${E}${b}`;case"**":return _+N(r);case"**/*":return `(?:${_}${N(r)}${o})?${E}${c}${b}`;case"**/*.*":return `(?:${_}${N(r)}${o})?${E}${b}${a}${c}${b}`;case"**/.*":return `(?:${_}${N(r)}${o})?${a}${c}${b}`;default:{let z=/^(.*?)\.(\w+)$/.exec(G);if(!z)return;let ee=L(z[1]);return ee?ee+a+z[2]:void 0}}},V=Sn.removePrefix(e,y),Z=L(V);return Z&&r.strictSlashes!==!0&&(Z+=`${o}?`),Z};II.exports=Fm;});var DI=I((ice,NI)=>{var _K=he("path"),bK=AI(),qm=PI(),Mm=vf(),SK=Mu(),EK=e=>e&&typeof e=="object"&&!Array.isArray(e),sr=(e,t,r=!1)=>{if(Array.isArray(e)){let u=e.map(h=>sr(h,t,r));return h=>{for(let p of u){let g=p(h);if(g)return g}return !1}}let n=EK(e)&&e.tokens&&e.input;if(e===""||typeof e!="string"&&!n)throw new TypeError("Expected pattern to be a non-empty string");let i=t||{},s=Mm.isWindows(t),a=n?sr.compileRe(e,t):sr.makeRe(e,t,!1,!0),o=a.state;delete a.state;let c=()=>!1;if(i.ignore){let u={...t,ignore:null,onMatch:null,onResult:null};c=sr(i.ignore,u,r);}let l=(u,f=!1)=>{let{isMatch:h,match:p,output:g}=sr.test(u,a,t,{glob:e,posix:s}),_={glob:e,state:o,regex:a,posix:s,input:u,output:g,match:p,isMatch:h};return typeof i.onResult=="function"&&i.onResult(_),h===!1?(_.isMatch=!1,f?_:!1):c(u)?(typeof i.onIgnore=="function"&&i.onIgnore(_),_.isMatch=!1,f?_:!1):(typeof i.onMatch=="function"&&i.onMatch(_),f?_:!0)};return r&&(l.state=o),l};sr.test=(e,t,r,{glob:n,posix:i}={})=>{if(typeof e!="string")throw new TypeError("Expected input to be a string");if(e==="")return {isMatch:!1,output:""};let s=r||{},a=s.format||(i?Mm.toPosixSlashes:null),o=e===n,c=o&&a?a(e):e;return o===!1&&(c=a?a(e):e,o=c===n),(o===!1||s.capture===!0)&&(s.matchBase===!0||s.basename===!0?o=sr.matchBase(e,t,r,i):o=t.exec(c)),{isMatch:!!o,match:o,output:c}};sr.matchBase=(e,t,r,n=Mm.isWindows(r))=>(t instanceof RegExp?t:sr.makeRe(t,r)).test(_K.basename(e));sr.isMatch=(e,t,r)=>sr(t,r)(e);sr.parse=(e,t)=>Array.isArray(e)?e.map(r=>sr.parse(r,t)):qm(e,{...t,fastpaths:!1});sr.scan=(e,t)=>bK(e,t);sr.compileRe=(e,t,r=!1,n=!1)=>{if(r===!0)return e.output;let i=t||{},s=i.contains?"":"^",a=i.contains?"":"$",o=`${s}(?:${e.output})${a}`;e&&e.negated===!0&&(o=`^(?!${o}).*$`);let c=sr.toRegex(o,t);return n===!0&&(c.state=e),c};sr.makeRe=(e,t={},r=!1,n=!1)=>{if(!e||typeof e!="string")throw new TypeError("Expected a non-empty string");let i={negated:!1,fastpaths:!0};return t.fastpaths!==!1&&(e[0]==="."||e[0]==="*")&&(i.output=qm.fastpaths(e,t)),i.output||(i=qm(e,t)),sr.compileRe(i,t,r,n)};sr.toRegex=(e,t)=>{try{let r=t||{};return new RegExp(e,r.flags||(r.nocase?"i":""))}catch(r){if(t&&t.debug===!0)throw r;return /$^/}};sr.constants=SK;NI.exports=sr;});var Um=I((sce,OI)=>{OI.exports=DI();});var $I=I((ace,UI)=>{var ju=he("fs"),{Readable:wK}=he("stream"),$u=he("path"),{promisify:Cf}=he("util"),$m=Um(),CK=Cf(ju.readdir),xK=Cf(ju.stat),kI=Cf(ju.lstat),TK=Cf(ju.realpath),AK="!",qI="READDIRP_RECURSIVE_ERROR",RK=new Set(["ENOENT","EPERM","EACCES","ELOOP",qI]),jm="files",MI="directories",Ef="files_directories",Sf="all",LI=[jm,MI,Ef,Sf],IK=e=>RK.has(e.code),[BI,PK]=process.versions.node.split(".").slice(0,2).map(e=>Number.parseInt(e,10)),NK=process.platform==="win32"&&(BI>10||BI===10&&PK>=5),FI=e=>{if(e!==void 0){if(typeof e=="function")return e;if(typeof e=="string"){let t=$m(e.trim());return r=>t(r.basename)}if(Array.isArray(e)){let t=[],r=[];for(let n of e){let i=n.trim();i.charAt(0)===AK?r.push($m(i.slice(1))):t.push($m(i));}return r.length>0?t.length>0?n=>t.some(i=>i(n.basename))&&!r.some(i=>i(n.basename)):n=>!r.some(i=>i(n.basename)):n=>t.some(i=>i(n.basename))}}},wf=class e extends wK{static get defaultOptions(){return {root:".",fileFilter:t=>!0,directoryFilter:t=>!0,type:jm,lstat:!1,depth:2147483648,alwaysStat:!1}}constructor(t={}){super({objectMode:!0,autoDestroy:!0,highWaterMark:t.highWaterMark||4096});let r={...e.defaultOptions,...t},{root:n,type:i}=r;this._fileFilter=FI(r.fileFilter),this._directoryFilter=FI(r.directoryFilter);let s=r.lstat?kI:xK;NK?this._stat=a=>s(a,{bigint:!0}):this._stat=s,this._maxDepth=r.depth,this._wantsDir=[MI,Ef,Sf].includes(i),this._wantsFile=[jm,Ef,Sf].includes(i),this._wantsEverything=i===Sf,this._root=$u.resolve(n),this._isDirent="Dirent"in ju&&!r.alwaysStat,this._statsProp=this._isDirent?"dirent":"stats",this._rdOptions={encoding:"utf8",withFileTypes:this._isDirent},this.parents=[this._exploreDir(n,1)],this.reading=!1,this.parent=void 0;}async _read(t){if(!this.reading){this.reading=!0;try{for(;!this.destroyed&&t>0;){let{path:r,depth:n,files:i=[]}=this.parent||{};if(i.length>0){let s=i.splice(0,t).map(a=>this._formatEntry(a,r));for(let a of await Promise.all(s)){if(this.destroyed)return;let o=await this._getEntryType(a);o==="directory"&&this._directoryFilter(a)?(n<=this._maxDepth&&this.parents.push(this._exploreDir(a.fullPath,n+1)),this._wantsDir&&(this.push(a),t--)):(o==="file"||this._includeAsFile(a))&&this._fileFilter(a)&&this._wantsFile&&(this.push(a),t--);}}else {let s=this.parents.pop();if(!s){this.push(null);break}if(this.parent=await s,this.destroyed)return}}}catch(r){this.destroy(r);}finally{this.reading=!1;}}}async _exploreDir(t,r){let n;try{n=await CK(t,this._rdOptions);}catch(i){this._onError(i);}return {files:n,depth:r,path:t}}async _formatEntry(t,r){let n;try{let i=this._isDirent?t.name:t,s=$u.resolve($u.join(r,i));n={path:$u.relative(this._root,s),fullPath:s,basename:i},n[this._statsProp]=this._isDirent?t:await this._stat(s);}catch(i){this._onError(i);}return n}_onError(t){IK(t)&&!this.destroyed?this.emit("warn",t):this.destroy(t);}async _getEntryType(t){let r=t&&t[this._statsProp];if(r){if(r.isFile())return "file";if(r.isDirectory())return "directory";if(r&&r.isSymbolicLink()){let n=t.fullPath;try{let i=await TK(n),s=await kI(i);if(s.isFile())return "file";if(s.isDirectory()){let a=i.length;if(n.startsWith(i)&&n.substr(a,1)===$u.sep){let o=new Error(`Circular symlink detected: "${n}" points to "${i}"`);return o.code=qI,this._onError(o)}return "directory"}}catch(i){this._onError(i);}}}}_includeAsFile(t){let r=t&&t[this._statsProp];return r&&this._wantsEverything&&!r.isDirectory()}},oo=(e,t={})=>{let r=t.entryType||t.type;if(r==="both"&&(r=Ef),r&&(t.type=r),e){if(typeof e!="string")throw new TypeError("readdirp: root argument must be a string. Usage: readdirp(root, options)");if(r&&!LI.includes(r))throw new Error(`readdirp: Invalid type passed. Use one of ${LI.join(", ")}`)}else throw new Error("readdirp: root argument is required. Usage: readdirp(root, options)");return t.root=e,new wf(t)},DK=(e,t={})=>new Promise((r,n)=>{let i=[];oo(e,t).on("data",s=>i.push(s)).on("end",()=>r(i)).on("error",s=>n(s));});oo.promise=DK;oo.ReaddirpStream=wf;oo.default=oo;UI.exports=oo;});var Vm=I((oce,jI)=>{jI.exports=function(e,t){if(typeof e!="string")throw new TypeError("expected path to be a string");if(e==="\\"||e==="/")return "/";var r=e.length;if(r<=1)return e;var n="";if(r>4&&e[3]==="\\"){var i=e[2];(i==="?"||i===".")&&e.slice(0,2)==="\\\\"&&(e=e.slice(2),n="//");}var s=e.split(/[/\\]+/);return t!==!1&&s[s.length-1]===""&&s.pop(),n+s.join("/")};});var zI=I((KI,GI)=>{Object.defineProperty(KI,"__esModule",{value:!0});var WI=Um(),OK=Vm(),VI="!",kK={returnIndex:!1},LK=e=>Array.isArray(e)?e:[e],BK=(e,t)=>{if(typeof e=="function")return e;if(typeof e=="string"){let r=WI(e,t);return n=>e===n||r(n)}return e instanceof RegExp?r=>e.test(r):r=>!1},HI=(e,t,r,n)=>{let i=Array.isArray(r),s=i?r[0]:r;if(!i&&typeof s!="string")throw new TypeError("anymatch: second argument must be a string: got "+Object.prototype.toString.call(s));let a=OK(s,!1);for(let c=0;c<t.length;c++){let l=t[c];if(l(a))return n?-1:!1}let o=i&&[a].concat(r.slice(1));for(let c=0;c<e.length;c++){let l=e[c];if(i?l(...o):l(a))return n?c:!0}return n?-1:!1},Hm=(e,t,r=kK)=>{if(e==null)throw new TypeError("anymatch: specify first argument");let n=typeof r=="boolean"?{returnIndex:r}:r,i=n.returnIndex||!1,s=LK(e),a=s.filter(c=>typeof c=="string"&&c.charAt(0)===VI).map(c=>c.slice(1)).map(c=>WI(c,n)),o=s.filter(c=>typeof c!="string"||typeof c=="string"&&c.charAt(0)!==VI).map(c=>BK(c,n));return t==null?(c,l=!1)=>HI(o,a,c,typeof l=="boolean"?l:!1):HI(o,a,t,i)};Hm.default=Hm;GI.exports=Hm;});var QI=I((uce,YI)=>{YI.exports=function(t){if(typeof t!="string"||t==="")return !1;for(var r;r=/(\\).|([@?!+*]\(.*\))/g.exec(t);){if(r[2])return !0;t=t.slice(r.index+r[0].length);}return !1};});var Wm=I((cce,ZI)=>{var FK=QI(),XI={"{":"}","(":")","[":"]"},qK=function(e){if(e[0]==="!")return !0;for(var t=0,r=-2,n=-2,i=-2,s=-2,a=-2;t<e.length;){if(e[t]==="*"||e[t+1]==="?"&&/[\].+)]/.test(e[t])||n!==-1&&e[t]==="["&&e[t+1]!=="]"&&(n<t&&(n=e.indexOf("]",t)),n>t&&(a===-1||a>n||(a=e.indexOf("\\",t),a===-1||a>n)))||i!==-1&&e[t]==="{"&&e[t+1]!=="}"&&(i=e.indexOf("}",t),i>t&&(a=e.indexOf("\\",t),a===-1||a>i))||s!==-1&&e[t]==="("&&e[t+1]==="?"&&/[:!=]/.test(e[t+2])&&e[t+3]!==")"&&(s=e.indexOf(")",t),s>t&&(a=e.indexOf("\\",t),a===-1||a>s))||r!==-1&&e[t]==="("&&e[t+1]!=="|"&&(r<t&&(r=e.indexOf("|",t)),r!==-1&&e[r+1]!==")"&&(s=e.indexOf(")",r),s>r&&(a=e.indexOf("\\",r),a===-1||a>s))))return !0;if(e[t]==="\\"){var o=e[t+1];t+=2;var c=XI[o];if(c){var l=e.indexOf(c,t);l!==-1&&(t=l+1);}if(e[t]==="!")return !0}else t++;}return !1},MK=function(e){if(e[0]==="!")return !0;for(var t=0;t<e.length;){if(/[*?{}()[\]]/.test(e[t]))return !0;if(e[t]==="\\"){var r=e[t+1];t+=2;var n=XI[r];if(n){var i=e.indexOf(n,t);i!==-1&&(t=i+1);}if(e[t]==="!")return !0}else t++;}return !1};ZI.exports=function(t,r){if(typeof t!="string"||t==="")return !1;if(FK(t))return !0;var n=qK;return r&&r.strict===!1&&(n=MK),n(t)};});var e2=I((lce,JI)=>{var UK=Wm(),$K=he("path").posix.dirname,jK=he("os").platform()==="win32",Km="/",VK=/\\/g,HK=/[\{\[].*[\}\]]$/,WK=/(^|[^\\])([\{\[]|\([^\)]+$)/,KK=/\\([\!\*\?\|\[\]\(\)\{\}])/g;JI.exports=function(t,r){var n=Object.assign({flipBackslashes:!0},r);n.flipBackslashes&&jK&&t.indexOf(Km)<0&&(t=t.replace(VK,Km)),HK.test(t)&&(t+=Km),t+="a";do t=$K(t);while(UK(t)||WK.test(t));return t.replace(KK,"$1")};});var xf=I(Ln=>{Ln.isInteger=e=>typeof e=="number"?Number.isInteger(e):typeof e=="string"&&e.trim()!==""?Number.isInteger(Number(e)):!1;Ln.find=(e,t)=>e.nodes.find(r=>r.type===t);Ln.exceedsLimit=(e,t,r=1,n)=>n===!1||!Ln.isInteger(e)||!Ln.isInteger(t)?!1:(Number(t)-Number(e))/Number(r)>=n;Ln.escapeNode=(e,t=0,r)=>{let n=e.nodes[t];n&&(r&&n.type===r||n.type==="open"||n.type==="close")&&n.escaped!==!0&&(n.value="\\"+n.value,n.escaped=!0);};Ln.encloseBrace=e=>e.type!=="brace"||e.commas>>0+e.ranges>>0?!1:(e.invalid=!0,!0);Ln.isInvalidBrace=e=>e.type!=="brace"?!1:e.invalid===!0||e.dollar?!0:!(e.commas>>0+e.ranges>>0)||e.open!==!0||e.close!==!0?(e.invalid=!0,!0):!1;Ln.isOpenOrClose=e=>e.type==="open"||e.type==="close"?!0:e.open===!0||e.close===!0;Ln.reduce=e=>e.reduce((t,r)=>(r.type==="text"&&t.push(r.value),r.type==="range"&&(r.type="text"),t),[]);Ln.flatten=(...e)=>{let t=[],r=n=>{for(let i=0;i<n.length;i++){let s=n[i];Array.isArray(s)?r(s):s!==void 0&&t.push(s);}return t};return r(e),t};});var Tf=I((dce,r2)=>{var t2=xf();r2.exports=(e,t={})=>{let r=(n,i={})=>{let s=t.escapeInvalid&&t2.isInvalidBrace(i),a=n.invalid===!0&&t.escapeInvalid===!0,o="";if(n.value)return (s||a)&&t2.isOpenOrClose(n)?"\\"+n.value:n.value;if(n.value)return n.value;if(n.nodes)for(let c of n.nodes)o+=r(c);return o};return r(e)};});var i2=I((hce,n2)=>{n2.exports=function(e){return typeof e=="number"?e-e===0:typeof e=="string"&&e.trim()!==""?Number.isFinite?Number.isFinite(+e):isFinite(+e):!1};});var h2=I((pce,d2)=>{var s2=i2(),sa=(e,t,r)=>{if(s2(e)===!1)throw new TypeError("toRegexRange: expected the first argument to be a number");if(t===void 0||e===t)return String(e);if(s2(t)===!1)throw new TypeError("toRegexRange: expected the second argument to be a number.");let n={relaxZeros:!0,...r};typeof n.strictZeros=="boolean"&&(n.relaxZeros=n.strictZeros===!1);let i=String(n.relaxZeros),s=String(n.shorthand),a=String(n.capture),o=String(n.wrap),c=e+":"+t+"="+i+s+a+o;if(sa.cache.hasOwnProperty(c))return sa.cache[c].result;let l=Math.min(e,t),u=Math.max(e,t);if(Math.abs(l-u)===1){let _=e+"|"+t;return n.capture?`(${_})`:n.wrap===!1?_:`(?:${_})`}let f=f2(e)||f2(t),h={min:e,max:t,a:l,b:u},p=[],g=[];if(f&&(h.isPadded=f,h.maxLen=String(h.max).length),l<0){let _=u<0?Math.abs(u):1;g=a2(_,Math.abs(l),h,n),l=h.a=0;}return u>=0&&(p=a2(l,u,h,n)),h.negatives=g,h.positives=p,h.result=GK(g,p),n.capture===!0?h.result=`(${h.result})`:n.wrap!==!1&&p.length+g.length>1&&(h.result=`(?:${h.result})`),sa.cache[c]=h,h.result};function GK(e,t,r){let n=Gm(e,t,"-",!1)||[],i=Gm(t,e,"",!1)||[],s=Gm(e,t,"-?",!0)||[];return n.concat(s).concat(i).join("|")}function zK(e,t){let r=1,n=1,i=u2(e,r),s=new Set([t]);for(;e<=i&&i<=t;)s.add(i),r+=1,i=u2(e,r);for(i=c2(t+1,n)-1;e<i&&i<=t;)s.add(i),n+=1,i=c2(t+1,n)-1;return s=[...s],s.sort(XK),s}function YK(e,t,r){if(e===t)return {pattern:e,count:[],digits:0};let n=QK(e,t),i=n.length,s="",a=0;for(let o=0;o<i;o++){let[c,l]=n[o];c===l?s+=c:c!=="0"||l!=="9"?s+=ZK(c,l):a++;}return a&&(s+=r.shorthand===!0?"\\d":"[0-9]"),{pattern:s,count:[a],digits:i}}function a2(e,t,r,n){let i=zK(e,t),s=[],a=e,o;for(let c=0;c<i.length;c++){let l=i[c],u=YK(String(a),String(l),n),f="";if(!r.isPadded&&o&&o.pattern===u.pattern){o.count.length>1&&o.count.pop(),o.count.push(u.count[0]),o.string=o.pattern+l2(o.count),a=l+1;continue}r.isPadded&&(f=JK(l,r,n)),u.string=f+u.pattern+l2(u.count),s.push(u),a=l+1,o=u;}return s}function Gm(e,t,r,n,i){let s=[];for(let a of e){let{string:o}=a;!n&&!o2(t,"string",o)&&s.push(r+o),n&&o2(t,"string",o)&&s.push(r+o);}return s}function QK(e,t){let r=[];for(let n=0;n<e.length;n++)r.push([e[n],t[n]]);return r}function XK(e,t){return e>t?1:t>e?-1:0}function o2(e,t,r){return e.some(n=>n[t]===r)}function u2(e,t){return Number(String(e).slice(0,-t)+"9".repeat(t))}function c2(e,t){return e-e%Math.pow(10,t)}function l2(e){let[t=0,r=""]=e;return r||t>1?`{${t+(r?","+r:"")}}`:""}function ZK(e,t,r){return `[${e}${t-e===1?"":"-"}${t}]`}function f2(e){return /^-?(0+)\d/.test(e)}function JK(e,t,r){if(!t.isPadded)return e;let n=Math.abs(t.maxLen-String(e).length),i=r.relaxZeros!==!1;switch(n){case 0:return "";case 1:return i?"0?":"0";case 2:return i?"0{0,2}":"00";default:return i?`0{0,${n}}`:`0{${n}}`}}sa.cache={};sa.clearCache=()=>sa.cache={};d2.exports=sa;});var Qm=I((gce,S2)=>{var e7=he("util"),m2=h2(),p2=e=>e!==null&&typeof e=="object"&&!Array.isArray(e),t7=e=>t=>e===!0?Number(t):String(t),zm=e=>typeof e=="number"||typeof e=="string"&&e!=="",Vu=e=>Number.isInteger(+e),Ym=e=>{let t=`${e}`,r=-1;if(t[0]==="-"&&(t=t.slice(1)),t==="0")return !1;for(;t[++r]==="0";);return r>0},r7=(e,t,r)=>typeof e=="string"||typeof t=="string"?!0:r.stringify===!0,n7=(e,t,r)=>{if(t>0){let n=e[0]==="-"?"-":"";n&&(e=e.slice(1)),e=n+e.padStart(n?t-1:t,"0");}return r===!1?String(e):e},g2=(e,t)=>{let r=e[0]==="-"?"-":"";for(r&&(e=e.slice(1),t--);e.length<t;)e="0"+e;return r?"-"+e:e},i7=(e,t)=>{e.negatives.sort((a,o)=>a<o?-1:a>o?1:0),e.positives.sort((a,o)=>a<o?-1:a>o?1:0);let r=t.capture?"":"?:",n="",i="",s;return e.positives.length&&(n=e.positives.join("|")),e.negatives.length&&(i=`-(${r}${e.negatives.join("|")})`),n&&i?s=`${n}|${i}`:s=n||i,t.wrap?`(${r}${s})`:s},y2=(e,t,r,n)=>{if(r)return m2(e,t,{wrap:!1,...n});let i=String.fromCharCode(e);if(e===t)return i;let s=String.fromCharCode(t);return `[${i}-${s}]`},v2=(e,t,r)=>{if(Array.isArray(e)){let n=r.wrap===!0,i=r.capture?"":"?:";return n?`(${i}${e.join("|")})`:e.join("|")}return m2(e,t,r)},_2=(...e)=>new RangeError("Invalid range arguments: "+e7.inspect(...e)),b2=(e,t,r)=>{if(r.strictRanges===!0)throw _2([e,t]);return []},s7=(e,t)=>{if(t.strictRanges===!0)throw new TypeError(`Expected step "${e}" to be a number`);return []},a7=(e,t,r=1,n={})=>{let i=Number(e),s=Number(t);if(!Number.isInteger(i)||!Number.isInteger(s)){if(n.strictRanges===!0)throw _2([e,t]);return []}i===0&&(i=0),s===0&&(s=0);let a=i>s,o=String(e),c=String(t),l=String(r);r=Math.max(Math.abs(r),1);let u=Ym(o)||Ym(c)||Ym(l),f=u?Math.max(o.length,c.length,l.length):0,h=u===!1&&r7(e,t,n)===!1,p=n.transform||t7(h);if(n.toRegex&&r===1)return y2(g2(e,f),g2(t,f),!0,n);let g={negatives:[],positives:[]},_=y=>g[y<0?"negatives":"positives"].push(Math.abs(y)),E=[],w=0;for(;a?i>=s:i<=s;)n.toRegex===!0&&r>1?_(i):E.push(n7(p(i,w),f,h)),i=a?i-r:i+r,w++;return n.toRegex===!0?r>1?i7(g,n):v2(E,null,{wrap:!1,...n}):E},o7=(e,t,r=1,n={})=>{if(!Vu(e)&&e.length>1||!Vu(t)&&t.length>1)return b2(e,t,n);let i=n.transform||(h=>String.fromCharCode(h)),s=`${e}`.charCodeAt(0),a=`${t}`.charCodeAt(0),o=s>a,c=Math.min(s,a),l=Math.max(s,a);if(n.toRegex&&r===1)return y2(c,l,!1,n);let u=[],f=0;for(;o?s>=a:s<=a;)u.push(i(s,f)),s=o?s-r:s+r,f++;return n.toRegex===!0?v2(u,null,{wrap:!1,options:n}):u},Af=(e,t,r,n={})=>{if(t==null&&zm(e))return [e];if(!zm(e)||!zm(t))return b2(e,t,n);if(typeof r=="function")return Af(e,t,1,{transform:r});if(p2(r))return Af(e,t,0,r);let i={...n};return i.capture===!0&&(i.wrap=!0),r=r||i.step||1,Vu(r)?Vu(e)&&Vu(t)?a7(e,t,r,i):o7(e,t,Math.max(Math.abs(r),1),i):r!=null&&!p2(r)?s7(r,i):Af(e,t,1,r)};S2.exports=Af;});var C2=I((mce,w2)=>{var u7=Qm(),E2=xf(),c7=(e,t={})=>{let r=(n,i={})=>{let s=E2.isInvalidBrace(i),a=n.invalid===!0&&t.escapeInvalid===!0,o=s===!0||a===!0,c=t.escapeInvalid===!0?"\\":"",l="";if(n.isOpen===!0||n.isClose===!0)return c+n.value;if(n.type==="open")return o?c+n.value:"(";if(n.type==="close")return o?c+n.value:")";if(n.type==="comma")return n.prev.type==="comma"?"":o?n.value:"|";if(n.value)return n.value;if(n.nodes&&n.ranges>0){let u=E2.reduce(n.nodes),f=u7(...u,{...t,wrap:!1,toRegex:!0});if(f.length!==0)return u.length>1&&f.length>1?`(${f})`:f}if(n.nodes)for(let u of n.nodes)l+=r(u,n);return l};return r(e)};w2.exports=c7;});var A2=I((yce,T2)=>{var l7=Qm(),x2=Tf(),uo=xf(),aa=(e="",t="",r=!1)=>{let n=[];if(e=[].concat(e),t=[].concat(t),!t.length)return e;if(!e.length)return r?uo.flatten(t).map(i=>`{${i}}`):t;for(let i of e)if(Array.isArray(i))for(let s of i)n.push(aa(s,t,r));else for(let s of t)r===!0&&typeof s=="string"&&(s=`{${s}}`),n.push(Array.isArray(s)?aa(i,s,r):i+s);return uo.flatten(n)},f7=(e,t={})=>{let r=t.rangeLimit===void 0?1e3:t.rangeLimit,n=(i,s={})=>{i.queue=[];let a=s,o=s.queue;for(;a.type!=="brace"&&a.type!=="root"&&a.parent;)a=a.parent,o=a.queue;if(i.invalid||i.dollar){o.push(aa(o.pop(),x2(i,t)));return}if(i.type==="brace"&&i.invalid!==!0&&i.nodes.length===2){o.push(aa(o.pop(),["{}"]));return}if(i.nodes&&i.ranges>0){let f=uo.reduce(i.nodes);if(uo.exceedsLimit(...f,t.step,r))throw new RangeError("expanded array length exceeds range limit. Use options.rangeLimit to increase or disable the limit.");let h=l7(...f,t);h.length===0&&(h=x2(i,t)),o.push(aa(o.pop(),h)),i.nodes=[];return}let c=uo.encloseBrace(i),l=i.queue,u=i;for(;u.type!=="brace"&&u.type!=="root"&&u.parent;)u=u.parent,l=u.queue;for(let f=0;f<i.nodes.length;f++){let h=i.nodes[f];if(h.type==="comma"&&i.type==="brace"){f===1&&l.push(""),l.push("");continue}if(h.type==="close"){o.push(aa(o.pop(),l,c));continue}if(h.value&&h.type!=="open"){l.push(aa(l.pop(),h.value));continue}h.nodes&&n(h,i);}return l};return uo.flatten(n(e))};T2.exports=f7;});var I2=I((vce,R2)=>{R2.exports={MAX_LENGTH:1024*64,CHAR_0:"0",CHAR_9:"9",CHAR_UPPERCASE_A:"A",CHAR_LOWERCASE_A:"a",CHAR_UPPERCASE_Z:"Z",CHAR_LOWERCASE_Z:"z",CHAR_LEFT_PARENTHESES:"(",CHAR_RIGHT_PARENTHESES:")",CHAR_ASTERISK:"*",CHAR_AMPERSAND:"&",CHAR_AT:"@",CHAR_BACKSLASH:"\\",CHAR_BACKTICK:"`",CHAR_CARRIAGE_RETURN:"\r",CHAR_CIRCUMFLEX_ACCENT:"^",CHAR_COLON:":",CHAR_COMMA:",",CHAR_DOLLAR:"$",CHAR_DOT:".",CHAR_DOUBLE_QUOTE:'"',CHAR_EQUAL:"=",CHAR_EXCLAMATION_MARK:"!",CHAR_FORM_FEED:"\f",CHAR_FORWARD_SLASH:"/",CHAR_HASH:"#",CHAR_HYPHEN_MINUS:"-",CHAR_LEFT_ANGLE_BRACKET:"<",CHAR_LEFT_CURLY_BRACE:"{",CHAR_LEFT_SQUARE_BRACKET:"[",CHAR_LINE_FEED:`
`,CHAR_NO_BREAK_SPACE:"\xA0",CHAR_PERCENT:"%",CHAR_PLUS:"+",CHAR_QUESTION_MARK:"?",CHAR_RIGHT_ANGLE_BRACKET:">",CHAR_RIGHT_CURLY_BRACE:"}",CHAR_RIGHT_SQUARE_BRACKET:"]",CHAR_SEMICOLON:";",CHAR_SINGLE_QUOTE:"'",CHAR_SPACE:" ",CHAR_TAB:"	",CHAR_UNDERSCORE:"_",CHAR_VERTICAL_LINE:"|",CHAR_ZERO_WIDTH_NOBREAK_SPACE:"\uFEFF"};});var k2=I((_ce,O2)=>{var d7=Tf(),{MAX_LENGTH:P2,CHAR_BACKSLASH:Xm,CHAR_BACKTICK:h7,CHAR_COMMA:p7,CHAR_DOT:g7,CHAR_LEFT_PARENTHESES:m7,CHAR_RIGHT_PARENTHESES:y7,CHAR_LEFT_CURLY_BRACE:v7,CHAR_RIGHT_CURLY_BRACE:_7,CHAR_LEFT_SQUARE_BRACKET:N2,CHAR_RIGHT_SQUARE_BRACKET:D2,CHAR_DOUBLE_QUOTE:b7,CHAR_SINGLE_QUOTE:S7,CHAR_NO_BREAK_SPACE:E7,CHAR_ZERO_WIDTH_NOBREAK_SPACE:w7}=I2(),C7=(e,t={})=>{if(typeof e!="string")throw new TypeError("Expected a string");let r=t||{},n=typeof r.maxLength=="number"?Math.min(P2,r.maxLength):P2;if(e.length>n)throw new SyntaxError(`Input length (${e.length}), exceeds max characters (${n})`);let i={type:"root",input:e,nodes:[]},s=[i],a=i,o=i,c=0,l=e.length,u=0,f=0,h,g=()=>e[u++],_=E=>{if(E.type==="text"&&o.type==="dot"&&(o.type="text"),o&&o.type==="text"&&E.type==="text"){o.value+=E.value;return}return a.nodes.push(E),E.parent=a,E.prev=o,o=E,E};for(_({type:"bos"});u<l;)if(a=s[s.length-1],h=g(),!(h===w7||h===E7)){if(h===Xm){_({type:"text",value:(t.keepEscaping?h:"")+g()});continue}if(h===D2){_({type:"text",value:"\\"+h});continue}if(h===N2){c++;let w;for(;u<l&&(w=g());){if(h+=w,w===N2){c++;continue}if(w===Xm){h+=g();continue}if(w===D2&&(c--,c===0))break}_({type:"text",value:h});continue}if(h===m7){a=_({type:"paren",nodes:[]}),s.push(a),_({type:"text",value:h});continue}if(h===y7){if(a.type!=="paren"){_({type:"text",value:h});continue}a=s.pop(),_({type:"text",value:h}),a=s[s.length-1];continue}if(h===b7||h===S7||h===h7){let E=h,w;for(t.keepQuotes!==!0&&(h="");u<l&&(w=g());){if(w===Xm){h+=w+g();continue}if(w===E){t.keepQuotes===!0&&(h+=w);break}h+=w;}_({type:"text",value:h});continue}if(h===v7){f++;let w={type:"brace",open:!0,close:!1,dollar:o.value&&o.value.slice(-1)==="$"||a.dollar===!0,depth:f,commas:0,ranges:0,nodes:[]};a=_(w),s.push(a),_({type:"open",value:h});continue}if(h===_7){if(a.type!=="brace"){_({type:"text",value:h});continue}let E="close";a=s.pop(),a.close=!0,_({type:E,value:h}),f--,a=s[s.length-1];continue}if(h===p7&&f>0){if(a.ranges>0){a.ranges=0;let E=a.nodes.shift();a.nodes=[E,{type:"text",value:d7(a)}];}_({type:"comma",value:h}),a.commas++;continue}if(h===g7&&f>0&&a.commas===0){let E=a.nodes;if(f===0||E.length===0){_({type:"text",value:h});continue}if(o.type==="dot"){if(a.range=[],o.value+=h,o.type="range",a.nodes.length!==3&&a.nodes.length!==5){a.invalid=!0,a.ranges=0,o.type="text";continue}a.ranges++,a.args=[];continue}if(o.type==="range"){E.pop();let w=E[E.length-1];w.value+=o.value+h,o=w,a.ranges--;continue}_({type:"dot",value:h});continue}_({type:"text",value:h});}do if(a=s.pop(),a.type!=="root"){a.nodes.forEach(y=>{y.nodes||(y.type==="open"&&(y.isOpen=!0),y.type==="close"&&(y.isClose=!0),y.nodes||(y.type="text"),y.invalid=!0);});let E=s[s.length-1],w=E.nodes.indexOf(a);E.nodes.splice(w,1,...a.nodes);}while(s.length>0);return _({type:"eos"}),i};O2.exports=C7;});var F2=I((bce,B2)=>{var L2=Tf(),x7=C2(),T7=A2(),A7=k2(),En=(e,t={})=>{let r=[];if(Array.isArray(e))for(let n of e){let i=En.create(n,t);Array.isArray(i)?r.push(...i):r.push(i);}else r=[].concat(En.create(e,t));return t&&t.expand===!0&&t.nodupes===!0&&(r=[...new Set(r)]),r};En.parse=(e,t={})=>A7(e,t);En.stringify=(e,t={})=>L2(typeof e=="string"?En.parse(e,t):e,t);En.compile=(e,t={})=>(typeof e=="string"&&(e=En.parse(e,t)),x7(e,t));En.expand=(e,t={})=>{typeof e=="string"&&(e=En.parse(e,t));let r=T7(e,t);return t.noempty===!0&&(r=r.filter(Boolean)),t.nodupes===!0&&(r=[...new Set(r)]),r};En.create=(e,t={})=>e===""||e.length<3?[e]:t.expand!==!0?En.compile(e,t):En.expand(e,t);B2.exports=En;});var q2=I((Sce,R7)=>{R7.exports=["3dm","3ds","3g2","3gp","7z","a","aac","adp","ai","aif","aiff","alz","ape","apk","appimage","ar","arj","asf","au","avi","bak","baml","bh","bin","bk","bmp","btif","bz2","bzip2","cab","caf","cgm","class","cmx","cpio","cr2","cur","dat","dcm","deb","dex","djvu","dll","dmg","dng","doc","docm","docx","dot","dotm","dra","DS_Store","dsk","dts","dtshd","dvb","dwg","dxf","ecelp4800","ecelp7470","ecelp9600","egg","eol","eot","epub","exe","f4v","fbs","fh","fla","flac","flatpak","fli","flv","fpx","fst","fvt","g3","gh","gif","graffle","gz","gzip","h261","h263","h264","icns","ico","ief","img","ipa","iso","jar","jpeg","jpg","jpgv","jpm","jxr","key","ktx","lha","lib","lvp","lz","lzh","lzma","lzo","m3u","m4a","m4v","mar","mdi","mht","mid","midi","mj2","mka","mkv","mmr","mng","mobi","mov","movie","mp3","mp4","mp4a","mpeg","mpg","mpga","mxu","nef","npx","numbers","nupkg","o","odp","ods","odt","oga","ogg","ogv","otf","ott","pages","pbm","pcx","pdb","pdf","pea","pgm","pic","png","pnm","pot","potm","potx","ppa","ppam","ppm","pps","ppsm","ppsx","ppt","pptm","pptx","psd","pya","pyc","pyo","pyv","qt","rar","ras","raw","resources","rgb","rip","rlc","rmf","rmvb","rpm","rtf","rz","s3m","s7z","scpt","sgi","shar","snap","sil","sketch","slk","smv","snk","so","stl","suo","sub","swf","tar","tbz","tbz2","tga","tgz","thmx","tif","tiff","tlz","ttc","ttf","txz","udf","uvh","uvi","uvm","uvp","uvs","uvu","viv","vob","war","wav","wax","wbmp","wdp","weba","webm","webp","whl","wim","wm","wma","wmv","wmx","woff","woff2","wrm","wvx","xbm","xif","xla","xlam","xls","xlsb","xlsm","xlsx","xlt","xltm","xltx","xm","xmind","xpi","xpm","xwd","xz","z","zip","zipx"];});var U2=I((Ece,M2)=>{M2.exports=q2();});var j2=I((wce,$2)=>{var I7=he("path"),P7=U2(),N7=new Set(P7);$2.exports=e=>N7.has(I7.extname(e).slice(1).toLowerCase());});var Rf=I(Fe=>{var{sep:D7}=he("path"),{platform:Zm}=process,O7=he("os");Fe.EV_ALL="all";Fe.EV_READY="ready";Fe.EV_ADD="add";Fe.EV_CHANGE="change";Fe.EV_ADD_DIR="addDir";Fe.EV_UNLINK="unlink";Fe.EV_UNLINK_DIR="unlinkDir";Fe.EV_RAW="raw";Fe.EV_ERROR="error";Fe.STR_DATA="data";Fe.STR_END="end";Fe.STR_CLOSE="close";Fe.FSEVENT_CREATED="created";Fe.FSEVENT_MODIFIED="modified";Fe.FSEVENT_DELETED="deleted";Fe.FSEVENT_MOVED="moved";Fe.FSEVENT_CLONED="cloned";Fe.FSEVENT_UNKNOWN="unknown";Fe.FSEVENT_TYPE_FILE="file";Fe.FSEVENT_TYPE_DIRECTORY="directory";Fe.FSEVENT_TYPE_SYMLINK="symlink";Fe.KEY_LISTENERS="listeners";Fe.KEY_ERR="errHandlers";Fe.KEY_RAW="rawEmitters";Fe.HANDLER_KEYS=[Fe.KEY_LISTENERS,Fe.KEY_ERR,Fe.KEY_RAW];Fe.DOT_SLASH=`.${D7}`;Fe.BACK_SLASH_RE=/\\/g;Fe.DOUBLE_SLASH_RE=/\/\//;Fe.SLASH_OR_BACK_SLASH_RE=/[/\\]/;Fe.DOT_RE=/\..*\.(sw[px])$|~$|\.subl.*\.tmp/;Fe.REPLACER_RE=/^\.[/\\]/;Fe.SLASH="/";Fe.SLASH_SLASH="//";Fe.BRACE_START="{";Fe.BANG="!";Fe.ONE_DOT=".";Fe.TWO_DOTS="..";Fe.STAR="*";Fe.GLOBSTAR="**";Fe.ROOT_GLOBSTAR="/**/*";Fe.SLASH_GLOBSTAR="/**";Fe.DIR_SUFFIX="Dir";Fe.ANYMATCH_OPTS={dot:!0};Fe.STRING_TYPE="string";Fe.FUNCTION_TYPE="function";Fe.EMPTY_STR="";Fe.EMPTY_FN=()=>{};Fe.IDENTITY_FN=e=>e;Fe.isWindows=Zm==="win32";Fe.isMacos=Zm==="darwin";Fe.isLinux=Zm==="linux";Fe.isIBMi=O7.type()==="OS400";});var z2=I((xce,G2)=>{var $i=he("fs"),mr=he("path"),{promisify:Gu}=he("util"),k7=j2(),{isWindows:L7,isLinux:B7,EMPTY_FN:F7,EMPTY_STR:q7,KEY_LISTENERS:co,KEY_ERR:Jm,KEY_RAW:Hu,HANDLER_KEYS:M7,EV_CHANGE:Pf,EV_ADD:If,EV_ADD_DIR:U7,EV_ERROR:H2,STR_DATA:$7,STR_END:j7,BRACE_START:V7,STAR:H7}=Rf(),W7="watch",K7=Gu($i.open),W2=Gu($i.stat),G7=Gu($i.lstat),z7=Gu($i.close),e0=Gu($i.realpath),Y7={lstat:G7,stat:W2},r0=(e,t)=>{e instanceof Set?e.forEach(t):t(e);},Wu=(e,t,r)=>{let n=e[t];n instanceof Set||(e[t]=n=new Set([n])),n.add(r);},Q7=e=>t=>{let r=e[t];r instanceof Set?r.clear():delete e[t];},Ku=(e,t,r)=>{let n=e[t];n instanceof Set?n.delete(r):n===r&&delete e[t];},K2=e=>e instanceof Set?e.size===0:!e,Nf=new Map;function V2(e,t,r,n,i){let s=(a,o)=>{r(e),i(a,o,{watchedPath:e}),o&&e!==o&&Df(mr.resolve(e,o),co,mr.join(e,o));};try{return $i.watch(e,t,s)}catch(a){n(a);}}var Df=(e,t,r,n,i)=>{let s=Nf.get(e);s&&r0(s[t],a=>{a(r,n,i);});},X7=(e,t,r,n)=>{let{listener:i,errHandler:s,rawEmitter:a}=n,o=Nf.get(t),c;if(!r.persistent)return c=V2(e,r,i,s,a),c.close.bind(c);if(o)Wu(o,co,i),Wu(o,Jm,s),Wu(o,Hu,a);else {if(c=V2(e,r,Df.bind(null,t,co),s,Df.bind(null,t,Hu)),!c)return;c.on(H2,async l=>{let u=Df.bind(null,t,Jm);if(o.watcherUnusable=!0,L7&&l.code==="EPERM")try{let f=await K7(e,"r");await z7(f),u(l);}catch{}else u(l);}),o={listeners:i,errHandlers:s,rawEmitters:a,watcher:c},Nf.set(t,o);}return ()=>{Ku(o,co,i),Ku(o,Jm,s),Ku(o,Hu,a),K2(o.listeners)&&(o.watcher.close(),Nf.delete(t),M7.forEach(Q7(o)),o.watcher=void 0,Object.freeze(o));}},t0=new Map,Z7=(e,t,r,n)=>{let {listener:i,rawEmitter:s}=n,a=t0.get(t),l=a&&a.options;return l&&(l.persistent<r.persistent||l.interval>r.interval)&&($i.unwatchFile(t),a=void 0),a?(Wu(a,co,i),Wu(a,Hu,s)):(a={listeners:i,rawEmitters:s,options:r,watcher:$i.watchFile(t,r,(u,f)=>{r0(a.rawEmitters,p=>{p(Pf,t,{curr:u,prev:f});});let h=u.mtimeMs;(u.size!==f.size||h>f.mtimeMs||h===0)&&r0(a.listeners,p=>p(e,u));})},t0.set(t,a)),()=>{Ku(a,co,i),Ku(a,Hu,s),K2(a.listeners)&&(t0.delete(t),$i.unwatchFile(t),a.options=a.watcher=void 0,Object.freeze(a));}},n0=class{constructor(t){this.fsw=t,this._boundHandleError=r=>t._handleError(r);}_watchWithNodeFs(t,r){let n=this.fsw.options,i=mr.dirname(t),s=mr.basename(t);this.fsw._getWatchedDir(i).add(s);let o=mr.resolve(t),c={persistent:n.persistent};r||(r=F7);let l;return n.usePolling?(c.interval=n.enableBinaryInterval&&k7(s)?n.binaryInterval:n.interval,l=Z7(t,o,c,{listener:r,rawEmitter:this.fsw._emitRaw})):l=X7(t,o,c,{listener:r,errHandler:this._boundHandleError,rawEmitter:this.fsw._emitRaw}),l}_handleFile(t,r,n){if(this.fsw.closed)return;let i=mr.dirname(t),s=mr.basename(t),a=this.fsw._getWatchedDir(i),o=r;if(a.has(s))return;let c=async(u,f)=>{if(this.fsw._throttle(W7,t,5)){if(!f||f.mtimeMs===0)try{let h=await W2(t);if(this.fsw.closed)return;let p=h.atimeMs,g=h.mtimeMs;(!p||p<=g||g!==o.mtimeMs)&&this.fsw._emit(Pf,t,h),B7&&o.ino!==h.ino?(this.fsw._closeFile(u),o=h,this.fsw._addPathCloser(u,this._watchWithNodeFs(t,c))):o=h;}catch{this.fsw._remove(i,s);}else if(a.has(s)){let h=f.atimeMs,p=f.mtimeMs;(!h||h<=p||p!==o.mtimeMs)&&this.fsw._emit(Pf,t,f),o=f;}}},l=this._watchWithNodeFs(t,c);if(!(n&&this.fsw.options.ignoreInitial)&&this.fsw._isntIgnored(t)){if(!this.fsw._throttle(If,t,0))return;this.fsw._emit(If,t,r);}return l}async _handleSymlink(t,r,n,i){if(this.fsw.closed)return;let s=t.fullPath,a=this.fsw._getWatchedDir(r);if(!this.fsw.options.followSymlinks){this.fsw._incrReadyCount();let o;try{o=await e0(n);}catch{return this.fsw._emitReady(),!0}return this.fsw.closed?void 0:(a.has(i)?this.fsw._symlinkPaths.get(s)!==o&&(this.fsw._symlinkPaths.set(s,o),this.fsw._emit(Pf,n,t.stats)):(a.add(i),this.fsw._symlinkPaths.set(s,o),this.fsw._emit(If,n,t.stats)),this.fsw._emitReady(),!0)}if(this.fsw._symlinkPaths.has(s))return !0;this.fsw._symlinkPaths.set(s,!0);}_handleRead(t,r,n,i,s,a,o){if(t=mr.join(t,q7),!n.hasGlob&&(o=this.fsw._throttle("readdir",t,1e3),!o))return;let c=this.fsw._getWatchedDir(n.path),l=new Set,u=this.fsw._readdirp(t,{fileFilter:f=>n.filterPath(f),directoryFilter:f=>n.filterDir(f),depth:0}).on($7,async f=>{if(this.fsw.closed){u=void 0;return}let h=f.path,p=mr.join(t,h);if(l.add(h),!(f.stats.isSymbolicLink()&&await this._handleSymlink(f,t,p,h))){if(this.fsw.closed){u=void 0;return}(h===i||!i&&!c.has(h))&&(this.fsw._incrReadyCount(),p=mr.join(s,mr.relative(s,p)),this._addToNodeFs(p,r,n,a+1));}}).on(H2,this._boundHandleError);return new Promise(f=>u.once(j7,()=>{if(this.fsw.closed){u=void 0;return}let h=o?o.clear():!1;f(),c.getChildren().filter(p=>p!==t&&!l.has(p)&&(!n.hasGlob||n.filterPath({fullPath:mr.resolve(t,p)}))).forEach(p=>{this.fsw._remove(t,p);}),u=void 0,h&&this._handleRead(t,!1,n,i,s,a,o);}))}async _handleDir(t,r,n,i,s,a,o){let c=this.fsw._getWatchedDir(mr.dirname(t)),l=c.has(mr.basename(t));!(n&&this.fsw.options.ignoreInitial)&&!s&&!l&&(!a.hasGlob||a.globFilter(t))&&this.fsw._emit(U7,t,r),c.add(mr.basename(t)),this.fsw._getWatchedDir(t);let u,f,h=this.fsw.options.depth;if((h==null||i<=h)&&!this.fsw._symlinkPaths.has(o)){if(!s&&(await this._handleRead(t,n,a,s,t,i,u),this.fsw.closed))return;f=this._watchWithNodeFs(t,(p,g)=>{g&&g.mtimeMs===0||this._handleRead(p,!1,a,s,t,i,u);});}return f}async _addToNodeFs(t,r,n,i,s){let a=this.fsw._emitReady;if(this.fsw._isIgnored(t)||this.fsw.closed)return a(),!1;let o=this.fsw._getWatchHelpers(t,i);!o.hasGlob&&n&&(o.hasGlob=n.hasGlob,o.globFilter=n.globFilter,o.filterPath=c=>n.filterPath(c),o.filterDir=c=>n.filterDir(c));try{let c=await Y7[o.statMethod](o.watchPath);if(this.fsw.closed)return;if(this.fsw._isIgnored(o.watchPath,c))return a(),!1;let l=this.fsw.options.followSymlinks&&!t.includes(H7)&&!t.includes(V7),u;if(c.isDirectory()){let f=mr.resolve(t),h=l?await e0(t):t;if(this.fsw.closed||(u=await this._handleDir(o.watchPath,c,r,i,s,o,h),this.fsw.closed))return;f!==h&&h!==void 0&&this.fsw._symlinkPaths.set(f,h);}else if(c.isSymbolicLink()){let f=l?await e0(t):t;if(this.fsw.closed)return;let h=mr.dirname(o.watchPath);if(this.fsw._getWatchedDir(h).add(o.watchPath),this.fsw._emit(If,o.watchPath,c),u=await this._handleDir(h,c,r,i,t,o,f),this.fsw.closed)return;f!==void 0&&this.fsw._symlinkPaths.set(mr.resolve(t),f);}else u=this._handleFile(o.watchPath,c,r);return a(),this.fsw._addPathCloser(t,u),!1}catch(c){if(this.fsw._handleError(c))return a(),t}}};G2.exports=n0;});var tP=I((Tce,f0)=>{var c0=he("fs"),yr=he("path"),{promisify:l0}=he("util"),lo;try{lo=he("fsevents");}catch(e){process.env.CHOKIDAR_PRINT_FSEVENTS_REQUIRE_ERROR&&console.error(e);}if(lo){let e=process.version.match(/v(\d+)\.(\d+)/);if(e&&e[1]&&e[2]){let t=Number.parseInt(e[1],10),r=Number.parseInt(e[2],10);t===8&&r<16&&(lo=void 0);}}var{EV_ADD:i0,EV_CHANGE:J7,EV_ADD_DIR:Y2,EV_UNLINK:Of,EV_ERROR:eG,STR_DATA:tG,STR_END:rG,FSEVENT_CREATED:nG,FSEVENT_MODIFIED:iG,FSEVENT_DELETED:sG,FSEVENT_MOVED:aG,FSEVENT_UNKNOWN:oG,FSEVENT_TYPE_FILE:uG,FSEVENT_TYPE_DIRECTORY:zu,FSEVENT_TYPE_SYMLINK:eP,ROOT_GLOBSTAR:Q2,DIR_SUFFIX:cG,DOT_SLASH:X2,FUNCTION_TYPE:s0,EMPTY_FN:lG,IDENTITY_FN:fG}=Rf(),dG=e=>isNaN(e)?{}:{depth:e},o0=l0(c0.stat),hG=l0(c0.lstat),Z2=l0(c0.realpath),pG={stat:o0,lstat:hG},oa=new Map,gG=10,mG=new Set([69888,70400,71424,72704,73472,131328,131840,262912]),yG=(e,t)=>({stop:lo.watch(e,t)});function vG(e,t,r,n){let i=yr.extname(t)?yr.dirname(t):t,s=yr.dirname(i),a=oa.get(i);_G(s)&&(i=s);let o=yr.resolve(e),c=o!==t,l=(f,h,p)=>{c&&(f=f.replace(t,o)),(f===o||!f.indexOf(o+yr.sep))&&r(f,h,p);},u=!1;for(let f of oa.keys())if(t.indexOf(yr.resolve(f)+yr.sep)===0){i=f,a=oa.get(i),u=!0;break}return a||u?a.listeners.add(l):(a={listeners:new Set([l]),rawEmitter:n,watcher:yG(i,(f,h)=>{if(!a.listeners.size)return;let p=lo.getInfo(f,h);a.listeners.forEach(g=>{g(f,h,p);}),a.rawEmitter(p.event,f,p);})},oa.set(i,a)),()=>{let f=a.listeners;if(f.delete(l),!f.size&&(oa.delete(i),a.watcher))return a.watcher.stop().then(()=>{a.rawEmitter=a.watcher=void 0,Object.freeze(a);})}}var _G=e=>{let t=0;for(let r of oa.keys())if(r.indexOf(e)===0&&(t++,t>=gG))return !0;return !1},bG=()=>lo&&oa.size<128,a0=(e,t)=>{let r=0;for(;!e.indexOf(t)&&(e=yr.dirname(e))!==t;)r++;return r},J2=(e,t)=>e.type===zu&&t.isDirectory()||e.type===eP&&t.isSymbolicLink()||e.type===uG&&t.isFile(),u0=class{constructor(t){this.fsw=t;}checkIgnored(t,r){let n=this.fsw._ignoredPaths;if(this.fsw._isIgnored(t,r))return n.add(t),r&&r.isDirectory()&&n.add(t+Q2),!0;n.delete(t),n.delete(t+Q2);}addOrChange(t,r,n,i,s,a,o,c){let l=s.has(a)?J7:i0;this.handleEvent(l,t,r,n,i,s,a,o,c);}async checkExists(t,r,n,i,s,a,o,c){try{let l=await o0(t);if(this.fsw.closed)return;J2(o,l)?this.addOrChange(t,r,n,i,s,a,o,c):this.handleEvent(Of,t,r,n,i,s,a,o,c);}catch(l){l.code==="EACCES"?this.addOrChange(t,r,n,i,s,a,o,c):this.handleEvent(Of,t,r,n,i,s,a,o,c);}}handleEvent(t,r,n,i,s,a,o,c,l){if(!(this.fsw.closed||this.checkIgnored(r)))if(t===Of){let u=c.type===zu;(u||a.has(o))&&this.fsw._remove(s,o,u);}else {if(t===i0){if(c.type===zu&&this.fsw._getWatchedDir(r),c.type===eP&&l.followSymlinks){let f=l.depth===void 0?void 0:a0(n,i)+1;return this._addToFsEvents(r,!1,!0,f)}this.fsw._getWatchedDir(s).add(o);}let u=c.type===zu?t+cG:t;this.fsw._emit(u,r),u===Y2&&this._addToFsEvents(r,!1,!0);}}_watchWithFsEvents(t,r,n,i){if(this.fsw.closed||this.fsw._isIgnored(t))return;let s=this.fsw.options,o=vG(t,r,async(c,l,u)=>{if(this.fsw.closed||s.depth!==void 0&&a0(c,r)>s.depth)return;let f=n(yr.join(t,yr.relative(t,c)));if(i&&!i(f))return;let h=yr.dirname(f),p=yr.basename(f),g=this.fsw._getWatchedDir(u.type===zu?f:h);if(mG.has(l)||u.event===oG)if(typeof s.ignored===s0){let _;try{_=await o0(f);}catch{}if(this.fsw.closed||this.checkIgnored(f,_))return;J2(u,_)?this.addOrChange(f,c,r,h,g,p,u,s):this.handleEvent(Of,f,c,r,h,g,p,u,s);}else this.checkExists(f,c,r,h,g,p,u,s);else switch(u.event){case nG:case iG:return this.addOrChange(f,c,r,h,g,p,u,s);case sG:case aG:return this.checkExists(f,c,r,h,g,p,u,s)}},this.fsw._emitRaw);return this.fsw._emitReady(),o}async _handleFsEventsSymlink(t,r,n,i){if(!(this.fsw.closed||this.fsw._symlinkPaths.has(r))){this.fsw._symlinkPaths.set(r,!0),this.fsw._incrReadyCount();try{let s=await Z2(t);if(this.fsw.closed)return;if(this.fsw._isIgnored(s))return this.fsw._emitReady();this.fsw._incrReadyCount(),this._addToFsEvents(s||t,a=>{let o=t;return s&&s!==X2?o=a.replace(s,t):a!==X2&&(o=yr.join(t,a)),n(o)},!1,i);}catch(s){if(this.fsw._handleError(s))return this.fsw._emitReady()}}}emitAdd(t,r,n,i,s){let a=n(t),o=r.isDirectory(),c=this.fsw._getWatchedDir(yr.dirname(a)),l=yr.basename(a);o&&this.fsw._getWatchedDir(a),!c.has(l)&&(c.add(l),(!i.ignoreInitial||s===!0)&&this.fsw._emit(o?Y2:i0,a,r));}initWatch(t,r,n,i){if(this.fsw.closed)return;let s=this._watchWithFsEvents(n.watchPath,yr.resolve(t||n.watchPath),i,n.globFilter);this.fsw._addPathCloser(r,s);}async _addToFsEvents(t,r,n,i){if(this.fsw.closed)return;let s=this.fsw.options,a=typeof r===s0?r:fG,o=this.fsw._getWatchHelpers(t);try{let c=await pG[o.statMethod](o.watchPath);if(this.fsw.closed)return;if(this.fsw._isIgnored(o.watchPath,c))throw null;if(c.isDirectory()){if(o.globFilter||this.emitAdd(a(t),c,a,s,n),i&&i>s.depth)return;this.fsw._readdirp(o.watchPath,{fileFilter:l=>o.filterPath(l),directoryFilter:l=>o.filterDir(l),...dG(s.depth-(i||0))}).on(tG,l=>{if(this.fsw.closed||l.stats.isDirectory()&&!o.filterPath(l))return;let u=yr.join(o.watchPath,l.path),{fullPath:f}=l;if(o.followSymlinks&&l.stats.isSymbolicLink()){let h=s.depth===void 0?void 0:a0(u,yr.resolve(o.watchPath))+1;this._handleFsEventsSymlink(u,f,a,h);}else this.emitAdd(u,l.stats,a,s,n);}).on(eG,lG).on(rG,()=>{this.fsw._emitReady();});}else this.emitAdd(o.watchPath,c,a,s,n),this.fsw._emitReady();}catch(c){(!c||this.fsw._handleError(c))&&(this.fsw._emitReady(),this.fsw._emitReady());}if(s.persistent&&n!==!0)if(typeof r===s0)this.initWatch(void 0,t,o,a);else {let c;try{c=await Z2(o.watchPath);}catch{}this.initWatch(c,t,o,a);}}};f0.exports=u0;f0.exports.canUse=bG;});var A0=I(T0=>{var{EventEmitter:SG}=he("events"),C0=he("fs"),Nt=he("path"),{promisify:uP}=he("util"),EG=$I(),y0=zI().default,wG=e2(),d0=Wm(),CG=F2(),xG=Vm(),TG=z2(),rP=tP(),{EV_ALL:h0,EV_READY:AG,EV_ADD:kf,EV_CHANGE:Yu,EV_UNLINK:nP,EV_ADD_DIR:RG,EV_UNLINK_DIR:IG,EV_RAW:PG,EV_ERROR:p0,STR_CLOSE:NG,STR_END:DG,BACK_SLASH_RE:OG,DOUBLE_SLASH_RE:iP,SLASH_OR_BACK_SLASH_RE:kG,DOT_RE:LG,REPLACER_RE:BG,SLASH:g0,SLASH_SLASH:FG,BRACE_START:qG,BANG:v0,ONE_DOT:cP,TWO_DOTS:MG,GLOBSTAR:UG,SLASH_GLOBSTAR:m0,ANYMATCH_OPTS:_0,STRING_TYPE:x0,FUNCTION_TYPE:$G,EMPTY_STR:b0,EMPTY_FN:jG,isWindows:VG,isMacos:HG,isIBMi:WG}=Rf(),KG=uP(C0.stat),GG=uP(C0.readdir),S0=(e=[])=>Array.isArray(e)?e:[e],lP=(e,t=[])=>(e.forEach(r=>{Array.isArray(r)?lP(r,t):t.push(r);}),t),sP=e=>{let t=lP(S0(e));if(!t.every(r=>typeof r===x0))throw new TypeError(`Non-string provided as watch path: ${t}`);return t.map(fP)},aP=e=>{let t=e.replace(OG,g0),r=!1;for(t.startsWith(FG)&&(r=!0);t.match(iP);)t=t.replace(iP,g0);return r&&(t=g0+t),t},fP=e=>aP(Nt.normalize(aP(e))),oP=(e=b0)=>t=>typeof t!==x0?t:fP(Nt.isAbsolute(t)?t:Nt.join(e,t)),zG=(e,t)=>Nt.isAbsolute(e)?e:e.startsWith(v0)?v0+Nt.join(t,e.slice(1)):Nt.join(t,e),ti=(e,t)=>e[t]===void 0,E0=class{constructor(t,r){this.path=t,this._removeWatcher=r,this.items=new Set;}add(t){let{items:r}=this;r&&t!==cP&&t!==MG&&r.add(t);}async remove(t){let{items:r}=this;if(!r||(r.delete(t),r.size>0))return;let n=this.path;try{await GG(n);}catch{this._removeWatcher&&this._removeWatcher(Nt.dirname(n),Nt.basename(n));}}has(t){let{items:r}=this;if(r)return r.has(t)}getChildren(){let{items:t}=this;if(t)return [...t.values()]}dispose(){this.items.clear(),delete this.path,delete this._removeWatcher,delete this.items,Object.freeze(this);}},YG="stat",QG="lstat",w0=class{constructor(t,r,n,i){this.fsw=i,this.path=t=t.replace(BG,b0),this.watchPath=r,this.fullWatchPath=Nt.resolve(r),this.hasGlob=r!==t,t===b0&&(this.hasGlob=!1),this.globSymlink=this.hasGlob&&n?void 0:!1,this.globFilter=this.hasGlob?y0(t,void 0,_0):!1,this.dirParts=this.getDirParts(t),this.dirParts.forEach(s=>{s.length>1&&s.pop();}),this.followSymlinks=n,this.statMethod=n?YG:QG;}checkGlobSymlink(t){return this.globSymlink===void 0&&(this.globSymlink=t.fullParentDir===this.fullWatchPath?!1:{realPath:t.fullParentDir,linkPath:this.fullWatchPath}),this.globSymlink?t.fullPath.replace(this.globSymlink.realPath,this.globSymlink.linkPath):t.fullPath}entryPath(t){return Nt.join(this.watchPath,Nt.relative(this.watchPath,this.checkGlobSymlink(t)))}filterPath(t){let{stats:r}=t;if(r&&r.isSymbolicLink())return this.filterDir(t);let n=this.entryPath(t);return (this.hasGlob&&typeof this.globFilter===$G?this.globFilter(n):!0)&&this.fsw._isntIgnored(n,r)&&this.fsw._hasReadPermissions(r)}getDirParts(t){if(!this.hasGlob)return [];let r=[];return (t.includes(qG)?CG.expand(t):[t]).forEach(i=>{r.push(Nt.relative(this.watchPath,i).split(kG));}),r}filterDir(t){if(this.hasGlob){let r=this.getDirParts(this.checkGlobSymlink(t)),n=!1;this.unmatchedGlob=!this.dirParts.some(i=>i.every((s,a)=>(s===UG&&(n=!0),n||!r[0][a]||y0(s,r[0][a],_0))));}return !this.unmatchedGlob&&this.fsw._isntIgnored(this.entryPath(t),t.stats)}},Lf=class extends SG{constructor(t){super();let r={};t&&Object.assign(r,t),this._watched=new Map,this._closers=new Map,this._ignoredPaths=new Set,this._throttled=new Map,this._symlinkPaths=new Map,this._streams=new Set,this.closed=!1,ti(r,"persistent")&&(r.persistent=!0),ti(r,"ignoreInitial")&&(r.ignoreInitial=!1),ti(r,"ignorePermissionErrors")&&(r.ignorePermissionErrors=!1),ti(r,"interval")&&(r.interval=100),ti(r,"binaryInterval")&&(r.binaryInterval=300),ti(r,"disableGlobbing")&&(r.disableGlobbing=!1),r.enableBinaryInterval=r.binaryInterval!==r.interval,ti(r,"useFsEvents")&&(r.useFsEvents=!r.usePolling),rP.canUse()||(r.useFsEvents=!1),ti(r,"usePolling")&&!r.useFsEvents&&(r.usePolling=HG),WG&&(r.usePolling=!0);let i=process.env.CHOKIDAR_USEPOLLING;if(i!==void 0){let c=i.toLowerCase();c==="false"||c==="0"?r.usePolling=!1:c==="true"||c==="1"?r.usePolling=!0:r.usePolling=!!c;}let s=process.env.CHOKIDAR_INTERVAL;s&&(r.interval=Number.parseInt(s,10)),ti(r,"atomic")&&(r.atomic=!r.usePolling&&!r.useFsEvents),r.atomic&&(this._pendingUnlinks=new Map),ti(r,"followSymlinks")&&(r.followSymlinks=!0),ti(r,"awaitWriteFinish")&&(r.awaitWriteFinish=!1),r.awaitWriteFinish===!0&&(r.awaitWriteFinish={});let a=r.awaitWriteFinish;a&&(a.stabilityThreshold||(a.stabilityThreshold=2e3),a.pollInterval||(a.pollInterval=100),this._pendingWrites=new Map),r.ignored&&(r.ignored=S0(r.ignored));let o=0;this._emitReady=()=>{o++,o>=this._readyCount&&(this._emitReady=jG,this._readyEmitted=!0,process.nextTick(()=>this.emit(AG)));},this._emitRaw=(...c)=>this.emit(PG,...c),this._readyEmitted=!1,this.options=r,r.useFsEvents?this._fsEventsHandler=new rP(this):this._nodeFsHandler=new TG(this),Object.freeze(r);}add(t,r,n){let{cwd:i,disableGlobbing:s}=this.options;this.closed=!1;let a=sP(t);return i&&(a=a.map(o=>{let c=zG(o,i);return s||!d0(o)?c:xG(c)})),a=a.filter(o=>o.startsWith(v0)?(this._ignoredPaths.add(o.slice(1)),!1):(this._ignoredPaths.delete(o),this._ignoredPaths.delete(o+m0),this._userIgnored=void 0,!0)),this.options.useFsEvents&&this._fsEventsHandler?(this._readyCount||(this._readyCount=a.length),this.options.persistent&&(this._readyCount*=2),a.forEach(o=>this._fsEventsHandler._addToFsEvents(o))):(this._readyCount||(this._readyCount=0),this._readyCount+=a.length,Promise.all(a.map(async o=>{let c=await this._nodeFsHandler._addToNodeFs(o,!n,0,0,r);return c&&this._emitReady(),c})).then(o=>{this.closed||o.filter(c=>c).forEach(c=>{this.add(Nt.dirname(c),Nt.basename(r||c));});})),this}unwatch(t){if(this.closed)return this;let r=sP(t),{cwd:n}=this.options;return r.forEach(i=>{!Nt.isAbsolute(i)&&!this._closers.has(i)&&(n&&(i=Nt.join(n,i)),i=Nt.resolve(i)),this._closePath(i),this._ignoredPaths.add(i),this._watched.has(i)&&this._ignoredPaths.add(i+m0),this._userIgnored=void 0;}),this}close(){if(this.closed)return this._closePromise;this.closed=!0,this.removeAllListeners();let t=[];return this._closers.forEach(r=>r.forEach(n=>{let i=n();i instanceof Promise&&t.push(i);})),this._streams.forEach(r=>r.destroy()),this._userIgnored=void 0,this._readyCount=0,this._readyEmitted=!1,this._watched.forEach(r=>r.dispose()),["closers","watched","streams","symlinkPaths","throttled"].forEach(r=>{this[`_${r}`].clear();}),this._closePromise=t.length?Promise.all(t).then(()=>{}):Promise.resolve(),this._closePromise}getWatched(){let t={};return this._watched.forEach((r,n)=>{let i=this.options.cwd?Nt.relative(this.options.cwd,n):n;t[i||cP]=r.getChildren().sort();}),t}emitWithAll(t,r){this.emit(...r),t!==p0&&this.emit(h0,...r);}async _emit(t,r,n,i,s){if(this.closed)return;let a=this.options;VG&&(r=Nt.normalize(r)),a.cwd&&(r=Nt.relative(a.cwd,r));let o=[t,r];s!==void 0?o.push(n,i,s):i!==void 0?o.push(n,i):n!==void 0&&o.push(n);let c=a.awaitWriteFinish,l;if(c&&(l=this._pendingWrites.get(r)))return l.lastChange=new Date,this;if(a.atomic){if(t===nP)return this._pendingUnlinks.set(r,o),setTimeout(()=>{this._pendingUnlinks.forEach((u,f)=>{this.emit(...u),this.emit(h0,...u),this._pendingUnlinks.delete(f);});},typeof a.atomic=="number"?a.atomic:100),this;t===kf&&this._pendingUnlinks.has(r)&&(t=o[0]=Yu,this._pendingUnlinks.delete(r));}if(c&&(t===kf||t===Yu)&&this._readyEmitted){let u=(f,h)=>{f?(t=o[0]=p0,o[1]=f,this.emitWithAll(t,o)):h&&(o.length>2?o[2]=h:o.push(h),this.emitWithAll(t,o));};return this._awaitWriteFinish(r,c.stabilityThreshold,t,u),this}if(t===Yu&&!this._throttle(Yu,r,50))return this;if(a.alwaysStat&&n===void 0&&(t===kf||t===RG||t===Yu)){let u=a.cwd?Nt.join(a.cwd,r):r,f;try{f=await KG(u);}catch{}if(!f||this.closed)return;o.push(f);}return this.emitWithAll(t,o),this}_handleError(t){let r=t&&t.code;return t&&r!=="ENOENT"&&r!=="ENOTDIR"&&(!this.options.ignorePermissionErrors||r!=="EPERM"&&r!=="EACCES")&&this.emit(p0,t),t||this.closed}_throttle(t,r,n){this._throttled.has(t)||this._throttled.set(t,new Map);let i=this._throttled.get(t),s=i.get(r);if(s)return s.count++,!1;let a,o=()=>{let l=i.get(r),u=l?l.count:0;return i.delete(r),clearTimeout(a),l&&clearTimeout(l.timeoutObject),u};a=setTimeout(o,n);let c={timeoutObject:a,clear:o,count:0};return i.set(r,c),c}_incrReadyCount(){return this._readyCount++}_awaitWriteFinish(t,r,n,i){let s,a=t;this.options.cwd&&!Nt.isAbsolute(t)&&(a=Nt.join(this.options.cwd,t));let o=new Date,c=l=>{C0.stat(a,(u,f)=>{if(u||!this._pendingWrites.has(t)){u&&u.code!=="ENOENT"&&i(u);return}let h=Number(new Date);l&&f.size!==l.size&&(this._pendingWrites.get(t).lastChange=h);let p=this._pendingWrites.get(t);h-p.lastChange>=r?(this._pendingWrites.delete(t),i(void 0,f)):s=setTimeout(c,this.options.awaitWriteFinish.pollInterval,f);});};this._pendingWrites.has(t)||(this._pendingWrites.set(t,{lastChange:o,cancelWait:()=>(this._pendingWrites.delete(t),clearTimeout(s),n)}),s=setTimeout(c,this.options.awaitWriteFinish.pollInterval));}_getGlobIgnored(){return [...this._ignoredPaths.values()]}_isIgnored(t,r){if(this.options.atomic&&LG.test(t))return !0;if(!this._userIgnored){let{cwd:n}=this.options,i=this.options.ignored,s=i&&i.map(oP(n)),a=S0(s).filter(c=>typeof c===x0&&!d0(c)).map(c=>c+m0),o=this._getGlobIgnored().map(oP(n)).concat(s,a);this._userIgnored=y0(o,void 0,_0);}return this._userIgnored([t,r])}_isntIgnored(t,r){return !this._isIgnored(t,r)}_getWatchHelpers(t,r){let n=r||this.options.disableGlobbing||!d0(t)?t:wG(t),i=this.options.followSymlinks;return new w0(t,n,i,this)}_getWatchedDir(t){this._boundRemove||(this._boundRemove=this._remove.bind(this));let r=Nt.resolve(t);return this._watched.has(r)||this._watched.set(r,new E0(r,this._boundRemove)),this._watched.get(r)}_hasReadPermissions(t){if(this.options.ignorePermissionErrors)return !0;let n=(t&&Number.parseInt(t.mode,10))&511;return !!(4&Number.parseInt(n.toString(8)[0],10))}_remove(t,r,n){let i=Nt.join(t,r),s=Nt.resolve(i);if(n=n??(this._watched.has(i)||this._watched.has(s)),!this._throttle("remove",i,100))return;!n&&!this.options.useFsEvents&&this._watched.size===1&&this.add(t,r,!0),this._getWatchedDir(i).getChildren().forEach(h=>this._remove(i,h));let c=this._getWatchedDir(t),l=c.has(r);c.remove(r),this._symlinkPaths.has(s)&&this._symlinkPaths.delete(s);let u=i;if(this.options.cwd&&(u=Nt.relative(this.options.cwd,i)),this.options.awaitWriteFinish&&this._pendingWrites.has(u)&&this._pendingWrites.get(u).cancelWait()===kf)return;this._watched.delete(i),this._watched.delete(s);let f=n?IG:nP;l&&!this._isIgnored(i)&&this._emit(f,i),this.options.useFsEvents||this._closePath(i);}_closePath(t){this._closeFile(t);let r=Nt.dirname(t);this._getWatchedDir(r).remove(Nt.basename(t));}_closeFile(t){let r=this._closers.get(t);r&&(r.forEach(n=>n()),this._closers.delete(t));}_addPathCloser(t,r){if(!r)return;let n=this._closers.get(t);n||(n=[],this._closers.set(t,n)),n.push(r);}_readdirp(t,r){if(this.closed)return;let n={type:h0,alwaysStat:!0,lstat:!0,...r},i=EG(t,n);return this._streams.add(i),i.once(NG,()=>{i=void 0;}),i.once(DG,()=>{i&&(this._streams.delete(i),i=void 0);}),i}};T0.FSWatcher=Lf;var XG=(e,t)=>{let r=new Lf(t);return r.add(e),r};T0.watch=XG;});var mP={};UU(mP,{closest:()=>nz,distance:()=>gP});var ji,tz,rz,gP,nz,yP=vE(()=>{ji=new Uint32Array(65536),tz=(e,t)=>{let r=e.length,n=t.length,i=1<<r-1,s=-1,a=0,o=r,c=r;for(;c--;)ji[e.charCodeAt(c)]|=1<<c;for(c=0;c<n;c++){let l=ji[t.charCodeAt(c)],u=l|a;l|=(l&s)+s^s,a|=~(l|s),s&=l,a&i&&o++,s&i&&o--,a=a<<1|1,s=s<<1|~(u|a),a&=u;}for(c=r;c--;)ji[e.charCodeAt(c)]=0;return o},rz=(e,t)=>{let r=t.length,n=e.length,i=[],s=[],a=Math.ceil(r/32),o=Math.ceil(n/32);for(let g=0;g<a;g++)s[g]=-1,i[g]=0;let c=0;for(;c<o-1;c++){let g=0,_=-1,E=c*32,w=Math.min(32,n)+E;for(let y=E;y<w;y++)ji[e.charCodeAt(y)]|=1<<y;for(let y=0;y<r;y++){let b=ji[t.charCodeAt(y)],N=s[y/32|0]>>>y&1,L=i[y/32|0]>>>y&1,V=b|g,Z=((b|L)&_)+_^_|b|L,G=g|~(Z|_),z=_&Z;G>>>31^N&&(s[y/32|0]^=1<<y),z>>>31^L&&(i[y/32|0]^=1<<y),G=G<<1|N,z=z<<1|L,_=z|~(V|G),g=G&V;}for(let y=E;y<w;y++)ji[e.charCodeAt(y)]=0;}let l=0,u=-1,f=c*32,h=Math.min(32,n-f)+f;for(let g=f;g<h;g++)ji[e.charCodeAt(g)]|=1<<g;let p=n;for(let g=0;g<r;g++){let _=ji[t.charCodeAt(g)],E=s[g/32|0]>>>g&1,w=i[g/32|0]>>>g&1,y=_|l,b=((_|w)&u)+u^u|_|w,N=l|~(b|u),L=u&b;p+=N>>>n-1&1,p-=L>>>n-1&1,N>>>31^E&&(s[g/32|0]^=1<<g),L>>>31^w&&(i[g/32|0]^=1<<g),N=N<<1|E,L=L<<1|w,u=L|~(y|N),l=N&y;}for(let g=f;g<h;g++)ji[e.charCodeAt(g)]=0;return p},gP=(e,t)=>{if(e.length<t.length){let r=t;t=e,e=r;}return t.length===0?e.length:e.length<=32?tz(e,t):rz(e,t)},nz=(e,t)=>{let r=1/0,n=0;for(let i=0;i<t.length;i++){let s=gP(e,t[i]);s<r&&(r=s,n=i);}return t[n]};});var vP=I((D0,Qu)=>{(function(){var e;try{e=typeof Intl<"u"&&typeof Intl.Collator<"u"?Intl.Collator("generic",{sensitivity:"base"}):null;}catch{console.log("Collator could not be initialized and wouldn't be used");}var t=(yP(),$U(mP)),r=[],n=[],i={get:function(s,a,o){var c=o&&e&&o.useCollator;if(c){var l=s.length,u=a.length;if(l===0)return u;if(u===0)return l;var f,h,p,g,_;for(p=0;p<u;++p)r[p]=p,n[p]=a.charCodeAt(p);r[u]=u;var E;for(p=0;p<l;++p){for(h=p+1,g=0;g<u;++g)f=h,E=e.compare(s.charAt(p),String.fromCharCode(n[g]))===0,h=r[g]+(E?0:1),_=f+1,h>_&&(h=_),_=r[g+1]+1,h>_&&(h=_),r[g]=f;r[g]=h;}return h}return t.distance(s,a)}};typeof define<"u"&&define!==null&&define.amd?define(function(){return i}):typeof Qu<"u"&&Qu!==null&&typeof D0<"u"&&Qu.exports===D0?Qu.exports=i:typeof self<"u"&&typeof self.postMessage=="function"&&typeof self.importScripts=="function"?self.Levenshtein=i:typeof window<"u"&&window!==null&&(window.Levenshtein=i);})();});var q0=I((Bce,CP)=>{var Ju=e=>e&&typeof e.message=="string",F0=e=>{if(!e)return;let t=e.cause;if(typeof t=="function"){let r=e.cause();return Ju(r)?r:void 0}else return Ju(t)?t:void 0},EP=(e,t)=>{if(!Ju(e))return "";let r=e.stack||"";if(t.has(e))return r+`
causes have become circular...`;let n=F0(e);return n?(t.add(e),r+`
caused by: `+EP(n,t)):r},az=e=>EP(e,new Set),wP=(e,t,r)=>{if(!Ju(e))return "";let n=r?"":e.message||"";if(t.has(e))return n+": ...";let i=F0(e);if(i){t.add(e);let s=typeof e.cause=="function";return n+(s?"":": ")+wP(i,t,s)}else return n},oz=e=>wP(e,new Set);CP.exports={isErrorLike:Ju,getErrorCause:F0,stackWithCauses:az,messageWithCauses:oz};});var M0=I((Fce,TP)=>{var uz=Symbol("circular-ref-tag"),Uf=Symbol("pino-raw-err-ref"),xP=Object.create({},{type:{enumerable:!0,writable:!0,value:void 0},message:{enumerable:!0,writable:!0,value:void 0},stack:{enumerable:!0,writable:!0,value:void 0},aggregateErrors:{enumerable:!0,writable:!0,value:void 0},raw:{enumerable:!1,get:function(){return this[Uf]},set:function(e){this[Uf]=e;}}});Object.defineProperty(xP,Uf,{writable:!0,value:{}});TP.exports={pinoErrProto:xP,pinoErrorSymbols:{seen:uz,rawSymbol:Uf}};});var IP=I((qce,RP)=>{RP.exports=$0;var{messageWithCauses:cz,stackWithCauses:lz,isErrorLike:AP}=q0(),{pinoErrProto:fz,pinoErrorSymbols:dz}=M0(),{seen:U0}=dz,{toString:hz}=Object.prototype;function $0(e){if(!AP(e))return e;e[U0]=void 0;let t=Object.create(fz);t.type=hz.call(e.constructor)==="[object Function]"?e.constructor.name:e.name,t.message=cz(e),t.stack=lz(e),Array.isArray(e.errors)&&(t.aggregateErrors=e.errors.map(r=>$0(r)));for(let r in e)if(t[r]===void 0){let n=e[r];AP(n)?r!=="cause"&&!Object.prototype.hasOwnProperty.call(n,U0)&&(t[r]=$0(n)):t[r]=n;}return delete e[U0],t.raw=e,t}});var NP=I((Mce,PP)=>{PP.exports=jf;var{isErrorLike:j0}=q0(),{pinoErrProto:pz,pinoErrorSymbols:gz}=M0(),{seen:$f}=gz,{toString:mz}=Object.prototype;function jf(e){if(!j0(e))return e;e[$f]=void 0;let t=Object.create(pz);t.type=mz.call(e.constructor)==="[object Function]"?e.constructor.name:e.name,t.message=e.message,t.stack=e.stack,Array.isArray(e.errors)&&(t.aggregateErrors=e.errors.map(r=>jf(r))),j0(e.cause)&&!Object.prototype.hasOwnProperty.call(e.cause,$f)&&(t.cause=jf(e.cause));for(let r in e)if(t[r]===void 0){let n=e[r];j0(n)?Object.prototype.hasOwnProperty.call(n,$f)||(t[r]=jf(n)):t[r]=n;}return delete e[$f],t.raw=e,t}});var LP=I((Uce,kP)=>{kP.exports={mapHttpRequest:yz,reqSerializer:OP};var V0=Symbol("pino-raw-req-ref"),DP=Object.create({},{id:{enumerable:!0,writable:!0,value:""},method:{enumerable:!0,writable:!0,value:""},url:{enumerable:!0,writable:!0,value:""},query:{enumerable:!0,writable:!0,value:""},params:{enumerable:!0,writable:!0,value:""},headers:{enumerable:!0,writable:!0,value:{}},remoteAddress:{enumerable:!0,writable:!0,value:""},remotePort:{enumerable:!0,writable:!0,value:""},raw:{enumerable:!1,get:function(){return this[V0]},set:function(e){this[V0]=e;}}});Object.defineProperty(DP,V0,{writable:!0,value:{}});function OP(e){let t=e.info||e.socket,r=Object.create(DP);if(r.id=typeof e.id=="function"?e.id():e.id||(e.info?e.info.id:void 0),r.method=e.method,e.originalUrl)r.url=e.originalUrl;else {let n=e.path;r.url=typeof n=="string"?n:e.url?e.url.path||e.url:void 0;}return e.query&&(r.query=e.query),e.params&&(r.params=e.params),r.headers=e.headers,r.remoteAddress=t&&t.remoteAddress,r.remotePort=t&&t.remotePort,r.raw=e.raw||e,r}function yz(e){return {req:OP(e)}}});var MP=I(($ce,qP)=>{qP.exports={mapHttpResponse:vz,resSerializer:FP};var H0=Symbol("pino-raw-res-ref"),BP=Object.create({},{statusCode:{enumerable:!0,writable:!0,value:0},headers:{enumerable:!0,writable:!0,value:""},raw:{enumerable:!1,get:function(){return this[H0]},set:function(e){this[H0]=e;}}});Object.defineProperty(BP,H0,{writable:!0,value:{}});function FP(e){let t=Object.create(BP);return t.statusCode=e.headersSent?e.statusCode:null,t.headers=e.getHeaders?e.getHeaders():e._headers,t.raw=e,t}function vz(e){return {res:FP(e)}}});var K0=I((jce,UP)=>{var W0=IP(),_z=NP(),Vf=LP(),Hf=MP();UP.exports={err:W0,errWithCause:_z,mapHttpRequest:Vf.mapHttpRequest,mapHttpResponse:Hf.mapHttpResponse,req:Vf.reqSerializer,res:Hf.resSerializer,wrapErrorSerializer:function(t){return t===W0?t:function(n){return t(W0(n))}},wrapRequestSerializer:function(t){return t===Vf.reqSerializer?t:function(n){return t(Vf.reqSerializer(n))}},wrapResponseSerializer:function(t){return t===Hf.resSerializer?t:function(n){return t(Hf.resSerializer(n))}}};});var G0=I((Vce,$P)=>{function bz(e,t){return t}$P.exports=function(){let t=Error.prepareStackTrace;Error.prepareStackTrace=bz;let r=new Error().stack;if(Error.prepareStackTrace=t,!Array.isArray(r))return;let n=r.slice(2),i=[];for(let s of n)s&&i.push(s.getFileName());return i};});var VP=I((Hce,jP)=>{jP.exports=Sz;function Sz(e={}){let{ERR_PATHS_MUST_BE_STRINGS:t=()=>"fast-redact - Paths must be (non-empty) strings",ERR_INVALID_PATH:r=n=>`fast-redact \u2013 Invalid path (${n})`}=e;return function({paths:i}){i.forEach(s=>{if(typeof s!="string")throw Error(t());try{if(/〇/.test(s))throw Error();let a=(s[0]==="["?"":".")+s.replace(/^\*/,"\u3007").replace(/\.\*/g,".\u3007").replace(/\[\*\]/g,"[\u3007]");if(/\n|\r|;/.test(a)||/\/\*/.test(a))throw Error();Function(`
            'use strict'
            const o = new Proxy({}, { get: () => o, set: () => { throw Error() } });
            const \u3007 = null;
            o${a}
            if ([o${a}].length !== 1) throw Error()`)();}catch{throw Error(r(s))}});}}});var Wf=I((Wce,HP)=>{HP.exports=/[^.[\]]+|\[((?:.)*?)\]/g;});var KP=I((Kce,WP)=>{var Ez=Wf();WP.exports=wz;function wz({paths:e}){let t=[];var r=0;let n=e.reduce(function(i,s,a){var o=s.match(Ez).map(u=>u.replace(/'|"|`/g,""));let c=s[0]==="[";o=o.map(u=>u[0]==="["?u.substr(1,u.length-2):u);let l=o.indexOf("*");if(l>-1){let u=o.slice(0,l),f=u.join("."),h=o.slice(l+1,o.length),p=h.length>0;r++,t.push({before:u,beforeStr:f,after:h,nested:p});}else i[s]={path:o,val:void 0,precensored:!1,circle:"",escPath:JSON.stringify(s),leadingBracket:c};return i},{});return {wildcards:t,wcLen:r,secret:n}}});var zP=I((Gce,GP)=>{var Cz=Wf();GP.exports=xz;function xz({secret:e,serialize:t,wcLen:r,strict:n,isCensorFct:i,censorFctTakesPath:s},a){let o=Function("o",`
    if (typeof o !== 'object' || o == null) {
      ${Iz(n,t)}
    }
    const { censor, secret } = this
    ${Tz(e,i,s)}
    this.compileRestore()
    ${Az(r>0,i,s)}
    ${Rz(t)}
  `).bind(a);return t===!1&&(o.restore=c=>a.restore(c)),o}function Tz(e,t,r){return Object.keys(e).map(n=>{let{escPath:i,leadingBracket:s,path:a}=e[n],o=s?1:0,c=s?"":".",l=[];for(var u;(u=Cz.exec(n))!==null;){let[,g]=u,{index:_,input:E}=u;_>o&&l.push(E.substring(0,_-(g?0:1)));}var f=l.map(g=>`o${c}${g}`).join(" && ");f.length===0?f+=`o${c}${n} != null`:f+=` && o${c}${n} != null`;let h=`
      switch (true) {
        ${l.reverse().map(g=>`
          case o${c}${g} === censor:
            secret[${i}].circle = ${JSON.stringify(g)}
            break
        `).join(`
`)}
      }
    `,p=r?`val, ${JSON.stringify(a)}`:"val";return `
      if (${f}) {
        const val = o${c}${n}
        if (val === censor) {
          secret[${i}].precensored = true
        } else {
          secret[${i}].val = val
          o${c}${n} = ${t?`censor(${p})`:"censor"}
          ${h}
        }
      }
    `}).join(`
`)}function Az(e,t,r){return e===!0?`
    {
      const { wildcards, wcLen, groupRedact, nestedRedact } = this
      for (var i = 0; i < wcLen; i++) {
        const { before, beforeStr, after, nested } = wildcards[i]
        if (nested === true) {
          secret[beforeStr] = secret[beforeStr] || []
          nestedRedact(secret[beforeStr], o, before, after, censor, ${t}, ${r})
        } else secret[beforeStr] = groupRedact(o, before, censor, ${t}, ${r})
      }
    }
  `:""}function Rz(e){return e===!1?"return o":`
    var s = this.serialize(o)
    this.restore(o)
    return s
  `}function Iz(e,t){return e===!0?"throw Error('fast-redact: primitives cannot be redacted')":t===!1?"return o":"return this.serialize(o)"}});var Y0=I((zce,XP)=>{XP.exports={groupRedact:Nz,groupRestore:Pz,nestedRedact:Oz,nestedRestore:Dz};function Pz({keys:e,values:t,target:r}){if(r==null)return;let n=e.length;for(var i=0;i<n;i++){let s=e[i];r[s]=t[i];}}function Nz(e,t,r,n,i){let s=YP(e,t);if(s==null)return {keys:null,values:null,target:null,flat:!0};let a=Object.keys(s),o=a.length,c=t.length,l=i?[...t]:void 0,u=new Array(o);for(var f=0;f<o;f++){let h=a[f];u[f]=s[h],i?(l[c]=h,s[h]=r(s[h],l)):n?s[h]=r(s[h]):s[h]=r;}return {keys:a,values:u,target:s,flat:!0}}function Dz(e){for(let t=0;t<e.length;t++){let{target:r,path:n,value:i}=e[t],s=r;for(let a=n.length-1;a>0;a--)s=s[n[a]];s[n[0]]=i;}}function Oz(e,t,r,n,i,s,a){let o=YP(t,r);if(o==null)return;let c=Object.keys(o),l=c.length;for(var u=0;u<l;u++){let f=c[u];kz(e,o,f,r,n,i,s,a);}return e}function z0(e,t){return e!=null?"hasOwn"in Object?Object.hasOwn(e,t):Object.prototype.hasOwnProperty.call(e,t):!1}function kz(e,t,r,n,i,s,a,o){let c=i.length,l=c-1,u=r;var f=-1,h,p,g,E=null,w,y,b=!1,N=0,L=0,V=Lz();if(g=h=t[r],typeof h=="object"){for(;h!=null&&++f<c&&(L+=1,r=i[f],!(r!=="*"&&!E&&!(typeof h=="object"&&r in h)));)if(!(r==="*"&&(E==="*"&&(b=!0),E=r,f!==l))){if(E){let G=Object.keys(h);for(var Z=0;Z<G.length;Z++){let z=G[Z];if(y=h[z],w=r==="*",b)V=Hi(V,z,L),N=f,g=QP(y,N-1,r,n,i,s,a,o,u,h,p,g,w,z,f,l,V,e,t[u],L+1);else if(w||typeof y=="object"&&y!==null&&r in y){if(w?g=y:g=y[r],p=f!==l?g:a?o?s(g,[...n,u,...i]):s(g):s,w){let ee=ec(Hi(V,z,L),g,t[u]);e.push(ee),h[z]=p;}else if(y[r]!==p)if(p===void 0&&s!==void 0||z0(y,r)&&p===g)V=Hi(V,z,L);else {V=Hi(V,z,L);let ee=ec(Hi(V,r,L+1),g,t[u]);e.push(ee),y[r]=p;}}}E=null;}else {if(g=h[r],V=Hi(V,r,L),p=f!==l?g:a?o?s(g,[...n,u,...i]):s(g):s,!(z0(h,r)&&p===g||p===void 0&&s!==void 0)){let G=ec(V,g,t[u]);e.push(G),h[r]=p;}h=h[r];}if(typeof h!="object")break}}}function YP(e,t){for(var r=-1,n=t.length,i=e;i!=null&&++r<n;)i=i[t[r]];return i}function QP(e,t,r,n,i,s,a,o,c,l,u,f,h,p,g,_,E,w,y,b){if(t===0&&(h||typeof e=="object"&&e!==null&&r in e)){if(h?f=e:f=e[r],u=g!==_?f:a?o?s(f,[...n,c,...i]):s(f):s,h){let N=ec(E,f,y);w.push(N),l[p]=u;}else if(e[r]!==u){if(!(u===void 0&&s!==void 0||z0(e,r)&&u===f)){let N=ec(Hi(E,r,b+1),f,y);w.push(N),e[r]=u;}}}for(let N in e)typeof e[N]=="object"&&(E=Hi(E,N,b),QP(e[N],t-1,r,n,i,s,a,o,c,l,u,f,h,p,g,_,E,w,y,b+1));}function Lz(){return {parent:null,key:null,children:[],depth:0}}function Hi(e,t,r){if(e.depth===r)return Hi(e.parent,t,r);var n={parent:e,key:t,depth:r,children:[]};return e.children.push(n),n}function ec(e,t,r){let n=e,i=[];do i.push(n.key),n=n.parent;while(n.parent!=null);return {path:i,value:t,target:r}}});var JP=I((Yce,ZP)=>{var{groupRestore:Bz,nestedRestore:Fz}=Y0();ZP.exports=qz;function qz({secret:e,wcLen:t}){return function(){if(this.restore)return;let n=Object.keys(e),i=Mz(e,n),s=t>0,a=s?{secret:e,groupRestore:Bz,nestedRestore:Fz}:{secret:e};this.restore=Function("o",Uz(i,n,s)).bind(a);}}function Mz(e,t){return t.map(r=>{let{circle:n,escPath:i,leadingBracket:s}=e[r],o=n?`o.${n} = secret[${i}].val`:`o${s?"":"."}${r} = secret[${i}].val`,c=`secret[${i}].val = undefined`;return `
      if (secret[${i}].val !== undefined) {
        try { ${o} } catch (e) {}
        ${c}
      }
    `}).join("")}function Uz(e,t,r){return `
    const secret = this.secret
    ${r===!0?`
    const keys = Object.keys(secret)
    const len = keys.length
    for (var i = len - 1; i >= ${t.length}; i--) {
      const k = keys[i]
      const o = secret[k]
      if (o.flat === true) this.groupRestore(o)
      else this.nestedRestore(o)
      secret[k] = null
    }
  `:""}
    ${e}
    return o
  `}});var tN=I((Qce,eN)=>{eN.exports=$z;function $z(e){let{secret:t,censor:r,compileRestore:n,serialize:i,groupRedact:s,nestedRedact:a,wildcards:o,wcLen:c}=e,l=[{secret:t,censor:r,compileRestore:n}];return i!==!1&&l.push({serialize:i}),c>0&&l.push({groupRedact:s,nestedRedact:a,wildcards:o,wcLen:c}),Object.assign(...l)}});var iN=I((Xce,nN)=>{var rN=VP(),jz=KP(),Vz=zP(),Hz=JP(),{groupRedact:Wz,nestedRedact:Kz}=Y0(),Gz=tN(),zz=Wf(),Yz=rN(),Q0=e=>e;Q0.restore=Q0;var Qz="[REDACTED]";X0.rx=zz;X0.validator=rN;nN.exports=X0;function X0(e={}){let t=Array.from(new Set(e.paths||[])),r="serialize"in e&&(e.serialize===!1||typeof e.serialize=="function")?e.serialize:JSON.stringify,n=e.remove;if(n===!0&&r!==JSON.stringify)throw Error("fast-redact \u2013 remove option may only be set when serializer is JSON.stringify");let i=n===!0?void 0:"censor"in e?e.censor:Qz,s=typeof i=="function",a=s&&i.length>1;if(t.length===0)return r||Q0;Yz({paths:t,serialize:r,censor:i});let{wildcards:o,wcLen:c,secret:l}=jz({paths:t,censor:i}),u=Hz({secret:l,wcLen:c}),f="strict"in e?e.strict:!0;return Vz({secret:l,wcLen:c,serialize:r,strict:f,isCensorFct:s,censorFctTakesPath:a},Gz({secret:l,censor:i,compileRestore:u,serialize:r,groupRedact:Wz,nestedRedact:Kz,wildcards:o,wcLen:c}))}});var ho=I((Zce,sN)=>{var Xz=Symbol("pino.setLevel"),Zz=Symbol("pino.getLevel"),Jz=Symbol("pino.levelVal"),eY=Symbol("pino.useLevelLabels"),tY=Symbol("pino.useOnlyCustomLevels"),rY=Symbol("pino.mixin"),nY=Symbol("pino.lsCache"),iY=Symbol("pino.chindings"),sY=Symbol("pino.asJson"),aY=Symbol("pino.write"),oY=Symbol("pino.redactFmt"),uY=Symbol("pino.time"),cY=Symbol("pino.timeSliceIndex"),lY=Symbol("pino.stream"),fY=Symbol("pino.stringify"),dY=Symbol("pino.stringifySafe"),hY=Symbol("pino.stringifiers"),pY=Symbol("pino.end"),gY=Symbol("pino.formatOpts"),mY=Symbol("pino.messageKey"),yY=Symbol("pino.errorKey"),vY=Symbol("pino.nestedKey"),_Y=Symbol("pino.nestedKeyStr"),bY=Symbol("pino.mixinMergeStrategy"),SY=Symbol("pino.msgPrefix"),EY=Symbol("pino.wildcardFirst"),wY=Symbol.for("pino.serializers"),CY=Symbol.for("pino.formatters"),xY=Symbol.for("pino.hooks"),TY=Symbol.for("pino.metadata");sN.exports={setLevelSym:Xz,getLevelSym:Zz,levelValSym:Jz,useLevelLabelsSym:eY,mixinSym:rY,lsCacheSym:nY,chindingsSym:iY,asJsonSym:sY,writeSym:aY,serializersSym:wY,redactFmtSym:oY,timeSym:uY,timeSliceIndexSym:cY,streamSym:lY,stringifySym:fY,stringifySafeSym:dY,stringifiersSym:hY,endSym:pY,formatOptsSym:gY,messageKeySym:mY,errorKeySym:yY,nestedKeySym:vY,wildcardFirstSym:EY,needsMetadataGsym:TY,useOnlyCustomLevelsSym:tY,formattersSym:CY,hooksSym:xY,nestedKeyStrSym:_Y,mixinMergeStrategySym:bY,msgPrefixSym:SY};});var ey=I((Jce,cN)=>{var J0=iN(),{redactFmtSym:AY,wildcardFirstSym:Kf}=ho(),{rx:Z0,validator:RY}=J0,aN=RY({ERR_PATHS_MUST_BE_STRINGS:()=>"pino \u2013 redacted paths must be strings",ERR_INVALID_PATH:e=>`pino \u2013 redact paths array contains an invalid path (${e})`}),oN="[Redacted]",uN=!1;function IY(e,t){let{paths:r,censor:n}=PY(e),i=r.reduce((o,c)=>{Z0.lastIndex=0;let l=Z0.exec(c),u=Z0.exec(c),f=l[1]!==void 0?l[1].replace(/^(?:"|'|`)(.*)(?:"|'|`)$/,"$1"):l[0];if(f==="*"&&(f=Kf),u===null)return o[f]=null,o;if(o[f]===null)return o;let{index:h}=u,p=`${c.substr(h,c.length-1)}`;return o[f]=o[f]||[],f!==Kf&&o[f].length===0&&o[f].push(...o[Kf]||[]),f===Kf&&Object.keys(o).forEach(function(g){o[g]&&o[g].push(p);}),o[f].push(p),o},{}),s={[AY]:J0({paths:r,censor:n,serialize:t,strict:uN})},a=(...o)=>t(typeof n=="function"?n(...o):n);return [...Object.keys(i),...Object.getOwnPropertySymbols(i)].reduce((o,c)=>{if(i[c]===null)o[c]=l=>a(l,[c]);else {let l=typeof n=="function"?(u,f)=>n(u,[c,...f]):n;o[c]=J0({paths:i[c],censor:l,serialize:t,strict:uN});}return o},s)}function PY(e){if(Array.isArray(e))return e={paths:e,censor:oN},aN(e),e;let{paths:t,censor:r=oN,remove:n}=e;if(Array.isArray(t)===!1)throw Error("pino \u2013 redact must contain an array of strings");return n===!0&&(r=void 0),aN({paths:t,censor:r}),{paths:t,censor:r}}cN.exports=IY;});var fN=I((ele,lN)=>{var NY=()=>"",DY=()=>`,"time":${Date.now()}`,OY=()=>`,"time":${Math.round(Date.now()/1e3)}`,kY=()=>`,"time":"${new Date(Date.now()).toISOString()}"`;lN.exports={nullTime:NY,epochTime:DY,unixTime:OY,isoTime:kY};});var hN=I((tle,dN)=>{function LY(e){try{return JSON.stringify(e)}catch{return '"[Circular]"'}}dN.exports=BY;function BY(e,t,r){var n=r&&r.stringify||LY,i=1;if(typeof e=="object"&&e!==null){var s=t.length+i;if(s===1)return e;var a=new Array(s);a[0]=n(e);for(var o=1;o<s;o++)a[o]=n(t[o]);return a.join(" ")}if(typeof e!="string")return e;var c=t.length;if(c===0)return e;for(var l="",u=1-i,f=-1,h=e&&e.length||0,p=0;p<h;){if(e.charCodeAt(p)===37&&p+1<h){switch(f=f>-1?f:0,e.charCodeAt(p+1)){case 100:case 102:if(u>=c||t[u]==null)break;f<p&&(l+=e.slice(f,p)),l+=Number(t[u]),f=p+2,p++;break;case 105:if(u>=c||t[u]==null)break;f<p&&(l+=e.slice(f,p)),l+=Math.floor(Number(t[u])),f=p+2,p++;break;case 79:case 111:case 106:if(u>=c||t[u]===void 0)break;f<p&&(l+=e.slice(f,p));var g=typeof t[u];if(g==="string"){l+="'"+t[u]+"'",f=p+2,p++;break}if(g==="function"){l+=t[u].name||"<anonymous>",f=p+2,p++;break}l+=n(t[u]),f=p+2,p++;break;case 115:if(u>=c)break;f<p&&(l+=e.slice(f,p)),l+=String(t[u]),f=p+2,p++;break;case 37:f<p&&(l+=e.slice(f,p)),l+="%",f=p+2,p++,u--;break}++u;}++p;}return f===-1?e:(f<h&&(l+=e.slice(f)),l)}});var ry=I((rle,ty)=>{if(typeof SharedArrayBuffer<"u"&&typeof Atomics<"u"){let t=function(r){if((r>0&&r<1/0)===!1)throw typeof r!="number"&&typeof r!="bigint"?TypeError("sleep: ms must be a number"):RangeError("sleep: ms must be a number that is greater than 0 but less than Infinity");Atomics.wait(e,0,0,Number(r));},e=new Int32Array(new SharedArrayBuffer(4));ty.exports=t;}else {let e=function(t){if((t>0&&t<1/0)===!1)throw typeof t!="number"&&typeof t!="bigint"?TypeError("sleep: ms must be a number"):RangeError("sleep: ms must be a number that is greater than 0 but less than Infinity");};ty.exports=e;}});var SN=I((nle,bN)=>{var ar=he("fs"),FY=he("events"),qY=he("util").inherits,pN=he("path"),ny=ry(),Gf=100,zf=Buffer.allocUnsafe(0),MY=16*1024,gN="buffer",mN="utf8";function yN(e,t){t._opening=!0,t._writing=!0,t._asyncDrainScheduled=!1;function r(s,a){if(s){t._reopening=!1,t._writing=!1,t._opening=!1,t.sync?process.nextTick(()=>{t.listenerCount("error")>0&&t.emit("error",s);}):t.emit("error",s);return}t.fd=a,t.file=e,t._reopening=!1,t._opening=!1,t._writing=!1,t.sync?process.nextTick(()=>t.emit("ready")):t.emit("ready"),!(t._reopening||t.destroyed)&&(!t._writing&&t._len>t.minLength||t._flushPending)&&t._actualWrite();}let n=t.append?"a":"w",i=t.mode;if(t.sync)try{t.mkdir&&ar.mkdirSync(pN.dirname(e),{recursive:!0});let s=ar.openSync(e,n,i);r(null,s);}catch(s){throw r(s),s}else t.mkdir?ar.mkdir(pN.dirname(e),{recursive:!0},s=>{if(s)return r(s);ar.open(e,n,i,r);}):ar.open(e,n,i,r);}function ri(e){if(!(this instanceof ri))return new ri(e);let{fd:t,dest:r,minLength:n,maxLength:i,maxWrite:s,sync:a,append:o=!0,mkdir:c,retryEAGAIN:l,fsync:u,contentMode:f,mode:h}=e||{};t=t||r,this._len=0,this.fd=-1,this._bufs=[],this._lens=[],this._writing=!1,this._ending=!1,this._reopening=!1,this._asyncDrainScheduled=!1,this._flushPending=!1,this._hwm=Math.max(n||0,16387),this.file=null,this.destroyed=!1,this.minLength=n||0,this.maxLength=i||0,this.maxWrite=s||MY,this.sync=a||!1,this.writable=!0,this._fsync=u||!1,this.append=o||!1,this.mode=h,this.retryEAGAIN=l||(()=>!0),this.mkdir=c||!1;let p,g;if(f===gN)this._writingBuf=zf,this.write=jY,this.flush=HY,this.flushSync=KY,this._actualWrite=zY,p=()=>ar.writeSync(this.fd,this._writingBuf),g=()=>ar.write(this.fd,this._writingBuf,this.release);else if(f===void 0||f===mN)this._writingBuf="",this.write=$Y,this.flush=VY,this.flushSync=WY,this._actualWrite=GY,p=()=>ar.writeSync(this.fd,this._writingBuf,"utf8"),g=()=>ar.write(this.fd,this._writingBuf,"utf8",this.release);else throw new Error(`SonicBoom supports "${mN}" and "${gN}", but passed ${f}`);if(typeof t=="number")this.fd=t,process.nextTick(()=>this.emit("ready"));else if(typeof t=="string")yN(t,this);else throw new Error("SonicBoom supports only file descriptors and files");if(this.minLength>=this.maxWrite)throw new Error(`minLength should be smaller than maxWrite (${this.maxWrite})`);this.release=(_,E)=>{if(_){if((_.code==="EAGAIN"||_.code==="EBUSY")&&this.retryEAGAIN(_,this._writingBuf.length,this._len-this._writingBuf.length))if(this.sync)try{ny(Gf),this.release(void 0,0);}catch(y){this.release(y);}else setTimeout(g,Gf);else this._writing=!1,this.emit("error",_);return}if(this.emit("write",E),this._len-=E,this._len<0&&(this._len=0),this._writingBuf=this._writingBuf.slice(E),this._writingBuf.length){if(!this.sync){g();return}try{do{let y=p();this._len-=y,this._writingBuf=this._writingBuf.slice(y);}while(this._writingBuf.length)}catch(y){this.release(y);return}}this._fsync&&ar.fsyncSync(this.fd);let w=this._len;this._reopening?(this._writing=!1,this._reopening=!1,this.reopen()):w>this.minLength?this._actualWrite():this._ending?w>0?this._actualWrite():(this._writing=!1,Yf(this)):(this._writing=!1,this.sync?this._asyncDrainScheduled||(this._asyncDrainScheduled=!0,process.nextTick(UY,this)):this.emit("drain"));},this.on("newListener",function(_){_==="drain"&&(this._asyncDrainScheduled=!1);});}function UY(e){e.listenerCount("drain")>0&&(e._asyncDrainScheduled=!1,e.emit("drain"));}qY(ri,FY);function vN(e,t){return e.length===0?zf:e.length===1?e[0]:Buffer.concat(e,t)}function $Y(e){if(this.destroyed)throw new Error("SonicBoom destroyed");let t=this._len+e.length,r=this._bufs;return this.maxLength&&t>this.maxLength?(this.emit("drop",e),this._len<this._hwm):(r.length===0||r[r.length-1].length+e.length>this.maxWrite?r.push(""+e):r[r.length-1]+=e,this._len=t,!this._writing&&this._len>=this.minLength&&this._actualWrite(),this._len<this._hwm)}function jY(e){if(this.destroyed)throw new Error("SonicBoom destroyed");let t=this._len+e.length,r=this._bufs,n=this._lens;return this.maxLength&&t>this.maxLength?(this.emit("drop",e),this._len<this._hwm):(r.length===0||n[n.length-1]+e.length>this.maxWrite?(r.push([e]),n.push(e.length)):(r[r.length-1].push(e),n[n.length-1]+=e.length),this._len=t,!this._writing&&this._len>=this.minLength&&this._actualWrite(),this._len<this._hwm)}function _N(e){this._flushPending=!0;let t=()=>{this._fsync?(this._flushPending=!1,e()):ar.fsync(this.fd,n=>{this._flushPending=!1,e(n);}),this.off("error",r);},r=n=>{this._flushPending=!1,e(n),this.off("drain",t);};this.once("drain",t),this.once("error",r);}function VY(e){if(e!=null&&typeof e!="function")throw new Error("flush cb must be a function");if(this.destroyed){let t=new Error("SonicBoom destroyed");if(e){e(t);return}throw t}if(this.minLength<=0){e?.();return}e&&_N.call(this,e),!this._writing&&(this._bufs.length===0&&this._bufs.push(""),this._actualWrite());}function HY(e){if(e!=null&&typeof e!="function")throw new Error("flush cb must be a function");if(this.destroyed){let t=new Error("SonicBoom destroyed");if(e){e(t);return}throw t}if(this.minLength<=0){e?.();return}e&&_N.call(this,e),!this._writing&&(this._bufs.length===0&&(this._bufs.push([]),this._lens.push(0)),this._actualWrite());}ri.prototype.reopen=function(e){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this._opening){this.once("ready",()=>{this.reopen(e);});return}if(this._ending)return;if(!this.file)throw new Error("Unable to reopen a file descriptor, you must pass a file to SonicBoom");if(this._reopening=!0,this._writing)return;let t=this.fd;this.once("ready",()=>{t!==this.fd&&ar.close(t,r=>{if(r)return this.emit("error",r)});}),yN(e||this.file,this);};ri.prototype.end=function(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this._opening){this.once("ready",()=>{this.end();});return}this._ending||(this._ending=!0,!this._writing&&(this._len>0&&this.fd>=0?this._actualWrite():Yf(this)));};function WY(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this.fd<0)throw new Error("sonic boom is not ready yet");!this._writing&&this._writingBuf.length>0&&(this._bufs.unshift(this._writingBuf),this._writingBuf="");let e="";for(;this._bufs.length||e;){e.length<=0&&(e=this._bufs[0]);try{let t=ar.writeSync(this.fd,e,"utf8");e=e.slice(t),this._len=Math.max(this._len-t,0),e.length<=0&&this._bufs.shift();}catch(t){if((t.code==="EAGAIN"||t.code==="EBUSY")&&!this.retryEAGAIN(t,e.length,this._len-e.length))throw t;ny(Gf);}}try{ar.fsyncSync(this.fd);}catch{}}function KY(){if(this.destroyed)throw new Error("SonicBoom destroyed");if(this.fd<0)throw new Error("sonic boom is not ready yet");!this._writing&&this._writingBuf.length>0&&(this._bufs.unshift([this._writingBuf]),this._writingBuf=zf);let e=zf;for(;this._bufs.length||e.length;){e.length<=0&&(e=vN(this._bufs[0],this._lens[0]));try{let t=ar.writeSync(this.fd,e);e=e.subarray(t),this._len=Math.max(this._len-t,0),e.length<=0&&(this._bufs.shift(),this._lens.shift());}catch(t){if((t.code==="EAGAIN"||t.code==="EBUSY")&&!this.retryEAGAIN(t,e.length,this._len-e.length))throw t;ny(Gf);}}}ri.prototype.destroy=function(){this.destroyed||Yf(this);};function GY(){let e=this.release;if(this._writing=!0,this._writingBuf=this._writingBuf||this._bufs.shift()||"",this.sync)try{let t=ar.writeSync(this.fd,this._writingBuf,"utf8");e(null,t);}catch(t){e(t);}else ar.write(this.fd,this._writingBuf,"utf8",e);}function zY(){let e=this.release;if(this._writing=!0,this._writingBuf=this._writingBuf.length?this._writingBuf:vN(this._bufs.shift(),this._lens.shift()),this.sync)try{let t=ar.writeSync(this.fd,this._writingBuf);e(null,t);}catch(t){e(t);}else ar.write(this.fd,this._writingBuf,e);}function Yf(e){if(e.fd===-1){e.once("ready",Yf.bind(null,e));return}e.destroyed=!0,e._bufs=[],e._lens=[],ar.fsync(e.fd,t);function t(){e.fd!==1&&e.fd!==2?ar.close(e.fd,r):r();}function r(n){if(n){e.emit("error",n);return}e._ending&&!e._writing&&e.emit("finish"),e.emit("close");}}ri.SonicBoom=ri;ri.default=ri;bN.exports=ri;});var iy=I((ile,TN)=>{var ni={exit:[],beforeExit:[]},EN={exit:XY,beforeExit:ZY},po;function YY(){po===void 0&&(po=new FinalizationRegistry(JY));}function QY(e){ni[e].length>0||process.on(e,EN[e]);}function wN(e){ni[e].length>0||(process.removeListener(e,EN[e]),ni.exit.length===0&&ni.beforeExit.length===0&&(po=void 0));}function XY(){CN("exit");}function ZY(){CN("beforeExit");}function CN(e){for(let t of ni[e]){let r=t.deref(),n=t.fn;r!==void 0&&n(r,e);}ni[e]=[];}function JY(e){for(let t of ["exit","beforeExit"]){let r=ni[t].indexOf(e);ni[t].splice(r,r+1),wN(t);}}function xN(e,t,r){if(t===void 0)throw new Error("the object can't be undefined");QY(e);let n=new WeakRef(t);n.fn=r,YY(),po.register(t,n),ni[e].push(n);}function eQ(e,t){xN("exit",e,t);}function tQ(e,t){xN("beforeExit",e,t);}function rQ(e){if(po!==void 0){po.unregister(e);for(let t of ["exit","beforeExit"])ni[t]=ni[t].filter(r=>{let n=r.deref();return n&&n!==e}),wN(t);}}TN.exports={register:eQ,registerBeforeExit:tQ,unregister:rQ};});var AN=I((sle,nQ)=>{nQ.exports={name:"thread-stream",version:"2.4.1",description:"A streaming way to send data to a Node.js Worker Thread",main:"index.js",types:"index.d.ts",dependencies:{"real-require":"^0.2.0"},devDependencies:{"@types/node":"^20.1.0","@types/tap":"^15.0.0",desm:"^1.3.0",fastbench:"^1.0.1",husky:"^8.0.1","pino-elasticsearch":"^6.0.0","sonic-boom":"^3.0.0",standard:"^17.0.0",tap:"^16.2.0","ts-node":"^10.8.0",typescript:"^4.7.2","why-is-node-running":"^2.2.2"},scripts:{test:"standard && npm run transpile && tap test/*.test.*js && tap --ts test/*.test.*ts","test:ci":"standard && npm run transpile && npm run test:ci:js && npm run test:ci:ts","test:ci:js":'tap --no-check-coverage --coverage-report=lcovonly "test/**/*.test.*js"',"test:ci:ts":'tap --ts --no-check-coverage --coverage-report=lcovonly "test/**/*.test.*ts"',"test:yarn":'npm run transpile && tap "test/**/*.test.js" --no-check-coverage',transpile:"sh ./test/ts/transpile.sh",prepare:"husky install"},standard:{ignore:["test/ts/**/*"]},repository:{type:"git",url:"git+https://github.com/mcollina/thread-stream.git"},keywords:["worker","thread","threads","stream"],author:"Matteo Collina <hello@matteocollina.com>",license:"MIT",bugs:{url:"https://github.com/mcollina/thread-stream/issues"},homepage:"https://github.com/mcollina/thread-stream#readme"};});var IN=I((ale,RN)=>{function iQ(e,t,r,n,i){let s=Date.now()+n,a=Atomics.load(e,t);if(a===r){i(null,"ok");return}let o=a,c=l=>{Date.now()>s?i(null,"timed-out"):setTimeout(()=>{o=a,a=Atomics.load(e,t),a===o?c(l>=1e3?1e3:l*2):a===r?i(null,"ok"):i(null,"not-equal");},l);};c(1);}function sQ(e,t,r,n,i){let s=Date.now()+n,a=Atomics.load(e,t);if(a!==r){i(null,"ok");return}let o=c=>{Date.now()>s?i(null,"timed-out"):setTimeout(()=>{a=Atomics.load(e,t),a!==r?i(null,"ok"):o(c>=1e3?1e3:c*2);},c);};o(1);}RN.exports={wait:iQ,waitDiff:sQ};});var NN=I((ole,PN)=>{PN.exports={WRITE_INDEX:4,READ_INDEX:8};});var BN=I((ule,LN)=>{var{version:aQ}=AN(),{EventEmitter:oQ}=he("events"),{Worker:uQ}=he("worker_threads"),{join:cQ}=he("path"),{pathToFileURL:lQ}=he("url"),{wait:fQ}=IN(),{WRITE_INDEX:an,READ_INDEX:yi}=NN(),dQ=he("buffer"),hQ=he("assert"),ue=Symbol("kImpl"),pQ=dQ.constants.MAX_STRING_LENGTH,tc=class{constructor(t){this._value=t;}deref(){return this._value}},Xf=class{register(){}unregister(){}},gQ=process.env.NODE_V8_COVERAGE?Xf:global.FinalizationRegistry||Xf,mQ=process.env.NODE_V8_COVERAGE?tc:global.WeakRef||tc,DN=new gQ(e=>{e.exited||e.terminate();});function yQ(e,t){let{filename:r,workerData:n}=t,s=("__bundlerPathsOverrides"in globalThis?globalThis.__bundlerPathsOverrides:{})["thread-stream-worker"]||cQ(__dirname,"lib","worker.js"),a=new uQ(s,{...t.workerOpts,trackUnmanagedFds:!1,workerData:{filename:r.indexOf("file://")===0?r:lQ(r).href,dataBuf:e[ue].dataBuf,stateBuf:e[ue].stateBuf,workerData:{$context:{threadStreamVersion:aQ},...n}}});return a.stream=new tc(e),a.on("message",vQ),a.on("exit",kN),DN.register(e,a),a}function ON(e){hQ(!e[ue].sync),e[ue].needDrain&&(e[ue].needDrain=!1,e.emit("drain"));}function Qf(e){let t=Atomics.load(e[ue].state,an),r=e[ue].data.length-t;if(r>0){if(e[ue].buf.length===0){e[ue].flushing=!1,e[ue].ending?cy(e):e[ue].needDrain&&process.nextTick(ON,e);return}let n=e[ue].buf.slice(0,r),i=Buffer.byteLength(n);i<=r?(e[ue].buf=e[ue].buf.slice(r),Zf(e,n,Qf.bind(null,e))):e.flush(()=>{if(!e.destroyed){for(Atomics.store(e[ue].state,yi,0),Atomics.store(e[ue].state,an,0);i>e[ue].data.length;)r=r/2,n=e[ue].buf.slice(0,r),i=Buffer.byteLength(n);e[ue].buf=e[ue].buf.slice(r),Zf(e,n,Qf.bind(null,e));}});}else if(r===0){if(t===0&&e[ue].buf.length===0)return;e.flush(()=>{Atomics.store(e[ue].state,yi,0),Atomics.store(e[ue].state,an,0),Qf(e);});}else vi(e,new Error("overwritten"));}function vQ(e){let t=this.stream.deref();if(t===void 0){this.exited=!0,this.terminate();return}switch(e.code){case"READY":this.stream=new mQ(t),t.flush(()=>{t[ue].ready=!0,t.emit("ready");});break;case"ERROR":vi(t,e.err);break;case"EVENT":Array.isArray(e.args)?t.emit(e.name,...e.args):t.emit(e.name,e.args);break;case"WARNING":process.emitWarning(e.err);break;default:vi(t,new Error("this should not happen: "+e.code));}}function kN(e){let t=this.stream.deref();t!==void 0&&(DN.unregister(t),t.worker.exited=!0,t.worker.off("exit",kN),vi(t,e!==0?new Error("the worker thread exited"):null));}var ay=class extends oQ{constructor(t={}){if(super(),t.bufferSize<4)throw new Error("bufferSize must at least fit a 4-byte utf-8 char");this[ue]={},this[ue].stateBuf=new SharedArrayBuffer(128),this[ue].state=new Int32Array(this[ue].stateBuf),this[ue].dataBuf=new SharedArrayBuffer(t.bufferSize||4*1024*1024),this[ue].data=Buffer.from(this[ue].dataBuf),this[ue].sync=t.sync||!1,this[ue].ending=!1,this[ue].ended=!1,this[ue].needDrain=!1,this[ue].destroyed=!1,this[ue].flushing=!1,this[ue].ready=!1,this[ue].finished=!1,this[ue].errored=null,this[ue].closed=!1,this[ue].buf="",this.worker=yQ(this,t);}write(t){if(this[ue].destroyed)return oy(this,new Error("the worker has exited")),!1;if(this[ue].ending)return oy(this,new Error("the worker is ending")),!1;if(this[ue].flushing&&this[ue].buf.length+t.length>=pQ)try{sy(this),this[ue].flushing=!0;}catch(r){return vi(this,r),!1}if(this[ue].buf+=t,this[ue].sync)try{return sy(this),!0}catch(r){return vi(this,r),!1}return this[ue].flushing||(this[ue].flushing=!0,setImmediate(Qf,this)),this[ue].needDrain=this[ue].data.length-this[ue].buf.length-Atomics.load(this[ue].state,an)<=0,!this[ue].needDrain}end(){this[ue].destroyed||(this[ue].ending=!0,cy(this));}flush(t){if(this[ue].destroyed){typeof t=="function"&&process.nextTick(t,new Error("the worker has exited"));return}let r=Atomics.load(this[ue].state,an);fQ(this[ue].state,yi,r,1/0,(n,i)=>{if(n){vi(this,n),process.nextTick(t,n);return}if(i==="not-equal"){this.flush(t);return}process.nextTick(t);});}flushSync(){this[ue].destroyed||(sy(this),uy(this));}unref(){this.worker.unref();}ref(){this.worker.ref();}get ready(){return this[ue].ready}get destroyed(){return this[ue].destroyed}get closed(){return this[ue].closed}get writable(){return !this[ue].destroyed&&!this[ue].ending}get writableEnded(){return this[ue].ending}get writableFinished(){return this[ue].finished}get writableNeedDrain(){return this[ue].needDrain}get writableObjectMode(){return !1}get writableErrored(){return this[ue].errored}};function oy(e,t){setImmediate(()=>{e.emit("error",t);});}function vi(e,t){e[ue].destroyed||(e[ue].destroyed=!0,t&&(e[ue].errored=t,oy(e,t)),e.worker.exited?setImmediate(()=>{e[ue].closed=!0,e.emit("close");}):e.worker.terminate().catch(()=>{}).then(()=>{e[ue].closed=!0,e.emit("close");}));}function Zf(e,t,r){let n=Atomics.load(e[ue].state,an),i=Buffer.byteLength(t);return e[ue].data.write(t,n),Atomics.store(e[ue].state,an,n+i),Atomics.notify(e[ue].state,an),r(),!0}function cy(e){if(!(e[ue].ended||!e[ue].ending||e[ue].flushing)){e[ue].ended=!0;try{e.flushSync();let t=Atomics.load(e[ue].state,yi);Atomics.store(e[ue].state,an,-1),Atomics.notify(e[ue].state,an);let r=0;for(;t!==-1;){if(Atomics.wait(e[ue].state,yi,t,1e3),t=Atomics.load(e[ue].state,yi),t===-2){vi(e,new Error("end() failed"));return}if(++r===10){vi(e,new Error("end() took too long (10s)"));return}}process.nextTick(()=>{e[ue].finished=!0,e.emit("finish");});}catch(t){vi(e,t);}}}function sy(e){let t=()=>{e[ue].ending?cy(e):e[ue].needDrain&&process.nextTick(ON,e);};for(e[ue].flushing=!1;e[ue].buf.length!==0;){let r=Atomics.load(e[ue].state,an),n=e[ue].data.length-r;if(n===0){uy(e),Atomics.store(e[ue].state,yi,0),Atomics.store(e[ue].state,an,0);continue}else if(n<0)throw new Error("overwritten");let i=e[ue].buf.slice(0,n),s=Buffer.byteLength(i);if(s<=n)e[ue].buf=e[ue].buf.slice(n),Zf(e,i,t);else {for(uy(e),Atomics.store(e[ue].state,yi,0),Atomics.store(e[ue].state,an,0);s>e[ue].buf.length;)n=n/2,i=e[ue].buf.slice(0,n),s=Buffer.byteLength(i);e[ue].buf=e[ue].buf.slice(n),Zf(e,i,t);}}}function uy(e){if(e[ue].flushing)throw new Error("unable to flush while flushing");let t=Atomics.load(e[ue].state,an),r=0;for(;;){let n=Atomics.load(e[ue].state,yi);if(n===-2)throw Error("_flushSync failed");if(n!==t)Atomics.wait(e[ue].state,yi,n,1e3);else break;if(++r===10)throw new Error("_flushSync took too long (10s)")}}LN.exports=ay;});var dy=I((cle,FN)=>{var{createRequire:_Q}=he("module"),bQ=G0(),{join:ly,isAbsolute:SQ,sep:EQ}=he("path"),wQ=ry(),fy=iy(),CQ=BN();function xQ(e){fy.register(e,AQ),fy.registerBeforeExit(e,RQ),e.on("close",function(){fy.unregister(e);});}function TQ(e,t,r){let n=new CQ({filename:e,workerData:t,workerOpts:r});n.on("ready",i),n.on("close",function(){process.removeListener("exit",s);}),process.on("exit",s);function i(){process.removeListener("exit",s),n.unref(),r.autoEnd!==!1&&xQ(n);}function s(){n.closed||(n.flushSync(),wQ(100),n.end());}return n}function AQ(e){e.ref(),e.flushSync(),e.end(),e.once("close",function(){e.unref();});}function RQ(e){e.flushSync();}function IQ(e){let{pipeline:t,targets:r,levels:n,dedupe:i,options:s={},worker:a={},caller:o=bQ()}=e,c=typeof o=="string"?[o]:o,l="__bundlerPathsOverrides"in globalThis?globalThis.__bundlerPathsOverrides:{},u=e.target;if(u&&r)throw new Error("only one of target or targets can be specified");return r?(u=l["pino-worker"]||ly(__dirname,"worker.js"),s.targets=r.map(h=>({...h,target:f(h.target)}))):t&&(u=l["pino-pipeline-worker"]||ly(__dirname,"worker-pipeline.js"),s.targets=t.map(h=>({...h,target:f(h.target)}))),n&&(s.levels=n),i&&(s.dedupe=i),TQ(f(u),s,a);function f(h){if(h=l[h]||h,SQ(h)||h.indexOf("file://")===0)return h;if(h==="pino/file")return ly(__dirname,"..","file.js");let p;for(let g of c)try{let _=g==="node:repl"?process.cwd()+EQ:g;p=_Q(_).resolve(h);break}catch{continue}if(!p)throw new Error(`unable to determine transport target for "${h}"`);return p}}FN.exports=IQ;});var td=I((lle,zN)=>{var qN=hN(),{mapHttpRequest:PQ,mapHttpResponse:NQ}=K0(),py=SN(),MN=iy(),{lsCacheSym:DQ,chindingsSym:jN,writeSym:UN,serializersSym:VN,formatOptsSym:$N,endSym:OQ,stringifiersSym:HN,stringifySym:WN,stringifySafeSym:gy,wildcardFirstSym:KN,nestedKeySym:kQ,formattersSym:GN,messageKeySym:LQ,errorKeySym:BQ,nestedKeyStrSym:FQ,msgPrefixSym:Jf}=ho(),{isMainThread:qQ}=he("worker_threads"),MQ=dy();function go(){}function UQ(e,t){if(!t)return r;return function(...i){t.call(this,i,r,e);};function r(n,...i){if(typeof n=="object"){let s=n;n!==null&&(n.method&&n.headers&&n.socket?n=PQ(n):typeof n.setHeader=="function"&&(n=NQ(n)));let a;s===null&&i.length===0?a=[null]:(s=i.shift(),a=i),typeof this[Jf]=="string"&&s!==void 0&&s!==null&&(s=this[Jf]+s),this[UN](n,qN(s,a,this[$N]),e);}else {let s=n===void 0?i.shift():n;typeof this[Jf]=="string"&&s!==void 0&&s!==null&&(s=this[Jf]+s),this[UN](null,qN(s,i,this[$N]),e);}}}function hy(e){let t="",r=0,n=!1,i=255,s=e.length;if(s>100)return JSON.stringify(e);for(var a=0;a<s&&i>=32;a++)i=e.charCodeAt(a),(i===34||i===92)&&(t+=e.slice(r,a)+"\\",r=a,n=!0);return n?t+=e.slice(r):t=e,i<32?JSON.stringify(e):'"'+t+'"'}function $Q(e,t,r,n){let i=this[WN],s=this[gy],a=this[HN],o=this[OQ],c=this[jN],l=this[VN],u=this[GN],f=this[LQ],h=this[BQ],p=this[DQ][r]+n;p=p+c;let g;u.log&&(e=u.log(e));let _=a[KN],E="";for(let y in e)if(g=e[y],Object.prototype.hasOwnProperty.call(e,y)&&g!==void 0){l[y]?g=l[y](g):y===h&&l.err&&(g=l.err(g));let b=a[y]||_;switch(typeof g){case"undefined":case"function":continue;case"number":Number.isFinite(g)===!1&&(g=null);case"boolean":b&&(g=b(g));break;case"string":g=(b||hy)(g);break;default:g=(b||i)(g,s);}if(g===void 0)continue;let N=hy(y);E+=","+N+":"+g;}let w="";if(t!==void 0){g=l[f]?l[f](t):t;let y=a[f]||_;switch(typeof g){case"function":break;case"number":Number.isFinite(g)===!1&&(g=null);case"boolean":y&&(g=y(g)),w=',"'+f+'":'+g;break;case"string":g=(y||hy)(g),w=',"'+f+'":'+g;break;default:g=(y||i)(g,s),w=',"'+f+'":'+g;}}return this[kQ]&&E?p+this[FQ]+E.slice(1)+"}"+w+o:p+E+w+o}function jQ(e,t){let r,n=e[jN],i=e[WN],s=e[gy],a=e[HN],o=a[KN],c=e[VN],l=e[GN].bindings;t=l(t);for(let u in t)if(r=t[u],(u!=="level"&&u!=="serializers"&&u!=="formatters"&&u!=="customLevels"&&t.hasOwnProperty(u)&&r!==void 0)===!0){if(r=c[u]?c[u](r):r,r=(a[u]||o||i)(r,s),r===void 0)continue;n+=',"'+u+'":'+r;}return n}function VQ(e){return e.write!==e.constructor.prototype.write}var HQ=process.env.NODE_V8_COVERAGE||process.env.V8_COVERAGE;function ed(e){let t=new py(e);return t.on("error",r),!HQ&&!e.sync&&qQ&&(MN.register(t,WQ),t.on("close",function(){MN.unregister(t);})),t;function r(n){if(n.code==="EPIPE"){t.write=go,t.end=go,t.flushSync=go,t.destroy=go;return}t.removeListener("error",r),t.emit("error",n);}}function WQ(e,t){e.destroyed||(t==="beforeExit"?(e.flush(),e.on("drain",function(){e.end();})):e.flushSync());}function KQ(e){return function(r,n,i={},s){if(typeof i=="string")s=ed({dest:i}),i={};else if(typeof s=="string"){if(i&&i.transport)throw Error("only one of option.transport or stream can be specified");s=ed({dest:s});}else if(i instanceof py||i.writable||i._writableState)s=i,i={};else if(i.transport){if(i.transport instanceof py||i.transport.writable||i.transport._writableState)throw Error("option.transport do not allow stream, please pass to option directly. e.g. pino(transport)");if(i.transport.targets&&i.transport.targets.length&&i.formatters&&typeof i.formatters.level=="function")throw Error("option.transport.targets do not allow custom level formatters");let c;i.customLevels&&(c=i.useOnlyCustomLevels?i.customLevels:Object.assign({},i.levels,i.customLevels)),s=MQ({caller:n,...i.transport,levels:c});}if(i=Object.assign({},e,i),i.serializers=Object.assign({},e.serializers,i.serializers),i.formatters=Object.assign({},e.formatters,i.formatters),i.prettyPrint)throw new Error("prettyPrint option is no longer supported, see the pino-pretty package (https://github.com/pinojs/pino-pretty)");let{enabled:a,onChild:o}=i;return a===!1&&(i.level="silent"),o||(i.onChild=go),s||(VQ(process.stdout)?s=process.stdout:s=ed({fd:process.stdout.fd||1})),{opts:i,stream:s}}}function GQ(e,t){try{return JSON.stringify(e)}catch{try{return (t||this[gy])(e)}catch{return '"[unable to serialize, circular reference is too complex to analyze]"'}}}function zQ(e,t,r){return {level:e,bindings:t,log:r}}function YQ(e){let t=Number(e);return typeof e=="string"&&Number.isFinite(t)?t:e===void 0?1:e}zN.exports={noop:go,buildSafeSonicBoom:ed,asChindings:jQ,asJson:$Q,genLog:UQ,createArgsNormalizer:KQ,stringify:GQ,buildFormatters:zQ,normalizeDestFileDescriptor:YQ};});var rd=I((fle,QN)=>{var{lsCacheSym:QQ,levelValSym:my,useOnlyCustomLevelsSym:XQ,streamSym:ZQ,formattersSym:JQ,hooksSym:eX}=ho(),{noop:tX,genLog:ua}=td(),ii={trace:10,debug:20,info:30,warn:40,error:50,fatal:60},YN={fatal:e=>{let t=ua(ii.fatal,e);return function(...r){let n=this[ZQ];if(t.call(this,...r),typeof n.flushSync=="function")try{n.flushSync();}catch{}}},error:e=>ua(ii.error,e),warn:e=>ua(ii.warn,e),info:e=>ua(ii.info,e),debug:e=>ua(ii.debug,e),trace:e=>ua(ii.trace,e)},yy=Object.keys(ii).reduce((e,t)=>(e[ii[t]]=t,e),{}),rX=Object.keys(yy).reduce((e,t)=>(e[t]='{"level":'+Number(t),e),{});function nX(e){let t=e[JQ].level,{labels:r}=e.levels,n={};for(let i in r){let s=t(r[i],Number(i));n[i]=JSON.stringify(s).slice(0,-1);}return e[QQ]=n,e}function iX(e,t){if(t)return !1;switch(e){case"fatal":case"error":case"warn":case"info":case"debug":case"trace":return !0;default:return !1}}function sX(e){let{labels:t,values:r}=this.levels;if(typeof e=="number"){if(t[e]===void 0)throw Error("unknown level value"+e);e=t[e];}if(r[e]===void 0)throw Error("unknown level "+e);let n=this[my],i=this[my]=r[e],s=this[XQ],a=this[eX].logMethod;for(let o in r){if(i>r[o]){this[o]=tX;continue}this[o]=iX(o,s)?YN[o](a):ua(r[o],a);}this.emit("level-change",e,i,t[n],n,this);}function aX(e){let{levels:t,levelVal:r}=this;return t&&t.labels?t.labels[r]:""}function oX(e){let{values:t}=this.levels,r=t[e];return r!==void 0&&r>=this[my]}function uX(e=null,t=!1){let r=e?Object.keys(e).reduce((s,a)=>(s[e[a]]=a,s),{}):null,n=Object.assign(Object.create(Object.prototype,{Infinity:{value:"silent"}}),t?null:yy,r),i=Object.assign(Object.create(Object.prototype,{silent:{value:1/0}}),t?null:ii,e);return {labels:n,values:i}}function cX(e,t,r){if(typeof e=="number"){if(![].concat(Object.keys(t||{}).map(s=>t[s]),r?[]:Object.keys(yy).map(s=>+s),1/0).includes(e))throw Error(`default level:${e} must be included in custom levels`);return}let n=Object.assign(Object.create(Object.prototype,{silent:{value:1/0}}),r?null:ii,t);if(!(e in n))throw Error(`default level:${e} must be included in custom levels`)}function lX(e,t){let{labels:r,values:n}=e;for(let i in t){if(i in n)throw Error("levels cannot be overridden");if(t[i]in r)throw Error("pre-existing level values cannot be used for new levels")}}QN.exports={initialLsCache:rX,genLsCache:nX,levelMethods:YN,getLevel:aX,setLevel:sX,isLevelEnabled:oX,mappings:uX,levels:ii,assertNoLevelCollisions:lX,assertDefaultLevelFound:cX};});var vy=I((dle,XN)=>{XN.exports={version:"8.17.1"};});var uD=I((ple,oD)=>{var{EventEmitter:fX}=he("events"),{lsCacheSym:dX,levelValSym:hX,setLevelSym:by,getLevelSym:ZN,chindingsSym:Sy,parsedChindingsSym:pX,mixinSym:gX,asJsonSym:nD,writeSym:mX,mixinMergeStrategySym:yX,timeSym:vX,timeSliceIndexSym:_X,streamSym:iD,serializersSym:ca,formattersSym:_y,errorKeySym:bX,messageKeySym:SX,useOnlyCustomLevelsSym:EX,needsMetadataGsym:wX,redactFmtSym:CX,stringifySym:xX,formatOptsSym:TX,stringifiersSym:AX,msgPrefixSym:JN}=ho(),{getLevel:RX,setLevel:IX,isLevelEnabled:PX,mappings:NX,initialLsCache:DX,genLsCache:OX,assertNoLevelCollisions:kX}=rd(),{asChindings:sD,asJson:LX,buildFormatters:eD,stringify:tD}=td(),{version:BX}=vy(),FX=ey(),qX=class{},aD={constructor:qX,child:MX,bindings:UX,setBindings:$X,flush:WX,isLevelEnabled:PX,version:BX,get level(){return this[ZN]()},set level(e){this[by](e);},get levelVal(){return this[hX]},set levelVal(e){throw Error("levelVal is read-only")},[dX]:DX,[mX]:VX,[nD]:LX,[ZN]:RX,[by]:IX};Object.setPrototypeOf(aD,fX.prototype);oD.exports=function(){return Object.create(aD)};var rD=e=>e;function MX(e,t){if(!e)throw Error("missing bindings for child Pino");t=t||{};let r=this[ca],n=this[_y],i=Object.create(this);if(t.hasOwnProperty("serializers")===!0){i[ca]=Object.create(null);for(let u in r)i[ca][u]=r[u];let c=Object.getOwnPropertySymbols(r);for(var s=0;s<c.length;s++){let u=c[s];i[ca][u]=r[u];}for(let u in t.serializers)i[ca][u]=t.serializers[u];let l=Object.getOwnPropertySymbols(t.serializers);for(var a=0;a<l.length;a++){let u=l[a];i[ca][u]=t.serializers[u];}}else i[ca]=r;if(t.hasOwnProperty("formatters")){let{level:c,bindings:l,log:u}=t.formatters;i[_y]=eD(c||n.level,l||rD,u||n.log);}else i[_y]=eD(n.level,rD,n.log);if(t.hasOwnProperty("customLevels")===!0&&(kX(this.levels,t.customLevels),i.levels=NX(t.customLevels,i[EX]),OX(i)),typeof t.redact=="object"&&t.redact!==null||Array.isArray(t.redact)){i.redact=t.redact;let c=FX(i.redact,tD),l={stringify:c[CX]};i[xX]=tD,i[AX]=c,i[TX]=l;}typeof t.msgPrefix=="string"&&(i[JN]=(this[JN]||"")+t.msgPrefix),i[Sy]=sD(i,e);let o=t.level||this.level;return i[by](o),this.onChild(i),i}function UX(){let t=`{${this[Sy].substr(1)}}`,r=JSON.parse(t);return delete r.pid,delete r.hostname,r}function $X(e){let t=sD(this,e);this[Sy]=t,delete this[pX];}function jX(e,t){return Object.assign(t,e)}function VX(e,t,r){let n=this[vX](),i=this[gX],s=this[bX],a=this[SX],o=this[yX]||jX,c;e==null?c={}:e instanceof Error?(c={[s]:e},t===void 0&&(t=e.message)):(c=e,t===void 0&&e[a]===void 0&&e[s]&&(t=e[s].message)),i&&(c=o(c,i(c,r,this)));let l=this[nD](c,t,r,n),u=this[iD];u[wX]===!0&&(u.lastLevel=r,u.lastObj=c,u.lastMsg=t,u.lastTime=n.slice(this[_X]),u.lastLogger=this),u.write(l);}function HX(){}function WX(e){if(e!=null&&typeof e!="function")throw Error("callback must be a function");let t=this[iD];typeof t.flush=="function"?t.flush(e||HX):e&&e();}});var hD=I((xy,dD)=>{var{hasOwnProperty:nd}=Object.prototype,fa=Cy();fa.configure=Cy;fa.stringify=fa;fa.default=fa;xy.stringify=fa;xy.configure=Cy;dD.exports=fa;var KX=/[\u0000-\u001f\u0022\u005c\ud800-\udfff]|[\ud800-\udbff](?![\udc00-\udfff])|(?:[^\ud800-\udbff]|^)[\udc00-\udfff]/;function gs(e){return e.length<5e3&&!KX.test(e)?`"${e}"`:JSON.stringify(e)}function Ey(e){if(e.length>200)return e.sort();for(let t=1;t<e.length;t++){let r=e[t],n=t;for(;n!==0&&e[n-1]>r;)e[n]=e[n-1],n--;e[n]=r;}return e}var GX=Object.getOwnPropertyDescriptor(Object.getPrototypeOf(Object.getPrototypeOf(new Int8Array)),Symbol.toStringTag).get;function wy(e){return GX.call(e)!==void 0&&e.length!==0}function cD(e,t,r){e.length<r&&(r=e.length);let n=t===","?"":" ",i=`"0":${n}${e[0]}`;for(let s=1;s<r;s++)i+=`${t}"${s}":${n}${e[s]}`;return i}function zX(e){if(nd.call(e,"circularValue")){let t=e.circularValue;if(typeof t=="string")return `"${t}"`;if(t==null)return t;if(t===Error||t===TypeError)return {toString(){throw new TypeError("Converting circular structure to JSON")}};throw new TypeError('The "circularValue" argument must be of type string or the value null or undefined')}return '"[Circular]"'}function lD(e,t){let r;if(nd.call(e,t)&&(r=e[t],typeof r!="boolean"))throw new TypeError(`The "${t}" argument must be of type boolean`);return r===void 0?!0:r}function fD(e,t){let r;if(nd.call(e,t)){if(r=e[t],typeof r!="number")throw new TypeError(`The "${t}" argument must be of type number`);if(!Number.isInteger(r))throw new TypeError(`The "${t}" argument must be an integer`);if(r<1)throw new RangeError(`The "${t}" argument must be >= 1`)}return r===void 0?1/0:r}function la(e){return e===1?"1 item":`${e} items`}function YX(e){let t=new Set;for(let r of e)(typeof r=="string"||typeof r=="number")&&t.add(String(r));return t}function QX(e){if(nd.call(e,"strict")){let t=e.strict;if(typeof t!="boolean")throw new TypeError('The "strict" argument must be of type boolean');if(t)return r=>{let n=`Object can not safely be stringified. Received type ${typeof r}`;throw typeof r!="function"&&(n+=` (${r.toString()})`),new Error(n)}}}function Cy(e){e={...e};let t=QX(e);t&&(e.bigint===void 0&&(e.bigint=!1),"circularValue"in e||(e.circularValue=Error));let r=zX(e),n=lD(e,"bigint"),i=lD(e,"deterministic"),s=fD(e,"maximumDepth"),a=fD(e,"maximumBreadth");function o(h,p,g,_,E,w){let y=p[h];switch(typeof y=="object"&&y!==null&&typeof y.toJSON=="function"&&(y=y.toJSON(h)),y=_.call(p,h,y),typeof y){case"string":return gs(y);case"object":{if(y===null)return "null";if(g.indexOf(y)!==-1)return r;let b="",N=",",L=w;if(Array.isArray(y)){if(y.length===0)return "[]";if(s<g.length+1)return '"[Array]"';g.push(y),E!==""&&(w+=E,b+=`
${w}`,N=`,
${w}`);let U=Math.min(y.length,a),ie=0;for(;ie<U-1;ie++){let Pe=o(String(ie),y,g,_,E,w);b+=Pe!==void 0?Pe:"null",b+=N;}let me=o(String(ie),y,g,_,E,w);if(b+=me!==void 0?me:"null",y.length-1>a){let Pe=y.length-a-1;b+=`${N}"... ${la(Pe)} not stringified"`;}return E!==""&&(b+=`
${L}`),g.pop(),`[${b}]`}let V=Object.keys(y),Z=V.length;if(Z===0)return "{}";if(s<g.length+1)return '"[Object]"';let G="",z="";E!==""&&(w+=E,N=`,
${w}`,G=" ");let ee=Math.min(Z,a);i&&!wy(y)&&(V=Ey(V)),g.push(y);for(let U=0;U<ee;U++){let ie=V[U],me=o(ie,y,g,_,E,w);me!==void 0&&(b+=`${z}${gs(ie)}:${G}${me}`,z=N);}if(Z>a){let U=Z-a;b+=`${z}"...":${G}"${la(U)} not stringified"`,z=N;}return E!==""&&z.length>1&&(b=`
${w}${b}
${L}`),g.pop(),`{${b}}`}case"number":return isFinite(y)?String(y):t?t(y):"null";case"boolean":return y===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(y);default:return t?t(y):void 0}}function c(h,p,g,_,E,w){switch(typeof p=="object"&&p!==null&&typeof p.toJSON=="function"&&(p=p.toJSON(h)),typeof p){case"string":return gs(p);case"object":{if(p===null)return "null";if(g.indexOf(p)!==-1)return r;let y=w,b="",N=",";if(Array.isArray(p)){if(p.length===0)return "[]";if(s<g.length+1)return '"[Array]"';g.push(p),E!==""&&(w+=E,b+=`
${w}`,N=`,
${w}`);let Z=Math.min(p.length,a),G=0;for(;G<Z-1;G++){let ee=c(String(G),p[G],g,_,E,w);b+=ee!==void 0?ee:"null",b+=N;}let z=c(String(G),p[G],g,_,E,w);if(b+=z!==void 0?z:"null",p.length-1>a){let ee=p.length-a-1;b+=`${N}"... ${la(ee)} not stringified"`;}return E!==""&&(b+=`
${y}`),g.pop(),`[${b}]`}g.push(p);let L="";E!==""&&(w+=E,N=`,
${w}`,L=" ");let V="";for(let Z of _){let G=c(Z,p[Z],g,_,E,w);G!==void 0&&(b+=`${V}${gs(Z)}:${L}${G}`,V=N);}return E!==""&&V.length>1&&(b=`
${w}${b}
${y}`),g.pop(),`{${b}}`}case"number":return isFinite(p)?String(p):t?t(p):"null";case"boolean":return p===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(p);default:return t?t(p):void 0}}function l(h,p,g,_,E){switch(typeof p){case"string":return gs(p);case"object":{if(p===null)return "null";if(typeof p.toJSON=="function"){if(p=p.toJSON(h),typeof p!="object")return l(h,p,g,_,E);if(p===null)return "null"}if(g.indexOf(p)!==-1)return r;let w=E;if(Array.isArray(p)){if(p.length===0)return "[]";if(s<g.length+1)return '"[Array]"';g.push(p),E+=_;let G=`
${E}`,z=`,
${E}`,ee=Math.min(p.length,a),U=0;for(;U<ee-1;U++){let me=l(String(U),p[U],g,_,E);G+=me!==void 0?me:"null",G+=z;}let ie=l(String(U),p[U],g,_,E);if(G+=ie!==void 0?ie:"null",p.length-1>a){let me=p.length-a-1;G+=`${z}"... ${la(me)} not stringified"`;}return G+=`
${w}`,g.pop(),`[${G}]`}let y=Object.keys(p),b=y.length;if(b===0)return "{}";if(s<g.length+1)return '"[Object]"';E+=_;let N=`,
${E}`,L="",V="",Z=Math.min(b,a);wy(p)&&(L+=cD(p,N,a),y=y.slice(p.length),Z-=p.length,V=N),i&&(y=Ey(y)),g.push(p);for(let G=0;G<Z;G++){let z=y[G],ee=l(z,p[z],g,_,E);ee!==void 0&&(L+=`${V}${gs(z)}: ${ee}`,V=N);}if(b>a){let G=b-a;L+=`${V}"...": "${la(G)} not stringified"`,V=N;}return V!==""&&(L=`
${E}${L}
${w}`),g.pop(),`{${L}}`}case"number":return isFinite(p)?String(p):t?t(p):"null";case"boolean":return p===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(p);default:return t?t(p):void 0}}function u(h,p,g){switch(typeof p){case"string":return gs(p);case"object":{if(p===null)return "null";if(typeof p.toJSON=="function"){if(p=p.toJSON(h),typeof p!="object")return u(h,p,g);if(p===null)return "null"}if(g.indexOf(p)!==-1)return r;let _="";if(Array.isArray(p)){if(p.length===0)return "[]";if(s<g.length+1)return '"[Array]"';g.push(p);let N=Math.min(p.length,a),L=0;for(;L<N-1;L++){let Z=u(String(L),p[L],g);_+=Z!==void 0?Z:"null",_+=",";}let V=u(String(L),p[L],g);if(_+=V!==void 0?V:"null",p.length-1>a){let Z=p.length-a-1;_+=`,"... ${la(Z)} not stringified"`;}return g.pop(),`[${_}]`}let E=Object.keys(p),w=E.length;if(w===0)return "{}";if(s<g.length+1)return '"[Object]"';let y="",b=Math.min(w,a);wy(p)&&(_+=cD(p,",",a),E=E.slice(p.length),b-=p.length,y=","),i&&(E=Ey(E)),g.push(p);for(let N=0;N<b;N++){let L=E[N],V=u(L,p[L],g);V!==void 0&&(_+=`${y}${gs(L)}:${V}`,y=",");}if(w>a){let N=w-a;_+=`${y}"...":"${la(N)} not stringified"`;}return g.pop(),`{${_}}`}case"number":return isFinite(p)?String(p):t?t(p):"null";case"boolean":return p===!0?"true":"false";case"undefined":return;case"bigint":if(n)return String(p);default:return t?t(p):void 0}}function f(h,p,g){if(arguments.length>1){let _="";if(typeof g=="number"?_=" ".repeat(Math.min(g,10)):typeof g=="string"&&(_=g.slice(0,10)),p!=null){if(typeof p=="function")return o("",{"":h},[],p,_,"");if(Array.isArray(p))return c("",h,[],YX(p),_,"")}if(_.length!==0)return l("",h,[],_,"")}return u("",h,[])}return f}});var mD=I((gle,gD)=>{var Ty=Symbol.for("pino.metadata"),{levels:pD}=rd(),XX=pD.info;function ZX(e,t){let r=0;e=e||[],t=t||{dedupe:!1};let n=Object.create(pD);n.silent=1/0,t.levels&&typeof t.levels=="object"&&Object.keys(t.levels).forEach(u=>{n[u]=t.levels[u];});let i={write:s,add:o,flushSync:a,end:c,minLevel:0,streams:[],clone:l,[Ty]:!0,streamLevels:n};return Array.isArray(e)?e.forEach(o,i):o.call(i,e),e=null,i;function s(u){let f,h=this.lastLevel,{streams:p}=this,g=0,_;for(let E=eZ(p.length,t.dedupe);rZ(E,p.length,t.dedupe);E=tZ(E,t.dedupe))if(f=p[E],f.level<=h){if(g!==0&&g!==f.level)break;if(_=f.stream,_[Ty]){let{lastTime:w,lastMsg:y,lastObj:b,lastLogger:N}=this;_.lastLevel=h,_.lastTime=w,_.lastMsg=y,_.lastObj=b,_.lastLogger=N;}_.write(u),t.dedupe&&(g=f.level);}else if(!t.dedupe)break}function a(){for(let{stream:u}of this.streams)typeof u.flushSync=="function"&&u.flushSync();}function o(u){if(!u)return i;let f=typeof u.write=="function"||u.stream,h=u.write?u:u.stream;if(!f)throw Error("stream object needs to implement either StreamEntry or DestinationStream interface");let{streams:p,streamLevels:g}=this,_;typeof u.levelVal=="number"?_=u.levelVal:typeof u.level=="string"?_=g[u.level]:typeof u.level=="number"?_=u.level:_=XX;let E={stream:h,level:_,levelVal:void 0,id:r++};return p.unshift(E),p.sort(JX),this.minLevel=p[0].level,i}function c(){for(let{stream:u}of this.streams)typeof u.flushSync=="function"&&u.flushSync(),u.end();}function l(u){let f=new Array(this.streams.length);for(let h=0;h<f.length;h++)f[h]={level:u,stream:this.streams[h].stream};return {write:s,add:o,minLevel:u,streams:f,clone:l,flushSync:a,[Ty]:!0}}}function JX(e,t){return e.level-t.level}function eZ(e,t){return t?e-1:0}function tZ(e,t){return t?e-1:e+1}function rZ(e,t,r){return r?e>=0:e<t}gD.exports=ZX;});var ID=I((mle,Bn)=>{var nZ=he("os"),CD=K0(),iZ=G0(),sZ=ey(),xD=fN(),aZ=uD(),TD=ho(),{configure:oZ}=hD(),{assertDefaultLevelFound:uZ,mappings:AD,genLsCache:cZ,levels:lZ}=rd(),{createArgsNormalizer:fZ,asChindings:dZ,buildSafeSonicBoom:yD,buildFormatters:hZ,stringify:Ay,normalizeDestFileDescriptor:vD,noop:pZ}=td(),{version:gZ}=vy(),{chindingsSym:_D,redactFmtSym:mZ,serializersSym:bD,timeSym:yZ,timeSliceIndexSym:vZ,streamSym:_Z,stringifySym:SD,stringifySafeSym:Ry,stringifiersSym:ED,setLevelSym:bZ,endSym:SZ,formatOptsSym:EZ,messageKeySym:wZ,errorKeySym:CZ,nestedKeySym:xZ,mixinSym:TZ,useOnlyCustomLevelsSym:AZ,formattersSym:wD,hooksSym:RZ,nestedKeyStrSym:IZ,mixinMergeStrategySym:PZ,msgPrefixSym:NZ}=TD,{epochTime:RD,nullTime:DZ}=xD,{pid:OZ}=process,kZ=nZ.hostname(),LZ=CD.err,BZ={level:"info",levels:lZ,messageKey:"msg",errorKey:"err",nestedKey:null,enabled:!0,base:{pid:OZ,hostname:kZ},serializers:Object.assign(Object.create(null),{err:LZ}),formatters:Object.assign(Object.create(null),{bindings(e){return e},level(e,t){return {level:t}}}),hooks:{logMethod:void 0},timestamp:RD,name:void 0,redact:null,customLevels:null,useOnlyCustomLevels:!1,depthLimit:5,edgeLimit:100},FZ=fZ(BZ),qZ=Object.assign(Object.create(null),CD);function Iy(...e){let t={},{opts:r,stream:n}=FZ(t,iZ(),...e),{redact:i,crlf:s,serializers:a,timestamp:o,messageKey:c,errorKey:l,nestedKey:u,base:f,name:h,level:p,customLevels:g,mixin:_,mixinMergeStrategy:E,useOnlyCustomLevels:w,formatters:y,hooks:b,depthLimit:N,edgeLimit:L,onChild:V,msgPrefix:Z}=r,G=oZ({maximumDepth:N,maximumBreadth:L}),z=hZ(y.level,y.bindings,y.log),ee=Ay.bind({[Ry]:G}),U=i?sZ(i,ee):{},ie=i?{stringify:U[mZ]}:{stringify:ee},me="}"+(s?`\r
`:`
`),Pe=dZ.bind(null,{[_D]:"",[bD]:a,[ED]:U,[SD]:Ay,[Ry]:G,[wD]:z}),W="";f!==null&&(h===void 0?W=Pe(f):W=Pe(Object.assign({},f,{name:h})));let K=o instanceof Function?o:o?RD:DZ,se=K().indexOf(":")+1;if(w&&!g)throw Error("customLevels is required if useOnlyCustomLevels is set true");if(_&&typeof _!="function")throw Error(`Unknown mixin type "${typeof _}" - expected "function"`);if(Z&&typeof Z!="string")throw Error(`Unknown msgPrefix type "${typeof Z}" - expected "string"`);uZ(p,g,w);let Ae=AD(g,w);return Object.assign(t,{levels:Ae,[AZ]:w,[_Z]:n,[yZ]:K,[vZ]:se,[SD]:Ay,[Ry]:G,[ED]:U,[SZ]:me,[EZ]:ie,[wZ]:c,[CZ]:l,[xZ]:u,[IZ]:u?`,${JSON.stringify(u)}:{`:"",[bD]:a,[TZ]:_,[PZ]:E,[_D]:W,[wD]:z,[RZ]:b,silent:pZ,onChild:V,[NZ]:Z}),Object.setPrototypeOf(t,aZ()),cZ(t),t[bZ](p),t}Bn.exports=Iy;Bn.exports.destination=(e=process.stdout.fd)=>typeof e=="object"?(e.dest=vD(e.dest||process.stdout.fd),yD(e)):yD({dest:vD(e),minLength:0});Bn.exports.transport=dy();Bn.exports.multistream=mD();Bn.exports.levels=AD();Bn.exports.stdSerializers=qZ;Bn.exports.stdTimeFunctions=Object.assign({},xD);Bn.exports.symbols=TD;Bn.exports.version=gZ;Bn.exports.default=Iy;Bn.exports.pino=Iy;});var rc=I(ms=>{Object.defineProperty(ms,"__esModule",{value:!0});ms.Frequency=ms.KeepLogFiles=void 0;(function(e){e[e.days=1]="days",e[e.fileCount=2]="fileCount";})(ms.KeepLogFiles||(ms.KeepLogFiles={}));(function(e){e[e.daily=1]="daily",e[e.minutes=2]="minutes",e[e.hours=3]="hours",e[e.date=4]="date",e[e.none=5]="none";})(ms.Frequency||(ms.Frequency={}));});var ND=I(Ny=>{Object.defineProperty(Ny,"__esModule",{value:!0});var PD=rc(),Py=class{static fileStreamRotatorOptions(t){return Object.assign(Object.assign({},{filename:"",verbose:!1,end_stream:!1,utc:!1,create_symlink:!1,symlink_name:"current.log"}),t)}static fileOptions(t){return Object.assign(Object.assign({},{flags:"a"}),t)}static auditSettings(t){let r={keepSettings:{type:PD.KeepLogFiles.fileCount,amount:10},auditFilename:"audit.json",hashType:"md5",extension:"",files:[]};return Object.assign(Object.assign({},r),t)}static rotationSettings(t){let r={filename:"",frequency:PD.Frequency.none,utc:!1};return Object.assign(Object.assign({},r),t)}static extractParam(t,r=!0){let n=t.toString().match(/(\w)$/),i={number:0};n?.length==2&&(i.letter=n[1].toLowerCase());let s=t.toString().match(/^(\d+)/);return s?.length==2&&(i.number=Number(s[1])),i}};Ny.default=Py;});var id=I(mo=>{Object.defineProperty(mo,"__esModule",{value:!0});mo.Logger=mo.makeDirectory=void 0;var $Z=he("fs"),jZ=he("path");function VZ(e){if(e.trim()!==""){var t=jZ.dirname(e);try{$Z.mkdirSync(t,{recursive:!0});}catch(r){if(r.code!=="EEXIST")throw r}}}mo.makeDirectory=VZ;var Dy=class e{constructor(){this.isVerbose=!1,this.allowDebug=!1;}static getInstance(t,r){return e.instance||(e.instance=new e,e.instance.isVerbose=t??!1,e.instance.allowDebug=r??!1),e.instance}static verbose(...t){e.getInstance().isVerbose&&console.log.apply(null,[new Date,"[FileStreamRotator:VERBOSE]",...t]);}static log(...t){console.log.apply(null,[new Date,"[FileStreamRotator]",...t]);}static debug(...t){e.getInstance().allowDebug&&console.debug.apply(null,[new Date,"[FileStreamRotator:DEBUG]",...t]);}};mo.Logger=Dy;});var OD=I(ky=>{Object.defineProperty(ky,"__esModule",{value:!0});var DD=he("fs"),wn=rc(),da=id(),Oy=class e{constructor(t,r){var n;switch(this.currentSize=0,this.lastDate="",this.fileIndx=0,this.settings=t,this.settings.frequency){case wn.Frequency.hours:this.settings.amount&&this.settings.amount<13?this.settings.amount&&this.settings.amount>0||(this.settings.amount=1):this.settings.amount=12,this.isFormatValidForHour()||(da.Logger.log("Date format not suitable for X hours rotation. Changing date format to 'YMDHm'"),this.settings.format="YMDHm");break;case wn.Frequency.minutes:this.settings.amount&&this.settings.amount<31?this.settings.amount&&this.settings.amount>0||(this.settings.amount=1):this.settings.amount=30,this.isFormatValidForMinutes()||(this.settings.format="YMDHm",da.Logger.log("Date format not suitable for X minutes rotation. Changing date format to 'YMDHm'"));break;case wn.Frequency.daily:this.isFormatValidForDaily()||(this.settings.format="YMD",da.Logger.log("Date format not suitable for daily rotation. Changing date format to 'YMD'"));break}if(this.settings.frequency!==wn.Frequency.none&&!this.settings.filename.match("%DATE%")&&(this.settings.filename+=".%DATE%",da.Logger.log("Appending date to the end of the filename")),this.lastDate=this.getDateString(),this.settings.maxSize&&r){let s=new Date(r.date),a=(n=this.settings.extension)!==null&&n!==void 0?n:"";if(da.Logger.debug(this.getDateString(s)==this.getDateString(new Date),this.getDateString(s),this.getDateString(new Date)),this.getDateString(s)==this.getDateString(new Date)){let o=r.name.match(RegExp("(\\d+)"+a.replace(/[.*+?^${}()|[\]\\]/g,"\\$&")));o&&(this.fileIndx=Number(o[1]));var i=this.getSizeForFile(this.getNewFilename());i&&(this.currentSize=i),this.lastDate=this.getDateString(s),da.Logger.debug("LOADED LAST ENTRY",this.currentSize,this.lastDate,this.fileIndx);}else {var i=this.getSizeForFile(this.getNewFilename());i&&(this.currentSize=i),da.Logger.debug("CURRENT FILE:",this.getNewFilename(),this.currentSize);}}}getSizeForFile(t){try{if(DD.existsSync(t)){var r=DD.statSync(this.getNewFilename());if(r)return r.size}}catch{return}}hasMaxSizeReached(){return this.settings.maxSize?this.currentSize>this.settings.maxSize:!1}shouldRotate(){let t=this.hasMaxSizeReached();switch(this.settings.frequency){case wn.Frequency.none:return t;case wn.Frequency.hours:case wn.Frequency.minutes:case wn.Frequency.date:case wn.Frequency.daily:default:let r=this.getDateString();return this.lastDate!=r?!0:t}}isFormatValidForDaily(){let t=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,23,55,45),n=new Date(2022,2,21,2,55,45);return this.getDateString(t)===this.getDateString(r)&&this.getDateString(t)!==this.getDateString(n)}isFormatValidForHour(){if(!this.settings.amount||this.settings.frequency!=wn.Frequency.hours)return !1;let t=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,2+this.settings.amount,55,45);return this.getDateString(t)!==this.getDateString(r)}isFormatValidForMinutes(){if(!this.settings.amount||this.settings.frequency!=wn.Frequency.minutes)return !1;let t=new Date(2022,2,20,1,2,3),r=new Date(2022,2,20,1,2+this.settings.amount,45);return this.getDateString(t)!==this.getDateString(r)}getDateString(t){let r=t||new Date,n=e.getDateComponents(r,this.settings.utc),i=this.settings.format;if(i){switch(this.settings.frequency){case wn.Frequency.hours:if(this.settings.amount){var s=Math.floor(n.hour/this.settings.amount)*this.settings.amount;n.hour=s,n.minute=0,n.second=0;}case wn.Frequency.minutes:if(this.settings.amount){var a=Math.floor(n.minute/this.settings.amount)*this.settings.amount;n.minute=a,n.second=0;}}return i?.replace(/D+/,n.day.toString().padStart(2,"0")).replace(/M+/,n.month.toString().padStart(2,"0")).replace(/Y+/,n.year.toString()).replace(/H+/,n.hour.toString().padStart(2,"0")).replace(/m+/,n.minute.toString().padStart(2,"0")).replace(/s+/,n.second.toString().padStart(2,"0")).replace(/A+/,n.hour>11?"PM":"AM")}return ""}getFilename(t,r){return t.replace("%DATE%",this.lastDate)+(this.settings.maxSize||this.fileIndx>0?"."+this.fileIndx:"")+(r||"")}getNewFilename(){return this.getFilename(this.settings.filename,this.settings.extension)}addBytes(t){this.currentSize+=t;}rotate(t=!1){return t?(this.fileIndx+=1,this.currentSize=0,this.lastDate=this.getDateString()):this.shouldRotate()&&(this.hasMaxSizeReached()?this.fileIndx+=1:this.fileIndx=0,this.currentSize=0,this.lastDate=this.getDateString()),this.getNewFilename()}static getDateComponents(t,r){return r?{day:t.getUTCDate(),month:t.getUTCMonth()+1,year:t.getUTCFullYear(),hour:t.getUTCHours(),minute:t.getUTCMinutes(),second:t.getUTCSeconds(),utc:r,source:t}:{day:t.getDate(),month:t.getMonth()+1,year:t.getFullYear(),hour:t.getHours(),minute:t.getMinutes(),second:t.getSeconds(),utc:r,source:t}}static createDate(t,r){return new Date(t.year,t.month,t.day,t.hour,t.minute,t.second)}};ky.default=Oy;});var kD=I(Fy=>{Object.defineProperty(Fy,"__esModule",{value:!0});var sd=he("fs"),HZ=he("path"),WZ=rc(),_i=id(),Ly=he("crypto"),By=class{constructor(t,r){this.config=t,this.emitter=r,this.loadLog();}loadLog(){var t;if(!this.config.keepSettings||((t=this.config.keepSettings)===null||t===void 0?void 0:t.amount)==0||!this.config.auditFilename||this.config.auditFilename==""){_i.Logger.verbose("no existing audit settings found",this.config);return}try{let r=HZ.resolve(this.config.auditFilename),n=JSON.parse(sd.readFileSync(r,{encoding:"utf-8"}));this.config.files=n.files;}catch(r){if(r.code!=="ENOENT"){_i.Logger.log("Failed to load config file",r);return}}}writeLog(){if(this.config.auditFilename)try{(0, _i.makeDirectory)(this.config.auditFilename),sd.writeFileSync(this.config.auditFilename,JSON.stringify(this.config,null,4));}catch(t){_i.Logger.verbose("ERROR: Failed to store log audit",t);}}addLog(t){var r;if(!this.config.keepSettings||((r=this.config.keepSettings)===null||r===void 0?void 0:r.amount)==0||!this.config.auditFilename||this.config.auditFilename==""){_i.Logger.verbose("audit log missing");return}if(this.config.files.findIndex(s=>s.name===t)!==-1){_i.Logger.debug("file already in the log",t);return}var n=Date.now();if(this.config.files.push({date:n,name:t,hash:Ly.createHash(this.config.hashType).update(t+"LOG_FILE"+n).digest("hex")}),_i.Logger.debug(`added file ${t} to log`),this.config.keepSettings&&this.config.keepSettings.amount){if(this.config.keepSettings.type==WZ.KeepLogFiles.days){let s=Date.now()-86400*this.config.keepSettings.amount*1e3,a=this.config.files.filter(o=>{if(o.date>=s)return !0;this.removeLog(o);});this.config.files=a;}else if(this.config.files.length>this.config.keepSettings.amount){var i=this.config.files.splice(-this.config.keepSettings.amount);this.config.files.length>0&&this.config.files.filter(s=>(this.removeLog(s),!1)),this.config.files=i;}}this.writeLog();}removeLog(t){if(t.hash===Ly.createHash(this.config.hashType).update(t.name+"LOG_FILE"+t.date).digest("hex"))try{sd.existsSync(t.name)&&(_i.Logger.debug("removing log file",t.name),sd.unlinkSync(t.name),this.emitter.emit("logRemoved",t.name));}catch{_i.Logger.verbose("Could not remove old log file: ",t.name);}else _i.Logger.debug("incorrect hash",t.name,t.hash,Ly.createHash(this.config.hashType).update(t.name+"LOG_FILE"+t.date).digest("hex"));}};Fy.default=By;});var BD=I(Uy=>{Object.defineProperty(Uy,"__esModule",{value:!0});var KZ=he("stream"),yo=he("fs"),qy=he("path"),Wi=rc(),Ki=ND(),LD=OD(),GZ=kD(),nc=id(),My=class e extends KZ.EventEmitter{constructor(t,r=!1){var n,i;super(),this.config={},this.config=this.parseOptions(t),nc.Logger.getInstance(t.verbose,r),this.auditManager=new GZ.default((n=this.config.auditSettings)!==null&&n!==void 0?n:Ki.default.auditSettings({}),this);let s=this.auditManager.config.files.slice(-1).shift();this.rotator=new LD.default((i=this.config.rotationSettings)!==null&&i!==void 0?i:Ki.default.rotationSettings({}),s),this.rotate();}static getStream(t){return new e(t)}parseOptions(t){var r,n,i,s;let a={};a.options=Ki.default.fileStreamRotatorOptions(t),a.fileOptions=Ki.default.fileOptions((r=t.file_options)!==null&&r!==void 0?r:{});let o=Ki.default.auditSettings({});if(t.audit_file&&(o.auditFilename=t.audit_file),t.audit_hash_type&&(o.hashType=t.audit_hash_type),t.extension&&(o.extension=t.extension),t.max_logs){let l=Ki.default.extractParam(t.max_logs);o.keepSettings={type:((n=l.letter)===null||n===void 0?void 0:n.toLowerCase())=="d"?Wi.KeepLogFiles.days:Wi.KeepLogFiles.fileCount,amount:l.number};}switch(a.auditSettings=o,a.rotationSettings=Ki.default.rotationSettings({filename:t.filename,extension:t.extension}),t.date_format&&!t.frequency?a.rotationSettings.frequency=Wi.Frequency.date:a.rotationSettings.frequency=Wi.Frequency.none,t.date_format&&(a.rotationSettings.format=t.date_format),a.rotationSettings.utc=(i=t.utc)!==null&&i!==void 0?i:!1,t.frequency){case"daily":a.rotationSettings.frequency=Wi.Frequency.daily;break;case"custom":case"date":a.rotationSettings.frequency=Wi.Frequency.date;break;case"test":a.rotationSettings.frequency=Wi.Frequency.minutes,a.rotationSettings.amount=1;break;default:if(t.frequency){let l=Ki.default.extractParam(t.frequency);!((s=l.letter)===null||s===void 0)&&s.match(/^([mh])$/)&&(a.rotationSettings.frequency=l.letter=="h"?Wi.Frequency.hours:Wi.Frequency.minutes,a.rotationSettings.amount=l.number);}}if(t.size){let l=Ki.default.extractParam(t.size);switch(l.letter){case"k":a.rotationSettings.maxSize=l.number*1024;break;case"m":a.rotationSettings.maxSize=l.number*1024*1024;break;case"g":a.rotationSettings.maxSize=l.number*1024*1024*1024;break}}this.rotator=new LD.default(a.rotationSettings);this.rotator.getNewFilename();return a}rotate(t=!1){var r;let n=this.currentFile;this.rotator.rotate(t),this.currentFile=this.rotator.getNewFilename(),this.currentFile!=n&&(this.fs&&(((r=this.config.options)===null||r===void 0?void 0:r.end_stream)===!0?this.fs.end():this.fs.destroy()),n&&this.auditManager.addLog(n),this.createNewLog(this.currentFile),this.emit("new",this.currentFile),this.emit("rotate",n,this.currentFile,t));}createNewLog(t){var r;(0, nc.makeDirectory)(t),this.auditManager.addLog(t);let n={};this.config.fileOptions&&(n=this.config.fileOptions),this.fs=yo.createWriteStream(t,n),this.bubbleEvents(this.fs,t),!((r=this.config.options)===null||r===void 0)&&r.create_symlink&&this.createCurrentSymLink(t);}write(t,r){this.fs&&(this.rotator.shouldRotate()&&this.rotate(),this.fs.write(t,r??"utf8"),this.rotator.addBytes(Buffer.byteLength(t,r)),this.rotator.hasMaxSizeReached()&&this.rotate());}end(t){this.fs&&(this.fs.end(t),this.fs=void 0);}bubbleEvents(t,r){t.on("close",()=>{this.emit("close");}),t.on("finish",()=>{this.emit("finish");}),t.on("error",n=>{this.emit("error",n);}),t.on("open",n=>{this.emit("open",r);});}createCurrentSymLink(t){var r,n;if(!t)return;let i=(n=(r=this.config.options)===null||r===void 0?void 0:r.symlink_name)!==null&&n!==void 0?n:"current.log",s=qy.dirname(t),a=qy.basename(t),o=s+qy.sep+i;try{if(yo.existsSync(o)){if(yo.lstatSync(o).isSymbolicLink()){yo.unlinkSync(o),yo.symlinkSync(a,o);return}nc.Logger.verbose("Could not create symlink file as file with the same name exists: ",o);}else yo.symlinkSync(a,o);}catch(c){nc.Logger.verbose("[Could not create symlink file: ",o," -> ",a),nc.Logger.debug("error creating sym link",o,c);}}test(){return {config:this.config,rotator:this.rotator}}};Uy.default=My;});var FD=I(ad=>{Object.defineProperty(ad,"__esModule",{value:!0});ad.getStream=void 0;var zZ=BD();function YZ(e){return new zZ.default(e)}ad.getStream=YZ;});var HD=I((Lle,VD)=>{VD.exports=function(){function e(n,i){function s(){this.constructor=n;}s.prototype=i.prototype,n.prototype=new s;}function t(n,i,s,a,o,c){this.message=n,this.expected=i,this.found=s,this.offset=a,this.line=o,this.column=c,this.name="SyntaxError";}e(t,Error);function r(n){var i=arguments.length>1?arguments[1]:{},s={},a={start:QS},o=QS,l=function(){return gE},u=s,f="#",h={type:"literal",value:"#",description:'"#"'},p=void 0,g={type:"any",description:"any character"},_="[",E={type:"literal",value:"[",description:'"["'},w="]",y={type:"literal",value:"]",description:'"]"'},b=function(d){Mp(Ar("ObjectPath",d,xr,Tr));},N=function(d){Mp(Ar("ArrayPath",d,xr,Tr));},L=function(d,v){return d.concat(v)},V=function(d){return [d]},Z=function(d){return d},G=".",z={type:"literal",value:".",description:'"."'},ee="=",U={type:"literal",value:"=",description:'"="'},ie=function(d,v){Mp(Ar("Assign",v,xr,Tr,d));},me=function(d){return d.join("")},Pe=function(d){return d.value},W='"""',K={type:"literal",value:'"""',description:'"\\"\\"\\""'},se=null,Ae=function(d){return Ar("String",d.join(""),xr,Tr)},Me='"',ze={type:"literal",value:'"',description:'"\\""'},We="'''",lt={type:"literal",value:"'''",description:`"'''"`},Bt="'",Ct={type:"literal",value:"'",description:`"'"`},pt=function(d){return d},Be=function(d){return d},Dt="\\",Vt={type:"literal",value:"\\",description:'"\\\\"'},ye=function(){return ""},Ve="e",le={type:"literal",value:"e",description:'"e"'},Ie="E",Ke={type:"literal",value:"E",description:'"E"'},nt=function(d,v){return Ar("Float",parseFloat(d+"e"+v),xr,Tr)},Ye=function(d){return Ar("Float",parseFloat(d),xr,Tr)},Rn="+",$r={type:"literal",value:"+",description:'"+"'},Vs=function(d){return d.join("")},jr="-",tn={type:"literal",value:"-",description:'"-"'},Hs=function(d){return "-"+d.join("")},Ba=function(d){return Ar("Integer",parseInt(d,10),xr,Tr)},mn="true",Ws={type:"literal",value:"true",description:'"true"'},Ks=function(){return Ar("Boolean",!0,xr,Tr)},ki="false",Gs={type:"literal",value:"false",description:'"false"'},Yn=function(){return Ar("Boolean",!1,xr,Tr)},q=function(){return Ar("Array",[],xr,Tr)},ae=function(d){return Ar("Array",d?[d]:[],xr,Tr)},Se=function(d){return Ar("Array",d,xr,Tr)},Ne=function(d,v){return Ar("Array",d.concat(v),xr,Tr)},xt=function(d){return d},vt=",",Ot={type:"literal",value:",",description:'","'},qt="{",it={type:"literal",value:"{",description:'"{"'},It="}",gt={type:"literal",value:"}",description:'"}"'},zt=function(d){return Ar("InlineTable",d,xr,Tr)},nr=function(d,v){return Ar("InlineTableValue",v,xr,Tr,d)},Vr=function(d){return "."+d},Fa=function(d){return d.join("")},es=":",ts={type:"literal",value:":",description:'":"'},su=function(d){return d.join("")},au="T",tl={type:"literal",value:"T",description:'"T"'},X="Z",A={type:"literal",value:"Z",description:'"Z"'},M=function(d,v){return Ar("Date",new Date(d+"T"+v+"Z"),xr,Tr)},$=function(d,v){return Ar("Date",new Date(d+"T"+v),xr,Tr)},D=/^[ \t]/,S={type:"class",value:"[ \\t]",description:"[ \\t]"},Y=`
`,oe={type:"literal",value:`
`,description:'"\\n"'},Qe="\r",Yt={type:"literal",value:"\r",description:'"\\r"'},kt=/^[0-9a-f]/i,yn={type:"class",value:"[0-9a-f]i",description:"[0-9a-f]i"},vn=/^[0-9]/,Qn={type:"class",value:"[0-9]",description:"[0-9]"},at="_",rs={type:"literal",value:"_",description:'"_"'},qa=function(){return ""},rl=/^[A-Za-z0-9_\-]/,X3={type:"class",value:"[A-Za-z0-9_\\-]",description:"[A-Za-z0-9_\\-]"},Z3=function(d){return d.join("")},US='\\"',J3={type:"literal",value:'\\"',description:'"\\\\\\""'},eU=function(){return '"'},$S="\\\\",tU={type:"literal",value:"\\\\",description:'"\\\\\\\\"'},rU=function(){return "\\"},jS="\\b",nU={type:"literal",value:"\\b",description:'"\\\\b"'},iU=function(){return "\b"},VS="\\t",sU={type:"literal",value:"\\t",description:'"\\\\t"'},aU=function(){return "	"},HS="\\n",oU={type:"literal",value:"\\n",description:'"\\\\n"'},uU=function(){return `
`},WS="\\f",cU={type:"literal",value:"\\f",description:'"\\\\f"'},lU=function(){return "\f"},KS="\\r",fU={type:"literal",value:"\\r",description:'"\\\\r"'},dU=function(){return "\r"},GS="\\U",hU={type:"literal",value:"\\U",description:'"\\\\U"'},zS=function(d){return OU(d.join(""))},YS="\\u",pU={type:"literal",value:"\\u",description:'"\\\\u"'},m=0,De=0,ou=0,Op={line:1,column:1,seenCR:!1},nl=0,kp=[],ce=0,pe={},il;if("startRule"in i){if(!(i.startRule in a))throw new Error(`Can't start parsing from rule "`+i.startRule+'".');o=a[i.startRule];}function xr(){return Lp(De).line}function Tr(){return Lp(De).column}function Lp(d){function v(x,O,B){var J,ne;for(J=O;J<B;J++)ne=n.charAt(J),ne===`
`?(x.seenCR||x.line++,x.column=1,x.seenCR=!1):ne==="\r"||ne==="\u2028"||ne==="\u2029"?(x.line++,x.column=1,x.seenCR=!0):(x.column++,x.seenCR=!1);}return ou!==d&&(ou>d&&(ou=0,Op={line:1,column:1,seenCR:!1}),v(Op,ou,d),ou=d),Op}function ve(d){m<nl||(m>nl&&(nl=m,kp=[]),kp.push(d));}function Bp(d,v,x){function O(Te){var Ge=1;for(Te.sort(function(Pt,St){return Pt.description<St.description?-1:Pt.description>St.description?1:0});Ge<Te.length;)Te[Ge-1]===Te[Ge]?Te.splice(Ge,1):Ge++;}function B(Te,Ge){function Pt(Ua){function ns(bn){return bn.charCodeAt(0).toString(16).toUpperCase()}return Ua.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(bn){return "\\x0"+ns(bn)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(bn){return "\\x"+ns(bn)}).replace(/[\u0180-\u0FFF]/g,function(bn){return "\\u0"+ns(bn)}).replace(/[\u1080-\uFFFF]/g,function(bn){return "\\u"+ns(bn)})}var St=new Array(Te.length),Zt,ir,_n;for(_n=0;_n<Te.length;_n++)St[_n]=Te[_n].description;return Zt=Te.length>1?St.slice(0,-1).join(", ")+" or "+St[Te.length-1]:St[0],ir=Ge?'"'+Pt(Ge)+'"':"end of input","Expected "+Zt+" but "+ir+" found."}var J=Lp(x),ne=x<n.length?n.charAt(x):null;return v!==null&&O(v),new t(d!==null?d:B(v,ne),v,ne,x,J.line,J.column)}function QS(){var d,v,x,O=m*49+0,B=pe[O];if(B)return m=B.nextPos,B.result;for(d=m,v=[],x=XS();x!==s;)v.push(x),x=XS();return v!==s&&(De=d,v=l()),d=v,pe[O]={nextPos:m,result:d},d}function XS(){var d,v,x,O,B,J,ne,Te=m*49+1,Ge=pe[Te];if(Ge)return m=Ge.nextPos,Ge.result;for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=gU(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();if(O!==s){for(B=[],J=sl();J!==s;)B.push(J),J=sl();if(B!==s){if(J=[],ne=Pn(),ne!==s)for(;ne!==s;)J.push(ne),ne=Pn();else J=u;J===s&&(J=ol()),J!==s?(v=[v,x,O,B,J],d=v):(m=d,d=u);}else m=d,d=u;}else m=d,d=u;}else m=d,d=u;else m=d,d=u;if(d===s){if(d=m,v=[],x=Oe(),x!==s)for(;x!==s;)v.push(x),x=Oe();else v=u;if(v!==s){if(x=[],O=Pn(),O!==s)for(;O!==s;)x.push(O),O=Pn();else x=u;x===s&&(x=ol()),x!==s?(v=[v,x],d=v):(m=d,d=u);}else m=d,d=u;d===s&&(d=Pn());}return pe[Te]={nextPos:m,result:d},d}function gU(){var d,v=m*49+2,x=pe[v];return x?(m=x.nextPos,x.result):(d=sl(),d===s&&(d=mU(),d===s&&(d=yU(),d===s&&(d=vU()))),pe[v]={nextPos:m,result:d},d)}function sl(){var d,v,x,O,B,J,ne=m*49+3,Te=pe[ne];if(Te)return m=Te.nextPos,Te.result;if(d=m,n.charCodeAt(m)===35?(v=f,m++):(v=s,ce===0&&ve(h)),v!==s){for(x=[],O=m,B=m,ce++,J=Pn(),J===s&&(J=ol()),ce--,J===s?B=p:(m=B,B=u),B!==s?(n.length>m?(J=n.charAt(m),m++):(J=s,ce===0&&ve(g)),J!==s?(B=[B,J],O=B):(m=O,O=u)):(m=O,O=u);O!==s;)x.push(O),O=m,B=m,ce++,J=Pn(),J===s&&(J=ol()),ce--,J===s?B=p:(m=B,B=u),B!==s?(n.length>m?(J=n.charAt(m),m++):(J=s,ce===0&&ve(g)),J!==s?(B=[B,J],O=B):(m=O,O=u)):(m=O,O=u);x!==s?(v=[v,x],d=v):(m=d,d=u);}else m=d,d=u;return pe[ne]={nextPos:m,result:d},d}function mU(){var d,v,x,O,B,J,ne=m*49+4,Te=pe[ne];if(Te)return m=Te.nextPos,Te.result;if(d=m,n.charCodeAt(m)===91?(v=_,m++):(v=s,ce===0&&ve(E)),v!==s){for(x=[],O=Oe();O!==s;)x.push(O),O=Oe();if(x!==s)if(O=ZS(),O!==s){for(B=[],J=Oe();J!==s;)B.push(J),J=Oe();B!==s?(n.charCodeAt(m)===93?(J=w,m++):(J=s,ce===0&&ve(y)),J!==s?(De=d,v=b(O),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;return pe[ne]={nextPos:m,result:d},d}function yU(){var d,v,x,O,B,J,ne,Te,Ge=m*49+5,Pt=pe[Ge];if(Pt)return m=Pt.nextPos,Pt.result;if(d=m,n.charCodeAt(m)===91?(v=_,m++):(v=s,ce===0&&ve(E)),v!==s)if(n.charCodeAt(m)===91?(x=_,m++):(x=s,ce===0&&ve(E)),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();if(O!==s)if(B=ZS(),B!==s){for(J=[],ne=Oe();ne!==s;)J.push(ne),ne=Oe();J!==s?(n.charCodeAt(m)===93?(ne=w,m++):(ne=s,ce===0&&ve(y)),ne!==s?(n.charCodeAt(m)===93?(Te=w,m++):(Te=s,ce===0&&ve(y)),Te!==s?(De=d,v=N(B),d=v):(m=d,d=u)):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;return pe[Ge]={nextPos:m,result:d},d}function ZS(){var d,v,x,O=m*49+6,B=pe[O];if(B)return m=B.nextPos,B.result;if(d=m,v=[],x=eE(),x!==s)for(;x!==s;)v.push(x),x=eE();else v=u;return v!==s?(x=JS(),x!==s?(De=d,v=L(v,x),d=v):(m=d,d=u)):(m=d,d=u),d===s&&(d=m,v=JS(),v!==s&&(De=d,v=V(v)),d=v),pe[O]={nextPos:m,result:d},d}function JS(){var d,v,x,O,B,J=m*49+7,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=uu(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();O!==s?(De=d,v=Z(x),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;if(d===s){for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=Fp(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();O!==s?(De=d,v=Z(x),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}return pe[J]={nextPos:m,result:d},d}function eE(){var d,v,x,O,B,J,ne,Te=m*49+8,Ge=pe[Te];if(Ge)return m=Ge.nextPos,Ge.result;for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=uu(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();if(O!==s)if(n.charCodeAt(m)===46?(B=G,m++):(B=s,ce===0&&ve(z)),B!==s){for(J=[],ne=Oe();ne!==s;)J.push(ne),ne=Oe();J!==s?(De=d,v=Z(x),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;if(d===s){for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=Fp(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();if(O!==s)if(n.charCodeAt(m)===46?(B=G,m++):(B=s,ce===0&&ve(z)),B!==s){for(J=[],ne=Oe();ne!==s;)J.push(ne),ne=Oe();J!==s?(De=d,v=Z(x),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;}return pe[Te]={nextPos:m,result:d},d}function vU(){var d,v,x,O,B,J,ne=m*49+9,Te=pe[ne];if(Te)return m=Te.nextPos,Te.result;if(d=m,v=uu(),v!==s){for(x=[],O=Oe();O!==s;)x.push(O),O=Oe();if(x!==s)if(n.charCodeAt(m)===61?(O=ee,m++):(O=s,ce===0&&ve(U)),O!==s){for(B=[],J=Oe();J!==s;)B.push(J),J=Oe();B!==s?(J=Ma(),J!==s?(De=d,v=ie(v,J),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;if(d===s)if(d=m,v=Fp(),v!==s){for(x=[],O=Oe();O!==s;)x.push(O),O=Oe();if(x!==s)if(n.charCodeAt(m)===61?(O=ee,m++):(O=s,ce===0&&ve(U)),O!==s){for(B=[],J=Oe();J!==s;)B.push(J),J=Oe();B!==s?(J=Ma(),J!==s?(De=d,v=ie(v,J),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;return pe[ne]={nextPos:m,result:d},d}function uu(){var d,v,x,O=m*49+10,B=pe[O];if(B)return m=B.nextPos,B.result;if(d=m,v=[],x=hE(),x!==s)for(;x!==s;)v.push(x),x=hE();else v=u;return v!==s&&(De=d,v=me(v)),d=v,pe[O]={nextPos:m,result:d},d}function Fp(){var d,v,x=m*49+11,O=pe[x];return O?(m=O.nextPos,O.result):(d=m,v=tE(),v!==s&&(De=d,v=Pe(v)),d=v,d===s&&(d=m,v=rE(),v!==s&&(De=d,v=Pe(v)),d=v),pe[x]={nextPos:m,result:d},d)}function Ma(){var d,v=m*49+12,x=pe[v];return x?(m=x.nextPos,x.result):(d=_U(),d===s&&(d=PU(),d===s&&(d=wU(),d===s&&(d=CU(),d===s&&(d=xU(),d===s&&(d=TU(),d===s&&(d=AU())))))),pe[v]={nextPos:m,result:d},d)}function _U(){var d,v=m*49+13,x=pe[v];return x?(m=x.nextPos,x.result):(d=bU(),d===s&&(d=tE(),d===s&&(d=SU(),d===s&&(d=rE()))),pe[v]={nextPos:m,result:d},d)}function bU(){var d,v,x,O,B,J=m*49+14,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;if(d=m,n.substr(m,3)===W?(v=W,m+=3):(v=s,ce===0&&ve(K)),v!==s)if(x=Pn(),x===s&&(x=se),x!==s){for(O=[],B=sE();B!==s;)O.push(B),B=sE();O!==s?(n.substr(m,3)===W?(B=W,m+=3):(B=s,ce===0&&ve(K)),B!==s?(De=d,v=Ae(O),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;return pe[J]={nextPos:m,result:d},d}function tE(){var d,v,x,O,B=m*49+15,J=pe[B];if(J)return m=J.nextPos,J.result;if(d=m,n.charCodeAt(m)===34?(v=Me,m++):(v=s,ce===0&&ve(ze)),v!==s){for(x=[],O=nE();O!==s;)x.push(O),O=nE();x!==s?(n.charCodeAt(m)===34?(O=Me,m++):(O=s,ce===0&&ve(ze)),O!==s?(De=d,v=Ae(x),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;return pe[B]={nextPos:m,result:d},d}function SU(){var d,v,x,O,B,J=m*49+16,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;if(d=m,n.substr(m,3)===We?(v=We,m+=3):(v=s,ce===0&&ve(lt)),v!==s)if(x=Pn(),x===s&&(x=se),x!==s){for(O=[],B=aE();B!==s;)O.push(B),B=aE();O!==s?(n.substr(m,3)===We?(B=We,m+=3):(B=s,ce===0&&ve(lt)),B!==s?(De=d,v=Ae(O),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;return pe[J]={nextPos:m,result:d},d}function rE(){var d,v,x,O,B=m*49+17,J=pe[B];if(J)return m=J.nextPos,J.result;if(d=m,n.charCodeAt(m)===39?(v=Bt,m++):(v=s,ce===0&&ve(Ct)),v!==s){for(x=[],O=iE();O!==s;)x.push(O),O=iE();x!==s?(n.charCodeAt(m)===39?(O=Bt,m++):(O=s,ce===0&&ve(Ct)),O!==s?(De=d,v=Ae(x),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;return pe[B]={nextPos:m,result:d},d}function nE(){var d,v,x,O=m*49+18,B=pe[O];return B?(m=B.nextPos,B.result):(d=pE(),d===s&&(d=m,v=m,ce++,n.charCodeAt(m)===34?(x=Me,m++):(x=s,ce===0&&ve(ze)),ce--,x===s?v=p:(m=v,v=u),v!==s?(n.length>m?(x=n.charAt(m),m++):(x=s,ce===0&&ve(g)),x!==s?(De=d,v=pt(x),d=v):(m=d,d=u)):(m=d,d=u)),pe[O]={nextPos:m,result:d},d)}function iE(){var d,v,x,O=m*49+19,B=pe[O];return B?(m=B.nextPos,B.result):(d=m,v=m,ce++,n.charCodeAt(m)===39?(x=Bt,m++):(x=s,ce===0&&ve(Ct)),ce--,x===s?v=p:(m=v,v=u),v!==s?(n.length>m?(x=n.charAt(m),m++):(x=s,ce===0&&ve(g)),x!==s?(De=d,v=pt(x),d=v):(m=d,d=u)):(m=d,d=u),pe[O]={nextPos:m,result:d},d)}function sE(){var d,v,x,O=m*49+20,B=pe[O];return B?(m=B.nextPos,B.result):(d=pE(),d===s&&(d=EU(),d===s&&(d=m,v=m,ce++,n.substr(m,3)===W?(x=W,m+=3):(x=s,ce===0&&ve(K)),ce--,x===s?v=p:(m=v,v=u),v!==s?(n.length>m?(x=n.charAt(m),m++):(x=s,ce===0&&ve(g)),x!==s?(De=d,v=Be(x),d=v):(m=d,d=u)):(m=d,d=u))),pe[O]={nextPos:m,result:d},d)}function EU(){var d,v,x,O,B,J=m*49+21,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;if(d=m,n.charCodeAt(m)===92?(v=Dt,m++):(v=s,ce===0&&ve(Vt)),v!==s)if(x=Pn(),x!==s){for(O=[],B=dE();B!==s;)O.push(B),B=dE();O!==s?(De=d,v=ye(),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;return pe[J]={nextPos:m,result:d},d}function aE(){var d,v,x,O=m*49+22,B=pe[O];return B?(m=B.nextPos,B.result):(d=m,v=m,ce++,n.substr(m,3)===We?(x=We,m+=3):(x=s,ce===0&&ve(lt)),ce--,x===s?v=p:(m=v,v=u),v!==s?(n.length>m?(x=n.charAt(m),m++):(x=s,ce===0&&ve(g)),x!==s?(De=d,v=pt(x),d=v):(m=d,d=u)):(m=d,d=u),pe[O]={nextPos:m,result:d},d)}function wU(){var d,v,x,O,B=m*49+23,J=pe[B];return J?(m=J.nextPos,J.result):(d=m,v=oE(),v===s&&(v=qp()),v!==s?(n.charCodeAt(m)===101?(x=Ve,m++):(x=s,ce===0&&ve(le)),x===s&&(n.charCodeAt(m)===69?(x=Ie,m++):(x=s,ce===0&&ve(Ke))),x!==s?(O=qp(),O!==s?(De=d,v=nt(v,O),d=v):(m=d,d=u)):(m=d,d=u)):(m=d,d=u),d===s&&(d=m,v=oE(),v!==s&&(De=d,v=Ye(v)),d=v),pe[B]={nextPos:m,result:d},d)}function oE(){var d,v,x,O,B,J,ne=m*49+24,Te=pe[ne];return Te?(m=Te.nextPos,Te.result):(d=m,n.charCodeAt(m)===43?(v=Rn,m++):(v=s,ce===0&&ve($r)),v===s&&(v=se),v!==s?(x=m,O=cu(),O!==s?(n.charCodeAt(m)===46?(B=G,m++):(B=s,ce===0&&ve(z)),B!==s?(J=cu(),J!==s?(O=[O,B,J],x=O):(m=x,x=u)):(m=x,x=u)):(m=x,x=u),x!==s?(De=d,v=Vs(x),d=v):(m=d,d=u)):(m=d,d=u),d===s&&(d=m,n.charCodeAt(m)===45?(v=jr,m++):(v=s,ce===0&&ve(tn)),v!==s?(x=m,O=cu(),O!==s?(n.charCodeAt(m)===46?(B=G,m++):(B=s,ce===0&&ve(z)),B!==s?(J=cu(),J!==s?(O=[O,B,J],x=O):(m=x,x=u)):(m=x,x=u)):(m=x,x=u),x!==s?(De=d,v=Hs(x),d=v):(m=d,d=u)):(m=d,d=u)),pe[ne]={nextPos:m,result:d},d)}function CU(){var d,v,x=m*49+25,O=pe[x];return O?(m=O.nextPos,O.result):(d=m,v=qp(),v!==s&&(De=d,v=Ba(v)),d=v,pe[x]={nextPos:m,result:d},d)}function qp(){var d,v,x,O,B,J=m*49+26,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;if(d=m,n.charCodeAt(m)===43?(v=Rn,m++):(v=s,ce===0&&ve($r)),v===s&&(v=se),v!==s){if(x=[],O=At(),O!==s)for(;O!==s;)x.push(O),O=At();else x=u;x!==s?(O=m,ce++,n.charCodeAt(m)===46?(B=G,m++):(B=s,ce===0&&ve(z)),ce--,B===s?O=p:(m=O,O=u),O!==s?(De=d,v=Vs(x),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;if(d===s)if(d=m,n.charCodeAt(m)===45?(v=jr,m++):(v=s,ce===0&&ve(tn)),v!==s){if(x=[],O=At(),O!==s)for(;O!==s;)x.push(O),O=At();else x=u;x!==s?(O=m,ce++,n.charCodeAt(m)===46?(B=G,m++):(B=s,ce===0&&ve(z)),ce--,B===s?O=p:(m=O,O=u),O!==s?(De=d,v=Hs(x),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;return pe[J]={nextPos:m,result:d},d}function xU(){var d,v,x=m*49+27,O=pe[x];return O?(m=O.nextPos,O.result):(d=m,n.substr(m,4)===mn?(v=mn,m+=4):(v=s,ce===0&&ve(Ws)),v!==s&&(De=d,v=Ks()),d=v,d===s&&(d=m,n.substr(m,5)===ki?(v=ki,m+=5):(v=s,ce===0&&ve(Gs)),v!==s&&(De=d,v=Yn()),d=v),pe[x]={nextPos:m,result:d},d)}function TU(){var d,v,x,O,B,J=m*49+28,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;if(d=m,n.charCodeAt(m)===91?(v=_,m++):(v=s,ce===0&&ve(E)),v!==s){for(x=[],O=In();O!==s;)x.push(O),O=In();x!==s?(n.charCodeAt(m)===93?(O=w,m++):(O=s,ce===0&&ve(y)),O!==s?(De=d,v=q(),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;if(d===s&&(d=m,n.charCodeAt(m)===91?(v=_,m++):(v=s,ce===0&&ve(E)),v!==s?(x=uE(),x===s&&(x=se),x!==s?(n.charCodeAt(m)===93?(O=w,m++):(O=s,ce===0&&ve(y)),O!==s?(De=d,v=ae(x),d=v):(m=d,d=u)):(m=d,d=u)):(m=d,d=u),d===s)){if(d=m,n.charCodeAt(m)===91?(v=_,m++):(v=s,ce===0&&ve(E)),v!==s){if(x=[],O=al(),O!==s)for(;O!==s;)x.push(O),O=al();else x=u;x!==s?(n.charCodeAt(m)===93?(O=w,m++):(O=s,ce===0&&ve(y)),O!==s?(De=d,v=Se(x),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;if(d===s)if(d=m,n.charCodeAt(m)===91?(v=_,m++):(v=s,ce===0&&ve(E)),v!==s){if(x=[],O=al(),O!==s)for(;O!==s;)x.push(O),O=al();else x=u;x!==s?(O=uE(),O!==s?(n.charCodeAt(m)===93?(B=w,m++):(B=s,ce===0&&ve(y)),B!==s?(De=d,v=Ne(x,O),d=v):(m=d,d=u)):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;}return pe[J]={nextPos:m,result:d},d}function uE(){var d,v,x,O,B,J=m*49+29,ne=pe[J];if(ne)return m=ne.nextPos,ne.result;for(d=m,v=[],x=In();x!==s;)v.push(x),x=In();if(v!==s)if(x=Ma(),x!==s){for(O=[],B=In();B!==s;)O.push(B),B=In();O!==s?(De=d,v=xt(x),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;return pe[J]={nextPos:m,result:d},d}function al(){var d,v,x,O,B,J,ne,Te=m*49+30,Ge=pe[Te];if(Ge)return m=Ge.nextPos,Ge.result;for(d=m,v=[],x=In();x!==s;)v.push(x),x=In();if(v!==s)if(x=Ma(),x!==s){for(O=[],B=In();B!==s;)O.push(B),B=In();if(O!==s)if(n.charCodeAt(m)===44?(B=vt,m++):(B=s,ce===0&&ve(Ot)),B!==s){for(J=[],ne=In();ne!==s;)J.push(ne),ne=In();J!==s?(De=d,v=xt(x),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;return pe[Te]={nextPos:m,result:d},d}function In(){var d,v=m*49+31,x=pe[v];return x?(m=x.nextPos,x.result):(d=Oe(),d===s&&(d=Pn(),d===s&&(d=sl())),pe[v]={nextPos:m,result:d},d)}function AU(){var d,v,x,O,B,J,ne=m*49+32,Te=pe[ne];if(Te)return m=Te.nextPos,Te.result;if(d=m,n.charCodeAt(m)===123?(v=qt,m++):(v=s,ce===0&&ve(it)),v!==s){for(x=[],O=Oe();O!==s;)x.push(O),O=Oe();if(x!==s){for(O=[],B=cE();B!==s;)O.push(B),B=cE();if(O!==s){for(B=[],J=Oe();J!==s;)B.push(J),J=Oe();B!==s?(n.charCodeAt(m)===125?(J=It,m++):(J=s,ce===0&&ve(gt)),J!==s?(De=d,v=zt(O),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;}else m=d,d=u;}else m=d,d=u;return pe[ne]={nextPos:m,result:d},d}function cE(){var d,v,x,O,B,J,ne,Te,Ge,Pt,St,Zt=m*49+33,ir=pe[Zt];if(ir)return m=ir.nextPos,ir.result;for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=uu(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();if(O!==s)if(n.charCodeAt(m)===61?(B=ee,m++):(B=s,ce===0&&ve(U)),B!==s){for(J=[],ne=Oe();ne!==s;)J.push(ne),ne=Oe();if(J!==s)if(ne=Ma(),ne!==s){for(Te=[],Ge=Oe();Ge!==s;)Te.push(Ge),Ge=Oe();if(Te!==s)if(n.charCodeAt(m)===44?(Ge=vt,m++):(Ge=s,ce===0&&ve(Ot)),Ge!==s){for(Pt=[],St=Oe();St!==s;)Pt.push(St),St=Oe();Pt!==s?(De=d,v=nr(x,ne),d=v):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;if(d===s){for(d=m,v=[],x=Oe();x!==s;)v.push(x),x=Oe();if(v!==s)if(x=uu(),x!==s){for(O=[],B=Oe();B!==s;)O.push(B),B=Oe();if(O!==s)if(n.charCodeAt(m)===61?(B=ee,m++):(B=s,ce===0&&ve(U)),B!==s){for(J=[],ne=Oe();ne!==s;)J.push(ne),ne=Oe();J!==s?(ne=Ma(),ne!==s?(De=d,v=nr(x,ne),d=v):(m=d,d=u)):(m=d,d=u);}else m=d,d=u;else m=d,d=u;}else m=d,d=u;else m=d,d=u;}return pe[Zt]={nextPos:m,result:d},d}function lE(){var d,v,x,O=m*49+34,B=pe[O];return B?(m=B.nextPos,B.result):(d=m,n.charCodeAt(m)===46?(v=G,m++):(v=s,ce===0&&ve(z)),v!==s?(x=cu(),x!==s?(De=d,v=Vr(x),d=v):(m=d,d=u)):(m=d,d=u),pe[O]={nextPos:m,result:d},d)}function fE(){var d,v,x,O,B,J,ne,Te,Ge,Pt,St,Zt,ir=m*49+35,_n=pe[ir];return _n?(m=_n.nextPos,_n.result):(d=m,v=m,x=At(),x!==s?(O=At(),O!==s?(B=At(),B!==s?(J=At(),J!==s?(n.charCodeAt(m)===45?(ne=jr,m++):(ne=s,ce===0&&ve(tn)),ne!==s?(Te=At(),Te!==s?(Ge=At(),Ge!==s?(n.charCodeAt(m)===45?(Pt=jr,m++):(Pt=s,ce===0&&ve(tn)),Pt!==s?(St=At(),St!==s?(Zt=At(),Zt!==s?(x=[x,O,B,J,ne,Te,Ge,Pt,St,Zt],v=x):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u),v!==s&&(De=d,v=Fa(v)),d=v,pe[ir]={nextPos:m,result:d},d)}function RU(){var d,v,x,O,B,J,ne,Te,Ge,Pt,St,Zt=m*49+36,ir=pe[Zt];return ir?(m=ir.nextPos,ir.result):(d=m,v=m,x=At(),x!==s?(O=At(),O!==s?(n.charCodeAt(m)===58?(B=es,m++):(B=s,ce===0&&ve(ts)),B!==s?(J=At(),J!==s?(ne=At(),ne!==s?(n.charCodeAt(m)===58?(Te=es,m++):(Te=s,ce===0&&ve(ts)),Te!==s?(Ge=At(),Ge!==s?(Pt=At(),Pt!==s?(St=lE(),St===s&&(St=se),St!==s?(x=[x,O,B,J,ne,Te,Ge,Pt,St],v=x):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u),v!==s&&(De=d,v=su(v)),d=v,pe[Zt]={nextPos:m,result:d},d)}function IU(){var d,v,x,O,B,J,ne,Te,Ge,Pt,St,Zt,ir,_n,Ua,ns,bn,mE=m*49+37,Up=pe[mE];return Up?(m=Up.nextPos,Up.result):(d=m,v=m,x=At(),x!==s?(O=At(),O!==s?(n.charCodeAt(m)===58?(B=es,m++):(B=s,ce===0&&ve(ts)),B!==s?(J=At(),J!==s?(ne=At(),ne!==s?(n.charCodeAt(m)===58?(Te=es,m++):(Te=s,ce===0&&ve(ts)),Te!==s?(Ge=At(),Ge!==s?(Pt=At(),Pt!==s?(St=lE(),St===s&&(St=se),St!==s?(n.charCodeAt(m)===45?(Zt=jr,m++):(Zt=s,ce===0&&ve(tn)),Zt===s&&(n.charCodeAt(m)===43?(Zt=Rn,m++):(Zt=s,ce===0&&ve($r))),Zt!==s?(ir=At(),ir!==s?(_n=At(),_n!==s?(n.charCodeAt(m)===58?(Ua=es,m++):(Ua=s,ce===0&&ve(ts)),Ua!==s?(ns=At(),ns!==s?(bn=At(),bn!==s?(x=[x,O,B,J,ne,Te,Ge,Pt,St,Zt,ir,_n,Ua,ns,bn],v=x):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u)):(m=v,v=u),v!==s&&(De=d,v=su(v)),d=v,pe[mE]={nextPos:m,result:d},d)}function PU(){var d,v,x,O,B,J=m*49+38,ne=pe[J];return ne?(m=ne.nextPos,ne.result):(d=m,v=fE(),v!==s?(n.charCodeAt(m)===84?(x=au,m++):(x=s,ce===0&&ve(tl)),x!==s?(O=RU(),O!==s?(n.charCodeAt(m)===90?(B=X,m++):(B=s,ce===0&&ve(A)),B!==s?(De=d,v=M(v,O),d=v):(m=d,d=u)):(m=d,d=u)):(m=d,d=u)):(m=d,d=u),d===s&&(d=m,v=fE(),v!==s?(n.charCodeAt(m)===84?(x=au,m++):(x=s,ce===0&&ve(tl)),x!==s?(O=IU(),O!==s?(De=d,v=$(v,O),d=v):(m=d,d=u)):(m=d,d=u)):(m=d,d=u)),pe[J]={nextPos:m,result:d},d)}function Oe(){var d,v=m*49+39,x=pe[v];return x?(m=x.nextPos,x.result):(D.test(n.charAt(m))?(d=n.charAt(m),m++):(d=s,ce===0&&ve(S)),pe[v]={nextPos:m,result:d},d)}function Pn(){var d,v,x,O=m*49+40,B=pe[O];return B?(m=B.nextPos,B.result):(n.charCodeAt(m)===10?(d=Y,m++):(d=s,ce===0&&ve(oe)),d===s&&(d=m,n.charCodeAt(m)===13?(v=Qe,m++):(v=s,ce===0&&ve(Yt)),v!==s?(n.charCodeAt(m)===10?(x=Y,m++):(x=s,ce===0&&ve(oe)),x!==s?(v=[v,x],d=v):(m=d,d=u)):(m=d,d=u)),pe[O]={nextPos:m,result:d},d)}function dE(){var d,v=m*49+41,x=pe[v];return x?(m=x.nextPos,x.result):(d=Pn(),d===s&&(d=Oe()),pe[v]={nextPos:m,result:d},d)}function ol(){var d,v,x=m*49+42,O=pe[x];return O?(m=O.nextPos,O.result):(d=m,ce++,n.length>m?(v=n.charAt(m),m++):(v=s,ce===0&&ve(g)),ce--,v===s?d=p:(m=d,d=u),pe[x]={nextPos:m,result:d},d)}function Nn(){var d,v=m*49+43,x=pe[v];return x?(m=x.nextPos,x.result):(kt.test(n.charAt(m))?(d=n.charAt(m),m++):(d=s,ce===0&&ve(yn)),pe[v]={nextPos:m,result:d},d)}function At(){var d,v,x=m*49+44,O=pe[x];return O?(m=O.nextPos,O.result):(vn.test(n.charAt(m))?(d=n.charAt(m),m++):(d=s,ce===0&&ve(Qn)),d===s&&(d=m,n.charCodeAt(m)===95?(v=at,m++):(v=s,ce===0&&ve(rs)),v!==s&&(De=d,v=qa()),d=v),pe[x]={nextPos:m,result:d},d)}function hE(){var d,v=m*49+45,x=pe[v];return x?(m=x.nextPos,x.result):(rl.test(n.charAt(m))?(d=n.charAt(m),m++):(d=s,ce===0&&ve(X3)),pe[v]={nextPos:m,result:d},d)}function cu(){var d,v,x,O=m*49+46,B=pe[O];if(B)return m=B.nextPos,B.result;if(d=m,v=[],x=At(),x!==s)for(;x!==s;)v.push(x),x=At();else v=u;return v!==s&&(De=d,v=Z3(v)),d=v,pe[O]={nextPos:m,result:d},d}function pE(){var d,v,x=m*49+47,O=pe[x];return O?(m=O.nextPos,O.result):(d=m,n.substr(m,2)===US?(v=US,m+=2):(v=s,ce===0&&ve(J3)),v!==s&&(De=d,v=eU()),d=v,d===s&&(d=m,n.substr(m,2)===$S?(v=$S,m+=2):(v=s,ce===0&&ve(tU)),v!==s&&(De=d,v=rU()),d=v,d===s&&(d=m,n.substr(m,2)===jS?(v=jS,m+=2):(v=s,ce===0&&ve(nU)),v!==s&&(De=d,v=iU()),d=v,d===s&&(d=m,n.substr(m,2)===VS?(v=VS,m+=2):(v=s,ce===0&&ve(sU)),v!==s&&(De=d,v=aU()),d=v,d===s&&(d=m,n.substr(m,2)===HS?(v=HS,m+=2):(v=s,ce===0&&ve(oU)),v!==s&&(De=d,v=uU()),d=v,d===s&&(d=m,n.substr(m,2)===WS?(v=WS,m+=2):(v=s,ce===0&&ve(cU)),v!==s&&(De=d,v=lU()),d=v,d===s&&(d=m,n.substr(m,2)===KS?(v=KS,m+=2):(v=s,ce===0&&ve(fU)),v!==s&&(De=d,v=dU()),d=v,d===s&&(d=NU()))))))),pe[x]={nextPos:m,result:d},d)}function NU(){var d,v,x,O,B,J,ne,Te,Ge,Pt,St,Zt=m*49+48,ir=pe[Zt];return ir?(m=ir.nextPos,ir.result):(d=m,n.substr(m,2)===GS?(v=GS,m+=2):(v=s,ce===0&&ve(hU)),v!==s?(x=m,O=Nn(),O!==s?(B=Nn(),B!==s?(J=Nn(),J!==s?(ne=Nn(),ne!==s?(Te=Nn(),Te!==s?(Ge=Nn(),Ge!==s?(Pt=Nn(),Pt!==s?(St=Nn(),St!==s?(O=[O,B,J,ne,Te,Ge,Pt,St],x=O):(m=x,x=u)):(m=x,x=u)):(m=x,x=u)):(m=x,x=u)):(m=x,x=u)):(m=x,x=u)):(m=x,x=u)):(m=x,x=u),x!==s?(De=d,v=zS(x),d=v):(m=d,d=u)):(m=d,d=u),d===s&&(d=m,n.substr(m,2)===YS?(v=YS,m+=2):(v=s,ce===0&&ve(pU)),v!==s?(x=m,O=Nn(),O!==s?(B=Nn(),B!==s?(J=Nn(),J!==s?(ne=Nn(),ne!==s?(O=[O,B,J,ne],x=O):(m=x,x=u)):(m=x,x=u)):(m=x,x=u)):(m=x,x=u),x!==s?(De=d,v=zS(x),d=v):(m=d,d=u)):(m=d,d=u)),pe[Zt]={nextPos:m,result:d},d)}var gE=[];function DU(d,v,x){var O=new Error(d);throw O.line=v,O.column=x,O}function Mp(d){gE.push(d);}function Ar(d,v,x,O,B){var J={type:d,value:v,line:x(),column:O()};return B&&(J.key=B),J}function OU(d,v,x){var O=parseInt("0x"+d);if(!isFinite(O)||Math.floor(O)!=O||O<0||O>1114111||O>55295&&O<57344)DU("Invalid Unicode escape code: "+d,v,x);else return kU(O)}function kU(){var d=16384,v=[],x,O,B=-1,J=arguments.length;if(!J)return "";for(var ne="";++B<J;){var Te=Number(arguments[B]);Te<=65535?v.push(Te):(Te-=65536,x=(Te>>10)+55296,O=Te%1024+56320,v.push(x,O)),(B+1==J||v.length>d)&&(ne+=String.fromCharCode.apply(null,v),v.length=0);}return ne}if(il=o(),il!==s&&m===n.length)return il;throw il!==s&&m<n.length&&ve({type:"end",description:"end of input"}),Bp(null,kp,nl)}return {SyntaxError:t,parse:r}}();});var KD=I((Ble,WD)=>{function eJ(e){var t=[],r=[],n="",i=Object.create(null),s=i;return o(e);function o(y){for(var b,N=0;N<y.length;N++)switch(b=y[N],b.type){case"Assign":l(b);break;case"ObjectPath":p(b);break;case"ArrayPath":g(b);break}return i}function c(y,b,N){var L=new Error(y);throw L.line=b,L.column=N,L}function l(y){var b=y.key,N=y.value,L=y.line,V=y.column,Z;n?Z=n+"."+b:Z=b,typeof s[b]<"u"&&c("Cannot redefine existing key '"+Z+"'.",L,V),s[b]=f(N),u(Z)||(t.push(Z),r.push(Z));}function u(y){return t.indexOf(y)!==-1}function f(y){return y.type==="Array"?E(y.value):y.type==="InlineTable"?h(y.value):y.value}function h(y){for(var b=Object.create(null),N=0;N<y.length;N++){var L=y[N];L.value.type==="InlineTable"?b[L.key]=h(L.value.value):L.type==="InlineTableValue"&&(b[L.key]=f(L.value));}return b}function p(y){var b=y.value,N=b.map(w).join("."),L=y.line,V=y.column;u(N)&&c("Cannot redefine existing key '"+b+"'.",L,V),t.push(N),s=_(i,b,Object.create(null),L,V),n=b;}function g(y){var b=y.value,N=b.map(w).join("."),L=y.line,V=y.column;if(u(N)||t.push(N),t=t.filter(function(G){return G.indexOf(N)!==0}),t.push(N),s=_(i,b,[],L,V),n=N,s instanceof Array){var Z=Object.create(null);s.push(Z),s=Z;}else c("Cannot redefine existing key '"+b+"'.",L,V);}function _(y,b,N,L,V){for(var Z=[],G="",z=b.join("."),ee=y,U=0;U<b.length;U++){var ie=b[U];Z.push(ie),G=Z.join("."),typeof ee[ie]>"u"?U===b.length-1?ee[ie]=N:ee[ie]=Object.create(null):U!==b.length-1&&r.indexOf(G)>-1&&c("Cannot redefine existing key '"+G+"'.",L,V),ee=ee[ie],ee instanceof Array&&ee.length&&U<b.length-1&&(ee=ee[ee.length-1]);}return ee}function E(y){for(var b=null,N=0;N<y.length;N++){var L=y[N];b===null?b=L.type:L.type!==b&&c("Cannot add value of type "+L.type+" to array of type "+b+".",L.line,L.column);}return y.map(f)}function w(y){return y.indexOf(".")>-1?'"'+y+'"':y}}WD.exports={compile:eJ};});var zD=I((Fle,GD)=>{var tJ=HD(),rJ=KD();GD.exports={parse:function(e){var t=tJ.parse(e.toString());return rJ.compile(t)}};});var uO=I((ha,oO)=>{var zy=he("crypto");ha=oO.exports=cc;function cc(e,t){return t=sO(e,t),lJ(e,t)}ha.sha1=function(e){return cc(e)};ha.keys=function(e){return cc(e,{excludeValues:!0,algorithm:"sha1",encoding:"hex"})};ha.MD5=function(e){return cc(e,{algorithm:"md5",encoding:"hex"})};ha.keysMD5=function(e){return cc(e,{algorithm:"md5",encoding:"hex",excludeValues:!0})};var bo=zy.getHashes?zy.getHashes().slice():["sha1","md5"];bo.push("passthrough");var nO=["buffer","hex","binary","base64"];function sO(e,t){t=t||{};var r={};if(r.algorithm=t.algorithm||"sha1",r.encoding=t.encoding||"hex",r.excludeValues=!!t.excludeValues,r.algorithm=r.algorithm.toLowerCase(),r.encoding=r.encoding.toLowerCase(),r.ignoreUnknown=t.ignoreUnknown===!0,r.respectType=t.respectType!==!1,r.respectFunctionNames=t.respectFunctionNames!==!1,r.respectFunctionProperties=t.respectFunctionProperties!==!1,r.unorderedArrays=t.unorderedArrays===!0,r.unorderedSets=t.unorderedSets!==!1,r.unorderedObjects=t.unorderedObjects!==!1,r.replacer=t.replacer||void 0,r.excludeKeys=t.excludeKeys||void 0,typeof e>"u")throw new Error("Object argument required.");for(var n=0;n<bo.length;++n)bo[n].toLowerCase()===r.algorithm.toLowerCase()&&(r.algorithm=bo[n]);if(bo.indexOf(r.algorithm)===-1)throw new Error('Algorithm "'+r.algorithm+'"  not supported. supported values: '+bo.join(", "));if(nO.indexOf(r.encoding)===-1&&r.algorithm!=="passthrough")throw new Error('Encoding "'+r.encoding+'"  not supported. supported values: '+nO.join(", "));return r}function iO(e){if(typeof e!="function")return !1;var t=/^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;return t.exec(Function.prototype.toString.call(e))!=null}function lJ(e,t){var r;t.algorithm!=="passthrough"?r=zy.createHash(t.algorithm):r=new aO,typeof r.write>"u"&&(r.write=r.update,r.end=r.update);var n=Yy(t,r);if(n.dispatch(e),r.update||r.end(""),r.digest)return r.digest(t.encoding==="buffer"?void 0:t.encoding);var i=r.read();return t.encoding==="buffer"?i:i.toString(t.encoding)}ha.writeToStream=function(e,t,r){return typeof r>"u"&&(r=t,t={}),t=sO(e,t),Yy(t,r).dispatch(e)};function Yy(e,t,r){r=r||[];var n=function(i){return t.update?t.update(i,"utf8"):t.write(i,"utf8")};return {dispatch:function(i){e.replacer&&(i=e.replacer(i));var s=typeof i;return i===null&&(s="null"),this["_"+s](i)},_object:function(i){var s=/\[object (.*)\]/i,a=Object.prototype.toString.call(i),o=s.exec(a);o?o=o[1]:o="unknown:["+a+"]",o=o.toLowerCase();var c=null;if((c=r.indexOf(i))>=0)return this.dispatch("[CIRCULAR:"+c+"]");if(r.push(i),typeof Buffer<"u"&&Buffer.isBuffer&&Buffer.isBuffer(i))return n("buffer:"),n(i);if(o!=="object"&&o!=="function"&&o!=="asyncfunction")if(this["_"+o])this["_"+o](i);else {if(e.ignoreUnknown)return n("["+o+"]");throw new Error('Unknown object type "'+o+'"')}else {var l=Object.keys(i);e.unorderedObjects&&(l=l.sort()),e.respectType!==!1&&!iO(i)&&l.splice(0,0,"prototype","__proto__","constructor"),e.excludeKeys&&(l=l.filter(function(f){return !e.excludeKeys(f)})),n("object:"+l.length+":");var u=this;return l.forEach(function(f){u.dispatch(f),n(":"),e.excludeValues||u.dispatch(i[f]),n(",");})}},_array:function(i,s){s=typeof s<"u"?s:e.unorderedArrays!==!1;var a=this;if(n("array:"+i.length+":"),!s||i.length<=1)return i.forEach(function(l){return a.dispatch(l)});var o=[],c=i.map(function(l){var u=new aO,f=r.slice(),h=Yy(e,u,f);return h.dispatch(l),o=o.concat(f.slice(r.length)),u.read().toString()});return r=r.concat(o),c.sort(),this._array(c,!1)},_date:function(i){return n("date:"+i.toJSON())},_symbol:function(i){return n("symbol:"+i.toString())},_error:function(i){return n("error:"+i.toString())},_boolean:function(i){return n("bool:"+i.toString())},_string:function(i){n("string:"+i.length+":"),n(i.toString());},_function:function(i){n("fn:"),iO(i)?this.dispatch("[native]"):this.dispatch(i.toString()),e.respectFunctionNames!==!1&&this.dispatch("function-name:"+String(i.name)),e.respectFunctionProperties&&this._object(i);},_number:function(i){return n("number:"+i.toString())},_xml:function(i){return n("xml:"+i.toString())},_null:function(){return n("Null")},_undefined:function(){return n("Undefined")},_regexp:function(i){return n("regex:"+i.toString())},_uint8array:function(i){return n("uint8array:"),this.dispatch(Array.prototype.slice.call(i))},_uint8clampedarray:function(i){return n("uint8clampedarray:"),this.dispatch(Array.prototype.slice.call(i))},_int8array:function(i){return n("int8array:"),this.dispatch(Array.prototype.slice.call(i))},_uint16array:function(i){return n("uint16array:"),this.dispatch(Array.prototype.slice.call(i))},_int16array:function(i){return n("int16array:"),this.dispatch(Array.prototype.slice.call(i))},_uint32array:function(i){return n("uint32array:"),this.dispatch(Array.prototype.slice.call(i))},_int32array:function(i){return n("int32array:"),this.dispatch(Array.prototype.slice.call(i))},_float32array:function(i){return n("float32array:"),this.dispatch(Array.prototype.slice.call(i))},_float64array:function(i){return n("float64array:"),this.dispatch(Array.prototype.slice.call(i))},_arraybuffer:function(i){return n("arraybuffer:"),this.dispatch(new Uint8Array(i))},_url:function(i){return n("url:"+i.toString())},_map:function(i){n("map:");var s=Array.from(i);return this._array(s,e.unorderedSets!==!1)},_set:function(i){n("set:");var s=Array.from(i);return this._array(s,e.unorderedSets!==!1)},_file:function(i){return n("file:"),this.dispatch([i.name,i.size,i.type,i.lastModfied])},_blob:function(){if(e.ignoreUnknown)return n("[blob]");throw Error(`Hashing Blob objects is currently not supported
(see https://github.com/puleos/object-hash/issues/26)
Use "options.replacer" or "options.ignoreUnknown"
`)},_domwindow:function(){return n("domwindow")},_bigint:function(i){return n("bigint:"+i.toString())},_process:function(){return n("process")},_timer:function(){return n("timer")},_pipe:function(){return n("pipe")},_tcp:function(){return n("tcp")},_udp:function(){return n("udp")},_tty:function(){return n("tty")},_statwatcher:function(){return n("statwatcher")},_securecontext:function(){return n("securecontext")},_connection:function(){return n("connection")},_zlib:function(){return n("zlib")},_context:function(){return n("context")},_nodescript:function(){return n("nodescript")},_httpparser:function(){return n("httpparser")},_dataview:function(){return n("dataview")},_signal:function(){return n("signal")},_fsevent:function(){return n("fsevent")},_tlswrap:function(){return n("tlswrap")}}}function aO(){return {buf:"",write:function(e){this.buf+=e;},end:function(e){this.buf+=e;},read:function(){return this.buf}}}});var gO=I((exports,module)=>{var Module=Module!==void 0?Module:{},TreeSitter=function(){var initPromise,document=typeof window=="object"?{currentScript:window.document.currentScript}:null;class Parser{constructor(){this.initialize();}initialize(){throw new Error("cannot construct a Parser before calling `init()`")}static init(moduleOptions){return initPromise||(Module=Object.assign({},Module,moduleOptions),initPromise=new Promise(resolveInitPromise=>{var moduleOverrides=Object.assign({},Module),arguments_=[],thisProgram="./this.program",quit_=(e,t)=>{throw t},ENVIRONMENT_IS_WEB=typeof window=="object",ENVIRONMENT_IS_WORKER=typeof importScripts=="function",ENVIRONMENT_IS_NODE=typeof process=="object"&&typeof process.versions=="object"&&typeof process.versions.node=="string",scriptDirectory="",read_,readAsync,readBinary;function locateFile(e){return Module.locateFile?Module.locateFile(e,scriptDirectory):scriptDirectory+e}function logExceptionOnExit(e){e instanceof ExitStatus||err("exiting due to exception: "+e);}if(ENVIRONMENT_IS_NODE){var fs=he("fs"),nodePath=he("path");scriptDirectory=ENVIRONMENT_IS_WORKER?nodePath.dirname(scriptDirectory)+"/":__dirname+"/",read_=(e,t)=>(e=isFileURI(e)?new URL(e):nodePath.normalize(e),fs.readFileSync(e,t?void 0:"utf8")),readBinary=e=>{var t=read_(e,!0);return t.buffer||(t=new Uint8Array(t)),t},readAsync=(e,t,r)=>{e=isFileURI(e)?new URL(e):nodePath.normalize(e),fs.readFile(e,function(n,i){n?r(n):t(i.buffer);});},process.argv.length>1&&(thisProgram=process.argv[1].replace(/\\/g,"/")),arguments_=process.argv.slice(2),typeof module<"u"&&(module.exports=Module),quit_=(e,t)=>{if(keepRuntimeAlive())throw process.exitCode=e,t;logExceptionOnExit(t),process.exit(e);},Module.inspect=function(){return "[Emscripten Module object]"};}else (ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)&&(ENVIRONMENT_IS_WORKER?scriptDirectory=self.location.href:document!==void 0&&document.currentScript&&(scriptDirectory=document.currentScript.src),scriptDirectory=scriptDirectory.indexOf("blob:")!==0?scriptDirectory.substr(0,scriptDirectory.replace(/[?#].*/,"").lastIndexOf("/")+1):"",read_=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.send(null),t.responseText},ENVIRONMENT_IS_WORKER&&(readBinary=e=>{var t=new XMLHttpRequest;return t.open("GET",e,!1),t.responseType="arraybuffer",t.send(null),new Uint8Array(t.response)}),readAsync=(e,t,r)=>{var n=new XMLHttpRequest;n.open("GET",e,!0),n.responseType="arraybuffer",n.onload=()=>{n.status==200||n.status==0&&n.response?t(n.response):r();},n.onerror=r,n.send(null);},e=>document.title=e);Module.print||console.log.bind(console);var err=Module.printErr||console.warn.bind(console);Object.assign(Module,moduleOverrides),moduleOverrides=null,Module.arguments&&(arguments_=Module.arguments),Module.thisProgram&&(thisProgram=Module.thisProgram),Module.quit&&(quit_=Module.quit);var STACK_ALIGN=16,dynamicLibraries=Module.dynamicLibraries||[],wasmBinary;Module.wasmBinary&&(wasmBinary=Module.wasmBinary);var noExitRuntime=Module.noExitRuntime||!0,wasmMemory;typeof WebAssembly!="object"&&abort("no native wasm support detected");var ABORT=!1,EXITSTATUS,UTF8Decoder=typeof TextDecoder<"u"?new TextDecoder("utf8"):void 0,buffer,HEAP8,HEAPU8,HEAP16,HEAP32,HEAPU32,HEAPF32,HEAPF64;function UTF8ArrayToString(e,t,r){for(var n=t+r,i=t;e[i]&&!(i>=n);)++i;if(i-t>16&&e.buffer&&UTF8Decoder)return UTF8Decoder.decode(e.subarray(t,i));for(var s="";t<i;){var a=e[t++];if(128&a){var o=63&e[t++];if((224&a)!=192){var c=63&e[t++];if((a=(240&a)==224?(15&a)<<12|o<<6|c:(7&a)<<18|o<<12|c<<6|63&e[t++])<65536)s+=String.fromCharCode(a);else {var l=a-65536;s+=String.fromCharCode(55296|l>>10,56320|1023&l);}}else s+=String.fromCharCode((31&a)<<6|o);}else s+=String.fromCharCode(a);}return s}function UTF8ToString(e,t){return e?UTF8ArrayToString(HEAPU8,e,t):""}function stringToUTF8Array(e,t,r,n){if(!(n>0))return 0;for(var i=r,s=r+n-1,a=0;a<e.length;++a){var o=e.charCodeAt(a);if(o>=55296&&o<=57343&&(o=65536+((1023&o)<<10)|1023&e.charCodeAt(++a)),o<=127){if(r>=s)break;t[r++]=o;}else if(o<=2047){if(r+1>=s)break;t[r++]=192|o>>6,t[r++]=128|63&o;}else if(o<=65535){if(r+2>=s)break;t[r++]=224|o>>12,t[r++]=128|o>>6&63,t[r++]=128|63&o;}else {if(r+3>=s)break;t[r++]=240|o>>18,t[r++]=128|o>>12&63,t[r++]=128|o>>6&63,t[r++]=128|63&o;}}return t[r]=0,r-i}function stringToUTF8(e,t,r){return stringToUTF8Array(e,HEAPU8,t,r)}function lengthBytesUTF8(e){for(var t=0,r=0;r<e.length;++r){var n=e.charCodeAt(r);n<=127?t++:n<=2047?t+=2:n>=55296&&n<=57343?(t+=4,++r):t+=3;}return t}function updateGlobalBufferAndViews(e){buffer=e,Module.HEAP8=HEAP8=new Int8Array(e),Module.HEAP16=HEAP16=new Int16Array(e),Module.HEAP32=HEAP32=new Int32Array(e),Module.HEAPU8=HEAPU8=new Uint8Array(e),Module.HEAPU16=new Uint16Array(e),Module.HEAPU32=HEAPU32=new Uint32Array(e),Module.HEAPF32=HEAPF32=new Float32Array(e),Module.HEAPF64=HEAPF64=new Float64Array(e);}var INITIAL_MEMORY=Module.INITIAL_MEMORY||33554432;wasmMemory=Module.wasmMemory?Module.wasmMemory:new WebAssembly.Memory({initial:INITIAL_MEMORY/65536,maximum:32768}),wasmMemory&&(buffer=wasmMemory.buffer),INITIAL_MEMORY=buffer.byteLength,updateGlobalBufferAndViews(buffer);var wasmTable=new WebAssembly.Table({initial:20,element:"anyfunc"}),__ATPRERUN__=[],__ATINIT__=[],__ATMAIN__=[],__ATPOSTRUN__=[],__RELOC_FUNCS__=[],runtimeInitialized=!1;function keepRuntimeAlive(){return noExitRuntime}function preRun(){if(Module.preRun)for(typeof Module.preRun=="function"&&(Module.preRun=[Module.preRun]);Module.preRun.length;)addOnPreRun(Module.preRun.shift());callRuntimeCallbacks(__ATPRERUN__);}function initRuntime(){runtimeInitialized=!0,callRuntimeCallbacks(__RELOC_FUNCS__),callRuntimeCallbacks(__ATINIT__);}function preMain(){callRuntimeCallbacks(__ATMAIN__);}function postRun(){if(Module.postRun)for(typeof Module.postRun=="function"&&(Module.postRun=[Module.postRun]);Module.postRun.length;)addOnPostRun(Module.postRun.shift());callRuntimeCallbacks(__ATPOSTRUN__);}function addOnPreRun(e){__ATPRERUN__.unshift(e);}function addOnInit(e){__ATINIT__.unshift(e);}function addOnPostRun(e){__ATPOSTRUN__.unshift(e);}var runDependencies=0,dependenciesFulfilled=null;function addRunDependency(e){runDependencies++,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies);}function removeRunDependency(e){if(runDependencies--,Module.monitorRunDependencies&&Module.monitorRunDependencies(runDependencies),runDependencies==0&&(dependenciesFulfilled)){var t=dependenciesFulfilled;dependenciesFulfilled=null,t();}}function abort(e){throw Module.onAbort&&Module.onAbort(e),err(e="Aborted("+e+")"),ABORT=!0,EXITSTATUS=1,e+=". Build with -sASSERTIONS for more info.",new WebAssembly.RuntimeError(e)}var dataURIPrefix="data:application/octet-stream;base64,",wasmBinaryFile,tempDouble,tempI64;function isDataURI(e){return e.startsWith(dataURIPrefix)}function isFileURI(e){return e.startsWith("file://")}function getBinary(e){try{if(e==wasmBinaryFile&&wasmBinary)return new Uint8Array(wasmBinary);if(readBinary)return readBinary(e);throw "both async and sync fetching of the wasm failed"}catch(t){abort(t);}}function getBinaryPromise(){if(!wasmBinary&&(ENVIRONMENT_IS_WEB||ENVIRONMENT_IS_WORKER)){if(typeof fetch=="function"&&!isFileURI(wasmBinaryFile))return fetch(wasmBinaryFile,{credentials:"same-origin"}).then(function(e){if(!e.ok)throw "failed to load wasm binary file at '"+wasmBinaryFile+"'";return e.arrayBuffer()}).catch(function(){return getBinary(wasmBinaryFile)});if(readAsync)return new Promise(function(e,t){readAsync(wasmBinaryFile,function(r){e(new Uint8Array(r));},t);})}return Promise.resolve().then(function(){return getBinary(wasmBinaryFile)})}function createWasm(){var e={env:asmLibraryArg,wasi_snapshot_preview1:asmLibraryArg,"GOT.mem":new Proxy(asmLibraryArg,GOTHandler),"GOT.func":new Proxy(asmLibraryArg,GOTHandler)};function t(i,s){var a=i.exports;a=relocateExports(a,1024);var o=getDylinkMetadata(s);o.neededDynlibs&&(dynamicLibraries=o.neededDynlibs.concat(dynamicLibraries)),mergeLibSymbols(a),Module.asm=a,addOnInit(Module.asm.__wasm_call_ctors),__RELOC_FUNCS__.push(Module.asm.__wasm_apply_data_relocs),removeRunDependency();}function r(i){t(i.instance,i.module);}function n(i){return getBinaryPromise().then(function(s){return WebAssembly.instantiate(s,e)}).then(function(s){return s}).then(i,function(s){err("failed to asynchronously prepare wasm: "+s),abort(s);})}if(addRunDependency(),Module.instantiateWasm)try{return Module.instantiateWasm(e,t)}catch(i){return err("Module.instantiateWasm callback failed with error: "+i),!1}return wasmBinary||typeof WebAssembly.instantiateStreaming!="function"||isDataURI(wasmBinaryFile)||isFileURI(wasmBinaryFile)||ENVIRONMENT_IS_NODE||typeof fetch!="function"?n(r):fetch(wasmBinaryFile,{credentials:"same-origin"}).then(function(i){return WebAssembly.instantiateStreaming(i,e).then(r,function(s){return err("wasm streaming compile failed: "+s),err("falling back to ArrayBuffer instantiation"),n(r)})}),{}}wasmBinaryFile="tree-sitter.wasm",isDataURI(wasmBinaryFile)||(wasmBinaryFile=locateFile(wasmBinaryFile));function ExitStatus(e){this.name="ExitStatus",this.message="Program terminated with exit("+e+")",this.status=e;}var GOT={},CurrentModuleWeakSymbols=new Set([]),GOTHandler={get:function(e,t){var r=GOT[t];return r||(r=GOT[t]=new WebAssembly.Global({value:"i32",mutable:!0})),CurrentModuleWeakSymbols.has(t)||(r.required=!0),r}};function callRuntimeCallbacks(e){for(;e.length>0;)e.shift()(Module);}function getDylinkMetadata(e){var t=0,r=0;function n(){for(var w=0,y=1;;){var b=e[t++];if(w+=(127&b)*y,y*=128,!(128&b))break}return w}function i(){var w=n();return UTF8ArrayToString(e,(t+=w)-w,w)}function s(w,y){if(w)throw new Error(y)}var a="dylink.0";if(e instanceof WebAssembly.Module){var o=WebAssembly.Module.customSections(e,a);o.length===0&&(a="dylink",o=WebAssembly.Module.customSections(e,a)),s(o.length===0,"need dylink section"),r=(e=new Uint8Array(o[0])).length;}else {s(new Uint32Array(new Uint8Array(e.subarray(0,24)).buffer)[0]!=1836278016,"need to see wasm magic number"),s(e[8]!==0,"need the dylink section to be first"),t=9;var c=n();r=t+c,a=i();}var l={neededDynlibs:[],tlsExports:new Set,weakImports:new Set};if(a=="dylink"){l.memorySize=n(),l.memoryAlign=n(),l.tableSize=n(),l.tableAlign=n();for(var u=n(),f=0;f<u;++f){var h=i();l.neededDynlibs.push(h);}}else for(s(a!=="dylink.0");t<r;){var p=e[t++],g=n();if(p===1)l.memorySize=n(),l.memoryAlign=n(),l.tableSize=n(),l.tableAlign=n();else if(p===2)for(u=n(),f=0;f<u;++f)h=i(),l.neededDynlibs.push(h);else if(p===3)for(var _=n();_--;){var E=i();256&n()&&l.tlsExports.add(E);}else if(p===4)for(_=n();_--;)i(),E=i(),(3&n())==1&&l.weakImports.add(E);else t+=g;}return l}function getValue(e,t="i8"){switch(t.endsWith("*")&&(t="*"),t){case"i1":case"i8":return HEAP8[e>>0];case"i16":return HEAP16[e>>1];case"i32":case"i64":return HEAP32[e>>2];case"float":return HEAPF32[e>>2];case"double":return HEAPF64[e>>3];case"*":return HEAPU32[e>>2];default:abort("invalid type for getValue: "+t);}return null}function asmjsMangle(e){return e.indexOf("dynCall_")==0||["stackAlloc","stackSave","stackRestore","getTempRet0","setTempRet0"].includes(e)?e:"_"+e}function mergeLibSymbols(e,t){for(var r in e)if(e.hasOwnProperty(r)){asmLibraryArg.hasOwnProperty(r)||(asmLibraryArg[r]=e[r]);var n=asmjsMangle(r);Module.hasOwnProperty(n)||(Module[n]=e[r]),r=="__main_argc_argv"&&(Module._main=e[r]);}}var LDSO={loadedLibsByName:{},loadedLibsByHandle:{}};function dynCallLegacy(e,t,r){var n=Module["dynCall_"+e];return r&&r.length?n.apply(null,[t].concat(r)):n.call(null,t)}var wasmTableMirror=[];function getWasmTableEntry(e){var t=wasmTableMirror[e];return t||(e>=wasmTableMirror.length&&(wasmTableMirror.length=e+1),wasmTableMirror[e]=t=wasmTable.get(e)),t}function dynCall(e,t,r){return e.includes("j")?dynCallLegacy(e,t,r):getWasmTableEntry(t).apply(null,r)}function createInvokeFunction(e){return function(){var t=stackSave();try{return dynCall(e,arguments[0],Array.prototype.slice.call(arguments,1))}catch(r){if(stackRestore(t),r!==r+0)throw r;_setThrew(1,0);}}}var ___heap_base=78144;function zeroMemory(e,t){return HEAPU8.fill(0,e,e+t),e}function getMemory(e){if(runtimeInitialized)return zeroMemory(_malloc(e),e);var t=___heap_base,r=t+e+15&-16;return ___heap_base=r,GOT.__heap_base.value=r,t}function isInternalSym(e){return ["__cpp_exception","__c_longjmp","__wasm_apply_data_relocs","__dso_handle","__tls_size","__tls_align","__set_stack_limits","_emscripten_tls_init","__wasm_init_tls","__wasm_call_ctors","__start_em_asm","__stop_em_asm"].includes(e)}function uleb128Encode(e,t){e<128?t.push(e):t.push(e%128|128,e>>7);}function sigToWasmTypes(e){for(var t={i:"i32",j:"i32",f:"f32",d:"f64",p:"i32"},r={parameters:[],results:e[0]=="v"?[]:[t[e[0]]]},n=1;n<e.length;++n)r.parameters.push(t[e[n]]),e[n]==="j"&&r.parameters.push("i32");return r}function generateFuncType(e,t){var r=e.slice(0,1),n=e.slice(1),i={i:127,p:127,j:126,f:125,d:124};t.push(96),uleb128Encode(n.length,t);for(var s=0;s<n.length;++s)t.push(i[n[s]]);r=="v"?t.push(0):t.push(1,i[r]);}function convertJsFunctionToWasm(e,t){if(typeof WebAssembly.Function=="function")return new WebAssembly.Function(sigToWasmTypes(t),e);var r=[1];generateFuncType(t,r);var n=[0,97,115,109,1,0,0,0,1];uleb128Encode(r.length,n),n.push.apply(n,r),n.push(2,7,1,1,101,1,102,0,0,7,5,1,1,102,0,0);var i=new WebAssembly.Module(new Uint8Array(n));return new WebAssembly.Instance(i,{e:{f:e}}).exports.f}function updateTableMap(e,t){if(functionsInTableMap)for(var r=e;r<e+t;r++){var n=getWasmTableEntry(r);n&&functionsInTableMap.set(n,r);}}var functionsInTableMap=void 0,freeTableIndexes=[];function getEmptyTableSlot(){if(freeTableIndexes.length)return freeTableIndexes.pop();try{wasmTable.grow(1);}catch(e){throw e instanceof RangeError?"Unable to grow wasm table. Set ALLOW_TABLE_GROWTH.":e}return wasmTable.length-1}function setWasmTableEntry(e,t){wasmTable.set(e,t),wasmTableMirror[e]=wasmTable.get(e);}function addFunction(e,t){if(functionsInTableMap||(functionsInTableMap=new WeakMap,updateTableMap(0,wasmTable.length)),functionsInTableMap.has(e))return functionsInTableMap.get(e);var r=getEmptyTableSlot();try{setWasmTableEntry(r,e);}catch(n){if(!(n instanceof TypeError))throw n;setWasmTableEntry(r,convertJsFunctionToWasm(e,t));}return functionsInTableMap.set(e,r),r}function updateGOT(e,t){for(var r in e)if(!isInternalSym(r)){var n=e[r];r.startsWith("orig$")&&(r=r.split("$")[1],t=!0),GOT[r]||(GOT[r]=new WebAssembly.Global({value:"i32",mutable:!0})),(t||GOT[r].value==0)&&(typeof n=="function"?GOT[r].value=addFunction(n):typeof n=="number"?GOT[r].value=n:err("unhandled export type for `"+r+"`: "+typeof n));}}function relocateExports(e,t,r){var n={};for(var i in e){var s=e[i];typeof s=="object"&&(s=s.value),typeof s=="number"&&(s+=t),n[i]=s;}return updateGOT(n,r),n}function resolveGlobalSymbol(e,t){var r;return t&&(r=asmLibraryArg["orig$"+e]),r||(r=asmLibraryArg[e])&&r.stub&&(r=void 0),r||(r=Module[asmjsMangle(e)]),!r&&e.startsWith("invoke_")&&(r=createInvokeFunction(e.split("_")[1])),r}function alignMemory(e,t){return Math.ceil(e/t)*t}function loadWebAssemblyModule(binary,flags,handle){var metadata=getDylinkMetadata(binary);function loadModule(){var firstLoad=!handle||!HEAP8[handle+12>>0];if(firstLoad){var memAlign=Math.pow(2,metadata.memoryAlign);memAlign=Math.max(memAlign,STACK_ALIGN);var memoryBase=metadata.memorySize?alignMemory(getMemory(metadata.memorySize+memAlign),memAlign):0,tableBase=metadata.tableSize?wasmTable.length:0;handle&&(HEAP8[handle+12>>0]=1,HEAPU32[handle+16>>2]=memoryBase,HEAP32[handle+20>>2]=metadata.memorySize,HEAPU32[handle+24>>2]=tableBase,HEAP32[handle+28>>2]=metadata.tableSize);}else memoryBase=HEAPU32[handle+16>>2],tableBase=HEAPU32[handle+24>>2];var tableGrowthNeeded=tableBase+metadata.tableSize-wasmTable.length,moduleExports;function resolveSymbol(e){var t=resolveGlobalSymbol(e,!1);return t||(t=moduleExports[e]),t}tableGrowthNeeded>0&&wasmTable.grow(tableGrowthNeeded);var proxyHandler={get:function(e,t){switch(t){case"__memory_base":return memoryBase;case"__table_base":return tableBase}if(t in asmLibraryArg)return asmLibraryArg[t];var r;return t in e||(e[t]=function(){return r||(r=resolveSymbol(t)),r.apply(null,arguments)}),e[t]}},proxy=new Proxy({},proxyHandler),info={"GOT.mem":new Proxy({},GOTHandler),"GOT.func":new Proxy({},GOTHandler),env:proxy,wasi_snapshot_preview1:proxy};function postInstantiation(instance){function addEmAsm(addr,body){for(var args=[],arity=0;arity<16&&body.indexOf("$"+arity)!=-1;arity++)args.push("$"+arity);args=args.join(",");var func="("+args+" ) => { "+body+"};";eval(func);}if(updateTableMap(tableBase,metadata.tableSize),moduleExports=relocateExports(instance.exports,memoryBase),flags.allowUndefined||reportUndefinedSymbols(),"__start_em_asm"in moduleExports)for(var start=moduleExports.__start_em_asm,stop=moduleExports.__stop_em_asm;start<stop;){var jsString=UTF8ToString(start);addEmAsm(start,jsString),start=HEAPU8.indexOf(0,start)+1;}var applyRelocs=moduleExports.__wasm_apply_data_relocs;applyRelocs&&(runtimeInitialized?applyRelocs():__RELOC_FUNCS__.push(applyRelocs));var init=moduleExports.__wasm_call_ctors;return init&&(runtimeInitialized?init():__ATINIT__.push(init)),moduleExports}if(flags.loadAsync){if(binary instanceof WebAssembly.Module){var instance=new WebAssembly.Instance(binary,info);return Promise.resolve(postInstantiation(instance))}return WebAssembly.instantiate(binary,info).then(function(e){return postInstantiation(e.instance)})}var module=binary instanceof WebAssembly.Module?binary:new WebAssembly.Module(binary),instance=new WebAssembly.Instance(module,info);return postInstantiation(instance)}return CurrentModuleWeakSymbols=metadata.weakImports,flags.loadAsync?metadata.neededDynlibs.reduce(function(e,t){return e.then(function(){return loadDynamicLibrary(t,flags)})},Promise.resolve()).then(function(){return loadModule()}):(metadata.neededDynlibs.forEach(function(e){loadDynamicLibrary(e,flags);}),loadModule())}function loadDynamicLibrary(e,t,r){t=t||{global:!0,nodelete:!0};var n=LDSO.loadedLibsByName[e];if(n)return t.global&&!n.global&&(n.global=!0,n.module!=="loading"&&mergeLibSymbols(n.module)),t.nodelete&&n.refcount!==1/0&&(n.refcount=1/0),n.refcount++,r&&(LDSO.loadedLibsByHandle[r]=n),!t.loadAsync||Promise.resolve(!0);function i(o){if(t.fs&&t.fs.findObject(o)){var c=t.fs.readFile(o,{encoding:"binary"});return c instanceof Uint8Array||(c=new Uint8Array(c)),t.loadAsync?Promise.resolve(c):c}if(o=locateFile(o),t.loadAsync)return new Promise(function(l,u){readAsync(o,f=>l(new Uint8Array(f)),u);});if(!readBinary)throw new Error(o+": file not found, and synchronous loading of external files is not available");return readBinary(o)}function s(){if(typeof preloadedWasm<"u"&&preloadedWasm[e]){var o=preloadedWasm[e];return t.loadAsync?Promise.resolve(o):o}return t.loadAsync?i(e).then(function(c){return loadWebAssemblyModule(c,t,r)}):loadWebAssemblyModule(i(e),t,r)}function a(o){n.global&&mergeLibSymbols(o),n.module=o;}return n={refcount:t.nodelete?1/0:1,name:e,module:"loading",global:t.global},LDSO.loadedLibsByName[e]=n,r&&(LDSO.loadedLibsByHandle[r]=n),t.loadAsync?s().then(function(o){return a(o),!0}):(a(s()),!0)}function reportUndefinedSymbols(){for(var e in GOT)if(GOT[e].value==0){var t=resolveGlobalSymbol(e,!0);if(!t&&!GOT[e].required)continue;if(typeof t=="function")GOT[e].value=addFunction(t,t.sig);else {if(typeof t!="number")throw new Error("bad export type for `"+e+"`: "+typeof t);GOT[e].value=t;}}}function preloadDylibs(){dynamicLibraries.length?(addRunDependency(),dynamicLibraries.reduce(function(e,t){return e.then(function(){return loadDynamicLibrary(t,{loadAsync:!0,global:!0,nodelete:!0,allowUndefined:!0})})},Promise.resolve()).then(function(){reportUndefinedSymbols(),removeRunDependency();})):reportUndefinedSymbols();}function setValue(e,t,r="i8"){switch(r.endsWith("*")&&(r="*"),r){case"i1":case"i8":HEAP8[e>>0]=t;break;case"i16":HEAP16[e>>1]=t;break;case"i32":HEAP32[e>>2]=t;break;case"i64":tempI64=[t>>>0,(tempDouble=t,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[e>>2]=tempI64[0],HEAP32[e+4>>2]=tempI64[1];break;case"float":HEAPF32[e>>2]=t;break;case"double":HEAPF64[e>>3]=t;break;case"*":HEAPU32[e>>2]=t;break;default:abort("invalid type for setValue: "+r);}}var ___memory_base=new WebAssembly.Global({value:"i32",mutable:!1},1024),___stack_pointer=new WebAssembly.Global({value:"i32",mutable:!0},78144),___table_base=new WebAssembly.Global({value:"i32",mutable:!1},1),nowIsMonotonic=!0,_emscripten_get_now;function __emscripten_get_now_is_monotonic(){return nowIsMonotonic}function _abort(){abort("");}function _emscripten_memcpy_big(e,t,r){HEAPU8.copyWithin(e,t,t+r);}function getHeapMax(){return 2147483648}function emscripten_realloc_buffer(e){try{return wasmMemory.grow(e-buffer.byteLength+65535>>>16),updateGlobalBufferAndViews(wasmMemory.buffer),1}catch{}}function _emscripten_resize_heap(e){var t=HEAPU8.length;e>>>=0;var r=getHeapMax();if(e>r)return !1;for(var n=1;n<=4;n*=2){var i=t*(1+.2/n);if(i=Math.min(i,e+100663296),emscripten_realloc_buffer(Math.min(r,(s=Math.max(e,i))+((a=65536)-s%a)%a)))return !0}var s,a;return !1}__emscripten_get_now_is_monotonic.sig="i",Module._abort=_abort,_abort.sig="v",_emscripten_get_now=ENVIRONMENT_IS_NODE?()=>{var e=process.hrtime();return 1e3*e[0]+e[1]/1e6}:()=>performance.now(),_emscripten_get_now.sig="d",_emscripten_memcpy_big.sig="vppp",_emscripten_resize_heap.sig="ip";var SYSCALLS={DEFAULT_POLLMASK:5,calculateAt:function(e,t,r){if(PATH.isAbs(t))return t;var n;if(e===-100?n=FS.cwd():n=SYSCALLS.getStreamFromFD(e).path,t.length==0){if(!r)throw new FS.ErrnoError(44);return n}return PATH.join2(n,t)},doStat:function(e,t,r){try{var n=e(t);}catch(o){if(o&&o.node&&PATH.normalize(t)!==PATH.normalize(FS.getPath(o.node)))return -54;throw o}HEAP32[r>>2]=n.dev,HEAP32[r+8>>2]=n.ino,HEAP32[r+12>>2]=n.mode,HEAPU32[r+16>>2]=n.nlink,HEAP32[r+20>>2]=n.uid,HEAP32[r+24>>2]=n.gid,HEAP32[r+28>>2]=n.rdev,tempI64=[n.size>>>0,(tempDouble=n.size,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+40>>2]=tempI64[0],HEAP32[r+44>>2]=tempI64[1],HEAP32[r+48>>2]=4096,HEAP32[r+52>>2]=n.blocks;var i=n.atime.getTime(),s=n.mtime.getTime(),a=n.ctime.getTime();return tempI64=[Math.floor(i/1e3)>>>0,(tempDouble=Math.floor(i/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+56>>2]=tempI64[0],HEAP32[r+60>>2]=tempI64[1],HEAPU32[r+64>>2]=i%1e3*1e3,tempI64=[Math.floor(s/1e3)>>>0,(tempDouble=Math.floor(s/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+72>>2]=tempI64[0],HEAP32[r+76>>2]=tempI64[1],HEAPU32[r+80>>2]=s%1e3*1e3,tempI64=[Math.floor(a/1e3)>>>0,(tempDouble=Math.floor(a/1e3),+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+88>>2]=tempI64[0],HEAP32[r+92>>2]=tempI64[1],HEAPU32[r+96>>2]=a%1e3*1e3,tempI64=[n.ino>>>0,(tempDouble=n.ino,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[r+104>>2]=tempI64[0],HEAP32[r+108>>2]=tempI64[1],0},doMsync:function(e,t,r,n,i){if(!FS.isFile(t.node.mode))throw new FS.ErrnoError(43);if(2&n)return 0;var s=HEAPU8.slice(e,e+r);FS.msync(t,s,i,r,n);},varargs:void 0,get:function(){return SYSCALLS.varargs+=4,HEAP32[SYSCALLS.varargs-4>>2]},getStr:function(e){return UTF8ToString(e)},getStreamFromFD:function(e){var t=FS.getStream(e);if(!t)throw new FS.ErrnoError(8);return t}};function _proc_exit(e){EXITSTATUS=e,keepRuntimeAlive()||(Module.onExit&&Module.onExit(e),ABORT=!0),quit_(e,new ExitStatus(e));}function exitJS(e,t){EXITSTATUS=e,_proc_exit(e);}_proc_exit.sig="vi";var _exit=exitJS;function _fd_close(e){try{var t=SYSCALLS.getStreamFromFD(e);return FS.close(t),0}catch(r){if(typeof FS>"u"||!(r instanceof FS.ErrnoError))throw r;return r.errno}}function convertI32PairToI53Checked(e,t){return t+2097152>>>0<4194305-!!e?(e>>>0)+4294967296*t:NaN}function _fd_seek(e,t,r,n,i){try{var s=convertI32PairToI53Checked(t,r);if(isNaN(s))return 61;var a=SYSCALLS.getStreamFromFD(e);return FS.llseek(a,s,n),tempI64=[a.position>>>0,(tempDouble=a.position,+Math.abs(tempDouble)>=1?tempDouble>0?(0|Math.min(+Math.floor(tempDouble/4294967296),4294967295))>>>0:~~+Math.ceil((tempDouble-+(~~tempDouble>>>0))/4294967296)>>>0:0)],HEAP32[i>>2]=tempI64[0],HEAP32[i+4>>2]=tempI64[1],a.getdents&&s===0&&n===0&&(a.getdents=null),0}catch(o){if(typeof FS>"u"||!(o instanceof FS.ErrnoError))throw o;return o.errno}}function doWritev(e,t,r,n){for(var i=0,s=0;s<r;s++){var a=HEAPU32[t>>2],o=HEAPU32[t+4>>2];t+=8;var c=FS.write(e,HEAP8,a,o,n);if(c<0)return -1;i+=c,n!==void 0&&(n+=c);}return i}function _fd_write(e,t,r,n){try{var i=doWritev(SYSCALLS.getStreamFromFD(e),t,r);return HEAPU32[n>>2]=i,0}catch(s){if(typeof FS>"u"||!(s instanceof FS.ErrnoError))throw s;return s.errno}}function _tree_sitter_log_callback(e,t){if(currentLogCallback){let r=UTF8ToString(t);currentLogCallback(r,e!==0);}}function _tree_sitter_parse_callback(e,t,r,n,i){var s=currentParseCallback(t,{row:r,column:n});typeof s=="string"?(setValue(i,s.length,"i32"),stringToUTF16(s,e,10240)):setValue(i,0,"i32");}function handleException(e){if(e instanceof ExitStatus||e=="unwind")return EXITSTATUS;quit_(1,e);}function allocateUTF8OnStack(e){var t=lengthBytesUTF8(e)+1,r=stackAlloc(t);return stringToUTF8Array(e,HEAP8,r,t),r}function stringToUTF16(e,t,r){if(r===void 0&&(r=2147483647),r<2)return 0;for(var n=t,i=(r-=2)<2*e.length?r/2:e.length,s=0;s<i;++s){var a=e.charCodeAt(s);HEAP16[t>>1]=a,t+=2;}return HEAP16[t>>1]=0,t-n}function AsciiToString(e){for(var t="";;){var r=HEAPU8[e++>>0];if(!r)return t;t+=String.fromCharCode(r);}}_exit.sig="vi",_fd_close.sig="ii",_fd_seek.sig="iijip",_fd_write.sig="iippp";var asmLibraryArg={__heap_base:___heap_base,__indirect_function_table:wasmTable,__memory_base:___memory_base,__stack_pointer:___stack_pointer,__table_base:___table_base,_emscripten_get_now_is_monotonic:__emscripten_get_now_is_monotonic,abort:_abort,emscripten_get_now:_emscripten_get_now,emscripten_memcpy_big:_emscripten_memcpy_big,emscripten_resize_heap:_emscripten_resize_heap,exit:_exit,fd_close:_fd_close,fd_seek:_fd_seek,fd_write:_fd_write,memory:wasmMemory,tree_sitter_log_callback:_tree_sitter_log_callback,tree_sitter_parse_callback:_tree_sitter_parse_callback};createWasm();Module.___wasm_call_ctors=function(){return (Module.___wasm_call_ctors=Module.asm.__wasm_call_ctors).apply(null,arguments)};Module.___wasm_apply_data_relocs=function(){return (Module.___wasm_apply_data_relocs=Module.asm.__wasm_apply_data_relocs).apply(null,arguments)};var _malloc=Module._malloc=function(){return (_malloc=Module._malloc=Module.asm.malloc).apply(null,arguments)};Module._calloc=function(){return (Module._calloc=Module.asm.calloc).apply(null,arguments)};Module._realloc=function(){return (Module._realloc=Module.asm.realloc).apply(null,arguments)};Module._free=function(){return (Module._free=Module.asm.free).apply(null,arguments)};Module._ts_language_symbol_count=function(){return (Module._ts_language_symbol_count=Module.asm.ts_language_symbol_count).apply(null,arguments)};Module._ts_language_version=function(){return (Module._ts_language_version=Module.asm.ts_language_version).apply(null,arguments)};Module._ts_language_field_count=function(){return (Module._ts_language_field_count=Module.asm.ts_language_field_count).apply(null,arguments)};Module._ts_language_symbol_name=function(){return (Module._ts_language_symbol_name=Module.asm.ts_language_symbol_name).apply(null,arguments)};Module._ts_language_symbol_for_name=function(){return (Module._ts_language_symbol_for_name=Module.asm.ts_language_symbol_for_name).apply(null,arguments)};Module._ts_language_symbol_type=function(){return (Module._ts_language_symbol_type=Module.asm.ts_language_symbol_type).apply(null,arguments)};Module._ts_language_field_name_for_id=function(){return (Module._ts_language_field_name_for_id=Module.asm.ts_language_field_name_for_id).apply(null,arguments)};Module._memset=function(){return (Module._memset=Module.asm.memset).apply(null,arguments)};Module._memcpy=function(){return (Module._memcpy=Module.asm.memcpy).apply(null,arguments)};Module._ts_parser_delete=function(){return (Module._ts_parser_delete=Module.asm.ts_parser_delete).apply(null,arguments)};Module._ts_parser_reset=function(){return (Module._ts_parser_reset=Module.asm.ts_parser_reset).apply(null,arguments)};Module._ts_parser_set_language=function(){return (Module._ts_parser_set_language=Module.asm.ts_parser_set_language).apply(null,arguments)};Module._ts_parser_timeout_micros=function(){return (Module._ts_parser_timeout_micros=Module.asm.ts_parser_timeout_micros).apply(null,arguments)};Module._ts_parser_set_timeout_micros=function(){return (Module._ts_parser_set_timeout_micros=Module.asm.ts_parser_set_timeout_micros).apply(null,arguments)};Module._memmove=function(){return (Module._memmove=Module.asm.memmove).apply(null,arguments)};Module._memcmp=function(){return (Module._memcmp=Module.asm.memcmp).apply(null,arguments)};Module._ts_query_new=function(){return (Module._ts_query_new=Module.asm.ts_query_new).apply(null,arguments)};Module._ts_query_delete=function(){return (Module._ts_query_delete=Module.asm.ts_query_delete).apply(null,arguments)};Module._iswspace=function(){return (Module._iswspace=Module.asm.iswspace).apply(null,arguments)};Module._iswalnum=function(){return (Module._iswalnum=Module.asm.iswalnum).apply(null,arguments)};Module._ts_query_pattern_count=function(){return (Module._ts_query_pattern_count=Module.asm.ts_query_pattern_count).apply(null,arguments)};Module._ts_query_capture_count=function(){return (Module._ts_query_capture_count=Module.asm.ts_query_capture_count).apply(null,arguments)};Module._ts_query_string_count=function(){return (Module._ts_query_string_count=Module.asm.ts_query_string_count).apply(null,arguments)};Module._ts_query_capture_name_for_id=function(){return (Module._ts_query_capture_name_for_id=Module.asm.ts_query_capture_name_for_id).apply(null,arguments)};Module._ts_query_string_value_for_id=function(){return (Module._ts_query_string_value_for_id=Module.asm.ts_query_string_value_for_id).apply(null,arguments)};Module._ts_query_predicates_for_pattern=function(){return (Module._ts_query_predicates_for_pattern=Module.asm.ts_query_predicates_for_pattern).apply(null,arguments)};Module._ts_tree_copy=function(){return (Module._ts_tree_copy=Module.asm.ts_tree_copy).apply(null,arguments)};Module._ts_tree_delete=function(){return (Module._ts_tree_delete=Module.asm.ts_tree_delete).apply(null,arguments)};Module._ts_init=function(){return (Module._ts_init=Module.asm.ts_init).apply(null,arguments)};Module._ts_parser_new_wasm=function(){return (Module._ts_parser_new_wasm=Module.asm.ts_parser_new_wasm).apply(null,arguments)};Module._ts_parser_enable_logger_wasm=function(){return (Module._ts_parser_enable_logger_wasm=Module.asm.ts_parser_enable_logger_wasm).apply(null,arguments)};Module._ts_parser_parse_wasm=function(){return (Module._ts_parser_parse_wasm=Module.asm.ts_parser_parse_wasm).apply(null,arguments)};Module._ts_language_type_is_named_wasm=function(){return (Module._ts_language_type_is_named_wasm=Module.asm.ts_language_type_is_named_wasm).apply(null,arguments)};Module._ts_language_type_is_visible_wasm=function(){return (Module._ts_language_type_is_visible_wasm=Module.asm.ts_language_type_is_visible_wasm).apply(null,arguments)};Module._ts_tree_root_node_wasm=function(){return (Module._ts_tree_root_node_wasm=Module.asm.ts_tree_root_node_wasm).apply(null,arguments)};Module._ts_tree_edit_wasm=function(){return (Module._ts_tree_edit_wasm=Module.asm.ts_tree_edit_wasm).apply(null,arguments)};Module._ts_tree_get_changed_ranges_wasm=function(){return (Module._ts_tree_get_changed_ranges_wasm=Module.asm.ts_tree_get_changed_ranges_wasm).apply(null,arguments)};Module._ts_tree_cursor_new_wasm=function(){return (Module._ts_tree_cursor_new_wasm=Module.asm.ts_tree_cursor_new_wasm).apply(null,arguments)};Module._ts_tree_cursor_delete_wasm=function(){return (Module._ts_tree_cursor_delete_wasm=Module.asm.ts_tree_cursor_delete_wasm).apply(null,arguments)};Module._ts_tree_cursor_reset_wasm=function(){return (Module._ts_tree_cursor_reset_wasm=Module.asm.ts_tree_cursor_reset_wasm).apply(null,arguments)};Module._ts_tree_cursor_goto_first_child_wasm=function(){return (Module._ts_tree_cursor_goto_first_child_wasm=Module.asm.ts_tree_cursor_goto_first_child_wasm).apply(null,arguments)};Module._ts_tree_cursor_goto_next_sibling_wasm=function(){return (Module._ts_tree_cursor_goto_next_sibling_wasm=Module.asm.ts_tree_cursor_goto_next_sibling_wasm).apply(null,arguments)};Module._ts_tree_cursor_goto_parent_wasm=function(){return (Module._ts_tree_cursor_goto_parent_wasm=Module.asm.ts_tree_cursor_goto_parent_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_type_id_wasm=function(){return (Module._ts_tree_cursor_current_node_type_id_wasm=Module.asm.ts_tree_cursor_current_node_type_id_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_is_named_wasm=function(){return (Module._ts_tree_cursor_current_node_is_named_wasm=Module.asm.ts_tree_cursor_current_node_is_named_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_is_missing_wasm=function(){return (Module._ts_tree_cursor_current_node_is_missing_wasm=Module.asm.ts_tree_cursor_current_node_is_missing_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_id_wasm=function(){return (Module._ts_tree_cursor_current_node_id_wasm=Module.asm.ts_tree_cursor_current_node_id_wasm).apply(null,arguments)};Module._ts_tree_cursor_start_position_wasm=function(){return (Module._ts_tree_cursor_start_position_wasm=Module.asm.ts_tree_cursor_start_position_wasm).apply(null,arguments)};Module._ts_tree_cursor_end_position_wasm=function(){return (Module._ts_tree_cursor_end_position_wasm=Module.asm.ts_tree_cursor_end_position_wasm).apply(null,arguments)};Module._ts_tree_cursor_start_index_wasm=function(){return (Module._ts_tree_cursor_start_index_wasm=Module.asm.ts_tree_cursor_start_index_wasm).apply(null,arguments)};Module._ts_tree_cursor_end_index_wasm=function(){return (Module._ts_tree_cursor_end_index_wasm=Module.asm.ts_tree_cursor_end_index_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_field_id_wasm=function(){return (Module._ts_tree_cursor_current_field_id_wasm=Module.asm.ts_tree_cursor_current_field_id_wasm).apply(null,arguments)};Module._ts_tree_cursor_current_node_wasm=function(){return (Module._ts_tree_cursor_current_node_wasm=Module.asm.ts_tree_cursor_current_node_wasm).apply(null,arguments)};Module._ts_node_symbol_wasm=function(){return (Module._ts_node_symbol_wasm=Module.asm.ts_node_symbol_wasm).apply(null,arguments)};Module._ts_node_child_count_wasm=function(){return (Module._ts_node_child_count_wasm=Module.asm.ts_node_child_count_wasm).apply(null,arguments)};Module._ts_node_named_child_count_wasm=function(){return (Module._ts_node_named_child_count_wasm=Module.asm.ts_node_named_child_count_wasm).apply(null,arguments)};Module._ts_node_child_wasm=function(){return (Module._ts_node_child_wasm=Module.asm.ts_node_child_wasm).apply(null,arguments)};Module._ts_node_named_child_wasm=function(){return (Module._ts_node_named_child_wasm=Module.asm.ts_node_named_child_wasm).apply(null,arguments)};Module._ts_node_child_by_field_id_wasm=function(){return (Module._ts_node_child_by_field_id_wasm=Module.asm.ts_node_child_by_field_id_wasm).apply(null,arguments)};Module._ts_node_next_sibling_wasm=function(){return (Module._ts_node_next_sibling_wasm=Module.asm.ts_node_next_sibling_wasm).apply(null,arguments)};Module._ts_node_prev_sibling_wasm=function(){return (Module._ts_node_prev_sibling_wasm=Module.asm.ts_node_prev_sibling_wasm).apply(null,arguments)};Module._ts_node_next_named_sibling_wasm=function(){return (Module._ts_node_next_named_sibling_wasm=Module.asm.ts_node_next_named_sibling_wasm).apply(null,arguments)};Module._ts_node_prev_named_sibling_wasm=function(){return (Module._ts_node_prev_named_sibling_wasm=Module.asm.ts_node_prev_named_sibling_wasm).apply(null,arguments)};Module._ts_node_parent_wasm=function(){return (Module._ts_node_parent_wasm=Module.asm.ts_node_parent_wasm).apply(null,arguments)};Module._ts_node_descendant_for_index_wasm=function(){return (Module._ts_node_descendant_for_index_wasm=Module.asm.ts_node_descendant_for_index_wasm).apply(null,arguments)};Module._ts_node_named_descendant_for_index_wasm=function(){return (Module._ts_node_named_descendant_for_index_wasm=Module.asm.ts_node_named_descendant_for_index_wasm).apply(null,arguments)};Module._ts_node_descendant_for_position_wasm=function(){return (Module._ts_node_descendant_for_position_wasm=Module.asm.ts_node_descendant_for_position_wasm).apply(null,arguments)};Module._ts_node_named_descendant_for_position_wasm=function(){return (Module._ts_node_named_descendant_for_position_wasm=Module.asm.ts_node_named_descendant_for_position_wasm).apply(null,arguments)};Module._ts_node_start_point_wasm=function(){return (Module._ts_node_start_point_wasm=Module.asm.ts_node_start_point_wasm).apply(null,arguments)};Module._ts_node_end_point_wasm=function(){return (Module._ts_node_end_point_wasm=Module.asm.ts_node_end_point_wasm).apply(null,arguments)};Module._ts_node_start_index_wasm=function(){return (Module._ts_node_start_index_wasm=Module.asm.ts_node_start_index_wasm).apply(null,arguments)};Module._ts_node_end_index_wasm=function(){return (Module._ts_node_end_index_wasm=Module.asm.ts_node_end_index_wasm).apply(null,arguments)};Module._ts_node_to_string_wasm=function(){return (Module._ts_node_to_string_wasm=Module.asm.ts_node_to_string_wasm).apply(null,arguments)};Module._ts_node_children_wasm=function(){return (Module._ts_node_children_wasm=Module.asm.ts_node_children_wasm).apply(null,arguments)};Module._ts_node_named_children_wasm=function(){return (Module._ts_node_named_children_wasm=Module.asm.ts_node_named_children_wasm).apply(null,arguments)};Module._ts_node_descendants_of_type_wasm=function(){return (Module._ts_node_descendants_of_type_wasm=Module.asm.ts_node_descendants_of_type_wasm).apply(null,arguments)};Module._ts_node_is_named_wasm=function(){return (Module._ts_node_is_named_wasm=Module.asm.ts_node_is_named_wasm).apply(null,arguments)};Module._ts_node_has_changes_wasm=function(){return (Module._ts_node_has_changes_wasm=Module.asm.ts_node_has_changes_wasm).apply(null,arguments)};Module._ts_node_has_error_wasm=function(){return (Module._ts_node_has_error_wasm=Module.asm.ts_node_has_error_wasm).apply(null,arguments)};Module._ts_node_is_missing_wasm=function(){return (Module._ts_node_is_missing_wasm=Module.asm.ts_node_is_missing_wasm).apply(null,arguments)};Module._ts_query_matches_wasm=function(){return (Module._ts_query_matches_wasm=Module.asm.ts_query_matches_wasm).apply(null,arguments)};Module._ts_query_captures_wasm=function(){return (Module._ts_query_captures_wasm=Module.asm.ts_query_captures_wasm).apply(null,arguments)};Module.___cxa_atexit=function(){return (Module.___cxa_atexit=Module.asm.__cxa_atexit).apply(null,arguments)};Module._iswdigit=function(){return (Module._iswdigit=Module.asm.iswdigit).apply(null,arguments)};Module._iswalpha=function(){return (Module._iswalpha=Module.asm.iswalpha).apply(null,arguments)};Module._iswlower=function(){return (Module._iswlower=Module.asm.iswlower).apply(null,arguments)};Module._memchr=function(){return (Module._memchr=Module.asm.memchr).apply(null,arguments)};Module._strlen=function(){return (Module._strlen=Module.asm.strlen).apply(null,arguments)};Module._towupper=function(){return (Module._towupper=Module.asm.towupper).apply(null,arguments)};var _setThrew=Module._setThrew=function(){return (_setThrew=Module._setThrew=Module.asm.setThrew).apply(null,arguments)},stackSave=Module.stackSave=function(){return (stackSave=Module.stackSave=Module.asm.stackSave).apply(null,arguments)},stackRestore=Module.stackRestore=function(){return (stackRestore=Module.stackRestore=Module.asm.stackRestore).apply(null,arguments)},stackAlloc=Module.stackAlloc=function(){return (stackAlloc=Module.stackAlloc=Module.asm.stackAlloc).apply(null,arguments)};Module.__Znwm=function(){return (Module.__Znwm=Module.asm._Znwm).apply(null,arguments)};Module.__ZdlPv=function(){return (Module.__ZdlPv=Module.asm._ZdlPv).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEmmmmmm=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEmmmmmm=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEmmmmmm).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcm=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcm=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcm).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEm=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEm=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEm).apply(null,arguments)};Module.__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcmm=function(){return (Module.__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcmm=Module.asm._ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcmm).apply(null,arguments)};Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc=function(){return (Module.__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc=Module.asm._ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc).apply(null,arguments)};Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev=function(){return (Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev=Module.asm._ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev).apply(null,arguments)};Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw=function(){return (Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw=Module.asm._ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw).apply(null,arguments)};Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEmw=function(){return (Module.__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEmw=Module.asm._ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEmw).apply(null,arguments)};Module.dynCall_jiji=function(){return (Module.dynCall_jiji=Module.asm.dynCall_jiji).apply(null,arguments)};Module._orig$ts_parser_timeout_micros=function(){return (Module._orig$ts_parser_timeout_micros=Module.asm.orig$ts_parser_timeout_micros).apply(null,arguments)};Module._orig$ts_parser_set_timeout_micros=function(){return (Module._orig$ts_parser_set_timeout_micros=Module.asm.orig$ts_parser_set_timeout_micros).apply(null,arguments)};var calledRun;function callMain(e){var t=Module._main;if(t){(e=e||[]).unshift(thisProgram);var r=e.length,n=stackAlloc(4*(r+1)),i=n>>2;e.forEach(a=>{HEAP32[i++]=allocateUTF8OnStack(a);}),HEAP32[i]=0;try{var s=t(r,n);return exitJS(s),s}catch(a){return handleException(a)}}}Module.AsciiToString=AsciiToString,Module.stringToUTF16=stringToUTF16,dependenciesFulfilled=function e(){calledRun||run(),calledRun||(dependenciesFulfilled=e);};var dylibsLoaded=!1;function run(e){function t(){calledRun||(calledRun=!0,Module.calledRun=!0,ABORT||(initRuntime(),preMain(),Module.onRuntimeInitialized&&Module.onRuntimeInitialized(),shouldRunNow&&callMain(e),postRun()));}e=e||arguments_,runDependencies>0||!dylibsLoaded&&(preloadDylibs(),dylibsLoaded=!0,runDependencies>0)||(preRun(),runDependencies>0||(Module.setStatus?(Module.setStatus("Running..."),setTimeout(function(){setTimeout(function(){Module.setStatus("");},1),t();},1)):t()));}if(Module.preInit)for(typeof Module.preInit=="function"&&(Module.preInit=[Module.preInit]);Module.preInit.length>0;)Module.preInit.pop()();var shouldRunNow=!0;Module.noInitialRun&&(shouldRunNow=!1),run();let C=Module,INTERNAL={},SIZE_OF_INT=4,SIZE_OF_NODE=5*SIZE_OF_INT,SIZE_OF_POINT=2*SIZE_OF_INT,SIZE_OF_RANGE=2*SIZE_OF_INT+2*SIZE_OF_POINT,ZERO_POINT={row:0,column:0},QUERY_WORD_REGEX=/[\w-.]*/g,PREDICATE_STEP_TYPE_CAPTURE=1,PREDICATE_STEP_TYPE_STRING=2,LANGUAGE_FUNCTION_REGEX=/^_?tree_sitter_\w+/;var VERSION,MIN_COMPATIBLE_VERSION,TRANSFER_BUFFER,currentParseCallback,currentLogCallback;class ParserImpl{static init(){TRANSFER_BUFFER=C._ts_init(),VERSION=getValue(TRANSFER_BUFFER,"i32"),MIN_COMPATIBLE_VERSION=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");}initialize(){C._ts_parser_new_wasm(),this[0]=getValue(TRANSFER_BUFFER,"i32"),this[1]=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");}delete(){C._ts_parser_delete(this[0]),C._free(this[1]),this[0]=0,this[1]=0;}setLanguage(t){let r;if(t){if(t.constructor!==Language)throw new Error("Argument must be a Language");{r=t[0];let n=C._ts_language_version(r);if(n<MIN_COMPATIBLE_VERSION||VERSION<n)throw new Error(`Incompatible language version ${n}. Compatibility range ${MIN_COMPATIBLE_VERSION} through ${VERSION}.`)}}else r=0,t=null;return this.language=t,C._ts_parser_set_language(this[0],r),this}getLanguage(){return this.language}parse(t,r,n){if(typeof t=="string")currentParseCallback=(c,l,u)=>t.slice(c,u);else {if(typeof t!="function")throw new Error("Argument must be a string or a function");currentParseCallback=t;}this.logCallback?(currentLogCallback=this.logCallback,C._ts_parser_enable_logger_wasm(this[0],1)):(currentLogCallback=null,C._ts_parser_enable_logger_wasm(this[0],0));let i=0,s=0;if(n&&n.includedRanges){i=n.includedRanges.length,s=C._calloc(i,SIZE_OF_RANGE);let c=s;for(let l=0;l<i;l++)marshalRange(c,n.includedRanges[l]),c+=SIZE_OF_RANGE;}let a=C._ts_parser_parse_wasm(this[0],this[1],r?r[0]:0,s,i);if(!a)throw currentParseCallback=null,currentLogCallback=null,new Error("Parsing failed");let o=new Tree(INTERNAL,a,this.language,currentParseCallback);return currentParseCallback=null,currentLogCallback=null,o}reset(){C._ts_parser_reset(this[0]);}setTimeoutMicros(t){C._ts_parser_set_timeout_micros(this[0],t);}getTimeoutMicros(){return C._ts_parser_timeout_micros(this[0])}setLogger(t){if(t){if(typeof t!="function")throw new Error("Logger callback must be a function")}else t=null;return this.logCallback=t,this}getLogger(){return this.logCallback}}class Tree{constructor(t,r,n,i){assertInternal(t),this[0]=r,this.language=n,this.textCallback=i;}copy(){let t=C._ts_tree_copy(this[0]);return new Tree(INTERNAL,t,this.language,this.textCallback)}delete(){C._ts_tree_delete(this[0]),this[0]=0;}edit(t){marshalEdit(t),C._ts_tree_edit_wasm(this[0]);}get rootNode(){return C._ts_tree_root_node_wasm(this[0]),unmarshalNode(this)}getLanguage(){return this.language}walk(){return this.rootNode.walk()}getChangedRanges(t){if(t.constructor!==Tree)throw new TypeError("Argument must be a Tree");C._ts_tree_get_changed_ranges_wasm(this[0],t[0]);let r=getValue(TRANSFER_BUFFER,"i32"),n=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),i=new Array(r);if(r>0){let s=n;for(let a=0;a<r;a++)i[a]=unmarshalRange(s),s+=SIZE_OF_RANGE;C._free(n);}return i}}class Node{constructor(t,r){assertInternal(t),this.tree=r;}get typeId(){return marshalNode(this),C._ts_node_symbol_wasm(this.tree[0])}get type(){return this.tree.language.types[this.typeId]||"ERROR"}get endPosition(){return marshalNode(this),C._ts_node_end_point_wasm(this.tree[0]),unmarshalPoint(TRANSFER_BUFFER)}get endIndex(){return marshalNode(this),C._ts_node_end_index_wasm(this.tree[0])}get text(){return getText(this.tree,this.startIndex,this.endIndex)}isNamed(){return marshalNode(this),C._ts_node_is_named_wasm(this.tree[0])===1}hasError(){return marshalNode(this),C._ts_node_has_error_wasm(this.tree[0])===1}hasChanges(){return marshalNode(this),C._ts_node_has_changes_wasm(this.tree[0])===1}isMissing(){return marshalNode(this),C._ts_node_is_missing_wasm(this.tree[0])===1}equals(t){return this.id===t.id}child(t){return marshalNode(this),C._ts_node_child_wasm(this.tree[0],t),unmarshalNode(this.tree)}namedChild(t){return marshalNode(this),C._ts_node_named_child_wasm(this.tree[0],t),unmarshalNode(this.tree)}childForFieldId(t){return marshalNode(this),C._ts_node_child_by_field_id_wasm(this.tree[0],t),unmarshalNode(this.tree)}childForFieldName(t){let r=this.tree.language.fields.indexOf(t);if(r!==-1)return this.childForFieldId(r)}get childCount(){return marshalNode(this),C._ts_node_child_count_wasm(this.tree[0])}get namedChildCount(){return marshalNode(this),C._ts_node_named_child_count_wasm(this.tree[0])}get firstChild(){return this.child(0)}get firstNamedChild(){return this.namedChild(0)}get lastChild(){return this.child(this.childCount-1)}get lastNamedChild(){return this.namedChild(this.namedChildCount-1)}get children(){if(!this._children){marshalNode(this),C._ts_node_children_wasm(this.tree[0]);let t=getValue(TRANSFER_BUFFER,"i32"),r=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");if(this._children=new Array(t),t>0){let n=r;for(let i=0;i<t;i++)this._children[i]=unmarshalNode(this.tree,n),n+=SIZE_OF_NODE;C._free(r);}}return this._children}get namedChildren(){if(!this._namedChildren){marshalNode(this),C._ts_node_named_children_wasm(this.tree[0]);let t=getValue(TRANSFER_BUFFER,"i32"),r=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32");if(this._namedChildren=new Array(t),t>0){let n=r;for(let i=0;i<t;i++)this._namedChildren[i]=unmarshalNode(this.tree,n),n+=SIZE_OF_NODE;C._free(r);}}return this._namedChildren}descendantsOfType(t,r,n){Array.isArray(t)||(t=[t]),r||(r=ZERO_POINT),n||(n=ZERO_POINT);let i=[],s=this.tree.language.types;for(let u=0,f=s.length;u<f;u++)t.includes(s[u])&&i.push(u);let a=C._malloc(SIZE_OF_INT*i.length);for(let u=0,f=i.length;u<f;u++)setValue(a+u*SIZE_OF_INT,i[u],"i32");marshalNode(this),C._ts_node_descendants_of_type_wasm(this.tree[0],a,i.length,r.row,r.column,n.row,n.column);let o=getValue(TRANSFER_BUFFER,"i32"),c=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),l=new Array(o);if(o>0){let u=c;for(let f=0;f<o;f++)l[f]=unmarshalNode(this.tree,u),u+=SIZE_OF_NODE;}return C._free(c),C._free(a),l}get nextSibling(){return marshalNode(this),C._ts_node_next_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get previousSibling(){return marshalNode(this),C._ts_node_prev_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get nextNamedSibling(){return marshalNode(this),C._ts_node_next_named_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get previousNamedSibling(){return marshalNode(this),C._ts_node_prev_named_sibling_wasm(this.tree[0]),unmarshalNode(this.tree)}get parent(){return marshalNode(this),C._ts_node_parent_wasm(this.tree[0]),unmarshalNode(this.tree)}descendantForIndex(t,r=t){if(typeof t!="number"||typeof r!="number")throw new Error("Arguments must be numbers");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return setValue(n,t,"i32"),setValue(n+SIZE_OF_INT,r,"i32"),C._ts_node_descendant_for_index_wasm(this.tree[0]),unmarshalNode(this.tree)}namedDescendantForIndex(t,r=t){if(typeof t!="number"||typeof r!="number")throw new Error("Arguments must be numbers");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return setValue(n,t,"i32"),setValue(n+SIZE_OF_INT,r,"i32"),C._ts_node_named_descendant_for_index_wasm(this.tree[0]),unmarshalNode(this.tree)}descendantForPosition(t,r=t){if(!isPoint(t)||!isPoint(r))throw new Error("Arguments must be {row, column} objects");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return marshalPoint(n,t),marshalPoint(n+SIZE_OF_POINT,r),C._ts_node_descendant_for_position_wasm(this.tree[0]),unmarshalNode(this.tree)}namedDescendantForPosition(t,r=t){if(!isPoint(t)||!isPoint(r))throw new Error("Arguments must be {row, column} objects");marshalNode(this);let n=TRANSFER_BUFFER+SIZE_OF_NODE;return marshalPoint(n,t),marshalPoint(n+SIZE_OF_POINT,r),C._ts_node_named_descendant_for_position_wasm(this.tree[0]),unmarshalNode(this.tree)}walk(){return marshalNode(this),C._ts_tree_cursor_new_wasm(this.tree[0]),new TreeCursor(INTERNAL,this.tree)}toString(){marshalNode(this);let t=C._ts_node_to_string_wasm(this.tree[0]),r=AsciiToString(t);return C._free(t),r}}class TreeCursor{constructor(t,r){assertInternal(t),this.tree=r,unmarshalTreeCursor(this);}delete(){marshalTreeCursor(this),C._ts_tree_cursor_delete_wasm(this.tree[0]),this[0]=this[1]=this[2]=0;}reset(t){marshalNode(t),marshalTreeCursor(this,TRANSFER_BUFFER+SIZE_OF_NODE),C._ts_tree_cursor_reset_wasm(this.tree[0]),unmarshalTreeCursor(this);}get nodeType(){return this.tree.language.types[this.nodeTypeId]||"ERROR"}get nodeTypeId(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_type_id_wasm(this.tree[0])}get nodeId(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_id_wasm(this.tree[0])}get nodeIsNamed(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_is_named_wasm(this.tree[0])===1}get nodeIsMissing(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_is_missing_wasm(this.tree[0])===1}get nodeText(){marshalTreeCursor(this);let t=C._ts_tree_cursor_start_index_wasm(this.tree[0]),r=C._ts_tree_cursor_end_index_wasm(this.tree[0]);return getText(this.tree,t,r)}get startPosition(){return marshalTreeCursor(this),C._ts_tree_cursor_start_position_wasm(this.tree[0]),unmarshalPoint(TRANSFER_BUFFER)}get endPosition(){return marshalTreeCursor(this),C._ts_tree_cursor_end_position_wasm(this.tree[0]),unmarshalPoint(TRANSFER_BUFFER)}get startIndex(){return marshalTreeCursor(this),C._ts_tree_cursor_start_index_wasm(this.tree[0])}get endIndex(){return marshalTreeCursor(this),C._ts_tree_cursor_end_index_wasm(this.tree[0])}currentNode(){return marshalTreeCursor(this),C._ts_tree_cursor_current_node_wasm(this.tree[0]),unmarshalNode(this.tree)}currentFieldId(){return marshalTreeCursor(this),C._ts_tree_cursor_current_field_id_wasm(this.tree[0])}currentFieldName(){return this.tree.language.fields[this.currentFieldId()]}gotoFirstChild(){marshalTreeCursor(this);let t=C._ts_tree_cursor_goto_first_child_wasm(this.tree[0]);return unmarshalTreeCursor(this),t===1}gotoNextSibling(){marshalTreeCursor(this);let t=C._ts_tree_cursor_goto_next_sibling_wasm(this.tree[0]);return unmarshalTreeCursor(this),t===1}gotoParent(){marshalTreeCursor(this);let t=C._ts_tree_cursor_goto_parent_wasm(this.tree[0]);return unmarshalTreeCursor(this),t===1}}class Language{constructor(t,r){assertInternal(t),this[0]=r,this.types=new Array(C._ts_language_symbol_count(this[0]));for(let n=0,i=this.types.length;n<i;n++)C._ts_language_symbol_type(this[0],n)<2&&(this.types[n]=UTF8ToString(C._ts_language_symbol_name(this[0],n)));this.fields=new Array(C._ts_language_field_count(this[0])+1);for(let n=0,i=this.fields.length;n<i;n++){let s=C._ts_language_field_name_for_id(this[0],n);this.fields[n]=s!==0?UTF8ToString(s):null;}}get version(){return C._ts_language_version(this[0])}get fieldCount(){return this.fields.length-1}fieldIdForName(t){let r=this.fields.indexOf(t);return r!==-1?r:null}fieldNameForId(t){return this.fields[t]||null}idForNodeType(t,r){let n=lengthBytesUTF8(t),i=C._malloc(n+1);stringToUTF8(t,i,n+1);let s=C._ts_language_symbol_for_name(this[0],i,n,r);return C._free(i),s||null}get nodeTypeCount(){return C._ts_language_symbol_count(this[0])}nodeTypeForId(t){let r=C._ts_language_symbol_name(this[0],t);return r?UTF8ToString(r):null}nodeTypeIsNamed(t){return !!C._ts_language_type_is_named_wasm(this[0],t)}nodeTypeIsVisible(t){return !!C._ts_language_type_is_visible_wasm(this[0],t)}query(t){let r=lengthBytesUTF8(t),n=C._malloc(r+1);stringToUTF8(t,n,r+1);let i=C._ts_query_new(this[0],n,r,TRANSFER_BUFFER,TRANSFER_BUFFER+SIZE_OF_INT);if(!i){let _=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),E=UTF8ToString(n,getValue(TRANSFER_BUFFER,"i32")).length,w=t.substr(E,100).split(`
`)[0],y,b=w.match(QUERY_WORD_REGEX)[0];switch(_){case 2:y=new RangeError(`Bad node name '${b}'`);break;case 3:y=new RangeError(`Bad field name '${b}'`);break;case 4:y=new RangeError(`Bad capture name @${b}`);break;case 5:y=new TypeError(`Bad pattern structure at offset ${E}: '${w}'...`),b="";break;default:y=new SyntaxError(`Bad syntax at offset ${E}: '${w}'...`),b="";}throw y.index=E,y.length=b.length,C._free(n),y}let s=C._ts_query_string_count(i),a=C._ts_query_capture_count(i),o=C._ts_query_pattern_count(i),c=new Array(a),l=new Array(s);for(let _=0;_<a;_++){let E=C._ts_query_capture_name_for_id(i,_,TRANSFER_BUFFER),w=getValue(TRANSFER_BUFFER,"i32");c[_]=UTF8ToString(E,w);}for(let _=0;_<s;_++){let E=C._ts_query_string_value_for_id(i,_,TRANSFER_BUFFER),w=getValue(TRANSFER_BUFFER,"i32");l[_]=UTF8ToString(E,w);}let u=new Array(o),f=new Array(o),h=new Array(o),p=new Array(o),g=new Array(o);for(let _=0;_<o;_++){let E=C._ts_query_predicates_for_pattern(i,_,TRANSFER_BUFFER),w=getValue(TRANSFER_BUFFER,"i32");p[_]=[],g[_]=[];let y=[],b=E;for(let N=0;N<w;N++){let L=getValue(b,"i32");b+=SIZE_OF_INT;let V=getValue(b,"i32");if(b+=SIZE_OF_INT,L===PREDICATE_STEP_TYPE_CAPTURE)y.push({type:"capture",name:c[V]});else if(L===PREDICATE_STEP_TYPE_STRING)y.push({type:"string",value:l[V]});else if(y.length>0){if(y[0].type!=="string")throw new Error("Predicates must begin with a literal value");let Z=y[0].value,G=!0;switch(Z){case"not-eq?":G=!1;case"eq?":if(y.length!==3)throw new Error("Wrong number of arguments to `#eq?` predicate. Expected 2, got "+(y.length-1));if(y[1].type!=="capture")throw new Error(`First argument of \`#eq?\` predicate must be a capture. Got "${y[1].value}"`);if(y[2].type==="capture"){let ie=y[1].name,me=y[2].name;g[_].push(function(Pe){let W,K;for(let se of Pe)se.name===ie&&(W=se.node),se.name===me&&(K=se.node);return W===void 0||K===void 0||W.text===K.text===G});}else {let ie=y[1].name,me=y[2].value;g[_].push(function(Pe){for(let W of Pe)if(W.name===ie)return W.node.text===me===G;return !0});}break;case"not-match?":G=!1;case"match?":if(y.length!==3)throw new Error(`Wrong number of arguments to \`#match?\` predicate. Expected 2, got ${y.length-1}.`);if(y[1].type!=="capture")throw new Error(`First argument of \`#match?\` predicate must be a capture. Got "${y[1].value}".`);if(y[2].type!=="string")throw new Error(`Second argument of \`#match?\` predicate must be a string. Got @${y[2].value}.`);let z=y[1].name,ee=new RegExp(y[2].value);g[_].push(function(ie){for(let me of ie)if(me.name===z)return ee.test(me.node.text)===G;return !0});break;case"set!":if(y.length<2||y.length>3)throw new Error(`Wrong number of arguments to \`#set!\` predicate. Expected 1 or 2. Got ${y.length-1}.`);if(y.some(ie=>ie.type!=="string"))throw new Error('Arguments to `#set!` predicate must be a strings.".');u[_]||(u[_]={}),u[_][y[1].value]=y[2]?y[2].value:null;break;case"is?":case"is-not?":if(y.length<2||y.length>3)throw new Error(`Wrong number of arguments to \`#${Z}\` predicate. Expected 1 or 2. Got ${y.length-1}.`);if(y.some(ie=>ie.type!=="string"))throw new Error(`Arguments to \`#${Z}\` predicate must be a strings.".`);let U=Z==="is?"?f:h;U[_]||(U[_]={}),U[_][y[1].value]=y[2]?y[2].value:null;break;default:p[_].push({operator:Z,operands:y.slice(1)});}y.length=0;}}Object.freeze(u[_]),Object.freeze(f[_]),Object.freeze(h[_]);}return C._free(n),new Query(INTERNAL,i,c,g,p,Object.freeze(u),Object.freeze(f),Object.freeze(h))}static load(t){let r;if(t instanceof Uint8Array)r=Promise.resolve(t);else {let i=t;if(typeof process<"u"&&process.versions&&process.versions.node){let s=he("fs");r=Promise.resolve(s.readFileSync(i));}else r=fetch(i).then(s=>s.arrayBuffer().then(a=>{if(s.ok)return new Uint8Array(a);{let o=new TextDecoder("utf-8").decode(a);throw new Error(`Language.load failed with status ${s.status}.

${o}`)}}));}let n=typeof loadSideModule=="function"?loadSideModule:loadWebAssemblyModule;return r.then(i=>n(i,{loadAsync:!0})).then(i=>{let s=Object.keys(i),a=s.find(c=>LANGUAGE_FUNCTION_REGEX.test(c)&&!c.includes("external_scanner_"));a||console.log(`Couldn't find language function in WASM file. Symbols:
${JSON.stringify(s,null,2)}`);let o=i[a]();return new Language(INTERNAL,o)})}}class Query{constructor(t,r,n,i,s,a,o,c){assertInternal(t),this[0]=r,this.captureNames=n,this.textPredicates=i,this.predicates=s,this.setProperties=a,this.assertedProperties=o,this.refutedProperties=c,this.exceededMatchLimit=!1;}delete(){C._ts_query_delete(this[0]),this[0]=0;}matches(t,r,n,i){r||(r=ZERO_POINT),n||(n=ZERO_POINT),i||(i={});let s=i.matchLimit;if(s===void 0)s=0;else if(typeof s!="number")throw new Error("Arguments must be numbers");marshalNode(t),C._ts_query_matches_wasm(this[0],t.tree[0],r.row,r.column,n.row,n.column,s);let a=getValue(TRANSFER_BUFFER,"i32"),o=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),c=getValue(TRANSFER_BUFFER+2*SIZE_OF_INT,"i32"),l=new Array(a);this.exceededMatchLimit=!!c;let u=0,f=o;for(let h=0;h<a;h++){let p=getValue(f,"i32");f+=SIZE_OF_INT;let g=getValue(f,"i32");f+=SIZE_OF_INT;let _=new Array(g);if(f=unmarshalCaptures(this,t.tree,f,_),this.textPredicates[p].every(E=>E(_))){l[u++]={pattern:p,captures:_};let E=this.setProperties[p];E&&(l[h].setProperties=E);let w=this.assertedProperties[p];w&&(l[h].assertedProperties=w);let y=this.refutedProperties[p];y&&(l[h].refutedProperties=y);}}return l.length=u,C._free(o),l}captures(t,r,n,i){r||(r=ZERO_POINT),n||(n=ZERO_POINT),i||(i={});let s=i.matchLimit;if(s===void 0)s=0;else if(typeof s!="number")throw new Error("Arguments must be numbers");marshalNode(t),C._ts_query_captures_wasm(this[0],t.tree[0],r.row,r.column,n.row,n.column,s);let a=getValue(TRANSFER_BUFFER,"i32"),o=getValue(TRANSFER_BUFFER+SIZE_OF_INT,"i32"),c=getValue(TRANSFER_BUFFER+2*SIZE_OF_INT,"i32"),l=[];this.exceededMatchLimit=!!c;let u=[],f=o;for(let h=0;h<a;h++){let p=getValue(f,"i32");f+=SIZE_OF_INT;let g=getValue(f,"i32");f+=SIZE_OF_INT;let _=getValue(f,"i32");if(f+=SIZE_OF_INT,u.length=g,f=unmarshalCaptures(this,t.tree,f,u),this.textPredicates[p].every(E=>E(u))){let E=u[_],w=this.setProperties[p];w&&(E.setProperties=w);let y=this.assertedProperties[p];y&&(E.assertedProperties=y);let b=this.refutedProperties[p];b&&(E.refutedProperties=b),l.push(E);}}return C._free(o),l}predicatesForPattern(t){return this.predicates[t]}didExceedMatchLimit(){return this.exceededMatchLimit}}function getText(e,t,r){let n=r-t,i=e.textCallback(t,null,r);for(t+=i.length;t<r;){let s=e.textCallback(t,null,r);if(!(s&&s.length>0))break;t+=s.length,i+=s;}return t>r&&(i=i.slice(0,n)),i}function unmarshalCaptures(e,t,r,n){for(let i=0,s=n.length;i<s;i++){let a=getValue(r,"i32"),o=unmarshalNode(t,r+=SIZE_OF_INT);r+=SIZE_OF_NODE,n[i]={name:e.captureNames[a],node:o};}return r}function assertInternal(e){if(e!==INTERNAL)throw new Error("Illegal constructor")}function isPoint(e){return e&&typeof e.row=="number"&&typeof e.column=="number"}function marshalNode(e){let t=TRANSFER_BUFFER;setValue(t,e.id,"i32"),t+=SIZE_OF_INT,setValue(t,e.startIndex,"i32"),t+=SIZE_OF_INT,setValue(t,e.startPosition.row,"i32"),t+=SIZE_OF_INT,setValue(t,e.startPosition.column,"i32"),t+=SIZE_OF_INT,setValue(t,e[0],"i32");}function unmarshalNode(e,t=TRANSFER_BUFFER){let r=getValue(t,"i32");if(r===0)return null;let n=getValue(t+=SIZE_OF_INT,"i32"),i=getValue(t+=SIZE_OF_INT,"i32"),s=getValue(t+=SIZE_OF_INT,"i32"),a=getValue(t+=SIZE_OF_INT,"i32"),o=new Node(INTERNAL,e);return o.id=r,o.startIndex=n,o.startPosition={row:i,column:s},o[0]=a,o}function marshalTreeCursor(e,t=TRANSFER_BUFFER){setValue(t+0*SIZE_OF_INT,e[0],"i32"),setValue(t+1*SIZE_OF_INT,e[1],"i32"),setValue(t+2*SIZE_OF_INT,e[2],"i32");}function unmarshalTreeCursor(e){e[0]=getValue(TRANSFER_BUFFER+0*SIZE_OF_INT,"i32"),e[1]=getValue(TRANSFER_BUFFER+1*SIZE_OF_INT,"i32"),e[2]=getValue(TRANSFER_BUFFER+2*SIZE_OF_INT,"i32");}function marshalPoint(e,t){setValue(e,t.row,"i32"),setValue(e+SIZE_OF_INT,t.column,"i32");}function unmarshalPoint(e){return {row:getValue(e,"i32"),column:getValue(e+SIZE_OF_INT,"i32")}}function marshalRange(e,t){marshalPoint(e,t.startPosition),marshalPoint(e+=SIZE_OF_POINT,t.endPosition),setValue(e+=SIZE_OF_POINT,t.startIndex,"i32"),setValue(e+=SIZE_OF_INT,t.endIndex,"i32"),e+=SIZE_OF_INT;}function unmarshalRange(e){let t={};return t.startPosition=unmarshalPoint(e),e+=SIZE_OF_POINT,t.endPosition=unmarshalPoint(e),e+=SIZE_OF_POINT,t.startIndex=getValue(e,"i32"),e+=SIZE_OF_INT,t.endIndex=getValue(e,"i32"),t}function marshalEdit(e){let t=TRANSFER_BUFFER;marshalPoint(t,e.startPosition),t+=SIZE_OF_POINT,marshalPoint(t,e.oldEndPosition),t+=SIZE_OF_POINT,marshalPoint(t,e.newEndPosition),t+=SIZE_OF_POINT,setValue(t,e.startIndex,"i32"),t+=SIZE_OF_INT,setValue(t,e.oldEndIndex,"i32"),t+=SIZE_OF_INT,setValue(t,e.newEndIndex,"i32"),t+=SIZE_OF_INT;}for(let e of Object.getOwnPropertyNames(ParserImpl.prototype))Object.defineProperty(Parser.prototype,e,{value:ParserImpl.prototype[e],enumerable:!1,writable:!1});Parser.Language=Language,Module.onRuntimeInitialized=()=>{ParserImpl.init(),resolveInitPromise();};}))}}return Parser}();typeof exports=="object"&&(module.exports=TreeSitter);});var nv=I(($de,NO)=>{var rv=class{constructor(t={}){let r=!t.flat&&t.base||1.001,n=t.precision??1e-9;if(!(n>0))throw new Error("precision must be a positive number");if(!(r>1)||!(r<1.5))throw new Error("base must be a number between 1 and 1.5");if(r+=1e-9,r=2**(1/Math.ceil(Math.log(2)/Math.log(r))),r===1)throw new Error("base too close to 1");n=Number.parseFloat(""+n);let i=Math.ceil(1/(r-1)),s=t.flat?1/0:n*i;t.flat?this._flat=!0:this._base=r,this._thresh=s,this._precision=n;}toJSON(){return this._flat?{precision:this._precision,flat:!0}:{precision:this._precision,base:this._base}}getBase(){return this._base}getPrecision(){return this._precision}round(t){if(typeof t!="number"&&(t=Number.parseFloat(t)),Number.isNaN(t))throw new Error("Attempt to round a non-numeric value: "+t);return t<0?-this.round(-t):t<this._thresh?Math.round(t/this._precision)*this._precision:this._thresh*this._base**Math.round(Math.log(t/this._thresh)/Math.log(this._base))}upper(t){return t<0?-this.lower(-t):(t=this.round(t),t<this._thresh?t+this._precision/2:t*Math.sqrt(this._base))}lower(t){return t<0?-this.upper(-t):(t=this.round(t),t<=this._thresh?t-this._precision/2:t/Math.sqrt(this._base))}shorten(t,r){return t===void 0?t:r===void 0?dc(this.lower(t),this.upper(t)):dc(t,r)}};function dc(e,t,r=10){if(e===t)return e;if(e*t<=0)return 0;if(t<0)return -dc(-t,-e,r);if(e>t)return dc(t,e,r);let n=-Math.floor(Math.log(t-e)/Math.log(r));for(;Math.ceil(e*r**n)<=Math.floor(t*r**n);)n--;return n++,n>=0?Math.ceil(e*r**n)/r**n:Math.ceil(e/r**-n)*r**-n}NO.exports={Binning:rv,shorten:dc};});var OO=I((jde,DO)=>{var{Binning:EJ}=nv(),wJ="stats-logscale/univariate@1.0",hc=class e extends EJ{constructor(t={}){super(t),this.storage=new Map,this._count=0,this._cache={},this.neat=new pc(this),t.bins&&this.addWeighted(t.bins);}add(...t){return this._cache={},t.forEach(r=>{let n=this.round(r),i=this.storage.get(n)??0;this.storage.set(n,i+1),this._count++;}),this}addWeighted(t){return this._cache={},t.forEach(r=>{let n=r[0],i=Number.parseFloat(r[1]);if(Number.isNaN(i))throw new Error("Attempt to provide a non-numeric weight");let s=this.round(n),a=(this.storage.get(s)??0)+i;a<=0?(this.storage.delete(s),this._count+=i-a):(this.storage.set(s,a),this._count+=i);}),this}toJSON(){return {version:wJ,...super.toJSON(),bins:this.getBins()}}clone(t={}){let r=this.getBins(t);return t.transform&&(r=r.map(n=>[t.transform(n[0]),n[1]])),new e({...super.toJSON(),bins:r})}getBins(t){if(this._cache.data||(this._cache.data=[...this.storage].sort((o,c)=>o[0]-c[0])),!t)return this._cache.data;let r=Math.max(t.min??-1/0,this.percentile(t.ltrim??0)),n=Math.min(t.max??1/0,this.percentile(100-(t.rtrim??0)));if(!t.winsorize)return this._cache.data.filter(o=>o[0]>=r&&o[0]<=n);let i=[this.round(r),0],s=[this.round(n),0],a=[i];for(let[o,c]of this._cache.data)o<=i[0]?i[1]+=c:o>=s[0]?s[1]+=c:a.push([o,c]);return s[1]>0&&a.push(s),a}count(){return this._count}min(){let t=this.getBins();return this.lower(t[0][0])}max(){let t=this.getBins();return this.upper(t[t.length-1][0])}sumOf(t){let r=0;return [...this.storage].forEach(n=>{r+=n[1]*t(n[0]);}),r}E(t){return this._count?this.sumOf(t)/this._count:void 0}mean(){return this._count?this.sumOf(t=>t)/this._count:void 0}stdev(){if(this._count<2)return;let t=this.mean();return Math.sqrt(this.sumOf(r=>(r-t)*(r-t))/(this._count-1))}skewness(){let t=this.count();return t<3?void 0:t*t/((t-1)*(t-2))*this.momentStd(3)}kurtosis(){let t=this.count();if(t<4)return;let r=t*t*(t+1)/((t-1)*(t-2)*(t-3)),n=(t-1)*(t-1)/((t-2)*(t-3));return this.momentStd(4)*r-3*n}moment(t,r){if(!Number.isInteger(t))throw new Error("Cannot calculate non-integer moment (did you mean momentAbs?)");return r===void 0&&(r=this.mean()),this.E(n=>(n-r)**t)}momentAbs(t=1,r){return r===void 0&&(r=this.mean()),this.E(n=>Math.abs(n-r)**t)}momentStd(t){return this.moment(t)/this.stdev()**t}quantile(t){let r=t*this._count,n=this._cumulative(),i=0,s=n.length;for(;i+1<s;){let c=Math.floor((s+i)/2);n[c][1]>=r?s=c:i=c;}let a=this.lower(n[i][0]),o=this.upper(n[i][0])-a;return a+o*(r-n[i][1])/(n[i][2]-n[i][1])}percentile(t){return this.quantile(t/100)}median(){return this.quantile(.5)}cdf(t){return this._rawCdf(t)/this._count}_rawCdf(t){let r=this._cumulative(),n=this.round(t),i=0,s=r.length;for(;i<s;){let o=Math.floor((s+i)/2);r[o][0]<n?i=o+1:s=o;}if(i>=r.length)return this._count;let a=i>0?r[i-1][2]:0;if(n===r[i][0]){let o=this.upper(t)-this.lower(t),c=r[i][2]-r[i][1];a+=o>0?c*(t-this.lower(t))/o:c/2;}return a}histogram(t={}){if(!this._count)return [];let r=this.min(),n=this.max(),i=t.count||10,s=[],a=r,o=(n-r)/i;for(let c=0;c<i;c++)s.push([this._rawCdf(a+o),a,a+=o]);for(let c=s.length;c-- >1;)s[c][0]-=s[c-1][0];if(s[0][0]-=this._rawCdf(r),t.scale){let c=0;for(let l=0;l<s.length;l++)c<s[l][0]&&(c=s[l][0]);for(let l=0;l<s.length;l++)s[l][0]=s[l][0]*t.scale/c;}return s}_cumulative(){if(!this._cache.cumulative){let t=this.getBins(),r=[],n=0;for(let i=0;i<t.length;i++)r.push([t[i][0],n,n+=t[i][1]]);this._cache.cumulative=r;}return this._cache.cumulative}};["cdf+","kurtosis","max","mean","min","moment+","momentAbs+","momentStd+","quantile+","skewness","stdev"].forEach(e=>{let t=!!e.match(/\+/);t&&(e=e.replace("+",""));let r=hc.prototype[e];if(typeof r!="function")throw new Error('method "'+e+'" is cached but never defined');hc.prototype[e]=t?function(...n){if(this._count===0)return;this._cache[e]===void 0&&(this._cache[e]={});let i=n.join(":");return this._cache[e][i]===void 0&&(this._cache[e][i]=r.apply(this,n)),this._cache[e][i]}:function(){if(this._count!==0)return this._cache[e]===void 0&&(this._cache[e]=r.apply(this)),this._cache[e]};});var pc=class{constructor(t){this._main=t;}min(){if(!this._main._count)return;let t=this._main.getBins();return this._main.shorten(t[0][0])}max(){if(!this._main._count)return;let t=this._main.getBins();return this._main.shorten(t[t.length-1][0])}};["E","kurtosis","mean","median","moment","momentAbs","momentStd","percentile","quantile","skewness","stdev","sumOf"].forEach(e=>{pc.prototype[e]=function(t){return this._main.shorten(this._main[e](t))};});["cdf","count"].forEach(e=>{pc.prototype[e]=function(t){return this._main[e](t)};});DO.exports={Univariate:hc};});var kO=I((Vde,iv)=>{(()=>{let{Binning:e}=nv(),{Univariate:t}=OO(),r={Binning:e,Univariate:t};typeof window<"u"&&(window.logstat=r),typeof iv=="object"&&(iv.exports=r);})();});var BO=I((Wde,LO)=>{LO.exports=gc();});var qO=I((Kde,FO)=>{function CJ(){return !!(typeof window<"u"&&typeof window.process=="object"&&window.process.type==="renderer"||typeof process<"u"&&typeof process.versions=="object"&&process.versions.electron||typeof navigator=="object"&&typeof navigator.userAgent=="string"&&navigator.userAgent.indexOf("Electron")>=0)}FO.exports=CJ;});var rt=I((Gde,MO)=>{MO.exports={options:{usePureJavaScript:!1}};});var jO=I((zde,$O)=>{var av={};$O.exports=av;var UO={};av.encode=function(e,t,r){if(typeof t!="string")throw new TypeError('"alphabet" must be a string.');if(r!==void 0&&typeof r!="number")throw new TypeError('"maxline" must be a number.');var n="";if(!(e instanceof Uint8Array))n=xJ(e,t);else {var i=0,s=t.length,a=t.charAt(0),o=[0];for(i=0;i<e.length;++i){for(var c=0,l=e[i];c<o.length;++c)l+=o[c]<<8,o[c]=l%s,l=l/s|0;for(;l>0;)o.push(l%s),l=l/s|0;}for(i=0;e[i]===0&&i<e.length-1;++i)n+=a;for(i=o.length-1;i>=0;--i)n+=t[o[i]];}if(r){var u=new RegExp(".{1,"+r+"}","g");n=n.match(u).join(`\r
`);}return n};av.decode=function(e,t){if(typeof e!="string")throw new TypeError('"input" must be a string.');if(typeof t!="string")throw new TypeError('"alphabet" must be a string.');var r=UO[t];if(!r){r=UO[t]=[];for(var n=0;n<t.length;++n)r[t.charCodeAt(n)]=n;}e=e.replace(/\s/g,"");for(var i=t.length,s=t.charAt(0),a=[0],n=0;n<e.length;n++){var o=r[e.charCodeAt(n)];if(o===void 0)return;for(var c=0,l=o;c<a.length;++c)l+=a[c]*i,a[c]=l&255,l>>=8;for(;l>0;)a.push(l&255),l>>=8;}for(var u=0;e[u]===s&&u<e.length-1;++u)a.push(0);return typeof Buffer<"u"?Buffer.from(a.reverse()):new Uint8Array(a.reverse())};function xJ(e,t){var r=0,n=t.length,i=t.charAt(0),s=[0];for(r=0;r<e.length();++r){for(var a=0,o=e.at(r);a<s.length;++a)o+=s[a]<<8,s[a]=o%n,o=o/n|0;for(;o>0;)s.push(o%n),o=o/n|0;}var c="";for(r=0;e.at(r)===0&&r<e.length()-1;++r)c+=i;for(r=s.length-1;r>=0;--r)c+=t[s[r]];return c}});var _t=I((Yde,KO)=>{var VO=rt(),HO=jO(),H=KO.exports=VO.util=VO.util||{};(function(){if(typeof process<"u"&&process.nextTick&&!process.browser){H.nextTick=process.nextTick,typeof setImmediate=="function"?H.setImmediate=setImmediate:H.setImmediate=H.nextTick;return}if(typeof setImmediate=="function"){H.setImmediate=function(){return setImmediate.apply(void 0,arguments)},H.nextTick=function(o){return setImmediate(o)};return}if(H.setImmediate=function(o){setTimeout(o,0);},typeof window<"u"&&typeof window.postMessage=="function"){let o=function(c){if(c.source===window&&c.data===e){c.stopPropagation();var l=t.slice();t.length=0,l.forEach(function(u){u();});}};var e="forge.setImmediate",t=[];H.setImmediate=function(c){t.push(c),t.length===1&&window.postMessage(e,"*");},window.addEventListener("message",o,!0);}if(typeof MutationObserver<"u"){var r=Date.now(),n=!0,i=document.createElement("div"),t=[];new MutationObserver(function(){var c=t.slice();t.length=0,c.forEach(function(l){l();});}).observe(i,{attributes:!0});var s=H.setImmediate;H.setImmediate=function(c){Date.now()-r>15?(r=Date.now(),s(c)):(t.push(c),t.length===1&&i.setAttribute("a",n=!n));};}H.nextTick=H.setImmediate;})();H.isNodejs=typeof process<"u"&&process.versions&&process.versions.node;H.globalScope=function(){return H.isNodejs?global:typeof self>"u"?window:self}();H.isArray=Array.isArray||function(e){return Object.prototype.toString.call(e)==="[object Array]"};H.isArrayBuffer=function(e){return typeof ArrayBuffer<"u"&&e instanceof ArrayBuffer};H.isArrayBufferView=function(e){return e&&H.isArrayBuffer(e.buffer)&&e.byteLength!==void 0};function mc(e){if(!(e===8||e===16||e===24||e===32))throw new Error("Only 8, 16, 24, or 32 bits supported: "+e)}H.ByteBuffer=ov;function ov(e){if(this.data="",this.read=0,typeof e=="string")this.data=e;else if(H.isArrayBuffer(e)||H.isArrayBufferView(e))if(typeof Buffer<"u"&&e instanceof Buffer)this.data=e.toString("binary");else {var t=new Uint8Array(e);try{this.data=String.fromCharCode.apply(null,t);}catch{for(var r=0;r<t.length;++r)this.putByte(t[r]);}}else (e instanceof ov||typeof e=="object"&&typeof e.data=="string"&&typeof e.read=="number")&&(this.data=e.data,this.read=e.read);this._constructedStringLength=0;}H.ByteStringBuffer=ov;var TJ=4096;H.ByteStringBuffer.prototype._optimizeConstructedString=function(e){this._constructedStringLength+=e,this._constructedStringLength>TJ&&(this.data.substr(0,1),this._constructedStringLength=0);};H.ByteStringBuffer.prototype.length=function(){return this.data.length-this.read};H.ByteStringBuffer.prototype.isEmpty=function(){return this.length()<=0};H.ByteStringBuffer.prototype.putByte=function(e){return this.putBytes(String.fromCharCode(e))};H.ByteStringBuffer.prototype.fillWithByte=function(e,t){e=String.fromCharCode(e);for(var r=this.data;t>0;)t&1&&(r+=e),t>>>=1,t>0&&(e+=e);return this.data=r,this._optimizeConstructedString(t),this};H.ByteStringBuffer.prototype.putBytes=function(e){return this.data+=e,this._optimizeConstructedString(e.length),this};H.ByteStringBuffer.prototype.putString=function(e){return this.putBytes(H.encodeUtf8(e))};H.ByteStringBuffer.prototype.putInt16=function(e){return this.putBytes(String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))};H.ByteStringBuffer.prototype.putInt24=function(e){return this.putBytes(String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))};H.ByteStringBuffer.prototype.putInt32=function(e){return this.putBytes(String.fromCharCode(e>>24&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255))};H.ByteStringBuffer.prototype.putInt16Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255))};H.ByteStringBuffer.prototype.putInt24Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e>>16&255))};H.ByteStringBuffer.prototype.putInt32Le=function(e){return this.putBytes(String.fromCharCode(e&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>24&255))};H.ByteStringBuffer.prototype.putInt=function(e,t){mc(t);var r="";do t-=8,r+=String.fromCharCode(e>>t&255);while(t>0);return this.putBytes(r)};H.ByteStringBuffer.prototype.putSignedInt=function(e,t){return e<0&&(e+=2<<t-1),this.putInt(e,t)};H.ByteStringBuffer.prototype.putBuffer=function(e){return this.putBytes(e.getBytes())};H.ByteStringBuffer.prototype.getByte=function(){return this.data.charCodeAt(this.read++)};H.ByteStringBuffer.prototype.getInt16=function(){var e=this.data.charCodeAt(this.read)<<8^this.data.charCodeAt(this.read+1);return this.read+=2,e};H.ByteStringBuffer.prototype.getInt24=function(){var e=this.data.charCodeAt(this.read)<<16^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2);return this.read+=3,e};H.ByteStringBuffer.prototype.getInt32=function(){var e=this.data.charCodeAt(this.read)<<24^this.data.charCodeAt(this.read+1)<<16^this.data.charCodeAt(this.read+2)<<8^this.data.charCodeAt(this.read+3);return this.read+=4,e};H.ByteStringBuffer.prototype.getInt16Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8;return this.read+=2,e};H.ByteStringBuffer.prototype.getInt24Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16;return this.read+=3,e};H.ByteStringBuffer.prototype.getInt32Le=function(){var e=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16^this.data.charCodeAt(this.read+3)<<24;return this.read+=4,e};H.ByteStringBuffer.prototype.getInt=function(e){mc(e);var t=0;do t=(t<<8)+this.data.charCodeAt(this.read++),e-=8;while(e>0);return t};H.ByteStringBuffer.prototype.getSignedInt=function(e){var t=this.getInt(e),r=2<<e-2;return t>=r&&(t-=r<<1),t};H.ByteStringBuffer.prototype.getBytes=function(e){var t;return e?(e=Math.min(this.length(),e),t=this.data.slice(this.read,this.read+e),this.read+=e):e===0?t="":(t=this.read===0?this.data:this.data.slice(this.read),this.clear()),t};H.ByteStringBuffer.prototype.bytes=function(e){return typeof e>"u"?this.data.slice(this.read):this.data.slice(this.read,this.read+e)};H.ByteStringBuffer.prototype.at=function(e){return this.data.charCodeAt(this.read+e)};H.ByteStringBuffer.prototype.setAt=function(e,t){return this.data=this.data.substr(0,this.read+e)+String.fromCharCode(t)+this.data.substr(this.read+e+1),this};H.ByteStringBuffer.prototype.last=function(){return this.data.charCodeAt(this.data.length-1)};H.ByteStringBuffer.prototype.copy=function(){var e=H.createBuffer(this.data);return e.read=this.read,e};H.ByteStringBuffer.prototype.compact=function(){return this.read>0&&(this.data=this.data.slice(this.read),this.read=0),this};H.ByteStringBuffer.prototype.clear=function(){return this.data="",this.read=0,this};H.ByteStringBuffer.prototype.truncate=function(e){var t=Math.max(0,this.length()-e);return this.data=this.data.substr(this.read,t),this.read=0,this};H.ByteStringBuffer.prototype.toHex=function(){for(var e="",t=this.read;t<this.data.length;++t){var r=this.data.charCodeAt(t);r<16&&(e+="0"),e+=r.toString(16);}return e};H.ByteStringBuffer.prototype.toString=function(){return H.decodeUtf8(this.bytes())};function AJ(e,t){t=t||{},this.read=t.readOffset||0,this.growSize=t.growSize||1024;var r=H.isArrayBuffer(e),n=H.isArrayBufferView(e);if(r||n){r?this.data=new DataView(e):this.data=new DataView(e.buffer,e.byteOffset,e.byteLength),this.write="writeOffset"in t?t.writeOffset:this.data.byteLength;return}this.data=new DataView(new ArrayBuffer(0)),this.write=0,e!=null&&this.putBytes(e),"writeOffset"in t&&(this.write=t.writeOffset);}H.DataBuffer=AJ;H.DataBuffer.prototype.length=function(){return this.write-this.read};H.DataBuffer.prototype.isEmpty=function(){return this.length()<=0};H.DataBuffer.prototype.accommodate=function(e,t){if(this.length()>=e)return this;t=Math.max(t||this.growSize,e);var r=new Uint8Array(this.data.buffer,this.data.byteOffset,this.data.byteLength),n=new Uint8Array(this.length()+t);return n.set(r),this.data=new DataView(n.buffer),this};H.DataBuffer.prototype.putByte=function(e){return this.accommodate(1),this.data.setUint8(this.write++,e),this};H.DataBuffer.prototype.fillWithByte=function(e,t){this.accommodate(t);for(var r=0;r<t;++r)this.data.setUint8(e);return this};H.DataBuffer.prototype.putBytes=function(e,t){if(H.isArrayBufferView(e)){var r=new Uint8Array(e.buffer,e.byteOffset,e.byteLength),n=r.byteLength-r.byteOffset;this.accommodate(n);var i=new Uint8Array(this.data.buffer,this.write);return i.set(r),this.write+=n,this}if(H.isArrayBuffer(e)){var r=new Uint8Array(e);this.accommodate(r.byteLength);var i=new Uint8Array(this.data.buffer);return i.set(r,this.write),this.write+=r.byteLength,this}if(e instanceof H.DataBuffer||typeof e=="object"&&typeof e.read=="number"&&typeof e.write=="number"&&H.isArrayBufferView(e.data)){var r=new Uint8Array(e.data.byteLength,e.read,e.length());this.accommodate(r.byteLength);var i=new Uint8Array(e.data.byteLength,this.write);return i.set(r),this.write+=r.byteLength,this}if(e instanceof H.ByteStringBuffer&&(e=e.data,t="binary"),t=t||"binary",typeof e=="string"){var s;if(t==="hex")return this.accommodate(Math.ceil(e.length/2)),s=new Uint8Array(this.data.buffer,this.write),this.write+=H.binary.hex.decode(e,s,this.write),this;if(t==="base64")return this.accommodate(Math.ceil(e.length/4)*3),s=new Uint8Array(this.data.buffer,this.write),this.write+=H.binary.base64.decode(e,s,this.write),this;if(t==="utf8"&&(e=H.encodeUtf8(e),t="binary"),t==="binary"||t==="raw")return this.accommodate(e.length),s=new Uint8Array(this.data.buffer,this.write),this.write+=H.binary.raw.decode(s),this;if(t==="utf16")return this.accommodate(e.length*2),s=new Uint16Array(this.data.buffer,this.write),this.write+=H.text.utf16.encode(s),this;throw new Error("Invalid encoding: "+t)}throw Error("Invalid parameter: "+e)};H.DataBuffer.prototype.putBuffer=function(e){return this.putBytes(e),e.clear(),this};H.DataBuffer.prototype.putString=function(e){return this.putBytes(e,"utf16")};H.DataBuffer.prototype.putInt16=function(e){return this.accommodate(2),this.data.setInt16(this.write,e),this.write+=2,this};H.DataBuffer.prototype.putInt24=function(e){return this.accommodate(3),this.data.setInt16(this.write,e>>8&65535),this.data.setInt8(this.write,e>>16&255),this.write+=3,this};H.DataBuffer.prototype.putInt32=function(e){return this.accommodate(4),this.data.setInt32(this.write,e),this.write+=4,this};H.DataBuffer.prototype.putInt16Le=function(e){return this.accommodate(2),this.data.setInt16(this.write,e,!0),this.write+=2,this};H.DataBuffer.prototype.putInt24Le=function(e){return this.accommodate(3),this.data.setInt8(this.write,e>>16&255),this.data.setInt16(this.write,e>>8&65535,!0),this.write+=3,this};H.DataBuffer.prototype.putInt32Le=function(e){return this.accommodate(4),this.data.setInt32(this.write,e,!0),this.write+=4,this};H.DataBuffer.prototype.putInt=function(e,t){mc(t),this.accommodate(t/8);do t-=8,this.data.setInt8(this.write++,e>>t&255);while(t>0);return this};H.DataBuffer.prototype.putSignedInt=function(e,t){return mc(t),this.accommodate(t/8),e<0&&(e+=2<<t-1),this.putInt(e,t)};H.DataBuffer.prototype.getByte=function(){return this.data.getInt8(this.read++)};H.DataBuffer.prototype.getInt16=function(){var e=this.data.getInt16(this.read);return this.read+=2,e};H.DataBuffer.prototype.getInt24=function(){var e=this.data.getInt16(this.read)<<8^this.data.getInt8(this.read+2);return this.read+=3,e};H.DataBuffer.prototype.getInt32=function(){var e=this.data.getInt32(this.read);return this.read+=4,e};H.DataBuffer.prototype.getInt16Le=function(){var e=this.data.getInt16(this.read,!0);return this.read+=2,e};H.DataBuffer.prototype.getInt24Le=function(){var e=this.data.getInt8(this.read)^this.data.getInt16(this.read+1,!0)<<8;return this.read+=3,e};H.DataBuffer.prototype.getInt32Le=function(){var e=this.data.getInt32(this.read,!0);return this.read+=4,e};H.DataBuffer.prototype.getInt=function(e){mc(e);var t=0;do t=(t<<8)+this.data.getInt8(this.read++),e-=8;while(e>0);return t};H.DataBuffer.prototype.getSignedInt=function(e){var t=this.getInt(e),r=2<<e-2;return t>=r&&(t-=r<<1),t};H.DataBuffer.prototype.getBytes=function(e){var t;return e?(e=Math.min(this.length(),e),t=this.data.slice(this.read,this.read+e),this.read+=e):e===0?t="":(t=this.read===0?this.data:this.data.slice(this.read),this.clear()),t};H.DataBuffer.prototype.bytes=function(e){return typeof e>"u"?this.data.slice(this.read):this.data.slice(this.read,this.read+e)};H.DataBuffer.prototype.at=function(e){return this.data.getUint8(this.read+e)};H.DataBuffer.prototype.setAt=function(e,t){return this.data.setUint8(e,t),this};H.DataBuffer.prototype.last=function(){return this.data.getUint8(this.write-1)};H.DataBuffer.prototype.copy=function(){return new H.DataBuffer(this)};H.DataBuffer.prototype.compact=function(){if(this.read>0){var e=new Uint8Array(this.data.buffer,this.read),t=new Uint8Array(e.byteLength);t.set(e),this.data=new DataView(t),this.write-=this.read,this.read=0;}return this};H.DataBuffer.prototype.clear=function(){return this.data=new DataView(new ArrayBuffer(0)),this.read=this.write=0,this};H.DataBuffer.prototype.truncate=function(e){return this.write=Math.max(0,this.length()-e),this.read=Math.min(this.read,this.write),this};H.DataBuffer.prototype.toHex=function(){for(var e="",t=this.read;t<this.data.byteLength;++t){var r=this.data.getUint8(t);r<16&&(e+="0"),e+=r.toString(16);}return e};H.DataBuffer.prototype.toString=function(e){var t=new Uint8Array(this.data,this.read,this.length());if(e=e||"utf8",e==="binary"||e==="raw")return H.binary.raw.encode(t);if(e==="hex")return H.binary.hex.encode(t);if(e==="base64")return H.binary.base64.encode(t);if(e==="utf8")return H.text.utf8.decode(t);if(e==="utf16")return H.text.utf16.decode(t);throw new Error("Invalid encoding: "+e)};H.createBuffer=function(e,t){return t=t||"raw",e!==void 0&&t==="utf8"&&(e=H.encodeUtf8(e)),new H.ByteBuffer(e)};H.fillString=function(e,t){for(var r="";t>0;)t&1&&(r+=e),t>>>=1,t>0&&(e+=e);return r};H.xorBytes=function(e,t,r){for(var n="",i="",s="",a=0,o=0;r>0;--r,++a)i=e.charCodeAt(a)^t.charCodeAt(a),o>=10&&(n+=s,s="",o=0),s+=String.fromCharCode(i),++o;return n+=s,n};H.hexToBytes=function(e){var t="",r=0;for(e.length&!0&&(r=1,t+=String.fromCharCode(parseInt(e[0],16)));r<e.length;r+=2)t+=String.fromCharCode(parseInt(e.substr(r,2),16));return t};H.bytesToHex=function(e){return H.createBuffer(e).toHex()};H.int32ToBytes=function(e){return String.fromCharCode(e>>24&255)+String.fromCharCode(e>>16&255)+String.fromCharCode(e>>8&255)+String.fromCharCode(e&255)};var vs="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",_s=[62,-1,-1,-1,63,52,53,54,55,56,57,58,59,60,61,-1,-1,-1,64,-1,-1,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51],WO="123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";H.encode64=function(e,t){for(var r="",n="",i,s,a,o=0;o<e.length;)i=e.charCodeAt(o++),s=e.charCodeAt(o++),a=e.charCodeAt(o++),r+=vs.charAt(i>>2),r+=vs.charAt((i&3)<<4|s>>4),isNaN(s)?r+="==":(r+=vs.charAt((s&15)<<2|a>>6),r+=isNaN(a)?"=":vs.charAt(a&63)),t&&r.length>t&&(n+=r.substr(0,t)+`\r
`,r=r.substr(t));return n+=r,n};H.decode64=function(e){e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");for(var t="",r,n,i,s,a=0;a<e.length;)r=_s[e.charCodeAt(a++)-43],n=_s[e.charCodeAt(a++)-43],i=_s[e.charCodeAt(a++)-43],s=_s[e.charCodeAt(a++)-43],t+=String.fromCharCode(r<<2|n>>4),i!==64&&(t+=String.fromCharCode((n&15)<<4|i>>2),s!==64&&(t+=String.fromCharCode((i&3)<<6|s)));return t};H.encodeUtf8=function(e){return unescape(encodeURIComponent(e))};H.decodeUtf8=function(e){return decodeURIComponent(escape(e))};H.binary={raw:{},hex:{},base64:{},base58:{},baseN:{encode:HO.encode,decode:HO.decode}};H.binary.raw.encode=function(e){return String.fromCharCode.apply(null,e)};H.binary.raw.decode=function(e,t,r){var n=t;n||(n=new Uint8Array(e.length)),r=r||0;for(var i=r,s=0;s<e.length;++s)n[i++]=e.charCodeAt(s);return t?i-r:n};H.binary.hex.encode=H.bytesToHex;H.binary.hex.decode=function(e,t,r){var n=t;n||(n=new Uint8Array(Math.ceil(e.length/2))),r=r||0;var i=0,s=r;for(e.length&1&&(i=1,n[s++]=parseInt(e[0],16));i<e.length;i+=2)n[s++]=parseInt(e.substr(i,2),16);return t?s-r:n};H.binary.base64.encode=function(e,t){for(var r="",n="",i,s,a,o=0;o<e.byteLength;)i=e[o++],s=e[o++],a=e[o++],r+=vs.charAt(i>>2),r+=vs.charAt((i&3)<<4|s>>4),isNaN(s)?r+="==":(r+=vs.charAt((s&15)<<2|a>>6),r+=isNaN(a)?"=":vs.charAt(a&63)),t&&r.length>t&&(n+=r.substr(0,t)+`\r
`,r=r.substr(t));return n+=r,n};H.binary.base64.decode=function(e,t,r){var n=t;n||(n=new Uint8Array(Math.ceil(e.length/4)*3)),e=e.replace(/[^A-Za-z0-9\+\/\=]/g,""),r=r||0;for(var i,s,a,o,c=0,l=r;c<e.length;)i=_s[e.charCodeAt(c++)-43],s=_s[e.charCodeAt(c++)-43],a=_s[e.charCodeAt(c++)-43],o=_s[e.charCodeAt(c++)-43],n[l++]=i<<2|s>>4,a!==64&&(n[l++]=(s&15)<<4|a>>2,o!==64&&(n[l++]=(a&3)<<6|o));return t?l-r:n.subarray(0,l)};H.binary.base58.encode=function(e,t){return H.binary.baseN.encode(e,WO,t)};H.binary.base58.decode=function(e,t){return H.binary.baseN.decode(e,WO,t)};H.text={utf8:{},utf16:{}};H.text.utf8.encode=function(e,t,r){e=H.encodeUtf8(e);var n=t;n||(n=new Uint8Array(e.length)),r=r||0;for(var i=r,s=0;s<e.length;++s)n[i++]=e.charCodeAt(s);return t?i-r:n};H.text.utf8.decode=function(e){return H.decodeUtf8(String.fromCharCode.apply(null,e))};H.text.utf16.encode=function(e,t,r){var n=t;n||(n=new Uint8Array(e.length*2));var i=new Uint16Array(n.buffer);r=r||0;for(var s=r,a=r,o=0;o<e.length;++o)i[a++]=e.charCodeAt(o),s+=2;return t?s-r:n};H.text.utf16.decode=function(e){return String.fromCharCode.apply(null,new Uint16Array(e.buffer))};H.deflate=function(e,t,r){if(t=H.decode64(e.deflate(H.encode64(t)).rval),r){var n=2,i=t.charCodeAt(1);i&32&&(n=6),t=t.substring(n,t.length-4);}return t};H.inflate=function(e,t,r){var n=e.inflate(H.encode64(t)).rval;return n===null?null:H.decode64(n)};var uv=function(e,t,r){if(!e)throw new Error("WebStorage not available.");var n;if(r===null?n=e.removeItem(t):(r=H.encode64(JSON.stringify(r)),n=e.setItem(t,r)),typeof n<"u"&&n.rval!==!0){var i=new Error(n.error.message);throw i.id=n.error.id,i.name=n.error.name,i}},cv=function(e,t){if(!e)throw new Error("WebStorage not available.");var r=e.getItem(t);if(e.init)if(r.rval===null){if(r.error){var n=new Error(r.error.message);throw n.id=r.error.id,n.name=r.error.name,n}r=null;}else r=r.rval;return r!==null&&(r=JSON.parse(H.decode64(r))),r},RJ=function(e,t,r,n){var i=cv(e,t);i===null&&(i={}),i[r]=n,uv(e,t,i);},IJ=function(e,t,r){var n=cv(e,t);return n!==null&&(n=r in n?n[r]:null),n},PJ=function(e,t,r){var n=cv(e,t);if(n!==null&&r in n){delete n[r];var i=!0;for(var s in n){i=!1;break}i&&(n=null),uv(e,t,n);}},NJ=function(e,t){uv(e,t,null);},_d=function(e,t,r){var n=null;typeof r>"u"&&(r=["web","flash"]);var i,s=!1,a=null;for(var o in r){i=r[o];try{if(i==="flash"||i==="both"){if(t[0]===null)throw new Error("Flash local storage not available.");n=e.apply(this,t),s=i==="flash";}(i==="web"||i==="both")&&(t[0]=localStorage,n=e.apply(this,t),s=!0);}catch(c){a=c;}if(s)break}if(!s)throw a;return n};H.setItem=function(e,t,r,n,i){_d(RJ,arguments,i);};H.getItem=function(e,t,r,n){return _d(IJ,arguments,n)};H.removeItem=function(e,t,r,n){_d(PJ,arguments,n);};H.clearItems=function(e,t,r){_d(NJ,arguments,r);};H.isEmpty=function(e){for(var t in e)if(e.hasOwnProperty(t))return !1;return !0};H.format=function(e){for(var t=/%./g,r,n,i=0,s=[],a=0;r=t.exec(e);){n=e.substring(a,t.lastIndex-2),n.length>0&&s.push(n),a=t.lastIndex;var o=r[0][1];switch(o){case"s":case"o":i<arguments.length?s.push(arguments[i+++1]):s.push("<?>");break;case"%":s.push("%");break;default:s.push("<%"+o+"?>");}}return s.push(e.substring(a)),s.join("")};H.formatNumber=function(e,t,r,n){var i=e,s=isNaN(t=Math.abs(t))?2:t,a=r===void 0?",":r,o=n===void 0?".":n,c=i<0?"-":"",l=parseInt(i=Math.abs(+i||0).toFixed(s),10)+"",u=l.length>3?l.length%3:0;return c+(u?l.substr(0,u)+o:"")+l.substr(u).replace(/(\d{3})(?=\d)/g,"$1"+o)+(s?a+Math.abs(i-l).toFixed(s).slice(2):"")};H.formatSize=function(e){return e>=1073741824?e=H.formatNumber(e/1073741824,2,".","")+" GiB":e>=1048576?e=H.formatNumber(e/1048576,2,".","")+" MiB":e>=1024?e=H.formatNumber(e/1024,0)+" KiB":e=H.formatNumber(e,0)+" bytes",e};H.bytesFromIP=function(e){return e.indexOf(".")!==-1?H.bytesFromIPv4(e):e.indexOf(":")!==-1?H.bytesFromIPv6(e):null};H.bytesFromIPv4=function(e){if(e=e.split("."),e.length!==4)return null;for(var t=H.createBuffer(),r=0;r<e.length;++r){var n=parseInt(e[r],10);if(isNaN(n))return null;t.putByte(n);}return t.getBytes()};H.bytesFromIPv6=function(e){var t=0;e=e.split(":").filter(function(a){return a.length===0&&++t,!0});for(var r=(8-e.length+t)*2,n=H.createBuffer(),i=0;i<8;++i){if(!e[i]||e[i].length===0){n.fillWithByte(0,r),r=0;continue}var s=H.hexToBytes(e[i]);s.length<2&&n.putByte(0),n.putBytes(s);}return n.getBytes()};H.bytesToIP=function(e){return e.length===4?H.bytesToIPv4(e):e.length===16?H.bytesToIPv6(e):null};H.bytesToIPv4=function(e){if(e.length!==4)return null;for(var t=[],r=0;r<e.length;++r)t.push(e.charCodeAt(r));return t.join(".")};H.bytesToIPv6=function(e){if(e.length!==16)return null;for(var t=[],r=[],n=0,i=0;i<e.length;i+=2){for(var s=H.bytesToHex(e[i]+e[i+1]);s[0]==="0"&&s!=="0";)s=s.substr(1);if(s==="0"){var a=r[r.length-1],o=t.length;!a||o!==a.end+1?r.push({start:o,end:o}):(a.end=o,a.end-a.start>r[n].end-r[n].start&&(n=r.length-1));}t.push(s);}if(r.length>0){var c=r[n];c.end-c.start>0&&(t.splice(c.start,c.end-c.start+1,""),c.start===0&&t.unshift(""),c.end===7&&t.push(""));}return t.join(":")};H.estimateCores=function(e,t){if(typeof e=="function"&&(t=e,e={}),e=e||{},"cores"in H&&!e.update)return t(null,H.cores);if(typeof navigator<"u"&&"hardwareConcurrency"in navigator&&navigator.hardwareConcurrency>0)return H.cores=navigator.hardwareConcurrency,t(null,H.cores);if(typeof Worker>"u")return H.cores=1,t(null,H.cores);if(typeof Blob>"u")return H.cores=2,t(null,H.cores);var r=URL.createObjectURL(new Blob(["(",function(){self.addEventListener("message",function(a){for(var o=Date.now(),c=o+4;Date.now()<c;);self.postMessage({st:o,et:c});});}.toString(),")()"],{type:"application/javascript"}));n([],5,16);function n(a,o,c){if(o===0){var l=Math.floor(a.reduce(function(u,f){return u+f},0)/a.length);return H.cores=Math.max(1,l),URL.revokeObjectURL(r),t(null,H.cores)}i(c,function(u,f){a.push(s(c,f)),n(a,o-1,c);});}function i(a,o){for(var c=[],l=[],u=0;u<a;++u){var f=new Worker(r);f.addEventListener("message",function(h){if(l.push(h.data),l.length===a){for(var p=0;p<a;++p)c[p].terminate();o(null,l);}}),c.push(f);}for(var u=0;u<a;++u)c[u].postMessage(u);}function s(a,o){for(var c=[],l=0;l<a;++l)for(var u=o[l],f=c[l]=[],h=0;h<a;++h)if(l!==h){var p=o[h];(u.st>p.st&&u.st<p.et||p.st>u.st&&p.st<u.et)&&f.push(h);}return c.reduce(function(g,_){return Math.max(g,_.length)},0)}};});var bd=I((Qde,GO)=>{var br=rt();_t();GO.exports=br.cipher=br.cipher||{};br.cipher.algorithms=br.cipher.algorithms||{};br.cipher.createCipher=function(e,t){var r=e;if(typeof r=="string"&&(r=br.cipher.getAlgorithm(r),r&&(r=r())),!r)throw new Error("Unsupported algorithm: "+e);return new br.cipher.BlockCipher({algorithm:r,key:t,decrypt:!1})};br.cipher.createDecipher=function(e,t){var r=e;if(typeof r=="string"&&(r=br.cipher.getAlgorithm(r),r&&(r=r())),!r)throw new Error("Unsupported algorithm: "+e);return new br.cipher.BlockCipher({algorithm:r,key:t,decrypt:!0})};br.cipher.registerAlgorithm=function(e,t){e=e.toUpperCase(),br.cipher.algorithms[e]=t;};br.cipher.getAlgorithm=function(e){return e=e.toUpperCase(),e in br.cipher.algorithms?br.cipher.algorithms[e]:null};var lv=br.cipher.BlockCipher=function(e){this.algorithm=e.algorithm,this.mode=this.algorithm.mode,this.blockSize=this.mode.blockSize,this._finish=!1,this._input=null,this.output=null,this._op=e.decrypt?this.mode.decrypt:this.mode.encrypt,this._decrypt=e.decrypt,this.algorithm.initialize(e);};lv.prototype.start=function(e){e=e||{};var t={};for(var r in e)t[r]=e[r];t.decrypt=this._decrypt,this._finish=!1,this._input=br.util.createBuffer(),this.output=e.output||br.util.createBuffer(),this.mode.start(t);};lv.prototype.update=function(e){for(e&&this._input.putBuffer(e);!this._op.call(this.mode,this._input,this.output,this._finish)&&!this._finish;);this._input.compact();};lv.prototype.finish=function(e){e&&(this.mode.name==="ECB"||this.mode.name==="CBC")&&(this.mode.pad=function(r){return e(this.blockSize,r,!1)},this.mode.unpad=function(r){return e(this.blockSize,r,!0)});var t={};return t.decrypt=this._decrypt,t.overflow=this._input.length()%this.blockSize,!(!this._decrypt&&this.mode.pad&&!this.mode.pad(this._input,t)||(this._finish=!0,this.update(),this._decrypt&&this.mode.unpad&&!this.mode.unpad(this.output,t))||this.mode.afterFinish&&!this.mode.afterFinish(this.output,t))};});var dv=I((Xde,zO)=>{var Sr=rt();_t();Sr.cipher=Sr.cipher||{};var ot=zO.exports=Sr.cipher.modes=Sr.cipher.modes||{};ot.ecb=function(e){e=e||{},this.name="ECB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints);};ot.ecb.prototype.start=function(e){};ot.ecb.prototype.encrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=e.getInt32();this.cipher.encrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._outBlock[n]);};ot.ecb.prototype.decrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=e.getInt32();this.cipher.decrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._outBlock[n]);};ot.ecb.prototype.pad=function(e,t){var r=e.length()===this.blockSize?this.blockSize:this.blockSize-e.length();return e.fillWithByte(r,r),!0};ot.ecb.prototype.unpad=function(e,t){if(t.overflow>0)return !1;var r=e.length(),n=e.at(r-1);return n>this.blockSize<<2?!1:(e.truncate(n),!0)};ot.cbc=function(e){e=e||{},this.name="CBC",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints);};ot.cbc.prototype.start=function(e){if(e.iv===null){if(!this._prev)throw new Error("Invalid IV parameter.");this._iv=this._prev.slice(0);}else if("iv"in e)this._iv=Sd(e.iv,this.blockSize),this._prev=this._iv.slice(0);else throw new Error("Invalid IV parameter.")};ot.cbc.prototype.encrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=this._prev[n]^e.getInt32();this.cipher.encrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._outBlock[n]);this._prev=this._outBlock;};ot.cbc.prototype.decrypt=function(e,t,r){if(e.length()<this.blockSize&&!(r&&e.length()>0))return !0;for(var n=0;n<this._ints;++n)this._inBlock[n]=e.getInt32();this.cipher.decrypt(this._inBlock,this._outBlock);for(var n=0;n<this._ints;++n)t.putInt32(this._prev[n]^this._outBlock[n]);this._prev=this._inBlock.slice(0);};ot.cbc.prototype.pad=function(e,t){var r=e.length()===this.blockSize?this.blockSize:this.blockSize-e.length();return e.fillWithByte(r,r),!0};ot.cbc.prototype.unpad=function(e,t){if(t.overflow>0)return !1;var r=e.length(),n=e.at(r-1);return n>this.blockSize<<2?!1:(e.truncate(n),!0)};ot.cfb=function(e){e=e||{},this.name="CFB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0;};ot.cfb.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=Sd(e.iv,this.blockSize),this._inBlock=this._iv.slice(0),this._partialBytes=0;};ot.cfb.prototype.encrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)this._inBlock[i]=e.getInt32()^this._outBlock[i],t.putInt32(this._inBlock[i]);return}var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialBlock[i]=e.getInt32()^this._outBlock[i],this._partialOutput.putInt32(this._partialBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._partialBlock[i];if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;};ot.cfb.prototype.decrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)this._inBlock[i]=e.getInt32(),t.putInt32(this._inBlock[i]^this._outBlock[i]);return}var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialBlock[i]=e.getInt32(),this._partialOutput.putInt32(this._partialBlock[i]^this._outBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._partialBlock[i];if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;};ot.ofb=function(e){e=e||{},this.name="OFB",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0;};ot.ofb.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=Sd(e.iv,this.blockSize),this._inBlock=this._iv.slice(0),this._partialBytes=0;};ot.ofb.prototype.encrypt=function(e,t,r){var n=e.length();if(e.length()===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)t.putInt32(e.getInt32()^this._outBlock[i]),this._inBlock[i]=this._outBlock[i];return}var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s>0)e.read-=this.blockSize;else for(var i=0;i<this._ints;++i)this._inBlock[i]=this._outBlock[i];if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;};ot.ofb.prototype.decrypt=ot.ofb.prototype.encrypt;ot.ctr=function(e){e=e||{},this.name="CTR",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=null,this._outBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0;};ot.ctr.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");this._iv=Sd(e.iv,this.blockSize),this._inBlock=this._iv.slice(0),this._partialBytes=0;};ot.ctr.prototype.encrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize)for(var i=0;i<this._ints;++i)t.putInt32(e.getInt32()^this._outBlock[i]);else {var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s>0&&(e.read-=this.blockSize),this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;}Ed(this._inBlock);};ot.ctr.prototype.decrypt=ot.ctr.prototype.encrypt;ot.gcm=function(e){e=e||{},this.name="GCM",this.cipher=e.cipher,this.blockSize=e.blockSize||16,this._ints=this.blockSize/4,this._inBlock=new Array(this._ints),this._outBlock=new Array(this._ints),this._partialOutput=Sr.util.createBuffer(),this._partialBytes=0,this._R=3774873600;};ot.gcm.prototype.start=function(e){if(!("iv"in e))throw new Error("Invalid IV parameter.");var t=Sr.util.createBuffer(e.iv);this._cipherLength=0;var r;if("additionalData"in e?r=Sr.util.createBuffer(e.additionalData):r=Sr.util.createBuffer(),"tagLength"in e?this._tagLength=e.tagLength:this._tagLength=128,this._tag=null,e.decrypt&&(this._tag=Sr.util.createBuffer(e.tag).getBytes(),this._tag.length!==this._tagLength/8))throw new Error("Authentication tag does not match tag length.");this._hashBlock=new Array(this._ints),this.tag=null,this._hashSubkey=new Array(this._ints),this.cipher.encrypt([0,0,0,0],this._hashSubkey),this.componentBits=4,this._m=this.generateHashTable(this._hashSubkey,this.componentBits);var n=t.length();if(n===12)this._j0=[t.getInt32(),t.getInt32(),t.getInt32(),1];else {for(this._j0=[0,0,0,0];t.length()>0;)this._j0=this.ghash(this._hashSubkey,this._j0,[t.getInt32(),t.getInt32(),t.getInt32(),t.getInt32()]);this._j0=this.ghash(this._hashSubkey,this._j0,[0,0].concat(fv(n*8)));}this._inBlock=this._j0.slice(0),Ed(this._inBlock),this._partialBytes=0,r=Sr.util.createBuffer(r),this._aDataLength=fv(r.length()*8);var i=r.length()%this.blockSize;for(i&&r.fillWithByte(0,this.blockSize-i),this._s=[0,0,0,0];r.length()>0;)this._s=this.ghash(this._hashSubkey,this._s,[r.getInt32(),r.getInt32(),r.getInt32(),r.getInt32()]);};ot.gcm.prototype.encrypt=function(e,t,r){var n=e.length();if(n===0)return !0;if(this.cipher.encrypt(this._inBlock,this._outBlock),this._partialBytes===0&&n>=this.blockSize){for(var i=0;i<this._ints;++i)t.putInt32(this._outBlock[i]^=e.getInt32());this._cipherLength+=this.blockSize;}else {var s=(this.blockSize-n)%this.blockSize;s>0&&(s=this.blockSize-s),this._partialOutput.clear();for(var i=0;i<this._ints;++i)this._partialOutput.putInt32(e.getInt32()^this._outBlock[i]);if(s<=0||r){if(r){var a=n%this.blockSize;this._cipherLength+=a,this._partialOutput.truncate(this.blockSize-a);}else this._cipherLength+=this.blockSize;for(var i=0;i<this._ints;++i)this._outBlock[i]=this._partialOutput.getInt32();this._partialOutput.read-=this.blockSize;}if(this._partialBytes>0&&this._partialOutput.getBytes(this._partialBytes),s>0&&!r)return e.read-=this.blockSize,t.putBytes(this._partialOutput.getBytes(s-this._partialBytes)),this._partialBytes=s,!0;t.putBytes(this._partialOutput.getBytes(n-this._partialBytes)),this._partialBytes=0;}this._s=this.ghash(this._hashSubkey,this._s,this._outBlock),Ed(this._inBlock);};ot.gcm.prototype.decrypt=function(e,t,r){var n=e.length();if(n<this.blockSize&&!(r&&n>0))return !0;this.cipher.encrypt(this._inBlock,this._outBlock),Ed(this._inBlock),this._hashBlock[0]=e.getInt32(),this._hashBlock[1]=e.getInt32(),this._hashBlock[2]=e.getInt32(),this._hashBlock[3]=e.getInt32(),this._s=this.ghash(this._hashSubkey,this._s,this._hashBlock);for(var i=0;i<this._ints;++i)t.putInt32(this._outBlock[i]^this._hashBlock[i]);n<this.blockSize?this._cipherLength+=n%this.blockSize:this._cipherLength+=this.blockSize;};ot.gcm.prototype.afterFinish=function(e,t){var r=!0;t.decrypt&&t.overflow&&e.truncate(this.blockSize-t.overflow),this.tag=Sr.util.createBuffer();var n=this._aDataLength.concat(fv(this._cipherLength*8));this._s=this.ghash(this._hashSubkey,this._s,n);var i=[];this.cipher.encrypt(this._j0,i);for(var s=0;s<this._ints;++s)this.tag.putInt32(this._s[s]^i[s]);return this.tag.truncate(this.tag.length()%(this._tagLength/8)),t.decrypt&&this.tag.bytes()!==this._tag&&(r=!1),r};ot.gcm.prototype.multiply=function(e,t){for(var r=[0,0,0,0],n=t.slice(0),i=0;i<128;++i){var s=e[i/32|0]&1<<31-i%32;s&&(r[0]^=n[0],r[1]^=n[1],r[2]^=n[2],r[3]^=n[3]),this.pow(n,n);}return r};ot.gcm.prototype.pow=function(e,t){for(var r=e[3]&1,n=3;n>0;--n)t[n]=e[n]>>>1|(e[n-1]&1)<<31;t[0]=e[0]>>>1,r&&(t[0]^=this._R);};ot.gcm.prototype.tableMultiply=function(e){for(var t=[0,0,0,0],r=0;r<32;++r){var n=r/8|0,i=e[n]>>>(7-r%8)*4&15,s=this._m[r][i];t[0]^=s[0],t[1]^=s[1],t[2]^=s[2],t[3]^=s[3];}return t};ot.gcm.prototype.ghash=function(e,t,r){return t[0]^=r[0],t[1]^=r[1],t[2]^=r[2],t[3]^=r[3],this.tableMultiply(t)};ot.gcm.prototype.generateHashTable=function(e,t){for(var r=8/t,n=4*r,i=16*r,s=new Array(i),a=0;a<i;++a){var o=[0,0,0,0],c=a/n|0,l=(n-1-a%n)*t;o[c]=1<<t-1<<l,s[a]=this.generateSubHashTable(this.multiply(o,e),t);}return s};ot.gcm.prototype.generateSubHashTable=function(e,t){var r=1<<t,n=r>>>1,i=new Array(r);i[n]=e.slice(0);for(var s=n>>>1;s>0;)this.pow(i[2*s],i[s]=[]),s>>=1;for(s=2;s<n;){for(var a=1;a<s;++a){var o=i[s],c=i[a];i[s+a]=[o[0]^c[0],o[1]^c[1],o[2]^c[2],o[3]^c[3]];}s*=2;}for(i[0]=[0,0,0,0],s=n+1;s<r;++s){var l=i[s^n];i[s]=[e[0]^l[0],e[1]^l[1],e[2]^l[2],e[3]^l[3]];}return i};function Sd(e,t){if(typeof e=="string"&&(e=Sr.util.createBuffer(e)),Sr.util.isArray(e)&&e.length>4){var r=e;e=Sr.util.createBuffer();for(var n=0;n<r.length;++n)e.putByte(r[n]);}if(e.length()<t)throw new Error("Invalid IV length; got "+e.length()+" bytes and expected "+t+" bytes.");if(!Sr.util.isArray(e)){for(var i=[],s=t/4,n=0;n<s;++n)i.push(e.getInt32());e=i;}return e}function Ed(e){e[e.length-1]=e[e.length-1]+1&4294967295;}function fv(e){return [e/4294967296|0,e&4294967295]}});var bs=I((Zde,ZO)=>{var Ut=rt();bd();dv();_t();ZO.exports=Ut.aes=Ut.aes||{};Ut.aes.startEncrypting=function(e,t,r,n){var i=wd({key:e,output:r,decrypt:!1,mode:n});return i.start(t),i};Ut.aes.createEncryptionCipher=function(e,t){return wd({key:e,output:null,decrypt:!1,mode:t})};Ut.aes.startDecrypting=function(e,t,r,n){var i=wd({key:e,output:r,decrypt:!0,mode:n});return i.start(t),i};Ut.aes.createDecryptionCipher=function(e,t){return wd({key:e,output:null,decrypt:!0,mode:t})};Ut.aes.Algorithm=function(e,t){gv||QO();var r=this;r.name=e,r.mode=new t({blockSize:16,cipher:{encrypt:function(n,i){return pv(r._w,n,i,!1)},decrypt:function(n,i){return pv(r._w,n,i,!0)}}}),r._init=!1;};Ut.aes.Algorithm.prototype.initialize=function(e){if(!this._init){var t=e.key,r;if(typeof t=="string"&&(t.length===16||t.length===24||t.length===32))t=Ut.util.createBuffer(t);else if(Ut.util.isArray(t)&&(t.length===16||t.length===24||t.length===32)){r=t,t=Ut.util.createBuffer();for(var n=0;n<r.length;++n)t.putByte(r[n]);}if(!Ut.util.isArray(t)){r=t,t=[];var i=r.length();if(i===16||i===24||i===32){i=i>>>2;for(var n=0;n<i;++n)t.push(r.getInt32());}}if(!Ut.util.isArray(t)||!(t.length===4||t.length===6||t.length===8))throw new Error("Invalid key parameter.");var s=this.mode.name,a=["CFB","OFB","CTR","GCM"].indexOf(s)!==-1;this._w=XO(t,e.decrypt&&!a),this._init=!0;}};Ut.aes._expandKey=function(e,t){return gv||QO(),XO(e,t)};Ut.aes._updateBlock=pv;wo("AES-ECB",Ut.cipher.modes.ecb);wo("AES-CBC",Ut.cipher.modes.cbc);wo("AES-CFB",Ut.cipher.modes.cfb);wo("AES-OFB",Ut.cipher.modes.ofb);wo("AES-CTR",Ut.cipher.modes.ctr);wo("AES-GCM",Ut.cipher.modes.gcm);function wo(e,t){var r=function(){return new Ut.aes.Algorithm(e,t)};Ut.cipher.registerAlgorithm(e,r);}var gv=!1,Eo=4,Qr,hv,YO,ga,si;function QO(){gv=!0,YO=[0,1,2,4,8,16,32,64,128,27,54];for(var e=new Array(256),t=0;t<128;++t)e[t]=t<<1,e[t+128]=t+128<<1^283;Qr=new Array(256),hv=new Array(256),ga=new Array(4),si=new Array(4);for(var t=0;t<4;++t)ga[t]=new Array(256),si[t]=new Array(256);for(var r=0,n=0,i,s,a,o,c,l,u,t=0;t<256;++t){o=n^n<<1^n<<2^n<<3^n<<4,o=o>>8^o&255^99,Qr[r]=o,hv[o]=r,c=e[o],i=e[r],s=e[i],a=e[s],l=c<<24^o<<16^o<<8^(o^c),u=(i^s^a)<<24^(r^a)<<16^(r^s^a)<<8^(r^i^a);for(var f=0;f<4;++f)ga[f][r]=l,si[f][o]=u,l=l<<24|l>>>8,u=u<<24|u>>>8;r===0?r=n=1:(r=i^e[e[e[i^a]]],n^=e[e[n]]);}}function XO(e,t){for(var r=e.slice(0),n,i=1,s=r.length,a=s+6+1,o=Eo*a,c=s;c<o;++c)n=r[c-1],c%s===0?(n=Qr[n>>>16&255]<<24^Qr[n>>>8&255]<<16^Qr[n&255]<<8^Qr[n>>>24]^YO[i]<<24,i++):s>6&&c%s===4&&(n=Qr[n>>>24]<<24^Qr[n>>>16&255]<<16^Qr[n>>>8&255]<<8^Qr[n&255]),r[c]=r[c-s]^n;if(t){var l,u=si[0],f=si[1],h=si[2],p=si[3],g=r.slice(0);o=r.length;for(var c=0,_=o-Eo;c<o;c+=Eo,_-=Eo)if(c===0||c===o-Eo)g[c]=r[_],g[c+1]=r[_+3],g[c+2]=r[_+2],g[c+3]=r[_+1];else for(var E=0;E<Eo;++E)l=r[_+E],g[c+(3&-E)]=u[Qr[l>>>24]]^f[Qr[l>>>16&255]]^h[Qr[l>>>8&255]]^p[Qr[l&255]];r=g;}return r}function pv(e,t,r,n){var i=e.length/4-1,s,a,o,c,l;n?(s=si[0],a=si[1],o=si[2],c=si[3],l=hv):(s=ga[0],a=ga[1],o=ga[2],c=ga[3],l=Qr);var u,f,h,p,g,_,E;u=t[0]^e[0],f=t[n?3:1]^e[1],h=t[2]^e[2],p=t[n?1:3]^e[3];for(var w=3,y=1;y<i;++y)g=s[u>>>24]^a[f>>>16&255]^o[h>>>8&255]^c[p&255]^e[++w],_=s[f>>>24]^a[h>>>16&255]^o[p>>>8&255]^c[u&255]^e[++w],E=s[h>>>24]^a[p>>>16&255]^o[u>>>8&255]^c[f&255]^e[++w],p=s[p>>>24]^a[u>>>16&255]^o[f>>>8&255]^c[h&255]^e[++w],u=g,f=_,h=E;r[0]=l[u>>>24]<<24^l[f>>>16&255]<<16^l[h>>>8&255]<<8^l[p&255]^e[++w],r[n?3:1]=l[f>>>24]<<24^l[h>>>16&255]<<16^l[p>>>8&255]<<8^l[u&255]^e[++w],r[2]=l[h>>>24]<<24^l[p>>>16&255]<<16^l[u>>>8&255]<<8^l[f&255]^e[++w],r[n?1:3]=l[p>>>24]<<24^l[u>>>16&255]<<16^l[f>>>8&255]<<8^l[h&255]^e[++w];}function wd(e){e=e||{};var t=(e.mode||"CBC").toUpperCase(),r="AES-"+t,n;e.decrypt?n=Ut.cipher.createDecipher(r,e.key):n=Ut.cipher.createCipher(r,e.key);var i=n.start;return n.start=function(s,a){var o=null;a instanceof Ut.util.ByteBuffer&&(o=a,a={}),a=a||{},a.output=o,a.iv=s,i.call(n,a);},n}});var Ss=I((Jde,JO)=>{var yc=rt();yc.pki=yc.pki||{};var mv=JO.exports=yc.pki.oids=yc.oids=yc.oids||{};function ge(e,t){mv[e]=t,mv[t]=e;}function Rt(e,t){mv[e]=t;}ge("1.2.840.113549.1.1.1","rsaEncryption");ge("1.2.840.113549.1.1.4","md5WithRSAEncryption");ge("1.2.840.113549.1.1.5","sha1WithRSAEncryption");ge("1.2.840.113549.1.1.7","RSAES-OAEP");ge("1.2.840.113549.1.1.8","mgf1");ge("1.2.840.113549.1.1.9","pSpecified");ge("1.2.840.113549.1.1.10","RSASSA-PSS");ge("1.2.840.113549.1.1.11","sha256WithRSAEncryption");ge("1.2.840.113549.1.1.12","sha384WithRSAEncryption");ge("1.2.840.113549.1.1.13","sha512WithRSAEncryption");ge("1.3.101.112","EdDSA25519");ge("1.2.840.10040.4.3","dsa-with-sha1");ge("1.3.14.3.2.7","desCBC");ge("1.3.14.3.2.26","sha1");ge("1.3.14.3.2.29","sha1WithRSASignature");ge("2.16.840.1.101.3.4.2.1","sha256");ge("2.16.840.1.101.3.4.2.2","sha384");ge("2.16.840.1.101.3.4.2.3","sha512");ge("2.16.840.1.101.3.4.2.4","sha224");ge("2.16.840.1.101.3.4.2.5","sha512-224");ge("2.16.840.1.101.3.4.2.6","sha512-256");ge("1.2.840.113549.2.2","md2");ge("1.2.840.113549.2.5","md5");ge("1.2.840.113549.1.7.1","data");ge("1.2.840.113549.1.7.2","signedData");ge("1.2.840.113549.1.7.3","envelopedData");ge("1.2.840.113549.1.7.4","signedAndEnvelopedData");ge("1.2.840.113549.1.7.5","digestedData");ge("1.2.840.113549.1.7.6","encryptedData");ge("1.2.840.113549.1.9.1","emailAddress");ge("1.2.840.113549.1.9.2","unstructuredName");ge("1.2.840.113549.1.9.3","contentType");ge("1.2.840.113549.1.9.4","messageDigest");ge("1.2.840.113549.1.9.5","signingTime");ge("1.2.840.113549.1.9.6","counterSignature");ge("1.2.840.113549.1.9.7","challengePassword");ge("1.2.840.113549.1.9.8","unstructuredAddress");ge("1.2.840.113549.1.9.14","extensionRequest");ge("1.2.840.113549.1.9.20","friendlyName");ge("1.2.840.113549.1.9.21","localKeyId");ge("1.2.840.113549.1.9.22.1","x509Certificate");ge("1.2.840.113549.1.12.10.1.1","keyBag");ge("1.2.840.113549.1.12.10.1.2","pkcs8ShroudedKeyBag");ge("1.2.840.113549.1.12.10.1.3","certBag");ge("1.2.840.113549.1.12.10.1.4","crlBag");ge("1.2.840.113549.1.12.10.1.5","secretBag");ge("1.2.840.113549.1.12.10.1.6","safeContentsBag");ge("1.2.840.113549.1.5.13","pkcs5PBES2");ge("1.2.840.113549.1.5.12","pkcs5PBKDF2");ge("1.2.840.113549.1.12.1.1","pbeWithSHAAnd128BitRC4");ge("1.2.840.113549.1.12.1.2","pbeWithSHAAnd40BitRC4");ge("1.2.840.113549.1.12.1.3","pbeWithSHAAnd3-KeyTripleDES-CBC");ge("1.2.840.113549.1.12.1.4","pbeWithSHAAnd2-KeyTripleDES-CBC");ge("1.2.840.113549.1.12.1.5","pbeWithSHAAnd128BitRC2-CBC");ge("1.2.840.113549.1.12.1.6","pbewithSHAAnd40BitRC2-CBC");ge("1.2.840.113549.2.7","hmacWithSHA1");ge("1.2.840.113549.2.8","hmacWithSHA224");ge("1.2.840.113549.2.9","hmacWithSHA256");ge("1.2.840.113549.2.10","hmacWithSHA384");ge("1.2.840.113549.2.11","hmacWithSHA512");ge("1.2.840.113549.3.7","des-EDE3-CBC");ge("2.16.840.1.101.3.4.1.2","aes128-CBC");ge("2.16.840.1.101.3.4.1.22","aes192-CBC");ge("2.16.840.1.101.3.4.1.42","aes256-CBC");ge("2.5.4.3","commonName");ge("2.5.4.4","surname");ge("2.5.4.5","serialNumber");ge("2.5.4.6","countryName");ge("2.5.4.7","localityName");ge("2.5.4.8","stateOrProvinceName");ge("2.5.4.9","streetAddress");ge("2.5.4.10","organizationName");ge("2.5.4.11","organizationalUnitName");ge("2.5.4.12","title");ge("2.5.4.13","description");ge("2.5.4.15","businessCategory");ge("2.5.4.17","postalCode");ge("2.5.4.42","givenName");ge("1.3.6.1.4.1.311.60.2.1.2","jurisdictionOfIncorporationStateOrProvinceName");ge("1.3.6.1.4.1.311.60.2.1.3","jurisdictionOfIncorporationCountryName");ge("2.16.840.1.113730.1.1","nsCertType");ge("2.16.840.1.113730.1.13","nsComment");Rt("2.5.29.1","authorityKeyIdentifier");Rt("2.5.29.2","keyAttributes");Rt("2.5.29.3","certificatePolicies");Rt("2.5.29.4","keyUsageRestriction");Rt("2.5.29.5","policyMapping");Rt("2.5.29.6","subtreesConstraint");Rt("2.5.29.7","subjectAltName");Rt("2.5.29.8","issuerAltName");Rt("2.5.29.9","subjectDirectoryAttributes");Rt("2.5.29.10","basicConstraints");Rt("2.5.29.11","nameConstraints");Rt("2.5.29.12","policyConstraints");Rt("2.5.29.13","basicConstraints");ge("2.5.29.14","subjectKeyIdentifier");ge("2.5.29.15","keyUsage");Rt("2.5.29.16","privateKeyUsagePeriod");ge("2.5.29.17","subjectAltName");ge("2.5.29.18","issuerAltName");ge("2.5.29.19","basicConstraints");Rt("2.5.29.20","cRLNumber");Rt("2.5.29.21","cRLReason");Rt("2.5.29.22","expirationDate");Rt("2.5.29.23","instructionCode");Rt("2.5.29.24","invalidityDate");Rt("2.5.29.25","cRLDistributionPoints");Rt("2.5.29.26","issuingDistributionPoint");Rt("2.5.29.27","deltaCRLIndicator");Rt("2.5.29.28","issuingDistributionPoint");Rt("2.5.29.29","certificateIssuer");Rt("2.5.29.30","nameConstraints");ge("2.5.29.31","cRLDistributionPoints");ge("2.5.29.32","certificatePolicies");Rt("2.5.29.33","policyMappings");Rt("2.5.29.34","policyConstraints");ge("2.5.29.35","authorityKeyIdentifier");Rt("2.5.29.36","policyConstraints");ge("2.5.29.37","extKeyUsage");Rt("2.5.29.46","freshestCRL");Rt("2.5.29.54","inhibitAnyPolicy");ge("1.3.6.1.4.1.11129.2.4.2","timestampList");ge("1.3.6.1.5.5.7.1.1","authorityInfoAccess");ge("1.3.6.1.5.5.7.3.1","serverAuth");ge("1.3.6.1.5.5.7.3.2","clientAuth");ge("1.3.6.1.5.5.7.3.3","codeSigning");ge("1.3.6.1.5.5.7.3.4","emailProtection");ge("1.3.6.1.5.5.7.3.8","timeStamping");});var ai=I((ehe,tk)=>{var Wt=rt();_t();Ss();var Ce=tk.exports=Wt.asn1=Wt.asn1||{};Ce.Class={UNIVERSAL:0,APPLICATION:64,CONTEXT_SPECIFIC:128,PRIVATE:192};Ce.Type={NONE:0,BOOLEAN:1,INTEGER:2,BITSTRING:3,OCTETSTRING:4,NULL:5,OID:6,ODESC:7,EXTERNAL:8,REAL:9,ENUMERATED:10,EMBEDDED:11,UTF8:12,ROID:13,SEQUENCE:16,SET:17,PRINTABLESTRING:19,IA5STRING:22,UTCTIME:23,GENERALIZEDTIME:24,BMPSTRING:30};Ce.create=function(e,t,r,n,i){if(Wt.util.isArray(n)){for(var s=[],a=0;a<n.length;++a)n[a]!==void 0&&s.push(n[a]);n=s;}var o={tagClass:e,type:t,constructed:r,composed:r||Wt.util.isArray(n),value:n};return i&&"bitStringContents"in i&&(o.bitStringContents=i.bitStringContents,o.original=Ce.copy(o)),o};Ce.copy=function(e,t){var r;if(Wt.util.isArray(e)){r=[];for(var n=0;n<e.length;++n)r.push(Ce.copy(e[n],t));return r}return typeof e=="string"?e:(r={tagClass:e.tagClass,type:e.type,constructed:e.constructed,composed:e.composed,value:Ce.copy(e.value,t)},t&&!t.excludeBitStringContents&&(r.bitStringContents=e.bitStringContents),r)};Ce.equals=function(e,t,r){if(Wt.util.isArray(e)){if(!Wt.util.isArray(t)||e.length!==t.length)return !1;for(var n=0;n<e.length;++n)if(!Ce.equals(e[n],t[n]))return !1;return !0}if(typeof e!=typeof t)return !1;if(typeof e=="string")return e===t;var i=e.tagClass===t.tagClass&&e.type===t.type&&e.constructed===t.constructed&&e.composed===t.composed&&Ce.equals(e.value,t.value);return r&&r.includeBitStringContents&&(i=i&&e.bitStringContents===t.bitStringContents),i};Ce.getBerValueLength=function(e){var t=e.getByte();if(t!==128){var r,n=t&128;return n?r=e.getInt((t&127)<<3):r=t,r}};function vc(e,t,r){if(r>t){var n=new Error("Too few bytes to parse DER.");throw n.available=e.length(),n.remaining=t,n.requested=r,n}}var DJ=function(e,t){var r=e.getByte();if(t--,r!==128){var n,i=r&128;if(!i)n=r;else {var s=r&127;vc(e,t,s),n=e.getInt(s<<3);}if(n<0)throw new Error("Negative length: "+n);return n}};Ce.fromDer=function(e,t){t===void 0&&(t={strict:!0,parseAllBytes:!0,decodeBitStrings:!0}),typeof t=="boolean"&&(t={strict:t,parseAllBytes:!0,decodeBitStrings:!0}),"strict"in t||(t.strict=!0),"parseAllBytes"in t||(t.parseAllBytes=!0),"decodeBitStrings"in t||(t.decodeBitStrings=!0),typeof e=="string"&&(e=Wt.util.createBuffer(e));var r=e.length(),n=Cd(e,e.length(),0,t);if(t.parseAllBytes&&e.length()!==0){var i=new Error("Unparsed DER bytes remain after ASN.1 parsing.");throw i.byteCount=r,i.remaining=e.length(),i}return n};function Cd(e,t,r,n){var i;vc(e,t,2);var s=e.getByte();t--;var a=s&192,o=s&31;i=e.length();var c=DJ(e,t);if(t-=i-e.length(),c!==void 0&&c>t){if(n.strict){var l=new Error("Too few bytes to read ASN.1 value.");throw l.available=e.length(),l.remaining=t,l.requested=c,l}c=t;}var u,f,h=(s&32)===32;if(h)if(u=[],c===void 0)for(;;){if(vc(e,t,2),e.bytes(2)==="\0\0"){e.getBytes(2),t-=2;break}i=e.length(),u.push(Cd(e,t,r+1,n)),t-=i-e.length();}else for(;c>0;)i=e.length(),u.push(Cd(e,c,r+1,n)),t-=i-e.length(),c-=i-e.length();if(u===void 0&&a===Ce.Class.UNIVERSAL&&o===Ce.Type.BITSTRING&&(f=e.bytes(c)),u===void 0&&n.decodeBitStrings&&a===Ce.Class.UNIVERSAL&&o===Ce.Type.BITSTRING&&c>1){var p=e.read,g=t,_=0;if(o===Ce.Type.BITSTRING&&(vc(e,t,1),_=e.getByte(),t--),_===0)try{i=e.length();var E={strict:!0,decodeBitStrings:!0},w=Cd(e,t,r+1,E),y=i-e.length();t-=y,o==Ce.Type.BITSTRING&&y++;var b=w.tagClass;y===c&&(b===Ce.Class.UNIVERSAL||b===Ce.Class.CONTEXT_SPECIFIC)&&(u=[w]);}catch{}u===void 0&&(e.read=p,t=g);}if(u===void 0){if(c===void 0){if(n.strict)throw new Error("Non-constructed ASN.1 object of indefinite length.");c=t;}if(o===Ce.Type.BMPSTRING)for(u="";c>0;c-=2)vc(e,t,2),u+=String.fromCharCode(e.getInt16()),t-=2;else u=e.getBytes(c),t-=c;}var N=f===void 0?null:{bitStringContents:f};return Ce.create(a,o,h,u,N)}Ce.toDer=function(e){var t=Wt.util.createBuffer(),r=e.tagClass|e.type,n=Wt.util.createBuffer(),i=!1;if("bitStringContents"in e&&(i=!0,e.original&&(i=Ce.equals(e,e.original))),i)n.putBytes(e.bitStringContents);else if(e.composed){e.constructed?r|=32:n.putByte(0);for(var s=0;s<e.value.length;++s)e.value[s]!==void 0&&n.putBuffer(Ce.toDer(e.value[s]));}else if(e.type===Ce.Type.BMPSTRING)for(var s=0;s<e.value.length;++s)n.putInt16(e.value.charCodeAt(s));else e.type===Ce.Type.INTEGER&&e.value.length>1&&(e.value.charCodeAt(0)===0&&!(e.value.charCodeAt(1)&128)||e.value.charCodeAt(0)===255&&(e.value.charCodeAt(1)&128)===128)?n.putBytes(e.value.substr(1)):n.putBytes(e.value);if(t.putByte(r),n.length()<=127)t.putByte(n.length()&127);else {var a=n.length(),o="";do o+=String.fromCharCode(a&255),a=a>>>8;while(a>0);t.putByte(o.length|128);for(var s=o.length-1;s>=0;--s)t.putByte(o.charCodeAt(s));}return t.putBuffer(n),t};Ce.oidToDer=function(e){var t=e.split("."),r=Wt.util.createBuffer();r.putByte(40*parseInt(t[0],10)+parseInt(t[1],10));for(var n,i,s,a,o=2;o<t.length;++o){n=!0,i=[],s=parseInt(t[o],10);do a=s&127,s=s>>>7,n||(a|=128),i.push(a),n=!1;while(s>0);for(var c=i.length-1;c>=0;--c)r.putByte(i[c]);}return r};Ce.derToOid=function(e){var t;typeof e=="string"&&(e=Wt.util.createBuffer(e));var r=e.getByte();t=Math.floor(r/40)+"."+r%40;for(var n=0;e.length()>0;)r=e.getByte(),n=n<<7,r&128?n+=r&127:(t+="."+(n+r),n=0);return t};Ce.utcTimeToDate=function(e){var t=new Date,r=parseInt(e.substr(0,2),10);r=r>=50?1900+r:2e3+r;var n=parseInt(e.substr(2,2),10)-1,i=parseInt(e.substr(4,2),10),s=parseInt(e.substr(6,2),10),a=parseInt(e.substr(8,2),10),o=0;if(e.length>11){var c=e.charAt(10),l=10;c!=="+"&&c!=="-"&&(o=parseInt(e.substr(10,2),10),l+=2);}if(t.setUTCFullYear(r,n,i),t.setUTCHours(s,a,o,0),l&&(c=e.charAt(l),c==="+"||c==="-")){var u=parseInt(e.substr(l+1,2),10),f=parseInt(e.substr(l+4,2),10),h=u*60+f;h*=6e4,c==="+"?t.setTime(+t-h):t.setTime(+t+h);}return t};Ce.generalizedTimeToDate=function(e){var t=new Date,r=parseInt(e.substr(0,4),10),n=parseInt(e.substr(4,2),10)-1,i=parseInt(e.substr(6,2),10),s=parseInt(e.substr(8,2),10),a=parseInt(e.substr(10,2),10),o=parseInt(e.substr(12,2),10),c=0,l=0,u=!1;e.charAt(e.length-1)==="Z"&&(u=!0);var f=e.length-5,h=e.charAt(f);if(h==="+"||h==="-"){var p=parseInt(e.substr(f+1,2),10),g=parseInt(e.substr(f+4,2),10);l=p*60+g,l*=6e4,h==="+"&&(l*=-1),u=!0;}return e.charAt(14)==="."&&(c=parseFloat(e.substr(14),10)*1e3),u?(t.setUTCFullYear(r,n,i),t.setUTCHours(s,a,o,c),t.setTime(+t+l)):(t.setFullYear(r,n,i),t.setHours(s,a,o,c)),t};Ce.dateToUtcTime=function(e){if(typeof e=="string")return e;var t="",r=[];r.push((""+e.getUTCFullYear()).substr(2)),r.push(""+(e.getUTCMonth()+1)),r.push(""+e.getUTCDate()),r.push(""+e.getUTCHours()),r.push(""+e.getUTCMinutes()),r.push(""+e.getUTCSeconds());for(var n=0;n<r.length;++n)r[n].length<2&&(t+="0"),t+=r[n];return t+="Z",t};Ce.dateToGeneralizedTime=function(e){if(typeof e=="string")return e;var t="",r=[];r.push(""+e.getUTCFullYear()),r.push(""+(e.getUTCMonth()+1)),r.push(""+e.getUTCDate()),r.push(""+e.getUTCHours()),r.push(""+e.getUTCMinutes()),r.push(""+e.getUTCSeconds());for(var n=0;n<r.length;++n)r[n].length<2&&(t+="0"),t+=r[n];return t+="Z",t};Ce.integerToDer=function(e){var t=Wt.util.createBuffer();if(e>=-128&&e<128)return t.putSignedInt(e,8);if(e>=-32768&&e<32768)return t.putSignedInt(e,16);if(e>=-8388608&&e<8388608)return t.putSignedInt(e,24);if(e>=-2147483648&&e<2147483648)return t.putSignedInt(e,32);var r=new Error("Integer too large; max is 32-bits.");throw r.integer=e,r};Ce.derToInteger=function(e){typeof e=="string"&&(e=Wt.util.createBuffer(e));var t=e.length()*8;if(t>32)throw new Error("Integer too large; max is 32-bits.");return e.getSignedInt(t)};Ce.validate=function(e,t,r,n){var i=!1;if((e.tagClass===t.tagClass||typeof t.tagClass>"u")&&(e.type===t.type||typeof t.type>"u"))if(e.constructed===t.constructed||typeof t.constructed>"u"){if(i=!0,t.value&&Wt.util.isArray(t.value))for(var s=0,a=0;i&&a<t.value.length;++a)i=t.value[a].optional||!1,e.value[s]&&(i=Ce.validate(e.value[s],t.value[a],r,n),i?++s:t.value[a].optional&&(i=!0)),!i&&n&&n.push("["+t.name+'] Tag class "'+t.tagClass+'", type "'+t.type+'" expected value length "'+t.value.length+'", got "'+e.value.length+'"');if(i&&r&&(t.capture&&(r[t.capture]=e.value),t.captureAsn1&&(r[t.captureAsn1]=e),t.captureBitStringContents&&"bitStringContents"in e&&(r[t.captureBitStringContents]=e.bitStringContents),t.captureBitStringValue&&"bitStringContents"in e)){if(e.bitStringContents.length<2)r[t.captureBitStringValue]="";else {var c=e.bitStringContents.charCodeAt(0);if(c!==0)throw new Error("captureBitStringValue only supported for zero unused bits");r[t.captureBitStringValue]=e.bitStringContents.slice(1);}}}else n&&n.push("["+t.name+'] Expected constructed "'+t.constructed+'", got "'+e.constructed+'"');else n&&(e.tagClass!==t.tagClass&&n.push("["+t.name+'] Expected tag class "'+t.tagClass+'", got "'+e.tagClass+'"'),e.type!==t.type&&n.push("["+t.name+'] Expected type "'+t.type+'", got "'+e.type+'"'));return i};var ek=/[^\\u0000-\\u00ff]/;Ce.prettyPrint=function(e,t,r){var n="";t=t||0,r=r||2,t>0&&(n+=`
`);for(var i="",s=0;s<t*r;++s)i+=" ";switch(n+=i+"Tag: ",e.tagClass){case Ce.Class.UNIVERSAL:n+="Universal:";break;case Ce.Class.APPLICATION:n+="Application:";break;case Ce.Class.CONTEXT_SPECIFIC:n+="Context-Specific:";break;case Ce.Class.PRIVATE:n+="Private:";break}if(e.tagClass===Ce.Class.UNIVERSAL)switch(n+=e.type,e.type){case Ce.Type.NONE:n+=" (None)";break;case Ce.Type.BOOLEAN:n+=" (Boolean)";break;case Ce.Type.INTEGER:n+=" (Integer)";break;case Ce.Type.BITSTRING:n+=" (Bit string)";break;case Ce.Type.OCTETSTRING:n+=" (Octet string)";break;case Ce.Type.NULL:n+=" (Null)";break;case Ce.Type.OID:n+=" (Object Identifier)";break;case Ce.Type.ODESC:n+=" (Object Descriptor)";break;case Ce.Type.EXTERNAL:n+=" (External or Instance of)";break;case Ce.Type.REAL:n+=" (Real)";break;case Ce.Type.ENUMERATED:n+=" (Enumerated)";break;case Ce.Type.EMBEDDED:n+=" (Embedded PDV)";break;case Ce.Type.UTF8:n+=" (UTF8)";break;case Ce.Type.ROID:n+=" (Relative Object Identifier)";break;case Ce.Type.SEQUENCE:n+=" (Sequence)";break;case Ce.Type.SET:n+=" (Set)";break;case Ce.Type.PRINTABLESTRING:n+=" (Printable String)";break;case Ce.Type.IA5String:n+=" (IA5String (ASCII))";break;case Ce.Type.UTCTIME:n+=" (UTC time)";break;case Ce.Type.GENERALIZEDTIME:n+=" (Generalized time)";break;case Ce.Type.BMPSTRING:n+=" (BMP String)";break}else n+=e.type;if(n+=`
`,n+=i+"Constructed: "+e.constructed+`
`,e.composed){for(var a=0,o="",s=0;s<e.value.length;++s)e.value[s]!==void 0&&(a+=1,o+=Ce.prettyPrint(e.value[s],t+1,r),s+1<e.value.length&&(o+=","));n+=i+"Sub values: "+a+o;}else {if(n+=i+"Value: ",e.type===Ce.Type.OID){var c=Ce.derToOid(e.value);n+=c,Wt.pki&&Wt.pki.oids&&c in Wt.pki.oids&&(n+=" ("+Wt.pki.oids[c]+") ");}if(e.type===Ce.Type.INTEGER)try{n+=Ce.derToInteger(e.value);}catch{n+="0x"+Wt.util.bytesToHex(e.value);}else if(e.type===Ce.Type.BITSTRING){if(e.value.length>1?n+="0x"+Wt.util.bytesToHex(e.value.slice(1)):n+="(none)",e.value.length>0){var l=e.value.charCodeAt(0);l==1?n+=" (1 unused bit shown)":l>1&&(n+=" ("+l+" unused bits shown)");}}else if(e.type===Ce.Type.OCTETSTRING)ek.test(e.value)||(n+="("+e.value+") "),n+="0x"+Wt.util.bytesToHex(e.value);else if(e.type===Ce.Type.UTF8)try{n+=Wt.util.decodeUtf8(e.value);}catch(u){if(u.message==="URI malformed")n+="0x"+Wt.util.bytesToHex(e.value)+" (malformed UTF8)";else throw u}else e.type===Ce.Type.PRINTABLESTRING||e.type===Ce.Type.IA5String?n+=e.value:ek.test(e.value)?n+="0x"+Wt.util.bytesToHex(e.value):e.value.length===0?n+="[null]":n+=e.value;}return n};});var bi=I((the,rk)=>{var xd=rt();rk.exports=xd.md=xd.md||{};xd.md.algorithms=xd.md.algorithms||{};});var Co=I((rhe,nk)=>{var Gi=rt();bi();_t();var OJ=nk.exports=Gi.hmac=Gi.hmac||{};OJ.create=function(){var e=null,t=null,r=null,n=null,i={};return i.start=function(s,a){if(s!==null)if(typeof s=="string")if(s=s.toLowerCase(),s in Gi.md.algorithms)t=Gi.md.algorithms[s].create();else throw new Error('Unknown hash algorithm "'+s+'"');else t=s;if(a===null)a=e;else {if(typeof a=="string")a=Gi.util.createBuffer(a);else if(Gi.util.isArray(a)){var o=a;a=Gi.util.createBuffer();for(var c=0;c<o.length;++c)a.putByte(o[c]);}var l=a.length();l>t.blockLength&&(t.start(),t.update(a.bytes()),a=t.digest()),r=Gi.util.createBuffer(),n=Gi.util.createBuffer(),l=a.length();for(var c=0;c<l;++c){var o=a.at(c);r.putByte(54^o),n.putByte(92^o);}if(l<t.blockLength)for(var o=t.blockLength-l,c=0;c<o;++c)r.putByte(54),n.putByte(92);e=a,r=r.bytes(),n=n.bytes();}t.start(),t.update(r);},i.update=function(s){t.update(s);},i.getMac=function(){var s=t.digest().bytes();return t.start(),t.update(n),t.update(s),t.digest()},i.digest=i.getMac,i};});var Ad=I((nhe,ok)=>{var Si=rt();bi();_t();var sk=ok.exports=Si.md5=Si.md5||{};Si.md.md5=Si.md.algorithms.md5=sk;sk.create=function(){ak||kJ();var e=null,t=Si.util.createBuffer(),r=new Array(16),n={algorithm:"md5",blockLength:64,digestLength:16,messageLength:0,fullMessageLength:null,messageLengthSize:8};return n.start=function(){n.messageLength=0,n.fullMessageLength=n.messageLength64=[];for(var i=n.messageLengthSize/4,s=0;s<i;++s)n.fullMessageLength.push(0);return t=Si.util.createBuffer(),e={h0:1732584193,h1:4023233417,h2:2562383102,h3:271733878},n},n.start(),n.update=function(i,s){s==="utf8"&&(i=Si.util.encodeUtf8(i));var a=i.length;n.messageLength+=a,a=[a/4294967296>>>0,a>>>0];for(var o=n.fullMessageLength.length-1;o>=0;--o)n.fullMessageLength[o]+=a[1],a[1]=a[0]+(n.fullMessageLength[o]/4294967296>>>0),n.fullMessageLength[o]=n.fullMessageLength[o]>>>0,a[0]=a[1]/4294967296>>>0;return t.putBytes(i),ik(e,r,t),(t.read>2048||t.length()===0)&&t.compact(),n},n.digest=function(){var i=Si.util.createBuffer();i.putBytes(t.bytes());var s=n.fullMessageLength[n.fullMessageLength.length-1]+n.messageLengthSize,a=s&n.blockLength-1;i.putBytes(yv.substr(0,n.blockLength-a));for(var o,c=0,l=n.fullMessageLength.length-1;l>=0;--l)o=n.fullMessageLength[l]*8+c,c=o/4294967296>>>0,i.putInt32Le(o>>>0);var u={h0:e.h0,h1:e.h1,h2:e.h2,h3:e.h3};ik(u,r,i);var f=Si.util.createBuffer();return f.putInt32Le(u.h0),f.putInt32Le(u.h1),f.putInt32Le(u.h2),f.putInt32Le(u.h3),f},n};var yv=null,Td=null,_c=null,xo=null,ak=!1;function kJ(){yv="\x80",yv+=Si.util.fillString("\0",64),Td=[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,1,6,11,0,5,10,15,4,9,14,3,8,13,2,7,12,5,8,11,14,1,4,7,10,13,0,3,6,9,12,15,2,0,7,14,5,12,3,10,1,8,15,6,13,4,11,2,9],_c=[7,12,17,22,7,12,17,22,7,12,17,22,7,12,17,22,5,9,14,20,5,9,14,20,5,9,14,20,5,9,14,20,4,11,16,23,4,11,16,23,4,11,16,23,4,11,16,23,6,10,15,21,6,10,15,21,6,10,15,21,6,10,15,21],xo=new Array(64);for(var e=0;e<64;++e)xo[e]=Math.floor(Math.abs(Math.sin(e+1))*4294967296);ak=!0;}function ik(e,t,r){for(var n,i,s,a,o,c,l,u,f=r.length();f>=64;){for(i=e.h0,s=e.h1,a=e.h2,o=e.h3,u=0;u<16;++u)t[u]=r.getInt32Le(),c=o^s&(a^o),n=i+c+xo[u]+t[u],l=_c[u],i=o,o=a,a=s,s+=n<<l|n>>>32-l;for(;u<32;++u)c=a^o&(s^a),n=i+c+xo[u]+t[Td[u]],l=_c[u],i=o,o=a,a=s,s+=n<<l|n>>>32-l;for(;u<48;++u)c=s^a^o,n=i+c+xo[u]+t[Td[u]],l=_c[u],i=o,o=a,a=s,s+=n<<l|n>>>32-l;for(;u<64;++u)c=a^(s|~o),n=i+c+xo[u]+t[Td[u]],l=_c[u],i=o,o=a,a=s,s+=n<<l|n>>>32-l;e.h0=e.h0+i|0,e.h1=e.h1+s|0,e.h2=e.h2+a|0,e.h3=e.h3+o|0,f-=64;}}});var ma=I((ihe,ck)=>{var Id=rt();_t();var uk=ck.exports=Id.pem=Id.pem||{};uk.encode=function(e,t){t=t||{};var r="-----BEGIN "+e.type+`-----\r
`,n;if(e.procType&&(n={name:"Proc-Type",values:[String(e.procType.version),e.procType.type]},r+=Rd(n)),e.contentDomain&&(n={name:"Content-Domain",values:[e.contentDomain]},r+=Rd(n)),e.dekInfo&&(n={name:"DEK-Info",values:[e.dekInfo.algorithm]},e.dekInfo.parameters&&n.values.push(e.dekInfo.parameters),r+=Rd(n)),e.headers)for(var i=0;i<e.headers.length;++i)r+=Rd(e.headers[i]);return e.procType&&(r+=`\r
`),r+=Id.util.encode64(e.body,t.maxline||64)+`\r
`,r+="-----END "+e.type+`-----\r
`,r};uk.decode=function(e){for(var t=[],r=/\s*-----BEGIN ([A-Z0-9- ]+)-----\r?\n?([\x21-\x7e\s]+?(?:\r?\n\r?\n))?([:A-Za-z0-9+\/=\s]+?)-----END \1-----/g,n=/([\x21-\x7e]+):\s*([\x21-\x7e\s^:]+)/,i=/\r?\n/,s;s=r.exec(e),!!s;){var a=s[1];a==="NEW CERTIFICATE REQUEST"&&(a="CERTIFICATE REQUEST");var o={type:a,procType:null,contentDomain:null,dekInfo:null,headers:[],body:Id.util.decode64(s[3])};if(t.push(o),!!s[2]){for(var c=s[2].split(i),l=0;s&&l<c.length;){for(var u=c[l].replace(/\s+$/,""),f=l+1;f<c.length;++f){var h=c[f];if(!/\s/.test(h[0]))break;u+=h,l=f;}if(s=u.match(n),s){for(var p={name:s[1],values:[]},g=s[2].split(","),_=0;_<g.length;++_)p.values.push(LJ(g[_]));if(o.procType)if(!o.contentDomain&&p.name==="Content-Domain")o.contentDomain=g[0]||"";else if(!o.dekInfo&&p.name==="DEK-Info"){if(p.values.length===0)throw new Error('Invalid PEM formatted message. The "DEK-Info" header must have at least one subfield.');o.dekInfo={algorithm:g[0],parameters:g[1]||null};}else o.headers.push(p);else {if(p.name!=="Proc-Type")throw new Error('Invalid PEM formatted message. The first encapsulated header must be "Proc-Type".');if(p.values.length!==2)throw new Error('Invalid PEM formatted message. The "Proc-Type" header must have two subfields.');o.procType={version:g[0],type:g[1]};}}++l;}if(o.procType==="ENCRYPTED"&&!o.dekInfo)throw new Error('Invalid PEM formatted message. The "DEK-Info" header must be present if "Proc-Type" is "ENCRYPTED".')}}if(t.length===0)throw new Error("Invalid PEM formatted message.");return t};function Rd(e){for(var t=e.name+": ",r=[],n=function(c,l){return " "+l},i=0;i<e.values.length;++i)r.push(e.values[i].replace(/^(\S+\r\n)/,n));t+=r.join(",")+`\r
`;for(var s=0,a=-1,i=0;i<t.length;++i,++s)if(s>65&&a!==-1){var o=t[a];o===","?(++a,t=t.substr(0,a)+`\r
 `+t.substr(a)):t=t.substr(0,a)+`\r
`+o+t.substr(a+1),s=i-a-1,a=-1,++i;}else (t[i]===" "||t[i]==="	"||t[i]===",")&&(a=i);return t}function LJ(e){return e.replace(/^\s+/,"")}});var bc=I((she,fk)=>{var Qt=rt();bd();dv();_t();fk.exports=Qt.des=Qt.des||{};Qt.des.startEncrypting=function(e,t,r,n){var i=Pd({key:e,output:r,decrypt:!1,mode:n||(t===null?"ECB":"CBC")});return i.start(t),i};Qt.des.createEncryptionCipher=function(e,t){return Pd({key:e,output:null,decrypt:!1,mode:t})};Qt.des.startDecrypting=function(e,t,r,n){var i=Pd({key:e,output:r,decrypt:!0,mode:n||(t===null?"ECB":"CBC")});return i.start(t),i};Qt.des.createDecryptionCipher=function(e,t){return Pd({key:e,output:null,decrypt:!0,mode:t})};Qt.des.Algorithm=function(e,t){var r=this;r.name=e,r.mode=new t({blockSize:8,cipher:{encrypt:function(n,i){return lk(r._keys,n,i,!1)},decrypt:function(n,i){return lk(r._keys,n,i,!0)}}}),r._init=!1;};Qt.des.Algorithm.prototype.initialize=function(e){if(!this._init){var t=Qt.util.createBuffer(e.key);if(this.name.indexOf("3DES")===0&&t.length()!==24)throw new Error("Invalid Triple-DES key size: "+t.length()*8);this._keys=HJ(t),this._init=!0;}};Ei("DES-ECB",Qt.cipher.modes.ecb);Ei("DES-CBC",Qt.cipher.modes.cbc);Ei("DES-CFB",Qt.cipher.modes.cfb);Ei("DES-OFB",Qt.cipher.modes.ofb);Ei("DES-CTR",Qt.cipher.modes.ctr);Ei("3DES-ECB",Qt.cipher.modes.ecb);Ei("3DES-CBC",Qt.cipher.modes.cbc);Ei("3DES-CFB",Qt.cipher.modes.cfb);Ei("3DES-OFB",Qt.cipher.modes.ofb);Ei("3DES-CTR",Qt.cipher.modes.ctr);function Ei(e,t){var r=function(){return new Qt.des.Algorithm(e,t)};Qt.cipher.registerAlgorithm(e,r);}var BJ=[16843776,0,65536,16843780,16842756,66564,4,65536,1024,16843776,16843780,1024,16778244,16842756,16777216,4,1028,16778240,16778240,66560,66560,16842752,16842752,16778244,65540,16777220,16777220,65540,0,1028,66564,16777216,65536,16843780,4,16842752,16843776,16777216,16777216,1024,16842756,65536,66560,16777220,1024,4,16778244,66564,16843780,65540,16842752,16778244,16777220,1028,66564,16843776,1028,16778240,16778240,0,65540,66560,0,16842756],FJ=[-2146402272,-2147450880,32768,1081376,1048576,32,-2146435040,-2147450848,-2147483616,-2146402272,-2146402304,-2147483648,-2147450880,1048576,32,-2146435040,1081344,1048608,-2147450848,0,-2147483648,32768,1081376,-2146435072,1048608,-2147483616,0,1081344,32800,-2146402304,-2146435072,32800,0,1081376,-2146435040,1048576,-2147450848,-2146435072,-2146402304,32768,-2146435072,-2147450880,32,-2146402272,1081376,32,32768,-2147483648,32800,-2146402304,1048576,-2147483616,1048608,-2147450848,-2147483616,1048608,1081344,0,-2147450880,32800,-2147483648,-2146435040,-2146402272,1081344],qJ=[520,134349312,0,134348808,134218240,0,131592,134218240,131080,134217736,134217736,131072,134349320,131080,134348800,520,134217728,8,134349312,512,131584,134348800,134348808,131592,134218248,131584,131072,134218248,8,134349320,512,134217728,134349312,134217728,131080,520,131072,134349312,134218240,0,512,131080,134349320,134218240,134217736,512,0,134348808,134218248,131072,134217728,134349320,8,131592,131584,134217736,134348800,134218248,520,134348800,131592,8,134348808,131584],MJ=[8396801,8321,8321,128,8396928,8388737,8388609,8193,0,8396800,8396800,8396929,129,0,8388736,8388609,1,8192,8388608,8396801,128,8388608,8193,8320,8388737,1,8320,8388736,8192,8396928,8396929,129,8388736,8388609,8396800,8396929,129,0,0,8396800,8320,8388736,8388737,1,8396801,8321,8321,128,8396929,129,1,8192,8388609,8193,8396928,8388737,8193,8320,8388608,8396801,128,8388608,8192,8396928],UJ=[256,34078976,34078720,1107296512,524288,256,1073741824,34078720,1074266368,524288,33554688,1074266368,1107296512,1107820544,524544,1073741824,33554432,1074266112,1074266112,0,1073742080,1107820800,1107820800,33554688,1107820544,1073742080,0,1107296256,34078976,33554432,1107296256,524544,524288,1107296512,256,33554432,1073741824,34078720,1107296512,1074266368,33554688,1073741824,1107820544,34078976,1074266368,256,33554432,1107820544,1107820800,524544,1107296256,1107820800,34078720,0,1074266112,1107296256,524544,33554688,1073742080,524288,0,1074266112,34078976,1073742080],$J=[536870928,541065216,16384,541081616,541065216,16,541081616,4194304,536887296,4210704,4194304,536870928,4194320,536887296,536870912,16400,0,4194320,536887312,16384,4210688,536887312,16,541065232,541065232,0,4210704,541081600,16400,4210688,541081600,536870912,536887296,16,541065232,4210688,541081616,4194304,16400,536870928,4194304,536887296,536870912,16400,536870928,541081616,4210688,541065216,4210704,541081600,0,541065232,16,16384,541065216,4210704,16384,4194320,536887312,0,541081600,536870912,4194320,536887312],jJ=[2097152,69206018,67110914,0,2048,67110914,2099202,69208064,69208066,2097152,0,67108866,2,67108864,69206018,2050,67110912,2099202,2097154,67110912,67108866,69206016,69208064,2097154,69206016,2048,2050,69208066,2099200,2,67108864,2099200,67108864,2099200,2097152,67110914,67110914,69206018,69206018,2,2097154,67108864,67110912,2097152,69208064,2050,2099202,69208064,2050,67108866,69208066,69206016,2099200,0,2,69208066,0,2099202,69206016,2048,67108866,67110912,2048,2097154],VJ=[268439616,4096,262144,268701760,268435456,268439616,64,268435456,262208,268697600,268701760,266240,268701696,266304,4096,64,268697600,268435520,268439552,4160,266240,262208,268697664,268701696,4160,0,0,268697664,268435520,268439552,266304,262144,266304,262144,268701696,4096,64,268697664,4096,266304,268439552,64,268435520,268697600,268697664,268435456,262144,268439616,0,268701760,262208,268435520,268697600,268439552,268439616,0,268701760,266240,266240,4160,4160,262208,268435456,268701696];function HJ(e){for(var t=[0,4,536870912,536870916,65536,65540,536936448,536936452,512,516,536871424,536871428,66048,66052,536936960,536936964],r=[0,1,1048576,1048577,67108864,67108865,68157440,68157441,256,257,1048832,1048833,67109120,67109121,68157696,68157697],n=[0,8,2048,2056,16777216,16777224,16779264,16779272,0,8,2048,2056,16777216,16777224,16779264,16779272],i=[0,2097152,134217728,136314880,8192,2105344,134225920,136323072,131072,2228224,134348800,136445952,139264,2236416,134356992,136454144],s=[0,262144,16,262160,0,262144,16,262160,4096,266240,4112,266256,4096,266240,4112,266256],a=[0,1024,32,1056,0,1024,32,1056,33554432,33555456,33554464,33555488,33554432,33555456,33554464,33555488],o=[0,268435456,524288,268959744,2,268435458,524290,268959746,0,268435456,524288,268959744,2,268435458,524290,268959746],c=[0,65536,2048,67584,536870912,536936448,536872960,536938496,131072,196608,133120,198656,537001984,537067520,537004032,537069568],l=[0,262144,0,262144,2,262146,2,262146,33554432,33816576,33554432,33816576,33554434,33816578,33554434,33816578],u=[0,268435456,8,268435464,0,268435456,8,268435464,1024,268436480,1032,268436488,1024,268436480,1032,268436488],f=[0,32,0,32,1048576,1048608,1048576,1048608,8192,8224,8192,8224,1056768,1056800,1056768,1056800],h=[0,16777216,512,16777728,2097152,18874368,2097664,18874880,67108864,83886080,67109376,83886592,69206016,85983232,69206528,85983744],p=[0,4096,134217728,134221824,524288,528384,134742016,134746112,16,4112,134217744,134221840,524304,528400,134742032,134746128],g=[0,4,256,260,0,4,256,260,1,5,257,261,1,5,257,261],_=e.length()>8?3:1,E=[],w=[0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0],y=0,b,N=0;N<_;N++){var L=e.getInt32(),V=e.getInt32();b=(L>>>4^V)&252645135,V^=b,L^=b<<4,b=(V>>>-16^L)&65535,L^=b,V^=b<<-16,b=(L>>>2^V)&858993459,V^=b,L^=b<<2,b=(V>>>-16^L)&65535,L^=b,V^=b<<-16,b=(L>>>1^V)&1431655765,V^=b,L^=b<<1,b=(V>>>8^L)&16711935,L^=b,V^=b<<8,b=(L>>>1^V)&1431655765,V^=b,L^=b<<1,b=L<<8|V>>>20&240,L=V<<24|V<<8&16711680|V>>>8&65280|V>>>24&240,V=b;for(var Z=0;Z<w.length;++Z){w[Z]?(L=L<<2|L>>>26,V=V<<2|V>>>26):(L=L<<1|L>>>27,V=V<<1|V>>>27),L&=-15,V&=-15;var G=t[L>>>28]|r[L>>>24&15]|n[L>>>20&15]|i[L>>>16&15]|s[L>>>12&15]|a[L>>>8&15]|o[L>>>4&15],z=c[V>>>28]|l[V>>>24&15]|u[V>>>20&15]|f[V>>>16&15]|h[V>>>12&15]|p[V>>>8&15]|g[V>>>4&15];b=(z>>>16^G)&65535,E[y++]=G^b,E[y++]=z^b<<16;}}return E}function lk(e,t,r,n){var i=e.length===32?3:9,s;i===3?s=n?[30,-2,-2]:[0,32,2]:s=n?[94,62,-2,32,64,2,30,-2,-2]:[0,32,2,62,30,-2,64,96,2];var a,o=t[0],c=t[1];a=(o>>>4^c)&252645135,c^=a,o^=a<<4,a=(o>>>16^c)&65535,c^=a,o^=a<<16,a=(c>>>2^o)&858993459,o^=a,c^=a<<2,a=(c>>>8^o)&16711935,o^=a,c^=a<<8,a=(o>>>1^c)&1431655765,c^=a,o^=a<<1,o=o<<1|o>>>31,c=c<<1|c>>>31;for(var l=0;l<i;l+=3){for(var u=s[l+1],f=s[l+2],h=s[l];h!=u;h+=f){var p=c^e[h],g=(c>>>4|c<<28)^e[h+1];a=o,o=c,c=a^(FJ[p>>>24&63]|MJ[p>>>16&63]|$J[p>>>8&63]|VJ[p&63]|BJ[g>>>24&63]|qJ[g>>>16&63]|UJ[g>>>8&63]|jJ[g&63]);}a=o,o=c,c=a;}o=o>>>1|o<<31,c=c>>>1|c<<31,a=(o>>>1^c)&1431655765,c^=a,o^=a<<1,a=(c>>>8^o)&16711935,o^=a,c^=a<<8,a=(c>>>2^o)&858993459,o^=a,c^=a<<2,a=(o>>>16^c)&65535,c^=a,o^=a<<16,a=(o>>>4^c)&252645135,c^=a,o^=a<<4,r[0]=o,r[1]=c;}function Pd(e){e=e||{};var t=(e.mode||"CBC").toUpperCase(),r="DES-"+t,n;e.decrypt?n=Qt.cipher.createDecipher(r,e.key):n=Qt.cipher.createCipher(r,e.key);var i=n.start;return n.start=function(s,a){var o=null;a instanceof Qt.util.ByteBuffer&&(o=a,a={}),a=a||{},a.output=o,a.iv=s,i.call(n,a);},n}});var Nd=I((ahe,dk)=>{var Xr=rt();Co();bi();_t();var WJ=Xr.pkcs5=Xr.pkcs5||{},zi;Xr.util.isNodejs&&!Xr.options.usePureJavaScript&&(zi=he("crypto"));dk.exports=Xr.pbkdf2=WJ.pbkdf2=function(e,t,r,n,i,s){if(typeof i=="function"&&(s=i,i=null),Xr.util.isNodejs&&!Xr.options.usePureJavaScript&&zi.pbkdf2&&(i===null||typeof i!="object")&&(zi.pbkdf2Sync.length>4||!i||i==="sha1"))return typeof i!="string"&&(i="sha1"),e=Buffer.from(e,"binary"),t=Buffer.from(t,"binary"),s?zi.pbkdf2Sync.length===4?zi.pbkdf2(e,t,r,n,function(b,N){if(b)return s(b);s(null,N.toString("binary"));}):zi.pbkdf2(e,t,r,n,i,function(b,N){if(b)return s(b);s(null,N.toString("binary"));}):zi.pbkdf2Sync.length===4?zi.pbkdf2Sync(e,t,r,n).toString("binary"):zi.pbkdf2Sync(e,t,r,n,i).toString("binary");if((typeof i>"u"||i===null)&&(i="sha1"),typeof i=="string"){if(!(i in Xr.md.algorithms))throw new Error("Unknown hash algorithm: "+i);i=Xr.md[i].create();}var a=i.digestLength;if(n>4294967295*a){var o=new Error("Derived key is too long.");if(s)return s(o);throw o}var c=Math.ceil(n/a),l=n-(c-1)*a,u=Xr.hmac.create();u.start(i,e);var f="",h,p,g;if(!s){for(var _=1;_<=c;++_){u.start(null,null),u.update(t),u.update(Xr.util.int32ToBytes(_)),h=g=u.digest().getBytes();for(var E=2;E<=r;++E)u.start(null,null),u.update(g),p=u.digest().getBytes(),h=Xr.util.xorBytes(h,p,a),g=p;f+=_<c?h:h.substr(0,l);}return f}var _=1,E;function w(){if(_>c)return s(null,f);u.start(null,null),u.update(t),u.update(Xr.util.int32ToBytes(_)),h=g=u.digest().getBytes(),E=2,y();}function y(){if(E<=r)return u.start(null,null),u.update(g),p=u.digest().getBytes(),h=Xr.util.xorBytes(h,p,a),g=p,++E,Xr.util.setImmediate(y);f+=_<c?h:h.substr(0,l),++_,w();}w();};});var _v=I((ohe,yk)=>{var wi=rt();bi();_t();var pk=yk.exports=wi.sha256=wi.sha256||{};wi.md.sha256=wi.md.algorithms.sha256=pk;pk.create=function(){gk||KJ();var e=null,t=wi.util.createBuffer(),r=new Array(64),n={algorithm:"sha256",blockLength:64,digestLength:32,messageLength:0,fullMessageLength:null,messageLengthSize:8};return n.start=function(){n.messageLength=0,n.fullMessageLength=n.messageLength64=[];for(var i=n.messageLengthSize/4,s=0;s<i;++s)n.fullMessageLength.push(0);return t=wi.util.createBuffer(),e={h0:1779033703,h1:3144134277,h2:1013904242,h3:2773480762,h4:1359893119,h5:2600822924,h6:528734635,h7:1541459225},n},n.start(),n.update=function(i,s){s==="utf8"&&(i=wi.util.encodeUtf8(i));var a=i.length;n.messageLength+=a,a=[a/4294967296>>>0,a>>>0];for(var o=n.fullMessageLength.length-1;o>=0;--o)n.fullMessageLength[o]+=a[1],a[1]=a[0]+(n.fullMessageLength[o]/4294967296>>>0),n.fullMessageLength[o]=n.fullMessageLength[o]>>>0,a[0]=a[1]/4294967296>>>0;return t.putBytes(i),hk(e,r,t),(t.read>2048||t.length()===0)&&t.compact(),n},n.digest=function(){var i=wi.util.createBuffer();i.putBytes(t.bytes());var s=n.fullMessageLength[n.fullMessageLength.length-1]+n.messageLengthSize,a=s&n.blockLength-1;i.putBytes(vv.substr(0,n.blockLength-a));for(var o,c,l=n.fullMessageLength[0]*8,u=0;u<n.fullMessageLength.length-1;++u)o=n.fullMessageLength[u+1]*8,c=o/4294967296>>>0,l+=c,i.putInt32(l>>>0),l=o>>>0;i.putInt32(l);var f={h0:e.h0,h1:e.h1,h2:e.h2,h3:e.h3,h4:e.h4,h5:e.h5,h6:e.h6,h7:e.h7};hk(f,r,i);var h=wi.util.createBuffer();return h.putInt32(f.h0),h.putInt32(f.h1),h.putInt32(f.h2),h.putInt32(f.h3),h.putInt32(f.h4),h.putInt32(f.h5),h.putInt32(f.h6),h.putInt32(f.h7),h},n};var vv=null,gk=!1,mk=null;function KJ(){vv="\x80",vv+=wi.util.fillString("\0",64),mk=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298],gk=!0;}function hk(e,t,r){for(var n,i,s,a,o,c,l,u,f,h,p,g,_,E,w,y=r.length();y>=64;){for(l=0;l<16;++l)t[l]=r.getInt32();for(;l<64;++l)n=t[l-2],n=(n>>>17|n<<15)^(n>>>19|n<<13)^n>>>10,i=t[l-15],i=(i>>>7|i<<25)^(i>>>18|i<<14)^i>>>3,t[l]=n+t[l-7]+i+t[l-16]|0;for(u=e.h0,f=e.h1,h=e.h2,p=e.h3,g=e.h4,_=e.h5,E=e.h6,w=e.h7,l=0;l<64;++l)a=(g>>>6|g<<26)^(g>>>11|g<<21)^(g>>>25|g<<7),o=E^g&(_^E),s=(u>>>2|u<<30)^(u>>>13|u<<19)^(u>>>22|u<<10),c=u&f|h&(u^f),n=w+a+o+mk[l]+t[l],i=s+c,w=E,E=_,_=g,g=p+n>>>0,p=h,h=f,f=u,u=n+i>>>0;e.h0=e.h0+u|0,e.h1=e.h1+f|0,e.h2=e.h2+h|0,e.h3=e.h3+p|0,e.h4=e.h4+g|0,e.h5=e.h5+_|0,e.h6=e.h6+E|0,e.h7=e.h7+w|0,y-=64;}}});var bv=I((uhe,vk)=>{var Ci=rt();_t();var Dd=null;Ci.util.isNodejs&&!Ci.options.usePureJavaScript&&!process.versions["node-webkit"]&&(Dd=he("crypto"));var GJ=vk.exports=Ci.prng=Ci.prng||{};GJ.create=function(e){for(var t={plugin:e,key:null,seed:null,time:null,reseeds:0,generated:0,keyBytes:""},r=e.md,n=new Array(32),i=0;i<32;++i)n[i]=r.create();t.pools=n,t.pool=0,t.generate=function(l,u){if(!u)return t.generateSync(l);var f=t.plugin.cipher,h=t.plugin.increment,p=t.plugin.formatKey,g=t.plugin.formatSeed,_=Ci.util.createBuffer();t.key=null,E();function E(w){if(w)return u(w);if(_.length()>=l)return u(null,_.getBytes(l));if(t.generated>1048575&&(t.key=null),t.key===null)return Ci.util.nextTick(function(){s(E);});var y=f(t.key,t.seed);t.generated+=y.length,_.putBytes(y),t.key=p(f(t.key,h(t.seed))),t.seed=g(f(t.key,t.seed)),Ci.util.setImmediate(E);}},t.generateSync=function(l){var u=t.plugin.cipher,f=t.plugin.increment,h=t.plugin.formatKey,p=t.plugin.formatSeed;t.key=null;for(var g=Ci.util.createBuffer();g.length()<l;){t.generated>1048575&&(t.key=null),t.key===null&&a();var _=u(t.key,t.seed);t.generated+=_.length,g.putBytes(_),t.key=h(u(t.key,f(t.seed))),t.seed=p(u(t.key,t.seed));}return g.getBytes(l)};function s(l){if(t.pools[0].messageLength>=32)return o(),l();var u=32-t.pools[0].messageLength<<5;t.seedFile(u,function(f,h){if(f)return l(f);t.collect(h),o(),l();});}function a(){if(t.pools[0].messageLength>=32)return o();var l=32-t.pools[0].messageLength<<5;t.collect(t.seedFileSync(l)),o();}function o(){t.reseeds=t.reseeds===4294967295?0:t.reseeds+1;var l=t.plugin.md.create();l.update(t.keyBytes);for(var u=1,f=0;f<32;++f)t.reseeds%u===0&&(l.update(t.pools[f].digest().getBytes()),t.pools[f].start()),u=u<<1;t.keyBytes=l.digest().getBytes(),l.start(),l.update(t.keyBytes);var h=l.digest().getBytes();t.key=t.plugin.formatKey(t.keyBytes),t.seed=t.plugin.formatSeed(h),t.generated=0;}function c(l){var u=null,f=Ci.util.globalScope,h=f.crypto||f.msCrypto;h&&h.getRandomValues&&(u=function(L){return h.getRandomValues(L)});var p=Ci.util.createBuffer();if(u)for(;p.length()<l;){var g=Math.max(1,Math.min(l-p.length(),65536)/4),_=new Uint32Array(Math.floor(g));try{u(_);for(var E=0;E<_.length;++E)p.putInt32(_[E]);}catch(L){if(!(typeof QuotaExceededError<"u"&&L instanceof QuotaExceededError))throw L}}if(p.length()<l)for(var w,y,b,N=Math.floor(Math.random()*65536);p.length()<l;){y=16807*(N&65535),w=16807*(N>>16),y+=(w&32767)<<16,y+=w>>15,y=(y&2147483647)+(y>>31),N=y&4294967295;for(var E=0;E<3;++E)b=N>>>(E<<3),b^=Math.floor(Math.random()*256),p.putByte(b&255);}return p.getBytes(l)}return Dd?(t.seedFile=function(l,u){Dd.randomBytes(l,function(f,h){if(f)return u(f);u(null,h.toString());});},t.seedFileSync=function(l){return Dd.randomBytes(l).toString()}):(t.seedFile=function(l,u){try{u(null,c(l));}catch(f){u(f);}},t.seedFileSync=c),t.collect=function(l){for(var u=l.length,f=0;f<u;++f)t.pools[t.pool].update(l.substr(f,1)),t.pool=t.pool===31?0:t.pool+1;},t.collectInt=function(l,u){for(var f="",h=0;h<u;h+=8)f+=String.fromCharCode(l>>h&255);t.collect(f);},t.registerWorker=function(l){if(l===self)t.seedFile=function(f,h){function p(g){var _=g.data;_.forge&&_.forge.prng&&(self.removeEventListener("message",p),h(_.forge.prng.err,_.forge.prng.bytes));}self.addEventListener("message",p),self.postMessage({forge:{prng:{needed:f}}});};else {var u=function(f){var h=f.data;h.forge&&h.forge.prng&&t.seedFile(h.forge.prng.needed,function(p,g){l.postMessage({forge:{prng:{err:p,bytes:g}}});});};l.addEventListener("message",u);}},t};});var Fn=I((che,Sv)=>{var Er=rt();bs();_v();bv();_t();(function(){if(Er.random&&Er.random.getBytes){Sv.exports=Er.random;return}(function(e){var t={},r=new Array(4),n=Er.util.createBuffer();t.formatKey=function(f){var h=Er.util.createBuffer(f);return f=new Array(4),f[0]=h.getInt32(),f[1]=h.getInt32(),f[2]=h.getInt32(),f[3]=h.getInt32(),Er.aes._expandKey(f,!1)},t.formatSeed=function(f){var h=Er.util.createBuffer(f);return f=new Array(4),f[0]=h.getInt32(),f[1]=h.getInt32(),f[2]=h.getInt32(),f[3]=h.getInt32(),f},t.cipher=function(f,h){return Er.aes._updateBlock(f,h,r,!1),n.putInt32(r[0]),n.putInt32(r[1]),n.putInt32(r[2]),n.putInt32(r[3]),n.getBytes()},t.increment=function(f){return ++f[3],f},t.md=Er.md.sha256;function i(){var f=Er.prng.create(t);return f.getBytes=function(h,p){return f.generate(h,p)},f.getBytesSync=function(h){return f.generate(h)},f}var s=i(),a=null,o=Er.util.globalScope,c=o.crypto||o.msCrypto;if(c&&c.getRandomValues&&(a=function(f){return c.getRandomValues(f)}),Er.options.usePureJavaScript||!Er.util.isNodejs&&!a){if(s.collectInt(+new Date,32),typeof navigator<"u"){var l="";for(var u in navigator)try{typeof navigator[u]=="string"&&(l+=navigator[u]);}catch{}s.collect(l),l=null;}e&&(e().mousemove(function(f){s.collectInt(f.clientX,16),s.collectInt(f.clientY,16);}),e().keypress(function(f){s.collectInt(f.charCode,8);}));}if(!Er.random)Er.random=s;else for(var u in s)Er.random[u]=s[u];Er.random.createInstance=i,Sv.exports=Er.random;})(typeof jQuery<"u"?jQuery:null);})();});var wv=I((lhe,Sk)=>{var un=rt();_t();var Ev=[217,120,249,196,25,221,181,237,40,233,253,121,74,160,216,157,198,126,55,131,43,118,83,142,98,76,100,136,68,139,251,162,23,154,89,245,135,179,79,19,97,69,109,141,9,129,125,50,189,143,64,235,134,183,123,11,240,149,33,34,92,107,78,130,84,214,101,147,206,96,178,28,115,86,192,20,167,140,241,220,18,117,202,31,59,190,228,209,66,61,212,48,163,60,182,38,111,191,14,218,70,105,7,87,39,242,29,155,188,148,67,3,248,17,199,246,144,239,62,231,6,195,213,47,200,102,30,215,8,232,234,222,128,82,238,247,132,170,114,172,53,77,106,42,150,26,210,113,90,21,73,116,75,159,208,94,4,24,164,236,194,224,65,110,15,81,203,204,36,145,175,80,161,244,112,57,153,124,58,133,35,184,180,122,252,2,54,91,37,85,151,49,45,93,250,152,227,138,146,174,5,223,41,16,103,108,186,201,211,0,230,207,225,158,168,44,99,22,1,63,88,226,137,169,13,56,52,27,171,51,255,176,187,72,12,95,185,177,205,46,197,243,219,71,229,165,156,119,10,166,32,104,254,127,193,173],_k=[1,2,3,5],zJ=function(e,t){return e<<t&65535|(e&65535)>>16-t},YJ=function(e,t){return (e&65535)>>t|e<<16-t&65535};Sk.exports=un.rc2=un.rc2||{};un.rc2.expandKey=function(e,t){typeof e=="string"&&(e=un.util.createBuffer(e)),t=t||128;var r=e,n=e.length(),i=t,s=Math.ceil(i/8),a=255>>(i&7),o;for(o=n;o<128;o++)r.putByte(Ev[r.at(o-1)+r.at(o-n)&255]);for(r.setAt(128-s,Ev[r.at(128-s)&a]),o=127-s;o>=0;o--)r.setAt(o,Ev[r.at(o+1)^r.at(o+s)]);return r};var bk=function(e,t,r){var n=!1,i=null,s=null,a=null,o,c,l,u,f=[];for(e=un.rc2.expandKey(e,t),l=0;l<64;l++)f.push(e.getInt16Le());r?(o=function(g){for(l=0;l<4;l++)g[l]+=f[u]+(g[(l+3)%4]&g[(l+2)%4])+(~g[(l+3)%4]&g[(l+1)%4]),g[l]=zJ(g[l],_k[l]),u++;},c=function(g){for(l=0;l<4;l++)g[l]+=f[g[(l+3)%4]&63];}):(o=function(g){for(l=3;l>=0;l--)g[l]=YJ(g[l],_k[l]),g[l]-=f[u]+(g[(l+3)%4]&g[(l+2)%4])+(~g[(l+3)%4]&g[(l+1)%4]),u--;},c=function(g){for(l=3;l>=0;l--)g[l]-=f[g[(l+3)%4]&63];});var h=function(g){var _=[];for(l=0;l<4;l++){var E=i.getInt16Le();a!==null&&(r?E^=a.getInt16Le():a.putInt16Le(E)),_.push(E&65535);}u=r?0:63;for(var w=0;w<g.length;w++)for(var y=0;y<g[w][0];y++)g[w][1](_);for(l=0;l<4;l++)a!==null&&(r?a.putInt16Le(_[l]):_[l]^=a.getInt16Le()),s.putInt16Le(_[l]);},p=null;return p={start:function(g,_){g&&typeof g=="string"&&(g=un.util.createBuffer(g)),n=!1,i=un.util.createBuffer(),s=_||new un.util.createBuffer,a=g,p.output=s;},update:function(g){for(n||i.putBuffer(g);i.length()>=8;)h([[5,o],[1,c],[6,o],[1,c],[5,o]]);},finish:function(g){var _=!0;if(r)if(g)_=g(8,i,!r);else {var E=i.length()===8?8:8-i.length();i.fillWithByte(E,E);}if(_&&(n=!0,p.update()),!r&&(_=i.length()===0,_))if(g)_=g(8,s,!r);else {var w=s.length(),y=s.at(w-1);y>w?_=!1:s.truncate(y);}return _}},p};un.rc2.startEncrypting=function(e,t,r){var n=un.rc2.createEncryptionCipher(e,128);return n.start(t,r),n};un.rc2.createEncryptionCipher=function(e,t){return bk(e,t,!0)};un.rc2.startDecrypting=function(e,t,r){var n=un.rc2.createDecryptionCipher(e,128);return n.start(t,r),n};un.rc2.createDecryptionCipher=function(e,t){return bk(e,t,!1)};});var Ec=I((fhe,Ik)=>{var Cv=rt();Ik.exports=Cv.jsbn=Cv.jsbn||{};var Yi;function fe(e,t,r){this.data=[],e!=null&&(typeof e=="number"?this.fromNumber(e,t,r):t==null&&typeof e!="string"?this.fromString(e,256):this.fromString(e,t));}Cv.jsbn.BigInteger=fe;function bt(){return new fe(null)}function XJ(e,t,r,n,i,s){for(;--s>=0;){var a=t*this.data[e++]+r.data[n]+i;i=Math.floor(a/67108864),r.data[n++]=a&67108863;}return i}function ZJ(e,t,r,n,i,s){for(var a=t&32767,o=t>>15;--s>=0;){var c=this.data[e]&32767,l=this.data[e++]>>15,u=o*c+l*a;c=a*c+((u&32767)<<15)+r.data[n]+(i&1073741823),i=(c>>>30)+(u>>>15)+o*l+(i>>>30),r.data[n++]=c&1073741823;}return i}function wk(e,t,r,n,i,s){for(var a=t&16383,o=t>>14;--s>=0;){var c=this.data[e]&16383,l=this.data[e++]>>14,u=o*c+l*a;c=a*c+((u&16383)<<14)+r.data[n]+i,i=(c>>28)+(u>>14)+o*l,r.data[n++]=c&268435455;}return i}typeof navigator>"u"?(fe.prototype.am=wk,Yi=28):navigator.appName=="Microsoft Internet Explorer"?(fe.prototype.am=ZJ,Yi=30):navigator.appName!="Netscape"?(fe.prototype.am=XJ,Yi=26):(fe.prototype.am=wk,Yi=28);fe.prototype.DB=Yi;fe.prototype.DM=(1<<Yi)-1;fe.prototype.DV=1<<Yi;var xv=52;fe.prototype.FV=Math.pow(2,xv);fe.prototype.F1=xv-Yi;fe.prototype.F2=2*Yi-xv;var JJ="0123456789abcdefghijklmnopqrstuvwxyz",Od=new Array,To,qn;To=48;for(qn=0;qn<=9;++qn)Od[To++]=qn;To=97;for(qn=10;qn<36;++qn)Od[To++]=qn;To=65;for(qn=10;qn<36;++qn)Od[To++]=qn;function Ck(e){return JJ.charAt(e)}function xk(e,t){var r=Od[e.charCodeAt(t)];return r??-1}function eee(e){for(var t=this.t-1;t>=0;--t)e.data[t]=this.data[t];e.t=this.t,e.s=this.s;}function tee(e){this.t=1,this.s=e<0?-1:0,e>0?this.data[0]=e:e<-1?this.data[0]=e+this.DV:this.t=0;}function Es(e){var t=bt();return t.fromInt(e),t}function ree(e,t){var r;if(t==16)r=4;else if(t==8)r=3;else if(t==256)r=8;else if(t==2)r=1;else if(t==32)r=5;else if(t==4)r=2;else {this.fromRadix(e,t);return}this.t=0,this.s=0;for(var n=e.length,i=!1,s=0;--n>=0;){var a=r==8?e[n]&255:xk(e,n);if(a<0){e.charAt(n)=="-"&&(i=!0);continue}i=!1,s==0?this.data[this.t++]=a:s+r>this.DB?(this.data[this.t-1]|=(a&(1<<this.DB-s)-1)<<s,this.data[this.t++]=a>>this.DB-s):this.data[this.t-1]|=a<<s,s+=r,s>=this.DB&&(s-=this.DB);}r==8&&e[0]&128&&(this.s=-1,s>0&&(this.data[this.t-1]|=(1<<this.DB-s)-1<<s)),this.clamp(),i&&fe.ZERO.subTo(this,this);}function nee(){for(var e=this.s&this.DM;this.t>0&&this.data[this.t-1]==e;)--this.t;}function iee(e){if(this.s<0)return "-"+this.negate().toString(e);var t;if(e==16)t=4;else if(e==8)t=3;else if(e==2)t=1;else if(e==32)t=5;else if(e==4)t=2;else return this.toRadix(e);var r=(1<<t)-1,n,i=!1,s="",a=this.t,o=this.DB-a*this.DB%t;if(a-- >0)for(o<this.DB&&(n=this.data[a]>>o)>0&&(i=!0,s=Ck(n));a>=0;)o<t?(n=(this.data[a]&(1<<o)-1)<<t-o,n|=this.data[--a]>>(o+=this.DB-t)):(n=this.data[a]>>(o-=t)&r,o<=0&&(o+=this.DB,--a)),n>0&&(i=!0),i&&(s+=Ck(n));return i?s:"0"}function see(){var e=bt();return fe.ZERO.subTo(this,e),e}function aee(){return this.s<0?this.negate():this}function oee(e){var t=this.s-e.s;if(t!=0)return t;var r=this.t;if(t=r-e.t,t!=0)return this.s<0?-t:t;for(;--r>=0;)if((t=this.data[r]-e.data[r])!=0)return t;return 0}function kd(e){var t=1,r;return (r=e>>>16)!=0&&(e=r,t+=16),(r=e>>8)!=0&&(e=r,t+=8),(r=e>>4)!=0&&(e=r,t+=4),(r=e>>2)!=0&&(e=r,t+=2),(r=e>>1)!=0&&(e=r,t+=1),t}function uee(){return this.t<=0?0:this.DB*(this.t-1)+kd(this.data[this.t-1]^this.s&this.DM)}function cee(e,t){var r;for(r=this.t-1;r>=0;--r)t.data[r+e]=this.data[r];for(r=e-1;r>=0;--r)t.data[r]=0;t.t=this.t+e,t.s=this.s;}function lee(e,t){for(var r=e;r<this.t;++r)t.data[r-e]=this.data[r];t.t=Math.max(this.t-e,0),t.s=this.s;}function fee(e,t){var r=e%this.DB,n=this.DB-r,i=(1<<n)-1,s=Math.floor(e/this.DB),a=this.s<<r&this.DM,o;for(o=this.t-1;o>=0;--o)t.data[o+s+1]=this.data[o]>>n|a,a=(this.data[o]&i)<<r;for(o=s-1;o>=0;--o)t.data[o]=0;t.data[s]=a,t.t=this.t+s+1,t.s=this.s,t.clamp();}function dee(e,t){t.s=this.s;var r=Math.floor(e/this.DB);if(r>=this.t){t.t=0;return}var n=e%this.DB,i=this.DB-n,s=(1<<n)-1;t.data[0]=this.data[r]>>n;for(var a=r+1;a<this.t;++a)t.data[a-r-1]|=(this.data[a]&s)<<i,t.data[a-r]=this.data[a]>>n;n>0&&(t.data[this.t-r-1]|=(this.s&s)<<i),t.t=this.t-r,t.clamp();}function hee(e,t){for(var r=0,n=0,i=Math.min(e.t,this.t);r<i;)n+=this.data[r]-e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;if(e.t<this.t){for(n-=e.s;r<this.t;)n+=this.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n+=this.s;}else {for(n+=this.s;r<e.t;)n-=e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n-=e.s;}t.s=n<0?-1:0,n<-1?t.data[r++]=this.DV+n:n>0&&(t.data[r++]=n),t.t=r,t.clamp();}function pee(e,t){var r=this.abs(),n=e.abs(),i=r.t;for(t.t=i+n.t;--i>=0;)t.data[i]=0;for(i=0;i<n.t;++i)t.data[i+r.t]=r.am(0,n.data[i],t,i,0,r.t);t.s=0,t.clamp(),this.s!=e.s&&fe.ZERO.subTo(t,t);}function gee(e){for(var t=this.abs(),r=e.t=2*t.t;--r>=0;)e.data[r]=0;for(r=0;r<t.t-1;++r){var n=t.am(r,t.data[r],e,2*r,0,1);(e.data[r+t.t]+=t.am(r+1,2*t.data[r],e,2*r+1,n,t.t-r-1))>=t.DV&&(e.data[r+t.t]-=t.DV,e.data[r+t.t+1]=1);}e.t>0&&(e.data[e.t-1]+=t.am(r,t.data[r],e,2*r,0,1)),e.s=0,e.clamp();}function mee(e,t,r){var n=e.abs();if(!(n.t<=0)){var i=this.abs();if(i.t<n.t){t?.fromInt(0),r!=null&&this.copyTo(r);return}r==null&&(r=bt());var s=bt(),a=this.s,o=e.s,c=this.DB-kd(n.data[n.t-1]);c>0?(n.lShiftTo(c,s),i.lShiftTo(c,r)):(n.copyTo(s),i.copyTo(r));var l=s.t,u=s.data[l-1];if(u!=0){var f=u*(1<<this.F1)+(l>1?s.data[l-2]>>this.F2:0),h=this.FV/f,p=(1<<this.F1)/f,g=1<<this.F2,_=r.t,E=_-l,w=t??bt();for(s.dlShiftTo(E,w),r.compareTo(w)>=0&&(r.data[r.t++]=1,r.subTo(w,r)),fe.ONE.dlShiftTo(l,w),w.subTo(s,s);s.t<l;)s.data[s.t++]=0;for(;--E>=0;){var y=r.data[--_]==u?this.DM:Math.floor(r.data[_]*h+(r.data[_-1]+g)*p);if((r.data[_]+=s.am(0,y,r,E,0,l))<y)for(s.dlShiftTo(E,w),r.subTo(w,r);r.data[_]<--y;)r.subTo(w,r);}t!=null&&(r.drShiftTo(l,t),a!=o&&fe.ZERO.subTo(t,t)),r.t=l,r.clamp(),c>0&&r.rShiftTo(c,r),a<0&&fe.ZERO.subTo(r,r);}}}function yee(e){var t=bt();return this.abs().divRemTo(e,null,t),this.s<0&&t.compareTo(fe.ZERO)>0&&e.subTo(t,t),t}function ya(e){this.m=e;}function vee(e){return e.s<0||e.compareTo(this.m)>=0?e.mod(this.m):e}function _ee(e){return e}function bee(e){e.divRemTo(this.m,null,e);}function See(e,t,r){e.multiplyTo(t,r),this.reduce(r);}function Eee(e,t){e.squareTo(t),this.reduce(t);}ya.prototype.convert=vee;ya.prototype.revert=_ee;ya.prototype.reduce=bee;ya.prototype.mulTo=See;ya.prototype.sqrTo=Eee;function wee(){if(this.t<1)return 0;var e=this.data[0];if(!(e&1))return 0;var t=e&3;return t=t*(2-(e&15)*t)&15,t=t*(2-(e&255)*t)&255,t=t*(2-((e&65535)*t&65535))&65535,t=t*(2-e*t%this.DV)%this.DV,t>0?this.DV-t:-t}function va(e){this.m=e,this.mp=e.invDigit(),this.mpl=this.mp&32767,this.mph=this.mp>>15,this.um=(1<<e.DB-15)-1,this.mt2=2*e.t;}function Cee(e){var t=bt();return e.abs().dlShiftTo(this.m.t,t),t.divRemTo(this.m,null,t),e.s<0&&t.compareTo(fe.ZERO)>0&&this.m.subTo(t,t),t}function xee(e){var t=bt();return e.copyTo(t),this.reduce(t),t}function Tee(e){for(;e.t<=this.mt2;)e.data[e.t++]=0;for(var t=0;t<this.m.t;++t){var r=e.data[t]&32767,n=r*this.mpl+((r*this.mph+(e.data[t]>>15)*this.mpl&this.um)<<15)&e.DM;for(r=t+this.m.t,e.data[r]+=this.m.am(0,n,e,t,0,this.m.t);e.data[r]>=e.DV;)e.data[r]-=e.DV,e.data[++r]++;}e.clamp(),e.drShiftTo(this.m.t,e),e.compareTo(this.m)>=0&&e.subTo(this.m,e);}function Aee(e,t){e.squareTo(t),this.reduce(t);}function Ree(e,t,r){e.multiplyTo(t,r),this.reduce(r);}va.prototype.convert=Cee;va.prototype.revert=xee;va.prototype.reduce=Tee;va.prototype.mulTo=Ree;va.prototype.sqrTo=Aee;function Iee(){return (this.t>0?this.data[0]&1:this.s)==0}function Pee(e,t){if(e>4294967295||e<1)return fe.ONE;var r=bt(),n=bt(),i=t.convert(this),s=kd(e)-1;for(i.copyTo(r);--s>=0;)if(t.sqrTo(r,n),(e&1<<s)>0)t.mulTo(n,i,r);else {var a=r;r=n,n=a;}return t.revert(r)}function Nee(e,t){var r;return e<256||t.isEven()?r=new ya(t):r=new va(t),this.exp(e,r)}fe.prototype.copyTo=eee;fe.prototype.fromInt=tee;fe.prototype.fromString=ree;fe.prototype.clamp=nee;fe.prototype.dlShiftTo=cee;fe.prototype.drShiftTo=lee;fe.prototype.lShiftTo=fee;fe.prototype.rShiftTo=dee;fe.prototype.subTo=hee;fe.prototype.multiplyTo=pee;fe.prototype.squareTo=gee;fe.prototype.divRemTo=mee;fe.prototype.invDigit=wee;fe.prototype.isEven=Iee;fe.prototype.exp=Pee;fe.prototype.toString=iee;fe.prototype.negate=see;fe.prototype.abs=aee;fe.prototype.compareTo=oee;fe.prototype.bitLength=uee;fe.prototype.mod=yee;fe.prototype.modPowInt=Nee;fe.ZERO=Es(0);fe.ONE=Es(1);function Dee(){var e=bt();return this.copyTo(e),e}function Oee(){if(this.s<0){if(this.t==1)return this.data[0]-this.DV;if(this.t==0)return -1}else {if(this.t==1)return this.data[0];if(this.t==0)return 0}return (this.data[1]&(1<<32-this.DB)-1)<<this.DB|this.data[0]}function kee(){return this.t==0?this.s:this.data[0]<<24>>24}function Lee(){return this.t==0?this.s:this.data[0]<<16>>16}function Bee(e){return Math.floor(Math.LN2*this.DB/Math.log(e))}function Fee(){return this.s<0?-1:this.t<=0||this.t==1&&this.data[0]<=0?0:1}function qee(e){if(e==null&&(e=10),this.signum()==0||e<2||e>36)return "0";var t=this.chunkSize(e),r=Math.pow(e,t),n=Es(r),i=bt(),s=bt(),a="";for(this.divRemTo(n,i,s);i.signum()>0;)a=(r+s.intValue()).toString(e).substr(1)+a,i.divRemTo(n,i,s);return s.intValue().toString(e)+a}function Mee(e,t){this.fromInt(0),t==null&&(t=10);for(var r=this.chunkSize(t),n=Math.pow(t,r),i=!1,s=0,a=0,o=0;o<e.length;++o){var c=xk(e,o);if(c<0){e.charAt(o)=="-"&&this.signum()==0&&(i=!0);continue}a=t*a+c,++s>=r&&(this.dMultiply(n),this.dAddOffset(a,0),s=0,a=0);}s>0&&(this.dMultiply(Math.pow(t,s)),this.dAddOffset(a,0)),i&&fe.ZERO.subTo(this,this);}function Uee(e,t,r){if(typeof t=="number")if(e<2)this.fromInt(1);else for(this.fromNumber(e,r),this.testBit(e-1)||this.bitwiseTo(fe.ONE.shiftLeft(e-1),Tv,this),this.isEven()&&this.dAddOffset(1,0);!this.isProbablePrime(t);)this.dAddOffset(2,0),this.bitLength()>e&&this.subTo(fe.ONE.shiftLeft(e-1),this);else {var n=new Array,i=e&7;n.length=(e>>3)+1,t.nextBytes(n),i>0?n[0]&=(1<<i)-1:n[0]=0,this.fromString(n,256);}}function $ee(){var e=this.t,t=new Array;t[0]=this.s;var r=this.DB-e*this.DB%8,n,i=0;if(e-- >0)for(r<this.DB&&(n=this.data[e]>>r)!=(this.s&this.DM)>>r&&(t[i++]=n|this.s<<this.DB-r);e>=0;)r<8?(n=(this.data[e]&(1<<r)-1)<<8-r,n|=this.data[--e]>>(r+=this.DB-8)):(n=this.data[e]>>(r-=8)&255,r<=0&&(r+=this.DB,--e)),n&128&&(n|=-256),i==0&&(this.s&128)!=(n&128)&&++i,(i>0||n!=this.s)&&(t[i++]=n);return t}function jee(e){return this.compareTo(e)==0}function Vee(e){return this.compareTo(e)<0?this:e}function Hee(e){return this.compareTo(e)>0?this:e}function Wee(e,t,r){var n,i,s=Math.min(e.t,this.t);for(n=0;n<s;++n)r.data[n]=t(this.data[n],e.data[n]);if(e.t<this.t){for(i=e.s&this.DM,n=s;n<this.t;++n)r.data[n]=t(this.data[n],i);r.t=this.t;}else {for(i=this.s&this.DM,n=s;n<e.t;++n)r.data[n]=t(i,e.data[n]);r.t=e.t;}r.s=t(this.s,e.s),r.clamp();}function Kee(e,t){return e&t}function Gee(e){var t=bt();return this.bitwiseTo(e,Kee,t),t}function Tv(e,t){return e|t}function zee(e){var t=bt();return this.bitwiseTo(e,Tv,t),t}function Tk(e,t){return e^t}function Yee(e){var t=bt();return this.bitwiseTo(e,Tk,t),t}function Ak(e,t){return e&~t}function Qee(e){var t=bt();return this.bitwiseTo(e,Ak,t),t}function Xee(){for(var e=bt(),t=0;t<this.t;++t)e.data[t]=this.DM&~this.data[t];return e.t=this.t,e.s=~this.s,e}function Zee(e){var t=bt();return e<0?this.rShiftTo(-e,t):this.lShiftTo(e,t),t}function Jee(e){var t=bt();return e<0?this.lShiftTo(-e,t):this.rShiftTo(e,t),t}function ete(e){if(e==0)return -1;var t=0;return e&65535||(e>>=16,t+=16),e&255||(e>>=8,t+=8),e&15||(e>>=4,t+=4),e&3||(e>>=2,t+=2),e&1||++t,t}function tte(){for(var e=0;e<this.t;++e)if(this.data[e]!=0)return e*this.DB+ete(this.data[e]);return this.s<0?this.t*this.DB:-1}function rte(e){for(var t=0;e!=0;)e&=e-1,++t;return t}function nte(){for(var e=0,t=this.s&this.DM,r=0;r<this.t;++r)e+=rte(this.data[r]^t);return e}function ite(e){var t=Math.floor(e/this.DB);return t>=this.t?this.s!=0:(this.data[t]&1<<e%this.DB)!=0}function ste(e,t){var r=fe.ONE.shiftLeft(e);return this.bitwiseTo(r,t,r),r}function ate(e){return this.changeBit(e,Tv)}function ote(e){return this.changeBit(e,Ak)}function ute(e){return this.changeBit(e,Tk)}function cte(e,t){for(var r=0,n=0,i=Math.min(e.t,this.t);r<i;)n+=this.data[r]+e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;if(e.t<this.t){for(n+=e.s;r<this.t;)n+=this.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n+=this.s;}else {for(n+=this.s;r<e.t;)n+=e.data[r],t.data[r++]=n&this.DM,n>>=this.DB;n+=e.s;}t.s=n<0?-1:0,n>0?t.data[r++]=n:n<-1&&(t.data[r++]=this.DV+n),t.t=r,t.clamp();}function lte(e){var t=bt();return this.addTo(e,t),t}function fte(e){var t=bt();return this.subTo(e,t),t}function dte(e){var t=bt();return this.multiplyTo(e,t),t}function hte(e){var t=bt();return this.divRemTo(e,t,null),t}function pte(e){var t=bt();return this.divRemTo(e,null,t),t}function gte(e){var t=bt(),r=bt();return this.divRemTo(e,t,r),new Array(t,r)}function mte(e){this.data[this.t]=this.am(0,e-1,this,0,0,this.t),++this.t,this.clamp();}function yte(e,t){if(e!=0){for(;this.t<=t;)this.data[this.t++]=0;for(this.data[t]+=e;this.data[t]>=this.DV;)this.data[t]-=this.DV,++t>=this.t&&(this.data[this.t++]=0),++this.data[t];}}function Sc(){}function Rk(e){return e}function vte(e,t,r){e.multiplyTo(t,r);}function _te(e,t){e.squareTo(t);}Sc.prototype.convert=Rk;Sc.prototype.revert=Rk;Sc.prototype.mulTo=vte;Sc.prototype.sqrTo=_te;function bte(e){return this.exp(e,new Sc)}function Ste(e,t,r){var n=Math.min(this.t+e.t,t);for(r.s=0,r.t=n;n>0;)r.data[--n]=0;var i;for(i=r.t-this.t;n<i;++n)r.data[n+this.t]=this.am(0,e.data[n],r,n,0,this.t);for(i=Math.min(e.t,t);n<i;++n)this.am(0,e.data[n],r,n,0,t-n);r.clamp();}function Ete(e,t,r){--t;var n=r.t=this.t+e.t-t;for(r.s=0;--n>=0;)r.data[n]=0;for(n=Math.max(t-this.t,0);n<e.t;++n)r.data[this.t+n-t]=this.am(t-n,e.data[n],r,0,0,this.t+n-t);r.clamp(),r.drShiftTo(1,r);}function Ao(e){this.r2=bt(),this.q3=bt(),fe.ONE.dlShiftTo(2*e.t,this.r2),this.mu=this.r2.divide(e),this.m=e;}function wte(e){if(e.s<0||e.t>2*this.m.t)return e.mod(this.m);if(e.compareTo(this.m)<0)return e;var t=bt();return e.copyTo(t),this.reduce(t),t}function Cte(e){return e}function xte(e){for(e.drShiftTo(this.m.t-1,this.r2),e.t>this.m.t+1&&(e.t=this.m.t+1,e.clamp()),this.mu.multiplyUpperTo(this.r2,this.m.t+1,this.q3),this.m.multiplyLowerTo(this.q3,this.m.t+1,this.r2);e.compareTo(this.r2)<0;)e.dAddOffset(1,this.m.t+1);for(e.subTo(this.r2,e);e.compareTo(this.m)>=0;)e.subTo(this.m,e);}function Tte(e,t){e.squareTo(t),this.reduce(t);}function Ate(e,t,r){e.multiplyTo(t,r),this.reduce(r);}Ao.prototype.convert=wte;Ao.prototype.revert=Cte;Ao.prototype.reduce=xte;Ao.prototype.mulTo=Ate;Ao.prototype.sqrTo=Tte;function Rte(e,t){var r=e.bitLength(),n,i=Es(1),s;if(r<=0)return i;r<18?n=1:r<48?n=3:r<144?n=4:r<768?n=5:n=6,r<8?s=new ya(t):t.isEven()?s=new Ao(t):s=new va(t);var a=new Array,o=3,c=n-1,l=(1<<n)-1;if(a[1]=s.convert(this),n>1){var u=bt();for(s.sqrTo(a[1],u);o<=l;)a[o]=bt(),s.mulTo(u,a[o-2],a[o]),o+=2;}var f=e.t-1,h,p=!0,g=bt(),_;for(r=kd(e.data[f])-1;f>=0;){for(r>=c?h=e.data[f]>>r-c&l:(h=(e.data[f]&(1<<r+1)-1)<<c-r,f>0&&(h|=e.data[f-1]>>this.DB+r-c)),o=n;!(h&1);)h>>=1,--o;if((r-=o)<0&&(r+=this.DB,--f),p)a[h].copyTo(i),p=!1;else {for(;o>1;)s.sqrTo(i,g),s.sqrTo(g,i),o-=2;o>0?s.sqrTo(i,g):(_=i,i=g,g=_),s.mulTo(g,a[h],i);}for(;f>=0&&!(e.data[f]&1<<r);)s.sqrTo(i,g),_=i,i=g,g=_,--r<0&&(r=this.DB-1,--f);}return s.revert(i)}function Ite(e){var t=this.s<0?this.negate():this.clone(),r=e.s<0?e.negate():e.clone();if(t.compareTo(r)<0){var n=t;t=r,r=n;}var i=t.getLowestSetBit(),s=r.getLowestSetBit();if(s<0)return t;for(i<s&&(s=i),s>0&&(t.rShiftTo(s,t),r.rShiftTo(s,r));t.signum()>0;)(i=t.getLowestSetBit())>0&&t.rShiftTo(i,t),(i=r.getLowestSetBit())>0&&r.rShiftTo(i,r),t.compareTo(r)>=0?(t.subTo(r,t),t.rShiftTo(1,t)):(r.subTo(t,r),r.rShiftTo(1,r));return s>0&&r.lShiftTo(s,r),r}function Pte(e){if(e<=0)return 0;var t=this.DV%e,r=this.s<0?e-1:0;if(this.t>0)if(t==0)r=this.data[0]%e;else for(var n=this.t-1;n>=0;--n)r=(t*r+this.data[n])%e;return r}function Nte(e){var t=e.isEven();if(this.isEven()&&t||e.signum()==0)return fe.ZERO;for(var r=e.clone(),n=this.clone(),i=Es(1),s=Es(0),a=Es(0),o=Es(1);r.signum()!=0;){for(;r.isEven();)r.rShiftTo(1,r),t?((!i.isEven()||!s.isEven())&&(i.addTo(this,i),s.subTo(e,s)),i.rShiftTo(1,i)):s.isEven()||s.subTo(e,s),s.rShiftTo(1,s);for(;n.isEven();)n.rShiftTo(1,n),t?((!a.isEven()||!o.isEven())&&(a.addTo(this,a),o.subTo(e,o)),a.rShiftTo(1,a)):o.isEven()||o.subTo(e,o),o.rShiftTo(1,o);r.compareTo(n)>=0?(r.subTo(n,r),t&&i.subTo(a,i),s.subTo(o,s)):(n.subTo(r,n),t&&a.subTo(i,a),o.subTo(s,o));}if(n.compareTo(fe.ONE)!=0)return fe.ZERO;if(o.compareTo(e)>=0)return o.subtract(e);if(o.signum()<0)o.addTo(e,o);else return o;return o.signum()<0?o.add(e):o}var oi=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509],Dte=(1<<26)/oi[oi.length-1];function Ote(e){var t,r=this.abs();if(r.t==1&&r.data[0]<=oi[oi.length-1]){for(t=0;t<oi.length;++t)if(r.data[0]==oi[t])return !0;return !1}if(r.isEven())return !1;for(t=1;t<oi.length;){for(var n=oi[t],i=t+1;i<oi.length&&n<Dte;)n*=oi[i++];for(n=r.modInt(n);t<i;)if(n%oi[t++]==0)return !1}return r.millerRabin(e)}function kte(e){var t=this.subtract(fe.ONE),r=t.getLowestSetBit();if(r<=0)return !1;for(var n=t.shiftRight(r),i=Lte(),s,a=0;a<e;++a){do s=new fe(this.bitLength(),i);while(s.compareTo(fe.ONE)<=0||s.compareTo(t)>=0);var o=s.modPow(n,this);if(o.compareTo(fe.ONE)!=0&&o.compareTo(t)!=0){for(var c=1;c++<r&&o.compareTo(t)!=0;)if(o=o.modPowInt(2,this),o.compareTo(fe.ONE)==0)return !1;if(o.compareTo(t)!=0)return !1}}return !0}function Lte(){return {nextBytes:function(e){for(var t=0;t<e.length;++t)e[t]=Math.floor(Math.random()*256);}}}fe.prototype.chunkSize=Bee;fe.prototype.toRadix=qee;fe.prototype.fromRadix=Mee;fe.prototype.fromNumber=Uee;fe.prototype.bitwiseTo=Wee;fe.prototype.changeBit=ste;fe.prototype.addTo=cte;fe.prototype.dMultiply=mte;fe.prototype.dAddOffset=yte;fe.prototype.multiplyLowerTo=Ste;fe.prototype.multiplyUpperTo=Ete;fe.prototype.modInt=Pte;fe.prototype.millerRabin=kte;fe.prototype.clone=Dee;fe.prototype.intValue=Oee;fe.prototype.byteValue=kee;fe.prototype.shortValue=Lee;fe.prototype.signum=Fee;fe.prototype.toByteArray=$ee;fe.prototype.equals=jee;fe.prototype.min=Vee;fe.prototype.max=Hee;fe.prototype.and=Gee;fe.prototype.or=zee;fe.prototype.xor=Yee;fe.prototype.andNot=Qee;fe.prototype.not=Xee;fe.prototype.shiftLeft=Zee;fe.prototype.shiftRight=Jee;fe.prototype.getLowestSetBit=tte;fe.prototype.bitCount=nte;fe.prototype.testBit=ite;fe.prototype.setBit=ate;fe.prototype.clearBit=ote;fe.prototype.flipBit=ute;fe.prototype.add=lte;fe.prototype.subtract=fte;fe.prototype.multiply=dte;fe.prototype.divide=hte;fe.prototype.remainder=pte;fe.prototype.divideAndRemainder=gte;fe.prototype.modPow=Rte;fe.prototype.modInverse=Nte;fe.prototype.pow=bte;fe.prototype.gcd=Ite;fe.prototype.isProbablePrime=Ote;});var Ro=I((dhe,Ok)=>{var xi=rt();bi();_t();var Nk=Ok.exports=xi.sha1=xi.sha1||{};xi.md.sha1=xi.md.algorithms.sha1=Nk;Nk.create=function(){Dk||Bte();var e=null,t=xi.util.createBuffer(),r=new Array(80),n={algorithm:"sha1",blockLength:64,digestLength:20,messageLength:0,fullMessageLength:null,messageLengthSize:8};return n.start=function(){n.messageLength=0,n.fullMessageLength=n.messageLength64=[];for(var i=n.messageLengthSize/4,s=0;s<i;++s)n.fullMessageLength.push(0);return t=xi.util.createBuffer(),e={h0:1732584193,h1:4023233417,h2:2562383102,h3:271733878,h4:3285377520},n},n.start(),n.update=function(i,s){s==="utf8"&&(i=xi.util.encodeUtf8(i));var a=i.length;n.messageLength+=a,a=[a/4294967296>>>0,a>>>0];for(var o=n.fullMessageLength.length-1;o>=0;--o)n.fullMessageLength[o]+=a[1],a[1]=a[0]+(n.fullMessageLength[o]/4294967296>>>0),n.fullMessageLength[o]=n.fullMessageLength[o]>>>0,a[0]=a[1]/4294967296>>>0;return t.putBytes(i),Pk(e,r,t),(t.read>2048||t.length()===0)&&t.compact(),n},n.digest=function(){var i=xi.util.createBuffer();i.putBytes(t.bytes());var s=n.fullMessageLength[n.fullMessageLength.length-1]+n.messageLengthSize,a=s&n.blockLength-1;i.putBytes(Av.substr(0,n.blockLength-a));for(var o,c,l=n.fullMessageLength[0]*8,u=0;u<n.fullMessageLength.length-1;++u)o=n.fullMessageLength[u+1]*8,c=o/4294967296>>>0,l+=c,i.putInt32(l>>>0),l=o>>>0;i.putInt32(l);var f={h0:e.h0,h1:e.h1,h2:e.h2,h3:e.h3,h4:e.h4};Pk(f,r,i);var h=xi.util.createBuffer();return h.putInt32(f.h0),h.putInt32(f.h1),h.putInt32(f.h2),h.putInt32(f.h3),h.putInt32(f.h4),h},n};var Av=null,Dk=!1;function Bte(){Av="\x80",Av+=xi.util.fillString("\0",64),Dk=!0;}function Pk(e,t,r){for(var n,i,s,a,o,c,l,u,f=r.length();f>=64;){for(i=e.h0,s=e.h1,a=e.h2,o=e.h3,c=e.h4,u=0;u<16;++u)n=r.getInt32(),t[u]=n,l=o^s&(a^o),n=(i<<5|i>>>27)+l+c+1518500249+n,c=o,o=a,a=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<20;++u)n=t[u-3]^t[u-8]^t[u-14]^t[u-16],n=n<<1|n>>>31,t[u]=n,l=o^s&(a^o),n=(i<<5|i>>>27)+l+c+1518500249+n,c=o,o=a,a=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<32;++u)n=t[u-3]^t[u-8]^t[u-14]^t[u-16],n=n<<1|n>>>31,t[u]=n,l=s^a^o,n=(i<<5|i>>>27)+l+c+1859775393+n,c=o,o=a,a=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<40;++u)n=t[u-6]^t[u-16]^t[u-28]^t[u-32],n=n<<2|n>>>30,t[u]=n,l=s^a^o,n=(i<<5|i>>>27)+l+c+1859775393+n,c=o,o=a,a=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<60;++u)n=t[u-6]^t[u-16]^t[u-28]^t[u-32],n=n<<2|n>>>30,t[u]=n,l=s&a|o&(s^a),n=(i<<5|i>>>27)+l+c+2400959708+n,c=o,o=a,a=(s<<30|s>>>2)>>>0,s=i,i=n;for(;u<80;++u)n=t[u-6]^t[u-16]^t[u-28]^t[u-32],n=n<<2|n>>>30,t[u]=n,l=s^a^o,n=(i<<5|i>>>27)+l+c+3395469782+n,c=o,o=a,a=(s<<30|s>>>2)>>>0,s=i,i=n;e.h0=e.h0+i|0,e.h1=e.h1+s|0,e.h2=e.h2+a|0,e.h3=e.h3+o|0,e.h4=e.h4+c|0,f-=64;}}});var Rv=I((hhe,Lk)=>{var Ti=rt();_t();Fn();Ro();var kk=Lk.exports=Ti.pkcs1=Ti.pkcs1||{};kk.encode_rsa_oaep=function(e,t,r){var n,i,s,a;typeof r=="string"?(n=r,i=arguments[3]||void 0,s=arguments[4]||void 0):r&&(n=r.label||void 0,i=r.seed||void 0,s=r.md||void 0,r.mgf1&&r.mgf1.md&&(a=r.mgf1.md)),s?s.start():s=Ti.md.sha1.create(),a||(a=s);var o=Math.ceil(e.n.bitLength()/8),c=o-2*s.digestLength-2;if(t.length>c){var l=new Error("RSAES-OAEP input message length is too long.");throw l.length=t.length,l.maxLength=c,l}n||(n=""),s.update(n,"raw");for(var u=s.digest(),f="",h=c-t.length,p=0;p<h;p++)f+="\0";var g=u.getBytes()+f+""+t;if(!i)i=Ti.random.getBytes(s.digestLength);else if(i.length!==s.digestLength){var l=new Error("Invalid RSAES-OAEP seed. The seed length must match the digest length.");throw l.seedLength=i.length,l.digestLength=s.digestLength,l}var _=Ld(i,o-s.digestLength-1,a),E=Ti.util.xorBytes(g,_,g.length),w=Ld(E,s.digestLength,a),y=Ti.util.xorBytes(i,w,i.length);return "\0"+y+E};kk.decode_rsa_oaep=function(e,t,r){var n,i,s;typeof r=="string"?(n=r,i=arguments[3]||void 0):r&&(n=r.label||void 0,i=r.md||void 0,r.mgf1&&r.mgf1.md&&(s=r.mgf1.md));var a=Math.ceil(e.n.bitLength()/8);if(t.length!==a){var E=new Error("RSAES-OAEP encoded message length is invalid.");throw E.length=t.length,E.expectedLength=a,E}if(i===void 0?i=Ti.md.sha1.create():i.start(),s||(s=i),a<2*i.digestLength+2)throw new Error("RSAES-OAEP key is too short for the hash function.");n||(n=""),i.update(n,"raw");for(var o=i.digest().getBytes(),c=t.charAt(0),l=t.substring(1,i.digestLength+1),u=t.substring(1+i.digestLength),f=Ld(u,i.digestLength,s),h=Ti.util.xorBytes(l,f,l.length),p=Ld(h,a-i.digestLength-1,s),g=Ti.util.xorBytes(u,p,u.length),_=g.substring(0,i.digestLength),E=c!=="\0",w=0;w<i.digestLength;++w)E|=o.charAt(w)!==_.charAt(w);for(var y=1,b=i.digestLength,N=i.digestLength;N<g.length;N++){var L=g.charCodeAt(N),V=L&1^1,Z=y?65534:0;E|=L&Z,y=y&V,b+=y;}if(E||g.charCodeAt(b)!==1)throw new Error("Invalid RSAES-OAEP padding.");return g.substring(b+1)};function Ld(e,t,r){r||(r=Ti.md.sha1.create());for(var n="",i=Math.ceil(t/r.digestLength),s=0;s<i;++s){var a=String.fromCharCode(s>>24&255,s>>16&255,s>>8&255,s&255);r.start(),r.update(e+a),n+=r.digest().getBytes();}return n.substring(0,t)}});var Pv=I((phe,Iv)=>{var ws=rt();_t();Ec();Fn();(function(){if(ws.prime){Iv.exports=ws.prime;return}var e=Iv.exports=ws.prime=ws.prime||{},t=ws.jsbn.BigInteger,r=[6,4,2,4,2,4,6,2],n=new t(null);n.fromInt(30);var i=function(f,h){return f|h};e.generateProbablePrime=function(f,h,p){typeof h=="function"&&(p=h,h={}),h=h||{};var g=h.algorithm||"PRIMEINC";typeof g=="string"&&(g={name:g}),g.options=g.options||{};var _=h.prng||ws.random,E={nextBytes:function(w){for(var y=_.getBytesSync(w.length),b=0;b<w.length;++b)w[b]=y.charCodeAt(b);}};if(g.name==="PRIMEINC")return s(f,E,g.options,p);throw new Error("Invalid prime generation algorithm: "+g.name)};function s(f,h,p,g){return "workers"in p?c(f,h,p,g):a(f,h,p,g)}function a(f,h,p,g){var _=l(f,h),E=0,w=u(_.bitLength());"millerRabinTests"in p&&(w=p.millerRabinTests);var y=10;"maxBlockTime"in p&&(y=p.maxBlockTime),o(_,f,h,E,w,y,g);}function o(f,h,p,g,_,E,w){var y=+new Date;do{if(f.bitLength()>h&&(f=l(h,p)),f.isProbablePrime(_))return w(null,f);f.dAddOffset(r[g++%8],0);}while(E<0||+new Date-y<E);ws.util.setImmediate(function(){o(f,h,p,g,_,E,w);});}function c(f,h,p,g){if(typeof Worker>"u")return a(f,h,p,g);var _=l(f,h),E=p.workers,w=p.workLoad||100,y=w*30/8,b=p.workerScript||"forge/prime.worker.js";if(E===-1)return ws.util.estimateCores(function(L,V){L&&(V=2),E=V-1,N();});N();function N(){E=Math.max(1,E);for(var L=[],V=0;V<E;++V)L[V]=new Worker(b);for(var Z=E,V=0;V<E;++V)L[V].addEventListener("message",z);var G=!1;function z(ee){if(!G){--Z;var U=ee.data;if(U.found){for(var ie=0;ie<L.length;++ie)L[ie].terminate();return G=!0,g(null,new t(U.prime,16))}_.bitLength()>f&&(_=l(f,h));var me=_.toString(16);ee.target.postMessage({hex:me,workLoad:w}),_.dAddOffset(y,0);}}}}function l(f,h){var p=new t(f,h),g=f-1;return p.testBit(g)||p.bitwiseTo(t.ONE.shiftLeft(g),i,p),p.dAddOffset(31-p.mod(n).byteValue(),0),p}function u(f){return f<=100?27:f<=150?18:f<=200?15:f<=250?12:f<=300?9:f<=350?8:f<=400?7:f<=500?6:f<=600?5:f<=800?4:f<=1250?3:2}})();});var wc=I((ghe,jk)=>{var Ue=rt();ai();Ec();Ss();Rv();Pv();Fn();_t();typeof mt>"u"&&(mt=Ue.jsbn.BigInteger);var mt,Nv=Ue.util.isNodejs?he("crypto"):null,Q=Ue.asn1,Mn=Ue.util;Ue.pki=Ue.pki||{};jk.exports=Ue.pki.rsa=Ue.rsa=Ue.rsa||{};var Ze=Ue.pki,Fte=[6,4,2,4,2,4,6,2],qte={name:"PrivateKeyInfo",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"PrivateKeyInfo.version",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"PrivateKeyInfo.privateKeyAlgorithm",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Q.Class.UNIVERSAL,type:Q.Type.OID,constructed:!1,capture:"privateKeyOid"}]},{name:"PrivateKeyInfo",tagClass:Q.Class.UNIVERSAL,type:Q.Type.OCTETSTRING,constructed:!1,capture:"privateKey"}]},Mte={name:"RSAPrivateKey",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPrivateKey.version",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"RSAPrivateKey.modulus",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyModulus"},{name:"RSAPrivateKey.publicExponent",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyPublicExponent"},{name:"RSAPrivateKey.privateExponent",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyPrivateExponent"},{name:"RSAPrivateKey.prime1",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyPrime1"},{name:"RSAPrivateKey.prime2",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyPrime2"},{name:"RSAPrivateKey.exponent1",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyExponent1"},{name:"RSAPrivateKey.exponent2",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyExponent2"},{name:"RSAPrivateKey.coefficient",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"privateKeyCoefficient"}]},Ute={name:"RSAPublicKey",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"RSAPublicKey.modulus",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"publicKeyModulus"},{name:"RSAPublicKey.exponent",tagClass:Q.Class.UNIVERSAL,type:Q.Type.INTEGER,constructed:!1,capture:"publicKeyExponent"}]},$te=Ue.pki.rsa.publicKeyValidator={name:"SubjectPublicKeyInfo",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,captureAsn1:"subjectPublicKeyInfo",value:[{name:"SubjectPublicKeyInfo.AlgorithmIdentifier",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:Q.Class.UNIVERSAL,type:Q.Type.OID,constructed:!1,capture:"publicKeyOid"}]},{name:"SubjectPublicKeyInfo.subjectPublicKey",tagClass:Q.Class.UNIVERSAL,type:Q.Type.BITSTRING,constructed:!1,value:[{name:"SubjectPublicKeyInfo.subjectPublicKey.RSAPublicKey",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"rsaPublicKey"}]}]},jte={name:"DigestInfo",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"DigestInfo.DigestAlgorithm",tagClass:Q.Class.UNIVERSAL,type:Q.Type.SEQUENCE,constructed:!0,value:[{name:"DigestInfo.DigestAlgorithm.algorithmIdentifier",tagClass:Q.Class.UNIVERSAL,type:Q.Type.OID,constructed:!1,capture:"algorithmIdentifier"},{name:"DigestInfo.DigestAlgorithm.parameters",tagClass:Q.Class.UNIVERSAL,type:Q.Type.NULL,capture:"parameters",optional:!0,constructed:!1}]},{name:"DigestInfo.digest",tagClass:Q.Class.UNIVERSAL,type:Q.Type.OCTETSTRING,constructed:!1,capture:"digest"}]},Vte=function(e){var t;if(e.algorithm in Ze.oids)t=Ze.oids[e.algorithm];else {var r=new Error("Unknown message digest algorithm.");throw r.algorithm=e.algorithm,r}var n=Q.oidToDer(t).getBytes(),i=Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[]),s=Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[]);s.value.push(Q.create(Q.Class.UNIVERSAL,Q.Type.OID,!1,n)),s.value.push(Q.create(Q.Class.UNIVERSAL,Q.Type.NULL,!1,""));var a=Q.create(Q.Class.UNIVERSAL,Q.Type.OCTETSTRING,!1,e.digest().getBytes());return i.value.push(s),i.value.push(a),Q.toDer(i).getBytes()},Uk=function(e,t,r){if(r)return e.modPow(t.e,t.n);if(!t.p||!t.q)return e.modPow(t.d,t.n);t.dP||(t.dP=t.d.mod(t.p.subtract(mt.ONE))),t.dQ||(t.dQ=t.d.mod(t.q.subtract(mt.ONE))),t.qInv||(t.qInv=t.q.modInverse(t.p));var n;do n=new mt(Ue.util.bytesToHex(Ue.random.getBytes(t.n.bitLength()/8)),16);while(n.compareTo(t.n)>=0||!n.gcd(t.n).equals(mt.ONE));e=e.multiply(n.modPow(t.e,t.n)).mod(t.n);for(var i=e.mod(t.p).modPow(t.dP,t.p),s=e.mod(t.q).modPow(t.dQ,t.q);i.compareTo(s)<0;)i=i.add(t.p);var a=i.subtract(s).multiply(t.qInv).mod(t.p).multiply(t.q).add(s);return a=a.multiply(n.modInverse(t.n)).mod(t.n),a};Ze.rsa.encrypt=function(e,t,r){var n=r,i,s=Math.ceil(t.n.bitLength()/8);r!==!1&&r!==!0?(n=r===2,i=$k(e,t,r)):(i=Ue.util.createBuffer(),i.putBytes(e));for(var a=new mt(i.toHex(),16),o=Uk(a,t,n),c=o.toString(16),l=Ue.util.createBuffer(),u=s-Math.ceil(c.length/2);u>0;)l.putByte(0),--u;return l.putBytes(Ue.util.hexToBytes(c)),l.getBytes()};Ze.rsa.decrypt=function(e,t,r,n){var i=Math.ceil(t.n.bitLength()/8);if(e.length!==i){var s=new Error("Encrypted message length is invalid.");throw s.length=e.length,s.expected=i,s}var a=new mt(Ue.util.createBuffer(e).toHex(),16);if(a.compareTo(t.n)>=0)throw new Error("Encrypted message is invalid.");for(var o=Uk(a,t,r),c=o.toString(16),l=Ue.util.createBuffer(),u=i-Math.ceil(c.length/2);u>0;)l.putByte(0),--u;return l.putBytes(Ue.util.hexToBytes(c)),n!==!1?Bd(l.getBytes(),t,r):l.getBytes()};Ze.rsa.createKeyPairGenerationState=function(e,t,r){typeof e=="string"&&(e=parseInt(e,10)),e=e||2048,r=r||{};var n=r.prng||Ue.random,i={nextBytes:function(o){for(var c=n.getBytesSync(o.length),l=0;l<o.length;++l)o[l]=c.charCodeAt(l);}},s=r.algorithm||"PRIMEINC",a;if(s==="PRIMEINC")a={algorithm:s,state:0,bits:e,rng:i,eInt:t||65537,e:new mt(null),p:null,q:null,qBits:e>>1,pBits:e-(e>>1),pqState:0,num:null,keys:null},a.e.fromInt(a.eInt);else throw new Error("Invalid key generation algorithm: "+s);return a};Ze.rsa.stepKeyPairGenerationState=function(e,t){"algorithm"in e||(e.algorithm="PRIMEINC");var r=new mt(null);r.fromInt(30);for(var n=0,i=function(f,h){return f|h},s=+new Date,a,o=0;e.keys===null&&(t<=0||o<t);){if(e.state===0){var c=e.p===null?e.pBits:e.qBits,l=c-1;e.pqState===0?(e.num=new mt(c,e.rng),e.num.testBit(l)||e.num.bitwiseTo(mt.ONE.shiftLeft(l),i,e.num),e.num.dAddOffset(31-e.num.mod(r).byteValue(),0),n=0,++e.pqState):e.pqState===1?e.num.bitLength()>c?e.pqState=0:e.num.isProbablePrime(Wte(e.num.bitLength()))?++e.pqState:e.num.dAddOffset(Fte[n++%8],0):e.pqState===2?e.pqState=e.num.subtract(mt.ONE).gcd(e.e).compareTo(mt.ONE)===0?3:0:e.pqState===3&&(e.pqState=0,e.p===null?e.p=e.num:e.q=e.num,e.p!==null&&e.q!==null&&++e.state,e.num=null);}else if(e.state===1)e.p.compareTo(e.q)<0&&(e.num=e.p,e.p=e.q,e.q=e.num),++e.state;else if(e.state===2)e.p1=e.p.subtract(mt.ONE),e.q1=e.q.subtract(mt.ONE),e.phi=e.p1.multiply(e.q1),++e.state;else if(e.state===3)e.phi.gcd(e.e).compareTo(mt.ONE)===0?++e.state:(e.p=null,e.q=null,e.state=0);else if(e.state===4)e.n=e.p.multiply(e.q),e.n.bitLength()===e.bits?++e.state:(e.q=null,e.state=0);else if(e.state===5){var u=e.e.modInverse(e.phi);e.keys={privateKey:Ze.rsa.setPrivateKey(e.n,e.e,u,e.p,e.q,u.mod(e.p1),u.mod(e.q1),e.q.modInverse(e.p)),publicKey:Ze.rsa.setPublicKey(e.n,e.e)};}a=+new Date,o+=a-s,s=a;}return e.keys!==null};Ze.rsa.generateKeyPair=function(e,t,r,n){if(arguments.length===1?typeof e=="object"?(r=e,e=void 0):typeof e=="function"&&(n=e,e=void 0):arguments.length===2?typeof e=="number"?typeof t=="function"?(n=t,t=void 0):typeof t!="number"&&(r=t,t=void 0):(r=e,n=t,e=void 0,t=void 0):arguments.length===3&&(typeof t=="number"?typeof r=="function"&&(n=r,r=void 0):(n=r,r=t,t=void 0)),r=r||{},e===void 0&&(e=r.bits||2048),t===void 0&&(t=r.e||65537),!Ue.options.usePureJavaScript&&!r.prng&&e>=256&&e<=16384&&(t===65537||t===3)){if(n){if(Bk("generateKeyPair"))return Nv.generateKeyPair("rsa",{modulusLength:e,publicExponent:t,publicKeyEncoding:{type:"spki",format:"pem"},privateKeyEncoding:{type:"pkcs8",format:"pem"}},function(o,c,l){if(o)return n(o);n(null,{privateKey:Ze.privateKeyFromPem(l),publicKey:Ze.publicKeyFromPem(c)});});if(Fk("generateKey")&&Fk("exportKey"))return Mn.globalScope.crypto.subtle.generateKey({name:"RSASSA-PKCS1-v1_5",modulusLength:e,publicExponent:Mk(t),hash:{name:"SHA-256"}},!0,["sign","verify"]).then(function(o){return Mn.globalScope.crypto.subtle.exportKey("pkcs8",o.privateKey)}).then(void 0,function(o){n(o);}).then(function(o){if(o){var c=Ze.privateKeyFromAsn1(Q.fromDer(Ue.util.createBuffer(o)));n(null,{privateKey:c,publicKey:Ze.setRsaPublicKey(c.n,c.e)});}});if(qk("generateKey")&&qk("exportKey")){var i=Mn.globalScope.msCrypto.subtle.generateKey({name:"RSASSA-PKCS1-v1_5",modulusLength:e,publicExponent:Mk(t),hash:{name:"SHA-256"}},!0,["sign","verify"]);i.oncomplete=function(o){var c=o.target.result,l=Mn.globalScope.msCrypto.subtle.exportKey("pkcs8",c.privateKey);l.oncomplete=function(u){var f=u.target.result,h=Ze.privateKeyFromAsn1(Q.fromDer(Ue.util.createBuffer(f)));n(null,{privateKey:h,publicKey:Ze.setRsaPublicKey(h.n,h.e)});},l.onerror=function(u){n(u);};},i.onerror=function(o){n(o);};return}}else if(Bk("generateKeyPairSync")){var s=Nv.generateKeyPairSync("rsa",{modulusLength:e,publicExponent:t,publicKeyEncoding:{type:"spki",format:"pem"},privateKeyEncoding:{type:"pkcs8",format:"pem"}});return {privateKey:Ze.privateKeyFromPem(s.privateKey),publicKey:Ze.publicKeyFromPem(s.publicKey)}}}var a=Ze.rsa.createKeyPairGenerationState(e,t,r);if(!n)return Ze.rsa.stepKeyPairGenerationState(a,0),a.keys;Hte(a,r,n);};Ze.setRsaPublicKey=Ze.rsa.setPublicKey=function(e,t){var r={n:e,e:t};return r.encrypt=function(n,i,s){if(typeof i=="string"?i=i.toUpperCase():i===void 0&&(i="RSAES-PKCS1-V1_5"),i==="RSAES-PKCS1-V1_5")i={encode:function(o,c,l){return $k(o,c,2).getBytes()}};else if(i==="RSA-OAEP"||i==="RSAES-OAEP")i={encode:function(o,c){return Ue.pkcs1.encode_rsa_oaep(c,o,s)}};else if(["RAW","NONE","NULL",null].indexOf(i)!==-1)i={encode:function(o){return o}};else if(typeof i=="string")throw new Error('Unsupported encryption scheme: "'+i+'".');var a=i.encode(n,r,!0);return Ze.rsa.encrypt(a,r,!0)},r.verify=function(n,i,s,a){typeof s=="string"?s=s.toUpperCase():s===void 0&&(s="RSASSA-PKCS1-V1_5"),a===void 0&&(a={_parseAllDigestBytes:!0}),"_parseAllDigestBytes"in a||(a._parseAllDigestBytes=!0),s==="RSASSA-PKCS1-V1_5"?s={verify:function(c,l){l=Bd(l,r,!0);var u=Q.fromDer(l,{parseAllBytes:a._parseAllDigestBytes}),f={},h=[];if(!Q.validate(u,jte,f,h)){var p=new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 DigestInfo value.");throw p.errors=h,p}var g=Q.derToOid(f.algorithmIdentifier);if(!(g===Ue.oids.md2||g===Ue.oids.md5||g===Ue.oids.sha1||g===Ue.oids.sha224||g===Ue.oids.sha256||g===Ue.oids.sha384||g===Ue.oids.sha512||g===Ue.oids["sha512-224"]||g===Ue.oids["sha512-256"])){var p=new Error("Unknown RSASSA-PKCS1-v1_5 DigestAlgorithm identifier.");throw p.oid=g,p}if((g===Ue.oids.md2||g===Ue.oids.md5)&&!("parameters"in f))throw new Error("ASN.1 object does not contain a valid RSASSA-PKCS1-v1_5 DigestInfo value. Missing algorithm identifer NULL parameters.");return c===f.digest}}:(s==="NONE"||s==="NULL"||s===null)&&(s={verify:function(c,l){return l=Bd(l,r,!0),c===l}});var o=Ze.rsa.decrypt(i,r,!0,!1);return s.verify(n,o,r.n.bitLength())},r};Ze.setRsaPrivateKey=Ze.rsa.setPrivateKey=function(e,t,r,n,i,s,a,o){var c={n:e,e:t,d:r,p:n,q:i,dP:s,dQ:a,qInv:o};return c.decrypt=function(l,u,f){typeof u=="string"?u=u.toUpperCase():u===void 0&&(u="RSAES-PKCS1-V1_5");var h=Ze.rsa.decrypt(l,c,!1,!1);if(u==="RSAES-PKCS1-V1_5")u={decode:Bd};else if(u==="RSA-OAEP"||u==="RSAES-OAEP")u={decode:function(p,g){return Ue.pkcs1.decode_rsa_oaep(g,p,f)}};else if(["RAW","NONE","NULL",null].indexOf(u)!==-1)u={decode:function(p){return p}};else throw new Error('Unsupported encryption scheme: "'+u+'".');return u.decode(h,c,!1)},c.sign=function(l,u){var f=!1;typeof u=="string"&&(u=u.toUpperCase()),u===void 0||u==="RSASSA-PKCS1-V1_5"?(u={encode:Vte},f=1):(u==="NONE"||u==="NULL"||u===null)&&(u={encode:function(){return l}},f=1);var h=u.encode(l,c.n.bitLength());return Ze.rsa.encrypt(h,c,f)},c};Ze.wrapRsaPrivateKey=function(e){return Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Q.integerToDer(0).getBytes()),Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[Q.create(Q.Class.UNIVERSAL,Q.Type.OID,!1,Q.oidToDer(Ze.oids.rsaEncryption).getBytes()),Q.create(Q.Class.UNIVERSAL,Q.Type.NULL,!1,"")]),Q.create(Q.Class.UNIVERSAL,Q.Type.OCTETSTRING,!1,Q.toDer(e).getBytes())])};Ze.privateKeyFromAsn1=function(e){var t={},r=[];if(Q.validate(e,qte,t,r)&&(e=Q.fromDer(Ue.util.createBuffer(t.privateKey))),t={},r=[],!Q.validate(e,Mte,t,r)){var n=new Error("Cannot read private key. ASN.1 object does not contain an RSAPrivateKey.");throw n.errors=r,n}var i,s,a,o,c,l,u,f;return i=Ue.util.createBuffer(t.privateKeyModulus).toHex(),s=Ue.util.createBuffer(t.privateKeyPublicExponent).toHex(),a=Ue.util.createBuffer(t.privateKeyPrivateExponent).toHex(),o=Ue.util.createBuffer(t.privateKeyPrime1).toHex(),c=Ue.util.createBuffer(t.privateKeyPrime2).toHex(),l=Ue.util.createBuffer(t.privateKeyExponent1).toHex(),u=Ue.util.createBuffer(t.privateKeyExponent2).toHex(),f=Ue.util.createBuffer(t.privateKeyCoefficient).toHex(),Ze.setRsaPrivateKey(new mt(i,16),new mt(s,16),new mt(a,16),new mt(o,16),new mt(c,16),new mt(l,16),new mt(u,16),new mt(f,16))};Ze.privateKeyToAsn1=Ze.privateKeyToRSAPrivateKey=function(e){return Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Q.integerToDer(0).getBytes()),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.n)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.e)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.d)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.p)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.q)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.dP)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.dQ)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.qInv))])};Ze.publicKeyFromAsn1=function(e){var t={},r=[];if(Q.validate(e,$te,t,r)){var n=Q.derToOid(t.publicKeyOid);if(n!==Ze.oids.rsaEncryption){var i=new Error("Cannot read public key. Unknown OID.");throw i.oid=n,i}e=t.rsaPublicKey;}if(r=[],!Q.validate(e,Ute,t,r)){var i=new Error("Cannot read public key. ASN.1 object does not contain an RSAPublicKey.");throw i.errors=r,i}var s=Ue.util.createBuffer(t.publicKeyModulus).toHex(),a=Ue.util.createBuffer(t.publicKeyExponent).toHex();return Ze.setRsaPublicKey(new mt(s,16),new mt(a,16))};Ze.publicKeyToAsn1=Ze.publicKeyToSubjectPublicKeyInfo=function(e){return Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[Q.create(Q.Class.UNIVERSAL,Q.Type.OID,!1,Q.oidToDer(Ze.oids.rsaEncryption).getBytes()),Q.create(Q.Class.UNIVERSAL,Q.Type.NULL,!1,"")]),Q.create(Q.Class.UNIVERSAL,Q.Type.BITSTRING,!1,[Ze.publicKeyToRSAPublicKey(e)])])};Ze.publicKeyToRSAPublicKey=function(e){return Q.create(Q.Class.UNIVERSAL,Q.Type.SEQUENCE,!0,[Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.n)),Q.create(Q.Class.UNIVERSAL,Q.Type.INTEGER,!1,Ai(e.e))])};function $k(e,t,r){var n=Ue.util.createBuffer(),i=Math.ceil(t.n.bitLength()/8);if(e.length>i-11){var s=new Error("Message is too long for PKCS#1 v1.5 padding.");throw s.length=e.length,s.max=i-11,s}n.putByte(0),n.putByte(r);var a=i-3-e.length,o;if(r===0||r===1){o=r===0?0:255;for(var c=0;c<a;++c)n.putByte(o);}else for(;a>0;){for(var l=0,u=Ue.random.getBytes(a),c=0;c<a;++c)o=u.charCodeAt(c),o===0?++l:n.putByte(o);a=l;}return n.putByte(0),n.putBytes(e),n}function Bd(e,t,r,n){var i=Math.ceil(t.n.bitLength()/8),s=Ue.util.createBuffer(e),a=s.getByte(),o=s.getByte();if(a!==0||r&&o!==0&&o!==1||!r&&o!=2||r&&o===0&&typeof n>"u")throw new Error("Encryption block is invalid.");var c=0;if(o===0){c=i-3-n;for(var l=0;l<c;++l)if(s.getByte()!==0)throw new Error("Encryption block is invalid.")}else if(o===1)for(c=0;s.length()>1;){if(s.getByte()!==255){--s.read;break}++c;}else if(o===2)for(c=0;s.length()>1;){if(s.getByte()===0){--s.read;break}++c;}var u=s.getByte();if(u!==0||c!==i-3-s.length())throw new Error("Encryption block is invalid.");return s.getBytes()}function Hte(e,t,r){typeof t=="function"&&(r=t,t={}),t=t||{};var n={algorithm:{name:t.algorithm||"PRIMEINC",options:{workers:t.workers||2,workLoad:t.workLoad||100,workerScript:t.workerScript}}};"prng"in t&&(n.prng=t.prng),i();function i(){s(e.pBits,function(o,c){if(o)return r(o);if(e.p=c,e.q!==null)return a(o,e.q);s(e.qBits,a);});}function s(o,c){Ue.prime.generateProbablePrime(o,n,c);}function a(o,c){if(o)return r(o);if(e.q=c,e.p.compareTo(e.q)<0){var l=e.p;e.p=e.q,e.q=l;}if(e.p.subtract(mt.ONE).gcd(e.e).compareTo(mt.ONE)!==0){e.p=null,i();return}if(e.q.subtract(mt.ONE).gcd(e.e).compareTo(mt.ONE)!==0){e.q=null,s(e.qBits,a);return}if(e.p1=e.p.subtract(mt.ONE),e.q1=e.q.subtract(mt.ONE),e.phi=e.p1.multiply(e.q1),e.phi.gcd(e.e).compareTo(mt.ONE)!==0){e.p=e.q=null,i();return}if(e.n=e.p.multiply(e.q),e.n.bitLength()!==e.bits){e.q=null,s(e.qBits,a);return}var u=e.e.modInverse(e.phi);e.keys={privateKey:Ze.rsa.setPrivateKey(e.n,e.e,u,e.p,e.q,u.mod(e.p1),u.mod(e.q1),e.q.modInverse(e.p)),publicKey:Ze.rsa.setPublicKey(e.n,e.e)},r(null,e.keys);}}function Ai(e){var t=e.toString(16);t[0]>="8"&&(t="00"+t);var r=Ue.util.hexToBytes(t);return r.length>1&&(r.charCodeAt(0)===0&&!(r.charCodeAt(1)&128)||r.charCodeAt(0)===255&&(r.charCodeAt(1)&128)===128)?r.substr(1):r}function Wte(e){return e<=100?27:e<=150?18:e<=200?15:e<=250?12:e<=300?9:e<=350?8:e<=400?7:e<=500?6:e<=600?5:e<=800?4:e<=1250?3:2}function Bk(e){return Ue.util.isNodejs&&typeof Nv[e]=="function"}function Fk(e){return typeof Mn.globalScope<"u"&&typeof Mn.globalScope.crypto=="object"&&typeof Mn.globalScope.crypto.subtle=="object"&&typeof Mn.globalScope.crypto.subtle[e]=="function"}function qk(e){return typeof Mn.globalScope<"u"&&typeof Mn.globalScope.msCrypto=="object"&&typeof Mn.globalScope.msCrypto.subtle=="object"&&typeof Mn.globalScope.msCrypto.subtle[e]=="function"}function Mk(e){for(var t=Ue.util.hexToBytes(e.toString(16)),r=new Uint8Array(t.length),n=0;n<t.length;++n)r[n]=t.charCodeAt(n);return r}});var Dv=I((mhe,Gk)=>{var Re=rt();bs();ai();bc();bi();Ss();Nd();ma();Fn();wv();wc();_t();var te=Re.asn1,et=Re.pki=Re.pki||{};Gk.exports=et.pbe=Re.pbe=Re.pbe||{};var _a=et.oids,Kte={name:"EncryptedPrivateKeyInfo",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedPrivateKeyInfo.encryptionAlgorithm",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:te.Class.UNIVERSAL,type:te.Type.OID,constructed:!1,capture:"encryptionOid"},{name:"AlgorithmIdentifier.parameters",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,captureAsn1:"encryptionParams"}]},{name:"EncryptedPrivateKeyInfo.encryptedData",tagClass:te.Class.UNIVERSAL,type:te.Type.OCTETSTRING,constructed:!1,capture:"encryptedData"}]},Gte={name:"PBES2Algorithms",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.keyDerivationFunc",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.keyDerivationFunc.oid",tagClass:te.Class.UNIVERSAL,type:te.Type.OID,constructed:!1,capture:"kdfOid"},{name:"PBES2Algorithms.params",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.params.salt",tagClass:te.Class.UNIVERSAL,type:te.Type.OCTETSTRING,constructed:!1,capture:"kdfSalt"},{name:"PBES2Algorithms.params.iterationCount",tagClass:te.Class.UNIVERSAL,type:te.Type.INTEGER,constructed:!1,capture:"kdfIterationCount"},{name:"PBES2Algorithms.params.keyLength",tagClass:te.Class.UNIVERSAL,type:te.Type.INTEGER,constructed:!1,optional:!0,capture:"keyLength"},{name:"PBES2Algorithms.params.prf",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,optional:!0,value:[{name:"PBES2Algorithms.params.prf.algorithm",tagClass:te.Class.UNIVERSAL,type:te.Type.OID,constructed:!1,capture:"prfOid"}]}]}]},{name:"PBES2Algorithms.encryptionScheme",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"PBES2Algorithms.encryptionScheme.oid",tagClass:te.Class.UNIVERSAL,type:te.Type.OID,constructed:!1,capture:"encOid"},{name:"PBES2Algorithms.encryptionScheme.iv",tagClass:te.Class.UNIVERSAL,type:te.Type.OCTETSTRING,constructed:!1,capture:"encIv"}]}]},zte={name:"pkcs-12PbeParams",tagClass:te.Class.UNIVERSAL,type:te.Type.SEQUENCE,constructed:!0,value:[{name:"pkcs-12PbeParams.salt",tagClass:te.Class.UNIVERSAL,type:te.Type.OCTETSTRING,constructed:!1,capture:"salt"},{name:"pkcs-12PbeParams.iterations",tagClass:te.Class.UNIVERSAL,type:te.Type.INTEGER,constructed:!1,capture:"iterations"}]};et.encryptPrivateKeyInfo=function(e,t,r){r=r||{},r.saltSize=r.saltSize||8,r.count=r.count||2048,r.algorithm=r.algorithm||"aes128",r.prfAlgorithm=r.prfAlgorithm||"sha1";var n=Re.random.getBytesSync(r.saltSize),i=r.count,s=te.integerToDer(i),a,o,c;if(r.algorithm.indexOf("aes")===0||r.algorithm==="des"){var l,u,f;switch(r.algorithm){case"aes128":a=16,l=16,u=_a["aes128-CBC"],f=Re.aes.createEncryptionCipher;break;case"aes192":a=24,l=16,u=_a["aes192-CBC"],f=Re.aes.createEncryptionCipher;break;case"aes256":a=32,l=16,u=_a["aes256-CBC"],f=Re.aes.createEncryptionCipher;break;case"des":a=8,l=8,u=_a.desCBC,f=Re.des.createEncryptionCipher;break;default:var h=new Error("Cannot encrypt private key. Unknown encryption algorithm.");throw h.algorithm=r.algorithm,h}var p="hmacWith"+r.prfAlgorithm.toUpperCase(),g=Kk(p),_=Re.pkcs5.pbkdf2(t,n,i,a,g),E=Re.random.getBytesSync(l),w=f(_);w.start(E),w.update(te.toDer(e)),w.finish(),c=w.output.getBytes();var y=Yte(n,s,a,p);o=te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OID,!1,te.oidToDer(_a.pkcs5PBES2).getBytes()),te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OID,!1,te.oidToDer(_a.pkcs5PBKDF2).getBytes()),y]),te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OID,!1,te.oidToDer(u).getBytes()),te.create(te.Class.UNIVERSAL,te.Type.OCTETSTRING,!1,E)])])]);}else if(r.algorithm==="3des"){a=24;var b=new Re.util.ByteBuffer(n),_=et.pbe.generatePkcs12Key(t,b,1,i,a),E=et.pbe.generatePkcs12Key(t,b,2,i,a),w=Re.des.createEncryptionCipher(_);w.start(E),w.update(te.toDer(e)),w.finish(),c=w.output.getBytes(),o=te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OID,!1,te.oidToDer(_a["pbeWithSHAAnd3-KeyTripleDES-CBC"]).getBytes()),te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OCTETSTRING,!1,n),te.create(te.Class.UNIVERSAL,te.Type.INTEGER,!1,s.getBytes())])]);}else {var h=new Error("Cannot encrypt private key. Unknown encryption algorithm.");throw h.algorithm=r.algorithm,h}var N=te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[o,te.create(te.Class.UNIVERSAL,te.Type.OCTETSTRING,!1,c)]);return N};et.decryptPrivateKeyInfo=function(e,t){var r=null,n={},i=[];if(!te.validate(e,Kte,n,i)){var s=new Error("Cannot read encrypted private key. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw s.errors=i,s}var a=te.derToOid(n.encryptionOid),o=et.pbe.getCipher(a,n.encryptionParams,t),c=Re.util.createBuffer(n.encryptedData);return o.update(c),o.finish()&&(r=te.fromDer(o.output)),r};et.encryptedPrivateKeyToPem=function(e,t){var r={type:"ENCRYPTED PRIVATE KEY",body:te.toDer(e).getBytes()};return Re.pem.encode(r,{maxline:t})};et.encryptedPrivateKeyFromPem=function(e){var t=Re.pem.decode(e)[0];if(t.type!=="ENCRYPTED PRIVATE KEY"){var r=new Error('Could not convert encrypted private key from PEM; PEM header type is "ENCRYPTED PRIVATE KEY".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert encrypted private key from PEM; PEM is encrypted.");return te.fromDer(t.body)};et.encryptRsaPrivateKey=function(e,t,r){if(r=r||{},!r.legacy){var n=et.wrapRsaPrivateKey(et.privateKeyToAsn1(e));return n=et.encryptPrivateKeyInfo(n,t,r),et.encryptedPrivateKeyToPem(n)}var i,s,a,o;switch(r.algorithm){case"aes128":i="AES-128-CBC",a=16,s=Re.random.getBytesSync(16),o=Re.aes.createEncryptionCipher;break;case"aes192":i="AES-192-CBC",a=24,s=Re.random.getBytesSync(16),o=Re.aes.createEncryptionCipher;break;case"aes256":i="AES-256-CBC",a=32,s=Re.random.getBytesSync(16),o=Re.aes.createEncryptionCipher;break;case"3des":i="DES-EDE3-CBC",a=24,s=Re.random.getBytesSync(8),o=Re.des.createEncryptionCipher;break;case"des":i="DES-CBC",a=8,s=Re.random.getBytesSync(8),o=Re.des.createEncryptionCipher;break;default:var c=new Error('Could not encrypt RSA private key; unsupported encryption algorithm "'+r.algorithm+'".');throw c.algorithm=r.algorithm,c}var l=Re.pbe.opensslDeriveBytes(t,s.substr(0,8),a),u=o(l);u.start(s),u.update(te.toDer(et.privateKeyToAsn1(e))),u.finish();var f={type:"RSA PRIVATE KEY",procType:{version:"4",type:"ENCRYPTED"},dekInfo:{algorithm:i,parameters:Re.util.bytesToHex(s).toUpperCase()},body:u.output.getBytes()};return Re.pem.encode(f)};et.decryptRsaPrivateKey=function(e,t){var r=null,n=Re.pem.decode(e)[0];if(n.type!=="ENCRYPTED PRIVATE KEY"&&n.type!=="PRIVATE KEY"&&n.type!=="RSA PRIVATE KEY"){var i=new Error('Could not convert private key from PEM; PEM header type is not "ENCRYPTED PRIVATE KEY", "PRIVATE KEY", or "RSA PRIVATE KEY".');throw i.headerType=i,i}if(n.procType&&n.procType.type==="ENCRYPTED"){var s,a;switch(n.dekInfo.algorithm){case"DES-CBC":s=8,a=Re.des.createDecryptionCipher;break;case"DES-EDE3-CBC":s=24,a=Re.des.createDecryptionCipher;break;case"AES-128-CBC":s=16,a=Re.aes.createDecryptionCipher;break;case"AES-192-CBC":s=24,a=Re.aes.createDecryptionCipher;break;case"AES-256-CBC":s=32,a=Re.aes.createDecryptionCipher;break;case"RC2-40-CBC":s=5,a=function(f){return Re.rc2.createDecryptionCipher(f,40)};break;case"RC2-64-CBC":s=8,a=function(f){return Re.rc2.createDecryptionCipher(f,64)};break;case"RC2-128-CBC":s=16,a=function(f){return Re.rc2.createDecryptionCipher(f,128)};break;default:var i=new Error('Could not decrypt private key; unsupported encryption algorithm "'+n.dekInfo.algorithm+'".');throw i.algorithm=n.dekInfo.algorithm,i}var o=Re.util.hexToBytes(n.dekInfo.parameters),c=Re.pbe.opensslDeriveBytes(t,o.substr(0,8),s),l=a(c);if(l.start(o),l.update(Re.util.createBuffer(n.body)),l.finish())r=l.output.getBytes();else return r}else r=n.body;return n.type==="ENCRYPTED PRIVATE KEY"?r=et.decryptPrivateKeyInfo(te.fromDer(r),t):r=te.fromDer(r),r!==null&&(r=et.privateKeyFromAsn1(r)),r};et.pbe.generatePkcs12Key=function(e,t,r,n,i,s){var a,o;if(typeof s>"u"||s===null){if(!("sha1"in Re.md))throw new Error('"sha1" hash algorithm unavailable.');s=Re.md.sha1.create();}var c=s.digestLength,l=s.blockLength,u=new Re.util.ByteBuffer,f=new Re.util.ByteBuffer;if(e!=null){for(o=0;o<e.length;o++)f.putInt16(e.charCodeAt(o));f.putInt16(0);}var h=f.length(),p=t.length(),g=new Re.util.ByteBuffer;g.fillWithByte(r,l);var _=l*Math.ceil(p/l),E=new Re.util.ByteBuffer;for(o=0;o<_;o++)E.putByte(t.at(o%p));var w=l*Math.ceil(h/l),y=new Re.util.ByteBuffer;for(o=0;o<w;o++)y.putByte(f.at(o%h));var b=E;b.putBuffer(y);for(var N=Math.ceil(i/c),L=1;L<=N;L++){var V=new Re.util.ByteBuffer;V.putBytes(g.bytes()),V.putBytes(b.bytes());for(var Z=0;Z<n;Z++)s.start(),s.update(V.getBytes()),V=s.digest();var G=new Re.util.ByteBuffer;for(o=0;o<l;o++)G.putByte(V.at(o%c));var z=Math.ceil(p/l)+Math.ceil(h/l),ee=new Re.util.ByteBuffer;for(a=0;a<z;a++){var U=new Re.util.ByteBuffer(b.getBytes(l)),ie=511;for(o=G.length()-1;o>=0;o--)ie=ie>>8,ie+=G.at(o)+U.at(o),U.setAt(o,ie&255);ee.putBuffer(U);}b=ee,u.putBuffer(V);}return u.truncate(u.length()-i),u};et.pbe.getCipher=function(e,t,r){switch(e){case et.oids.pkcs5PBES2:return et.pbe.getCipherForPBES2(e,t,r);case et.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:case et.oids["pbewithSHAAnd40BitRC2-CBC"]:return et.pbe.getCipherForPKCS12PBE(e,t,r);default:var n=new Error("Cannot read encrypted PBE data block. Unsupported OID.");throw n.oid=e,n.supportedOids=["pkcs5PBES2","pbeWithSHAAnd3-KeyTripleDES-CBC","pbewithSHAAnd40BitRC2-CBC"],n}};et.pbe.getCipherForPBES2=function(e,t,r){var n={},i=[];if(!te.validate(t,Gte,n,i)){var s=new Error("Cannot read password-based-encryption algorithm parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw s.errors=i,s}if(e=te.derToOid(n.kdfOid),e!==et.oids.pkcs5PBKDF2){var s=new Error("Cannot read encrypted private key. Unsupported key derivation function OID.");throw s.oid=e,s.supportedOids=["pkcs5PBKDF2"],s}if(e=te.derToOid(n.encOid),e!==et.oids["aes128-CBC"]&&e!==et.oids["aes192-CBC"]&&e!==et.oids["aes256-CBC"]&&e!==et.oids["des-EDE3-CBC"]&&e!==et.oids.desCBC){var s=new Error("Cannot read encrypted private key. Unsupported encryption scheme OID.");throw s.oid=e,s.supportedOids=["aes128-CBC","aes192-CBC","aes256-CBC","des-EDE3-CBC","desCBC"],s}var a=n.kdfSalt,o=Re.util.createBuffer(n.kdfIterationCount);o=o.getInt(o.length()<<3);var c,l;switch(et.oids[e]){case"aes128-CBC":c=16,l=Re.aes.createDecryptionCipher;break;case"aes192-CBC":c=24,l=Re.aes.createDecryptionCipher;break;case"aes256-CBC":c=32,l=Re.aes.createDecryptionCipher;break;case"des-EDE3-CBC":c=24,l=Re.des.createDecryptionCipher;break;case"desCBC":c=8,l=Re.des.createDecryptionCipher;break}var u=Wk(n.prfOid),f=Re.pkcs5.pbkdf2(r,a,o,c,u),h=n.encIv,p=l(f);return p.start(h),p};et.pbe.getCipherForPKCS12PBE=function(e,t,r){var n={},i=[];if(!te.validate(t,zte,n,i)){var s=new Error("Cannot read password-based-encryption algorithm parameters. ASN.1 object is not a supported EncryptedPrivateKeyInfo.");throw s.errors=i,s}var a=Re.util.createBuffer(n.salt),o=Re.util.createBuffer(n.iterations);o=o.getInt(o.length()<<3);var c,l,u;switch(e){case et.oids["pbeWithSHAAnd3-KeyTripleDES-CBC"]:c=24,l=8,u=Re.des.startDecrypting;break;case et.oids["pbewithSHAAnd40BitRC2-CBC"]:c=5,l=8,u=function(_,E){var w=Re.rc2.createDecryptionCipher(_,40);return w.start(E,null),w};break;default:var s=new Error("Cannot read PKCS #12 PBE data block. Unsupported OID.");throw s.oid=e,s}var f=Wk(n.prfOid),h=et.pbe.generatePkcs12Key(r,a,1,o,c,f);f.start();var p=et.pbe.generatePkcs12Key(r,a,2,o,l,f);return u(h,p)};et.pbe.opensslDeriveBytes=function(e,t,r,n){if(typeof n>"u"||n===null){if(!("md5"in Re.md))throw new Error('"md5" hash algorithm unavailable.');n=Re.md.md5.create();}t===null&&(t="");for(var i=[Hk(n,e+t)],s=16,a=1;s<r;++a,s+=16)i.push(Hk(n,i[a-1]+e+t));return i.join("").substr(0,r)};function Hk(e,t){return e.start().update(t).digest().getBytes()}function Wk(e){var t;if(!e)t="hmacWithSHA1";else if(t=et.oids[te.derToOid(e)],!t){var r=new Error("Unsupported PRF OID.");throw r.oid=e,r.supported=["hmacWithSHA1","hmacWithSHA224","hmacWithSHA256","hmacWithSHA384","hmacWithSHA512"],r}return Kk(t)}function Kk(e){var t=Re.md;switch(e){case"hmacWithSHA224":t=Re.md.sha512;case"hmacWithSHA1":case"hmacWithSHA256":case"hmacWithSHA384":case"hmacWithSHA512":e=e.substr(8).toLowerCase();break;default:var r=new Error("Unsupported PRF algorithm.");throw r.algorithm=e,r.supported=["hmacWithSHA1","hmacWithSHA224","hmacWithSHA256","hmacWithSHA384","hmacWithSHA512"],r}if(!t||!(e in t))throw new Error("Unknown hash algorithm: "+e);return t[e].create()}function Yte(e,t,r,n){var i=te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OCTETSTRING,!1,e),te.create(te.Class.UNIVERSAL,te.Type.INTEGER,!1,t.getBytes())]);return n!=="hmacWithSHA1"&&i.value.push(te.create(te.Class.UNIVERSAL,te.Type.INTEGER,!1,Re.util.hexToBytes(r.toString(16))),te.create(te.Class.UNIVERSAL,te.Type.SEQUENCE,!0,[te.create(te.Class.UNIVERSAL,te.Type.OID,!1,te.oidToDer(et.oids[n]).getBytes()),te.create(te.Class.UNIVERSAL,te.Type.NULL,!1,"")])),i}});var Ov=I((yhe,Qk)=>{var Io=rt();ai();_t();var xe=Io.asn1,Po=Qk.exports=Io.pkcs7asn1=Io.pkcs7asn1||{};Io.pkcs7=Io.pkcs7||{};Io.pkcs7.asn1=Po;var zk={name:"ContentInfo",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.ContentType",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:xe.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,captureAsn1:"content"}]};Po.contentInfoValidator=zk;var Yk={name:"EncryptedContentInfo",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedContentInfo.contentType",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OID,constructed:!1,capture:"contentType"},{name:"EncryptedContentInfo.contentEncryptionAlgorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedContentInfo.contentEncryptionAlgorithm.algorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OID,constructed:!1,capture:"encAlgorithm"},{name:"EncryptedContentInfo.contentEncryptionAlgorithm.parameter",tagClass:xe.Class.UNIVERSAL,captureAsn1:"encParameter"}]},{name:"EncryptedContentInfo.encryptedContent",tagClass:xe.Class.CONTEXT_SPECIFIC,type:0,capture:"encryptedContent",captureAsn1:"encryptedContentAsn1"}]};Po.envelopedDataValidator={name:"EnvelopedData",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"EnvelopedData.Version",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1,capture:"version"},{name:"EnvelopedData.RecipientInfos",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SET,constructed:!0,captureAsn1:"recipientInfos"}].concat(Yk)};Po.encryptedDataValidator={name:"EncryptedData",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"EncryptedData.Version",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1,capture:"version"}].concat(Yk)};var Qte={name:"SignerInfo",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.version",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1},{name:"SignerInfo.issuerAndSerialNumber",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.issuerAndSerialNumber.issuer",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,captureAsn1:"issuer"},{name:"SignerInfo.issuerAndSerialNumber.serialNumber",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1,capture:"serial"}]},{name:"SignerInfo.digestAlgorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"SignerInfo.digestAlgorithm.algorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OID,constructed:!1,capture:"digestAlgorithm"},{name:"SignerInfo.digestAlgorithm.parameter",tagClass:xe.Class.UNIVERSAL,constructed:!1,captureAsn1:"digestParameter",optional:!0}]},{name:"SignerInfo.authenticatedAttributes",tagClass:xe.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,capture:"authenticatedAttributes"},{name:"SignerInfo.digestEncryptionAlgorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,capture:"signatureAlgorithm"},{name:"SignerInfo.encryptedDigest",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OCTETSTRING,constructed:!1,capture:"signature"},{name:"SignerInfo.unauthenticatedAttributes",tagClass:xe.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,optional:!0,capture:"unauthenticatedAttributes"}]};Po.signedDataValidator={name:"SignedData",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"SignedData.Version",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1,capture:"version"},{name:"SignedData.DigestAlgorithms",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SET,constructed:!0,captureAsn1:"digestAlgorithms"},zk,{name:"SignedData.Certificates",tagClass:xe.Class.CONTEXT_SPECIFIC,type:0,optional:!0,captureAsn1:"certificates"},{name:"SignedData.CertificateRevocationLists",tagClass:xe.Class.CONTEXT_SPECIFIC,type:1,optional:!0,captureAsn1:"crls"},{name:"SignedData.SignerInfos",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SET,capture:"signerInfos",optional:!0,value:[Qte]}]};Po.recipientInfoValidator={name:"RecipientInfo",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.version",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1,capture:"version"},{name:"RecipientInfo.issuerAndSerial",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.issuerAndSerial.issuer",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,captureAsn1:"issuer"},{name:"RecipientInfo.issuerAndSerial.serialNumber",tagClass:xe.Class.UNIVERSAL,type:xe.Type.INTEGER,constructed:!1,capture:"serial"}]},{name:"RecipientInfo.keyEncryptionAlgorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.SEQUENCE,constructed:!0,value:[{name:"RecipientInfo.keyEncryptionAlgorithm.algorithm",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OID,constructed:!1,capture:"encAlgorithm"},{name:"RecipientInfo.keyEncryptionAlgorithm.parameter",tagClass:xe.Class.UNIVERSAL,constructed:!1,captureAsn1:"encParameter",optional:!0}]},{name:"RecipientInfo.encryptedKey",tagClass:xe.Class.UNIVERSAL,type:xe.Type.OCTETSTRING,constructed:!1,capture:"encKey"}]};});var kv=I((vhe,Xk)=>{var ba=rt();_t();ba.mgf=ba.mgf||{};var Xte=Xk.exports=ba.mgf.mgf1=ba.mgf1=ba.mgf1||{};Xte.create=function(e){var t={generate:function(r,n){for(var i=new ba.util.ByteBuffer,s=Math.ceil(n/e.digestLength),a=0;a<s;a++){var o=new ba.util.ByteBuffer;o.putInt32(a),e.start(),e.update(r+o.getBytes()),i.putBuffer(e.digest());}return i.truncate(i.length()-n),i.getBytes()}};return t};});var Jk=I((_he,Zk)=>{var Fd=rt();kv();Zk.exports=Fd.mgf=Fd.mgf||{};Fd.mgf.mgf1=Fd.mgf1;});var qd=I((bhe,eL)=>{var Sa=rt();Fn();_t();var Zte=eL.exports=Sa.pss=Sa.pss||{};Zte.create=function(e){arguments.length===3&&(e={md:arguments[0],mgf:arguments[1],saltLength:arguments[2]});var t=e.md,r=e.mgf,n=t.digestLength,i=e.salt||null;typeof i=="string"&&(i=Sa.util.createBuffer(i));var s;if("saltLength"in e)s=e.saltLength;else if(i!==null)s=i.length();else throw new Error("Salt length not specified or specific salt not given.");if(i!==null&&i.length()!==s)throw new Error("Given salt length does not match length of given salt.");var a=e.prng||Sa.random,o={};return o.encode=function(c,l){var u,f=l-1,h=Math.ceil(f/8),p=c.digest().getBytes();if(h<n+s+2)throw new Error("Message is too long to encrypt.");var g;i===null?g=a.getBytesSync(s):g=i.bytes();var _=new Sa.util.ByteBuffer;_.fillWithByte(0,8),_.putBytes(p),_.putBytes(g),t.start(),t.update(_.getBytes());var E=t.digest().getBytes(),w=new Sa.util.ByteBuffer;w.fillWithByte(0,h-s-n-2),w.putByte(1),w.putBytes(g);var y=w.getBytes(),b=h-n-1,N=r.generate(E,b),L="";for(u=0;u<b;u++)L+=String.fromCharCode(y.charCodeAt(u)^N.charCodeAt(u));var V=65280>>8*h-f&255;return L=String.fromCharCode(L.charCodeAt(0)&~V)+L.substr(1),L+E+"\xBC"},o.verify=function(c,l,u){var f,h=u-1,p=Math.ceil(h/8);if(l=l.substr(-p),p<n+s+2)throw new Error("Inconsistent parameters to PSS signature verification.");if(l.charCodeAt(p-1)!==188)throw new Error("Encoded message does not end in 0xBC.");var g=p-n-1,_=l.substr(0,g),E=l.substr(g,n),w=65280>>8*p-h&255;if(_.charCodeAt(0)&w)throw new Error("Bits beyond keysize not zero as expected.");var y=r.generate(E,g),b="";for(f=0;f<g;f++)b+=String.fromCharCode(_.charCodeAt(f)^y.charCodeAt(f));b=String.fromCharCode(b.charCodeAt(0)&~w)+b.substr(1);var N=p-n-s-2;for(f=0;f<N;f++)if(b.charCodeAt(f)!==0)throw new Error("Leftmost octets not zero as expected");if(b.charCodeAt(N)!==1)throw new Error("Inconsistent PSS signature, 0x01 marker not found");var L=b.substr(-s),V=new Sa.util.ByteBuffer;V.fillWithByte(0,8),V.putBytes(c),V.putBytes(L),t.start(),t.update(V.getBytes());var Z=t.digest().getBytes();return E===Z},o};});var $d=I((She,sL)=>{var $e=rt();bs();ai();bc();bi();Jk();Ss();ma();qd();wc();_t();var T=$e.asn1,be=sL.exports=$e.pki=$e.pki||{},yt=be.oids,tr={};tr.CN=yt.commonName;tr.commonName="CN";tr.C=yt.countryName;tr.countryName="C";tr.L=yt.localityName;tr.localityName="L";tr.ST=yt.stateOrProvinceName;tr.stateOrProvinceName="ST";tr.O=yt.organizationName;tr.organizationName="O";tr.OU=yt.organizationalUnitName;tr.organizationalUnitName="OU";tr.E=yt.emailAddress;tr.emailAddress="E";var rL=$e.pki.rsa.publicKeyValidator,Jte={name:"Certificate",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,captureAsn1:"tbsCertificate",value:[{name:"Certificate.TBSCertificate.version",tagClass:T.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.version.integer",tagClass:T.Class.UNIVERSAL,type:T.Type.INTEGER,constructed:!1,capture:"certVersion"}]},{name:"Certificate.TBSCertificate.serialNumber",tagClass:T.Class.UNIVERSAL,type:T.Type.INTEGER,constructed:!1,capture:"certSerialNumber"},{name:"Certificate.TBSCertificate.signature",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate.signature.algorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1,capture:"certinfoSignatureOid"},{name:"Certificate.TBSCertificate.signature.parameters",tagClass:T.Class.UNIVERSAL,optional:!0,captureAsn1:"certinfoSignatureParams"}]},{name:"Certificate.TBSCertificate.issuer",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,captureAsn1:"certIssuer"},{name:"Certificate.TBSCertificate.validity",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.TBSCertificate.validity.notBefore (utc)",tagClass:T.Class.UNIVERSAL,type:T.Type.UTCTIME,constructed:!1,optional:!0,capture:"certValidity1UTCTime"},{name:"Certificate.TBSCertificate.validity.notBefore (generalized)",tagClass:T.Class.UNIVERSAL,type:T.Type.GENERALIZEDTIME,constructed:!1,optional:!0,capture:"certValidity2GeneralizedTime"},{name:"Certificate.TBSCertificate.validity.notAfter (utc)",tagClass:T.Class.UNIVERSAL,type:T.Type.UTCTIME,constructed:!1,optional:!0,capture:"certValidity3UTCTime"},{name:"Certificate.TBSCertificate.validity.notAfter (generalized)",tagClass:T.Class.UNIVERSAL,type:T.Type.GENERALIZEDTIME,constructed:!1,optional:!0,capture:"certValidity4GeneralizedTime"}]},{name:"Certificate.TBSCertificate.subject",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,captureAsn1:"certSubject"},rL,{name:"Certificate.TBSCertificate.issuerUniqueID",tagClass:T.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.issuerUniqueID.id",tagClass:T.Class.UNIVERSAL,type:T.Type.BITSTRING,constructed:!1,captureBitStringValue:"certIssuerUniqueId"}]},{name:"Certificate.TBSCertificate.subjectUniqueID",tagClass:T.Class.CONTEXT_SPECIFIC,type:2,constructed:!0,optional:!0,value:[{name:"Certificate.TBSCertificate.subjectUniqueID.id",tagClass:T.Class.UNIVERSAL,type:T.Type.BITSTRING,constructed:!1,captureBitStringValue:"certSubjectUniqueId"}]},{name:"Certificate.TBSCertificate.extensions",tagClass:T.Class.CONTEXT_SPECIFIC,type:3,constructed:!0,captureAsn1:"certExtensions",optional:!0}]},{name:"Certificate.signatureAlgorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"Certificate.signatureAlgorithm.algorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1,capture:"certSignatureOid"},{name:"Certificate.TBSCertificate.signature.parameters",tagClass:T.Class.UNIVERSAL,optional:!0,captureAsn1:"certSignatureParams"}]},{name:"Certificate.signatureValue",tagClass:T.Class.UNIVERSAL,type:T.Type.BITSTRING,constructed:!1,captureBitStringValue:"certSignature"}]},ere={name:"rsapss",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"rsapss.hashAlgorithm",tagClass:T.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,value:[{name:"rsapss.hashAlgorithm.AlgorithmIdentifier",tagClass:T.Class.UNIVERSAL,type:T.Class.SEQUENCE,constructed:!0,optional:!0,value:[{name:"rsapss.hashAlgorithm.AlgorithmIdentifier.algorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1,capture:"hashOid"}]}]},{name:"rsapss.maskGenAlgorithm",tagClass:T.Class.CONTEXT_SPECIFIC,type:1,constructed:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier",tagClass:T.Class.UNIVERSAL,type:T.Class.SEQUENCE,constructed:!0,optional:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.algorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1,capture:"maskGenOid"},{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.params",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"rsapss.maskGenAlgorithm.AlgorithmIdentifier.params.algorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1,capture:"maskGenHashOid"}]}]}]},{name:"rsapss.saltLength",tagClass:T.Class.CONTEXT_SPECIFIC,type:2,optional:!0,value:[{name:"rsapss.saltLength.saltLength",tagClass:T.Class.UNIVERSAL,type:T.Class.INTEGER,constructed:!1,capture:"saltLength"}]},{name:"rsapss.trailerField",tagClass:T.Class.CONTEXT_SPECIFIC,type:3,optional:!0,value:[{name:"rsapss.trailer.trailer",tagClass:T.Class.UNIVERSAL,type:T.Class.INTEGER,constructed:!1,capture:"trailer"}]}]},tre={name:"CertificationRequestInfo",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,captureAsn1:"certificationRequestInfo",value:[{name:"CertificationRequestInfo.integer",tagClass:T.Class.UNIVERSAL,type:T.Type.INTEGER,constructed:!1,capture:"certificationRequestInfoVersion"},{name:"CertificationRequestInfo.subject",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,captureAsn1:"certificationRequestInfoSubject"},rL,{name:"CertificationRequestInfo.attributes",tagClass:T.Class.CONTEXT_SPECIFIC,type:0,constructed:!0,optional:!0,capture:"certificationRequestInfoAttributes",value:[{name:"CertificationRequestInfo.attributes",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"CertificationRequestInfo.attributes.type",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1},{name:"CertificationRequestInfo.attributes.value",tagClass:T.Class.UNIVERSAL,type:T.Type.SET,constructed:!0}]}]}]},rre={name:"CertificationRequest",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,captureAsn1:"csr",value:[tre,{name:"CertificationRequest.signatureAlgorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.SEQUENCE,constructed:!0,value:[{name:"CertificationRequest.signatureAlgorithm.algorithm",tagClass:T.Class.UNIVERSAL,type:T.Type.OID,constructed:!1,capture:"csrSignatureOid"},{name:"CertificationRequest.signatureAlgorithm.parameters",tagClass:T.Class.UNIVERSAL,optional:!0,captureAsn1:"csrSignatureParams"}]},{name:"CertificationRequest.signature",tagClass:T.Class.UNIVERSAL,type:T.Type.BITSTRING,constructed:!1,captureBitStringValue:"csrSignature"}]};be.RDNAttributesAsArray=function(e,t){for(var r=[],n,i,s,a=0;a<e.value.length;++a){n=e.value[a];for(var o=0;o<n.value.length;++o)s={},i=n.value[o],s.type=T.derToOid(i.value[0].value),s.value=i.value[1].value,s.valueTagClass=i.value[1].type,s.type in yt&&(s.name=yt[s.type],s.name in tr&&(s.shortName=tr[s.name])),t&&(t.update(s.type),t.update(s.value)),r.push(s);}return r};be.CRIAttributesAsArray=function(e){for(var t=[],r=0;r<e.length;++r)for(var n=e[r],i=T.derToOid(n.value[0].value),s=n.value[1].value,a=0;a<s.length;++a){var o={};if(o.type=i,o.value=s[a].value,o.valueTagClass=s[a].type,o.type in yt&&(o.name=yt[o.type],o.name in tr&&(o.shortName=tr[o.name])),o.type===yt.extensionRequest){o.extensions=[];for(var c=0;c<o.value.length;++c)o.extensions.push(be.certificateExtensionFromAsn1(o.value[c]));}t.push(o);}return t};function Cs(e,t){typeof t=="string"&&(t={shortName:t});for(var r=null,n,i=0;r===null&&i<e.attributes.length;++i)n=e.attributes[i],(t.type&&t.type===n.type||t.name&&t.name===n.name||t.shortName&&t.shortName===n.shortName)&&(r=n);return r}var Md=function(e,t,r){var n={};if(e!==yt["RSASSA-PSS"])return n;r&&(n={hash:{algorithmOid:yt.sha1},mgf:{algorithmOid:yt.mgf1,hash:{algorithmOid:yt.sha1}},saltLength:20});var i={},s=[];if(!T.validate(t,ere,i,s)){var a=new Error("Cannot read RSASSA-PSS parameter block.");throw a.errors=s,a}return i.hashOid!==void 0&&(n.hash=n.hash||{},n.hash.algorithmOid=T.derToOid(i.hashOid)),i.maskGenOid!==void 0&&(n.mgf=n.mgf||{},n.mgf.algorithmOid=T.derToOid(i.maskGenOid),n.mgf.hash=n.mgf.hash||{},n.mgf.hash.algorithmOid=T.derToOid(i.maskGenHashOid)),i.saltLength!==void 0&&(n.saltLength=i.saltLength.charCodeAt(0)),n},Ud=function(e){switch(yt[e.signatureOid]){case"sha1WithRSAEncryption":case"sha1WithRSASignature":return $e.md.sha1.create();case"md5WithRSAEncryption":return $e.md.md5.create();case"sha256WithRSAEncryption":return $e.md.sha256.create();case"sha384WithRSAEncryption":return $e.md.sha384.create();case"sha512WithRSAEncryption":return $e.md.sha512.create();case"RSASSA-PSS":return $e.md.sha256.create();default:var t=new Error("Could not compute "+e.type+" digest. Unknown signature OID.");throw t.signatureOid=e.signatureOid,t}},nL=function(e){var t=e.certificate,r;switch(t.signatureOid){case yt.sha1WithRSAEncryption:case yt.sha1WithRSASignature:break;case yt["RSASSA-PSS"]:var n,i;if(n=yt[t.signatureParameters.mgf.hash.algorithmOid],n===void 0||$e.md[n]===void 0){var s=new Error("Unsupported MGF hash function.");throw s.oid=t.signatureParameters.mgf.hash.algorithmOid,s.name=n,s}if(i=yt[t.signatureParameters.mgf.algorithmOid],i===void 0||$e.mgf[i]===void 0){var s=new Error("Unsupported MGF function.");throw s.oid=t.signatureParameters.mgf.algorithmOid,s.name=i,s}if(i=$e.mgf[i].create($e.md[n].create()),n=yt[t.signatureParameters.hash.algorithmOid],n===void 0||$e.md[n]===void 0){var s=new Error("Unsupported RSASSA-PSS hash function.");throw s.oid=t.signatureParameters.hash.algorithmOid,s.name=n,s}r=$e.pss.create($e.md[n].create(),i,t.signatureParameters.saltLength);break}return t.publicKey.verify(e.md.digest().getBytes(),e.signature,r)};be.certificateFromPem=function(e,t,r){var n=$e.pem.decode(e)[0];if(n.type!=="CERTIFICATE"&&n.type!=="X509 CERTIFICATE"&&n.type!=="TRUSTED CERTIFICATE"){var i=new Error('Could not convert certificate from PEM; PEM header type is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');throw i.headerType=n.type,i}if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert certificate from PEM; PEM is encrypted.");var s=T.fromDer(n.body,r);return be.certificateFromAsn1(s,t)};be.certificateToPem=function(e,t){var r={type:"CERTIFICATE",body:T.toDer(be.certificateToAsn1(e)).getBytes()};return $e.pem.encode(r,{maxline:t})};be.publicKeyFromPem=function(e){var t=$e.pem.decode(e)[0];if(t.type!=="PUBLIC KEY"&&t.type!=="RSA PUBLIC KEY"){var r=new Error('Could not convert public key from PEM; PEM header type is not "PUBLIC KEY" or "RSA PUBLIC KEY".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert public key from PEM; PEM is encrypted.");var n=T.fromDer(t.body);return be.publicKeyFromAsn1(n)};be.publicKeyToPem=function(e,t){var r={type:"PUBLIC KEY",body:T.toDer(be.publicKeyToAsn1(e)).getBytes()};return $e.pem.encode(r,{maxline:t})};be.publicKeyToRSAPublicKeyPem=function(e,t){var r={type:"RSA PUBLIC KEY",body:T.toDer(be.publicKeyToRSAPublicKey(e)).getBytes()};return $e.pem.encode(r,{maxline:t})};be.getPublicKeyFingerprint=function(e,t){t=t||{};var r=t.md||$e.md.sha1.create(),n=t.type||"RSAPublicKey",i;switch(n){case"RSAPublicKey":i=T.toDer(be.publicKeyToRSAPublicKey(e)).getBytes();break;case"SubjectPublicKeyInfo":i=T.toDer(be.publicKeyToAsn1(e)).getBytes();break;default:throw new Error('Unknown fingerprint type "'+t.type+'".')}r.start(),r.update(i);var s=r.digest();if(t.encoding==="hex"){var a=s.toHex();return t.delimiter?a.match(/.{2}/g).join(t.delimiter):a}else {if(t.encoding==="binary")return s.getBytes();if(t.encoding)throw new Error('Unknown encoding "'+t.encoding+'".')}return s};be.certificationRequestFromPem=function(e,t,r){var n=$e.pem.decode(e)[0];if(n.type!=="CERTIFICATE REQUEST"){var i=new Error('Could not convert certification request from PEM; PEM header type is not "CERTIFICATE REQUEST".');throw i.headerType=n.type,i}if(n.procType&&n.procType.type==="ENCRYPTED")throw new Error("Could not convert certification request from PEM; PEM is encrypted.");var s=T.fromDer(n.body,r);return be.certificationRequestFromAsn1(s,t)};be.certificationRequestToPem=function(e,t){var r={type:"CERTIFICATE REQUEST",body:T.toDer(be.certificationRequestToAsn1(e)).getBytes()};return $e.pem.encode(r,{maxline:t})};be.createCertificate=function(){var e={};return e.version=2,e.serialNumber="00",e.signatureOid=null,e.signature=null,e.siginfo={},e.siginfo.algorithmOid=null,e.validity={},e.validity.notBefore=new Date,e.validity.notAfter=new Date,e.issuer={},e.issuer.getField=function(t){return Cs(e.issuer,t)},e.issuer.addField=function(t){Un([t]),e.issuer.attributes.push(t);},e.issuer.attributes=[],e.issuer.hash=null,e.subject={},e.subject.getField=function(t){return Cs(e.subject,t)},e.subject.addField=function(t){Un([t]),e.subject.attributes.push(t);},e.subject.attributes=[],e.subject.hash=null,e.extensions=[],e.publicKey=null,e.md=null,e.setSubject=function(t,r){Un(t),e.subject.attributes=t,delete e.subject.uniqueId,r&&(e.subject.uniqueId=r),e.subject.hash=null;},e.setIssuer=function(t,r){Un(t),e.issuer.attributes=t,delete e.issuer.uniqueId,r&&(e.issuer.uniqueId=r),e.issuer.hash=null;},e.setExtensions=function(t){for(var r=0;r<t.length;++r)iL(t[r],{cert:e});e.extensions=t;},e.getExtension=function(t){typeof t=="string"&&(t={name:t});for(var r=null,n,i=0;r===null&&i<e.extensions.length;++i)n=e.extensions[i],(t.id&&n.id===t.id||t.name&&n.name===t.name)&&(r=n);return r},e.sign=function(t,r){e.md=r||$e.md.sha1.create();var n=yt[e.md.algorithm+"WithRSAEncryption"];if(!n){var i=new Error("Could not compute certificate digest. Unknown message digest algorithm OID.");throw i.algorithm=e.md.algorithm,i}e.signatureOid=e.siginfo.algorithmOid=n,e.tbsCertificate=be.getTBSCertificate(e);var s=T.toDer(e.tbsCertificate);e.md.update(s.getBytes()),e.signature=t.sign(e.md);},e.verify=function(t){var r=!1;if(!e.issued(t)){var n=t.issuer,i=e.subject,s=new Error("The parent certificate did not issue the given child certificate; the child certificate's issuer does not match the parent's subject.");throw s.expectedIssuer=i.attributes,s.actualIssuer=n.attributes,s}var a=t.md;if(a===null){a=Ud({signatureOid:t.signatureOid,type:"certificate"});var o=t.tbsCertificate||be.getTBSCertificate(t),c=T.toDer(o);a.update(c.getBytes());}return a!==null&&(r=nL({certificate:e,md:a,signature:t.signature})),r},e.isIssuer=function(t){var r=!1,n=e.issuer,i=t.subject;if(n.hash&&i.hash)r=n.hash===i.hash;else if(n.attributes.length===i.attributes.length){r=!0;for(var s,a,o=0;r&&o<n.attributes.length;++o)s=n.attributes[o],a=i.attributes[o],(s.type!==a.type||s.value!==a.value)&&(r=!1);}return r},e.issued=function(t){return t.isIssuer(e)},e.generateSubjectKeyIdentifier=function(){return be.getPublicKeyFingerprint(e.publicKey,{type:"RSAPublicKey"})},e.verifySubjectKeyIdentifier=function(){for(var t=yt.subjectKeyIdentifier,r=0;r<e.extensions.length;++r){var n=e.extensions[r];if(n.id===t){var i=e.generateSubjectKeyIdentifier().getBytes();return $e.util.hexToBytes(n.subjectKeyIdentifier)===i}}return !1},e};be.certificateFromAsn1=function(e,t){var r={},n=[];if(!T.validate(e,Jte,r,n)){var i=new Error("Cannot read X.509 certificate. ASN.1 object is not an X509v3 Certificate.");throw i.errors=n,i}var s=T.derToOid(r.publicKeyOid);if(s!==be.oids.rsaEncryption)throw new Error("Cannot read public key. OID is not RSA.");var a=be.createCertificate();a.version=r.certVersion?r.certVersion.charCodeAt(0):0;var o=$e.util.createBuffer(r.certSerialNumber);a.serialNumber=o.toHex(),a.signatureOid=$e.asn1.derToOid(r.certSignatureOid),a.signatureParameters=Md(a.signatureOid,r.certSignatureParams,!0),a.siginfo.algorithmOid=$e.asn1.derToOid(r.certinfoSignatureOid),a.siginfo.parameters=Md(a.siginfo.algorithmOid,r.certinfoSignatureParams,!1),a.signature=r.certSignature;var c=[];if(r.certValidity1UTCTime!==void 0&&c.push(T.utcTimeToDate(r.certValidity1UTCTime)),r.certValidity2GeneralizedTime!==void 0&&c.push(T.generalizedTimeToDate(r.certValidity2GeneralizedTime)),r.certValidity3UTCTime!==void 0&&c.push(T.utcTimeToDate(r.certValidity3UTCTime)),r.certValidity4GeneralizedTime!==void 0&&c.push(T.generalizedTimeToDate(r.certValidity4GeneralizedTime)),c.length>2)throw new Error("Cannot read notBefore/notAfter validity times; more than two times were provided in the certificate.");if(c.length<2)throw new Error("Cannot read notBefore/notAfter validity times; they were not provided as either UTCTime or GeneralizedTime.");if(a.validity.notBefore=c[0],a.validity.notAfter=c[1],a.tbsCertificate=r.tbsCertificate,t){a.md=Ud({signatureOid:a.signatureOid,type:"certificate"});var l=T.toDer(a.tbsCertificate);a.md.update(l.getBytes());}var u=$e.md.sha1.create(),f=T.toDer(r.certIssuer);u.update(f.getBytes()),a.issuer.getField=function(g){return Cs(a.issuer,g)},a.issuer.addField=function(g){Un([g]),a.issuer.attributes.push(g);},a.issuer.attributes=be.RDNAttributesAsArray(r.certIssuer),r.certIssuerUniqueId&&(a.issuer.uniqueId=r.certIssuerUniqueId),a.issuer.hash=u.digest().toHex();var h=$e.md.sha1.create(),p=T.toDer(r.certSubject);return h.update(p.getBytes()),a.subject.getField=function(g){return Cs(a.subject,g)},a.subject.addField=function(g){Un([g]),a.subject.attributes.push(g);},a.subject.attributes=be.RDNAttributesAsArray(r.certSubject),r.certSubjectUniqueId&&(a.subject.uniqueId=r.certSubjectUniqueId),a.subject.hash=h.digest().toHex(),r.certExtensions?a.extensions=be.certificateExtensionsFromAsn1(r.certExtensions):a.extensions=[],a.publicKey=be.publicKeyFromAsn1(r.subjectPublicKeyInfo),a};be.certificateExtensionsFromAsn1=function(e){for(var t=[],r=0;r<e.value.length;++r)for(var n=e.value[r],i=0;i<n.value.length;++i)t.push(be.certificateExtensionFromAsn1(n.value[i]));return t};be.certificateExtensionFromAsn1=function(e){var t={};if(t.id=T.derToOid(e.value[0].value),t.critical=!1,e.value[1].type===T.Type.BOOLEAN?(t.critical=e.value[1].value.charCodeAt(0)!==0,t.value=e.value[2].value):t.value=e.value[1].value,t.id in yt){if(t.name=yt[t.id],t.name==="keyUsage"){var r=T.fromDer(t.value),n=0,i=0;r.value.length>1&&(n=r.value.charCodeAt(1),i=r.value.length>2?r.value.charCodeAt(2):0),t.digitalSignature=(n&128)===128,t.nonRepudiation=(n&64)===64,t.keyEncipherment=(n&32)===32,t.dataEncipherment=(n&16)===16,t.keyAgreement=(n&8)===8,t.keyCertSign=(n&4)===4,t.cRLSign=(n&2)===2,t.encipherOnly=(n&1)===1,t.decipherOnly=(i&128)===128;}else if(t.name==="basicConstraints"){var r=T.fromDer(t.value);r.value.length>0&&r.value[0].type===T.Type.BOOLEAN?t.cA=r.value[0].value.charCodeAt(0)!==0:t.cA=!1;var s=null;r.value.length>0&&r.value[0].type===T.Type.INTEGER?s=r.value[0].value:r.value.length>1&&(s=r.value[1].value),s!==null&&(t.pathLenConstraint=T.derToInteger(s));}else if(t.name==="extKeyUsage")for(var r=T.fromDer(t.value),a=0;a<r.value.length;++a){var o=T.derToOid(r.value[a].value);o in yt?t[yt[o]]=!0:t[o]=!0;}else if(t.name==="nsCertType"){var r=T.fromDer(t.value),n=0;r.value.length>1&&(n=r.value.charCodeAt(1)),t.client=(n&128)===128,t.server=(n&64)===64,t.email=(n&32)===32,t.objsign=(n&16)===16,t.reserved=(n&8)===8,t.sslCA=(n&4)===4,t.emailCA=(n&2)===2,t.objCA=(n&1)===1;}else if(t.name==="subjectAltName"||t.name==="issuerAltName"){t.altNames=[];for(var c,r=T.fromDer(t.value),l=0;l<r.value.length;++l){c=r.value[l];var u={type:c.type,value:c.value};switch(t.altNames.push(u),c.type){case 1:case 2:case 6:break;case 7:u.ip=$e.util.bytesToIP(c.value);break;case 8:u.oid=T.derToOid(c.value);break;}}}else if(t.name==="subjectKeyIdentifier"){var r=T.fromDer(t.value);t.subjectKeyIdentifier=$e.util.bytesToHex(r.value);}}return t};be.certificationRequestFromAsn1=function(e,t){var r={},n=[];if(!T.validate(e,rre,r,n)){var i=new Error("Cannot read PKCS#10 certificate request. ASN.1 object is not a PKCS#10 CertificationRequest.");throw i.errors=n,i}var s=T.derToOid(r.publicKeyOid);if(s!==be.oids.rsaEncryption)throw new Error("Cannot read public key. OID is not RSA.");var a=be.createCertificationRequest();if(a.version=r.csrVersion?r.csrVersion.charCodeAt(0):0,a.signatureOid=$e.asn1.derToOid(r.csrSignatureOid),a.signatureParameters=Md(a.signatureOid,r.csrSignatureParams,!0),a.siginfo.algorithmOid=$e.asn1.derToOid(r.csrSignatureOid),a.siginfo.parameters=Md(a.siginfo.algorithmOid,r.csrSignatureParams,!1),a.signature=r.csrSignature,a.certificationRequestInfo=r.certificationRequestInfo,t){a.md=Ud({signatureOid:a.signatureOid,type:"certification request"});var o=T.toDer(a.certificationRequestInfo);a.md.update(o.getBytes());}var c=$e.md.sha1.create();return a.subject.getField=function(l){return Cs(a.subject,l)},a.subject.addField=function(l){Un([l]),a.subject.attributes.push(l);},a.subject.attributes=be.RDNAttributesAsArray(r.certificationRequestInfoSubject,c),a.subject.hash=c.digest().toHex(),a.publicKey=be.publicKeyFromAsn1(r.subjectPublicKeyInfo),a.getAttribute=function(l){return Cs(a,l)},a.addAttribute=function(l){Un([l]),a.attributes.push(l);},a.attributes=be.CRIAttributesAsArray(r.certificationRequestInfoAttributes||[]),a};be.createCertificationRequest=function(){var e={};return e.version=0,e.signatureOid=null,e.signature=null,e.siginfo={},e.siginfo.algorithmOid=null,e.subject={},e.subject.getField=function(t){return Cs(e.subject,t)},e.subject.addField=function(t){Un([t]),e.subject.attributes.push(t);},e.subject.attributes=[],e.subject.hash=null,e.publicKey=null,e.attributes=[],e.getAttribute=function(t){return Cs(e,t)},e.addAttribute=function(t){Un([t]),e.attributes.push(t);},e.md=null,e.setSubject=function(t){Un(t),e.subject.attributes=t,e.subject.hash=null;},e.setAttributes=function(t){Un(t),e.attributes=t;},e.sign=function(t,r){e.md=r||$e.md.sha1.create();var n=yt[e.md.algorithm+"WithRSAEncryption"];if(!n){var i=new Error("Could not compute certification request digest. Unknown message digest algorithm OID.");throw i.algorithm=e.md.algorithm,i}e.signatureOid=e.siginfo.algorithmOid=n,e.certificationRequestInfo=be.getCertificationRequestInfo(e);var s=T.toDer(e.certificationRequestInfo);e.md.update(s.getBytes()),e.signature=t.sign(e.md);},e.verify=function(){var t=!1,r=e.md;if(r===null){r=Ud({signatureOid:e.signatureOid,type:"certification request"});var n=e.certificationRequestInfo||be.getCertificationRequestInfo(e),i=T.toDer(n);r.update(i.getBytes());}return r!==null&&(t=nL({certificate:e,md:r,signature:e.signature})),t},e};function No(e){for(var t=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]),r,n,i=e.attributes,s=0;s<i.length;++s){r=i[s];var a=r.value,o=T.Type.PRINTABLESTRING;"valueTagClass"in r&&(o=r.valueTagClass,o===T.Type.UTF8&&(a=$e.util.encodeUtf8(a))),n=T.create(T.Class.UNIVERSAL,T.Type.SET,!0,[T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(r.type).getBytes()),T.create(T.Class.UNIVERSAL,o,!1,a)])]),t.value.push(n);}return t}function Un(e){for(var t,r=0;r<e.length;++r){if(t=e[r],typeof t.name>"u"&&(t.type&&t.type in be.oids?t.name=be.oids[t.type]:t.shortName&&t.shortName in tr&&(t.name=be.oids[tr[t.shortName]])),typeof t.type>"u")if(t.name&&t.name in be.oids)t.type=be.oids[t.name];else {var n=new Error("Attribute type not specified.");throw n.attribute=t,n}if(typeof t.shortName>"u"&&t.name&&t.name in tr&&(t.shortName=tr[t.name]),t.type===yt.extensionRequest&&(t.valueConstructed=!0,t.valueTagClass=T.Type.SEQUENCE,!t.value&&t.extensions)){t.value=[];for(var i=0;i<t.extensions.length;++i)t.value.push(be.certificateExtensionToAsn1(iL(t.extensions[i])));}if(typeof t.value>"u"){var n=new Error("Attribute value not specified.");throw n.attribute=t,n}}}function iL(e,t){if(t=t||{},typeof e.name>"u"&&e.id&&e.id in be.oids&&(e.name=be.oids[e.id]),typeof e.id>"u")if(e.name&&e.name in be.oids)e.id=be.oids[e.name];else {var r=new Error("Extension ID not specified.");throw r.extension=e,r}if(typeof e.value<"u")return e;if(e.name==="keyUsage"){var n=0,i=0,s=0;e.digitalSignature&&(i|=128,n=7),e.nonRepudiation&&(i|=64,n=6),e.keyEncipherment&&(i|=32,n=5),e.dataEncipherment&&(i|=16,n=4),e.keyAgreement&&(i|=8,n=3),e.keyCertSign&&(i|=4,n=2),e.cRLSign&&(i|=2,n=1),e.encipherOnly&&(i|=1,n=0),e.decipherOnly&&(s|=128,n=7);var a=String.fromCharCode(n);s!==0?a+=String.fromCharCode(i)+String.fromCharCode(s):i!==0&&(a+=String.fromCharCode(i)),e.value=T.create(T.Class.UNIVERSAL,T.Type.BITSTRING,!1,a);}else if(e.name==="basicConstraints")e.value=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]),e.cA&&e.value.value.push(T.create(T.Class.UNIVERSAL,T.Type.BOOLEAN,!1,"\xFF")),"pathLenConstraint"in e&&e.value.value.push(T.create(T.Class.UNIVERSAL,T.Type.INTEGER,!1,T.integerToDer(e.pathLenConstraint).getBytes()));else if(e.name==="extKeyUsage"){e.value=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]);var o=e.value.value;for(var c in e)e[c]===!0&&(c in yt?o.push(T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(yt[c]).getBytes())):c.indexOf(".")!==-1&&o.push(T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(c).getBytes())));}else if(e.name==="nsCertType"){var n=0,i=0;e.client&&(i|=128,n=7),e.server&&(i|=64,n=6),e.email&&(i|=32,n=5),e.objsign&&(i|=16,n=4),e.reserved&&(i|=8,n=3),e.sslCA&&(i|=4,n=2),e.emailCA&&(i|=2,n=1),e.objCA&&(i|=1,n=0);var a=String.fromCharCode(n);i!==0&&(a+=String.fromCharCode(i)),e.value=T.create(T.Class.UNIVERSAL,T.Type.BITSTRING,!1,a);}else if(e.name==="subjectAltName"||e.name==="issuerAltName"){e.value=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]);for(var l,u=0;u<e.altNames.length;++u){l=e.altNames[u];var a=l.value;if(l.type===7&&l.ip){if(a=$e.util.bytesFromIP(l.ip),a===null){var r=new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');throw r.extension=e,r}}else l.type===8&&(l.oid?a=T.oidToDer(T.oidToDer(l.oid)):a=T.oidToDer(a));e.value.value.push(T.create(T.Class.CONTEXT_SPECIFIC,l.type,!1,a));}}else if(e.name==="nsComment"&&t.cert){if(!/^[\x00-\x7F]*$/.test(e.comment)||e.comment.length<1||e.comment.length>128)throw new Error('Invalid "nsComment" content.');e.value=T.create(T.Class.UNIVERSAL,T.Type.IA5STRING,!1,e.comment);}else if(e.name==="subjectKeyIdentifier"&&t.cert){var f=t.cert.generateSubjectKeyIdentifier();e.subjectKeyIdentifier=f.toHex(),e.value=T.create(T.Class.UNIVERSAL,T.Type.OCTETSTRING,!1,f.getBytes());}else if(e.name==="authorityKeyIdentifier"&&t.cert){e.value=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]);var o=e.value.value;if(e.keyIdentifier){var h=e.keyIdentifier===!0?t.cert.generateSubjectKeyIdentifier().getBytes():e.keyIdentifier;o.push(T.create(T.Class.CONTEXT_SPECIFIC,0,!1,h));}if(e.authorityCertIssuer){var p=[T.create(T.Class.CONTEXT_SPECIFIC,4,!0,[No(e.authorityCertIssuer===!0?t.cert.issuer:e.authorityCertIssuer)])];o.push(T.create(T.Class.CONTEXT_SPECIFIC,1,!0,p));}if(e.serialNumber){var g=$e.util.hexToBytes(e.serialNumber===!0?t.cert.serialNumber:e.serialNumber);o.push(T.create(T.Class.CONTEXT_SPECIFIC,2,!1,g));}}else if(e.name==="cRLDistributionPoints"){e.value=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]);for(var o=e.value.value,_=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]),E=T.create(T.Class.CONTEXT_SPECIFIC,0,!0,[]),l,u=0;u<e.altNames.length;++u){l=e.altNames[u];var a=l.value;if(l.type===7&&l.ip){if(a=$e.util.bytesFromIP(l.ip),a===null){var r=new Error('Extension "ip" value is not a valid IPv4 or IPv6 address.');throw r.extension=e,r}}else l.type===8&&(l.oid?a=T.oidToDer(T.oidToDer(l.oid)):a=T.oidToDer(a));E.value.push(T.create(T.Class.CONTEXT_SPECIFIC,l.type,!1,a));}_.value.push(T.create(T.Class.CONTEXT_SPECIFIC,0,!0,[E])),o.push(_);}if(typeof e.value>"u"){var r=new Error("Extension value not specified.");throw r.extension=e,r}return e}function Lv(e,t){switch(e){case yt["RSASSA-PSS"]:var r=[];return t.hash.algorithmOid!==void 0&&r.push(T.create(T.Class.CONTEXT_SPECIFIC,0,!0,[T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(t.hash.algorithmOid).getBytes()),T.create(T.Class.UNIVERSAL,T.Type.NULL,!1,"")])])),t.mgf.algorithmOid!==void 0&&r.push(T.create(T.Class.CONTEXT_SPECIFIC,1,!0,[T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(t.mgf.algorithmOid).getBytes()),T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(t.mgf.hash.algorithmOid).getBytes()),T.create(T.Class.UNIVERSAL,T.Type.NULL,!1,"")])])])),t.saltLength!==void 0&&r.push(T.create(T.Class.CONTEXT_SPECIFIC,2,!0,[T.create(T.Class.UNIVERSAL,T.Type.INTEGER,!1,T.integerToDer(t.saltLength).getBytes())])),T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,r);default:return T.create(T.Class.UNIVERSAL,T.Type.NULL,!1,"")}}function nre(e){var t=T.create(T.Class.CONTEXT_SPECIFIC,0,!0,[]);if(e.attributes.length===0)return t;for(var r=e.attributes,n=0;n<r.length;++n){var i=r[n],s=i.value,a=T.Type.UTF8;"valueTagClass"in i&&(a=i.valueTagClass),a===T.Type.UTF8&&(s=$e.util.encodeUtf8(s));var o=!1;"valueConstructed"in i&&(o=i.valueConstructed);var c=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(i.type).getBytes()),T.create(T.Class.UNIVERSAL,T.Type.SET,!0,[T.create(T.Class.UNIVERSAL,a,o,s)])]);t.value.push(c);}return t}var ire=new Date("1950-01-01T00:00:00Z"),sre=new Date("2050-01-01T00:00:00Z");function tL(e){return e>=ire&&e<sre?T.create(T.Class.UNIVERSAL,T.Type.UTCTIME,!1,T.dateToUtcTime(e)):T.create(T.Class.UNIVERSAL,T.Type.GENERALIZEDTIME,!1,T.dateToGeneralizedTime(e))}be.getTBSCertificate=function(e){var t=tL(e.validity.notBefore),r=tL(e.validity.notAfter),n=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.CONTEXT_SPECIFIC,0,!0,[T.create(T.Class.UNIVERSAL,T.Type.INTEGER,!1,T.integerToDer(e.version).getBytes())]),T.create(T.Class.UNIVERSAL,T.Type.INTEGER,!1,$e.util.hexToBytes(e.serialNumber)),T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(e.siginfo.algorithmOid).getBytes()),Lv(e.siginfo.algorithmOid,e.siginfo.parameters)]),No(e.issuer),T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[t,r]),No(e.subject),be.publicKeyToAsn1(e.publicKey)]);return e.issuer.uniqueId&&n.value.push(T.create(T.Class.CONTEXT_SPECIFIC,1,!0,[T.create(T.Class.UNIVERSAL,T.Type.BITSTRING,!1,"\0"+e.issuer.uniqueId)])),e.subject.uniqueId&&n.value.push(T.create(T.Class.CONTEXT_SPECIFIC,2,!0,[T.create(T.Class.UNIVERSAL,T.Type.BITSTRING,!1,"\0"+e.subject.uniqueId)])),e.extensions.length>0&&n.value.push(be.certificateExtensionsToAsn1(e.extensions)),n};be.getCertificationRequestInfo=function(e){var t=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.INTEGER,!1,T.integerToDer(e.version).getBytes()),No(e.subject),be.publicKeyToAsn1(e.publicKey),nre(e)]);return t};be.distinguishedNameToAsn1=function(e){return No(e)};be.certificateToAsn1=function(e){var t=e.tbsCertificate||be.getTBSCertificate(e);return T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[t,T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(e.signatureOid).getBytes()),Lv(e.signatureOid,e.signatureParameters)]),T.create(T.Class.UNIVERSAL,T.Type.BITSTRING,!1,"\0"+e.signature)])};be.certificateExtensionsToAsn1=function(e){var t=T.create(T.Class.CONTEXT_SPECIFIC,3,!0,[]),r=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]);t.value.push(r);for(var n=0;n<e.length;++n)r.value.push(be.certificateExtensionToAsn1(e[n]));return t};be.certificateExtensionToAsn1=function(e){var t=T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[]);t.value.push(T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(e.id).getBytes())),e.critical&&t.value.push(T.create(T.Class.UNIVERSAL,T.Type.BOOLEAN,!1,"\xFF"));var r=e.value;return typeof e.value!="string"&&(r=T.toDer(r).getBytes()),t.value.push(T.create(T.Class.UNIVERSAL,T.Type.OCTETSTRING,!1,r)),t};be.certificationRequestToAsn1=function(e){var t=e.certificationRequestInfo||be.getCertificationRequestInfo(e);return T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[t,T.create(T.Class.UNIVERSAL,T.Type.SEQUENCE,!0,[T.create(T.Class.UNIVERSAL,T.Type.OID,!1,T.oidToDer(e.signatureOid).getBytes()),Lv(e.signatureOid,e.signatureParameters)]),T.create(T.Class.UNIVERSAL,T.Type.BITSTRING,!1,"\0"+e.signature)])};be.createCaStore=function(e){var t={certs:{}};t.getIssuer=function(a){var o=r(a.issuer);return o},t.addCertificate=function(a){if(typeof a=="string"&&(a=$e.pki.certificateFromPem(a)),n(a.subject),!t.hasCertificate(a))if(a.subject.hash in t.certs){var o=t.certs[a.subject.hash];$e.util.isArray(o)||(o=[o]),o.push(a),t.certs[a.subject.hash]=o;}else t.certs[a.subject.hash]=a;},t.hasCertificate=function(a){typeof a=="string"&&(a=$e.pki.certificateFromPem(a));var o=r(a.subject);if(!o)return !1;$e.util.isArray(o)||(o=[o]);for(var c=T.toDer(be.certificateToAsn1(a)).getBytes(),l=0;l<o.length;++l){var u=T.toDer(be.certificateToAsn1(o[l])).getBytes();if(c===u)return !0}return !1},t.listAllCertificates=function(){var a=[];for(var o in t.certs)if(t.certs.hasOwnProperty(o)){var c=t.certs[o];if(!$e.util.isArray(c))a.push(c);else for(var l=0;l<c.length;++l)a.push(c[l]);}return a},t.removeCertificate=function(a){var o;if(typeof a=="string"&&(a=$e.pki.certificateFromPem(a)),n(a.subject),!t.hasCertificate(a))return null;var c=r(a.subject);if(!$e.util.isArray(c))return o=t.certs[a.subject.hash],delete t.certs[a.subject.hash],o;for(var l=T.toDer(be.certificateToAsn1(a)).getBytes(),u=0;u<c.length;++u){var f=T.toDer(be.certificateToAsn1(c[u])).getBytes();l===f&&(o=c[u],c.splice(u,1));}return c.length===0&&delete t.certs[a.subject.hash],o};function r(a){return n(a),t.certs[a.hash]||null}function n(a){if(!a.hash){var o=$e.md.sha1.create();a.attributes=be.RDNAttributesAsArray(No(a),o),a.hash=o.digest().toHex();}}if(e)for(var i=0;i<e.length;++i){var s=e[i];t.addCertificate(s);}return t};be.certificateError={bad_certificate:"forge.pki.BadCertificate",unsupported_certificate:"forge.pki.UnsupportedCertificate",certificate_revoked:"forge.pki.CertificateRevoked",certificate_expired:"forge.pki.CertificateExpired",certificate_unknown:"forge.pki.CertificateUnknown",unknown_ca:"forge.pki.UnknownCertificateAuthority"};be.verifyCertificateChain=function(e,t,r){typeof r=="function"&&(r={verify:r}),r=r||{},t=t.slice(0);var n=t.slice(0),i=r.validityCheckDate;typeof i>"u"&&(i=new Date);var s=!0,a=null,o=0;do{var c=t.shift(),l=null,u=!1;if(i&&(i<c.validity.notBefore||i>c.validity.notAfter)&&(a={message:"Certificate is not valid yet or has expired.",error:be.certificateError.certificate_expired,notBefore:c.validity.notBefore,notAfter:c.validity.notAfter,now:i}),a===null){if(l=t[0]||e.getIssuer(c),l===null&&c.isIssuer(c)&&(u=!0,l=c),l){var f=l;$e.util.isArray(f)||(f=[f]);for(var h=!1;!h&&f.length>0;){l=f.shift();try{h=l.verify(c);}catch{}}h||(a={message:"Certificate signature is invalid.",error:be.certificateError.bad_certificate});}a===null&&(!l||u)&&!e.hasCertificate(c)&&(a={message:"Certificate is not trusted.",error:be.certificateError.unknown_ca});}if(a===null&&l&&!c.isIssuer(l)&&(a={message:"Certificate issuer is invalid.",error:be.certificateError.bad_certificate}),a===null)for(var p={keyUsage:!0,basicConstraints:!0},g=0;a===null&&g<c.extensions.length;++g){var _=c.extensions[g];_.critical&&!(_.name in p)&&(a={message:"Certificate has an unsupported critical extension.",error:be.certificateError.unsupported_certificate});}if(a===null&&(!s||t.length===0&&(!l||u))){var E=c.getExtension("basicConstraints"),w=c.getExtension("keyUsage");if(w!==null&&(!w.keyCertSign||E===null)&&(a={message:"Certificate keyUsage or basicConstraints conflict or indicate that the certificate is not a CA. If the certificate is the only one in the chain or isn't the first then the certificate must be a valid CA.",error:be.certificateError.bad_certificate}),a===null&&E!==null&&!E.cA&&(a={message:"Certificate basicConstraints indicates the certificate is not a CA.",error:be.certificateError.bad_certificate}),a===null&&w!==null&&"pathLenConstraint"in E){var y=o-1;y>E.pathLenConstraint&&(a={message:"Certificate basicConstraints pathLenConstraint violated.",error:be.certificateError.bad_certificate});}}var b=a===null?!0:a.error,N=r.verify?r.verify(b,o,n):b;if(N===!0)a=null;else throw b===!0&&(a={message:"The application rejected the certificate.",error:be.certificateError.bad_certificate}),(N||N===0)&&(typeof N=="object"&&!$e.util.isArray(N)?(N.message&&(a.message=N.message),N.error&&(a.error=N.error)):typeof N=="string"&&(a.error=N)),a;s=!1,++o;}while(t.length>0);return !0};});var Fv=I((Ehe,oL)=>{var $t=rt();ai();Co();Ss();Ov();Dv();Fn();wc();Ro();_t();$d();var F=$t.asn1,ut=$t.pki,xc=oL.exports=$t.pkcs12=$t.pkcs12||{},aL={name:"ContentInfo",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"ContentInfo.contentType",tagClass:F.Class.UNIVERSAL,type:F.Type.OID,constructed:!1,capture:"contentType"},{name:"ContentInfo.content",tagClass:F.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"content"}]},are={name:"PFX",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.version",tagClass:F.Class.UNIVERSAL,type:F.Type.INTEGER,constructed:!1,capture:"version"},aL,{name:"PFX.macData",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,optional:!0,captureAsn1:"mac",value:[{name:"PFX.macData.mac",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"PFX.macData.mac.digestAlgorithm.algorithm",tagClass:F.Class.UNIVERSAL,type:F.Type.OID,constructed:!1,capture:"macAlgorithm"},{name:"PFX.macData.mac.digestAlgorithm.parameters",tagClass:F.Class.UNIVERSAL,captureAsn1:"macAlgorithmParameters"}]},{name:"PFX.macData.mac.digest",tagClass:F.Class.UNIVERSAL,type:F.Type.OCTETSTRING,constructed:!1,capture:"macDigest"}]},{name:"PFX.macData.macSalt",tagClass:F.Class.UNIVERSAL,type:F.Type.OCTETSTRING,constructed:!1,capture:"macSalt"},{name:"PFX.macData.iterations",tagClass:F.Class.UNIVERSAL,type:F.Type.INTEGER,constructed:!1,optional:!0,capture:"macIterations"}]}]},ore={name:"SafeBag",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"SafeBag.bagId",tagClass:F.Class.UNIVERSAL,type:F.Type.OID,constructed:!1,capture:"bagId"},{name:"SafeBag.bagValue",tagClass:F.Class.CONTEXT_SPECIFIC,constructed:!0,captureAsn1:"bagValue"},{name:"SafeBag.bagAttributes",tagClass:F.Class.UNIVERSAL,type:F.Type.SET,constructed:!0,optional:!0,capture:"bagAttributes"}]},ure={name:"Attribute",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"Attribute.attrId",tagClass:F.Class.UNIVERSAL,type:F.Type.OID,constructed:!1,capture:"oid"},{name:"Attribute.attrValues",tagClass:F.Class.UNIVERSAL,type:F.Type.SET,constructed:!0,capture:"values"}]},cre={name:"CertBag",tagClass:F.Class.UNIVERSAL,type:F.Type.SEQUENCE,constructed:!0,value:[{name:"CertBag.certId",tagClass:F.Class.UNIVERSAL,type:F.Type.OID,constructed:!1,capture:"certId"},{name:"CertBag.certValue",tagClass:F.Class.CONTEXT_SPECIFIC,constructed:!0,value:[{name:"CertBag.certValue[0]",tagClass:F.Class.UNIVERSAL,type:F.Class.OCTETSTRING,constructed:!1,capture:"cert"}]}]};function Cc(e,t,r,n){for(var i=[],s=0;s<e.length;s++)for(var a=0;a<e[s].safeBags.length;a++){var o=e[s].safeBags[a];if(!(n!==void 0&&o.type!==n)){if(t===null){i.push(o);continue}o.attributes[t]!==void 0&&o.attributes[t].indexOf(r)>=0&&i.push(o);}}return i}xc.pkcs12FromAsn1=function(e,t,r){typeof t=="string"?(r=t,t=!0):t===void 0&&(t=!0);var n={},i=[];if(!F.validate(e,are,n,i)){var s=new Error("Cannot read PKCS#12 PFX. ASN.1 object is not an PKCS#12 PFX.");throw s.errors=s,s}var a={version:n.version.charCodeAt(0),safeContents:[],getBags:function(E){var w={},y;return "localKeyId"in E?y=E.localKeyId:"localKeyIdHex"in E&&(y=$t.util.hexToBytes(E.localKeyIdHex)),y===void 0&&!("friendlyName"in E)&&"bagType"in E&&(w[E.bagType]=Cc(a.safeContents,null,null,E.bagType)),y!==void 0&&(w.localKeyId=Cc(a.safeContents,"localKeyId",y,E.bagType)),"friendlyName"in E&&(w.friendlyName=Cc(a.safeContents,"friendlyName",E.friendlyName,E.bagType)),w},getBagsByFriendlyName:function(E,w){return Cc(a.safeContents,"friendlyName",E,w)},getBagsByLocalKeyId:function(E,w){return Cc(a.safeContents,"localKeyId",E,w)}};if(n.version.charCodeAt(0)!==3){var s=new Error("PKCS#12 PFX of version other than 3 not supported.");throw s.version=n.version.charCodeAt(0),s}if(F.derToOid(n.contentType)!==ut.oids.data){var s=new Error("Only PKCS#12 PFX in password integrity mode supported.");throw s.oid=F.derToOid(n.contentType),s}var o=n.content.value[0];if(o.tagClass!==F.Class.UNIVERSAL||o.type!==F.Type.OCTETSTRING)throw new Error("PKCS#12 authSafe content data is not an OCTET STRING.");if(o=Bv(o),n.mac){var c=null,l=0,u=F.derToOid(n.macAlgorithm);switch(u){case ut.oids.sha1:c=$t.md.sha1.create(),l=20;break;case ut.oids.sha256:c=$t.md.sha256.create(),l=32;break;case ut.oids.sha384:c=$t.md.sha384.create(),l=48;break;case ut.oids.sha512:c=$t.md.sha512.create(),l=64;break;case ut.oids.md5:c=$t.md.md5.create(),l=16;break}if(c===null)throw new Error("PKCS#12 uses unsupported MAC algorithm: "+u);var f=new $t.util.ByteBuffer(n.macSalt),h="macIterations"in n?parseInt($t.util.bytesToHex(n.macIterations),16):1,p=xc.generateKey(r,f,3,h,l,c),g=$t.hmac.create();g.start(c,p),g.update(o.value);var _=g.getMac();if(_.getBytes()!==n.macDigest)throw new Error("PKCS#12 MAC could not be verified. Invalid password?")}return lre(a,o.value,t,r),a};function Bv(e){if(e.composed||e.constructed){for(var t=$t.util.createBuffer(),r=0;r<e.value.length;++r)t.putBytes(e.value[r].value);e.composed=e.constructed=!1,e.value=t.getBytes();}return e}function lre(e,t,r,n){if(t=F.fromDer(t,r),t.tagClass!==F.Class.UNIVERSAL||t.type!==F.Type.SEQUENCE||t.constructed!==!0)throw new Error("PKCS#12 AuthenticatedSafe expected to be a SEQUENCE OF ContentInfo");for(var i=0;i<t.value.length;i++){var s=t.value[i],a={},o=[];if(!F.validate(s,aL,a,o)){var c=new Error("Cannot read ContentInfo.");throw c.errors=o,c}var l={encrypted:!1},u=null,f=a.content.value[0];switch(F.derToOid(a.contentType)){case ut.oids.data:if(f.tagClass!==F.Class.UNIVERSAL||f.type!==F.Type.OCTETSTRING)throw new Error("PKCS#12 SafeContents Data is not an OCTET STRING.");u=Bv(f).value;break;case ut.oids.encryptedData:u=fre(f,n),l.encrypted=!0;break;default:var c=new Error("Unsupported PKCS#12 contentType.");throw c.contentType=F.derToOid(a.contentType),c}l.safeBags=dre(u,r,n),e.safeContents.push(l);}}function fre(e,t){var r={},n=[];if(!F.validate(e,$t.pkcs7.asn1.encryptedDataValidator,r,n)){var i=new Error("Cannot read EncryptedContentInfo.");throw i.errors=n,i}var s=F.derToOid(r.contentType);if(s!==ut.oids.data){var i=new Error("PKCS#12 EncryptedContentInfo ContentType is not Data.");throw i.oid=s,i}s=F.derToOid(r.encAlgorithm);var a=ut.pbe.getCipher(s,r.encParameter,t),o=Bv(r.encryptedContentAsn1),c=$t.util.createBuffer(o.value);if(a.update(c),!a.finish())throw new Error("Failed to decrypt PKCS#12 SafeContents.");return a.output.getBytes()}function dre(e,t,r){if(!t&&e.length===0)return [];if(e=F.fromDer(e,t),e.tagClass!==F.Class.UNIVERSAL||e.type!==F.Type.SEQUENCE||e.constructed!==!0)throw new Error("PKCS#12 SafeContents expected to be a SEQUENCE OF SafeBag.");for(var n=[],i=0;i<e.value.length;i++){var s=e.value[i],a={},o=[];if(!F.validate(s,ore,a,o)){var c=new Error("Cannot read SafeBag.");throw c.errors=o,c}var l={type:F.derToOid(a.bagId),attributes:hre(a.bagAttributes)};n.push(l);var u,f,h=a.bagValue.value[0];switch(l.type){case ut.oids.pkcs8ShroudedKeyBag:if(h=ut.decryptPrivateKeyInfo(h,r),h===null)throw new Error("Unable to decrypt PKCS#8 ShroudedKeyBag, wrong password?");case ut.oids.keyBag:try{l.key=ut.privateKeyFromAsn1(h);}catch{l.key=null,l.asn1=h;}continue;case ut.oids.certBag:u=cre,f=function(){if(F.derToOid(a.certId)!==ut.oids.x509Certificate){var g=new Error("Unsupported certificate type, only X.509 supported.");throw g.oid=F.derToOid(a.certId),g}var _=F.fromDer(a.cert,t);try{l.cert=ut.certificateFromAsn1(_,!0);}catch{l.cert=null,l.asn1=_;}};break;default:var c=new Error("Unsupported PKCS#12 SafeBag type.");throw c.oid=l.type,c}if(u!==void 0&&!F.validate(h,u,a,o)){var c=new Error("Cannot read PKCS#12 "+u.name);throw c.errors=o,c}f();}return n}function hre(e){var t={};if(e!==void 0)for(var r=0;r<e.length;++r){var n={},i=[];if(!F.validate(e[r],ure,n,i)){var s=new Error("Cannot read PKCS#12 BagAttribute.");throw s.errors=i,s}var a=F.derToOid(n.oid);if(ut.oids[a]!==void 0){t[ut.oids[a]]=[];for(var o=0;o<n.values.length;++o)t[ut.oids[a]].push(n.values[o].value);}}return t}xc.toPkcs12Asn1=function(e,t,r,n){n=n||{},n.saltSize=n.saltSize||8,n.count=n.count||2048,n.algorithm=n.algorithm||n.encAlgorithm||"aes128","useMac"in n||(n.useMac=!0),"localKeyId"in n||(n.localKeyId=null),"generateLocalKeyId"in n||(n.generateLocalKeyId=!0);var i=n.localKeyId,s;if(i!==null)i=$t.util.hexToBytes(i);else if(n.generateLocalKeyId)if(t){var a=$t.util.isArray(t)?t[0]:t;typeof a=="string"&&(a=ut.certificateFromPem(a));var o=$t.md.sha1.create();o.update(F.toDer(ut.certificateToAsn1(a)).getBytes()),i=o.digest().getBytes();}else i=$t.random.getBytes(20);var c=[];i!==null&&c.push(F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.localKeyId).getBytes()),F.create(F.Class.UNIVERSAL,F.Type.SET,!0,[F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,i)])])),"friendlyName"in n&&c.push(F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.friendlyName).getBytes()),F.create(F.Class.UNIVERSAL,F.Type.SET,!0,[F.create(F.Class.UNIVERSAL,F.Type.BMPSTRING,!1,n.friendlyName)])])),c.length>0&&(s=F.create(F.Class.UNIVERSAL,F.Type.SET,!0,c));var l=[],u=[];t!==null&&($t.util.isArray(t)?u=t:u=[t]);for(var f=[],h=0;h<u.length;++h){t=u[h],typeof t=="string"&&(t=ut.certificateFromPem(t));var p=h===0?s:void 0,g=ut.certificateToAsn1(t),_=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.certBag).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.x509Certificate).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,F.toDer(g).getBytes())])])]),p]);f.push(_);}if(f.length>0){var E=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,f),w=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.data).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,F.toDer(E).getBytes())])]);l.push(w);}var y=null;if(e!==null){var b=ut.wrapRsaPrivateKey(ut.privateKeyToAsn1(e));r===null?y=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.keyBag).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[b]),s]):y=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.pkcs8ShroudedKeyBag).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[ut.encryptPrivateKeyInfo(b,r,n)]),s]);var N=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[y]),L=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.data).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,F.toDer(N).getBytes())])]);l.push(L);}var V=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,l),Z;if(n.useMac){var o=$t.md.sha1.create(),G=new $t.util.ByteBuffer($t.random.getBytes(n.saltSize)),z=n.count,e=xc.generateKey(r,G,3,z,20),ee=$t.hmac.create();ee.start(o,e),ee.update(F.toDer(V).getBytes());var U=ee.getMac();Z=F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.sha1).getBytes()),F.create(F.Class.UNIVERSAL,F.Type.NULL,!1,"")]),F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,U.getBytes())]),F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,G.getBytes()),F.create(F.Class.UNIVERSAL,F.Type.INTEGER,!1,F.integerToDer(z).getBytes())]);}return F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.INTEGER,!1,F.integerToDer(3).getBytes()),F.create(F.Class.UNIVERSAL,F.Type.SEQUENCE,!0,[F.create(F.Class.UNIVERSAL,F.Type.OID,!1,F.oidToDer(ut.oids.data).getBytes()),F.create(F.Class.CONTEXT_SPECIFIC,0,!0,[F.create(F.Class.UNIVERSAL,F.Type.OCTETSTRING,!1,F.toDer(V).getBytes())])]),Z])};xc.generateKey=$t.pbe.generatePkcs12Key;});var Mv=I((whe,uL)=>{var xs=rt();ai();Ss();Dv();ma();Nd();Fv();qd();wc();_t();$d();var qv=xs.asn1,Do=uL.exports=xs.pki=xs.pki||{};Do.pemToDer=function(e){var t=xs.pem.decode(e)[0];if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert PEM to DER; PEM is encrypted.");return xs.util.createBuffer(t.body)};Do.privateKeyFromPem=function(e){var t=xs.pem.decode(e)[0];if(t.type!=="PRIVATE KEY"&&t.type!=="RSA PRIVATE KEY"){var r=new Error('Could not convert private key from PEM; PEM header type is not "PRIVATE KEY" or "RSA PRIVATE KEY".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert private key from PEM; PEM is encrypted.");var n=qv.fromDer(t.body);return Do.privateKeyFromAsn1(n)};Do.privateKeyToPem=function(e,t){var r={type:"RSA PRIVATE KEY",body:qv.toDer(Do.privateKeyToAsn1(e)).getBytes()};return xs.pem.encode(r,{maxline:t})};Do.privateKeyInfoToPem=function(e,t){var r={type:"PRIVATE KEY",body:qv.toDer(e).getBytes()};return xs.pem.encode(r,{maxline:t})};});var Wv=I((Che,mL)=>{var de=rt();ai();Co();Ad();ma();Mv();Fn();Ro();_t();var Wd=function(e,t,r,n){var i=de.util.createBuffer(),s=e.length>>1,a=s+(e.length&1),o=e.substr(0,a),c=e.substr(s,a),l=de.util.createBuffer(),u=de.hmac.create();r=t+r;var f=Math.ceil(n/16),h=Math.ceil(n/20);u.start("MD5",o);var p=de.util.createBuffer();l.putBytes(r);for(var g=0;g<f;++g)u.start(null,null),u.update(l.getBytes()),l.putBuffer(u.digest()),u.start(null,null),u.update(l.bytes()+r),p.putBuffer(u.digest());u.start("SHA1",c);var _=de.util.createBuffer();l.clear(),l.putBytes(r);for(var g=0;g<h;++g)u.start(null,null),u.update(l.getBytes()),l.putBuffer(u.digest()),u.start(null,null),u.update(l.bytes()+r),_.putBuffer(u.digest());return i.putBytes(de.util.xorBytes(p.getBytes(),_.getBytes(),n)),i},pre=function(e,t,r){var n=de.hmac.create();n.start("SHA1",e);var i=de.util.createBuffer();return i.putInt32(t[0]),i.putInt32(t[1]),i.putByte(r.type),i.putByte(r.version.major),i.putByte(r.version.minor),i.putInt16(r.length),i.putBytes(r.fragment.bytes()),n.update(i.getBytes()),n.digest().getBytes()},gre=function(e,t,r){var n=!1;try{var i=e.deflate(t.fragment.getBytes());t.fragment=de.util.createBuffer(i),t.length=i.length,n=!0;}catch{}return n},mre=function(e,t,r){var n=!1;try{var i=e.inflate(t.fragment.getBytes());t.fragment=de.util.createBuffer(i),t.length=i.length,n=!0;}catch{}return n},Cn=function(e,t){var r=0;switch(t){case 1:r=e.getByte();break;case 2:r=e.getInt16();break;case 3:r=e.getInt24();break;case 4:r=e.getInt32();break}return de.util.createBuffer(e.getBytes(r))},$n=function(e,t,r){e.putInt(r.length(),t<<3),e.putBuffer(r);},P={};P.Versions={TLS_1_0:{major:3,minor:1},TLS_1_1:{major:3,minor:2},TLS_1_2:{major:3,minor:3}};P.SupportedVersions=[P.Versions.TLS_1_1,P.Versions.TLS_1_0];P.Version=P.SupportedVersions[0];P.MaxFragment=15360;P.ConnectionEnd={server:0,client:1};P.PRFAlgorithm={tls_prf_sha256:0};P.BulkCipherAlgorithm={none:null,rc4:0,des3:1,aes:2};P.CipherType={stream:0,block:1,aead:2};P.MACAlgorithm={none:null,hmac_md5:0,hmac_sha1:1,hmac_sha256:2,hmac_sha384:3,hmac_sha512:4};P.CompressionMethod={none:0,deflate:1};P.ContentType={change_cipher_spec:20,alert:21,handshake:22,application_data:23,heartbeat:24};P.HandshakeType={hello_request:0,client_hello:1,server_hello:2,certificate:11,server_key_exchange:12,certificate_request:13,server_hello_done:14,certificate_verify:15,client_key_exchange:16,finished:20};P.Alert={};P.Alert.Level={warning:1,fatal:2};P.Alert.Description={close_notify:0,unexpected_message:10,bad_record_mac:20,decryption_failed:21,record_overflow:22,decompression_failure:30,handshake_failure:40,bad_certificate:42,unsupported_certificate:43,certificate_revoked:44,certificate_expired:45,certificate_unknown:46,illegal_parameter:47,unknown_ca:48,access_denied:49,decode_error:50,decrypt_error:51,export_restriction:60,protocol_version:70,insufficient_security:71,internal_error:80,user_canceled:90,no_renegotiation:100};P.HeartbeatMessageType={heartbeat_request:1,heartbeat_response:2};P.CipherSuites={};P.getCipherSuite=function(e){var t=null;for(var r in P.CipherSuites){var n=P.CipherSuites[r];if(n.id[0]===e.charCodeAt(0)&&n.id[1]===e.charCodeAt(1)){t=n;break}}return t};P.handleUnexpected=function(e,t){var r=!e.open&&e.entity===P.ConnectionEnd.client;r||e.error(e,{message:"Unexpected message. Received TLS record out of order.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.unexpected_message}});};P.handleHelloRequest=function(e,t,r){!e.handshaking&&e.handshakes>0&&(P.queue(e,P.createAlert(e,{level:P.Alert.Level.warning,description:P.Alert.Description.no_renegotiation})),P.flush(e)),e.process();};P.parseHelloMessage=function(e,t,r){var n=null,i=e.entity===P.ConnectionEnd.client;if(r<38)e.error(e,{message:i?"Invalid ServerHello message. Message too short.":"Invalid ClientHello message. Message too short.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.illegal_parameter}});else {var s=t.fragment,a=s.length();if(n={version:{major:s.getByte(),minor:s.getByte()},random:de.util.createBuffer(s.getBytes(32)),session_id:Cn(s,1),extensions:[]},i?(n.cipher_suite=s.getBytes(2),n.compression_method=s.getByte()):(n.cipher_suites=Cn(s,2),n.compression_methods=Cn(s,1)),a=r-(a-s.length()),a>0){for(var o=Cn(s,2);o.length()>0;)n.extensions.push({type:[o.getByte(),o.getByte()],data:Cn(o,2)});if(!i)for(var c=0;c<n.extensions.length;++c){var l=n.extensions[c];if(l.type[0]===0&&l.type[1]===0)for(var u=Cn(l.data,2);u.length()>0;){var f=u.getByte();if(f!==0)break;e.session.extensions.server_name.serverNameList.push(Cn(u,2).getBytes());}}}if(e.session.version&&(n.version.major!==e.session.version.major||n.version.minor!==e.session.version.minor))return e.error(e,{message:"TLS version change is disallowed during renegotiation.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.protocol_version}});if(i)e.session.cipherSuite=P.getCipherSuite(n.cipher_suite);else for(var h=de.util.createBuffer(n.cipher_suites.bytes());h.length()>0&&(e.session.cipherSuite=P.getCipherSuite(h.getBytes(2)),e.session.cipherSuite===null););if(e.session.cipherSuite===null)return e.error(e,{message:"No cipher suites in common.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.handshake_failure},cipherSuite:de.util.bytesToHex(n.cipher_suite)});i?e.session.compressionMethod=n.compression_method:e.session.compressionMethod=P.CompressionMethod.none;}return n};P.createSecurityParameters=function(e,t){var r=e.entity===P.ConnectionEnd.client,n=t.random.bytes(),i=r?e.session.sp.client_random:n,s=r?n:P.createRandom().getBytes();e.session.sp={entity:e.entity,prf_algorithm:P.PRFAlgorithm.tls_prf_sha256,bulk_cipher_algorithm:null,cipher_type:null,enc_key_length:null,block_length:null,fixed_iv_length:null,record_iv_length:null,mac_algorithm:null,mac_length:null,mac_key_length:null,compression_algorithm:e.session.compressionMethod,pre_master_secret:null,master_secret:null,client_random:i,server_random:s};};P.handleServerHello=function(e,t,r){var n=P.parseHelloMessage(e,t,r);if(!e.fail){if(n.version.minor<=e.version.minor)e.version.minor=n.version.minor;else return e.error(e,{message:"Incompatible TLS version.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.protocol_version}});e.session.version=e.version;var i=n.session_id.bytes();i.length>0&&i===e.session.id?(e.expect=fL,e.session.resuming=!0,e.session.sp.server_random=n.random.bytes()):(e.expect=vre,e.session.resuming=!1,P.createSecurityParameters(e,n)),e.session.id=i,e.process();}};P.handleClientHello=function(e,t,r){var n=P.parseHelloMessage(e,t,r);if(!e.fail){var i=n.session_id.bytes(),s=null;if(e.sessionCache&&(s=e.sessionCache.getSession(i),s===null?i="":(s.version.major!==n.version.major||s.version.minor>n.version.minor)&&(s=null,i="")),i.length===0&&(i=de.random.getBytes(32)),e.session.id=i,e.session.clientHelloVersion=n.version,e.session.sp={},s)e.version=e.session.version=s.version,e.session.sp=s.sp;else {for(var a,o=1;o<P.SupportedVersions.length&&(a=P.SupportedVersions[o],!(a.minor<=n.version.minor));++o);e.version={major:a.major,minor:a.minor},e.session.version=e.version;}s!==null?(e.expect=Vv,e.session.resuming=!0,e.session.sp.client_random=n.random.bytes()):(e.expect=e.verifyClient!==!1?xre:jv,e.session.resuming=!1,P.createSecurityParameters(e,n)),e.open=!0,P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createServerHello(e)})),e.session.resuming?(P.queue(e,P.createRecord(e,{type:P.ContentType.change_cipher_spec,data:P.createChangeCipherSpec()})),e.state.pending=P.createConnectionState(e),e.state.current.write=e.state.pending.write,P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createFinished(e)}))):(P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createCertificate(e)})),e.fail||(P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createServerKeyExchange(e)})),e.verifyClient!==!1&&P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createCertificateRequest(e)})),P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createServerHelloDone(e)})))),P.flush(e),e.process();}};P.handleCertificate=function(e,t,r){if(r<3)return e.error(e,{message:"Invalid Certificate message. Message too short.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.illegal_parameter}});var n=t.fragment,i={certificate_list:Cn(n,3)},s,a,o=[];try{for(;i.certificate_list.length()>0;)s=Cn(i.certificate_list,3),a=de.asn1.fromDer(s),s=de.pki.certificateFromAsn1(a,!0),o.push(s);}catch(l){return e.error(e,{message:"Could not parse certificate list.",cause:l,send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.bad_certificate}})}var c=e.entity===P.ConnectionEnd.client;(c||e.verifyClient===!0)&&o.length===0?e.error(e,{message:c?"No server certificate provided.":"No client certificate provided.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.illegal_parameter}}):o.length===0?e.expect=c?cL:jv:(c?e.session.serverCertificate=o[0]:e.session.clientCertificate=o[0],P.verifyCertificateChain(e,o)&&(e.expect=c?cL:jv)),e.process();};P.handleServerKeyExchange=function(e,t,r){if(r>0)return e.error(e,{message:"Invalid key parameters. Only RSA is supported.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.unsupported_certificate}});e.expect=_re,e.process();};P.handleClientKeyExchange=function(e,t,r){if(r<48)return e.error(e,{message:"Invalid key parameters. Only RSA is supported.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.unsupported_certificate}});var n=t.fragment,i={enc_pre_master_secret:Cn(n,2).getBytes()},s=null;if(e.getPrivateKey)try{s=e.getPrivateKey(e,e.session.serverCertificate),s=de.pki.privateKeyFromPem(s);}catch(c){e.error(e,{message:"Could not get private key.",cause:c,send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.internal_error}});}if(s===null)return e.error(e,{message:"No private key set.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.internal_error}});try{var a=e.session.sp;a.pre_master_secret=s.decrypt(i.enc_pre_master_secret);var o=e.session.clientHelloVersion;if(o.major!==a.pre_master_secret.charCodeAt(0)||o.minor!==a.pre_master_secret.charCodeAt(1))throw new Error("TLS version rollback attack detected.")}catch{a.pre_master_secret=de.random.getBytes(48);}e.expect=Vv,e.session.clientCertificate!==null&&(e.expect=Tre),e.process();};P.handleCertificateRequest=function(e,t,r){if(r<3)return e.error(e,{message:"Invalid CertificateRequest. Message too short.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.illegal_parameter}});var n=t.fragment,i={certificate_types:Cn(n,1),certificate_authorities:Cn(n,2)};e.session.certificateRequest=i,e.expect=bre,e.process();};P.handleCertificateVerify=function(e,t,r){if(r<2)return e.error(e,{message:"Invalid CertificateVerify. Message too short.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.illegal_parameter}});var n=t.fragment;n.read-=4;var i=n.bytes();n.read+=4;var s={signature:Cn(n,2).getBytes()},a=de.util.createBuffer();a.putBuffer(e.session.md5.digest()),a.putBuffer(e.session.sha1.digest()),a=a.getBytes();try{var o=e.session.clientCertificate;if(!o.publicKey.verify(a,s.signature,"NONE"))throw new Error("CertificateVerify signature does not match.");e.session.md5.update(i),e.session.sha1.update(i);}catch{return e.error(e,{message:"Bad signature in CertificateVerify.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.handshake_failure}})}e.expect=Vv,e.process();};P.handleServerHelloDone=function(e,t,r){if(r>0)return e.error(e,{message:"Invalid ServerHelloDone message. Invalid length.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.record_overflow}});if(e.serverCertificate===null){var n={message:"No server certificate provided. Not enough security.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.insufficient_security}},i=0,s=e.verify(e,n.alert.description,i,[]);if(s!==!0)return (s||s===0)&&(typeof s=="object"&&!de.util.isArray(s)?(s.message&&(n.message=s.message),s.alert&&(n.alert.description=s.alert)):typeof s=="number"&&(n.alert.description=s)),e.error(e,n)}e.session.certificateRequest!==null&&(t=P.createRecord(e,{type:P.ContentType.handshake,data:P.createCertificate(e)}),P.queue(e,t)),t=P.createRecord(e,{type:P.ContentType.handshake,data:P.createClientKeyExchange(e)}),P.queue(e,t),e.expect=wre;var a=function(o,c){o.session.certificateRequest!==null&&o.session.clientCertificate!==null&&P.queue(o,P.createRecord(o,{type:P.ContentType.handshake,data:P.createCertificateVerify(o,c)})),P.queue(o,P.createRecord(o,{type:P.ContentType.change_cipher_spec,data:P.createChangeCipherSpec()})),o.state.pending=P.createConnectionState(o),o.state.current.write=o.state.pending.write,P.queue(o,P.createRecord(o,{type:P.ContentType.handshake,data:P.createFinished(o)})),o.expect=fL,P.flush(o),o.process();};if(e.session.certificateRequest===null||e.session.clientCertificate===null)return a(e,null);P.getClientSignature(e,a);};P.handleChangeCipherSpec=function(e,t){if(t.fragment.getByte()!==1)return e.error(e,{message:"Invalid ChangeCipherSpec message received.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.illegal_parameter}});var r=e.entity===P.ConnectionEnd.client;(e.session.resuming&&r||!e.session.resuming&&!r)&&(e.state.pending=P.createConnectionState(e)),e.state.current.read=e.state.pending.read,(!e.session.resuming&&r||e.session.resuming&&!r)&&(e.state.pending=null),e.expect=r?Sre:Are,e.process();};P.handleFinished=function(e,t,r){var n=t.fragment;n.read-=4;var i=n.bytes();n.read+=4;var s=t.fragment.getBytes();n=de.util.createBuffer(),n.putBuffer(e.session.md5.digest()),n.putBuffer(e.session.sha1.digest());var a=e.entity===P.ConnectionEnd.client,o=a?"server finished":"client finished",c=e.session.sp,l=12,u=Wd;if(n=u(c.master_secret,o,n.getBytes(),l),n.getBytes()!==s)return e.error(e,{message:"Invalid verify_data in Finished message.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.decrypt_error}});e.session.md5.update(i),e.session.sha1.update(i),(e.session.resuming&&a||!e.session.resuming&&!a)&&(P.queue(e,P.createRecord(e,{type:P.ContentType.change_cipher_spec,data:P.createChangeCipherSpec()})),e.state.current.write=e.state.pending.write,e.state.pending=null,P.queue(e,P.createRecord(e,{type:P.ContentType.handshake,data:P.createFinished(e)}))),e.expect=a?Ere:Rre,e.handshaking=!1,++e.handshakes,e.peerCertificate=a?e.session.serverCertificate:e.session.clientCertificate,P.flush(e),e.isConnected=!0,e.connected(e),e.process();};P.handleAlert=function(e,t){var r=t.fragment,n={level:r.getByte(),description:r.getByte()},i;switch(n.description){case P.Alert.Description.close_notify:i="Connection closed.";break;case P.Alert.Description.unexpected_message:i="Unexpected message.";break;case P.Alert.Description.bad_record_mac:i="Bad record MAC.";break;case P.Alert.Description.decryption_failed:i="Decryption failed.";break;case P.Alert.Description.record_overflow:i="Record overflow.";break;case P.Alert.Description.decompression_failure:i="Decompression failed.";break;case P.Alert.Description.handshake_failure:i="Handshake failure.";break;case P.Alert.Description.bad_certificate:i="Bad certificate.";break;case P.Alert.Description.unsupported_certificate:i="Unsupported certificate.";break;case P.Alert.Description.certificate_revoked:i="Certificate revoked.";break;case P.Alert.Description.certificate_expired:i="Certificate expired.";break;case P.Alert.Description.certificate_unknown:i="Certificate unknown.";break;case P.Alert.Description.illegal_parameter:i="Illegal parameter.";break;case P.Alert.Description.unknown_ca:i="Unknown certificate authority.";break;case P.Alert.Description.access_denied:i="Access denied.";break;case P.Alert.Description.decode_error:i="Decode error.";break;case P.Alert.Description.decrypt_error:i="Decrypt error.";break;case P.Alert.Description.export_restriction:i="Export restriction.";break;case P.Alert.Description.protocol_version:i="Unsupported protocol version.";break;case P.Alert.Description.insufficient_security:i="Insufficient security.";break;case P.Alert.Description.internal_error:i="Internal error.";break;case P.Alert.Description.user_canceled:i="User canceled.";break;case P.Alert.Description.no_renegotiation:i="Renegotiation not supported.";break;default:i="Unknown error.";break}if(n.description===P.Alert.Description.close_notify)return e.close();e.error(e,{message:i,send:!1,origin:e.entity===P.ConnectionEnd.client?"server":"client",alert:n}),e.process();};P.handleHandshake=function(e,t){var r=t.fragment,n=r.getByte(),i=r.getInt24();if(i>r.length())return e.fragmented=t,t.fragment=de.util.createBuffer(),r.read-=4,e.process();e.fragmented=null,r.read-=4;var s=r.bytes(i+4);r.read+=4,n in Hd[e.entity][e.expect]?(e.entity===P.ConnectionEnd.server&&!e.open&&!e.fail&&(e.handshaking=!0,e.session={version:null,extensions:{server_name:{serverNameList:[]}},cipherSuite:null,compressionMethod:null,serverCertificate:null,clientCertificate:null,md5:de.md.md5.create(),sha1:de.md.sha1.create()}),n!==P.HandshakeType.hello_request&&n!==P.HandshakeType.certificate_verify&&n!==P.HandshakeType.finished&&(e.session.md5.update(s),e.session.sha1.update(s)),Hd[e.entity][e.expect][n](e,t,i)):P.handleUnexpected(e,t);};P.handleApplicationData=function(e,t){e.data.putBuffer(t.fragment),e.dataReady(e),e.process();};P.handleHeartbeat=function(e,t){var r=t.fragment,n=r.getByte(),i=r.getInt16(),s=r.getBytes(i);if(n===P.HeartbeatMessageType.heartbeat_request){if(e.handshaking||i>s.length)return e.process();P.queue(e,P.createRecord(e,{type:P.ContentType.heartbeat,data:P.createHeartbeat(P.HeartbeatMessageType.heartbeat_response,s)})),P.flush(e);}else if(n===P.HeartbeatMessageType.heartbeat_response){if(s!==e.expectedHeartbeatPayload)return e.process();e.heartbeatReceived&&e.heartbeatReceived(e,de.util.createBuffer(s));}e.process();};var yre=0,vre=1,cL=2,_re=3,bre=4,fL=5,Sre=6,Ere=7,wre=8,Cre=0,xre=1,jv=2,Tre=3,Vv=4,Are=5,Rre=6,R=P.handleUnexpected,dL=P.handleChangeCipherSpec,Pr=P.handleAlert,Zr=P.handleHandshake,hL=P.handleApplicationData,Nr=P.handleHeartbeat,Hv=[];Hv[P.ConnectionEnd.client]=[[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[dL,Pr,R,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,hL,Nr],[R,Pr,Zr,R,Nr]];Hv[P.ConnectionEnd.server]=[[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,R,Nr],[dL,Pr,R,R,Nr],[R,Pr,Zr,R,Nr],[R,Pr,Zr,hL,Nr],[R,Pr,Zr,R,Nr]];var Ts=P.handleHelloRequest,Ire=P.handleServerHello,pL=P.handleCertificate,lL=P.handleServerKeyExchange,Uv=P.handleCertificateRequest,jd=P.handleServerHelloDone,gL=P.handleFinished,Hd=[];Hd[P.ConnectionEnd.client]=[[R,R,Ire,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,pL,lL,Uv,jd,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,R,lL,Uv,jd,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,R,R,Uv,jd,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,R,R,R,jd,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,gL],[Ts,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R],[Ts,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R]];var Pre=P.handleClientHello,Nre=P.handleClientKeyExchange,Dre=P.handleCertificateVerify;Hd[P.ConnectionEnd.server]=[[R,Pre,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R],[R,R,R,R,R,R,R,R,R,R,R,pL,R,R,R,R,R,R,R,R,R],[R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,Nre,R,R,R,R],[R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,Dre,R,R,R,R,R],[R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R],[R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,gL],[R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R],[R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R,R]];P.generateKeys=function(e,t){var r=Wd,n=t.client_random+t.server_random;e.session.resuming||(t.master_secret=r(t.pre_master_secret,"master secret",n,48).bytes(),t.pre_master_secret=null),n=t.server_random+t.client_random;var i=2*t.mac_key_length+2*t.enc_key_length,s=e.version.major===P.Versions.TLS_1_0.major&&e.version.minor===P.Versions.TLS_1_0.minor;s&&(i+=2*t.fixed_iv_length);var a=r(t.master_secret,"key expansion",n,i),o={client_write_MAC_key:a.getBytes(t.mac_key_length),server_write_MAC_key:a.getBytes(t.mac_key_length),client_write_key:a.getBytes(t.enc_key_length),server_write_key:a.getBytes(t.enc_key_length)};return s&&(o.client_write_IV=a.getBytes(t.fixed_iv_length),o.server_write_IV=a.getBytes(t.fixed_iv_length)),o};P.createConnectionState=function(e){var t=e.entity===P.ConnectionEnd.client,r=function(){var s={sequenceNumber:[0,0],macKey:null,macLength:0,macFunction:null,cipherState:null,cipherFunction:function(a){return !0},compressionState:null,compressFunction:function(a){return !0},updateSequenceNumber:function(){s.sequenceNumber[1]===4294967295?(s.sequenceNumber[1]=0,++s.sequenceNumber[0]):++s.sequenceNumber[1];}};return s},n={read:r(),write:r()};if(n.read.update=function(s,a){return n.read.cipherFunction(a,n.read)?n.read.compressFunction(s,a,n.read)||s.error(s,{message:"Could not decompress record.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.decompression_failure}}):s.error(s,{message:"Could not decrypt record or bad MAC.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.bad_record_mac}}),!s.fail},n.write.update=function(s,a){return n.write.compressFunction(s,a,n.write)?n.write.cipherFunction(a,n.write)||s.error(s,{message:"Could not encrypt record.",send:!1,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.internal_error}}):s.error(s,{message:"Could not compress record.",send:!1,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.internal_error}}),!s.fail},e.session){var i=e.session.sp;switch(e.session.cipherSuite.initSecurityParameters(i),i.keys=P.generateKeys(e,i),n.read.macKey=t?i.keys.server_write_MAC_key:i.keys.client_write_MAC_key,n.write.macKey=t?i.keys.client_write_MAC_key:i.keys.server_write_MAC_key,e.session.cipherSuite.initConnectionState(n,e,i),i.compression_algorithm){case P.CompressionMethod.none:break;case P.CompressionMethod.deflate:n.read.compressFunction=mre,n.write.compressFunction=gre;break;default:throw new Error("Unsupported compression algorithm.")}}return n};P.createRandom=function(){var e=new Date,t=+e+e.getTimezoneOffset()*6e4,r=de.util.createBuffer();return r.putInt32(t),r.putBytes(de.random.getBytes(28)),r};P.createRecord=function(e,t){if(!t.data)return null;var r={type:t.type,version:{major:e.version.major,minor:e.version.minor},length:t.data.length(),fragment:t.data};return r};P.createAlert=function(e,t){var r=de.util.createBuffer();return r.putByte(t.level),r.putByte(t.description),P.createRecord(e,{type:P.ContentType.alert,data:r})};P.createClientHello=function(e){e.session.clientHelloVersion={major:e.version.major,minor:e.version.minor};for(var t=de.util.createBuffer(),r=0;r<e.cipherSuites.length;++r){var n=e.cipherSuites[r];t.putByte(n.id[0]),t.putByte(n.id[1]);}var i=t.length(),s=de.util.createBuffer();s.putByte(P.CompressionMethod.none);var a=s.length(),o=de.util.createBuffer();if(e.virtualHost){var c=de.util.createBuffer();c.putByte(0),c.putByte(0);var l=de.util.createBuffer();l.putByte(0),$n(l,2,de.util.createBuffer(e.virtualHost));var u=de.util.createBuffer();$n(u,2,l),$n(c,2,u),o.putBuffer(c);}var f=o.length();f>0&&(f+=2);var h=e.session.id,p=h.length+1+2+4+28+2+i+1+a+f,g=de.util.createBuffer();return g.putByte(P.HandshakeType.client_hello),g.putInt24(p),g.putByte(e.version.major),g.putByte(e.version.minor),g.putBytes(e.session.sp.client_random),$n(g,1,de.util.createBuffer(h)),$n(g,2,t),$n(g,1,s),f>0&&$n(g,2,o),g};P.createServerHello=function(e){var t=e.session.id,r=t.length+1+2+4+28+2+1,n=de.util.createBuffer();return n.putByte(P.HandshakeType.server_hello),n.putInt24(r),n.putByte(e.version.major),n.putByte(e.version.minor),n.putBytes(e.session.sp.server_random),$n(n,1,de.util.createBuffer(t)),n.putByte(e.session.cipherSuite.id[0]),n.putByte(e.session.cipherSuite.id[1]),n.putByte(e.session.compressionMethod),n};P.createCertificate=function(e){var t=e.entity===P.ConnectionEnd.client,r=null;if(e.getCertificate){var n;t?n=e.session.certificateRequest:n=e.session.extensions.server_name.serverNameList,r=e.getCertificate(e,n);}var i=de.util.createBuffer();if(r!==null)try{de.util.isArray(r)||(r=[r]);for(var s=null,a=0;a<r.length;++a){var o=de.pem.decode(r[a])[0];if(o.type!=="CERTIFICATE"&&o.type!=="X509 CERTIFICATE"&&o.type!=="TRUSTED CERTIFICATE"){var c=new Error('Could not convert certificate from PEM; PEM header type is not "CERTIFICATE", "X509 CERTIFICATE", or "TRUSTED CERTIFICATE".');throw c.headerType=o.type,c}if(o.procType&&o.procType.type==="ENCRYPTED")throw new Error("Could not convert certificate from PEM; PEM is encrypted.");var l=de.util.createBuffer(o.body);s===null&&(s=de.asn1.fromDer(l.bytes(),!1));var u=de.util.createBuffer();$n(u,3,l),i.putBuffer(u);}r=de.pki.certificateFromAsn1(s),t?e.session.clientCertificate=r:e.session.serverCertificate=r;}catch(p){return e.error(e,{message:"Could not send certificate list.",cause:p,send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.bad_certificate}})}var f=3+i.length(),h=de.util.createBuffer();return h.putByte(P.HandshakeType.certificate),h.putInt24(f),$n(h,3,i),h};P.createClientKeyExchange=function(e){var t=de.util.createBuffer();t.putByte(e.session.clientHelloVersion.major),t.putByte(e.session.clientHelloVersion.minor),t.putBytes(de.random.getBytes(46));var r=e.session.sp;r.pre_master_secret=t.getBytes();var n=e.session.serverCertificate.publicKey;t=n.encrypt(r.pre_master_secret);var i=t.length+2,s=de.util.createBuffer();return s.putByte(P.HandshakeType.client_key_exchange),s.putInt24(i),s.putInt16(t.length),s.putBytes(t),s};P.createServerKeyExchange=function(e){var r=de.util.createBuffer();return r};P.getClientSignature=function(e,t){var r=de.util.createBuffer();r.putBuffer(e.session.md5.digest()),r.putBuffer(e.session.sha1.digest()),r=r.getBytes(),e.getSignature=e.getSignature||function(n,i,s){var a=null;if(n.getPrivateKey)try{a=n.getPrivateKey(n,n.session.clientCertificate),a=de.pki.privateKeyFromPem(a);}catch(o){n.error(n,{message:"Could not get private key.",cause:o,send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.internal_error}});}a===null?n.error(n,{message:"No private key set.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.internal_error}}):i=a.sign(i,null),s(n,i);},e.getSignature(e,r,t);};P.createCertificateVerify=function(e,t){var r=t.length+2,n=de.util.createBuffer();return n.putByte(P.HandshakeType.certificate_verify),n.putInt24(r),n.putInt16(t.length),n.putBytes(t),n};P.createCertificateRequest=function(e){var t=de.util.createBuffer();t.putByte(1);var r=de.util.createBuffer();for(var n in e.caStore.certs){var i=e.caStore.certs[n],s=de.pki.distinguishedNameToAsn1(i.subject),a=de.asn1.toDer(s);r.putInt16(a.length()),r.putBuffer(a);}var o=1+t.length()+2+r.length(),c=de.util.createBuffer();return c.putByte(P.HandshakeType.certificate_request),c.putInt24(o),$n(c,1,t),$n(c,2,r),c};P.createServerHelloDone=function(e){var t=de.util.createBuffer();return t.putByte(P.HandshakeType.server_hello_done),t.putInt24(0),t};P.createChangeCipherSpec=function(){var e=de.util.createBuffer();return e.putByte(1),e};P.createFinished=function(e){var t=de.util.createBuffer();t.putBuffer(e.session.md5.digest()),t.putBuffer(e.session.sha1.digest());var r=e.entity===P.ConnectionEnd.client,n=e.session.sp,i=12,s=Wd,a=r?"client finished":"server finished";t=s(n.master_secret,a,t.getBytes(),i);var o=de.util.createBuffer();return o.putByte(P.HandshakeType.finished),o.putInt24(t.length()),o.putBuffer(t),o};P.createHeartbeat=function(e,t,r){typeof r>"u"&&(r=t.length);var n=de.util.createBuffer();n.putByte(e),n.putInt16(r),n.putBytes(t);var i=n.length(),s=Math.max(16,i-r-3);return n.putBytes(de.random.getBytes(s)),n};P.queue=function(e,t){if(t&&!(t.fragment.length()===0&&(t.type===P.ContentType.handshake||t.type===P.ContentType.alert||t.type===P.ContentType.change_cipher_spec))){if(t.type===P.ContentType.handshake){var r=t.fragment.bytes();e.session.md5.update(r),e.session.sha1.update(r),r=null;}var n;if(t.fragment.length()<=P.MaxFragment)n=[t];else {n=[];for(var i=t.fragment.bytes();i.length>P.MaxFragment;)n.push(P.createRecord(e,{type:t.type,data:de.util.createBuffer(i.slice(0,P.MaxFragment))})),i=i.slice(P.MaxFragment);i.length>0&&n.push(P.createRecord(e,{type:t.type,data:de.util.createBuffer(i)}));}for(var s=0;s<n.length&&!e.fail;++s){var a=n[s],o=e.state.current.write;o.update(e,a)&&e.records.push(a);}}};P.flush=function(e){for(var t=0;t<e.records.length;++t){var r=e.records[t];e.tlsData.putByte(r.type),e.tlsData.putByte(r.version.major),e.tlsData.putByte(r.version.minor),e.tlsData.putInt16(r.fragment.length()),e.tlsData.putBuffer(e.records[t].fragment);}return e.records=[],e.tlsDataReady(e)};var $v=function(e){switch(e){case!0:return !0;case de.pki.certificateError.bad_certificate:return P.Alert.Description.bad_certificate;case de.pki.certificateError.unsupported_certificate:return P.Alert.Description.unsupported_certificate;case de.pki.certificateError.certificate_revoked:return P.Alert.Description.certificate_revoked;case de.pki.certificateError.certificate_expired:return P.Alert.Description.certificate_expired;case de.pki.certificateError.certificate_unknown:return P.Alert.Description.certificate_unknown;case de.pki.certificateError.unknown_ca:return P.Alert.Description.unknown_ca;default:return P.Alert.Description.bad_certificate}},Ore=function(e){switch(e){case!0:return !0;case P.Alert.Description.bad_certificate:return de.pki.certificateError.bad_certificate;case P.Alert.Description.unsupported_certificate:return de.pki.certificateError.unsupported_certificate;case P.Alert.Description.certificate_revoked:return de.pki.certificateError.certificate_revoked;case P.Alert.Description.certificate_expired:return de.pki.certificateError.certificate_expired;case P.Alert.Description.certificate_unknown:return de.pki.certificateError.certificate_unknown;case P.Alert.Description.unknown_ca:return de.pki.certificateError.unknown_ca;default:return de.pki.certificateError.bad_certificate}};P.verifyCertificateChain=function(e,t){try{var r={};for(var n in e.verifyOptions)r[n]=e.verifyOptions[n];r.verify=function(s,a,o){var l=e.verify(e,s,a,o);if(l!==!0){if(typeof l=="object"&&!de.util.isArray(l)){var u=new Error("The application rejected the certificate.");throw u.send=!0,u.alert={level:P.Alert.Level.fatal,description:P.Alert.Description.bad_certificate},l.message&&(u.message=l.message),l.alert&&(u.alert.description=l.alert),u}l!==s&&(l=Ore(l));}return l},de.pki.verifyCertificateChain(e.caStore,t,r);}catch(s){var i=s;(typeof i!="object"||de.util.isArray(i))&&(i={send:!0,alert:{level:P.Alert.Level.fatal,description:$v(s)}}),"send"in i||(i.send=!0),"alert"in i||(i.alert={level:P.Alert.Level.fatal,description:$v(i.error)}),e.error(e,i);}return !e.fail};P.createSessionCache=function(e,t){var r=null;if(e&&e.getSession&&e.setSession&&e.order)r=e;else {r={},r.cache=e||{},r.capacity=Math.max(t||100,1),r.order=[];for(var n in e)r.order.length<=t?r.order.push(n):delete e[n];r.getSession=function(i){var s=null,a=null;if(i?a=de.util.bytesToHex(i):r.order.length>0&&(a=r.order[0]),a!==null&&a in r.cache){s=r.cache[a],delete r.cache[a];for(var o in r.order)if(r.order[o]===a){r.order.splice(o,1);break}}return s},r.setSession=function(i,s){if(r.order.length===r.capacity){var a=r.order.shift();delete r.cache[a];}var a=de.util.bytesToHex(i);r.order.push(a),r.cache[a]=s;};}return r};P.createConnection=function(e){var t=null;e.caStore?de.util.isArray(e.caStore)?t=de.pki.createCaStore(e.caStore):t=e.caStore:t=de.pki.createCaStore();var r=e.cipherSuites||null;if(r===null){r=[];for(var n in P.CipherSuites)r.push(P.CipherSuites[n]);}var i=e.server?P.ConnectionEnd.server:P.ConnectionEnd.client,s=e.sessionCache?P.createSessionCache(e.sessionCache):null,a={version:{major:P.Version.major,minor:P.Version.minor},entity:i,sessionId:e.sessionId,caStore:t,sessionCache:s,cipherSuites:r,connected:e.connected,virtualHost:e.virtualHost||null,verifyClient:e.verifyClient||!1,verify:e.verify||function(u,f,h,p){return f},verifyOptions:e.verifyOptions||{},getCertificate:e.getCertificate||null,getPrivateKey:e.getPrivateKey||null,getSignature:e.getSignature||null,input:de.util.createBuffer(),tlsData:de.util.createBuffer(),data:de.util.createBuffer(),tlsDataReady:e.tlsDataReady,dataReady:e.dataReady,heartbeatReceived:e.heartbeatReceived,closed:e.closed,error:function(u,f){f.origin=f.origin||(u.entity===P.ConnectionEnd.client?"client":"server"),f.send&&(P.queue(u,P.createAlert(u,f.alert)),P.flush(u));var h=f.fatal!==!1;h&&(u.fail=!0),e.error(u,f),h&&u.close(!1);},deflate:e.deflate||null,inflate:e.inflate||null};a.reset=function(u){a.version={major:P.Version.major,minor:P.Version.minor},a.record=null,a.session=null,a.peerCertificate=null,a.state={pending:null,current:null},a.expect=a.entity===P.ConnectionEnd.client?yre:Cre,a.fragmented=null,a.records=[],a.open=!1,a.handshakes=0,a.handshaking=!1,a.isConnected=!1,a.fail=!(u||typeof u>"u"),a.input.clear(),a.tlsData.clear(),a.data.clear(),a.state.current=P.createConnectionState(a);},a.reset();var o=function(u,f){var h=f.type-P.ContentType.change_cipher_spec,p=Hv[u.entity][u.expect];h in p?p[h](u,f):P.handleUnexpected(u,f);},c=function(u){var f=0,h=u.input,p=h.length();if(p<5)f=5-p;else {u.record={type:h.getByte(),version:{major:h.getByte(),minor:h.getByte()},length:h.getInt16(),fragment:de.util.createBuffer(),ready:!1};var g=u.record.version.major===u.version.major;g&&u.session&&u.session.version&&(g=u.record.version.minor===u.version.minor),g||u.error(u,{message:"Incompatible TLS version.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.protocol_version}});}return f},l=function(u){var f=0,h=u.input,p=h.length();if(p<u.record.length)f=u.record.length-p;else {u.record.fragment.putBytes(h.getBytes(u.record.length)),h.compact();var g=u.state.current.read;g.update(u,u.record)&&(u.fragmented!==null&&(u.fragmented.type===u.record.type?(u.fragmented.fragment.putBuffer(u.record.fragment),u.record=u.fragmented):u.error(u,{message:"Invalid fragmented record.",send:!0,alert:{level:P.Alert.Level.fatal,description:P.Alert.Description.unexpected_message}})),u.record.ready=!0);}return f};return a.handshake=function(u){if(a.entity!==P.ConnectionEnd.client)a.error(a,{message:"Cannot initiate handshake as a server.",fatal:!1});else if(a.handshaking)a.error(a,{message:"Handshake already in progress.",fatal:!1});else {a.fail&&!a.open&&a.handshakes===0&&(a.fail=!1),a.handshaking=!0,u=u||"";var f=null;u.length>0&&(a.sessionCache&&(f=a.sessionCache.getSession(u)),f===null&&(u="")),u.length===0&&a.sessionCache&&(f=a.sessionCache.getSession(),f!==null&&(u=f.id)),a.session={id:u,version:null,cipherSuite:null,compressionMethod:null,serverCertificate:null,certificateRequest:null,clientCertificate:null,sp:{},md5:de.md.md5.create(),sha1:de.md.sha1.create()},f&&(a.version=f.version,a.session.sp=f.sp),a.session.sp.client_random=P.createRandom().getBytes(),a.open=!0,P.queue(a,P.createRecord(a,{type:P.ContentType.handshake,data:P.createClientHello(a)})),P.flush(a);}},a.process=function(u){var f=0;return u&&a.input.putBytes(u),a.fail||(a.record!==null&&a.record.ready&&a.record.fragment.isEmpty()&&(a.record=null),a.record===null&&(f=c(a)),!a.fail&&a.record!==null&&!a.record.ready&&(f=l(a)),!a.fail&&a.record!==null&&a.record.ready&&o(a,a.record)),f},a.prepare=function(u){return P.queue(a,P.createRecord(a,{type:P.ContentType.application_data,data:de.util.createBuffer(u)})),P.flush(a)},a.prepareHeartbeatRequest=function(u,f){return u instanceof de.util.ByteBuffer&&(u=u.bytes()),typeof f>"u"&&(f=u.length),a.expectedHeartbeatPayload=u,P.queue(a,P.createRecord(a,{type:P.ContentType.heartbeat,data:P.createHeartbeat(P.HeartbeatMessageType.heartbeat_request,u,f)})),P.flush(a)},a.close=function(u){if(!a.fail&&a.sessionCache&&a.session){var f={id:a.session.id,version:a.session.version,sp:a.session.sp};f.sp.keys=null,a.sessionCache.setSession(f.id,f);}a.open&&(a.open=!1,a.input.clear(),(a.isConnected||a.handshaking)&&(a.isConnected=a.handshaking=!1,P.queue(a,P.createAlert(a,{level:P.Alert.Level.warning,description:P.Alert.Description.close_notify})),P.flush(a)),a.closed(a)),a.reset(u);},a};mL.exports=de.tls=de.tls||{};for(Vd in P)typeof P[Vd]!="function"&&(de.tls[Vd]=P[Vd]);var Vd;de.tls.prf_tls1=Wd;de.tls.hmac_sha1=pre;de.tls.createSessionCache=P.createSessionCache;de.tls.createConnection=P.createConnection;});var _L=I((xhe,vL)=>{var As=rt();bs();Wv();var jn=vL.exports=As.tls;jn.CipherSuites.TLS_RSA_WITH_AES_128_CBC_SHA={id:[0,47],name:"TLS_RSA_WITH_AES_128_CBC_SHA",initSecurityParameters:function(e){e.bulk_cipher_algorithm=jn.BulkCipherAlgorithm.aes,e.cipher_type=jn.CipherType.block,e.enc_key_length=16,e.block_length=16,e.fixed_iv_length=16,e.record_iv_length=16,e.mac_algorithm=jn.MACAlgorithm.hmac_sha1,e.mac_length=20,e.mac_key_length=20;},initConnectionState:yL};jn.CipherSuites.TLS_RSA_WITH_AES_256_CBC_SHA={id:[0,53],name:"TLS_RSA_WITH_AES_256_CBC_SHA",initSecurityParameters:function(e){e.bulk_cipher_algorithm=jn.BulkCipherAlgorithm.aes,e.cipher_type=jn.CipherType.block,e.enc_key_length=32,e.block_length=16,e.fixed_iv_length=16,e.record_iv_length=16,e.mac_algorithm=jn.MACAlgorithm.hmac_sha1,e.mac_length=20,e.mac_key_length=20;},initConnectionState:yL};function yL(e,t,r){var n=t.entity===As.tls.ConnectionEnd.client;e.read.cipherState={init:!1,cipher:As.cipher.createDecipher("AES-CBC",n?r.keys.server_write_key:r.keys.client_write_key),iv:n?r.keys.server_write_IV:r.keys.client_write_IV},e.write.cipherState={init:!1,cipher:As.cipher.createCipher("AES-CBC",n?r.keys.client_write_key:r.keys.server_write_key),iv:n?r.keys.client_write_IV:r.keys.server_write_IV},e.read.cipherFunction=Fre,e.write.cipherFunction=kre,e.read.macLength=e.write.macLength=r.mac_length,e.read.macFunction=e.write.macFunction=jn.hmac_sha1;}function kre(e,t){var r=!1,n=t.macFunction(t.macKey,t.sequenceNumber,e);e.fragment.putBytes(n),t.updateSequenceNumber();var i;e.version.minor===jn.Versions.TLS_1_0.minor?i=t.cipherState.init?null:t.cipherState.iv:i=As.random.getBytesSync(16),t.cipherState.init=!0;var s=t.cipherState.cipher;return s.start({iv:i}),e.version.minor>=jn.Versions.TLS_1_1.minor&&s.output.putBytes(i),s.update(e.fragment),s.finish(Lre)&&(e.fragment=s.output,e.length=e.fragment.length(),r=!0),r}function Lre(e,t,r){if(!r){var n=e-t.length()%e;t.fillWithByte(n-1,n);}return !0}function Bre(e,t,r){var n=!0;if(r){for(var i=t.length(),s=t.last(),a=i-1-s;a<i-1;++a)n=n&&t.at(a)==s;n&&t.truncate(s+1);}return n}function Fre(e,t){var r=!1,n;e.version.minor===jn.Versions.TLS_1_0.minor?n=t.cipherState.init?null:t.cipherState.iv:n=e.fragment.getBytes(16),t.cipherState.init=!0;var i=t.cipherState.cipher;i.start({iv:n}),i.update(e.fragment),r=i.finish(Bre);var s=t.macLength,a=As.random.getBytesSync(s),o=i.output.length();o>=s?(e.fragment=i.output.getBytes(o-s),a=i.output.getBytes(s)):e.fragment=i.output.getBytes(),e.fragment=As.util.createBuffer(e.fragment),e.length=e.fragment.length();var c=t.macFunction(t.macKey,t.sequenceNumber,e);return t.updateSequenceNumber(),r=qre(t.macKey,a,c)&&r,r}function qre(e,t,r){var n=As.hmac.create();return n.start("SHA1",e),n.update(t),t=n.digest().getBytes(),n.start(null,null),n.update(r),r=n.digest().getBytes(),t===r}});var zv=I((The,wL)=>{var Kt=rt();bi();_t();var Tc=wL.exports=Kt.sha512=Kt.sha512||{};Kt.md.sha512=Kt.md.algorithms.sha512=Tc;var SL=Kt.sha384=Kt.sha512.sha384=Kt.sha512.sha384||{};SL.create=function(){return Tc.create("SHA-384")};Kt.md.sha384=Kt.md.algorithms.sha384=SL;Kt.sha512.sha256=Kt.sha512.sha256||{create:function(){return Tc.create("SHA-512/256")}};Kt.md["sha512/256"]=Kt.md.algorithms["sha512/256"]=Kt.sha512.sha256;Kt.sha512.sha224=Kt.sha512.sha224||{create:function(){return Tc.create("SHA-512/224")}};Kt.md["sha512/224"]=Kt.md.algorithms["sha512/224"]=Kt.sha512.sha224;Tc.create=function(e){if(EL||Mre(),typeof e>"u"&&(e="SHA-512"),!(e in Ea))throw new Error("Invalid SHA-512 algorithm: "+e);for(var t=Ea[e],r=null,n=Kt.util.createBuffer(),i=new Array(80),s=0;s<80;++s)i[s]=new Array(2);var a=64;switch(e){case"SHA-384":a=48;break;case"SHA-512/256":a=32;break;case"SHA-512/224":a=28;break}var o={algorithm:e.replace("-","").toLowerCase(),blockLength:128,digestLength:a,messageLength:0,fullMessageLength:null,messageLengthSize:16};return o.start=function(){o.messageLength=0,o.fullMessageLength=o.messageLength128=[];for(var c=o.messageLengthSize/4,l=0;l<c;++l)o.fullMessageLength.push(0);n=Kt.util.createBuffer(),r=new Array(t.length);for(var l=0;l<t.length;++l)r[l]=t[l].slice(0);return o},o.start(),o.update=function(c,l){l==="utf8"&&(c=Kt.util.encodeUtf8(c));var u=c.length;o.messageLength+=u,u=[u/4294967296>>>0,u>>>0];for(var f=o.fullMessageLength.length-1;f>=0;--f)o.fullMessageLength[f]+=u[1],u[1]=u[0]+(o.fullMessageLength[f]/4294967296>>>0),o.fullMessageLength[f]=o.fullMessageLength[f]>>>0,u[0]=u[1]/4294967296>>>0;return n.putBytes(c),bL(r,i,n),(n.read>2048||n.length()===0)&&n.compact(),o},o.digest=function(){var c=Kt.util.createBuffer();c.putBytes(n.bytes());var l=o.fullMessageLength[o.fullMessageLength.length-1]+o.messageLengthSize,u=l&o.blockLength-1;c.putBytes(Kv.substr(0,o.blockLength-u));for(var f,h,p=o.fullMessageLength[0]*8,g=0;g<o.fullMessageLength.length-1;++g)f=o.fullMessageLength[g+1]*8,h=f/4294967296>>>0,p+=h,c.putInt32(p>>>0),p=f>>>0;c.putInt32(p);for(var _=new Array(r.length),g=0;g<r.length;++g)_[g]=r[g].slice(0);bL(_,i,c);var E=Kt.util.createBuffer(),w;e==="SHA-512"?w=_.length:e==="SHA-384"?w=_.length-2:w=_.length-4;for(var g=0;g<w;++g)E.putInt32(_[g][0]),(g!==w-1||e!=="SHA-512/224")&&E.putInt32(_[g][1]);return E},o};var Kv=null,EL=!1,Gv=null,Ea=null;function Mre(){Kv="\x80",Kv+=Kt.util.fillString("\0",128),Gv=[[1116352408,3609767458],[1899447441,602891725],[3049323471,3964484399],[3921009573,2173295548],[961987163,4081628472],[1508970993,3053834265],[2453635748,2937671579],[2870763221,3664609560],[3624381080,2734883394],[310598401,1164996542],[607225278,1323610764],[1426881987,3590304994],[1925078388,4068182383],[2162078206,991336113],[2614888103,633803317],[3248222580,3479774868],[3835390401,2666613458],[4022224774,944711139],[264347078,2341262773],[604807628,2007800933],[770255983,1495990901],[1249150122,1856431235],[1555081692,3175218132],[1996064986,2198950837],[2554220882,3999719339],[2821834349,766784016],[2952996808,2566594879],[3210313671,3203337956],[3336571891,1034457026],[3584528711,2466948901],[113926993,3758326383],[338241895,168717936],[666307205,1188179964],[773529912,1546045734],[1294757372,1522805485],[1396182291,2643833823],[1695183700,2343527390],[1986661051,1014477480],[2177026350,1206759142],[2456956037,344077627],[2730485921,1290863460],[2820302411,3158454273],[3259730800,3505952657],[3345764771,106217008],[3516065817,3606008344],[3600352804,1432725776],[4094571909,1467031594],[275423344,851169720],[430227734,3100823752],[506948616,1363258195],[659060556,3750685593],[883997877,3785050280],[958139571,3318307427],[1322822218,3812723403],[1537002063,2003034995],[1747873779,3602036899],[1955562222,1575990012],[2024104815,1125592928],[2227730452,2716904306],[2361852424,442776044],[2428436474,593698344],[2756734187,3733110249],[3204031479,2999351573],[3329325298,3815920427],[3391569614,3928383900],[3515267271,566280711],[3940187606,3454069534],[4118630271,4000239992],[116418474,1914138554],[174292421,2731055270],[289380356,3203993006],[460393269,320620315],[685471733,587496836],[852142971,1086792851],[1017036298,365543100],[1126000580,2618297676],[1288033470,3409855158],[1501505948,4234509866],[1607167915,987167468],[1816402316,1246189591]],Ea={},Ea["SHA-512"]=[[1779033703,4089235720],[3144134277,2227873595],[1013904242,4271175723],[2773480762,1595750129],[1359893119,2917565137],[2600822924,725511199],[528734635,4215389547],[1541459225,327033209]],Ea["SHA-384"]=[[3418070365,3238371032],[1654270250,914150663],[2438529370,812702999],[355462360,4144912697],[1731405415,4290775857],[2394180231,1750603025],[3675008525,1694076839],[1203062813,3204075428]],Ea["SHA-512/256"]=[[573645204,4230739756],[2673172387,3360449730],[596883563,1867755857],[2520282905,1497426621],[2519219938,2827943907],[3193839141,1401305490],[721525244,746961066],[246885852,2177182882]],Ea["SHA-512/224"]=[[2352822216,424955298],[1944164710,2312950998],[502970286,855612546],[1738396948,1479516111],[258812777,2077511080],[2011393907,79989058],[1067287976,1780299464],[286451373,2446758561]],EL=!0;}function bL(e,t,r){for(var n,i,s,a,o,c,l,u,f,h,p,g,_,E,w,y,b,N,L,V,Z,G,z,ee,U,ie,me,Pe,W,K,se,Ae,Me,ze,We,lt=r.length();lt>=128;){for(W=0;W<16;++W)t[W][0]=r.getInt32()>>>0,t[W][1]=r.getInt32()>>>0;for(;W<80;++W)Ae=t[W-2],K=Ae[0],se=Ae[1],n=((K>>>19|se<<13)^(se>>>29|K<<3)^K>>>6)>>>0,i=((K<<13|se>>>19)^(se<<3|K>>>29)^(K<<26|se>>>6))>>>0,ze=t[W-15],K=ze[0],se=ze[1],s=((K>>>1|se<<31)^(K>>>8|se<<24)^K>>>7)>>>0,a=((K<<31|se>>>1)^(K<<24|se>>>8)^(K<<25|se>>>7))>>>0,Me=t[W-7],We=t[W-16],se=i+Me[1]+a+We[1],t[W][0]=n+Me[0]+s+We[0]+(se/4294967296>>>0)>>>0,t[W][1]=se>>>0;for(_=e[0][0],E=e[0][1],w=e[1][0],y=e[1][1],b=e[2][0],N=e[2][1],L=e[3][0],V=e[3][1],Z=e[4][0],G=e[4][1],z=e[5][0],ee=e[5][1],U=e[6][0],ie=e[6][1],me=e[7][0],Pe=e[7][1],W=0;W<80;++W)l=((Z>>>14|G<<18)^(Z>>>18|G<<14)^(G>>>9|Z<<23))>>>0,u=((Z<<18|G>>>14)^(Z<<14|G>>>18)^(G<<23|Z>>>9))>>>0,f=(U^Z&(z^U))>>>0,h=(ie^G&(ee^ie))>>>0,o=((_>>>28|E<<4)^(E>>>2|_<<30)^(E>>>7|_<<25))>>>0,c=((_<<4|E>>>28)^(E<<30|_>>>2)^(E<<25|_>>>7))>>>0,p=(_&w|b&(_^w))>>>0,g=(E&y|N&(E^y))>>>0,se=Pe+u+h+Gv[W][1]+t[W][1],n=me+l+f+Gv[W][0]+t[W][0]+(se/4294967296>>>0)>>>0,i=se>>>0,se=c+g,s=o+p+(se/4294967296>>>0)>>>0,a=se>>>0,me=U,Pe=ie,U=z,ie=ee,z=Z,ee=G,se=V+i,Z=L+n+(se/4294967296>>>0)>>>0,G=se>>>0,L=b,V=N,b=w,N=y,w=_,y=E,se=i+a,_=n+s+(se/4294967296>>>0)>>>0,E=se>>>0;se=e[0][1]+E,e[0][0]=e[0][0]+_+(se/4294967296>>>0)>>>0,e[0][1]=se>>>0,se=e[1][1]+y,e[1][0]=e[1][0]+w+(se/4294967296>>>0)>>>0,e[1][1]=se>>>0,se=e[2][1]+N,e[2][0]=e[2][0]+b+(se/4294967296>>>0)>>>0,e[2][1]=se>>>0,se=e[3][1]+V,e[3][0]=e[3][0]+L+(se/4294967296>>>0)>>>0,e[3][1]=se>>>0,se=e[4][1]+G,e[4][0]=e[4][0]+Z+(se/4294967296>>>0)>>>0,e[4][1]=se>>>0,se=e[5][1]+ee,e[5][0]=e[5][0]+z+(se/4294967296>>>0)>>>0,e[5][1]=se>>>0,se=e[6][1]+ie,e[6][0]=e[6][0]+U+(se/4294967296>>>0)>>>0,e[6][1]=se>>>0,se=e[7][1]+Pe,e[7][0]=e[7][0]+me+(se/4294967296>>>0)>>>0,e[7][1]=se>>>0,lt-=128;}}});var CL=I(Yv=>{var Ure=rt();ai();var wr=Ure.asn1;Yv.privateKeyValidator={name:"PrivateKeyInfo",tagClass:wr.Class.UNIVERSAL,type:wr.Type.SEQUENCE,constructed:!0,value:[{name:"PrivateKeyInfo.version",tagClass:wr.Class.UNIVERSAL,type:wr.Type.INTEGER,constructed:!1,capture:"privateKeyVersion"},{name:"PrivateKeyInfo.privateKeyAlgorithm",tagClass:wr.Class.UNIVERSAL,type:wr.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:wr.Class.UNIVERSAL,type:wr.Type.OID,constructed:!1,capture:"privateKeyOid"}]},{name:"PrivateKeyInfo",tagClass:wr.Class.UNIVERSAL,type:wr.Type.OCTETSTRING,constructed:!1,capture:"privateKey"}]};Yv.publicKeyValidator={name:"SubjectPublicKeyInfo",tagClass:wr.Class.UNIVERSAL,type:wr.Type.SEQUENCE,constructed:!0,captureAsn1:"subjectPublicKeyInfo",value:[{name:"SubjectPublicKeyInfo.AlgorithmIdentifier",tagClass:wr.Class.UNIVERSAL,type:wr.Type.SEQUENCE,constructed:!0,value:[{name:"AlgorithmIdentifier.algorithm",tagClass:wr.Class.UNIVERSAL,type:wr.Type.OID,constructed:!1,capture:"publicKeyOid"}]},{tagClass:wr.Class.UNIVERSAL,type:wr.Type.BITSTRING,constructed:!1,composed:!0,captureBitStringValue:"ed25519PublicKey"}]};});var FL=I((Rhe,BL)=>{var Dr=rt();Ec();Fn();zv();_t();var PL=CL(),$re=PL.publicKeyValidator,jre=PL.privateKeyValidator;var Zv=Dr.util.ByteBuffer,cn=typeof Buffer>"u"?Uint8Array:Buffer;Dr.pki=Dr.pki||{};BL.exports=Dr.pki.ed25519=Dr.ed25519=Dr.ed25519||{};var ct=Dr.ed25519;ct.constants={};ct.constants.PUBLIC_KEY_BYTE_LENGTH=32;ct.constants.PRIVATE_KEY_BYTE_LENGTH=64;ct.constants.SEED_BYTE_LENGTH=32;ct.constants.SIGN_BYTE_LENGTH=64;ct.constants.HASH_BYTE_LENGTH=64;ct.generateKeyPair=function(e){e=e||{};var t=e.seed;if(t===void 0)t=Dr.random.getBytesSync(ct.constants.SEED_BYTE_LENGTH);else if(typeof t=="string"){if(t.length!==ct.constants.SEED_BYTE_LENGTH)throw new TypeError('"seed" must be '+ct.constants.SEED_BYTE_LENGTH+" bytes in length.")}else if(!(t instanceof Uint8Array))throw new TypeError('"seed" must be a node.js Buffer, Uint8Array, or a binary string.');t=Qi({message:t,encoding:"binary"});for(var r=new cn(ct.constants.PUBLIC_KEY_BYTE_LENGTH),n=new cn(ct.constants.PRIVATE_KEY_BYTE_LENGTH),i=0;i<32;++i)n[i]=t[i];return Kre(r,n),{publicKey:r,privateKey:n}};ct.privateKeyFromAsn1=function(e){var t={},r=[],n=Dr.asn1.validate(e,jre,t,r);if(!n){var i=new Error("Invalid Key.");throw i.errors=r,i}var s=Dr.asn1.derToOid(t.privateKeyOid),a=Dr.oids.EdDSA25519;if(s!==a)throw new Error('Invalid OID "'+s+'"; OID must be "'+a+'".');var o=t.privateKey,c=Qi({message:Dr.asn1.fromDer(o).value,encoding:"binary"});return {privateKeyBytes:c}};ct.publicKeyFromAsn1=function(e){var t={},r=[],n=Dr.asn1.validate(e,$re,t,r);if(!n){var i=new Error("Invalid Key.");throw i.errors=r,i}var s=Dr.asn1.derToOid(t.publicKeyOid),a=Dr.oids.EdDSA25519;if(s!==a)throw new Error('Invalid OID "'+s+'"; OID must be "'+a+'".');var o=t.ed25519PublicKey;if(o.length!==ct.constants.PUBLIC_KEY_BYTE_LENGTH)throw new Error("Key length is invalid.");return Qi({message:o,encoding:"binary"})};ct.publicKeyFromPrivateKey=function(e){e=e||{};var t=Qi({message:e.privateKey,encoding:"binary"});if(t.length!==ct.constants.PRIVATE_KEY_BYTE_LENGTH)throw new TypeError('"options.privateKey" must have a byte length of '+ct.constants.PRIVATE_KEY_BYTE_LENGTH);for(var r=new cn(ct.constants.PUBLIC_KEY_BYTE_LENGTH),n=0;n<r.length;++n)r[n]=t[32+n];return r};ct.sign=function(e){e=e||{};var t=Qi(e),r=Qi({message:e.privateKey,encoding:"binary"});if(r.length===ct.constants.SEED_BYTE_LENGTH){var n=ct.generateKeyPair({seed:r});r=n.privateKey;}else if(r.length!==ct.constants.PRIVATE_KEY_BYTE_LENGTH)throw new TypeError('"options.privateKey" must have a byte length of '+ct.constants.SEED_BYTE_LENGTH+" or "+ct.constants.PRIVATE_KEY_BYTE_LENGTH);var i=new cn(ct.constants.SIGN_BYTE_LENGTH+t.length);Gre(i,t,t.length,r);for(var s=new cn(ct.constants.SIGN_BYTE_LENGTH),a=0;a<s.length;++a)s[a]=i[a];return s};ct.verify=function(e){e=e||{};var t=Qi(e);if(e.signature===void 0)throw new TypeError('"options.signature" must be a node.js Buffer, a Uint8Array, a forge ByteBuffer, or a binary string.');var r=Qi({message:e.signature,encoding:"binary"});if(r.length!==ct.constants.SIGN_BYTE_LENGTH)throw new TypeError('"options.signature" must have a byte length of '+ct.constants.SIGN_BYTE_LENGTH);var n=Qi({message:e.publicKey,encoding:"binary"});if(n.length!==ct.constants.PUBLIC_KEY_BYTE_LENGTH)throw new TypeError('"options.publicKey" must have a byte length of '+ct.constants.PUBLIC_KEY_BYTE_LENGTH);var i=new cn(ct.constants.SIGN_BYTE_LENGTH+t.length),s=new cn(ct.constants.SIGN_BYTE_LENGTH+t.length),a;for(a=0;a<ct.constants.SIGN_BYTE_LENGTH;++a)i[a]=r[a];for(a=0;a<t.length;++a)i[a+ct.constants.SIGN_BYTE_LENGTH]=t[a];return zre(s,i,i.length,n)>=0};function Qi(e){var t=e.message;if(t instanceof Uint8Array||t instanceof cn)return t;var r=e.encoding;if(t===void 0)if(e.md)t=e.md.digest().getBytes(),r="binary";else throw new TypeError('"options.message" or "options.md" not specified.');if(typeof t=="string"&&!r)throw new TypeError('"options.encoding" must be "binary" or "utf8".');if(typeof t=="string"){if(typeof Buffer<"u")return Buffer.from(t,r);t=new Zv(t,r);}else if(!(t instanceof Zv))throw new TypeError('"options.message" must be a node.js Buffer, a Uint8Array, a forge ByteBuffer, or a string with "options.encoding" specifying its encoding.');for(var n=new cn(t.length()),i=0;i<n.length;++i)n[i]=t.at(i);return n}var Jv=je(),Kd=je([1]),Vre=je([30883,4953,19914,30187,55467,16705,2637,112,59544,30585,16505,36039,65139,11119,27886,20995]),Hre=je([61785,9906,39828,60374,45398,33411,5274,224,53552,61171,33010,6542,64743,22239,55772,9222]),TL=je([54554,36645,11616,51542,42930,38181,51040,26924,56412,64982,57905,49316,21502,52590,14035,8553]),AL=je([26200,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214,26214]),Qv=new Float64Array([237,211,245,92,26,99,18,88,214,156,247,162,222,249,222,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16]),Wre=je([41136,18958,6951,50414,58488,44335,6150,12099,55207,15867,153,11085,57099,20417,9344,11139]);function Ac(e,t){var r=Dr.md.sha512.create(),n=new Zv(e);r.update(n.getBytes(t),"binary");var i=r.digest().getBytes();if(typeof Buffer<"u")return Buffer.from(i,"binary");for(var s=new cn(ct.constants.HASH_BYTE_LENGTH),a=0;a<64;++a)s[a]=i.charCodeAt(a);return s}function Kre(e,t){var r=[je(),je(),je(),je()],n,i=Ac(t,32);for(i[0]&=248,i[31]&=127,i[31]|=64,n_(r,i),r_(e,r),n=0;n<32;++n)t[n+32]=e[n];return 0}function Gre(e,t,r,n){var i,s,a=new Float64Array(64),o=[je(),je(),je(),je()],c=Ac(n,32);c[0]&=248,c[31]&=127,c[31]|=64;var l=r+64;for(i=0;i<r;++i)e[64+i]=t[i];for(i=0;i<32;++i)e[32+i]=c[32+i];var u=Ac(e.subarray(32),r+32);for(e_(u),n_(o,u),r_(e,o),i=32;i<64;++i)e[i]=n[i];var f=Ac(e,r+64);for(e_(f),i=32;i<64;++i)a[i]=0;for(i=0;i<32;++i)a[i]=u[i];for(i=0;i<32;++i)for(s=0;s<32;s++)a[i+s]+=f[i]*c[s];return NL(e.subarray(32),a),l}function zre(e,t,r,n){var i,s,a=new cn(32),o=[je(),je(),je(),je()],c=[je(),je(),je(),je()];if(s=-1,r<64||Yre(c,n))return -1;for(i=0;i<r;++i)e[i]=t[i];for(i=0;i<32;++i)e[i+32]=n[i];var l=Ac(e,r);if(e_(l),kL(o,c,l),n_(c,t.subarray(32)),t_(o,c),r_(a,o),r-=64,DL(t,0,a,0)){for(i=0;i<r;++i)e[i]=0;return -1}for(i=0;i<r;++i)e[i]=t[i+64];return s=r,s}function NL(e,t){var r,n,i,s;for(n=63;n>=32;--n){for(r=0,i=n-32,s=n-12;i<s;++i)t[i]+=r-16*t[n]*Qv[i-(n-32)],r=t[i]+128>>8,t[i]-=r*256;t[i]+=r,t[n]=0;}for(r=0,i=0;i<32;++i)t[i]+=r-(t[31]>>4)*Qv[i],r=t[i]>>8,t[i]&=255;for(i=0;i<32;++i)t[i]-=r*Qv[i];for(n=0;n<32;++n)t[n+1]+=t[n]>>8,e[n]=t[n]&255;}function e_(e){for(var t=new Float64Array(64),r=0;r<64;++r)t[r]=e[r],e[r]=0;NL(e,t);}function t_(e,t){var r=je(),n=je(),i=je(),s=je(),a=je(),o=je(),c=je(),l=je(),u=je();ko(r,e[1],e[0]),ko(u,t[1],t[0]),Ft(r,r,u),Oo(n,e[0],e[1]),Oo(u,t[0],t[1]),Ft(n,n,u),Ft(i,e[3],t[3]),Ft(i,i,Hre),Ft(s,e[2],t[2]),Oo(s,s,s),ko(a,n,r),ko(o,s,i),Oo(c,s,i),Oo(l,n,r),Ft(e[0],a,o),Ft(e[1],l,c),Ft(e[2],c,o),Ft(e[3],a,l);}function RL(e,t,r){for(var n=0;n<4;++n)LL(e[n],t[n],r);}function r_(e,t){var r=je(),n=je(),i=je();Jre(i,t[2]),Ft(r,t[0],i),Ft(n,t[1],i),Gd(e,n),e[31]^=OL(r)<<7;}function Gd(e,t){var r,n,i,s=je(),a=je();for(r=0;r<16;++r)a[r]=t[r];for(Xv(a),Xv(a),Xv(a),n=0;n<2;++n){for(s[0]=a[0]-65517,r=1;r<15;++r)s[r]=a[r]-65535-(s[r-1]>>16&1),s[r-1]&=65535;s[15]=a[15]-32767-(s[14]>>16&1),i=s[15]>>16&1,s[14]&=65535,LL(a,s,1-i);}for(r=0;r<16;r++)e[2*r]=a[r]&255,e[2*r+1]=a[r]>>8;}function Yre(e,t){var r=je(),n=je(),i=je(),s=je(),a=je(),o=je(),c=je();return Rs(e[2],Kd),Qre(e[1],t),wa(i,e[1]),Ft(s,i,Vre),ko(i,i,e[2]),Oo(s,e[2],s),wa(a,s),wa(o,a),Ft(c,o,a),Ft(r,c,i),Ft(r,r,s),Xre(r,r),Ft(r,r,i),Ft(r,r,s),Ft(r,r,s),Ft(e[0],r,s),wa(n,e[0]),Ft(n,n,s),IL(n,i)&&Ft(e[0],e[0],Wre),wa(n,e[0]),Ft(n,n,s),IL(n,i)?-1:(OL(e[0])===t[31]>>7&&ko(e[0],Jv,e[0]),Ft(e[3],e[0],e[1]),0)}function Qre(e,t){var r;for(r=0;r<16;++r)e[r]=t[2*r]+(t[2*r+1]<<8);e[15]&=32767;}function Xre(e,t){var r=je(),n;for(n=0;n<16;++n)r[n]=t[n];for(n=250;n>=0;--n)wa(r,r),n!==1&&Ft(r,r,t);for(n=0;n<16;++n)e[n]=r[n];}function IL(e,t){var r=new cn(32),n=new cn(32);return Gd(r,e),Gd(n,t),DL(r,0,n,0)}function DL(e,t,r,n){return Zre(e,t,r,n,32)}function Zre(e,t,r,n,i){var s,a=0;for(s=0;s<i;++s)a|=e[t+s]^r[n+s];return (1&a-1>>>8)-1}function OL(e){var t=new cn(32);return Gd(t,e),t[0]&1}function kL(e,t,r){var n,i;for(Rs(e[0],Jv),Rs(e[1],Kd),Rs(e[2],Kd),Rs(e[3],Jv),i=255;i>=0;--i)n=r[i/8|0]>>(i&7)&1,RL(e,t,n),t_(t,e),t_(e,e),RL(e,t,n);}function n_(e,t){var r=[je(),je(),je(),je()];Rs(r[0],TL),Rs(r[1],AL),Rs(r[2],Kd),Ft(r[3],TL,AL),kL(e,r,t);}function Rs(e,t){var r;for(r=0;r<16;r++)e[r]=t[r]|0;}function Jre(e,t){var r=je(),n;for(n=0;n<16;++n)r[n]=t[n];for(n=253;n>=0;--n)wa(r,r),n!==2&&n!==4&&Ft(r,r,t);for(n=0;n<16;++n)e[n]=r[n];}function Xv(e){var t,r,n=1;for(t=0;t<16;++t)r=e[t]+n+65535,n=Math.floor(r/65536),e[t]=r-n*65536;e[0]+=n-1+37*(n-1);}function LL(e,t,r){for(var n,i=~(r-1),s=0;s<16;++s)n=i&(e[s]^t[s]),e[s]^=n,t[s]^=n;}function je(e){var t,r=new Float64Array(16);if(e)for(t=0;t<e.length;++t)r[t]=e[t];return r}function Oo(e,t,r){for(var n=0;n<16;++n)e[n]=t[n]+r[n];}function ko(e,t,r){for(var n=0;n<16;++n)e[n]=t[n]-r[n];}function wa(e,t){Ft(e,t,t);}function Ft(e,t,r){var n,i,s=0,a=0,o=0,c=0,l=0,u=0,f=0,h=0,p=0,g=0,_=0,E=0,w=0,y=0,b=0,N=0,L=0,V=0,Z=0,G=0,z=0,ee=0,U=0,ie=0,me=0,Pe=0,W=0,K=0,se=0,Ae=0,Me=0,ze=r[0],We=r[1],lt=r[2],Bt=r[3],Ct=r[4],pt=r[5],Be=r[6],Dt=r[7],Vt=r[8],ye=r[9],Ve=r[10],le=r[11],Ie=r[12],Ke=r[13],nt=r[14],Ye=r[15];n=t[0],s+=n*ze,a+=n*We,o+=n*lt,c+=n*Bt,l+=n*Ct,u+=n*pt,f+=n*Be,h+=n*Dt,p+=n*Vt,g+=n*ye,_+=n*Ve,E+=n*le,w+=n*Ie,y+=n*Ke,b+=n*nt,N+=n*Ye,n=t[1],a+=n*ze,o+=n*We,c+=n*lt,l+=n*Bt,u+=n*Ct,f+=n*pt,h+=n*Be,p+=n*Dt,g+=n*Vt,_+=n*ye,E+=n*Ve,w+=n*le,y+=n*Ie,b+=n*Ke,N+=n*nt,L+=n*Ye,n=t[2],o+=n*ze,c+=n*We,l+=n*lt,u+=n*Bt,f+=n*Ct,h+=n*pt,p+=n*Be,g+=n*Dt,_+=n*Vt,E+=n*ye,w+=n*Ve,y+=n*le,b+=n*Ie,N+=n*Ke,L+=n*nt,V+=n*Ye,n=t[3],c+=n*ze,l+=n*We,u+=n*lt,f+=n*Bt,h+=n*Ct,p+=n*pt,g+=n*Be,_+=n*Dt,E+=n*Vt,w+=n*ye,y+=n*Ve,b+=n*le,N+=n*Ie,L+=n*Ke,V+=n*nt,Z+=n*Ye,n=t[4],l+=n*ze,u+=n*We,f+=n*lt,h+=n*Bt,p+=n*Ct,g+=n*pt,_+=n*Be,E+=n*Dt,w+=n*Vt,y+=n*ye,b+=n*Ve,N+=n*le,L+=n*Ie,V+=n*Ke,Z+=n*nt,G+=n*Ye,n=t[5],u+=n*ze,f+=n*We,h+=n*lt,p+=n*Bt,g+=n*Ct,_+=n*pt,E+=n*Be,w+=n*Dt,y+=n*Vt,b+=n*ye,N+=n*Ve,L+=n*le,V+=n*Ie,Z+=n*Ke,G+=n*nt,z+=n*Ye,n=t[6],f+=n*ze,h+=n*We,p+=n*lt,g+=n*Bt,_+=n*Ct,E+=n*pt,w+=n*Be,y+=n*Dt,b+=n*Vt,N+=n*ye,L+=n*Ve,V+=n*le,Z+=n*Ie,G+=n*Ke,z+=n*nt,ee+=n*Ye,n=t[7],h+=n*ze,p+=n*We,g+=n*lt,_+=n*Bt,E+=n*Ct,w+=n*pt,y+=n*Be,b+=n*Dt,N+=n*Vt,L+=n*ye,V+=n*Ve,Z+=n*le,G+=n*Ie,z+=n*Ke,ee+=n*nt,U+=n*Ye,n=t[8],p+=n*ze,g+=n*We,_+=n*lt,E+=n*Bt,w+=n*Ct,y+=n*pt,b+=n*Be,N+=n*Dt,L+=n*Vt,V+=n*ye,Z+=n*Ve,G+=n*le,z+=n*Ie,ee+=n*Ke,U+=n*nt,ie+=n*Ye,n=t[9],g+=n*ze,_+=n*We,E+=n*lt,w+=n*Bt,y+=n*Ct,b+=n*pt,N+=n*Be,L+=n*Dt,V+=n*Vt,Z+=n*ye,G+=n*Ve,z+=n*le,ee+=n*Ie,U+=n*Ke,ie+=n*nt,me+=n*Ye,n=t[10],_+=n*ze,E+=n*We,w+=n*lt,y+=n*Bt,b+=n*Ct,N+=n*pt,L+=n*Be,V+=n*Dt,Z+=n*Vt,G+=n*ye,z+=n*Ve,ee+=n*le,U+=n*Ie,ie+=n*Ke,me+=n*nt,Pe+=n*Ye,n=t[11],E+=n*ze,w+=n*We,y+=n*lt,b+=n*Bt,N+=n*Ct,L+=n*pt,V+=n*Be,Z+=n*Dt,G+=n*Vt,z+=n*ye,ee+=n*Ve,U+=n*le,ie+=n*Ie,me+=n*Ke,Pe+=n*nt,W+=n*Ye,n=t[12],w+=n*ze,y+=n*We,b+=n*lt,N+=n*Bt,L+=n*Ct,V+=n*pt,Z+=n*Be,G+=n*Dt,z+=n*Vt,ee+=n*ye,U+=n*Ve,ie+=n*le,me+=n*Ie,Pe+=n*Ke,W+=n*nt,K+=n*Ye,n=t[13],y+=n*ze,b+=n*We,N+=n*lt,L+=n*Bt,V+=n*Ct,Z+=n*pt,G+=n*Be,z+=n*Dt,ee+=n*Vt,U+=n*ye,ie+=n*Ve,me+=n*le,Pe+=n*Ie,W+=n*Ke,K+=n*nt,se+=n*Ye,n=t[14],b+=n*ze,N+=n*We,L+=n*lt,V+=n*Bt,Z+=n*Ct,G+=n*pt,z+=n*Be,ee+=n*Dt,U+=n*Vt,ie+=n*ye,me+=n*Ve,Pe+=n*le,W+=n*Ie,K+=n*Ke,se+=n*nt,Ae+=n*Ye,n=t[15],N+=n*ze,L+=n*We,V+=n*lt,Z+=n*Bt,G+=n*Ct,z+=n*pt,ee+=n*Be,U+=n*Dt,ie+=n*Vt,me+=n*ye,Pe+=n*Ve,W+=n*le,K+=n*Ie,se+=n*Ke,Ae+=n*nt,Me+=n*Ye,s+=38*L,a+=38*V,o+=38*Z,c+=38*G,l+=38*z,u+=38*ee,f+=38*U,h+=38*ie,p+=38*me,g+=38*Pe,_+=38*W,E+=38*K,w+=38*se,y+=38*Ae,b+=38*Me,i=1,n=s+i+65535,i=Math.floor(n/65536),s=n-i*65536,n=a+i+65535,i=Math.floor(n/65536),a=n-i*65536,n=o+i+65535,i=Math.floor(n/65536),o=n-i*65536,n=c+i+65535,i=Math.floor(n/65536),c=n-i*65536,n=l+i+65535,i=Math.floor(n/65536),l=n-i*65536,n=u+i+65535,i=Math.floor(n/65536),u=n-i*65536,n=f+i+65535,i=Math.floor(n/65536),f=n-i*65536,n=h+i+65535,i=Math.floor(n/65536),h=n-i*65536,n=p+i+65535,i=Math.floor(n/65536),p=n-i*65536,n=g+i+65535,i=Math.floor(n/65536),g=n-i*65536,n=_+i+65535,i=Math.floor(n/65536),_=n-i*65536,n=E+i+65535,i=Math.floor(n/65536),E=n-i*65536,n=w+i+65535,i=Math.floor(n/65536),w=n-i*65536,n=y+i+65535,i=Math.floor(n/65536),y=n-i*65536,n=b+i+65535,i=Math.floor(n/65536),b=n-i*65536,n=N+i+65535,i=Math.floor(n/65536),N=n-i*65536,s+=i-1+37*(i-1),i=1,n=s+i+65535,i=Math.floor(n/65536),s=n-i*65536,n=a+i+65535,i=Math.floor(n/65536),a=n-i*65536,n=o+i+65535,i=Math.floor(n/65536),o=n-i*65536,n=c+i+65535,i=Math.floor(n/65536),c=n-i*65536,n=l+i+65535,i=Math.floor(n/65536),l=n-i*65536,n=u+i+65535,i=Math.floor(n/65536),u=n-i*65536,n=f+i+65535,i=Math.floor(n/65536),f=n-i*65536,n=h+i+65535,i=Math.floor(n/65536),h=n-i*65536,n=p+i+65535,i=Math.floor(n/65536),p=n-i*65536,n=g+i+65535,i=Math.floor(n/65536),g=n-i*65536,n=_+i+65535,i=Math.floor(n/65536),_=n-i*65536,n=E+i+65535,i=Math.floor(n/65536),E=n-i*65536,n=w+i+65535,i=Math.floor(n/65536),w=n-i*65536,n=y+i+65535,i=Math.floor(n/65536),y=n-i*65536,n=b+i+65535,i=Math.floor(n/65536),b=n-i*65536,n=N+i+65535,i=Math.floor(n/65536),N=n-i*65536,s+=i-1+37*(i-1),e[0]=s,e[1]=a,e[2]=o,e[3]=c,e[4]=l,e[5]=u,e[6]=f,e[7]=h,e[8]=p,e[9]=g,e[10]=_,e[11]=E,e[12]=w,e[13]=y,e[14]=b,e[15]=N;}});var $L=I((Ihe,UL)=>{var xn=rt();_t();Fn();Ec();UL.exports=xn.kem=xn.kem||{};var qL=xn.jsbn.BigInteger;xn.kem.rsa={};xn.kem.rsa.create=function(e,t){t=t||{};var r=t.prng||xn.random,n={};return n.encrypt=function(i,s){var a=Math.ceil(i.n.bitLength()/8),o;do o=new qL(xn.util.bytesToHex(r.getBytesSync(a)),16).mod(i.n);while(o.compareTo(qL.ONE)<=0);o=xn.util.hexToBytes(o.toString(16));var c=a-o.length;c>0&&(o=xn.util.fillString("\0",c)+o);var l=i.encrypt(o,"NONE"),u=e.generate(o,s);return {encapsulation:l,key:u}},n.decrypt=function(i,s,a){var o=i.decrypt(s,"NONE");return e.generate(o,a)},n};xn.kem.kdf1=function(e,t){ML(this,e,0,t||e.digestLength);};xn.kem.kdf2=function(e,t){ML(this,e,1,t||e.digestLength);};function ML(e,t,r,n){e.generate=function(i,s){for(var a=new xn.util.ByteBuffer,o=Math.ceil(s/n)+r,c=new xn.util.ByteBuffer,l=r;l<o;++l){c.putInt32(l),t.start(),t.update(i+c.getBytes());var u=t.digest();a.putBytes(u.getBytes(n));}return a.truncate(a.length()-s),a.getBytes()};}});var WL=I((Phe,HL)=>{var dt=rt();_t();HL.exports=dt.log=dt.log||{};dt.log.levels=["none","error","warning","info","debug","verbose","max"];var zd={},a_=[],Ic=null;dt.log.LEVEL_LOCKED=2;dt.log.NO_LEVEL_CHECK=4;dt.log.INTERPOLATE=8;for(Ri=0;Ri<dt.log.levels.length;++Ri)i_=dt.log.levels[Ri],zd[i_]={index:Ri,name:i_.toUpperCase()};var i_,Ri;dt.log.logMessage=function(e){for(var t=zd[e.level].index,r=0;r<a_.length;++r){var n=a_[r];if(n.flags&dt.log.NO_LEVEL_CHECK)n.f(e);else {var i=zd[n.level].index;t<=i&&n.f(n,e);}}};dt.log.prepareStandard=function(e){"standard"in e||(e.standard=zd[e.level].name+" ["+e.category+"] "+e.message);};dt.log.prepareFull=function(e){if(!("full"in e)){var t=[e.message];t=t.concat([]),e.full=dt.util.format.apply(this,t);}};dt.log.prepareStandardFull=function(e){"standardFull"in e||(dt.log.prepareStandard(e),e.standardFull=e.standard);};for(s_=["error","warning","info","debug","verbose"],Ri=0;Ri<s_.length;++Ri)(function(t){dt.log[t]=function(r,n){var i=Array.prototype.slice.call(arguments).slice(2),s={timestamp:new Date,level:t,category:r,message:n,arguments:i};dt.log.logMessage(s);};})(s_[Ri]);var s_,Ri;dt.log.makeLogger=function(e){var t={flags:0,f:e};return dt.log.setLevel(t,"none"),t};dt.log.setLevel=function(e,t){var r=!1;if(e&&!(e.flags&dt.log.LEVEL_LOCKED))for(var n=0;n<dt.log.levels.length;++n){var i=dt.log.levels[n];if(t==i){e.level=t,r=!0;break}}return r};dt.log.lock=function(e,t){typeof t>"u"||t?e.flags|=dt.log.LEVEL_LOCKED:e.flags&=~dt.log.LEVEL_LOCKED;};dt.log.addLogger=function(e){a_.push(e);};typeof console<"u"&&"log"in console?(console.error&&console.warn&&console.info&&console.debug?(jL={error:console.error,warning:console.warn,info:console.info,debug:console.debug,verbose:console.debug},Pc=function(e,t){dt.log.prepareStandard(t);var r=jL[t.level],n=[t.standard];n=n.concat(t.arguments.slice()),r.apply(console,n);},Lo=dt.log.makeLogger(Pc)):(Pc=function(t,r){dt.log.prepareStandardFull(r),console.log(r.standardFull);},Lo=dt.log.makeLogger(Pc)),dt.log.setLevel(Lo,"debug"),dt.log.addLogger(Lo),Ic=Lo):console={log:function(){}};var Lo,jL,Pc;Ic!==null&&typeof window<"u"&&window.location&&(Rc=new URL(window.location.href).searchParams,Rc.has("console.level")&&dt.log.setLevel(Ic,Rc.get("console.level").slice(-1)[0]),Rc.has("console.lock")&&(VL=Rc.get("console.lock").slice(-1)[0],VL=="true"&&dt.log.lock(Ic)));var Rc,VL;dt.log.consoleLogger=Ic;});var GL=I((Nhe,KL)=>{KL.exports=bi();Ad();Ro();_v();zv();});var QL=I((Dhe,YL)=>{var Ee=rt();bs();ai();bc();Ss();ma();Ov();Fn();_t();$d();var j=Ee.asn1,Jr=YL.exports=Ee.pkcs7=Ee.pkcs7||{};Jr.messageFromPem=function(e){var t=Ee.pem.decode(e)[0];if(t.type!=="PKCS7"){var r=new Error('Could not convert PKCS#7 message from PEM; PEM header type is not "PKCS#7".');throw r.headerType=t.type,r}if(t.procType&&t.procType.type==="ENCRYPTED")throw new Error("Could not convert PKCS#7 message from PEM; PEM is encrypted.");var n=j.fromDer(t.body);return Jr.messageFromAsn1(n)};Jr.messageToPem=function(e,t){var r={type:"PKCS7",body:j.toDer(e.toAsn1()).getBytes()};return Ee.pem.encode(r,{maxline:t})};Jr.messageFromAsn1=function(e){var t={},r=[];if(!j.validate(e,Jr.asn1.contentInfoValidator,t,r)){var n=new Error("Cannot read PKCS#7 message. ASN.1 object is not an PKCS#7 ContentInfo.");throw n.errors=r,n}var i=j.derToOid(t.contentType),s;switch(i){case Ee.pki.oids.envelopedData:s=Jr.createEnvelopedData();break;case Ee.pki.oids.encryptedData:s=Jr.createEncryptedData();break;case Ee.pki.oids.signedData:s=Jr.createSignedData();break;default:throw new Error("Cannot read PKCS#7 message. ContentType with OID "+i+" is not (yet) supported.")}return s.fromAsn1(t.content.value[0]),s};Jr.createSignedData=function(){var e=null;return e={type:Ee.pki.oids.signedData,version:1,certificates:[],crls:[],signers:[],digestAlgorithmIdentifiers:[],contentInfo:null,signerInfos:[],fromAsn1:function(n){if(u_(e,n,Jr.asn1.signedDataValidator),e.certificates=[],e.crls=[],e.digestAlgorithmIdentifiers=[],e.contentInfo=null,e.signerInfos=[],e.rawCapture.certificates)for(var i=e.rawCapture.certificates.value,s=0;s<i.length;++s)e.certificates.push(Ee.pki.certificateFromAsn1(i[s]));},toAsn1:function(){e.contentInfo||e.sign();for(var n=[],i=0;i<e.certificates.length;++i)n.push(Ee.pki.certificateToAsn1(e.certificates[i]));var s=[],a=j.create(j.Class.CONTEXT_SPECIFIC,0,!0,[j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.INTEGER,!1,j.integerToDer(e.version).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.SET,!0,e.digestAlgorithmIdentifiers),e.contentInfo])]);return n.length>0&&a.value[0].value.push(j.create(j.Class.CONTEXT_SPECIFIC,0,!0,n)),s.length>0&&a.value[0].value.push(j.create(j.Class.CONTEXT_SPECIFIC,1,!0,s)),a.value[0].value.push(j.create(j.Class.UNIVERSAL,j.Type.SET,!0,e.signerInfos)),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.type).getBytes()),a])},addSigner:function(n){var i=n.issuer,s=n.serialNumber;if(n.certificate){var a=n.certificate;typeof a=="string"&&(a=Ee.pki.certificateFromPem(a)),i=a.issuer.attributes,s=a.serialNumber;}var o=n.key;if(!o)throw new Error("Could not add PKCS#7 signer; no private key specified.");typeof o=="string"&&(o=Ee.pki.privateKeyFromPem(o));var c=n.digestAlgorithm||Ee.pki.oids.sha1;switch(c){case Ee.pki.oids.sha1:case Ee.pki.oids.sha256:case Ee.pki.oids.sha384:case Ee.pki.oids.sha512:case Ee.pki.oids.md5:break;default:throw new Error("Could not add PKCS#7 signer; unknown message digest algorithm: "+c)}var l=n.authenticatedAttributes||[];if(l.length>0){for(var u=!1,f=!1,h=0;h<l.length;++h){var p=l[h];if(!u&&p.type===Ee.pki.oids.contentType){if(u=!0,f)break;continue}if(!f&&p.type===Ee.pki.oids.messageDigest){if(f=!0,u)break;continue}}if(!u||!f)throw new Error("Invalid signer.authenticatedAttributes. If signer.authenticatedAttributes is specified, then it must contain at least two attributes, PKCS #9 content-type and PKCS #9 message-digest.")}e.signers.push({key:o,version:1,issuer:i,serialNumber:s,digestAlgorithm:c,signatureAlgorithm:Ee.pki.oids.rsaEncryption,signature:null,authenticatedAttributes:l,unauthenticatedAttributes:[]});},sign:function(n){if(n=n||{},(typeof e.content!="object"||e.contentInfo===null)&&(e.contentInfo=j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(Ee.pki.oids.data).getBytes())]),"content"in e)){var i;e.content instanceof Ee.util.ByteBuffer?i=e.content.bytes():typeof e.content=="string"&&(i=Ee.util.encodeUtf8(e.content)),n.detached?e.detachedContent=j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,i):e.contentInfo.value.push(j.create(j.Class.CONTEXT_SPECIFIC,0,!0,[j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,i)]));}if(e.signers.length!==0){var s=t();r(s);}},verify:function(){throw new Error("PKCS#7 signature verification not yet implemented.")},addCertificate:function(n){typeof n=="string"&&(n=Ee.pki.certificateFromPem(n)),e.certificates.push(n);},addCertificateRevokationList:function(n){throw new Error("PKCS#7 CRL support not yet implemented.")}},e;function t(){for(var n={},i=0;i<e.signers.length;++i){var s=e.signers[i],a=s.digestAlgorithm;a in n||(n[a]=Ee.md[Ee.pki.oids[a]].create()),s.authenticatedAttributes.length===0?s.md=n[a]:s.md=Ee.md[Ee.pki.oids[a]].create();}e.digestAlgorithmIdentifiers=[];for(var a in n)e.digestAlgorithmIdentifiers.push(j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(a).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.NULL,!1,"")]));return n}function r(n){var i;if(e.detachedContent?i=e.detachedContent:(i=e.contentInfo.value[1],i=i.value[0]),!i)throw new Error("Could not sign PKCS#7 message; there is no content to sign.");var s=j.derToOid(e.contentInfo.value[0].value),a=j.toDer(i);a.getByte(),j.getBerValueLength(a),a=a.getBytes();for(var o in n)n[o].start().update(a);for(var c=new Date,l=0;l<e.signers.length;++l){var u=e.signers[l];if(u.authenticatedAttributes.length===0){if(s!==Ee.pki.oids.data)throw new Error("Invalid signer; authenticatedAttributes must be present when the ContentInfo content type is not PKCS#7 Data.")}else {u.authenticatedAttributesAsn1=j.create(j.Class.CONTEXT_SPECIFIC,0,!0,[]);for(var f=j.create(j.Class.UNIVERSAL,j.Type.SET,!0,[]),h=0;h<u.authenticatedAttributes.length;++h){var p=u.authenticatedAttributes[h];p.type===Ee.pki.oids.messageDigest?p.value=n[u.digestAlgorithm].digest():p.type===Ee.pki.oids.signingTime&&(p.value||(p.value=c)),f.value.push(o_(p)),u.authenticatedAttributesAsn1.value.push(o_(p));}a=j.toDer(f).getBytes(),u.md.start().update(a);}u.signature=u.key.sign(u.md,"RSASSA-PKCS1-V1_5");}e.signerInfos=sne(e.signers);}};Jr.createEncryptedData=function(){var e=null;return e={type:Ee.pki.oids.encryptedData,version:0,encryptedContent:{algorithm:Ee.pki.oids["aes256-CBC"]},fromAsn1:function(t){u_(e,t,Jr.asn1.encryptedDataValidator);},decrypt:function(t){t!==void 0&&(e.encryptedContent.key=t),zL(e);}},e};Jr.createEnvelopedData=function(){var e=null;return e={type:Ee.pki.oids.envelopedData,version:0,recipients:[],encryptedContent:{algorithm:Ee.pki.oids["aes256-CBC"]},fromAsn1:function(t){var r=u_(e,t,Jr.asn1.envelopedDataValidator);e.recipients=rne(r.recipientInfos.value);},toAsn1:function(){return j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.type).getBytes()),j.create(j.Class.CONTEXT_SPECIFIC,0,!0,[j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.INTEGER,!1,j.integerToDer(e.version).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.SET,!0,nne(e.recipients)),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,ane(e.encryptedContent))])])])},findRecipient:function(t){for(var r=t.issuer.attributes,n=0;n<e.recipients.length;++n){var i=e.recipients[n],s=i.issuer;if(i.serialNumber===t.serialNumber&&s.length===r.length){for(var a=!0,o=0;o<r.length;++o)if(s[o].type!==r[o].type||s[o].value!==r[o].value){a=!1;break}if(a)return i}}return null},decrypt:function(t,r){if(e.encryptedContent.key===void 0&&t!==void 0&&r!==void 0)switch(t.encryptedContent.algorithm){case Ee.pki.oids.rsaEncryption:case Ee.pki.oids.desCBC:var n=r.decrypt(t.encryptedContent.content);e.encryptedContent.key=Ee.util.createBuffer(n);break;default:throw new Error("Unsupported asymmetric cipher, OID "+t.encryptedContent.algorithm)}zL(e);},addRecipient:function(t){e.recipients.push({version:0,issuer:t.issuer.attributes,serialNumber:t.serialNumber,encryptedContent:{algorithm:Ee.pki.oids.rsaEncryption,key:t.publicKey}});},encrypt:function(t,r){if(e.encryptedContent.content===void 0){r=r||e.encryptedContent.algorithm,t=t||e.encryptedContent.key;var n,i,s;switch(r){case Ee.pki.oids["aes128-CBC"]:n=16,i=16,s=Ee.aes.createEncryptionCipher;break;case Ee.pki.oids["aes192-CBC"]:n=24,i=16,s=Ee.aes.createEncryptionCipher;break;case Ee.pki.oids["aes256-CBC"]:n=32,i=16,s=Ee.aes.createEncryptionCipher;break;case Ee.pki.oids["des-EDE3-CBC"]:n=24,i=8,s=Ee.des.createEncryptionCipher;break;default:throw new Error("Unsupported symmetric cipher, OID "+r)}if(t===void 0)t=Ee.util.createBuffer(Ee.random.getBytes(n));else if(t.length()!=n)throw new Error("Symmetric key has wrong length; got "+t.length()+" bytes, expected "+n+".");e.encryptedContent.algorithm=r,e.encryptedContent.key=t,e.encryptedContent.parameter=Ee.util.createBuffer(Ee.random.getBytes(i));var a=s(t);if(a.start(e.encryptedContent.parameter.copy()),a.update(e.content),!a.finish())throw new Error("Symmetric encryption failed.");e.encryptedContent.content=a.output;}for(var o=0;o<e.recipients.length;++o){var c=e.recipients[o];if(c.encryptedContent.content===void 0)switch(c.encryptedContent.algorithm){case Ee.pki.oids.rsaEncryption:c.encryptedContent.content=c.encryptedContent.key.encrypt(e.encryptedContent.key.data);break;default:throw new Error("Unsupported asymmetric cipher, OID "+c.encryptedContent.algorithm)}}}},e};function ene(e){var t={},r=[];if(!j.validate(e,Jr.asn1.recipientInfoValidator,t,r)){var n=new Error("Cannot read PKCS#7 RecipientInfo. ASN.1 object is not an PKCS#7 RecipientInfo.");throw n.errors=r,n}return {version:t.version.charCodeAt(0),issuer:Ee.pki.RDNAttributesAsArray(t.issuer),serialNumber:Ee.util.createBuffer(t.serial).toHex(),encryptedContent:{algorithm:j.derToOid(t.encAlgorithm),parameter:t.encParameter?t.encParameter.value:void 0,content:t.encKey}}}function tne(e){return j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.INTEGER,!1,j.integerToDer(e.version).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[Ee.pki.distinguishedNameToAsn1({attributes:e.issuer}),j.create(j.Class.UNIVERSAL,j.Type.INTEGER,!1,Ee.util.hexToBytes(e.serialNumber))]),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.encryptedContent.algorithm).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.NULL,!1,"")]),j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,e.encryptedContent.content)])}function rne(e){for(var t=[],r=0;r<e.length;++r)t.push(ene(e[r]));return t}function nne(e){for(var t=[],r=0;r<e.length;++r)t.push(tne(e[r]));return t}function ine(e){var t=j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.INTEGER,!1,j.integerToDer(e.version).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[Ee.pki.distinguishedNameToAsn1({attributes:e.issuer}),j.create(j.Class.UNIVERSAL,j.Type.INTEGER,!1,Ee.util.hexToBytes(e.serialNumber))]),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.digestAlgorithm).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.NULL,!1,"")])]);if(e.authenticatedAttributesAsn1&&t.value.push(e.authenticatedAttributesAsn1),t.value.push(j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.signatureAlgorithm).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.NULL,!1,"")])),t.value.push(j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,e.signature)),e.unauthenticatedAttributes.length>0){for(var r=j.create(j.Class.CONTEXT_SPECIFIC,1,!0,[]),n=0;n<e.unauthenticatedAttributes.length;++n){var i=e.unauthenticatedAttributes[n];r.values.push(o_(i));}t.value.push(r);}return t}function sne(e){for(var t=[],r=0;r<e.length;++r)t.push(ine(e[r]));return t}function o_(e){var t;if(e.type===Ee.pki.oids.contentType)t=j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.value).getBytes());else if(e.type===Ee.pki.oids.messageDigest)t=j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,e.value.bytes());else if(e.type===Ee.pki.oids.signingTime){var r=new Date("1950-01-01T00:00:00Z"),n=new Date("2050-01-01T00:00:00Z"),i=e.value;if(typeof i=="string"){var s=Date.parse(i);isNaN(s)?i.length===13?i=j.utcTimeToDate(i):i=j.generalizedTimeToDate(i):i=new Date(s);}i>=r&&i<n?t=j.create(j.Class.UNIVERSAL,j.Type.UTCTIME,!1,j.dateToUtcTime(i)):t=j.create(j.Class.UNIVERSAL,j.Type.GENERALIZEDTIME,!1,j.dateToGeneralizedTime(i));}return j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.type).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.SET,!0,[t])])}function ane(e){return [j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(Ee.pki.oids.data).getBytes()),j.create(j.Class.UNIVERSAL,j.Type.SEQUENCE,!0,[j.create(j.Class.UNIVERSAL,j.Type.OID,!1,j.oidToDer(e.algorithm).getBytes()),e.parameter?j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,e.parameter.getBytes()):void 0]),j.create(j.Class.CONTEXT_SPECIFIC,0,!0,[j.create(j.Class.UNIVERSAL,j.Type.OCTETSTRING,!1,e.content.getBytes())])]}function u_(e,t,r){var n={},i=[];if(!j.validate(t,r,n,i)){var s=new Error("Cannot read PKCS#7 message. ASN.1 object is not a supported PKCS#7 message.");throw s.errors=s,s}var a=j.derToOid(n.contentType);if(a!==Ee.pki.oids.data)throw new Error("Unsupported PKCS#7 message. Only wrapped ContentType Data supported.");if(n.encryptedContent){var o="";if(Ee.util.isArray(n.encryptedContent))for(var c=0;c<n.encryptedContent.length;++c){if(n.encryptedContent[c].type!==j.Type.OCTETSTRING)throw new Error("Malformed PKCS#7 message, expecting encrypted content constructed of only OCTET STRING objects.");o+=n.encryptedContent[c].value;}else o=n.encryptedContent;e.encryptedContent={algorithm:j.derToOid(n.encAlgorithm),parameter:Ee.util.createBuffer(n.encParameter.value),content:Ee.util.createBuffer(o)};}if(n.content){var o="";if(Ee.util.isArray(n.content))for(var c=0;c<n.content.length;++c){if(n.content[c].type!==j.Type.OCTETSTRING)throw new Error("Malformed PKCS#7 message, expecting content constructed of only OCTET STRING objects.");o+=n.content[c].value;}else o=n.content;e.content=Ee.util.createBuffer(o);}return e.version=n.version.charCodeAt(0),e.rawCapture=n,n}function zL(e){if(e.encryptedContent.key===void 0)throw new Error("Symmetric key not available.");if(e.content===void 0){var t;switch(e.encryptedContent.algorithm){case Ee.pki.oids["aes128-CBC"]:case Ee.pki.oids["aes192-CBC"]:case Ee.pki.oids["aes256-CBC"]:t=Ee.aes.createDecryptionCipher(e.encryptedContent.key);break;case Ee.pki.oids.desCBC:case Ee.pki.oids["des-EDE3-CBC"]:t=Ee.des.createDecryptionCipher(e.encryptedContent.key);break;default:throw new Error("Unsupported symmetric cipher, OID "+e.encryptedContent.algorithm)}if(t.start(e.encryptedContent.parameter),t.update(e.encryptedContent.content),!t.finish())throw new Error("Symmetric decryption failed.");e.content=t.output;}}});var ZL=I((Ohe,XL)=>{var cr=rt();bs();Co();Ad();Ro();_t();var Qd=XL.exports=cr.ssh=cr.ssh||{};Qd.privateKeyToPutty=function(e,t,r){r=r||"",t=t||"";var n="ssh-rsa",i=t===""?"none":"aes256-cbc",s="PuTTY-User-Key-File-2: "+n+`\r
`;s+="Encryption: "+i+`\r
`,s+="Comment: "+r+`\r
`;var a=cr.util.createBuffer();Bo(a,n),Ii(a,e.e),Ii(a,e.n);var o=cr.util.encode64(a.bytes(),64),c=Math.floor(o.length/66)+1;s+="Public-Lines: "+c+`\r
`,s+=o;var l=cr.util.createBuffer();Ii(l,e.d),Ii(l,e.p),Ii(l,e.q),Ii(l,e.qInv);var u;if(!t)u=cr.util.encode64(l.bytes(),64);else {var f=l.length()+16-1;f-=f%16;var h=Yd(l.bytes());h.truncate(h.length()-f+l.length()),l.putBuffer(h);var p=cr.util.createBuffer();p.putBuffer(Yd("\0\0\0\0",t)),p.putBuffer(Yd("\0\0\0",t));var g=cr.aes.createEncryptionCipher(p.truncate(8),"CBC");g.start(cr.util.createBuffer().fillWithByte(0,16)),g.update(l.copy()),g.finish();var _=g.output;_.truncate(16),u=cr.util.encode64(_.bytes(),64);}c=Math.floor(u.length/66)+1,s+=`\r
Private-Lines: `+c+`\r
`,s+=u;var E=Yd("putty-private-key-file-mac-key",t),w=cr.util.createBuffer();Bo(w,n),Bo(w,i),Bo(w,r),w.putInt32(a.length()),w.putBuffer(a),w.putInt32(l.length()),w.putBuffer(l);var y=cr.hmac.create();return y.start("sha1",E),y.update(w.bytes()),s+=`\r
Private-MAC: `+y.digest().toHex()+`\r
`,s};Qd.publicKeyToOpenSSH=function(e,t){var r="ssh-rsa";t=t||"";var n=cr.util.createBuffer();return Bo(n,r),Ii(n,e.e),Ii(n,e.n),r+" "+cr.util.encode64(n.bytes())+" "+t};Qd.privateKeyToOpenSSH=function(e,t){return t?cr.pki.encryptRsaPrivateKey(e,t,{legacy:!0,algorithm:"aes128"}):cr.pki.privateKeyToPem(e)};Qd.getPublicKeyFingerprint=function(e,t){t=t||{};var r=t.md||cr.md.md5.create(),n="ssh-rsa",i=cr.util.createBuffer();Bo(i,n),Ii(i,e.e),Ii(i,e.n),r.start(),r.update(i.getBytes());var s=r.digest();if(t.encoding==="hex"){var a=s.toHex();return t.delimiter?a.match(/.{2}/g).join(t.delimiter):a}else {if(t.encoding==="binary")return s.getBytes();if(t.encoding)throw new Error('Unknown encoding "'+t.encoding+'".')}return s};function Ii(e,t){var r=t.toString(16);r[0]>="8"&&(r="00"+r);var n=cr.util.hexToBytes(r);e.putInt32(n.length),e.putBytes(n);}function Bo(e,t){e.putInt32(t.length),e.putString(t);}function Yd(){for(var e=cr.md.sha1.create(),t=arguments.length,r=0;r<t;++r)e.update(arguments[r]);return e.digest()}});var c_=I((khe,JL)=>{JL.exports=rt();bs();_L();ai();bd();bc();FL();Co();$L();WL();GL();kv();Nd();ma();Rv();Fv();QL();Mv();Pv();bv();qd();Fn();wv();ZL();Wv();_t();});var tB=I((Lhe,eB)=>{eB.exports={dc:"0.9.2342.19200300.100.1.25"};});var l_=I((Bhe,rB)=>{var Xd;rB.exports=one;function one(){var e,t,r,n;if(!Xd){Xd=c_(),e=Xd.oids;for(t in r=tB())n=r[t],e[t]==null&&(e[t]=n),e[n]==null&&(e[n]=t);}return Xd}});var Dc=I((Fhe,uB)=>{var Zd,d_,Nc,f_,nB,iB,h_;uB.exports=Jd;Zd=l_();d_={der:sB,pem:aB,txt:une,asn1:oB,x509:cne};Nc=[];for(f_ in d_)nB=d_[f_],Jd[f_]=Nc.length,Nc.push(nB);Jd.forge=Jd.x509;iB=Buffer.isBuffer;h_=Buffer.from||function(e,t){return new Buffer(e,t)};function Jd(e,t){var r;return r=Nc[e]||Nc[0],t!=null?r(t):r}function sB(e){return iB(e)?e:h_(e,"binary")}function aB(e){var t,r,n,i;for(e=sB(e).toString("base64"),t=["-----BEGIN CERTIFICATE-----"],r=0,n=e.length;r<n;r+=64)i=r,t.push(e.substr(i,64));return t.push("-----END CERTIFICATE-----",""),t.join(`\r
`)}function une(e){var t;return t=oB(e),"Subject	"+t.subject.value.map(function(r){return h_(r.value[0].value[1].value,"binary").toString("utf8")}).join("/")+`
Valid	`+t.valid.value.map(function(r){return r.value}).join(" - ")+`
`+aB(e)}function oB(e){var t,r,n,i;return t=Zd().asn1,e=e.toString("binary"),r=t.fromDer(e).value[0].value,n=r[0],i=n.tagClass===t.Class.CONTEXT_SPECIFIC&&n.type===0&&n.constructed,r=r.slice(i),{serial:r[0],valid:r[3],issuer:r[2],subject:r[4]}}function cne(e){return Zd().pki.certificateFromAsn1(Zd().asn1.fromDer(e.toString("binary")))}});var lB=I(g_=>{g_.all=fne;g_.each=cB;cB.async=lne;function cB(){var e;p_(arguments,e={unique:!0,ondata:function(t){typeof e.$cb=="function"&&e.$cb(t);}});}function lne(){var e;p_(arguments,e={async:!0,ondata:function(t){typeof e.$cb=="function"&&e.$cb(void 0,t);},onend:function(){typeof e.$cb=="function"&&e.$cb();}});}function fne(){var e;return p_(arguments,{ondata:e=[]}),e}function p_(e,t){var r,n;r=gc(),n=e[0],t.unique==null&&(t.unique=!1),t.format=n??r.der2.x509,t.$cb=e[1]||n,r(t);}});var b_=I((Mhe,hB)=>{var v_,fB,m_,Oc,__,y_;v_=he("crypto");fB=l_();m_=Dc();Oc=fB().asn1;__=m_(m_.asn1);hB.exports=pne;y_=Buffer.from||function(e,t){return new Buffer(e,t)};function dne(e){var t;return t=v_.createHash("sha1"),__(e).subject.value.forEach(function(r){var n,i;r=Oc.copy(r),n=r.value[0].value[1],n.value&&(n.type=Oc.Type.UTF8,i=y_(n.value,"binary").toString("utf8"),i=i.trim().replace(/[A-Z]+/g,function(s){return s.toLowerCase()}).replace(/\s+/g," "),n.value=y_(i,"utf8").toString("binary"),t.update(Oc.toDer(r).getBytes(),"binary"));}),dB(t)}function hne(e){var t,r;return t=v_.createHash("md5"),r=__(e).subject,t.update(Oc.toDer(r).getBytes(),"binary"),dB(t)}function dB(e){return e=e.digest().slice(0,4),e.writeUInt32LE(e.readUInt32BE(0),0),e.toString("hex")}function pne(e,t){var r;return r=e===0?hne:dne,t!=null?r(t):r}});var E_=I((Uhe,_B)=>{var gB,kc,S_,mB,eh,Is,Bc,Lc;gB=he("https");kc=he("tls");S_=Dc();_B.exports=yB;yB.inject=vB;mB=S_(S_.pem);eh=gB.globalAgent.options;Is=[];function yB(e){return vB(e,[]),gne}function gne(e){Is.push(mB(e));}Bc=0;function vB(e,t){if(t&&(Is.length=0,Is.push.apply(Is,t)),e=e==="+"?2:e?1:0,e!==Bc){switch(Bc){case 1:eh.ca===Is&&delete eh.ca;break;case 2:kc.createSecureContext===pB&&(kc.createSecureContext=Lc,Lc=void 0);}switch(Bc=e){case 1:eh.ca=Is;break;case 2:Lc||(Lc=kc.createSecureContext,kc.createSecureContext=pB);}}}function pB(e){var t,r,n,i,s;if(t=Lc.apply(this,arguments),Bc===2&&!(e!=null&&e.ca))for(r=0,i=(n=Is).length;r<i;++r)s=n[r],t.context.addCACert(s);return t}});var EB=I((bB,SB)=>{var mne=he("stream");SB.exports=w_;w_.through=w_;function w_(e,t,r){e=e||function(u){this.queue(u);},t=t||function(){this.queue(null);};var n=!1,i=!1,s=[],a=!1,o=new mne;o.readable=o.writable=!0,o.paused=!1,o.autoDestroy=!(r&&r.autoDestroy===!1),o.write=function(u){return e.call(this,u),!o.paused};function c(){for(;s.length&&!o.paused;){var u=s.shift();if(u===null)return o.emit("end");o.emit("data",u);}}o.queue=o.push=function(u){return a||(u===null&&(a=!0),s.push(u),c()),o},o.on("end",function(){o.readable=!1,!o.writable&&o.autoDestroy&&process.nextTick(function(){o.destroy();});});function l(){o.writable=!1,t.call(o),!o.readable&&o.autoDestroy&&o.destroy();}return o.end=function(u){if(!n)return n=!0,arguments.length&&o.write(u),l(),o},o.destroy=function(){if(!i)return i=!0,n=!0,s.length=0,o.writable=o.readable=!1,o.emit("close"),o},o.pause=function(){if(!o.paused)return o.paused=!0,o},o.resume=function(){return o.paused&&(o.paused=!1,o.emit("resume")),c(),o.paused||o.emit("drain"),o},o}});var CB=I(($he,wB)=>{var yne=EB(),vne=he("string_decoder").StringDecoder;wB.exports=_ne;function _ne(e,t,r){var n=new vne,i="",s=r&&r.maxLength,a=!(r&&r.trailing===!1);typeof e=="function"&&(t=e,e=null),e||(e=/\r?\n/);function o(l,u){if(t){try{u=t(u);}catch(f){return l.emit("error",f)}typeof u<"u"&&l.queue(u);}else l.queue(u);}function c(l,u){var f=((i??"")+u).split(e);if(i=f.pop(),s&&i.length>s)return l.emit("error",new Error("maximum buffer reached"));for(var h=0;h<f.length;h++){var p=f[h];o(l,p);}}return yne(function(l){c(this,n.write(l));},function(){n.end&&c(this,n.end()),a&&i!=null&&o(this,i),this.queue(null);})}});var A_=I(th=>{var xB,C_,TB,rh,x_,AB,T_=typeof th<"u"&&th||th;xB=he("path");C_=he("child_process");TB=CB();x_={maxBuffer:1024*1024*1024};function RB(e){var t;return e==null&&(e="roots.exe"),t=rh,rh=xB.resolve(__dirname,e),t}RB();T_.exe=RB;T_.sync=bne;function bne(e){var t,r;return {run:s,next:n,done:i};function n(){if(t||(t=[],r=0,s(function(a){a&&t.push(a);})),r<t.length)return t[r++];t=[];}function i(){t=[];}function s(a){IB(a).on("end",function(){a();}).end(C_.execFileSync(rh,e,x_));}}T_.async=Sne;function Sne(e){var t,r,n;return {run:c,next:i,done:a};function i(){return t||(t=[],r=[],c(s)),t.length?Promise.resolve(t.shift()):n?Promise.resolve():new Promise(function(l){r.push(l);})}function s(l){n||(l?r.length?r.shift()(l):t.push(l):o());}function a(){t=[],o();}function o(){var l,u,f,h;for(n=!0,l=0,f=(u=r).length;l<f;++l)h=u[l],h();}function c(l){C_.execFile(rh,e,x_,function(){}).stdout.pipe(IB(l)).on("end",function(){l();});}}function IB(e){return TB(function(t){t.length&&e(AB(t,"hex"));})}AB=Buffer.from||function(e,t){return new Buffer(e,t)};});var DB=I(nh=>{var PB=typeof nh<"u"&&nh||nh;PB.sync=NB;function NB(){return {next:function(){},done:function(){},run:function(e){return e()}}}PB.async=NB;});var OB=I(()=>{});var kB=I(()=>{});var Qhe,R_=vE(()=>{Qhe=yE({"./crypt32-ia32.node":()=>OB(),"./crypt32-x64.node":()=>kB()});});var FB=I(ih=>{R_();var I_,LB=typeof ih<"u"&&ih||ih;I_=Qhe("./crypt32-"+process.arch);LB.sync=BB;function BB(e){var t,r;return r=e.length?0:-1,{next:n,done:i,run:s};function n(){for(var a;r<e.length;){if(t==null&&(t=r<0?I_():I_(e[r])),a=t.next())return a;t.done(),t=void 0,r++;}}function i(){t?.done(),t=void 0,r=e.length;}function s(a){for(var o;o=n();)a(o);a();}}LB.async=wne;function wne(e){var t,r;return t=BB(e),r=t.next,t.run=n,t;function n(i){function s(){return Promise.resolve().then(r).then(function(a){if(a)return i(a),s();i();})}s();}}});var UB=I((Jhe,MB)=>{var qB;qB=he("crypto");MB.exports=Cne;function Cne(){var e;e=new Set;function t(r){var n;if(n=qB.createHash("sha256").update(r).digest("base64"),!e.has(n))return e.add(n),!0}return t}});var VB=I((epe,jB)=>{var $B=(e,t)=>function(){let r=t.promiseModule,n=new Array(arguments.length);for(let i=0;i<arguments.length;i++)n[i]=arguments[i];return new r((i,s)=>{t.errorFirst?n.push(function(a,o){if(t.multiArgs){let c=new Array(arguments.length-1);for(let l=1;l<arguments.length;l++)c[l-1]=arguments[l];a?(c.unshift(a),s(c)):i(c);}else a?s(a):i(o);}):n.push(function(a){if(t.multiArgs){let o=new Array(arguments.length-1);for(let c=0;c<arguments.length;c++)o[c]=arguments[c];i(o);}else i(a);}),e.apply(this,n);})};jB.exports=(e,t)=>{t=Object.assign({exclude:[/.+(Sync|Stream)$/],errorFirst:!0,promiseModule:Promise},t);let r=i=>{let s=a=>typeof a=="string"?i===a:a.test(i);return t.include?t.include.some(s):!t.exclude.some(s)},n;typeof e=="function"?n=function(){return t.excludeMain?e.apply(this,arguments):$B(e,t).apply(this,arguments)}:n=Object.create(Object.getPrototypeOf(e));for(let i in e){let s=e[i];n[i]=typeof s=="function"&&r(i)?$B(s,t):s;}return n};});var GB=I((tpe,P_)=>{var xne=he("fs"),Ca=he("path"),HB=VB(),WB={mode:511&~process.umask(),fs:xne},KB=e=>{if(process.platform==="win32"&&/[<>:"|?*]/.test(e.replace(Ca.parse(e).root,""))){let r=new Error(`Path contains invalid characters: ${e}`);throw r.code="EINVAL",r}};P_.exports=(e,t)=>Promise.resolve().then(()=>{KB(e),t=Object.assign({},WB,t);let r=HB(t.fs.mkdir),n=HB(t.fs.stat),i=s=>r(s,t.mode).then(()=>s).catch(a=>{if(a.code==="ENOENT"){if(a.message.includes("null bytes")||Ca.dirname(s)===s)throw a;return i(Ca.dirname(s)).then(()=>i(s))}return n(s).then(o=>o.isDirectory()?s:Promise.reject()).catch(()=>{throw a})});return i(Ca.resolve(e))});P_.exports.sync=(e,t)=>{KB(e),t=Object.assign({},WB,t);let r=n=>{try{t.fs.mkdirSync(n,t.mode);}catch(i){if(i.code==="ENOENT"){if(i.message.includes("null bytes")||Ca.dirname(n)===n)throw i;return r(Ca.dirname(n)),r(n)}try{if(!t.fs.statSync(n).isDirectory())throw new Error("The path is not a directory")}catch{throw i}}return n};return r(Ca.resolve(e))};});var nF=I((rpe,rF)=>{var qc,zB,Fc,YB,D_,QB,XB,ZB,JB,eF,tF;qc=he("fs");zB=he("os");Fc=he("path");YB=GB();D_=Dc();QB=b_();rF.exports=Tne;XB=D_(D_.txt);ZB=QB();JB=O_(qc.writeFile);eF=O_(qc.readdir);tF=O_(qc.unlink);function Tne(e){var t,r,n,i,s;return i={},s=new Set,a;function a(f){return Promise.resolve(f).then(o)}function o(f){f?(r||(r=Rne(e.save||e.$ave).then(function(h){return t=h})),r=r.then(function(){if(t)return c(f)})):r?r.then(u).then(function(){n?.end(),t&&e.$ave&&(process.env.SSL_CERT_DIR=gc().path=t),typeof e.onsave=="function"&&e.onsave(t);}):typeof e.onsave=="function"&&e.onsave();}function c(f){var h,p;return (n||(n=qc.createWriteStream(l("roots.pem")))).write(h=XB(f)),i[p=ZB(f)]||(i[p]=0),JB(l(p+"."+i[p]++),h).catch(N_)}function l(f){return s.add(f),Fc.join(t,f)}function u(){t&&eF(t).then(function(f){return Promise.all(f.filter(function(h){return !s.has(h)}).map(function(h){return Fc.join(t,h)}).map(function(h){return tF(h).catch(N_)}))}).catch(N_);}}function Ane(){return [Fc.join(__dirname,"../pem"),Fc.join(zB.homedir(),".local/win-ca/pem")]}function Rne(e){var t;return typeof e=="string"?e=[e]:Array.isArray(e)||(e=Ane()),t=0,r();function r(){return t<e.length?YB(e[t++]).catch(r):Promise.resolve()}}function O_(e){return function(){var t,r=this;return t=[].slice.call(arguments),new Promise(function(n,i){t.push(s),e.apply(r,t);function s(a,o){a?i(a):n(o);}})}}function N_(){}});var gc=I((npe,oF)=>{var k_,sF,aF;oF.exports=en;en.disabled=k_=process.platform!=="win32";en.nApi=sF=!!process.versions.napi&&en===BO()&&!(en.electron=qO()());en.der2=aF=Dc();en.hash=Ine;en.inject=Pne;en.exe=Nne;Dne(en,lB());!k_&&en===L_()&&en({inject:!0,$ave:!0,async:!0});function Ine(){return (en.hash=b_()).apply(this,arguments)}function Pne(){return (en.inject=E_().inject).apply(this,arguments)}function Nne(){return (en.exe=A_().exe).apply(this,arguments)}function en(e){var t,r,n,i,s,a,o,c,l;if(e==null&&(e={}),t=k_||e.disabled?DB():((r=e.fallback)!=null?r:!sF)?A_():FB(),(n=e.store)?Array.isArray(n)||(n=[n]):n=[],t=t[(i=e.async)?"async":"sync"](n),s=i?f:u,e.unique!==!1&&(a=UB()()),o=aF(e.format),Array.isArray(e.ondata)&&(e.ondata=e.ondata.push.bind(e.ondata)),(e.save||e.$ave)&&(c=nF()(e)),e.inject&&(l=E_()(e.inject)),e.generator)return (i?p:h)();t.run(function(y){(!y||!a||a(y))&&s(y);});function u(y){c&&c(y),y?(l&&l(y),typeof e.ondata=="function"&&e.ondata(o(y))):typeof e.onend=="function"&&e.onend();}function f(y){Promise.resolve(y).then(u);}function h(){var y;return y={},y[Symbol.iterator]=iF,y.return=_,y.next=E,y}function p(){var y,b;return y={},y[(b=Symbol.asyncIterator)!=null?b:"@"]=iF,y.return=_,y.next=w,y}function g(y){return s(y),{done:!y,value:y!=null?o(y):y}}function _(y){return t.done(),{done:!0,value:y}}function E(){for(var y;(y=t.next())&&a&&!a(y););return g(y)}function w(){function y(){return Promise.resolve().then(t.next).then(function(b){return b&&a&&!a(b)?y():g(b)})}return y()}}function iF(){return this}function Dne(e,t){for(var r in t)e[r]=t[r];return e}});var L_=I((ipe,uF)=>{uF.exports=gc();});var fF=I(xa=>{Object.defineProperty(xa,"__esModule",{value:!0});xa.convert=xa.Format=void 0;var Mc=c_(),Ps;(function(e){e.der="der",e.pem="pem",e.txt="txt",e.asn1="asn1",e.x509="x509",e.fingerprint="fingerprint";})(Ps=xa.Format||(xa.Format={}));function cF(e){var t=Mc.pki.pemToDer(e),r=Mc.asn1,n=r.fromDer(t.data.toString("binary")).value[0].value,i=n[0],s=i.tagClass===r.Class.CONTEXT_SPECIFIC&&i.type===0&&i.constructed,a=n.slice(s);return {serial:a[0],issuer:a[2],valid:a[3],subject:a[4]}}function One(e){var t=cF(e),r=t.subject.value.map(function(i){return i.value[0].value[1].value}).join("/"),n=t.valid.value.map(function(i){return i.value}).join(" - ");return ["Subject	".concat(r),"Valid	".concat(n),String(e)].join(`
`)}function lF(e,t){switch(t){case Ps.der:return Mc.pki.pemToDer(e);case Ps.pem:return e;case Ps.txt:return One(e);case Ps.asn1:return cF(e);case Ps.fingerprint:var r=Mc.md.sha1.create(),n=lF(e,Ps.der);return r.update(n.getBytes()),r.digest().toHex();case Ps.x509:return Mc.pki.certificateFromPem(e);default:throw new Error("unknown format ".concat(t))}}xa.convert=lF;});var mF=I(ln=>{var Ta=ln&&ln.__assign||function(){return Ta=Object.assign||function(e){for(var t,r=1,n=arguments.length;r<n;r++){t=arguments[r];for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);}return e},Ta.apply(this,arguments)},sh=ln&&ln.__spreadArray||function(e,t,r){if(r||arguments.length===2)for(var n=0,i=t.length,s;n<i;n++)(s||!(n in t))&&(s||(s=Array.prototype.slice.call(t,0,n)),s[n]=t[n]);return e.concat(s||Array.prototype.slice.call(t))};Object.defineProperty(ln,"__esModule",{value:!0});ln.convert=ln.Format=ln.addToGlobalAgent=ln.get=void 0;var hF=he("https"),kne=he("tls"),dF=he("child_process"),Xi=fF();Object.defineProperty(ln,"Format",{enumerable:!0,get:function(){return Xi.Format}});Object.defineProperty(ln,"convert",{enumerable:!0,get:function(){return Xi.convert}});var pF=process.platform==="darwin",oh={keychain:"all",unique:!0,excludeBundled:!0,format:Xi.Format.pem};function gF(e){if(e===void 0&&(e=oh),!pF)return [];e=Ta(Ta({},oh),e);var t=/(?=-----BEGIN\sCERTIFICATE-----)/g,r=["find-certificate","-a","-p"],n=[];if(e.keychain==="all"||e.keychain==="SystemRootCertificates"){var i="/System/Library/Keychains/SystemRootCertificates.keychain",s=(0, dF.spawnSync)("/usr/bin/security",r.concat(i)).stdout.toString().split(t).map(function(l){return l.trim()});n=sh(sh([],n,!0),s,!0);}if(e.keychain==="all"||e.keychain==="SystemRootCertificates"){var a=(0, dF.spawnSync)("/usr/bin/security",r).stdout.toString().split(t).map(function(l){return l.trim()});n=sh(sh([],n,!0),a,!0);}if(e.unique||e.excludeBundled){var o=n.map(function(l){return (0, Xi.convert)(l,Xi.Format.fingerprint)}),c=e.excludeBundled?kne.rootCertificates.map(function(l){return (0, Xi.convert)(l,Xi.Format.fingerprint)}):[];n=n.filter(function(l,u){var f=o[u];return !(e.unique&&u!==o.indexOf(f)||e.excludeBundled&&c.includes(f))});}return n.map(function(l){return (0, Xi.convert)(l,e.format)})}ln.get=gF;var ah=hF.globalAgent.options.ca,Lne=function(e){if(e===void 0&&(e=oh),!!pF){var t;Array.isArray(ah)?t=Array.from(ah):t=typeof ah<"u"?[ah]:[],gF(Ta(Ta(Ta({},oh),e),{format:Xi.Format.pem})).forEach(function(r){return t.push(r)}),hF.globalAgent.options.ca=t;}};ln.addToGlobalAgent=Lne;});var hh=I(lr=>{Object.defineProperty(lr,"__esModule",{value:!0});lr.thenable=lr.typedArray=lr.stringArray=lr.array=lr.func=lr.error=lr.number=lr.string=lr.boolean=void 0;function Fne(e){return e===!0||e===!1}lr.boolean=Fne;function xF(e){return typeof e=="string"||e instanceof String}lr.string=xF;function qne(e){return typeof e=="number"||e instanceof Number}lr.number=qne;function Mne(e){return e instanceof Error}lr.error=Mne;function TF(e){return typeof e=="function"}lr.func=TF;function AF(e){return Array.isArray(e)}lr.array=AF;function Une(e){return AF(e)&&e.every(t=>xF(t))}lr.stringArray=Une;function $ne(e,t){return Array.isArray(e)&&e.every(t)}lr.typedArray=$ne;function jne(e){return e&&TF(e.then)}lr.thenable=jne;});var Fo=I(Fr=>{Object.defineProperty(Fr,"__esModule",{value:!0});Fr.stringArray=Fr.array=Fr.func=Fr.error=Fr.number=Fr.string=Fr.boolean=void 0;function Vne(e){return e===!0||e===!1}Fr.boolean=Vne;function RF(e){return typeof e=="string"||e instanceof String}Fr.string=RF;function Hne(e){return typeof e=="number"||e instanceof Number}Fr.number=Hne;function Wne(e){return e instanceof Error}Fr.error=Wne;function Kne(e){return typeof e=="function"}Fr.func=Kne;function IF(e){return Array.isArray(e)}Fr.array=IF;function Gne(e){return IF(e)&&e.every(t=>RF(t))}Fr.stringArray=Gne;});var lb=I(qe=>{Object.defineProperty(qe,"__esModule",{value:!0});qe.Message=qe.NotificationType9=qe.NotificationType8=qe.NotificationType7=qe.NotificationType6=qe.NotificationType5=qe.NotificationType4=qe.NotificationType3=qe.NotificationType2=qe.NotificationType1=qe.NotificationType0=qe.NotificationType=qe.RequestType9=qe.RequestType8=qe.RequestType7=qe.RequestType6=qe.RequestType5=qe.RequestType4=qe.RequestType3=qe.RequestType2=qe.RequestType1=qe.RequestType=qe.RequestType0=qe.AbstractMessageSignature=qe.ParameterStructures=qe.ResponseError=qe.ErrorCodes=void 0;var Ra=Fo(),U_;(function(e){e.ParseError=-32700,e.InvalidRequest=-32600,e.MethodNotFound=-32601,e.InvalidParams=-32602,e.InternalError=-32603,e.jsonrpcReservedErrorRangeStart=-32099,e.serverErrorStart=-32099,e.MessageWriteError=-32099,e.MessageReadError=-32098,e.PendingResponseRejected=-32097,e.ConnectionInactive=-32096,e.ServerNotInitialized=-32002,e.UnknownErrorCode=-32001,e.jsonrpcReservedErrorRangeEnd=-32e3,e.serverErrorEnd=-32e3;})(U_||(qe.ErrorCodes=U_={}));var $_=class e extends Error{constructor(t,r,n){super(r),this.code=Ra.number(t)?t:U_.UnknownErrorCode,this.data=n,Object.setPrototypeOf(this,e.prototype);}toJson(){let t={code:this.code,message:this.message};return this.data!==void 0&&(t.data=this.data),t}};qe.ResponseError=$_;var fn=class e{constructor(t){this.kind=t;}static is(t){return t===e.auto||t===e.byName||t===e.byPosition}toString(){return this.kind}};qe.ParameterStructures=fn;fn.auto=new fn("auto");fn.byPosition=new fn("byPosition");fn.byName=new fn("byName");var Gt=class{constructor(t,r){this.method=t,this.numberOfParams=r;}get parameterStructures(){return fn.auto}};qe.AbstractMessageSignature=Gt;var j_=class extends Gt{constructor(t){super(t,0);}};qe.RequestType0=j_;var V_=class extends Gt{constructor(t,r=fn.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.RequestType=V_;var H_=class extends Gt{constructor(t,r=fn.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.RequestType1=H_;var W_=class extends Gt{constructor(t){super(t,2);}};qe.RequestType2=W_;var K_=class extends Gt{constructor(t){super(t,3);}};qe.RequestType3=K_;var G_=class extends Gt{constructor(t){super(t,4);}};qe.RequestType4=G_;var z_=class extends Gt{constructor(t){super(t,5);}};qe.RequestType5=z_;var Y_=class extends Gt{constructor(t){super(t,6);}};qe.RequestType6=Y_;var Q_=class extends Gt{constructor(t){super(t,7);}};qe.RequestType7=Q_;var X_=class extends Gt{constructor(t){super(t,8);}};qe.RequestType8=X_;var Z_=class extends Gt{constructor(t){super(t,9);}};qe.RequestType9=Z_;var J_=class extends Gt{constructor(t,r=fn.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.NotificationType=J_;var eb=class extends Gt{constructor(t){super(t,0);}};qe.NotificationType0=eb;var tb=class extends Gt{constructor(t,r=fn.auto){super(t,1),this._parameterStructures=r;}get parameterStructures(){return this._parameterStructures}};qe.NotificationType1=tb;var rb=class extends Gt{constructor(t){super(t,2);}};qe.NotificationType2=rb;var nb=class extends Gt{constructor(t){super(t,3);}};qe.NotificationType3=nb;var ib=class extends Gt{constructor(t){super(t,4);}};qe.NotificationType4=ib;var sb=class extends Gt{constructor(t){super(t,5);}};qe.NotificationType5=sb;var ab=class extends Gt{constructor(t){super(t,6);}};qe.NotificationType6=ab;var ob=class extends Gt{constructor(t){super(t,7);}};qe.NotificationType7=ob;var ub=class extends Gt{constructor(t){super(t,8);}};qe.NotificationType8=ub;var cb=class extends Gt{constructor(t){super(t,9);}};qe.NotificationType9=cb;var PF;(function(e){function t(i){let s=i;return s&&Ra.string(s.method)&&(Ra.string(s.id)||Ra.number(s.id))}e.isRequest=t;function r(i){let s=i;return s&&Ra.string(s.method)&&i.id===void 0}e.isNotification=r;function n(i){let s=i;return s&&(s.result!==void 0||!!s.error)&&(Ra.string(s.id)||Ra.number(s.id)||s.id===null)}e.isResponse=n;})(PF||(qe.Message=PF={}));});var db=I(Ns=>{var NF;Object.defineProperty(Ns,"__esModule",{value:!0});Ns.LRUCache=Ns.LinkedMap=Ns.Touch=void 0;var qr;(function(e){e.None=0,e.First=1,e.AsOld=e.First,e.Last=2,e.AsNew=e.Last;})(qr||(Ns.Touch=qr={}));var ph=class{constructor(){this[NF]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0;}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++;}isEmpty(){return !this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,r=qr.None){let n=this._map.get(t);if(n)return r!==qr.None&&this.touch(n,r),n.value}set(t,r,n=qr.None){let i=this._map.get(t);if(i)i.value=r,n!==qr.None&&this.touch(i,n);else {switch(i={key:t,value:r,next:void 0,previous:void 0},n){case qr.None:this.addItemLast(i);break;case qr.First:this.addItemFirst(i);break;case qr.Last:this.addItemLast(i);break;default:this.addItemLast(i);break}this._map.set(t,i),this._size++;}return this}delete(t){return !!this.remove(t)}remove(t){let r=this._map.get(t);if(r)return this._map.delete(t),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");let t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,r){let n=this._state,i=this._head;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");i=i.next;}}keys(){let t=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:r.key,done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}values(){let t=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:r.value,done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}entries(){let t=this._state,r=this._head,n={[Symbol.iterator]:()=>n,next:()=>{if(this._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){let i={value:[r.key,r.value],done:!1};return r=r.next,i}else return {value:void 0,done:!0}}};return n}[(NF=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this._head,n=this.size;for(;r&&n>t;)this._map.delete(r.key),r=r.next,n--;this._head=r,this._size=n,r&&(r.previous=void 0),this._state++;}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++;}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++;}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next;}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous;}else {let r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r;}t.next=void 0,t.previous=void 0,this._state++;}touch(t,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==qr.First&&r!==qr.Last)){if(r===qr.First){if(t===this._head)return;let n=t.next,i=t.previous;t===this._tail?(i.next=void 0,this._tail=i):(n.previous=i,i.next=n),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++;}else if(r===qr.Last){if(t===this._tail)return;let n=t.next,i=t.previous;t===this._head?(n.previous=void 0,this._head=n):(n.previous=i,i.next=n),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++;}}}toJSON(){let t=[];return this.forEach((r,n)=>{t.push([n,r]);}),t}fromJSON(t){this.clear();for(let[r,n]of t)this.set(r,n);}};Ns.LinkedMap=ph;var fb=class extends ph{constructor(t,r=1){super(),this._limit=t,this._ratio=Math.min(Math.max(0,r),1);}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim();}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim();}get(t,r=qr.AsNew){return super.get(t,r)}peek(t){return super.get(t,qr.None)}set(t,r){return super.set(t,r,qr.Last),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio));}};Ns.LRUCache=fb;});var OF=I(gh=>{Object.defineProperty(gh,"__esModule",{value:!0});gh.Disposable=void 0;var DF;(function(e){function t(r){return {dispose:r}}e.create=t;})(DF||(gh.Disposable=DF={}));});var Ds=I(gb=>{Object.defineProperty(gb,"__esModule",{value:!0});var hb;function pb(){if(hb===void 0)throw new Error("No runtime abstraction layer installed");return hb}(function(e){function t(r){if(r===void 0)throw new Error("No runtime abstraction layer provided");hb=r;}e.install=t;})(pb||(pb={}));gb.default=pb;});var Mo=I(qo=>{Object.defineProperty(qo,"__esModule",{value:!0});qo.Emitter=qo.Event=void 0;var zne=Ds(),kF;(function(e){let t={dispose(){}};e.None=function(){return t};})(kF||(qo.Event=kF={}));var mb=class{add(t,r=null,n){this._callbacks||(this._callbacks=[],this._contexts=[]),this._callbacks.push(t),this._contexts.push(r),Array.isArray(n)&&n.push({dispose:()=>this.remove(t,r)});}remove(t,r=null){if(!this._callbacks)return;let n=!1;for(let i=0,s=this._callbacks.length;i<s;i++)if(this._callbacks[i]===t)if(this._contexts[i]===r){this._callbacks.splice(i,1),this._contexts.splice(i,1);return}else n=!0;if(n)throw new Error("When adding a listener with a context, you should remove it with the same context")}invoke(...t){if(!this._callbacks)return [];let r=[],n=this._callbacks.slice(0),i=this._contexts.slice(0);for(let s=0,a=n.length;s<a;s++)try{r.push(n[s].apply(i[s],t));}catch(o){(0, zne.default)().console.error(o);}return r}isEmpty(){return !this._callbacks||this._callbacks.length===0}dispose(){this._callbacks=void 0,this._contexts=void 0;}},mh=class e{constructor(t){this._options=t;}get event(){return this._event||(this._event=(t,r,n)=>{this._callbacks||(this._callbacks=new mb),this._options&&this._options.onFirstListenerAdd&&this._callbacks.isEmpty()&&this._options.onFirstListenerAdd(this),this._callbacks.add(t,r);let i={dispose:()=>{this._callbacks&&(this._callbacks.remove(t,r),i.dispose=e._noop,this._options&&this._options.onLastListenerRemove&&this._callbacks.isEmpty()&&this._options.onLastListenerRemove(this));}};return Array.isArray(n)&&n.push(i),i}),this._event}fire(t){this._callbacks&&this._callbacks.invoke.call(this._callbacks,t);}dispose(){this._callbacks&&(this._callbacks.dispose(),this._callbacks=void 0);}};qo.Emitter=mh;mh._noop=function(){};});var _h=I(Uo=>{Object.defineProperty(Uo,"__esModule",{value:!0});Uo.CancellationTokenSource=Uo.CancellationToken=void 0;var Yne=Ds(),Qne=Fo(),yb=Mo(),yh;(function(e){e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:yb.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:yb.Event.None});function t(r){let n=r;return n&&(n===e.None||n===e.Cancelled||Qne.boolean(n.isCancellationRequested)&&!!n.onCancellationRequested)}e.is=t;})(yh||(Uo.CancellationToken=yh={}));var Xne=Object.freeze(function(e,t){let r=(0, Yne.default)().timer.setTimeout(e.bind(t),0);return {dispose(){r.dispose();}}}),vh=class{constructor(){this._isCancelled=!1;}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()));}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?Xne:(this._emitter||(this._emitter=new yb.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=void 0);}},vb=class{get token(){return this._token||(this._token=new vh),this._token}cancel(){this._token?this._token.cancel():this._token=yh.Cancelled;}dispose(){this._token?this._token instanceof vh&&this._token.dispose():this._token=yh.None;}};Uo.CancellationTokenSource=vb;});var LF=I($o=>{Object.defineProperty($o,"__esModule",{value:!0});$o.SharedArrayReceiverStrategy=$o.SharedArraySenderStrategy=void 0;var Zne=_h(),Uc;(function(e){e.Continue=0,e.Cancelled=1;})(Uc||(Uc={}));var _b=class{constructor(){this.buffers=new Map;}enableCancellation(t){if(t.id===null)return;let r=new SharedArrayBuffer(4),n=new Int32Array(r,0,1);n[0]=Uc.Continue,this.buffers.set(t.id,r),t.$cancellationData=r;}async sendCancellation(t,r){let n=this.buffers.get(r);if(n===void 0)return;let i=new Int32Array(n,0,1);Atomics.store(i,0,Uc.Cancelled);}cleanup(t){this.buffers.delete(t);}dispose(){this.buffers.clear();}};$o.SharedArraySenderStrategy=_b;var bb=class{constructor(t){this.data=new Int32Array(t,0,1);}get isCancellationRequested(){return Atomics.load(this.data,0)===Uc.Cancelled}get onCancellationRequested(){throw new Error("Cancellation over SharedArrayBuffer doesn't support cancellation events")}},Sb=class{constructor(t){this.token=new bb(t);}cancel(){}dispose(){}},Eb=class{constructor(){this.kind="request";}createCancellationTokenSource(t){let r=t.$cancellationData;return r===void 0?new Zne.CancellationTokenSource:new Sb(r)}};$o.SharedArrayReceiverStrategy=Eb;});var Cb=I(bh=>{Object.defineProperty(bh,"__esModule",{value:!0});bh.Semaphore=void 0;var Jne=Ds(),wb=class{constructor(t=1){if(t<=0)throw new Error("Capacity must be greater than 0");this._capacity=t,this._active=0,this._waiting=[];}lock(t){return new Promise((r,n)=>{this._waiting.push({thunk:t,resolve:r,reject:n}),this.runNext();})}get active(){return this._active}runNext(){this._waiting.length===0||this._active===this._capacity||(0, Jne.default)().timer.setImmediate(()=>this.doRunNext());}doRunNext(){if(this._waiting.length===0||this._active===this._capacity)return;let t=this._waiting.shift();if(this._active++,this._active>this._capacity)throw new Error("To many thunks active");try{let r=t.thunk();r instanceof Promise?r.then(n=>{this._active--,t.resolve(n),this.runNext();},n=>{this._active--,t.reject(n),this.runNext();}):(this._active--,t.resolve(r),this.runNext());}catch(r){this._active--,t.reject(r),this.runNext();}}};bh.Semaphore=wb;});var FF=I(Os=>{Object.defineProperty(Os,"__esModule",{value:!0});Os.ReadableStreamMessageReader=Os.AbstractMessageReader=Os.MessageReader=void 0;var Tb=Ds(),jo=Fo(),xb=Mo(),eie=Cb(),BF;(function(e){function t(r){let n=r;return n&&jo.func(n.listen)&&jo.func(n.dispose)&&jo.func(n.onError)&&jo.func(n.onClose)&&jo.func(n.onPartialMessage)}e.is=t;})(BF||(Os.MessageReader=BF={}));var Sh=class{constructor(){this.errorEmitter=new xb.Emitter,this.closeEmitter=new xb.Emitter,this.partialMessageEmitter=new xb.Emitter;}dispose(){this.errorEmitter.dispose(),this.closeEmitter.dispose();}get onError(){return this.errorEmitter.event}fireError(t){this.errorEmitter.fire(this.asError(t));}get onClose(){return this.closeEmitter.event}fireClose(){this.closeEmitter.fire(void 0);}get onPartialMessage(){return this.partialMessageEmitter.event}firePartialMessage(t){this.partialMessageEmitter.fire(t);}asError(t){return t instanceof Error?t:new Error(`Reader received error. Reason: ${jo.string(t.message)?t.message:"unknown"}`)}};Os.AbstractMessageReader=Sh;var Ab;(function(e){function t(r){let n,s,a=new Map,o,c=new Map;if(r===void 0||typeof r=="string")n=r??"utf-8";else {if(n=r.charset??"utf-8",r.contentDecoder!==void 0&&(s=r.contentDecoder,a.set(s.name,s)),r.contentDecoders!==void 0)for(let l of r.contentDecoders)a.set(l.name,l);if(r.contentTypeDecoder!==void 0&&(o=r.contentTypeDecoder,c.set(o.name,o)),r.contentTypeDecoders!==void 0)for(let l of r.contentTypeDecoders)c.set(l.name,l);}return o===void 0&&(o=(0, Tb.default)().applicationJson.decoder,c.set(o.name,o)),{charset:n,contentDecoder:s,contentDecoders:a,contentTypeDecoder:o,contentTypeDecoders:c}}e.fromOptions=t;})(Ab||(Ab={}));var Rb=class extends Sh{constructor(t,r){super(),this.readable=t,this.options=Ab.fromOptions(r),this.buffer=(0, Tb.default)().messageBuffer.create(this.options.charset),this._partialMessageTimeout=1e4,this.nextMessageLength=-1,this.messageToken=0,this.readSemaphore=new eie.Semaphore(1);}set partialMessageTimeout(t){this._partialMessageTimeout=t;}get partialMessageTimeout(){return this._partialMessageTimeout}listen(t){this.nextMessageLength=-1,this.messageToken=0,this.partialMessageTimer=void 0,this.callback=t;let r=this.readable.onData(n=>{this.onData(n);});return this.readable.onError(n=>this.fireError(n)),this.readable.onClose(()=>this.fireClose()),r}onData(t){try{for(this.buffer.append(t);;){if(this.nextMessageLength===-1){let n=this.buffer.tryReadHeaders(!0);if(!n)return;let i=n.get("content-length");if(!i){this.fireError(new Error(`Header must provide a Content-Length property.
${JSON.stringify(Object.fromEntries(n))}`));return}let s=parseInt(i);if(isNaN(s)){this.fireError(new Error(`Content-Length value must be a number. Got ${i}`));return}this.nextMessageLength=s;}let r=this.buffer.tryReadBody(this.nextMessageLength);if(r===void 0){this.setPartialMessageTimer();return}this.clearPartialMessageTimer(),this.nextMessageLength=-1,this.readSemaphore.lock(async()=>{let n=this.options.contentDecoder!==void 0?await this.options.contentDecoder.decode(r):r,i=await this.options.contentTypeDecoder.decode(n,this.options);this.callback(i);}).catch(n=>{this.fireError(n);});}}catch(r){this.fireError(r);}}clearPartialMessageTimer(){this.partialMessageTimer&&(this.partialMessageTimer.dispose(),this.partialMessageTimer=void 0);}setPartialMessageTimer(){this.clearPartialMessageTimer(),!(this._partialMessageTimeout<=0)&&(this.partialMessageTimer=(0, Tb.default)().timer.setTimeout((t,r)=>{this.partialMessageTimer=void 0,t===this.messageToken&&(this.firePartialMessage({messageToken:t,waitingTime:r}),this.setPartialMessageTimer());},this._partialMessageTimeout,this.messageToken,this._partialMessageTimeout));}};Os.ReadableStreamMessageReader=Rb;});var jF=I(ks=>{Object.defineProperty(ks,"__esModule",{value:!0});ks.WriteableStreamMessageWriter=ks.AbstractMessageWriter=ks.MessageWriter=void 0;var qF=Ds(),$c=Fo(),tie=Cb(),MF=Mo(),rie="Content-Length: ",UF=`\r
`,$F;(function(e){function t(r){let n=r;return n&&$c.func(n.dispose)&&$c.func(n.onClose)&&$c.func(n.onError)&&$c.func(n.write)}e.is=t;})($F||(ks.MessageWriter=$F={}));var Eh=class{constructor(){this.errorEmitter=new MF.Emitter,this.closeEmitter=new MF.Emitter;}dispose(){this.errorEmitter.dispose(),this.closeEmitter.dispose();}get onError(){return this.errorEmitter.event}fireError(t,r,n){this.errorEmitter.fire([this.asError(t),r,n]);}get onClose(){return this.closeEmitter.event}fireClose(){this.closeEmitter.fire(void 0);}asError(t){return t instanceof Error?t:new Error(`Writer received error. Reason: ${$c.string(t.message)?t.message:"unknown"}`)}};ks.AbstractMessageWriter=Eh;var Ib;(function(e){function t(r){return r===void 0||typeof r=="string"?{charset:r??"utf-8",contentTypeEncoder:(0, qF.default)().applicationJson.encoder}:{charset:r.charset??"utf-8",contentEncoder:r.contentEncoder,contentTypeEncoder:r.contentTypeEncoder??(0, qF.default)().applicationJson.encoder}}e.fromOptions=t;})(Ib||(Ib={}));var Pb=class extends Eh{constructor(t,r){super(),this.writable=t,this.options=Ib.fromOptions(r),this.errorCount=0,this.writeSemaphore=new tie.Semaphore(1),this.writable.onError(n=>this.fireError(n)),this.writable.onClose(()=>this.fireClose());}async write(t){return this.writeSemaphore.lock(async()=>this.options.contentTypeEncoder.encode(t,this.options).then(n=>this.options.contentEncoder!==void 0?this.options.contentEncoder.encode(n):n).then(n=>{let i=[];return i.push(rie,n.byteLength.toString(),UF),i.push(UF),this.doWrite(t,i,n)},n=>{throw this.fireError(n),n}))}async doWrite(t,r,n){try{return await this.writable.write(r.join(""),"ascii"),this.writable.write(n)}catch(i){return this.handleError(i,t),Promise.reject(i)}}handleError(t,r){this.errorCount++,this.fireError(t,r,this.errorCount);}end(){this.writable.end();}};ks.WriteableStreamMessageWriter=Pb;});var VF=I(wh=>{Object.defineProperty(wh,"__esModule",{value:!0});wh.AbstractMessageBuffer=void 0;var nie=13,iie=10,sie=`\r
`,Nb=class{constructor(t="utf-8"){this._encoding=t,this._chunks=[],this._totalLength=0;}get encoding(){return this._encoding}append(t){let r=typeof t=="string"?this.fromString(t,this._encoding):t;this._chunks.push(r),this._totalLength+=r.byteLength;}tryReadHeaders(t=!1){if(this._chunks.length===0)return;let r=0,n=0,i=0,s=0;e:for(;n<this._chunks.length;){let l=this._chunks[n];for(i=0;i<l.length;){switch(l[i]){case nie:switch(r){case 0:r=1;break;case 2:r=3;break;default:r=0;}break;case iie:switch(r){case 1:r=2;break;case 3:r=4,i++;break e;default:r=0;}break;default:r=0;}i++;}s+=l.byteLength,n++;}if(r!==4)return;let a=this._read(s+i),o=new Map,c=this.toString(a,"ascii").split(sie);if(c.length<2)return o;for(let l=0;l<c.length-2;l++){let u=c[l],f=u.indexOf(":");if(f===-1)throw new Error(`Message header must separate key and value using ':'
${u}`);let h=u.substr(0,f),p=u.substr(f+1).trim();o.set(t?h.toLowerCase():h,p);}return o}tryReadBody(t){if(!(this._totalLength<t))return this._read(t)}get numberOfBytes(){return this._totalLength}_read(t){if(t===0)return this.emptyBuffer();if(t>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===t){let s=this._chunks[0];return this._chunks.shift(),this._totalLength-=t,this.asNative(s)}if(this._chunks[0].byteLength>t){let s=this._chunks[0],a=this.asNative(s,t);return this._chunks[0]=s.slice(t),this._totalLength-=t,a}let r=this.allocNative(t),n=0,i=0;for(;t>0;){let s=this._chunks[i];if(s.byteLength>t){let a=s.slice(0,t);r.set(a,n),n+=t,this._chunks[i]=s.slice(t),this._totalLength-=t,t-=t;}else r.set(s,n),n+=s.byteLength,this._chunks.shift(),this._totalLength-=s.byteLength,t-=s.byteLength;}return r}};wh.AbstractMessageBuffer=Nb;});var zF=I(Je=>{Object.defineProperty(Je,"__esModule",{value:!0});Je.createMessageConnection=Je.ConnectionOptions=Je.MessageStrategy=Je.CancellationStrategy=Je.CancellationSenderStrategy=Je.CancellationReceiverStrategy=Je.RequestCancellationReceiverStrategy=Je.IdCancellationReceiverStrategy=Je.ConnectionStrategy=Je.ConnectionError=Je.ConnectionErrors=Je.LogTraceNotification=Je.SetTraceNotification=Je.TraceFormat=Je.TraceValues=Je.Trace=Je.NullLogger=Je.ProgressType=Je.ProgressToken=void 0;var HF=Ds(),er=Fo(),He=lb(),WF=db(),jc=Mo(),Db=_h(),Wc;(function(e){e.type=new He.NotificationType("$/cancelRequest");})(Wc||(Wc={}));var Ob;(function(e){function t(r){return typeof r=="string"||typeof r=="number"}e.is=t;})(Ob||(Je.ProgressToken=Ob={}));var Vc;(function(e){e.type=new He.NotificationType("$/progress");})(Vc||(Vc={}));var kb=class{constructor(){}};Je.ProgressType=kb;var Lb;(function(e){function t(r){return er.func(r)}e.is=t;})(Lb||(Lb={}));Je.NullLogger=Object.freeze({error:()=>{},warn:()=>{},info:()=>{},log:()=>{}});var Tt;(function(e){e[e.Off=0]="Off",e[e.Messages=1]="Messages",e[e.Compact=2]="Compact",e[e.Verbose=3]="Verbose";})(Tt||(Je.Trace=Tt={}));var KF;(function(e){e.Off="off",e.Messages="messages",e.Compact="compact",e.Verbose="verbose";})(KF||(Je.TraceValues=KF={}));(function(e){function t(n){if(!er.string(n))return e.Off;switch(n=n.toLowerCase(),n){case"off":return e.Off;case"messages":return e.Messages;case"compact":return e.Compact;case"verbose":return e.Verbose;default:return e.Off}}e.fromString=t;function r(n){switch(n){case e.Off:return "off";case e.Messages:return "messages";case e.Compact:return "compact";case e.Verbose:return "verbose";default:return "off"}}e.toString=r;})(Tt||(Je.Trace=Tt={}));var Tn;(function(e){e.Text="text",e.JSON="json";})(Tn||(Je.TraceFormat=Tn={}));(function(e){function t(r){return er.string(r)?(r=r.toLowerCase(),r==="json"?e.JSON:e.Text):e.Text}e.fromString=t;})(Tn||(Je.TraceFormat=Tn={}));var Bb;(function(e){e.type=new He.NotificationType("$/setTrace");})(Bb||(Je.SetTraceNotification=Bb={}));var Ch;(function(e){e.type=new He.NotificationType("$/logTrace");})(Ch||(Je.LogTraceNotification=Ch={}));var Hc;(function(e){e[e.Closed=1]="Closed",e[e.Disposed=2]="Disposed",e[e.AlreadyListening=3]="AlreadyListening";})(Hc||(Je.ConnectionErrors=Hc={}));var Vo=class e extends Error{constructor(t,r){super(r),this.code=t,Object.setPrototypeOf(this,e.prototype);}};Je.ConnectionError=Vo;var Fb;(function(e){function t(r){let n=r;return n&&er.func(n.cancelUndispatched)}e.is=t;})(Fb||(Je.ConnectionStrategy=Fb={}));var xh;(function(e){function t(r){let n=r;return n&&(n.kind===void 0||n.kind==="id")&&er.func(n.createCancellationTokenSource)&&(n.dispose===void 0||er.func(n.dispose))}e.is=t;})(xh||(Je.IdCancellationReceiverStrategy=xh={}));var qb;(function(e){function t(r){let n=r;return n&&n.kind==="request"&&er.func(n.createCancellationTokenSource)&&(n.dispose===void 0||er.func(n.dispose))}e.is=t;})(qb||(Je.RequestCancellationReceiverStrategy=qb={}));var Th;(function(e){e.Message=Object.freeze({createCancellationTokenSource(r){return new Db.CancellationTokenSource}});function t(r){return xh.is(r)||qb.is(r)}e.is=t;})(Th||(Je.CancellationReceiverStrategy=Th={}));var Ah;(function(e){e.Message=Object.freeze({sendCancellation(r,n){return r.sendNotification(Wc.type,{id:n})},cleanup(r){}});function t(r){let n=r;return n&&er.func(n.sendCancellation)&&er.func(n.cleanup)}e.is=t;})(Ah||(Je.CancellationSenderStrategy=Ah={}));var Rh;(function(e){e.Message=Object.freeze({receiver:Th.Message,sender:Ah.Message});function t(r){let n=r;return n&&Th.is(n.receiver)&&Ah.is(n.sender)}e.is=t;})(Rh||(Je.CancellationStrategy=Rh={}));var Ih;(function(e){function t(r){let n=r;return n&&er.func(n.handleMessage)}e.is=t;})(Ih||(Je.MessageStrategy=Ih={}));var GF;(function(e){function t(r){let n=r;return n&&(Rh.is(n.cancellationStrategy)||Fb.is(n.connectionStrategy)||Ih.is(n.messageStrategy))}e.is=t;})(GF||(Je.ConnectionOptions=GF={}));var ui;(function(e){e[e.New=1]="New",e[e.Listening=2]="Listening",e[e.Closed=3]="Closed",e[e.Disposed=4]="Disposed";})(ui||(ui={}));function aie(e,t,r,n){let i=r!==void 0?r:Je.NullLogger,s=0,a=0,o=0,c="2.0",l,u=new Map,f,h=new Map,p=new Map,g,_=new WF.LinkedMap,E=new Map,w=new Set,y=new Map,b=Tt.Off,N=Tn.Text,L,V=ui.New,Z=new jc.Emitter,G=new jc.Emitter,z=new jc.Emitter,ee=new jc.Emitter,U=new jc.Emitter,ie=n&&n.cancellationStrategy?n.cancellationStrategy:Rh.Message;function me(q){if(q===null)throw new Error("Can't send requests with id null since the response can't be correlated.");return "req-"+q.toString()}function Pe(q){return q===null?"res-unknown-"+(++o).toString():"res-"+q.toString()}function W(){return "not-"+(++a).toString()}function K(q,ae){He.Message.isRequest(ae)?q.set(me(ae.id),ae):He.Message.isResponse(ae)?q.set(Pe(ae.id),ae):q.set(W(),ae);}function se(q){}function Ae(){return V===ui.Listening}function Me(){return V===ui.Closed}function ze(){return V===ui.Disposed}function We(){(V===ui.New||V===ui.Listening)&&(V=ui.Closed,G.fire(void 0));}function lt(q){Z.fire([q,void 0,void 0]);}function Bt(q){Z.fire(q);}e.onClose(We),e.onError(lt),t.onClose(We),t.onError(Bt);function Ct(){g||_.size===0||(g=(0, HF.default)().timer.setImmediate(()=>{g=void 0,Be();}));}function pt(q){He.Message.isRequest(q)?Vt(q):He.Message.isNotification(q)?Ve(q):He.Message.isResponse(q)?ye(q):le(q);}function Be(){if(_.size===0)return;let q=_.shift();try{let ae=n?.messageStrategy;Ih.is(ae)?ae.handleMessage(q,pt):pt(q);}finally{Ct();}}let Dt=q=>{try{if(He.Message.isNotification(q)&&q.method===Wc.type.method){let ae=q.params.id,Se=me(ae),Ne=_.get(Se);if(He.Message.isRequest(Ne)){let vt=n?.connectionStrategy,Ot=vt&&vt.cancelUndispatched?vt.cancelUndispatched(Ne,se):void 0;if(Ot&&(Ot.error!==void 0||Ot.result!==void 0)){_.delete(Se),y.delete(ae),Ot.id=Ne.id,Ye(Ot,q.method,Date.now()),t.write(Ot).catch(()=>i.error("Sending response for canceled message failed."));return}}let xt=y.get(ae);if(xt!==void 0){xt.cancel(),$r(q);return}else w.add(ae);}K(_,q);}finally{Ct();}};function Vt(q){if(ze())return;function ae(it,It,gt){let zt={jsonrpc:c,id:q.id};it instanceof He.ResponseError?zt.error=it.toJson():zt.result=it===void 0?null:it,Ye(zt,It,gt),t.write(zt).catch(()=>i.error("Sending response failed."));}function Se(it,It,gt){let zt={jsonrpc:c,id:q.id,error:it.toJson()};Ye(zt,It,gt),t.write(zt).catch(()=>i.error("Sending response failed."));}function Ne(it,It,gt){it===void 0&&(it=null);let zt={jsonrpc:c,id:q.id,result:it};Ye(zt,It,gt),t.write(zt).catch(()=>i.error("Sending response failed."));}Rn(q);let xt=u.get(q.method),vt,Ot;xt&&(vt=xt.type,Ot=xt.handler);let qt=Date.now();if(Ot||l){let it=q.id??String(Date.now()),It=xh.is(ie.receiver)?ie.receiver.createCancellationTokenSource(it):ie.receiver.createCancellationTokenSource(q);q.id!==null&&w.has(q.id)&&It.cancel(),q.id!==null&&y.set(it,It);try{let gt;if(Ot)if(q.params===void 0){if(vt!==void 0&&vt.numberOfParams!==0){Se(new He.ResponseError(He.ErrorCodes.InvalidParams,`Request ${q.method} defines ${vt.numberOfParams} params but received none.`),q.method,qt);return}gt=Ot(It.token);}else if(Array.isArray(q.params)){if(vt!==void 0&&vt.parameterStructures===He.ParameterStructures.byName){Se(new He.ResponseError(He.ErrorCodes.InvalidParams,`Request ${q.method} defines parameters by name but received parameters by position`),q.method,qt);return}gt=Ot(...q.params,It.token);}else {if(vt!==void 0&&vt.parameterStructures===He.ParameterStructures.byPosition){Se(new He.ResponseError(He.ErrorCodes.InvalidParams,`Request ${q.method} defines parameters by position but received parameters by name`),q.method,qt);return}gt=Ot(q.params,It.token);}else l&&(gt=l(q.method,q.params,It.token));let zt=gt;gt?zt.then?zt.then(nr=>{y.delete(it),ae(nr,q.method,qt);},nr=>{y.delete(it),nr instanceof He.ResponseError?Se(nr,q.method,qt):nr&&er.string(nr.message)?Se(new He.ResponseError(He.ErrorCodes.InternalError,`Request ${q.method} failed with message: ${nr.message}`),q.method,qt):Se(new He.ResponseError(He.ErrorCodes.InternalError,`Request ${q.method} failed unexpectedly without providing any details.`),q.method,qt);}):(y.delete(it),ae(gt,q.method,qt)):(y.delete(it),Ne(gt,q.method,qt));}catch(gt){y.delete(it),gt instanceof He.ResponseError?ae(gt,q.method,qt):gt&&er.string(gt.message)?Se(new He.ResponseError(He.ErrorCodes.InternalError,`Request ${q.method} failed with message: ${gt.message}`),q.method,qt):Se(new He.ResponseError(He.ErrorCodes.InternalError,`Request ${q.method} failed unexpectedly without providing any details.`),q.method,qt);}}else Se(new He.ResponseError(He.ErrorCodes.MethodNotFound,`Unhandled method ${q.method}`),q.method,qt);}function ye(q){if(!ze())if(q.id===null)q.error?i.error(`Received response message without id: Error is: 
${JSON.stringify(q.error,void 0,4)}`):i.error("Received response message without id. No further error information provided.");else {let ae=q.id,Se=E.get(ae);if(Vs(q,Se),Se!==void 0){E.delete(ae);try{if(q.error){let Ne=q.error;Se.reject(new He.ResponseError(Ne.code,Ne.message,Ne.data));}else if(q.result!==void 0)Se.resolve(q.result);else throw new Error("Should never happen.")}catch(Ne){Ne.message?i.error(`Response handler '${Se.method}' failed with message: ${Ne.message}`):i.error(`Response handler '${Se.method}' failed unexpectedly.`);}}}}function Ve(q){if(ze())return;let ae,Se;if(q.method===Wc.type.method){let Ne=q.params.id;w.delete(Ne),$r(q);return}else {let Ne=h.get(q.method);Ne&&(Se=Ne.handler,ae=Ne.type);}if(Se||f)try{if($r(q),Se)if(q.params===void 0)ae!==void 0&&ae.numberOfParams!==0&&ae.parameterStructures!==He.ParameterStructures.byName&&i.error(`Notification ${q.method} defines ${ae.numberOfParams} params but received none.`),Se();else if(Array.isArray(q.params)){let Ne=q.params;q.method===Vc.type.method&&Ne.length===2&&Ob.is(Ne[0])?Se({token:Ne[0],value:Ne[1]}):(ae!==void 0&&(ae.parameterStructures===He.ParameterStructures.byName&&i.error(`Notification ${q.method} defines parameters by name but received parameters by position`),ae.numberOfParams!==q.params.length&&i.error(`Notification ${q.method} defines ${ae.numberOfParams} params but received ${Ne.length} arguments`)),Se(...Ne));}else ae!==void 0&&ae.parameterStructures===He.ParameterStructures.byPosition&&i.error(`Notification ${q.method} defines parameters by position but received parameters by name`),Se(q.params);else f&&f(q.method,q.params);}catch(Ne){Ne.message?i.error(`Notification handler '${q.method}' failed with message: ${Ne.message}`):i.error(`Notification handler '${q.method}' failed unexpectedly.`);}else z.fire(q);}function le(q){if(!q){i.error("Received empty message.");return}i.error(`Received message which is neither a response nor a notification message:
${JSON.stringify(q,null,4)}`);let ae=q;if(er.string(ae.id)||er.number(ae.id)){let Se=ae.id,Ne=E.get(Se);Ne&&Ne.reject(new Error("The received response has neither a result nor an error property."));}}function Ie(q){if(q!=null)switch(b){case Tt.Verbose:return JSON.stringify(q,null,4);case Tt.Compact:return JSON.stringify(q);default:return}}function Ke(q){if(!(b===Tt.Off||!L))if(N===Tn.Text){let ae;(b===Tt.Verbose||b===Tt.Compact)&&q.params&&(ae=`Params: ${Ie(q.params)}

`),L.log(`Sending request '${q.method} - (${q.id})'.`,ae);}else jr("send-request",q);}function nt(q){if(!(b===Tt.Off||!L))if(N===Tn.Text){let ae;(b===Tt.Verbose||b===Tt.Compact)&&(q.params?ae=`Params: ${Ie(q.params)}

`:ae=`No parameters provided.

`),L.log(`Sending notification '${q.method}'.`,ae);}else jr("send-notification",q);}function Ye(q,ae,Se){if(!(b===Tt.Off||!L))if(N===Tn.Text){let Ne;(b===Tt.Verbose||b===Tt.Compact)&&(q.error&&q.error.data?Ne=`Error data: ${Ie(q.error.data)}

`:q.result?Ne=`Result: ${Ie(q.result)}

`:q.error===void 0&&(Ne=`No result returned.

`)),L.log(`Sending response '${ae} - (${q.id})'. Processing request took ${Date.now()-Se}ms`,Ne);}else jr("send-response",q);}function Rn(q){if(!(b===Tt.Off||!L))if(N===Tn.Text){let ae;(b===Tt.Verbose||b===Tt.Compact)&&q.params&&(ae=`Params: ${Ie(q.params)}

`),L.log(`Received request '${q.method} - (${q.id})'.`,ae);}else jr("receive-request",q);}function $r(q){if(!(b===Tt.Off||!L||q.method===Ch.type.method))if(N===Tn.Text){let ae;(b===Tt.Verbose||b===Tt.Compact)&&(q.params?ae=`Params: ${Ie(q.params)}

`:ae=`No parameters provided.

`),L.log(`Received notification '${q.method}'.`,ae);}else jr("receive-notification",q);}function Vs(q,ae){if(!(b===Tt.Off||!L))if(N===Tn.Text){let Se;if((b===Tt.Verbose||b===Tt.Compact)&&(q.error&&q.error.data?Se=`Error data: ${Ie(q.error.data)}

`:q.result?Se=`Result: ${Ie(q.result)}

`:q.error===void 0&&(Se=`No result returned.

`)),ae){let Ne=q.error?` Request failed: ${q.error.message} (${q.error.code}).`:"";L.log(`Received response '${ae.method} - (${q.id})' in ${Date.now()-ae.timerStart}ms.${Ne}`,Se);}else L.log(`Received response ${q.id} without active response promise.`,Se);}else jr("receive-response",q);}function jr(q,ae){if(!L||b===Tt.Off)return;let Se={isLSPMessage:!0,type:q,message:ae,timestamp:Date.now()};L.log(Se);}function tn(){if(Me())throw new Vo(Hc.Closed,"Connection is closed.");if(ze())throw new Vo(Hc.Disposed,"Connection is disposed.")}function Hs(){if(Ae())throw new Vo(Hc.AlreadyListening,"Connection is already listening")}function Ba(){if(!Ae())throw new Error("Call listen() first.")}function mn(q){return q===void 0?null:q}function Ws(q){if(q!==null)return q}function Ks(q){return q!=null&&!Array.isArray(q)&&typeof q=="object"}function ki(q,ae){switch(q){case He.ParameterStructures.auto:return Ks(ae)?Ws(ae):[mn(ae)];case He.ParameterStructures.byName:if(!Ks(ae))throw new Error("Received parameters by name but param is not an object literal.");return Ws(ae);case He.ParameterStructures.byPosition:return [mn(ae)];default:throw new Error(`Unknown parameter structure ${q.toString()}`)}}function Gs(q,ae){let Se,Ne=q.numberOfParams;switch(Ne){case 0:Se=void 0;break;case 1:Se=ki(q.parameterStructures,ae[0]);break;default:Se=[];for(let xt=0;xt<ae.length&&xt<Ne;xt++)Se.push(mn(ae[xt]));if(ae.length<Ne)for(let xt=ae.length;xt<Ne;xt++)Se.push(null);break}return Se}let Yn={sendNotification:(q,...ae)=>{tn();let Se,Ne;if(er.string(q)){Se=q;let vt=ae[0],Ot=0,qt=He.ParameterStructures.auto;He.ParameterStructures.is(vt)&&(Ot=1,qt=vt);let it=ae.length,It=it-Ot;switch(It){case 0:Ne=void 0;break;case 1:Ne=ki(qt,ae[Ot]);break;default:if(qt===He.ParameterStructures.byName)throw new Error(`Received ${It} parameters for 'by Name' notification parameter structure.`);Ne=ae.slice(Ot,it).map(gt=>mn(gt));break}}else {let vt=ae;Se=q.method,Ne=Gs(q,vt);}let xt={jsonrpc:c,method:Se,params:Ne};return nt(xt),t.write(xt).catch(vt=>{throw i.error("Sending notification failed."),vt})},onNotification:(q,ae)=>{tn();let Se;return er.func(q)?f=q:ae&&(er.string(q)?(Se=q,h.set(q,{type:void 0,handler:ae})):(Se=q.method,h.set(q.method,{type:q,handler:ae}))),{dispose:()=>{Se!==void 0?h.delete(Se):f=void 0;}}},onProgress:(q,ae,Se)=>{if(p.has(ae))throw new Error(`Progress handler for token ${ae} already registered`);return p.set(ae,Se),{dispose:()=>{p.delete(ae);}}},sendProgress:(q,ae,Se)=>Yn.sendNotification(Vc.type,{token:ae,value:Se}),onUnhandledProgress:ee.event,sendRequest:(q,...ae)=>{tn(),Ba();let Se,Ne,xt;if(er.string(q)){Se=q;let it=ae[0],It=ae[ae.length-1],gt=0,zt=He.ParameterStructures.auto;He.ParameterStructures.is(it)&&(gt=1,zt=it);let nr=ae.length;Db.CancellationToken.is(It)&&(nr=nr-1,xt=It);let Vr=nr-gt;switch(Vr){case 0:Ne=void 0;break;case 1:Ne=ki(zt,ae[gt]);break;default:if(zt===He.ParameterStructures.byName)throw new Error(`Received ${Vr} parameters for 'by Name' request parameter structure.`);Ne=ae.slice(gt,nr).map(Fa=>mn(Fa));break}}else {let it=ae;Se=q.method,Ne=Gs(q,it);let It=q.numberOfParams;xt=Db.CancellationToken.is(it[It])?it[It]:void 0;}let vt=s++,Ot;xt&&(Ot=xt.onCancellationRequested(()=>{let it=ie.sender.sendCancellation(Yn,vt);return it===void 0?(i.log(`Received no promise from cancellation strategy when cancelling id ${vt}`),Promise.resolve()):it.catch(()=>{i.log(`Sending cancellation messages for id ${vt} failed`);})}));let qt={jsonrpc:c,id:vt,method:Se,params:Ne};return Ke(qt),typeof ie.sender.enableCancellation=="function"&&ie.sender.enableCancellation(qt),new Promise(async(it,It)=>{let gt=Vr=>{it(Vr),ie.sender.cleanup(vt),Ot?.dispose();},zt=Vr=>{It(Vr),ie.sender.cleanup(vt),Ot?.dispose();},nr={method:Se,timerStart:Date.now(),resolve:gt,reject:zt};try{await t.write(qt),E.set(vt,nr);}catch(Vr){throw i.error("Sending request failed."),nr.reject(new He.ResponseError(He.ErrorCodes.MessageWriteError,Vr.message?Vr.message:"Unknown reason")),Vr}})},onRequest:(q,ae)=>{tn();let Se=null;return Lb.is(q)?(Se=void 0,l=q):er.string(q)?(Se=null,ae!==void 0&&(Se=q,u.set(q,{handler:ae,type:void 0}))):ae!==void 0&&(Se=q.method,u.set(q.method,{type:q,handler:ae})),{dispose:()=>{Se!==null&&(Se!==void 0?u.delete(Se):l=void 0);}}},hasPendingResponse:()=>E.size>0,trace:async(q,ae,Se)=>{let Ne=!1,xt=Tn.Text;Se!==void 0&&(er.boolean(Se)?Ne=Se:(Ne=Se.sendNotification||!1,xt=Se.traceFormat||Tn.Text)),b=q,N=xt,b===Tt.Off?L=void 0:L=ae,Ne&&!Me()&&!ze()&&await Yn.sendNotification(Bb.type,{value:Tt.toString(q)});},onError:Z.event,onClose:G.event,onUnhandledNotification:z.event,onDispose:U.event,end:()=>{t.end();},dispose:()=>{if(ze())return;V=ui.Disposed,U.fire(void 0);let q=new He.ResponseError(He.ErrorCodes.PendingResponseRejected,"Pending response rejected since connection got disposed");for(let ae of E.values())ae.reject(q);E=new Map,y=new Map,w=new Set,_=new WF.LinkedMap,er.func(t.dispose)&&t.dispose(),er.func(e.dispose)&&e.dispose();},listen:()=>{tn(),Hs(),V=ui.Listening,e.listen(Dt);},inspect:()=>{(0, HF.default)().console.log("inspect");}};return Yn.onNotification(Ch.type,q=>{if(b===Tt.Off||!L)return;let ae=b===Tt.Verbose||b===Tt.Compact;L.log(q.message,ae?q.verbose:void 0);}),Yn.onNotification(Vc.type,q=>{let ae=p.get(q.token);ae?ae(q.value):ee.fire(q);}),Yn}Je.createMessageConnection=aie;});var Ph=I(re=>{Object.defineProperty(re,"__esModule",{value:!0});re.ProgressType=re.ProgressToken=re.createMessageConnection=re.NullLogger=re.ConnectionOptions=re.ConnectionStrategy=re.AbstractMessageBuffer=re.WriteableStreamMessageWriter=re.AbstractMessageWriter=re.MessageWriter=re.ReadableStreamMessageReader=re.AbstractMessageReader=re.MessageReader=re.SharedArrayReceiverStrategy=re.SharedArraySenderStrategy=re.CancellationToken=re.CancellationTokenSource=re.Emitter=re.Event=re.Disposable=re.LRUCache=re.Touch=re.LinkedMap=re.ParameterStructures=re.NotificationType9=re.NotificationType8=re.NotificationType7=re.NotificationType6=re.NotificationType5=re.NotificationType4=re.NotificationType3=re.NotificationType2=re.NotificationType1=re.NotificationType0=re.NotificationType=re.ErrorCodes=re.ResponseError=re.RequestType9=re.RequestType8=re.RequestType7=re.RequestType6=re.RequestType5=re.RequestType4=re.RequestType3=re.RequestType2=re.RequestType1=re.RequestType0=re.RequestType=re.Message=re.RAL=void 0;re.MessageStrategy=re.CancellationStrategy=re.CancellationSenderStrategy=re.CancellationReceiverStrategy=re.ConnectionError=re.ConnectionErrors=re.LogTraceNotification=re.SetTraceNotification=re.TraceFormat=re.TraceValues=re.Trace=void 0;var jt=lb();Object.defineProperty(re,"Message",{enumerable:!0,get:function(){return jt.Message}});Object.defineProperty(re,"RequestType",{enumerable:!0,get:function(){return jt.RequestType}});Object.defineProperty(re,"RequestType0",{enumerable:!0,get:function(){return jt.RequestType0}});Object.defineProperty(re,"RequestType1",{enumerable:!0,get:function(){return jt.RequestType1}});Object.defineProperty(re,"RequestType2",{enumerable:!0,get:function(){return jt.RequestType2}});Object.defineProperty(re,"RequestType3",{enumerable:!0,get:function(){return jt.RequestType3}});Object.defineProperty(re,"RequestType4",{enumerable:!0,get:function(){return jt.RequestType4}});Object.defineProperty(re,"RequestType5",{enumerable:!0,get:function(){return jt.RequestType5}});Object.defineProperty(re,"RequestType6",{enumerable:!0,get:function(){return jt.RequestType6}});Object.defineProperty(re,"RequestType7",{enumerable:!0,get:function(){return jt.RequestType7}});Object.defineProperty(re,"RequestType8",{enumerable:!0,get:function(){return jt.RequestType8}});Object.defineProperty(re,"RequestType9",{enumerable:!0,get:function(){return jt.RequestType9}});Object.defineProperty(re,"ResponseError",{enumerable:!0,get:function(){return jt.ResponseError}});Object.defineProperty(re,"ErrorCodes",{enumerable:!0,get:function(){return jt.ErrorCodes}});Object.defineProperty(re,"NotificationType",{enumerable:!0,get:function(){return jt.NotificationType}});Object.defineProperty(re,"NotificationType0",{enumerable:!0,get:function(){return jt.NotificationType0}});Object.defineProperty(re,"NotificationType1",{enumerable:!0,get:function(){return jt.NotificationType1}});Object.defineProperty(re,"NotificationType2",{enumerable:!0,get:function(){return jt.NotificationType2}});Object.defineProperty(re,"NotificationType3",{enumerable:!0,get:function(){return jt.NotificationType3}});Object.defineProperty(re,"NotificationType4",{enumerable:!0,get:function(){return jt.NotificationType4}});Object.defineProperty(re,"NotificationType5",{enumerable:!0,get:function(){return jt.NotificationType5}});Object.defineProperty(re,"NotificationType6",{enumerable:!0,get:function(){return jt.NotificationType6}});Object.defineProperty(re,"NotificationType7",{enumerable:!0,get:function(){return jt.NotificationType7}});Object.defineProperty(re,"NotificationType8",{enumerable:!0,get:function(){return jt.NotificationType8}});Object.defineProperty(re,"NotificationType9",{enumerable:!0,get:function(){return jt.NotificationType9}});Object.defineProperty(re,"ParameterStructures",{enumerable:!0,get:function(){return jt.ParameterStructures}});var Mb=db();Object.defineProperty(re,"LinkedMap",{enumerable:!0,get:function(){return Mb.LinkedMap}});Object.defineProperty(re,"LRUCache",{enumerable:!0,get:function(){return Mb.LRUCache}});Object.defineProperty(re,"Touch",{enumerable:!0,get:function(){return Mb.Touch}});var oie=OF();Object.defineProperty(re,"Disposable",{enumerable:!0,get:function(){return oie.Disposable}});var YF=Mo();Object.defineProperty(re,"Event",{enumerable:!0,get:function(){return YF.Event}});Object.defineProperty(re,"Emitter",{enumerable:!0,get:function(){return YF.Emitter}});var QF=_h();Object.defineProperty(re,"CancellationTokenSource",{enumerable:!0,get:function(){return QF.CancellationTokenSource}});Object.defineProperty(re,"CancellationToken",{enumerable:!0,get:function(){return QF.CancellationToken}});var XF=LF();Object.defineProperty(re,"SharedArraySenderStrategy",{enumerable:!0,get:function(){return XF.SharedArraySenderStrategy}});Object.defineProperty(re,"SharedArrayReceiverStrategy",{enumerable:!0,get:function(){return XF.SharedArrayReceiverStrategy}});var Ub=FF();Object.defineProperty(re,"MessageReader",{enumerable:!0,get:function(){return Ub.MessageReader}});Object.defineProperty(re,"AbstractMessageReader",{enumerable:!0,get:function(){return Ub.AbstractMessageReader}});Object.defineProperty(re,"ReadableStreamMessageReader",{enumerable:!0,get:function(){return Ub.ReadableStreamMessageReader}});var $b=jF();Object.defineProperty(re,"MessageWriter",{enumerable:!0,get:function(){return $b.MessageWriter}});Object.defineProperty(re,"AbstractMessageWriter",{enumerable:!0,get:function(){return $b.AbstractMessageWriter}});Object.defineProperty(re,"WriteableStreamMessageWriter",{enumerable:!0,get:function(){return $b.WriteableStreamMessageWriter}});var uie=VF();Object.defineProperty(re,"AbstractMessageBuffer",{enumerable:!0,get:function(){return uie.AbstractMessageBuffer}});var Or=zF();Object.defineProperty(re,"ConnectionStrategy",{enumerable:!0,get:function(){return Or.ConnectionStrategy}});Object.defineProperty(re,"ConnectionOptions",{enumerable:!0,get:function(){return Or.ConnectionOptions}});Object.defineProperty(re,"NullLogger",{enumerable:!0,get:function(){return Or.NullLogger}});Object.defineProperty(re,"createMessageConnection",{enumerable:!0,get:function(){return Or.createMessageConnection}});Object.defineProperty(re,"ProgressToken",{enumerable:!0,get:function(){return Or.ProgressToken}});Object.defineProperty(re,"ProgressType",{enumerable:!0,get:function(){return Or.ProgressType}});Object.defineProperty(re,"Trace",{enumerable:!0,get:function(){return Or.Trace}});Object.defineProperty(re,"TraceValues",{enumerable:!0,get:function(){return Or.TraceValues}});Object.defineProperty(re,"TraceFormat",{enumerable:!0,get:function(){return Or.TraceFormat}});Object.defineProperty(re,"SetTraceNotification",{enumerable:!0,get:function(){return Or.SetTraceNotification}});Object.defineProperty(re,"LogTraceNotification",{enumerable:!0,get:function(){return Or.LogTraceNotification}});Object.defineProperty(re,"ConnectionErrors",{enumerable:!0,get:function(){return Or.ConnectionErrors}});Object.defineProperty(re,"ConnectionError",{enumerable:!0,get:function(){return Or.ConnectionError}});Object.defineProperty(re,"CancellationReceiverStrategy",{enumerable:!0,get:function(){return Or.CancellationReceiverStrategy}});Object.defineProperty(re,"CancellationSenderStrategy",{enumerable:!0,get:function(){return Or.CancellationSenderStrategy}});Object.defineProperty(re,"CancellationStrategy",{enumerable:!0,get:function(){return Or.CancellationStrategy}});Object.defineProperty(re,"MessageStrategy",{enumerable:!0,get:function(){return Or.MessageStrategy}});var cie=Ds();re.RAL=cie.default;});var eq=I(Wb=>{Object.defineProperty(Wb,"__esModule",{value:!0});var ZF=he("util"),Zi=Ph(),Nh=class e extends Zi.AbstractMessageBuffer{constructor(t="utf-8"){super(t);}emptyBuffer(){return e.emptyBuffer}fromString(t,r){return Buffer.from(t,r)}toString(t,r){return t instanceof Buffer?t.toString(r):new ZF.TextDecoder(r).decode(t)}asNative(t,r){return r===void 0?t instanceof Buffer?t:Buffer.from(t):t instanceof Buffer?t.slice(0,r):Buffer.from(t,0,r)}allocNative(t){return Buffer.allocUnsafe(t)}};Nh.emptyBuffer=Buffer.allocUnsafe(0);var jb=class{constructor(t){this.stream=t;}onClose(t){return this.stream.on("close",t),Zi.Disposable.create(()=>this.stream.off("close",t))}onError(t){return this.stream.on("error",t),Zi.Disposable.create(()=>this.stream.off("error",t))}onEnd(t){return this.stream.on("end",t),Zi.Disposable.create(()=>this.stream.off("end",t))}onData(t){return this.stream.on("data",t),Zi.Disposable.create(()=>this.stream.off("data",t))}},Vb=class{constructor(t){this.stream=t;}onClose(t){return this.stream.on("close",t),Zi.Disposable.create(()=>this.stream.off("close",t))}onError(t){return this.stream.on("error",t),Zi.Disposable.create(()=>this.stream.off("error",t))}onEnd(t){return this.stream.on("end",t),Zi.Disposable.create(()=>this.stream.off("end",t))}write(t,r){return new Promise((n,i)=>{let s=a=>{a==null?n():i(a);};typeof t=="string"?this.stream.write(t,r,s):this.stream.write(t,s);})}end(){this.stream.end();}},JF=Object.freeze({messageBuffer:Object.freeze({create:e=>new Nh(e)}),applicationJson:Object.freeze({encoder:Object.freeze({name:"application/json",encode:(e,t)=>{try{return Promise.resolve(Buffer.from(JSON.stringify(e,void 0,0),t.charset))}catch(r){return Promise.reject(r)}}}),decoder:Object.freeze({name:"application/json",decode:(e,t)=>{try{return e instanceof Buffer?Promise.resolve(JSON.parse(e.toString(t.charset))):Promise.resolve(JSON.parse(new ZF.TextDecoder(t.charset).decode(e)))}catch(r){return Promise.reject(r)}}})}),stream:Object.freeze({asReadableStream:e=>new jb(e),asWritableStream:e=>new Vb(e)}),console,timer:Object.freeze({setTimeout(e,t,...r){let n=setTimeout(e,t,...r);return {dispose:()=>clearTimeout(n)}},setImmediate(e,...t){let r=setImmediate(e,...t);return {dispose:()=>clearImmediate(r)}},setInterval(e,t,...r){let n=setInterval(e,t,...r);return {dispose:()=>clearInterval(n)}}})});function Hb(){return JF}(function(e){function t(){Zi.RAL.install(JF);}e.install=t;})(Hb||(Hb={}));Wb.default=Hb;});var Na=I(ht=>{var lie=ht&&ht.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),fie=ht&&ht.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&lie(t,e,r);};Object.defineProperty(ht,"__esModule",{value:!0});ht.createMessageConnection=ht.createServerSocketTransport=ht.createClientSocketTransport=ht.createServerPipeTransport=ht.createClientPipeTransport=ht.generateRandomPipeName=ht.StreamMessageWriter=ht.StreamMessageReader=ht.SocketMessageWriter=ht.SocketMessageReader=ht.PortMessageWriter=ht.PortMessageReader=ht.IPCMessageWriter=ht.IPCMessageReader=void 0;var Ho=eq();Ho.default.install();var tq=he("path"),die=he("os"),hie=he("crypto"),kh=he("net"),An=Ph();fie(Ph(),ht);var Kb=class extends An.AbstractMessageReader{constructor(t){super(),this.process=t;let r=this.process;r.on("error",n=>this.fireError(n)),r.on("close",()=>this.fireClose());}listen(t){return this.process.on("message",t),An.Disposable.create(()=>this.process.off("message",t))}};ht.IPCMessageReader=Kb;var Gb=class extends An.AbstractMessageWriter{constructor(t){super(),this.process=t,this.errorCount=0;let r=this.process;r.on("error",n=>this.fireError(n)),r.on("close",()=>this.fireClose);}write(t){try{return typeof this.process.send=="function"&&this.process.send(t,void 0,void 0,r=>{r?(this.errorCount++,this.handleError(r,t)):this.errorCount=0;}),Promise.resolve()}catch(r){return this.handleError(r,t),Promise.reject(r)}}handleError(t,r){this.errorCount++,this.fireError(t,r,this.errorCount);}end(){}};ht.IPCMessageWriter=Gb;var zb=class extends An.AbstractMessageReader{constructor(t){super(),this.onData=new An.Emitter,t.on("close",()=>this.fireClose),t.on("error",r=>this.fireError(r)),t.on("message",r=>{this.onData.fire(r);});}listen(t){return this.onData.event(t)}};ht.PortMessageReader=zb;var Yb=class extends An.AbstractMessageWriter{constructor(t){super(),this.port=t,this.errorCount=0,t.on("close",()=>this.fireClose()),t.on("error",r=>this.fireError(r));}write(t){try{return this.port.postMessage(t),Promise.resolve()}catch(r){return this.handleError(r,t),Promise.reject(r)}}handleError(t,r){this.errorCount++,this.fireError(t,r,this.errorCount);}end(){}};ht.PortMessageWriter=Yb;var Ia=class extends An.ReadableStreamMessageReader{constructor(t,r="utf-8"){super((0, Ho.default)().stream.asReadableStream(t),r);}};ht.SocketMessageReader=Ia;var Pa=class extends An.WriteableStreamMessageWriter{constructor(t,r){super((0, Ho.default)().stream.asWritableStream(t),r),this.socket=t;}dispose(){super.dispose(),this.socket.destroy();}};ht.SocketMessageWriter=Pa;var Dh=class extends An.ReadableStreamMessageReader{constructor(t,r){super((0, Ho.default)().stream.asReadableStream(t),r);}};ht.StreamMessageReader=Dh;var Oh=class extends An.WriteableStreamMessageWriter{constructor(t,r){super((0, Ho.default)().stream.asWritableStream(t),r);}};ht.StreamMessageWriter=Oh;var rq=process.env.XDG_RUNTIME_DIR,pie=new Map([["linux",107],["darwin",103]]);function gie(){let e=(0, hie.randomBytes)(21).toString("hex");if(process.platform==="win32")return `\\\\.\\pipe\\vscode-jsonrpc-${e}-sock`;let t;rq?t=tq.join(rq,`vscode-ipc-${e}.sock`):t=tq.join(die.tmpdir(),`vscode-${e}.sock`);let r=pie.get(process.platform);return r!==void 0&&t.length>r&&(0, Ho.default)().console.warn(`WARNING: IPC handle "${t}" is longer than ${r} characters.`),t}ht.generateRandomPipeName=gie;function mie(e,t="utf-8"){let r,n=new Promise((i,s)=>{r=i;});return new Promise((i,s)=>{let a=(0, kh.createServer)(o=>{a.close(),r([new Ia(o,t),new Pa(o,t)]);});a.on("error",s),a.listen(e,()=>{a.removeListener("error",s),i({onConnected:()=>n});});})}ht.createClientPipeTransport=mie;function yie(e,t="utf-8"){let r=(0, kh.createConnection)(e);return [new Ia(r,t),new Pa(r,t)]}ht.createServerPipeTransport=yie;function vie(e,t="utf-8"){let r,n=new Promise((i,s)=>{r=i;});return new Promise((i,s)=>{let a=(0, kh.createServer)(o=>{a.close(),r([new Ia(o,t),new Pa(o,t)]);});a.on("error",s),a.listen(e,"127.0.0.1",()=>{a.removeListener("error",s),i({onConnected:()=>n});});})}ht.createClientSocketTransport=vie;function _ie(e,t="utf-8"){let r=(0, kh.createConnection)(e,"127.0.0.1");return [new Ia(r,t),new Pa(r,t)]}ht.createServerSocketTransport=_ie;function bie(e){let t=e;return t.read!==void 0&&t.addListener!==void 0}function Sie(e){let t=e;return t.write!==void 0&&t.addListener!==void 0}function Eie(e,t,r,n){r||(r=An.NullLogger);let i=bie(e)?new Dh(e):e,s=Sie(t)?new Oh(t):t;return An.ConnectionStrategy.is(n)&&(n={connectionStrategy:n}),(0, An.createMessageConnection)(i,s,r,n)}ht.createMessageConnection=Eie;});var Qb=I((cge,nq)=>{nq.exports=Na();});var Bh=I((iq,Lh)=>{(function(e){if(typeof Lh=="object"&&typeof Lh.exports=="object"){var t=e(he,iq);t!==void 0&&(Lh.exports=t);}else typeof define=="function"&&define.amd&&define(["require","exports"],e);})(function(e,t){Object.defineProperty(t,"__esModule",{value:!0}),t.TextDocument=t.EOL=t.WorkspaceFolder=t.InlineCompletionContext=t.SelectedCompletionInfo=t.InlineCompletionTriggerKind=t.InlineCompletionList=t.InlineCompletionItem=t.StringValue=t.InlayHint=t.InlayHintLabelPart=t.InlayHintKind=t.InlineValueContext=t.InlineValueEvaluatableExpression=t.InlineValueVariableLookup=t.InlineValueText=t.SemanticTokens=t.SemanticTokenModifiers=t.SemanticTokenTypes=t.SelectionRange=t.DocumentLink=t.FormattingOptions=t.CodeLens=t.CodeAction=t.CodeActionContext=t.CodeActionTriggerKind=t.CodeActionKind=t.DocumentSymbol=t.WorkspaceSymbol=t.SymbolInformation=t.SymbolTag=t.SymbolKind=t.DocumentHighlight=t.DocumentHighlightKind=t.SignatureInformation=t.ParameterInformation=t.Hover=t.MarkedString=t.CompletionList=t.CompletionItem=t.CompletionItemLabelDetails=t.InsertTextMode=t.InsertReplaceEdit=t.CompletionItemTag=t.InsertTextFormat=t.CompletionItemKind=t.MarkupContent=t.MarkupKind=t.TextDocumentItem=t.OptionalVersionedTextDocumentIdentifier=t.VersionedTextDocumentIdentifier=t.TextDocumentIdentifier=t.WorkspaceChange=t.WorkspaceEdit=t.DeleteFile=t.RenameFile=t.CreateFile=t.TextDocumentEdit=t.AnnotatedTextEdit=t.ChangeAnnotationIdentifier=t.ChangeAnnotation=t.TextEdit=t.Command=t.Diagnostic=t.CodeDescription=t.DiagnosticTag=t.DiagnosticSeverity=t.DiagnosticRelatedInformation=t.FoldingRange=t.FoldingRangeKind=t.ColorPresentation=t.ColorInformation=t.Color=t.LocationLink=t.Location=t.Range=t.Position=t.uinteger=t.integer=t.URI=t.DocumentUri=void 0;var r;(function(A){function M($){return typeof $=="string"}A.is=M;})(r||(t.DocumentUri=r={}));var n;(function(A){function M($){return typeof $=="string"}A.is=M;})(n||(t.URI=n={}));var i;(function(A){A.MIN_VALUE=-2147483648,A.MAX_VALUE=2147483647;function M($){return typeof $=="number"&&A.MIN_VALUE<=$&&$<=A.MAX_VALUE}A.is=M;})(i||(t.integer=i={}));var s;(function(A){A.MIN_VALUE=0,A.MAX_VALUE=2147483647;function M($){return typeof $=="number"&&A.MIN_VALUE<=$&&$<=A.MAX_VALUE}A.is=M;})(s||(t.uinteger=s={}));var a;(function(A){function M(D,S){return D===Number.MAX_VALUE&&(D=s.MAX_VALUE),S===Number.MAX_VALUE&&(S=s.MAX_VALUE),{line:D,character:S}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&X.uinteger(S.line)&&X.uinteger(S.character)}A.is=$;})(a||(t.Position=a={}));var o;(function(A){function M(D,S,Y,oe){if(X.uinteger(D)&&X.uinteger(S)&&X.uinteger(Y)&&X.uinteger(oe))return {start:a.create(D,S),end:a.create(Y,oe)};if(a.is(D)&&a.is(S))return {start:D,end:S};throw new Error("Range#create called with invalid arguments[".concat(D,", ").concat(S,", ").concat(Y,", ").concat(oe,"]"))}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&a.is(S.start)&&a.is(S.end)}A.is=$;})(o||(t.Range=o={}));var c;(function(A){function M(D,S){return {uri:D,range:S}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&o.is(S.range)&&(X.string(S.uri)||X.undefined(S.uri))}A.is=$;})(c||(t.Location=c={}));var l;(function(A){function M(D,S,Y,oe){return {targetUri:D,targetRange:S,targetSelectionRange:Y,originSelectionRange:oe}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&o.is(S.targetRange)&&X.string(S.targetUri)&&o.is(S.targetSelectionRange)&&(o.is(S.originSelectionRange)||X.undefined(S.originSelectionRange))}A.is=$;})(l||(t.LocationLink=l={}));var u;(function(A){function M(D,S,Y,oe){return {red:D,green:S,blue:Y,alpha:oe}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&X.numberRange(S.red,0,1)&&X.numberRange(S.green,0,1)&&X.numberRange(S.blue,0,1)&&X.numberRange(S.alpha,0,1)}A.is=$;})(u||(t.Color=u={}));var f;(function(A){function M(D,S){return {range:D,color:S}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&o.is(S.range)&&u.is(S.color)}A.is=$;})(f||(t.ColorInformation=f={}));var h;(function(A){function M(D,S,Y){return {label:D,textEdit:S,additionalTextEdits:Y}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&X.string(S.label)&&(X.undefined(S.textEdit)||L.is(S))&&(X.undefined(S.additionalTextEdits)||X.typedArray(S.additionalTextEdits,L.is))}A.is=$;})(h||(t.ColorPresentation=h={}));var p;(function(A){A.Comment="comment",A.Imports="imports",A.Region="region";})(p||(t.FoldingRangeKind=p={}));var g;(function(A){function M(D,S,Y,oe,Qe,Yt){var kt={startLine:D,endLine:S};return X.defined(Y)&&(kt.startCharacter=Y),X.defined(oe)&&(kt.endCharacter=oe),X.defined(Qe)&&(kt.kind=Qe),X.defined(Yt)&&(kt.collapsedText=Yt),kt}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&X.uinteger(S.startLine)&&X.uinteger(S.startLine)&&(X.undefined(S.startCharacter)||X.uinteger(S.startCharacter))&&(X.undefined(S.endCharacter)||X.uinteger(S.endCharacter))&&(X.undefined(S.kind)||X.string(S.kind))}A.is=$;})(g||(t.FoldingRange=g={}));var _;(function(A){function M(D,S){return {location:D,message:S}}A.create=M;function $(D){var S=D;return X.defined(S)&&c.is(S.location)&&X.string(S.message)}A.is=$;})(_||(t.DiagnosticRelatedInformation=_={}));var E;(function(A){A.Error=1,A.Warning=2,A.Information=3,A.Hint=4;})(E||(t.DiagnosticSeverity=E={}));var w;(function(A){A.Unnecessary=1,A.Deprecated=2;})(w||(t.DiagnosticTag=w={}));var y;(function(A){function M($){var D=$;return X.objectLiteral(D)&&X.string(D.href)}A.is=M;})(y||(t.CodeDescription=y={}));var b;(function(A){function M(D,S,Y,oe,Qe,Yt){var kt={range:D,message:S};return X.defined(Y)&&(kt.severity=Y),X.defined(oe)&&(kt.code=oe),X.defined(Qe)&&(kt.source=Qe),X.defined(Yt)&&(kt.relatedInformation=Yt),kt}A.create=M;function $(D){var S,Y=D;return X.defined(Y)&&o.is(Y.range)&&X.string(Y.message)&&(X.number(Y.severity)||X.undefined(Y.severity))&&(X.integer(Y.code)||X.string(Y.code)||X.undefined(Y.code))&&(X.undefined(Y.codeDescription)||X.string((S=Y.codeDescription)===null||S===void 0?void 0:S.href))&&(X.string(Y.source)||X.undefined(Y.source))&&(X.undefined(Y.relatedInformation)||X.typedArray(Y.relatedInformation,_.is))}A.is=$;})(b||(t.Diagnostic=b={}));var N;(function(A){function M(D,S){for(var Y=[],oe=2;oe<arguments.length;oe++)Y[oe-2]=arguments[oe];var Qe={title:D,command:S};return X.defined(Y)&&Y.length>0&&(Qe.arguments=Y),Qe}A.create=M;function $(D){var S=D;return X.defined(S)&&X.string(S.title)&&X.string(S.command)}A.is=$;})(N||(t.Command=N={}));var L;(function(A){function M(Y,oe){return {range:Y,newText:oe}}A.replace=M;function $(Y,oe){return {range:{start:Y,end:Y},newText:oe}}A.insert=$;function D(Y){return {range:Y,newText:""}}A.del=D;function S(Y){var oe=Y;return X.objectLiteral(oe)&&X.string(oe.newText)&&o.is(oe.range)}A.is=S;})(L||(t.TextEdit=L={}));var V;(function(A){function M(D,S,Y){var oe={label:D};return S!==void 0&&(oe.needsConfirmation=S),Y!==void 0&&(oe.description=Y),oe}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&X.string(S.label)&&(X.boolean(S.needsConfirmation)||S.needsConfirmation===void 0)&&(X.string(S.description)||S.description===void 0)}A.is=$;})(V||(t.ChangeAnnotation=V={}));var Z;(function(A){function M($){var D=$;return X.string(D)}A.is=M;})(Z||(t.ChangeAnnotationIdentifier=Z={}));var G;(function(A){function M(Y,oe,Qe){return {range:Y,newText:oe,annotationId:Qe}}A.replace=M;function $(Y,oe,Qe){return {range:{start:Y,end:Y},newText:oe,annotationId:Qe}}A.insert=$;function D(Y,oe){return {range:Y,newText:"",annotationId:oe}}A.del=D;function S(Y){var oe=Y;return L.is(oe)&&(V.is(oe.annotationId)||Z.is(oe.annotationId))}A.is=S;})(G||(t.AnnotatedTextEdit=G={}));var z;(function(A){function M(D,S){return {textDocument:D,edits:S}}A.create=M;function $(D){var S=D;return X.defined(S)&&Me.is(S.textDocument)&&Array.isArray(S.edits)}A.is=$;})(z||(t.TextDocumentEdit=z={}));var ee;(function(A){function M(D,S,Y){var oe={kind:"create",uri:D};return S!==void 0&&(S.overwrite!==void 0||S.ignoreIfExists!==void 0)&&(oe.options=S),Y!==void 0&&(oe.annotationId=Y),oe}A.create=M;function $(D){var S=D;return S&&S.kind==="create"&&X.string(S.uri)&&(S.options===void 0||(S.options.overwrite===void 0||X.boolean(S.options.overwrite))&&(S.options.ignoreIfExists===void 0||X.boolean(S.options.ignoreIfExists)))&&(S.annotationId===void 0||Z.is(S.annotationId))}A.is=$;})(ee||(t.CreateFile=ee={}));var U;(function(A){function M(D,S,Y,oe){var Qe={kind:"rename",oldUri:D,newUri:S};return Y!==void 0&&(Y.overwrite!==void 0||Y.ignoreIfExists!==void 0)&&(Qe.options=Y),oe!==void 0&&(Qe.annotationId=oe),Qe}A.create=M;function $(D){var S=D;return S&&S.kind==="rename"&&X.string(S.oldUri)&&X.string(S.newUri)&&(S.options===void 0||(S.options.overwrite===void 0||X.boolean(S.options.overwrite))&&(S.options.ignoreIfExists===void 0||X.boolean(S.options.ignoreIfExists)))&&(S.annotationId===void 0||Z.is(S.annotationId))}A.is=$;})(U||(t.RenameFile=U={}));var ie;(function(A){function M(D,S,Y){var oe={kind:"delete",uri:D};return S!==void 0&&(S.recursive!==void 0||S.ignoreIfNotExists!==void 0)&&(oe.options=S),Y!==void 0&&(oe.annotationId=Y),oe}A.create=M;function $(D){var S=D;return S&&S.kind==="delete"&&X.string(S.uri)&&(S.options===void 0||(S.options.recursive===void 0||X.boolean(S.options.recursive))&&(S.options.ignoreIfNotExists===void 0||X.boolean(S.options.ignoreIfNotExists)))&&(S.annotationId===void 0||Z.is(S.annotationId))}A.is=$;})(ie||(t.DeleteFile=ie={}));var me;(function(A){function M($){var D=$;return D&&(D.changes!==void 0||D.documentChanges!==void 0)&&(D.documentChanges===void 0||D.documentChanges.every(function(S){return X.string(S.kind)?ee.is(S)||U.is(S)||ie.is(S):z.is(S)}))}A.is=M;})(me||(t.WorkspaceEdit=me={}));var Pe=function(){function A(M,$){this.edits=M,this.changeAnnotations=$;}return A.prototype.insert=function(M,$,D){var S,Y;if(D===void 0?S=L.insert(M,$):Z.is(D)?(Y=D,S=G.insert(M,$,D)):(this.assertChangeAnnotations(this.changeAnnotations),Y=this.changeAnnotations.manage(D),S=G.insert(M,$,Y)),this.edits.push(S),Y!==void 0)return Y},A.prototype.replace=function(M,$,D){var S,Y;if(D===void 0?S=L.replace(M,$):Z.is(D)?(Y=D,S=G.replace(M,$,D)):(this.assertChangeAnnotations(this.changeAnnotations),Y=this.changeAnnotations.manage(D),S=G.replace(M,$,Y)),this.edits.push(S),Y!==void 0)return Y},A.prototype.delete=function(M,$){var D,S;if($===void 0?D=L.del(M):Z.is($)?(S=$,D=G.del(M,$)):(this.assertChangeAnnotations(this.changeAnnotations),S=this.changeAnnotations.manage($),D=G.del(M,S)),this.edits.push(D),S!==void 0)return S},A.prototype.add=function(M){this.edits.push(M);},A.prototype.all=function(){return this.edits},A.prototype.clear=function(){this.edits.splice(0,this.edits.length);},A.prototype.assertChangeAnnotations=function(M){if(M===void 0)throw new Error("Text edit change is not configured to manage change annotations.")},A}(),W=function(){function A(M){this._annotations=M===void 0?Object.create(null):M,this._counter=0,this._size=0;}return A.prototype.all=function(){return this._annotations},Object.defineProperty(A.prototype,"size",{get:function(){return this._size},enumerable:!1,configurable:!0}),A.prototype.manage=function(M,$){var D;if(Z.is(M)?D=M:(D=this.nextId(),$=M),this._annotations[D]!==void 0)throw new Error("Id ".concat(D," is already in use."));if($===void 0)throw new Error("No annotation provided for id ".concat(D));return this._annotations[D]=$,this._size++,D},A.prototype.nextId=function(){return this._counter++,this._counter.toString()},A}(),K=function(){function A(M){var $=this;this._textEditChanges=Object.create(null),M!==void 0?(this._workspaceEdit=M,M.documentChanges?(this._changeAnnotations=new W(M.changeAnnotations),M.changeAnnotations=this._changeAnnotations.all(),M.documentChanges.forEach(function(D){if(z.is(D)){var S=new Pe(D.edits,$._changeAnnotations);$._textEditChanges[D.textDocument.uri]=S;}})):M.changes&&Object.keys(M.changes).forEach(function(D){var S=new Pe(M.changes[D]);$._textEditChanges[D]=S;})):this._workspaceEdit={};}return Object.defineProperty(A.prototype,"edit",{get:function(){return this.initDocumentChanges(),this._changeAnnotations!==void 0&&(this._changeAnnotations.size===0?this._workspaceEdit.changeAnnotations=void 0:this._workspaceEdit.changeAnnotations=this._changeAnnotations.all()),this._workspaceEdit},enumerable:!1,configurable:!0}),A.prototype.getTextEditChange=function(M){if(Me.is(M)){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var $={uri:M.uri,version:M.version},D=this._textEditChanges[$.uri];if(!D){var S=[],Y={textDocument:$,edits:S};this._workspaceEdit.documentChanges.push(Y),D=new Pe(S,this._changeAnnotations),this._textEditChanges[$.uri]=D;}return D}else {if(this.initChanges(),this._workspaceEdit.changes===void 0)throw new Error("Workspace edit is not configured for normal text edit changes.");var D=this._textEditChanges[M];if(!D){var S=[];this._workspaceEdit.changes[M]=S,D=new Pe(S),this._textEditChanges[M]=D;}return D}},A.prototype.initDocumentChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._changeAnnotations=new W,this._workspaceEdit.documentChanges=[],this._workspaceEdit.changeAnnotations=this._changeAnnotations.all());},A.prototype.initChanges=function(){this._workspaceEdit.documentChanges===void 0&&this._workspaceEdit.changes===void 0&&(this._workspaceEdit.changes=Object.create(null));},A.prototype.createFile=function(M,$,D){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var S;V.is($)||Z.is($)?S=$:D=$;var Y,oe;if(S===void 0?Y=ee.create(M,D):(oe=Z.is(S)?S:this._changeAnnotations.manage(S),Y=ee.create(M,D,oe)),this._workspaceEdit.documentChanges.push(Y),oe!==void 0)return oe},A.prototype.renameFile=function(M,$,D,S){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var Y;V.is(D)||Z.is(D)?Y=D:S=D;var oe,Qe;if(Y===void 0?oe=U.create(M,$,S):(Qe=Z.is(Y)?Y:this._changeAnnotations.manage(Y),oe=U.create(M,$,S,Qe)),this._workspaceEdit.documentChanges.push(oe),Qe!==void 0)return Qe},A.prototype.deleteFile=function(M,$,D){if(this.initDocumentChanges(),this._workspaceEdit.documentChanges===void 0)throw new Error("Workspace edit is not configured for document changes.");var S;V.is($)||Z.is($)?S=$:D=$;var Y,oe;if(S===void 0?Y=ie.create(M,D):(oe=Z.is(S)?S:this._changeAnnotations.manage(S),Y=ie.create(M,D,oe)),this._workspaceEdit.documentChanges.push(Y),oe!==void 0)return oe},A}();t.WorkspaceChange=K;var se;(function(A){function M(D){return {uri:D}}A.create=M;function $(D){var S=D;return X.defined(S)&&X.string(S.uri)}A.is=$;})(se||(t.TextDocumentIdentifier=se={}));var Ae;(function(A){function M(D,S){return {uri:D,version:S}}A.create=M;function $(D){var S=D;return X.defined(S)&&X.string(S.uri)&&X.integer(S.version)}A.is=$;})(Ae||(t.VersionedTextDocumentIdentifier=Ae={}));var Me;(function(A){function M(D,S){return {uri:D,version:S}}A.create=M;function $(D){var S=D;return X.defined(S)&&X.string(S.uri)&&(S.version===null||X.integer(S.version))}A.is=$;})(Me||(t.OptionalVersionedTextDocumentIdentifier=Me={}));var ze;(function(A){function M(D,S,Y,oe){return {uri:D,languageId:S,version:Y,text:oe}}A.create=M;function $(D){var S=D;return X.defined(S)&&X.string(S.uri)&&X.string(S.languageId)&&X.integer(S.version)&&X.string(S.text)}A.is=$;})(ze||(t.TextDocumentItem=ze={}));var We;(function(A){A.PlainText="plaintext",A.Markdown="markdown";function M($){var D=$;return D===A.PlainText||D===A.Markdown}A.is=M;})(We||(t.MarkupKind=We={}));var lt;(function(A){function M($){var D=$;return X.objectLiteral($)&&We.is(D.kind)&&X.string(D.value)}A.is=M;})(lt||(t.MarkupContent=lt={}));var Bt;(function(A){A.Text=1,A.Method=2,A.Function=3,A.Constructor=4,A.Field=5,A.Variable=6,A.Class=7,A.Interface=8,A.Module=9,A.Property=10,A.Unit=11,A.Value=12,A.Enum=13,A.Keyword=14,A.Snippet=15,A.Color=16,A.File=17,A.Reference=18,A.Folder=19,A.EnumMember=20,A.Constant=21,A.Struct=22,A.Event=23,A.Operator=24,A.TypeParameter=25;})(Bt||(t.CompletionItemKind=Bt={}));var Ct;(function(A){A.PlainText=1,A.Snippet=2;})(Ct||(t.InsertTextFormat=Ct={}));var pt;(function(A){A.Deprecated=1;})(pt||(t.CompletionItemTag=pt={}));var Be;(function(A){function M(D,S,Y){return {newText:D,insert:S,replace:Y}}A.create=M;function $(D){var S=D;return S&&X.string(S.newText)&&o.is(S.insert)&&o.is(S.replace)}A.is=$;})(Be||(t.InsertReplaceEdit=Be={}));var Dt;(function(A){A.asIs=1,A.adjustIndentation=2;})(Dt||(t.InsertTextMode=Dt={}));var Vt;(function(A){function M($){var D=$;return D&&(X.string(D.detail)||D.detail===void 0)&&(X.string(D.description)||D.description===void 0)}A.is=M;})(Vt||(t.CompletionItemLabelDetails=Vt={}));var ye;(function(A){function M($){return {label:$}}A.create=M;})(ye||(t.CompletionItem=ye={}));var Ve;(function(A){function M($,D){return {items:$||[],isIncomplete:!!D}}A.create=M;})(Ve||(t.CompletionList=Ve={}));var le;(function(A){function M(D){return D.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}A.fromPlainText=M;function $(D){var S=D;return X.string(S)||X.objectLiteral(S)&&X.string(S.language)&&X.string(S.value)}A.is=$;})(le||(t.MarkedString=le={}));var Ie;(function(A){function M($){var D=$;return !!D&&X.objectLiteral(D)&&(lt.is(D.contents)||le.is(D.contents)||X.typedArray(D.contents,le.is))&&($.range===void 0||o.is($.range))}A.is=M;})(Ie||(t.Hover=Ie={}));var Ke;(function(A){function M($,D){return D?{label:$,documentation:D}:{label:$}}A.create=M;})(Ke||(t.ParameterInformation=Ke={}));var nt;(function(A){function M($,D){for(var S=[],Y=2;Y<arguments.length;Y++)S[Y-2]=arguments[Y];var oe={label:$};return X.defined(D)&&(oe.documentation=D),X.defined(S)?oe.parameters=S:oe.parameters=[],oe}A.create=M;})(nt||(t.SignatureInformation=nt={}));var Ye;(function(A){A.Text=1,A.Read=2,A.Write=3;})(Ye||(t.DocumentHighlightKind=Ye={}));var Rn;(function(A){function M($,D){var S={range:$};return X.number(D)&&(S.kind=D),S}A.create=M;})(Rn||(t.DocumentHighlight=Rn={}));var $r;(function(A){A.File=1,A.Module=2,A.Namespace=3,A.Package=4,A.Class=5,A.Method=6,A.Property=7,A.Field=8,A.Constructor=9,A.Enum=10,A.Interface=11,A.Function=12,A.Variable=13,A.Constant=14,A.String=15,A.Number=16,A.Boolean=17,A.Array=18,A.Object=19,A.Key=20,A.Null=21,A.EnumMember=22,A.Struct=23,A.Event=24,A.Operator=25,A.TypeParameter=26;})($r||(t.SymbolKind=$r={}));var Vs;(function(A){A.Deprecated=1;})(Vs||(t.SymbolTag=Vs={}));var jr;(function(A){function M($,D,S,Y,oe){var Qe={name:$,kind:D,location:{uri:Y,range:S}};return oe&&(Qe.containerName=oe),Qe}A.create=M;})(jr||(t.SymbolInformation=jr={}));var tn;(function(A){function M($,D,S,Y){return Y!==void 0?{name:$,kind:D,location:{uri:S,range:Y}}:{name:$,kind:D,location:{uri:S}}}A.create=M;})(tn||(t.WorkspaceSymbol=tn={}));var Hs;(function(A){function M(D,S,Y,oe,Qe,Yt){var kt={name:D,detail:S,kind:Y,range:oe,selectionRange:Qe};return Yt!==void 0&&(kt.children=Yt),kt}A.create=M;function $(D){var S=D;return S&&X.string(S.name)&&X.number(S.kind)&&o.is(S.range)&&o.is(S.selectionRange)&&(S.detail===void 0||X.string(S.detail))&&(S.deprecated===void 0||X.boolean(S.deprecated))&&(S.children===void 0||Array.isArray(S.children))&&(S.tags===void 0||Array.isArray(S.tags))}A.is=$;})(Hs||(t.DocumentSymbol=Hs={}));var Ba;(function(A){A.Empty="",A.QuickFix="quickfix",A.Refactor="refactor",A.RefactorExtract="refactor.extract",A.RefactorInline="refactor.inline",A.RefactorRewrite="refactor.rewrite",A.Source="source",A.SourceOrganizeImports="source.organizeImports",A.SourceFixAll="source.fixAll";})(Ba||(t.CodeActionKind=Ba={}));var mn;(function(A){A.Invoked=1,A.Automatic=2;})(mn||(t.CodeActionTriggerKind=mn={}));var Ws;(function(A){function M(D,S,Y){var oe={diagnostics:D};return S!=null&&(oe.only=S),Y!=null&&(oe.triggerKind=Y),oe}A.create=M;function $(D){var S=D;return X.defined(S)&&X.typedArray(S.diagnostics,b.is)&&(S.only===void 0||X.typedArray(S.only,X.string))&&(S.triggerKind===void 0||S.triggerKind===mn.Invoked||S.triggerKind===mn.Automatic)}A.is=$;})(Ws||(t.CodeActionContext=Ws={}));var Ks;(function(A){function M(D,S,Y){var oe={title:D},Qe=!0;return typeof S=="string"?(Qe=!1,oe.kind=S):N.is(S)?oe.command=S:oe.edit=S,Qe&&Y!==void 0&&(oe.kind=Y),oe}A.create=M;function $(D){var S=D;return S&&X.string(S.title)&&(S.diagnostics===void 0||X.typedArray(S.diagnostics,b.is))&&(S.kind===void 0||X.string(S.kind))&&(S.edit!==void 0||S.command!==void 0)&&(S.command===void 0||N.is(S.command))&&(S.isPreferred===void 0||X.boolean(S.isPreferred))&&(S.edit===void 0||me.is(S.edit))}A.is=$;})(Ks||(t.CodeAction=Ks={}));var ki;(function(A){function M(D,S){var Y={range:D};return X.defined(S)&&(Y.data=S),Y}A.create=M;function $(D){var S=D;return X.defined(S)&&o.is(S.range)&&(X.undefined(S.command)||N.is(S.command))}A.is=$;})(ki||(t.CodeLens=ki={}));var Gs;(function(A){function M(D,S){return {tabSize:D,insertSpaces:S}}A.create=M;function $(D){var S=D;return X.defined(S)&&X.uinteger(S.tabSize)&&X.boolean(S.insertSpaces)}A.is=$;})(Gs||(t.FormattingOptions=Gs={}));var Yn;(function(A){function M(D,S,Y){return {range:D,target:S,data:Y}}A.create=M;function $(D){var S=D;return X.defined(S)&&o.is(S.range)&&(X.undefined(S.target)||X.string(S.target))}A.is=$;})(Yn||(t.DocumentLink=Yn={}));var q;(function(A){function M(D,S){return {range:D,parent:S}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&o.is(S.range)&&(S.parent===void 0||A.is(S.parent))}A.is=$;})(q||(t.SelectionRange=q={}));var ae;(function(A){A.namespace="namespace",A.type="type",A.class="class",A.enum="enum",A.interface="interface",A.struct="struct",A.typeParameter="typeParameter",A.parameter="parameter",A.variable="variable",A.property="property",A.enumMember="enumMember",A.event="event",A.function="function",A.method="method",A.macro="macro",A.keyword="keyword",A.modifier="modifier",A.comment="comment",A.string="string",A.number="number",A.regexp="regexp",A.operator="operator",A.decorator="decorator";})(ae||(t.SemanticTokenTypes=ae={}));var Se;(function(A){A.declaration="declaration",A.definition="definition",A.readonly="readonly",A.static="static",A.deprecated="deprecated",A.abstract="abstract",A.async="async",A.modification="modification",A.documentation="documentation",A.defaultLibrary="defaultLibrary";})(Se||(t.SemanticTokenModifiers=Se={}));var Ne;(function(A){function M($){var D=$;return X.objectLiteral(D)&&(D.resultId===void 0||typeof D.resultId=="string")&&Array.isArray(D.data)&&(D.data.length===0||typeof D.data[0]=="number")}A.is=M;})(Ne||(t.SemanticTokens=Ne={}));var xt;(function(A){function M(D,S){return {range:D,text:S}}A.create=M;function $(D){var S=D;return S!=null&&o.is(S.range)&&X.string(S.text)}A.is=$;})(xt||(t.InlineValueText=xt={}));var vt;(function(A){function M(D,S,Y){return {range:D,variableName:S,caseSensitiveLookup:Y}}A.create=M;function $(D){var S=D;return S!=null&&o.is(S.range)&&X.boolean(S.caseSensitiveLookup)&&(X.string(S.variableName)||S.variableName===void 0)}A.is=$;})(vt||(t.InlineValueVariableLookup=vt={}));var Ot;(function(A){function M(D,S){return {range:D,expression:S}}A.create=M;function $(D){var S=D;return S!=null&&o.is(S.range)&&(X.string(S.expression)||S.expression===void 0)}A.is=$;})(Ot||(t.InlineValueEvaluatableExpression=Ot={}));var qt;(function(A){function M(D,S){return {frameId:D,stoppedLocation:S}}A.create=M;function $(D){var S=D;return X.defined(S)&&o.is(D.stoppedLocation)}A.is=$;})(qt||(t.InlineValueContext=qt={}));var it;(function(A){A.Type=1,A.Parameter=2;function M($){return $===1||$===2}A.is=M;})(it||(t.InlayHintKind=it={}));var It;(function(A){function M(D){return {value:D}}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&(S.tooltip===void 0||X.string(S.tooltip)||lt.is(S.tooltip))&&(S.location===void 0||c.is(S.location))&&(S.command===void 0||N.is(S.command))}A.is=$;})(It||(t.InlayHintLabelPart=It={}));var gt;(function(A){function M(D,S,Y){var oe={position:D,label:S};return Y!==void 0&&(oe.kind=Y),oe}A.create=M;function $(D){var S=D;return X.objectLiteral(S)&&a.is(S.position)&&(X.string(S.label)||X.typedArray(S.label,It.is))&&(S.kind===void 0||it.is(S.kind))&&S.textEdits===void 0||X.typedArray(S.textEdits,L.is)&&(S.tooltip===void 0||X.string(S.tooltip)||lt.is(S.tooltip))&&(S.paddingLeft===void 0||X.boolean(S.paddingLeft))&&(S.paddingRight===void 0||X.boolean(S.paddingRight))}A.is=$;})(gt||(t.InlayHint=gt={}));var zt;(function(A){function M($){return {kind:"snippet",value:$}}A.createSnippet=M;})(zt||(t.StringValue=zt={}));var nr;(function(A){function M($,D,S,Y){return {insertText:$,filterText:D,range:S,command:Y}}A.create=M;})(nr||(t.InlineCompletionItem=nr={}));var Vr;(function(A){function M($){return {items:$}}A.create=M;})(Vr||(t.InlineCompletionList=Vr={}));var Fa;(function(A){A.Invoked=0,A.Automatic=1;})(Fa||(t.InlineCompletionTriggerKind=Fa={}));var es;(function(A){function M($,D){return {range:$,text:D}}A.create=M;})(es||(t.SelectedCompletionInfo=es={}));var ts;(function(A){function M($,D){return {triggerKind:$,selectedCompletionInfo:D}}A.create=M;})(ts||(t.InlineCompletionContext=ts={}));var su;((function(A){function M($){var D=$;return X.objectLiteral(D)&&n.is(D.uri)&&X.string(D.name)}A.is=M;}))(su||(t.WorkspaceFolder=su={})),t.EOL=[`
`,`\r
`,"\r"];var au;(function(A){function M(Y,oe,Qe,Yt){return new tl(Y,oe,Qe,Yt)}A.create=M;function $(Y){var oe=Y;return !!(X.defined(oe)&&X.string(oe.uri)&&(X.undefined(oe.languageId)||X.string(oe.languageId))&&X.uinteger(oe.lineCount)&&X.func(oe.getText)&&X.func(oe.positionAt)&&X.func(oe.offsetAt))}A.is=$;function D(Y,oe){for(var Qe=Y.getText(),Yt=S(oe,function(rs,qa){var rl=rs.range.start.line-qa.range.start.line;return rl===0?rs.range.start.character-qa.range.start.character:rl}),kt=Qe.length,yn=Yt.length-1;yn>=0;yn--){var vn=Yt[yn],Qn=Y.offsetAt(vn.range.start),at=Y.offsetAt(vn.range.end);if(at<=kt)Qe=Qe.substring(0,Qn)+vn.newText+Qe.substring(at,Qe.length);else throw new Error("Overlapping edit");kt=Qn;}return Qe}A.applyEdits=D;function S(Y,oe){if(Y.length<=1)return Y;var Qe=Y.length/2|0,Yt=Y.slice(0,Qe),kt=Y.slice(Qe);S(Yt,oe),S(kt,oe);for(var yn=0,vn=0,Qn=0;yn<Yt.length&&vn<kt.length;){var at=oe(Yt[yn],kt[vn]);at<=0?Y[Qn++]=Yt[yn++]:Y[Qn++]=kt[vn++];}for(;yn<Yt.length;)Y[Qn++]=Yt[yn++];for(;vn<kt.length;)Y[Qn++]=kt[vn++];return Y}})(au||(t.TextDocument=au={}));var tl=function(){function A(M,$,D,S){this._uri=M,this._languageId=$,this._version=D,this._content=S,this._lineOffsets=void 0;}return Object.defineProperty(A.prototype,"uri",{get:function(){return this._uri},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"languageId",{get:function(){return this._languageId},enumerable:!1,configurable:!0}),Object.defineProperty(A.prototype,"version",{get:function(){return this._version},enumerable:!1,configurable:!0}),A.prototype.getText=function(M){if(M){var $=this.offsetAt(M.start),D=this.offsetAt(M.end);return this._content.substring($,D)}return this._content},A.prototype.update=function(M,$){this._content=M.text,this._version=$,this._lineOffsets=void 0;},A.prototype.getLineOffsets=function(){if(this._lineOffsets===void 0){for(var M=[],$=this._content,D=!0,S=0;S<$.length;S++){D&&(M.push(S),D=!1);var Y=$.charAt(S);D=Y==="\r"||Y===`
`,Y==="\r"&&S+1<$.length&&$.charAt(S+1)===`
`&&S++;}D&&$.length>0&&M.push($.length),this._lineOffsets=M;}return this._lineOffsets},A.prototype.positionAt=function(M){M=Math.max(Math.min(M,this._content.length),0);var $=this.getLineOffsets(),D=0,S=$.length;if(S===0)return a.create(0,M);for(;D<S;){var Y=Math.floor((D+S)/2);$[Y]>M?S=Y:D=Y+1;}var oe=D-1;return a.create(oe,M-$[oe])},A.prototype.offsetAt=function(M){var $=this.getLineOffsets();if(M.line>=$.length)return this._content.length;if(M.line<0)return 0;var D=$[M.line],S=M.line+1<$.length?$[M.line+1]:this._content.length;return Math.max(Math.min(D+M.character,S),D)},Object.defineProperty(A.prototype,"lineCount",{get:function(){return this.getLineOffsets().length},enumerable:!1,configurable:!0}),A}(),X;(function(A){var M=Object.prototype.toString;function $(at){return typeof at<"u"}A.defined=$;function D(at){return typeof at>"u"}A.undefined=D;function S(at){return at===!0||at===!1}A.boolean=S;function Y(at){return M.call(at)==="[object String]"}A.string=Y;function oe(at){return M.call(at)==="[object Number]"}A.number=oe;function Qe(at,rs,qa){return M.call(at)==="[object Number]"&&rs<=at&&at<=qa}A.numberRange=Qe;function Yt(at){return M.call(at)==="[object Number]"&&-2147483648<=at&&at<=2147483647}A.integer=Yt;function kt(at){return M.call(at)==="[object Number]"&&0<=at&&at<=2147483647}A.uinteger=kt;function yn(at){return M.call(at)==="[object Function]"}A.func=yn;function vn(at){return at!==null&&typeof at=="object"}A.objectLiteral=vn;function Qn(at,rs){return Array.isArray(at)&&at.every(rs)}A.typedArray=Qn;})(X||(X={}));});});var Xt=I(dn=>{Object.defineProperty(dn,"__esModule",{value:!0});dn.ProtocolNotificationType=dn.ProtocolNotificationType0=dn.ProtocolRequestType=dn.ProtocolRequestType0=dn.RegistrationType=dn.MessageDirection=void 0;var Wo=Na(),sq;(function(e){e.clientToServer="clientToServer",e.serverToClient="serverToClient",e.both="both";})(sq||(dn.MessageDirection=sq={}));var Xb=class{constructor(t){this.method=t;}};dn.RegistrationType=Xb;var Zb=class extends Wo.RequestType0{constructor(t){super(t);}};dn.ProtocolRequestType0=Zb;var Jb=class extends Wo.RequestType{constructor(t){super(t,Wo.ParameterStructures.byName);}};dn.ProtocolRequestType=Jb;var eS=class extends Wo.NotificationType0{constructor(t){super(t);}};dn.ProtocolNotificationType0=eS;var tS=class extends Wo.NotificationType{constructor(t){super(t,Wo.ParameterStructures.byName);}};dn.ProtocolNotificationType=tS;});var Fh=I(fr=>{Object.defineProperty(fr,"__esModule",{value:!0});fr.objectLiteral=fr.typedArray=fr.stringArray=fr.array=fr.func=fr.error=fr.number=fr.string=fr.boolean=void 0;function wie(e){return e===!0||e===!1}fr.boolean=wie;function aq(e){return typeof e=="string"||e instanceof String}fr.string=aq;function Cie(e){return typeof e=="number"||e instanceof Number}fr.number=Cie;function xie(e){return e instanceof Error}fr.error=xie;function Tie(e){return typeof e=="function"}fr.func=Tie;function oq(e){return Array.isArray(e)}fr.array=oq;function Aie(e){return oq(e)&&e.every(t=>aq(t))}fr.stringArray=Aie;function Rie(e,t){return Array.isArray(e)&&e.every(t)}fr.typedArray=Rie;function Iie(e){return e!==null&&typeof e=="object"}fr.objectLiteral=Iie;});var lq=I(qh=>{Object.defineProperty(qh,"__esModule",{value:!0});qh.ImplementationRequest=void 0;var uq=Xt(),cq;(function(e){e.method="textDocument/implementation",e.messageDirection=uq.MessageDirection.clientToServer,e.type=new uq.ProtocolRequestType(e.method);})(cq||(qh.ImplementationRequest=cq={}));});var hq=I(Mh=>{Object.defineProperty(Mh,"__esModule",{value:!0});Mh.TypeDefinitionRequest=void 0;var fq=Xt(),dq;(function(e){e.method="textDocument/typeDefinition",e.messageDirection=fq.MessageDirection.clientToServer,e.type=new fq.ProtocolRequestType(e.method);})(dq||(Mh.TypeDefinitionRequest=dq={}));});var mq=I(Ko=>{Object.defineProperty(Ko,"__esModule",{value:!0});Ko.DidChangeWorkspaceFoldersNotification=Ko.WorkspaceFoldersRequest=void 0;var Uh=Xt(),pq;(function(e){e.method="workspace/workspaceFolders",e.messageDirection=Uh.MessageDirection.serverToClient,e.type=new Uh.ProtocolRequestType0(e.method);})(pq||(Ko.WorkspaceFoldersRequest=pq={}));var gq;(function(e){e.method="workspace/didChangeWorkspaceFolders",e.messageDirection=Uh.MessageDirection.clientToServer,e.type=new Uh.ProtocolNotificationType(e.method);})(gq||(Ko.DidChangeWorkspaceFoldersNotification=gq={}));});var _q=I($h=>{Object.defineProperty($h,"__esModule",{value:!0});$h.ConfigurationRequest=void 0;var yq=Xt(),vq;(function(e){e.method="workspace/configuration",e.messageDirection=yq.MessageDirection.serverToClient,e.type=new yq.ProtocolRequestType(e.method);})(vq||($h.ConfigurationRequest=vq={}));});var Eq=I(Go=>{Object.defineProperty(Go,"__esModule",{value:!0});Go.ColorPresentationRequest=Go.DocumentColorRequest=void 0;var jh=Xt(),bq;(function(e){e.method="textDocument/documentColor",e.messageDirection=jh.MessageDirection.clientToServer,e.type=new jh.ProtocolRequestType(e.method);})(bq||(Go.DocumentColorRequest=bq={}));var Sq;(function(e){e.method="textDocument/colorPresentation",e.messageDirection=jh.MessageDirection.clientToServer,e.type=new jh.ProtocolRequestType(e.method);})(Sq||(Go.ColorPresentationRequest=Sq={}));});var xq=I(zo=>{Object.defineProperty(zo,"__esModule",{value:!0});zo.FoldingRangeRefreshRequest=zo.FoldingRangeRequest=void 0;var Vh=Xt(),wq;(function(e){e.method="textDocument/foldingRange",e.messageDirection=Vh.MessageDirection.clientToServer,e.type=new Vh.ProtocolRequestType(e.method);})(wq||(zo.FoldingRangeRequest=wq={}));var Cq;(function(e){e.method="workspace/foldingRange/refresh",e.messageDirection=Vh.MessageDirection.serverToClient,e.type=new Vh.ProtocolRequestType0(e.method);})(Cq||(zo.FoldingRangeRefreshRequest=Cq={}));});var Rq=I(Hh=>{Object.defineProperty(Hh,"__esModule",{value:!0});Hh.DeclarationRequest=void 0;var Tq=Xt(),Aq;(function(e){e.method="textDocument/declaration",e.messageDirection=Tq.MessageDirection.clientToServer,e.type=new Tq.ProtocolRequestType(e.method);})(Aq||(Hh.DeclarationRequest=Aq={}));});var Nq=I(Wh=>{Object.defineProperty(Wh,"__esModule",{value:!0});Wh.SelectionRangeRequest=void 0;var Iq=Xt(),Pq;(function(e){e.method="textDocument/selectionRange",e.messageDirection=Iq.MessageDirection.clientToServer,e.type=new Iq.ProtocolRequestType(e.method);})(Pq||(Wh.SelectionRangeRequest=Pq={}));});var Lq=I(Ls=>{Object.defineProperty(Ls,"__esModule",{value:!0});Ls.WorkDoneProgressCancelNotification=Ls.WorkDoneProgressCreateRequest=Ls.WorkDoneProgress=void 0;var Pie=Na(),Kh=Xt(),Dq;(function(e){e.type=new Pie.ProgressType;function t(r){return r===e.type}e.is=t;})(Dq||(Ls.WorkDoneProgress=Dq={}));var Oq;(function(e){e.method="window/workDoneProgress/create",e.messageDirection=Kh.MessageDirection.serverToClient,e.type=new Kh.ProtocolRequestType(e.method);})(Oq||(Ls.WorkDoneProgressCreateRequest=Oq={}));var kq;(function(e){e.method="window/workDoneProgress/cancel",e.messageDirection=Kh.MessageDirection.clientToServer,e.type=new Kh.ProtocolNotificationType(e.method);})(kq||(Ls.WorkDoneProgressCancelNotification=kq={}));});var Mq=I(Bs=>{Object.defineProperty(Bs,"__esModule",{value:!0});Bs.CallHierarchyOutgoingCallsRequest=Bs.CallHierarchyIncomingCallsRequest=Bs.CallHierarchyPrepareRequest=void 0;var Yo=Xt(),Bq;(function(e){e.method="textDocument/prepareCallHierarchy",e.messageDirection=Yo.MessageDirection.clientToServer,e.type=new Yo.ProtocolRequestType(e.method);})(Bq||(Bs.CallHierarchyPrepareRequest=Bq={}));var Fq;(function(e){e.method="callHierarchy/incomingCalls",e.messageDirection=Yo.MessageDirection.clientToServer,e.type=new Yo.ProtocolRequestType(e.method);})(Fq||(Bs.CallHierarchyIncomingCallsRequest=Fq={}));var qq;(function(e){e.method="callHierarchy/outgoingCalls",e.messageDirection=Yo.MessageDirection.clientToServer,e.type=new Yo.ProtocolRequestType(e.method);})(qq||(Bs.CallHierarchyOutgoingCallsRequest=qq={}));});var Wq=I(hn=>{Object.defineProperty(hn,"__esModule",{value:!0});hn.SemanticTokensRefreshRequest=hn.SemanticTokensRangeRequest=hn.SemanticTokensDeltaRequest=hn.SemanticTokensRequest=hn.SemanticTokensRegistrationType=hn.TokenFormat=void 0;var Ji=Xt(),Uq;(function(e){e.Relative="relative";})(Uq||(hn.TokenFormat=Uq={}));var Kc;(function(e){e.method="textDocument/semanticTokens",e.type=new Ji.RegistrationType(e.method);})(Kc||(hn.SemanticTokensRegistrationType=Kc={}));var $q;(function(e){e.method="textDocument/semanticTokens/full",e.messageDirection=Ji.MessageDirection.clientToServer,e.type=new Ji.ProtocolRequestType(e.method),e.registrationMethod=Kc.method;})($q||(hn.SemanticTokensRequest=$q={}));var jq;(function(e){e.method="textDocument/semanticTokens/full/delta",e.messageDirection=Ji.MessageDirection.clientToServer,e.type=new Ji.ProtocolRequestType(e.method),e.registrationMethod=Kc.method;})(jq||(hn.SemanticTokensDeltaRequest=jq={}));var Vq;(function(e){e.method="textDocument/semanticTokens/range",e.messageDirection=Ji.MessageDirection.clientToServer,e.type=new Ji.ProtocolRequestType(e.method),e.registrationMethod=Kc.method;})(Vq||(hn.SemanticTokensRangeRequest=Vq={}));var Hq;(function(e){e.method="workspace/semanticTokens/refresh",e.messageDirection=Ji.MessageDirection.serverToClient,e.type=new Ji.ProtocolRequestType0(e.method);})(Hq||(hn.SemanticTokensRefreshRequest=Hq={}));});var zq=I(Gh=>{Object.defineProperty(Gh,"__esModule",{value:!0});Gh.ShowDocumentRequest=void 0;var Kq=Xt(),Gq;(function(e){e.method="window/showDocument",e.messageDirection=Kq.MessageDirection.serverToClient,e.type=new Kq.ProtocolRequestType(e.method);})(Gq||(Gh.ShowDocumentRequest=Gq={}));});var Xq=I(zh=>{Object.defineProperty(zh,"__esModule",{value:!0});zh.LinkedEditingRangeRequest=void 0;var Yq=Xt(),Qq;(function(e){e.method="textDocument/linkedEditingRange",e.messageDirection=Yq.MessageDirection.clientToServer,e.type=new Yq.ProtocolRequestType(e.method);})(Qq||(zh.LinkedEditingRangeRequest=Qq={}));});var sM=I(Mr=>{Object.defineProperty(Mr,"__esModule",{value:!0});Mr.WillDeleteFilesRequest=Mr.DidDeleteFilesNotification=Mr.DidRenameFilesNotification=Mr.WillRenameFilesRequest=Mr.DidCreateFilesNotification=Mr.WillCreateFilesRequest=Mr.FileOperationPatternKind=void 0;var Vn=Xt(),Zq;(function(e){e.file="file",e.folder="folder";})(Zq||(Mr.FileOperationPatternKind=Zq={}));var Jq;(function(e){e.method="workspace/willCreateFiles",e.messageDirection=Vn.MessageDirection.clientToServer,e.type=new Vn.ProtocolRequestType(e.method);})(Jq||(Mr.WillCreateFilesRequest=Jq={}));var eM;(function(e){e.method="workspace/didCreateFiles",e.messageDirection=Vn.MessageDirection.clientToServer,e.type=new Vn.ProtocolNotificationType(e.method);})(eM||(Mr.DidCreateFilesNotification=eM={}));var tM;(function(e){e.method="workspace/willRenameFiles",e.messageDirection=Vn.MessageDirection.clientToServer,e.type=new Vn.ProtocolRequestType(e.method);})(tM||(Mr.WillRenameFilesRequest=tM={}));var rM;(function(e){e.method="workspace/didRenameFiles",e.messageDirection=Vn.MessageDirection.clientToServer,e.type=new Vn.ProtocolNotificationType(e.method);})(rM||(Mr.DidRenameFilesNotification=rM={}));var nM;(function(e){e.method="workspace/didDeleteFiles",e.messageDirection=Vn.MessageDirection.clientToServer,e.type=new Vn.ProtocolNotificationType(e.method);})(nM||(Mr.DidDeleteFilesNotification=nM={}));var iM;(function(e){e.method="workspace/willDeleteFiles",e.messageDirection=Vn.MessageDirection.clientToServer,e.type=new Vn.ProtocolRequestType(e.method);})(iM||(Mr.WillDeleteFilesRequest=iM={}));});var lM=I(Fs=>{Object.defineProperty(Fs,"__esModule",{value:!0});Fs.MonikerRequest=Fs.MonikerKind=Fs.UniquenessLevel=void 0;var aM=Xt(),oM;(function(e){e.document="document",e.project="project",e.group="group",e.scheme="scheme",e.global="global";})(oM||(Fs.UniquenessLevel=oM={}));var uM;(function(e){e.$import="import",e.$export="export",e.local="local";})(uM||(Fs.MonikerKind=uM={}));var cM;(function(e){e.method="textDocument/moniker",e.messageDirection=aM.MessageDirection.clientToServer,e.type=new aM.ProtocolRequestType(e.method);})(cM||(Fs.MonikerRequest=cM={}));});var pM=I(qs=>{Object.defineProperty(qs,"__esModule",{value:!0});qs.TypeHierarchySubtypesRequest=qs.TypeHierarchySupertypesRequest=qs.TypeHierarchyPrepareRequest=void 0;var Qo=Xt(),fM;(function(e){e.method="textDocument/prepareTypeHierarchy",e.messageDirection=Qo.MessageDirection.clientToServer,e.type=new Qo.ProtocolRequestType(e.method);})(fM||(qs.TypeHierarchyPrepareRequest=fM={}));var dM;(function(e){e.method="typeHierarchy/supertypes",e.messageDirection=Qo.MessageDirection.clientToServer,e.type=new Qo.ProtocolRequestType(e.method);})(dM||(qs.TypeHierarchySupertypesRequest=dM={}));var hM;(function(e){e.method="typeHierarchy/subtypes",e.messageDirection=Qo.MessageDirection.clientToServer,e.type=new Qo.ProtocolRequestType(e.method);})(hM||(qs.TypeHierarchySubtypesRequest=hM={}));});var yM=I(Xo=>{Object.defineProperty(Xo,"__esModule",{value:!0});Xo.InlineValueRefreshRequest=Xo.InlineValueRequest=void 0;var Yh=Xt(),gM;(function(e){e.method="textDocument/inlineValue",e.messageDirection=Yh.MessageDirection.clientToServer,e.type=new Yh.ProtocolRequestType(e.method);})(gM||(Xo.InlineValueRequest=gM={}));var mM;(function(e){e.method="workspace/inlineValue/refresh",e.messageDirection=Yh.MessageDirection.serverToClient,e.type=new Yh.ProtocolRequestType0(e.method);})(mM||(Xo.InlineValueRefreshRequest=mM={}));});var SM=I(Ms=>{Object.defineProperty(Ms,"__esModule",{value:!0});Ms.InlayHintRefreshRequest=Ms.InlayHintResolveRequest=Ms.InlayHintRequest=void 0;var Zo=Xt(),vM;(function(e){e.method="textDocument/inlayHint",e.messageDirection=Zo.MessageDirection.clientToServer,e.type=new Zo.ProtocolRequestType(e.method);})(vM||(Ms.InlayHintRequest=vM={}));var _M;(function(e){e.method="inlayHint/resolve",e.messageDirection=Zo.MessageDirection.clientToServer,e.type=new Zo.ProtocolRequestType(e.method);})(_M||(Ms.InlayHintResolveRequest=_M={}));var bM;(function(e){e.method="workspace/inlayHint/refresh",e.messageDirection=Zo.MessageDirection.serverToClient,e.type=new Zo.ProtocolRequestType0(e.method);})(bM||(Ms.InlayHintRefreshRequest=bM={}));});var RM=I(Hn=>{Object.defineProperty(Hn,"__esModule",{value:!0});Hn.DiagnosticRefreshRequest=Hn.WorkspaceDiagnosticRequest=Hn.DocumentDiagnosticRequest=Hn.DocumentDiagnosticReportKind=Hn.DiagnosticServerCancellationData=void 0;var AM=Na(),Nie=Fh(),Jo=Xt(),EM;(function(e){function t(r){let n=r;return n&&Nie.boolean(n.retriggerRequest)}e.is=t;})(EM||(Hn.DiagnosticServerCancellationData=EM={}));var wM;(function(e){e.Full="full",e.Unchanged="unchanged";})(wM||(Hn.DocumentDiagnosticReportKind=wM={}));var CM;(function(e){e.method="textDocument/diagnostic",e.messageDirection=Jo.MessageDirection.clientToServer,e.type=new Jo.ProtocolRequestType(e.method),e.partialResult=new AM.ProgressType;})(CM||(Hn.DocumentDiagnosticRequest=CM={}));var xM;(function(e){e.method="workspace/diagnostic",e.messageDirection=Jo.MessageDirection.clientToServer,e.type=new Jo.ProtocolRequestType(e.method),e.partialResult=new AM.ProgressType;})(xM||(Hn.WorkspaceDiagnosticRequest=xM={}));var TM;(function(e){e.method="workspace/diagnostic/refresh",e.messageDirection=Jo.MessageDirection.serverToClient,e.type=new Jo.ProtocolRequestType0(e.method);})(TM||(Hn.DiagnosticRefreshRequest=TM={}));});var LM=I(rr=>{Object.defineProperty(rr,"__esModule",{value:!0});rr.DidCloseNotebookDocumentNotification=rr.DidSaveNotebookDocumentNotification=rr.DidChangeNotebookDocumentNotification=rr.NotebookCellArrayChange=rr.DidOpenNotebookDocumentNotification=rr.NotebookDocumentSyncRegistrationType=rr.NotebookDocument=rr.NotebookCell=rr.ExecutionSummary=rr.NotebookCellKind=void 0;var Gc=Bh(),ci=Fh(),Pi=Xt(),rS;(function(e){e.Markup=1,e.Code=2;function t(r){return r===1||r===2}e.is=t;})(rS||(rr.NotebookCellKind=rS={}));var nS;(function(e){function t(i,s){let a={executionOrder:i};return (s===!0||s===!1)&&(a.success=s),a}e.create=t;function r(i){let s=i;return ci.objectLiteral(s)&&Gc.uinteger.is(s.executionOrder)&&(s.success===void 0||ci.boolean(s.success))}e.is=r;function n(i,s){return i===s?!0:i==null||s===null||s===void 0?!1:i.executionOrder===s.executionOrder&&i.success===s.success}e.equals=n;})(nS||(rr.ExecutionSummary=nS={}));var Qh;(function(e){function t(s,a){return {kind:s,document:a}}e.create=t;function r(s){let a=s;return ci.objectLiteral(a)&&rS.is(a.kind)&&Gc.DocumentUri.is(a.document)&&(a.metadata===void 0||ci.objectLiteral(a.metadata))}e.is=r;function n(s,a){let o=new Set;return s.document!==a.document&&o.add("document"),s.kind!==a.kind&&o.add("kind"),s.executionSummary!==a.executionSummary&&o.add("executionSummary"),(s.metadata!==void 0||a.metadata!==void 0)&&!i(s.metadata,a.metadata)&&o.add("metadata"),(s.executionSummary!==void 0||a.executionSummary!==void 0)&&!nS.equals(s.executionSummary,a.executionSummary)&&o.add("executionSummary"),o}e.diff=n;function i(s,a){if(s===a)return !0;if(s==null||a===null||a===void 0||typeof s!=typeof a||typeof s!="object")return !1;let o=Array.isArray(s),c=Array.isArray(a);if(o!==c)return !1;if(o&&c){if(s.length!==a.length)return !1;for(let l=0;l<s.length;l++)if(!i(s[l],a[l]))return !1}if(ci.objectLiteral(s)&&ci.objectLiteral(a)){let l=Object.keys(s),u=Object.keys(a);if(l.length!==u.length||(l.sort(),u.sort(),!i(l,u)))return !1;for(let f=0;f<l.length;f++){let h=l[f];if(!i(s[h],a[h]))return !1}}return !0}})(Qh||(rr.NotebookCell=Qh={}));var IM;(function(e){function t(n,i,s,a){return {uri:n,notebookType:i,version:s,cells:a}}e.create=t;function r(n){let i=n;return ci.objectLiteral(i)&&ci.string(i.uri)&&Gc.integer.is(i.version)&&ci.typedArray(i.cells,Qh.is)}e.is=r;})(IM||(rr.NotebookDocument=IM={}));var eu;(function(e){e.method="notebookDocument/sync",e.messageDirection=Pi.MessageDirection.clientToServer,e.type=new Pi.RegistrationType(e.method);})(eu||(rr.NotebookDocumentSyncRegistrationType=eu={}));var PM;(function(e){e.method="notebookDocument/didOpen",e.messageDirection=Pi.MessageDirection.clientToServer,e.type=new Pi.ProtocolNotificationType(e.method),e.registrationMethod=eu.method;})(PM||(rr.DidOpenNotebookDocumentNotification=PM={}));var NM;(function(e){function t(n){let i=n;return ci.objectLiteral(i)&&Gc.uinteger.is(i.start)&&Gc.uinteger.is(i.deleteCount)&&(i.cells===void 0||ci.typedArray(i.cells,Qh.is))}e.is=t;function r(n,i,s){let a={start:n,deleteCount:i};return s!==void 0&&(a.cells=s),a}e.create=r;})(NM||(rr.NotebookCellArrayChange=NM={}));var DM;(function(e){e.method="notebookDocument/didChange",e.messageDirection=Pi.MessageDirection.clientToServer,e.type=new Pi.ProtocolNotificationType(e.method),e.registrationMethod=eu.method;})(DM||(rr.DidChangeNotebookDocumentNotification=DM={}));var OM;(function(e){e.method="notebookDocument/didSave",e.messageDirection=Pi.MessageDirection.clientToServer,e.type=new Pi.ProtocolNotificationType(e.method),e.registrationMethod=eu.method;})(OM||(rr.DidSaveNotebookDocumentNotification=OM={}));var kM;(function(e){e.method="notebookDocument/didClose",e.messageDirection=Pi.MessageDirection.clientToServer,e.type=new Pi.ProtocolNotificationType(e.method),e.registrationMethod=eu.method;})(kM||(rr.DidCloseNotebookDocumentNotification=kM={}));});var qM=I(Xh=>{Object.defineProperty(Xh,"__esModule",{value:!0});Xh.InlineCompletionRequest=void 0;var BM=Xt(),FM;(function(e){e.method="textDocument/inlineCompletion",e.messageDirection=BM.MessageDirection.clientToServer,e.type=new BM.ProtocolRequestType(e.method);})(FM||(Xh.InlineCompletionRequest=FM={}));});var X4=I(k=>{Object.defineProperty(k,"__esModule",{value:!0});k.WorkspaceSymbolRequest=k.CodeActionResolveRequest=k.CodeActionRequest=k.DocumentSymbolRequest=k.DocumentHighlightRequest=k.ReferencesRequest=k.DefinitionRequest=k.SignatureHelpRequest=k.SignatureHelpTriggerKind=k.HoverRequest=k.CompletionResolveRequest=k.CompletionRequest=k.CompletionTriggerKind=k.PublishDiagnosticsNotification=k.WatchKind=k.RelativePattern=k.FileChangeType=k.DidChangeWatchedFilesNotification=k.WillSaveTextDocumentWaitUntilRequest=k.WillSaveTextDocumentNotification=k.TextDocumentSaveReason=k.DidSaveTextDocumentNotification=k.DidCloseTextDocumentNotification=k.DidChangeTextDocumentNotification=k.TextDocumentContentChangeEvent=k.DidOpenTextDocumentNotification=k.TextDocumentSyncKind=k.TelemetryEventNotification=k.LogMessageNotification=k.ShowMessageRequest=k.ShowMessageNotification=k.MessageType=k.DidChangeConfigurationNotification=k.ExitNotification=k.ShutdownRequest=k.InitializedNotification=k.InitializeErrorCodes=k.InitializeRequest=k.WorkDoneProgressOptions=k.TextDocumentRegistrationOptions=k.StaticRegistrationOptions=k.PositionEncodingKind=k.FailureHandlingKind=k.ResourceOperationKind=k.UnregistrationRequest=k.RegistrationRequest=k.DocumentSelector=k.NotebookCellTextDocumentFilter=k.NotebookDocumentFilter=k.TextDocumentFilter=void 0;k.MonikerRequest=k.MonikerKind=k.UniquenessLevel=k.WillDeleteFilesRequest=k.DidDeleteFilesNotification=k.WillRenameFilesRequest=k.DidRenameFilesNotification=k.WillCreateFilesRequest=k.DidCreateFilesNotification=k.FileOperationPatternKind=k.LinkedEditingRangeRequest=k.ShowDocumentRequest=k.SemanticTokensRegistrationType=k.SemanticTokensRefreshRequest=k.SemanticTokensRangeRequest=k.SemanticTokensDeltaRequest=k.SemanticTokensRequest=k.TokenFormat=k.CallHierarchyPrepareRequest=k.CallHierarchyOutgoingCallsRequest=k.CallHierarchyIncomingCallsRequest=k.WorkDoneProgressCancelNotification=k.WorkDoneProgressCreateRequest=k.WorkDoneProgress=k.SelectionRangeRequest=k.DeclarationRequest=k.FoldingRangeRefreshRequest=k.FoldingRangeRequest=k.ColorPresentationRequest=k.DocumentColorRequest=k.ConfigurationRequest=k.DidChangeWorkspaceFoldersNotification=k.WorkspaceFoldersRequest=k.TypeDefinitionRequest=k.ImplementationRequest=k.ApplyWorkspaceEditRequest=k.ExecuteCommandRequest=k.PrepareRenameRequest=k.RenameRequest=k.PrepareSupportDefaultBehavior=k.DocumentOnTypeFormattingRequest=k.DocumentRangesFormattingRequest=k.DocumentRangeFormattingRequest=k.DocumentFormattingRequest=k.DocumentLinkResolveRequest=k.DocumentLinkRequest=k.CodeLensRefreshRequest=k.CodeLensResolveRequest=k.CodeLensRequest=k.WorkspaceSymbolResolveRequest=void 0;k.InlineCompletionRequest=k.DidCloseNotebookDocumentNotification=k.DidSaveNotebookDocumentNotification=k.DidChangeNotebookDocumentNotification=k.NotebookCellArrayChange=k.DidOpenNotebookDocumentNotification=k.NotebookDocumentSyncRegistrationType=k.NotebookDocument=k.NotebookCell=k.ExecutionSummary=k.NotebookCellKind=k.DiagnosticRefreshRequest=k.WorkspaceDiagnosticRequest=k.DocumentDiagnosticRequest=k.DocumentDiagnosticReportKind=k.DiagnosticServerCancellationData=k.InlayHintRefreshRequest=k.InlayHintResolveRequest=k.InlayHintRequest=k.InlineValueRefreshRequest=k.InlineValueRequest=k.TypeHierarchySupertypesRequest=k.TypeHierarchySubtypesRequest=k.TypeHierarchyPrepareRequest=void 0;var _e=Xt(),MM=Bh(),Cr=Fh(),Die=lq();Object.defineProperty(k,"ImplementationRequest",{enumerable:!0,get:function(){return Die.ImplementationRequest}});var Oie=hq();Object.defineProperty(k,"TypeDefinitionRequest",{enumerable:!0,get:function(){return Oie.TypeDefinitionRequest}});var G4=mq();Object.defineProperty(k,"WorkspaceFoldersRequest",{enumerable:!0,get:function(){return G4.WorkspaceFoldersRequest}});Object.defineProperty(k,"DidChangeWorkspaceFoldersNotification",{enumerable:!0,get:function(){return G4.DidChangeWorkspaceFoldersNotification}});var kie=_q();Object.defineProperty(k,"ConfigurationRequest",{enumerable:!0,get:function(){return kie.ConfigurationRequest}});var z4=Eq();Object.defineProperty(k,"DocumentColorRequest",{enumerable:!0,get:function(){return z4.DocumentColorRequest}});Object.defineProperty(k,"ColorPresentationRequest",{enumerable:!0,get:function(){return z4.ColorPresentationRequest}});var Y4=xq();Object.defineProperty(k,"FoldingRangeRequest",{enumerable:!0,get:function(){return Y4.FoldingRangeRequest}});Object.defineProperty(k,"FoldingRangeRefreshRequest",{enumerable:!0,get:function(){return Y4.FoldingRangeRefreshRequest}});var Lie=Rq();Object.defineProperty(k,"DeclarationRequest",{enumerable:!0,get:function(){return Lie.DeclarationRequest}});var Bie=Nq();Object.defineProperty(k,"SelectionRangeRequest",{enumerable:!0,get:function(){return Bie.SelectionRangeRequest}});var uS=Lq();Object.defineProperty(k,"WorkDoneProgress",{enumerable:!0,get:function(){return uS.WorkDoneProgress}});Object.defineProperty(k,"WorkDoneProgressCreateRequest",{enumerable:!0,get:function(){return uS.WorkDoneProgressCreateRequest}});Object.defineProperty(k,"WorkDoneProgressCancelNotification",{enumerable:!0,get:function(){return uS.WorkDoneProgressCancelNotification}});var cS=Mq();Object.defineProperty(k,"CallHierarchyIncomingCallsRequest",{enumerable:!0,get:function(){return cS.CallHierarchyIncomingCallsRequest}});Object.defineProperty(k,"CallHierarchyOutgoingCallsRequest",{enumerable:!0,get:function(){return cS.CallHierarchyOutgoingCallsRequest}});Object.defineProperty(k,"CallHierarchyPrepareRequest",{enumerable:!0,get:function(){return cS.CallHierarchyPrepareRequest}});var tu=Wq();Object.defineProperty(k,"TokenFormat",{enumerable:!0,get:function(){return tu.TokenFormat}});Object.defineProperty(k,"SemanticTokensRequest",{enumerable:!0,get:function(){return tu.SemanticTokensRequest}});Object.defineProperty(k,"SemanticTokensDeltaRequest",{enumerable:!0,get:function(){return tu.SemanticTokensDeltaRequest}});Object.defineProperty(k,"SemanticTokensRangeRequest",{enumerable:!0,get:function(){return tu.SemanticTokensRangeRequest}});Object.defineProperty(k,"SemanticTokensRefreshRequest",{enumerable:!0,get:function(){return tu.SemanticTokensRefreshRequest}});Object.defineProperty(k,"SemanticTokensRegistrationType",{enumerable:!0,get:function(){return tu.SemanticTokensRegistrationType}});var Fie=zq();Object.defineProperty(k,"ShowDocumentRequest",{enumerable:!0,get:function(){return Fie.ShowDocumentRequest}});var qie=Xq();Object.defineProperty(k,"LinkedEditingRangeRequest",{enumerable:!0,get:function(){return qie.LinkedEditingRangeRequest}});var Da=sM();Object.defineProperty(k,"FileOperationPatternKind",{enumerable:!0,get:function(){return Da.FileOperationPatternKind}});Object.defineProperty(k,"DidCreateFilesNotification",{enumerable:!0,get:function(){return Da.DidCreateFilesNotification}});Object.defineProperty(k,"WillCreateFilesRequest",{enumerable:!0,get:function(){return Da.WillCreateFilesRequest}});Object.defineProperty(k,"DidRenameFilesNotification",{enumerable:!0,get:function(){return Da.DidRenameFilesNotification}});Object.defineProperty(k,"WillRenameFilesRequest",{enumerable:!0,get:function(){return Da.WillRenameFilesRequest}});Object.defineProperty(k,"DidDeleteFilesNotification",{enumerable:!0,get:function(){return Da.DidDeleteFilesNotification}});Object.defineProperty(k,"WillDeleteFilesRequest",{enumerable:!0,get:function(){return Da.WillDeleteFilesRequest}});var lS=lM();Object.defineProperty(k,"UniquenessLevel",{enumerable:!0,get:function(){return lS.UniquenessLevel}});Object.defineProperty(k,"MonikerKind",{enumerable:!0,get:function(){return lS.MonikerKind}});Object.defineProperty(k,"MonikerRequest",{enumerable:!0,get:function(){return lS.MonikerRequest}});var fS=pM();Object.defineProperty(k,"TypeHierarchyPrepareRequest",{enumerable:!0,get:function(){return fS.TypeHierarchyPrepareRequest}});Object.defineProperty(k,"TypeHierarchySubtypesRequest",{enumerable:!0,get:function(){return fS.TypeHierarchySubtypesRequest}});Object.defineProperty(k,"TypeHierarchySupertypesRequest",{enumerable:!0,get:function(){return fS.TypeHierarchySupertypesRequest}});var Q4=yM();Object.defineProperty(k,"InlineValueRequest",{enumerable:!0,get:function(){return Q4.InlineValueRequest}});Object.defineProperty(k,"InlineValueRefreshRequest",{enumerable:!0,get:function(){return Q4.InlineValueRefreshRequest}});var dS=SM();Object.defineProperty(k,"InlayHintRequest",{enumerable:!0,get:function(){return dS.InlayHintRequest}});Object.defineProperty(k,"InlayHintResolveRequest",{enumerable:!0,get:function(){return dS.InlayHintResolveRequest}});Object.defineProperty(k,"InlayHintRefreshRequest",{enumerable:!0,get:function(){return dS.InlayHintRefreshRequest}});var zc=RM();Object.defineProperty(k,"DiagnosticServerCancellationData",{enumerable:!0,get:function(){return zc.DiagnosticServerCancellationData}});Object.defineProperty(k,"DocumentDiagnosticReportKind",{enumerable:!0,get:function(){return zc.DocumentDiagnosticReportKind}});Object.defineProperty(k,"DocumentDiagnosticRequest",{enumerable:!0,get:function(){return zc.DocumentDiagnosticRequest}});Object.defineProperty(k,"WorkspaceDiagnosticRequest",{enumerable:!0,get:function(){return zc.WorkspaceDiagnosticRequest}});Object.defineProperty(k,"DiagnosticRefreshRequest",{enumerable:!0,get:function(){return zc.DiagnosticRefreshRequest}});var Ni=LM();Object.defineProperty(k,"NotebookCellKind",{enumerable:!0,get:function(){return Ni.NotebookCellKind}});Object.defineProperty(k,"ExecutionSummary",{enumerable:!0,get:function(){return Ni.ExecutionSummary}});Object.defineProperty(k,"NotebookCell",{enumerable:!0,get:function(){return Ni.NotebookCell}});Object.defineProperty(k,"NotebookDocument",{enumerable:!0,get:function(){return Ni.NotebookDocument}});Object.defineProperty(k,"NotebookDocumentSyncRegistrationType",{enumerable:!0,get:function(){return Ni.NotebookDocumentSyncRegistrationType}});Object.defineProperty(k,"DidOpenNotebookDocumentNotification",{enumerable:!0,get:function(){return Ni.DidOpenNotebookDocumentNotification}});Object.defineProperty(k,"NotebookCellArrayChange",{enumerable:!0,get:function(){return Ni.NotebookCellArrayChange}});Object.defineProperty(k,"DidChangeNotebookDocumentNotification",{enumerable:!0,get:function(){return Ni.DidChangeNotebookDocumentNotification}});Object.defineProperty(k,"DidSaveNotebookDocumentNotification",{enumerable:!0,get:function(){return Ni.DidSaveNotebookDocumentNotification}});Object.defineProperty(k,"DidCloseNotebookDocumentNotification",{enumerable:!0,get:function(){return Ni.DidCloseNotebookDocumentNotification}});var Mie=qM();Object.defineProperty(k,"InlineCompletionRequest",{enumerable:!0,get:function(){return Mie.InlineCompletionRequest}});var iS;(function(e){function t(r){let n=r;return Cr.string(n)||Cr.string(n.language)||Cr.string(n.scheme)||Cr.string(n.pattern)}e.is=t;})(iS||(k.TextDocumentFilter=iS={}));var sS;(function(e){function t(r){let n=r;return Cr.objectLiteral(n)&&(Cr.string(n.notebookType)||Cr.string(n.scheme)||Cr.string(n.pattern))}e.is=t;})(sS||(k.NotebookDocumentFilter=sS={}));var aS;(function(e){function t(r){let n=r;return Cr.objectLiteral(n)&&(Cr.string(n.notebook)||sS.is(n.notebook))&&(n.language===void 0||Cr.string(n.language))}e.is=t;})(aS||(k.NotebookCellTextDocumentFilter=aS={}));var oS;(function(e){function t(r){if(!Array.isArray(r))return !1;for(let n of r)if(!Cr.string(n)&&!iS.is(n)&&!aS.is(n))return !1;return !0}e.is=t;})(oS||(k.DocumentSelector=oS={}));var UM;(function(e){e.method="client/registerCapability",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolRequestType(e.method);})(UM||(k.RegistrationRequest=UM={}));var $M;(function(e){e.method="client/unregisterCapability",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolRequestType(e.method);})($M||(k.UnregistrationRequest=$M={}));var jM;(function(e){e.Create="create",e.Rename="rename",e.Delete="delete";})(jM||(k.ResourceOperationKind=jM={}));var VM;(function(e){e.Abort="abort",e.Transactional="transactional",e.TextOnlyTransactional="textOnlyTransactional",e.Undo="undo";})(VM||(k.FailureHandlingKind=VM={}));var HM;(function(e){e.UTF8="utf-8",e.UTF16="utf-16",e.UTF32="utf-32";})(HM||(k.PositionEncodingKind=HM={}));var WM;(function(e){function t(r){let n=r;return n&&Cr.string(n.id)&&n.id.length>0}e.hasId=t;})(WM||(k.StaticRegistrationOptions=WM={}));var KM;(function(e){function t(r){let n=r;return n&&(n.documentSelector===null||oS.is(n.documentSelector))}e.is=t;})(KM||(k.TextDocumentRegistrationOptions=KM={}));var GM;(function(e){function t(n){let i=n;return Cr.objectLiteral(i)&&(i.workDoneProgress===void 0||Cr.boolean(i.workDoneProgress))}e.is=t;function r(n){let i=n;return i&&Cr.boolean(i.workDoneProgress)}e.hasWorkDoneProgress=r;})(GM||(k.WorkDoneProgressOptions=GM={}));var zM;(function(e){e.method="initialize",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(zM||(k.InitializeRequest=zM={}));var YM;(function(e){e.unknownProtocolVersion=1;})(YM||(k.InitializeErrorCodes=YM={}));var QM;(function(e){e.method="initialized",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(QM||(k.InitializedNotification=QM={}));var XM;(function(e){e.method="shutdown",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType0(e.method);})(XM||(k.ShutdownRequest=XM={}));var ZM;(function(e){e.method="exit",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType0(e.method);})(ZM||(k.ExitNotification=ZM={}));var JM;(function(e){e.method="workspace/didChangeConfiguration",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(JM||(k.DidChangeConfigurationNotification=JM={}));var e4;(function(e){e.Error=1,e.Warning=2,e.Info=3,e.Log=4,e.Debug=5;})(e4||(k.MessageType=e4={}));var t4;(function(e){e.method="window/showMessage",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolNotificationType(e.method);})(t4||(k.ShowMessageNotification=t4={}));var r4;(function(e){e.method="window/showMessageRequest",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolRequestType(e.method);})(r4||(k.ShowMessageRequest=r4={}));var n4;(function(e){e.method="window/logMessage",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolNotificationType(e.method);})(n4||(k.LogMessageNotification=n4={}));var i4;(function(e){e.method="telemetry/event",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolNotificationType(e.method);})(i4||(k.TelemetryEventNotification=i4={}));var s4;(function(e){e.None=0,e.Full=1,e.Incremental=2;})(s4||(k.TextDocumentSyncKind=s4={}));var a4;(function(e){e.method="textDocument/didOpen",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(a4||(k.DidOpenTextDocumentNotification=a4={}));var o4;(function(e){function t(n){let i=n;return i!=null&&typeof i.text=="string"&&i.range!==void 0&&(i.rangeLength===void 0||typeof i.rangeLength=="number")}e.isIncremental=t;function r(n){let i=n;return i!=null&&typeof i.text=="string"&&i.range===void 0&&i.rangeLength===void 0}e.isFull=r;})(o4||(k.TextDocumentContentChangeEvent=o4={}));var u4;(function(e){e.method="textDocument/didChange",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(u4||(k.DidChangeTextDocumentNotification=u4={}));var c4;(function(e){e.method="textDocument/didClose",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(c4||(k.DidCloseTextDocumentNotification=c4={}));var l4;(function(e){e.method="textDocument/didSave",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(l4||(k.DidSaveTextDocumentNotification=l4={}));var f4;(function(e){e.Manual=1,e.AfterDelay=2,e.FocusOut=3;})(f4||(k.TextDocumentSaveReason=f4={}));var d4;(function(e){e.method="textDocument/willSave",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(d4||(k.WillSaveTextDocumentNotification=d4={}));var h4;(function(e){e.method="textDocument/willSaveWaitUntil",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(h4||(k.WillSaveTextDocumentWaitUntilRequest=h4={}));var p4;(function(e){e.method="workspace/didChangeWatchedFiles",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolNotificationType(e.method);})(p4||(k.DidChangeWatchedFilesNotification=p4={}));var g4;(function(e){e.Created=1,e.Changed=2,e.Deleted=3;})(g4||(k.FileChangeType=g4={}));var m4;(function(e){function t(r){let n=r;return Cr.objectLiteral(n)&&(MM.URI.is(n.baseUri)||MM.WorkspaceFolder.is(n.baseUri))&&Cr.string(n.pattern)}e.is=t;})(m4||(k.RelativePattern=m4={}));var y4;(function(e){e.Create=1,e.Change=2,e.Delete=4;})(y4||(k.WatchKind=y4={}));var v4;(function(e){e.method="textDocument/publishDiagnostics",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolNotificationType(e.method);})(v4||(k.PublishDiagnosticsNotification=v4={}));var _4;(function(e){e.Invoked=1,e.TriggerCharacter=2,e.TriggerForIncompleteCompletions=3;})(_4||(k.CompletionTriggerKind=_4={}));var b4;(function(e){e.method="textDocument/completion",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(b4||(k.CompletionRequest=b4={}));var S4;(function(e){e.method="completionItem/resolve",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(S4||(k.CompletionResolveRequest=S4={}));var E4;(function(e){e.method="textDocument/hover",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(E4||(k.HoverRequest=E4={}));var w4;(function(e){e.Invoked=1,e.TriggerCharacter=2,e.ContentChange=3;})(w4||(k.SignatureHelpTriggerKind=w4={}));var C4;(function(e){e.method="textDocument/signatureHelp",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(C4||(k.SignatureHelpRequest=C4={}));var x4;(function(e){e.method="textDocument/definition",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(x4||(k.DefinitionRequest=x4={}));var T4;(function(e){e.method="textDocument/references",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(T4||(k.ReferencesRequest=T4={}));var A4;(function(e){e.method="textDocument/documentHighlight",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(A4||(k.DocumentHighlightRequest=A4={}));var R4;(function(e){e.method="textDocument/documentSymbol",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(R4||(k.DocumentSymbolRequest=R4={}));var I4;(function(e){e.method="textDocument/codeAction",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(I4||(k.CodeActionRequest=I4={}));var P4;(function(e){e.method="codeAction/resolve",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(P4||(k.CodeActionResolveRequest=P4={}));var N4;(function(e){e.method="workspace/symbol",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(N4||(k.WorkspaceSymbolRequest=N4={}));var D4;(function(e){e.method="workspaceSymbol/resolve",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(D4||(k.WorkspaceSymbolResolveRequest=D4={}));var O4;(function(e){e.method="textDocument/codeLens",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(O4||(k.CodeLensRequest=O4={}));var k4;(function(e){e.method="codeLens/resolve",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(k4||(k.CodeLensResolveRequest=k4={}));var L4;(function(e){e.method="workspace/codeLens/refresh",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolRequestType0(e.method);})(L4||(k.CodeLensRefreshRequest=L4={}));var B4;(function(e){e.method="textDocument/documentLink",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(B4||(k.DocumentLinkRequest=B4={}));var F4;(function(e){e.method="documentLink/resolve",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(F4||(k.DocumentLinkResolveRequest=F4={}));var q4;(function(e){e.method="textDocument/formatting",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(q4||(k.DocumentFormattingRequest=q4={}));var M4;(function(e){e.method="textDocument/rangeFormatting",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(M4||(k.DocumentRangeFormattingRequest=M4={}));var U4;(function(e){e.method="textDocument/rangesFormatting",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(U4||(k.DocumentRangesFormattingRequest=U4={}));var $4;(function(e){e.method="textDocument/onTypeFormatting",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})($4||(k.DocumentOnTypeFormattingRequest=$4={}));var j4;(function(e){e.Identifier=1;})(j4||(k.PrepareSupportDefaultBehavior=j4={}));var V4;(function(e){e.method="textDocument/rename",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(V4||(k.RenameRequest=V4={}));var H4;(function(e){e.method="textDocument/prepareRename",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(H4||(k.PrepareRenameRequest=H4={}));var W4;(function(e){e.method="workspace/executeCommand",e.messageDirection=_e.MessageDirection.clientToServer,e.type=new _e.ProtocolRequestType(e.method);})(W4||(k.ExecuteCommandRequest=W4={}));var K4;(function(e){e.method="workspace/applyEdit",e.messageDirection=_e.MessageDirection.serverToClient,e.type=new _e.ProtocolRequestType("workspace/applyEdit");})(K4||(k.ApplyWorkspaceEditRequest=K4={}));});var J4=I(Zh=>{Object.defineProperty(Zh,"__esModule",{value:!0});Zh.createProtocolConnection=void 0;var Z4=Na();function Uie(e,t,r,n){return Z4.ConnectionStrategy.is(n)&&(n={connectionStrategy:n}),(0, Z4.createMessageConnection)(e,t,r,n)}Zh.createProtocolConnection=Uie;});var t3=I(pn=>{var $ie=pn&&pn.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),Jh=pn&&pn.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&$ie(t,e,r);};Object.defineProperty(pn,"__esModule",{value:!0});pn.LSPErrorCodes=pn.createProtocolConnection=void 0;Jh(Na(),pn);Jh(Bh(),pn);Jh(Xt(),pn);Jh(X4(),pn);var jie=J4();Object.defineProperty(pn,"createProtocolConnection",{enumerable:!0,get:function(){return jie.createProtocolConnection}});var e3;(function(e){e.lspReservedErrorRangeStart=-32899,e.RequestFailed=-32803,e.ServerCancelled=-32802,e.ContentModified=-32801,e.RequestCancelled=-32800,e.lspReservedErrorRangeEnd=-32800;})(e3||(pn.LSPErrorCodes=e3={}));});var or=I(Di=>{var Vie=Di&&Di.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),r3=Di&&Di.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Vie(t,e,r);};Object.defineProperty(Di,"__esModule",{value:!0});Di.createProtocolConnection=void 0;var Hie=Qb();r3(Qb(),Di);r3(t3(),Di);function Wie(e,t,r,n){return (0, Hie.createMessageConnection)(e,t,r,n)}Di.createProtocolConnection=Wie;});var hS=I(Wn=>{Object.defineProperty(Wn,"__esModule",{value:!0});Wn.generateUuid=Wn.parse=Wn.isUUID=Wn.v4=Wn.empty=void 0;var Yc=class{constructor(t){this._value=t;}asHex(){return this._value}equals(t){return this.asHex()===t.asHex()}},Qc=class e extends Yc{static _oneOf(t){return t[Math.floor(t.length*Math.random())]}static _randomHex(){return e._oneOf(e._chars)}constructor(){super([e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),"-",e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),"-","4",e._randomHex(),e._randomHex(),e._randomHex(),"-",e._oneOf(e._timeHighBits),e._randomHex(),e._randomHex(),e._randomHex(),"-",e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex(),e._randomHex()].join(""));}};Qc._chars=["0","1","2","3","4","5","6","6","7","8","9","a","b","c","d","e","f"];Qc._timeHighBits=["8","9","a","b"];Wn.empty=new Yc("00000000-0000-0000-0000-000000000000");function n3(){return new Qc}Wn.v4=n3;var Kie=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function i3(e){return Kie.test(e)}Wn.isUUID=i3;function Gie(e){if(!i3(e))throw new Error("invalid uuid");return new Yc(e)}Wn.parse=Gie;function zie(){return n3().asHex()}Wn.generateUuid=zie;});var s3=I($s=>{Object.defineProperty($s,"__esModule",{value:!0});$s.attachPartialResult=$s.ProgressFeature=$s.attachWorkDone=void 0;var Us=or(),Yie=hS(),Oa=class e{constructor(t,r){this._connection=t,this._token=r,e.Instances.set(this._token,this);}begin(t,r,n,i){let s={kind:"begin",title:t,percentage:r,message:n,cancellable:i};this._connection.sendProgress(Us.WorkDoneProgress.type,this._token,s);}report(t,r){let n={kind:"report"};typeof t=="number"?(n.percentage=t,r!==void 0&&(n.message=r)):n.message=t,this._connection.sendProgress(Us.WorkDoneProgress.type,this._token,n);}done(){e.Instances.delete(this._token),this._connection.sendProgress(Us.WorkDoneProgress.type,this._token,{kind:"end"});}};Oa.Instances=new Map;var ep=class extends Oa{constructor(t,r){super(t,r),this._source=new Us.CancellationTokenSource;}get token(){return this._source.token}done(){this._source.dispose(),super.done();}cancel(){this._source.cancel();}},Xc=class{constructor(){}begin(){}report(){}done(){}},tp=class extends Xc{constructor(){super(),this._source=new Us.CancellationTokenSource;}get token(){return this._source.token}done(){this._source.dispose();}cancel(){this._source.cancel();}};function Qie(e,t){if(t===void 0||t.workDoneToken===void 0)return new Xc;let r=t.workDoneToken;return delete t.workDoneToken,new Oa(e,r)}$s.attachWorkDone=Qie;var Xie=e=>class extends e{constructor(){super(),this._progressSupported=!1;}initialize(t){super.initialize(t),t?.window?.workDoneProgress===!0&&(this._progressSupported=!0,this.connection.onNotification(Us.WorkDoneProgressCancelNotification.type,r=>{let n=Oa.Instances.get(r.token);(n instanceof ep||n instanceof tp)&&n.cancel();}));}attachWorkDoneProgress(t){return t===void 0?new Xc:new Oa(this.connection,t)}createWorkDoneProgress(){if(this._progressSupported){let t=(0, Yie.generateUuid)();return this.connection.sendRequest(Us.WorkDoneProgressCreateRequest.type,{token:t}).then(()=>new ep(this.connection,t))}else return Promise.resolve(new tp)}};$s.ProgressFeature=Xie;var pS;(function(e){e.type=new Us.ProgressType;})(pS||(pS={}));var gS=class{constructor(t,r){this._connection=t,this._token=r;}report(t){this._connection.sendProgress(pS.type,this._token,t);}};function Zie(e,t){if(t===void 0||t.partialResultToken===void 0)return;let r=t.partialResultToken;return delete t.partialResultToken,new gS(e,r)}$s.attachPartialResult=Zie;});var a3=I(rp=>{Object.defineProperty(rp,"__esModule",{value:!0});rp.ConfigurationFeature=void 0;var Jie=or(),ese=hh(),tse=e=>class extends e{getConfiguration(t){return t?ese.string(t)?this._getConfiguration({section:t}):this._getConfiguration(t):this._getConfiguration({})}_getConfiguration(t){let r={items:Array.isArray(t)?t:[t]};return this.connection.sendRequest(Jie.ConfigurationRequest.type,r).then(n=>Array.isArray(n)?Array.isArray(t)?n:n[0]:Array.isArray(t)?[]:null)}};rp.ConfigurationFeature=tse;});var o3=I(ip=>{Object.defineProperty(ip,"__esModule",{value:!0});ip.WorkspaceFoldersFeature=void 0;var np=or(),rse=e=>class extends e{constructor(){super(),this._notificationIsAutoRegistered=!1;}initialize(t){super.initialize(t);let r=t.workspace;r&&r.workspaceFolders&&(this._onDidChangeWorkspaceFolders=new np.Emitter,this.connection.onNotification(np.DidChangeWorkspaceFoldersNotification.type,n=>{this._onDidChangeWorkspaceFolders.fire(n.event);}));}fillServerCapabilities(t){super.fillServerCapabilities(t);let r=t.workspace?.workspaceFolders?.changeNotifications;this._notificationIsAutoRegistered=r===!0||typeof r=="string";}getWorkspaceFolders(){return this.connection.sendRequest(np.WorkspaceFoldersRequest.type)}get onDidChangeWorkspaceFolders(){if(!this._onDidChangeWorkspaceFolders)throw new Error("Client doesn't support sending workspace folder change events.");return !this._notificationIsAutoRegistered&&!this._unregistration&&(this._unregistration=this.connection.client.register(np.DidChangeWorkspaceFoldersNotification.type)),this._onDidChangeWorkspaceFolders.event}};ip.WorkspaceFoldersFeature=rse;});var u3=I(sp=>{Object.defineProperty(sp,"__esModule",{value:!0});sp.CallHierarchyFeature=void 0;var mS=or(),nse=e=>class extends e{get callHierarchy(){return {onPrepare:t=>this.connection.onRequest(mS.CallHierarchyPrepareRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),void 0)),onIncomingCalls:t=>{let r=mS.CallHierarchyIncomingCallsRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onOutgoingCalls:t=>{let r=mS.CallHierarchyOutgoingCallsRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};sp.CallHierarchyFeature=nse;});var vS=I(js=>{Object.defineProperty(js,"__esModule",{value:!0});js.SemanticTokensBuilder=js.SemanticTokensDiff=js.SemanticTokensFeature=void 0;var ap=or(),ise=e=>class extends e{get semanticTokens(){return {refresh:()=>this.connection.sendRequest(ap.SemanticTokensRefreshRequest.type),on:t=>{let r=ap.SemanticTokensRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onDelta:t=>{let r=ap.SemanticTokensDeltaRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onRange:t=>{let r=ap.SemanticTokensRangeRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};js.SemanticTokensFeature=ise;var op=class{constructor(t,r){this.originalSequence=t,this.modifiedSequence=r;}computeDiff(){let t=this.originalSequence.length,r=this.modifiedSequence.length,n=0;for(;n<r&&n<t&&this.originalSequence[n]===this.modifiedSequence[n];)n++;if(n<r&&n<t){let i=t-1,s=r-1;for(;i>=n&&s>=n&&this.originalSequence[i]===this.modifiedSequence[s];)i--,s--;(i<n||s<n)&&(i++,s++);let a=i-n+1,o=this.modifiedSequence.slice(n,s+1);return o.length===1&&o[0]===this.originalSequence[i]?[{start:n,deleteCount:a-1}]:[{start:n,deleteCount:a,data:o}]}else return n<r?[{start:n,deleteCount:0,data:this.modifiedSequence.slice(n)}]:n<t?[{start:n,deleteCount:t-n}]:[]}};js.SemanticTokensDiff=op;var yS=class{constructor(){this._prevData=void 0,this.initialize();}initialize(){this._id=Date.now(),this._prevLine=0,this._prevChar=0,this._data=[],this._dataLen=0;}push(t,r,n,i,s){let a=t,o=r;this._dataLen>0&&(a-=this._prevLine,a===0&&(o-=this._prevChar)),this._data[this._dataLen++]=a,this._data[this._dataLen++]=o,this._data[this._dataLen++]=n,this._data[this._dataLen++]=i,this._data[this._dataLen++]=s,this._prevLine=t,this._prevChar=r;}get id(){return this._id.toString()}previousResult(t){this.id===t&&(this._prevData=this._data),this.initialize();}build(){return this._prevData=void 0,{resultId:this.id,data:this._data}}canBuildEdits(){return this._prevData!==void 0}buildEdits(){return this._prevData!==void 0?{resultId:this.id,edits:new op(this._prevData,this._data).computeDiff()}:this.build()}};js.SemanticTokensBuilder=yS;});var c3=I(up=>{Object.defineProperty(up,"__esModule",{value:!0});up.ShowDocumentFeature=void 0;var sse=or(),ase=e=>class extends e{showDocument(t){return this.connection.sendRequest(sse.ShowDocumentRequest.type,t)}};up.ShowDocumentFeature=ase;});var l3=I(cp=>{Object.defineProperty(cp,"__esModule",{value:!0});cp.FileOperationsFeature=void 0;var ru=or(),ose=e=>class extends e{onDidCreateFiles(t){return this.connection.onNotification(ru.DidCreateFilesNotification.type,r=>{t(r);})}onDidRenameFiles(t){return this.connection.onNotification(ru.DidRenameFilesNotification.type,r=>{t(r);})}onDidDeleteFiles(t){return this.connection.onNotification(ru.DidDeleteFilesNotification.type,r=>{t(r);})}onWillCreateFiles(t){return this.connection.onRequest(ru.WillCreateFilesRequest.type,(r,n)=>t(r,n))}onWillRenameFiles(t){return this.connection.onRequest(ru.WillRenameFilesRequest.type,(r,n)=>t(r,n))}onWillDeleteFiles(t){return this.connection.onRequest(ru.WillDeleteFilesRequest.type,(r,n)=>t(r,n))}};cp.FileOperationsFeature=ose;});var f3=I(lp=>{Object.defineProperty(lp,"__esModule",{value:!0});lp.LinkedEditingRangeFeature=void 0;var use=or(),cse=e=>class extends e{onLinkedEditingRange(t){return this.connection.onRequest(use.LinkedEditingRangeRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),void 0))}};lp.LinkedEditingRangeFeature=cse;});var d3=I(fp=>{Object.defineProperty(fp,"__esModule",{value:!0});fp.TypeHierarchyFeature=void 0;var _S=or(),lse=e=>class extends e{get typeHierarchy(){return {onPrepare:t=>this.connection.onRequest(_S.TypeHierarchyPrepareRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),void 0)),onSupertypes:t=>{let r=_S.TypeHierarchySupertypesRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))},onSubtypes:t=>{let r=_S.TypeHierarchySubtypesRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};fp.TypeHierarchyFeature=lse;});var p3=I(dp=>{Object.defineProperty(dp,"__esModule",{value:!0});dp.InlineValueFeature=void 0;var h3=or(),fse=e=>class extends e{get inlineValue(){return {refresh:()=>this.connection.sendRequest(h3.InlineValueRefreshRequest.type),on:t=>this.connection.onRequest(h3.InlineValueRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r)))}}};dp.InlineValueFeature=fse;});var m3=I(hp=>{Object.defineProperty(hp,"__esModule",{value:!0});hp.FoldingRangeFeature=void 0;var g3=or(),dse=e=>class extends e{get foldingRange(){return {refresh:()=>this.connection.sendRequest(g3.FoldingRangeRefreshRequest.type),on:t=>{let r=g3.FoldingRangeRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};hp.FoldingRangeFeature=dse;});var y3=I(pp=>{Object.defineProperty(pp,"__esModule",{value:!0});pp.InlayHintFeature=void 0;var bS=or(),hse=e=>class extends e{get inlayHint(){return {refresh:()=>this.connection.sendRequest(bS.InlayHintRefreshRequest.type),on:t=>this.connection.onRequest(bS.InlayHintRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r))),resolve:t=>this.connection.onRequest(bS.InlayHintResolveRequest.type,(r,n)=>t(r,n))}}};pp.InlayHintFeature=hse;});var v3=I(gp=>{Object.defineProperty(gp,"__esModule",{value:!0});gp.DiagnosticFeature=void 0;var Zc=or(),pse=e=>class extends e{get diagnostics(){return {refresh:()=>this.connection.sendRequest(Zc.DiagnosticRefreshRequest.type),on:t=>this.connection.onRequest(Zc.DocumentDiagnosticRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),this.attachPartialResultProgress(Zc.DocumentDiagnosticRequest.partialResult,r))),onWorkspace:t=>this.connection.onRequest(Zc.WorkspaceDiagnosticRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r),this.attachPartialResultProgress(Zc.WorkspaceDiagnosticRequest.partialResult,r)))}}};gp.DiagnosticFeature=pse;});var ES=I(mp=>{Object.defineProperty(mp,"__esModule",{value:!0});mp.TextDocuments=void 0;var ka=or(),SS=class{constructor(t){this._configuration=t,this._syncedDocuments=new Map,this._onDidChangeContent=new ka.Emitter,this._onDidOpen=new ka.Emitter,this._onDidClose=new ka.Emitter,this._onDidSave=new ka.Emitter,this._onWillSave=new ka.Emitter;}get onDidOpen(){return this._onDidOpen.event}get onDidChangeContent(){return this._onDidChangeContent.event}get onWillSave(){return this._onWillSave.event}onWillSaveWaitUntil(t){this._willSaveWaitUntil=t;}get onDidSave(){return this._onDidSave.event}get onDidClose(){return this._onDidClose.event}get(t){return this._syncedDocuments.get(t)}all(){return Array.from(this._syncedDocuments.values())}keys(){return Array.from(this._syncedDocuments.keys())}listen(t){t.__textDocumentSync=ka.TextDocumentSyncKind.Incremental;let r=[];return r.push(t.onDidOpenTextDocument(n=>{let i=n.textDocument,s=this._configuration.create(i.uri,i.languageId,i.version,i.text);this._syncedDocuments.set(i.uri,s);let a=Object.freeze({document:s});this._onDidOpen.fire(a),this._onDidChangeContent.fire(a);})),r.push(t.onDidChangeTextDocument(n=>{let i=n.textDocument,s=n.contentChanges;if(s.length===0)return;let{version:a}=i;if(a==null)throw new Error(`Received document change event for ${i.uri} without valid version identifier`);let o=this._syncedDocuments.get(i.uri);o!==void 0&&(o=this._configuration.update(o,s,a),this._syncedDocuments.set(i.uri,o),this._onDidChangeContent.fire(Object.freeze({document:o})));})),r.push(t.onDidCloseTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&(this._syncedDocuments.delete(n.textDocument.uri),this._onDidClose.fire(Object.freeze({document:i})));})),r.push(t.onWillSaveTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&this._onWillSave.fire(Object.freeze({document:i,reason:n.reason}));})),r.push(t.onWillSaveTextDocumentWaitUntil((n,i)=>{let s=this._syncedDocuments.get(n.textDocument.uri);return s!==void 0&&this._willSaveWaitUntil?this._willSaveWaitUntil(Object.freeze({document:s,reason:n.reason}),i):[]})),r.push(t.onDidSaveTextDocument(n=>{let i=this._syncedDocuments.get(n.textDocument.uri);i!==void 0&&this._onDidSave.fire(Object.freeze({document:i}));})),ka.Disposable.create(()=>{r.forEach(n=>n.dispose());})}};mp.TextDocuments=SS;});var CS=I(nu=>{Object.defineProperty(nu,"__esModule",{value:!0});nu.NotebookDocuments=nu.NotebookSyncFeature=void 0;var Kn=or(),_3=ES(),gse=e=>class extends e{get synchronization(){return {onDidOpenNotebookDocument:t=>this.connection.onNotification(Kn.DidOpenNotebookDocumentNotification.type,r=>{t(r);}),onDidChangeNotebookDocument:t=>this.connection.onNotification(Kn.DidChangeNotebookDocumentNotification.type,r=>{t(r);}),onDidSaveNotebookDocument:t=>this.connection.onNotification(Kn.DidSaveNotebookDocumentNotification.type,r=>{t(r);}),onDidCloseNotebookDocument:t=>this.connection.onNotification(Kn.DidCloseNotebookDocumentNotification.type,r=>{t(r);})}}};nu.NotebookSyncFeature=gse;var yp=class e{onDidOpenTextDocument(t){return this.openHandler=t,Kn.Disposable.create(()=>{this.openHandler=void 0;})}openTextDocument(t){this.openHandler&&this.openHandler(t);}onDidChangeTextDocument(t){return this.changeHandler=t,Kn.Disposable.create(()=>{this.changeHandler=t;})}changeTextDocument(t){this.changeHandler&&this.changeHandler(t);}onDidCloseTextDocument(t){return this.closeHandler=t,Kn.Disposable.create(()=>{this.closeHandler=void 0;})}closeTextDocument(t){this.closeHandler&&this.closeHandler(t);}onWillSaveTextDocument(){return e.NULL_DISPOSE}onWillSaveTextDocumentWaitUntil(){return e.NULL_DISPOSE}onDidSaveTextDocument(){return e.NULL_DISPOSE}};yp.NULL_DISPOSE=Object.freeze({dispose:()=>{}});var wS=class{constructor(t){t instanceof _3.TextDocuments?this._cellTextDocuments=t:this._cellTextDocuments=new _3.TextDocuments(t),this.notebookDocuments=new Map,this.notebookCellMap=new Map,this._onDidOpen=new Kn.Emitter,this._onDidChange=new Kn.Emitter,this._onDidSave=new Kn.Emitter,this._onDidClose=new Kn.Emitter;}get cellTextDocuments(){return this._cellTextDocuments}getCellTextDocument(t){return this._cellTextDocuments.get(t.document)}getNotebookDocument(t){return this.notebookDocuments.get(t)}getNotebookCell(t){let r=this.notebookCellMap.get(t);return r&&r[0]}findNotebookDocumentForCell(t){let r=typeof t=="string"?t:t.document,n=this.notebookCellMap.get(r);return n&&n[1]}get onDidOpen(){return this._onDidOpen.event}get onDidSave(){return this._onDidSave.event}get onDidChange(){return this._onDidChange.event}get onDidClose(){return this._onDidClose.event}listen(t){let r=new yp,n=[];return n.push(this.cellTextDocuments.listen(r)),n.push(t.notebooks.synchronization.onDidOpenNotebookDocument(i=>{this.notebookDocuments.set(i.notebookDocument.uri,i.notebookDocument);for(let s of i.cellTextDocuments)r.openTextDocument({textDocument:s});this.updateCellMap(i.notebookDocument),this._onDidOpen.fire(i.notebookDocument);})),n.push(t.notebooks.synchronization.onDidChangeNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);if(s===void 0)return;s.version=i.notebookDocument.version;let a=s.metadata,o=!1,c=i.change;c.metadata!==void 0&&(o=!0,s.metadata=c.metadata);let l=[],u=[],f=[],h=[];if(c.cells!==void 0){let w=c.cells;if(w.structure!==void 0){let y=w.structure.array;if(s.cells.splice(y.start,y.deleteCount,...y.cells!==void 0?y.cells:[]),w.structure.didOpen!==void 0)for(let b of w.structure.didOpen)r.openTextDocument({textDocument:b}),l.push(b.uri);if(w.structure.didClose)for(let b of w.structure.didClose)r.closeTextDocument({textDocument:b}),u.push(b.uri);}if(w.data!==void 0){let y=new Map(w.data.map(b=>[b.document,b]));for(let b=0;b<=s.cells.length;b++){let N=y.get(s.cells[b].document);if(N!==void 0){let L=s.cells.splice(b,1,N);if(f.push({old:L[0],new:N}),y.delete(N.document),y.size===0)break}}}if(w.textContent!==void 0)for(let y of w.textContent)r.changeTextDocument({textDocument:y.document,contentChanges:y.changes}),h.push(y.document.uri);}this.updateCellMap(s);let p={notebookDocument:s};o&&(p.metadata={old:a,new:s.metadata});let g=[];for(let w of l)g.push(this.getNotebookCell(w));let _=[];for(let w of u)_.push(this.getNotebookCell(w));let E=[];for(let w of h)E.push(this.getNotebookCell(w));(g.length>0||_.length>0||f.length>0||E.length>0)&&(p.cells={added:g,removed:_,changed:{data:f,textContent:E}}),(p.metadata!==void 0||p.cells!==void 0)&&this._onDidChange.fire(p);})),n.push(t.notebooks.synchronization.onDidSaveNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);s!==void 0&&this._onDidSave.fire(s);})),n.push(t.notebooks.synchronization.onDidCloseNotebookDocument(i=>{let s=this.notebookDocuments.get(i.notebookDocument.uri);if(s!==void 0){this._onDidClose.fire(s);for(let a of i.cellTextDocuments)r.closeTextDocument({textDocument:a});this.notebookDocuments.delete(i.notebookDocument.uri);for(let a of s.cells)this.notebookCellMap.delete(a.document);}})),Kn.Disposable.create(()=>{n.forEach(i=>i.dispose());})}updateCellMap(t){for(let r of t.cells)this.notebookCellMap.set(r.document,[r,t]);}};nu.NotebookDocuments=wS;});var b3=I(vp=>{Object.defineProperty(vp,"__esModule",{value:!0});vp.MonikerFeature=void 0;var mse=or(),yse=e=>class extends e{get moniker(){return {on:t=>{let r=mse.MonikerRequest.type;return this.connection.onRequest(r,(n,i)=>t(n,i,this.attachWorkDoneProgress(n),this.attachPartialResultProgress(r,n)))}}}};vp.MonikerFeature=yse;});var PS=I(wt=>{Object.defineProperty(wt,"__esModule",{value:!0});wt.createConnection=wt.combineFeatures=wt.combineNotebooksFeatures=wt.combineLanguagesFeatures=wt.combineWorkspaceFeatures=wt.combineWindowFeatures=wt.combineClientFeatures=wt.combineTracerFeatures=wt.combineTelemetryFeatures=wt.combineConsoleFeatures=wt._NotebooksImpl=wt._LanguagesImpl=wt.BulkUnregistration=wt.BulkRegistration=wt.ErrorMessageTracker=void 0;var we=or(),Gn=hh(),TS=hS(),Xe=s3(),vse=a3(),_se=o3(),bse=u3(),Sse=vS(),Ese=c3(),wse=l3(),Cse=f3(),xse=d3(),Tse=p3(),Ase=m3(),Rse=y3(),Ise=v3(),Pse=CS(),Nse=b3();function xS(e){if(e!==null)return e}var AS=class{constructor(){this._messages=Object.create(null);}add(t){let r=this._messages[t];r||(r=0),r++,this._messages[t]=r;}sendErrors(t){Object.keys(this._messages).forEach(r=>{t.window.showErrorMessage(r);});}};wt.ErrorMessageTracker=AS;var _p=class{constructor(){}rawAttach(t){this._rawConnection=t;}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}fillServerCapabilities(t){}initialize(t){}error(t){this.send(we.MessageType.Error,t);}warn(t){this.send(we.MessageType.Warning,t);}info(t){this.send(we.MessageType.Info,t);}log(t){this.send(we.MessageType.Log,t);}debug(t){this.send(we.MessageType.Debug,t);}send(t,r){this._rawConnection&&this._rawConnection.sendNotification(we.LogMessageNotification.type,{type:t,message:r}).catch(()=>{(0, we.RAL)().console.error("Sending log message failed");});}},RS=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}showErrorMessage(t,...r){let n={type:we.MessageType.Error,message:t,actions:r};return this.connection.sendRequest(we.ShowMessageRequest.type,n).then(xS)}showWarningMessage(t,...r){let n={type:we.MessageType.Warning,message:t,actions:r};return this.connection.sendRequest(we.ShowMessageRequest.type,n).then(xS)}showInformationMessage(t,...r){let n={type:we.MessageType.Info,message:t,actions:r};return this.connection.sendRequest(we.ShowMessageRequest.type,n).then(xS)}},S3=(0, Ese.ShowDocumentFeature)((0, Xe.ProgressFeature)(RS)),E3;(function(e){function t(){return new bp}e.create=t;})(E3||(wt.BulkRegistration=E3={}));var bp=class{constructor(){this._registrations=[],this._registered=new Set;}add(t,r){let n=Gn.string(t)?t:t.method;if(this._registered.has(n))throw new Error(`${n} is already added to this registration`);let i=TS.generateUuid();this._registrations.push({id:i,method:n,registerOptions:r||{}}),this._registered.add(n);}asRegistrationParams(){return {registrations:this._registrations}}},w3;(function(e){function t(){return new Jc(void 0,[])}e.create=t;})(w3||(wt.BulkUnregistration=w3={}));var Jc=class{constructor(t,r){this._connection=t,this._unregistrations=new Map,r.forEach(n=>{this._unregistrations.set(n.method,n);});}get isAttached(){return !!this._connection}attach(t){this._connection=t;}add(t){this._unregistrations.set(t.method,t);}dispose(){let t=[];for(let n of this._unregistrations.values())t.push(n);let r={unregisterations:t};this._connection.sendRequest(we.UnregistrationRequest.type,r).catch(()=>{this._connection.console.info("Bulk unregistration failed.");});}disposeSingle(t){let r=Gn.string(t)?t:t.method,n=this._unregistrations.get(r);if(!n)return !1;let i={unregisterations:[n]};return this._connection.sendRequest(we.UnregistrationRequest.type,i).then(()=>{this._unregistrations.delete(r);},s=>{this._connection.console.info(`Un-registering request handler for ${n.id} failed.`);}),!0}},Sp=class{attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}register(t,r,n){return t instanceof bp?this.registerMany(t):t instanceof Jc?this.registerSingle1(t,r,n):this.registerSingle2(t,r)}registerSingle1(t,r,n){let i=Gn.string(r)?r:r.method,s=TS.generateUuid(),a={registrations:[{id:s,method:i,registerOptions:n||{}}]};return t.isAttached||t.attach(this.connection),this.connection.sendRequest(we.RegistrationRequest.type,a).then(o=>(t.add({id:s,method:i}),t),o=>(this.connection.console.info(`Registering request handler for ${i} failed.`),Promise.reject(o)))}registerSingle2(t,r){let n=Gn.string(t)?t:t.method,i=TS.generateUuid(),s={registrations:[{id:i,method:n,registerOptions:r||{}}]};return this.connection.sendRequest(we.RegistrationRequest.type,s).then(a=>we.Disposable.create(()=>{this.unregisterSingle(i,n).catch(()=>{this.connection.console.info(`Un-registering capability with id ${i} failed.`);});}),a=>(this.connection.console.info(`Registering request handler for ${n} failed.`),Promise.reject(a)))}unregisterSingle(t,r){let n={unregisterations:[{id:t,method:r}]};return this.connection.sendRequest(we.UnregistrationRequest.type,n).catch(()=>{this.connection.console.info(`Un-registering request handler for ${t} failed.`);})}registerMany(t){let r=t.asRegistrationParams();return this.connection.sendRequest(we.RegistrationRequest.type,r).then(()=>new Jc(this._connection,r.registrations.map(n=>({id:n.id,method:n.method}))),n=>(this.connection.console.info("Bulk registration failed."),Promise.reject(n)))}},IS=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}applyEdit(t){function r(i){return i&&!!i.edit}let n=r(t)?t:{edit:t};return this.connection.sendRequest(we.ApplyWorkspaceEditRequest.type,n)}},C3=(0, wse.FileOperationsFeature)((0, _se.WorkspaceFoldersFeature)((0, vse.ConfigurationFeature)(IS))),Ep=class{constructor(){this._trace=we.Trace.Off;}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}set trace(t){this._trace=t;}log(t,r){this._trace!==we.Trace.Off&&this.connection.sendNotification(we.LogTraceNotification.type,{message:t,verbose:this._trace===we.Trace.Verbose?r:void 0}).catch(()=>{});}},wp=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}logEvent(t){this.connection.sendNotification(we.TelemetryEventNotification.type,t).catch(()=>{this.connection.console.log("Sending TelemetryEventNotification failed");});}},Cp=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}attachWorkDoneProgress(t){return (0, Xe.attachWorkDone)(this.connection,t)}attachPartialResultProgress(t,r){return (0, Xe.attachPartialResult)(this.connection,r)}};wt._LanguagesImpl=Cp;var x3=(0, Ase.FoldingRangeFeature)((0, Nse.MonikerFeature)((0, Ise.DiagnosticFeature)((0, Rse.InlayHintFeature)((0, Tse.InlineValueFeature)((0, xse.TypeHierarchyFeature)((0, Cse.LinkedEditingRangeFeature)((0, Sse.SemanticTokensFeature)((0, bse.CallHierarchyFeature)(Cp))))))))),xp=class{constructor(){}attach(t){this._connection=t;}get connection(){if(!this._connection)throw new Error("Remote is not attached to a connection yet.");return this._connection}initialize(t){}fillServerCapabilities(t){}attachWorkDoneProgress(t){return (0, Xe.attachWorkDone)(this.connection,t)}attachPartialResultProgress(t,r){return (0, Xe.attachPartialResult)(this.connection,r)}};wt._NotebooksImpl=xp;var T3=(0, Pse.NotebookSyncFeature)(xp);function A3(e,t){return function(r){return t(e(r))}}wt.combineConsoleFeatures=A3;function R3(e,t){return function(r){return t(e(r))}}wt.combineTelemetryFeatures=R3;function I3(e,t){return function(r){return t(e(r))}}wt.combineTracerFeatures=I3;function P3(e,t){return function(r){return t(e(r))}}wt.combineClientFeatures=P3;function N3(e,t){return function(r){return t(e(r))}}wt.combineWindowFeatures=N3;function D3(e,t){return function(r){return t(e(r))}}wt.combineWorkspaceFeatures=D3;function O3(e,t){return function(r){return t(e(r))}}wt.combineLanguagesFeatures=O3;function k3(e,t){return function(r){return t(e(r))}}wt.combineNotebooksFeatures=k3;function Dse(e,t){function r(i,s,a){return i&&s?a(i,s):i||s}return {__brand:"features",console:r(e.console,t.console,A3),tracer:r(e.tracer,t.tracer,I3),telemetry:r(e.telemetry,t.telemetry,R3),client:r(e.client,t.client,P3),window:r(e.window,t.window,N3),workspace:r(e.workspace,t.workspace,D3),languages:r(e.languages,t.languages,O3),notebooks:r(e.notebooks,t.notebooks,k3)}}wt.combineFeatures=Dse;function Ose(e,t,r){let n=r&&r.console?new(r.console(_p)):new _p,i=e(n);n.rawAttach(i);let s=r&&r.tracer?new(r.tracer(Ep)):new Ep,a=r&&r.telemetry?new(r.telemetry(wp)):new wp,o=r&&r.client?new(r.client(Sp)):new Sp,c=r&&r.window?new(r.window(S3)):new S3,l=r&&r.workspace?new(r.workspace(C3)):new C3,u=r&&r.languages?new(r.languages(x3)):new x3,f=r&&r.notebooks?new(r.notebooks(T3)):new T3,h=[n,s,a,o,c,l,u,f];function p(y){return y instanceof Promise?y:Gn.thenable(y)?new Promise((b,N)=>{y.then(L=>b(L),L=>N(L));}):Promise.resolve(y)}let g,_,E,w={listen:()=>i.listen(),sendRequest:(y,...b)=>i.sendRequest(Gn.string(y)?y:y.method,...b),onRequest:(y,b)=>i.onRequest(y,b),sendNotification:(y,b)=>{let N=Gn.string(y)?y:y.method;return i.sendNotification(N,b)},onNotification:(y,b)=>i.onNotification(y,b),onProgress:i.onProgress,sendProgress:i.sendProgress,onInitialize:y=>(_=y,{dispose:()=>{_=void 0;}}),onInitialized:y=>i.onNotification(we.InitializedNotification.type,y),onShutdown:y=>(g=y,{dispose:()=>{g=void 0;}}),onExit:y=>(E=y,{dispose:()=>{E=void 0;}}),get console(){return n},get telemetry(){return a},get tracer(){return s},get client(){return o},get window(){return c},get workspace(){return l},get languages(){return u},get notebooks(){return f},onDidChangeConfiguration:y=>i.onNotification(we.DidChangeConfigurationNotification.type,y),onDidChangeWatchedFiles:y=>i.onNotification(we.DidChangeWatchedFilesNotification.type,y),__textDocumentSync:void 0,onDidOpenTextDocument:y=>i.onNotification(we.DidOpenTextDocumentNotification.type,y),onDidChangeTextDocument:y=>i.onNotification(we.DidChangeTextDocumentNotification.type,y),onDidCloseTextDocument:y=>i.onNotification(we.DidCloseTextDocumentNotification.type,y),onWillSaveTextDocument:y=>i.onNotification(we.WillSaveTextDocumentNotification.type,y),onWillSaveTextDocumentWaitUntil:y=>i.onRequest(we.WillSaveTextDocumentWaitUntilRequest.type,y),onDidSaveTextDocument:y=>i.onNotification(we.DidSaveTextDocumentNotification.type,y),sendDiagnostics:y=>i.sendNotification(we.PublishDiagnosticsNotification.type,y),onHover:y=>i.onRequest(we.HoverRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),void 0)),onCompletion:y=>i.onRequest(we.CompletionRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onCompletionResolve:y=>i.onRequest(we.CompletionResolveRequest.type,y),onSignatureHelp:y=>i.onRequest(we.SignatureHelpRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),void 0)),onDeclaration:y=>i.onRequest(we.DeclarationRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onDefinition:y=>i.onRequest(we.DefinitionRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onTypeDefinition:y=>i.onRequest(we.TypeDefinitionRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onImplementation:y=>i.onRequest(we.ImplementationRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onReferences:y=>i.onRequest(we.ReferencesRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onDocumentHighlight:y=>i.onRequest(we.DocumentHighlightRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onDocumentSymbol:y=>i.onRequest(we.DocumentSymbolRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onWorkspaceSymbol:y=>i.onRequest(we.WorkspaceSymbolRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onWorkspaceSymbolResolve:y=>i.onRequest(we.WorkspaceSymbolResolveRequest.type,y),onCodeAction:y=>i.onRequest(we.CodeActionRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onCodeActionResolve:y=>i.onRequest(we.CodeActionResolveRequest.type,(b,N)=>y(b,N)),onCodeLens:y=>i.onRequest(we.CodeLensRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onCodeLensResolve:y=>i.onRequest(we.CodeLensResolveRequest.type,(b,N)=>y(b,N)),onDocumentFormatting:y=>i.onRequest(we.DocumentFormattingRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),void 0)),onDocumentRangeFormatting:y=>i.onRequest(we.DocumentRangeFormattingRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),void 0)),onDocumentOnTypeFormatting:y=>i.onRequest(we.DocumentOnTypeFormattingRequest.type,(b,N)=>y(b,N)),onRenameRequest:y=>i.onRequest(we.RenameRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),void 0)),onPrepareRename:y=>i.onRequest(we.PrepareRenameRequest.type,(b,N)=>y(b,N)),onDocumentLinks:y=>i.onRequest(we.DocumentLinkRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onDocumentLinkResolve:y=>i.onRequest(we.DocumentLinkResolveRequest.type,(b,N)=>y(b,N)),onDocumentColor:y=>i.onRequest(we.DocumentColorRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onColorPresentation:y=>i.onRequest(we.ColorPresentationRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onFoldingRanges:y=>i.onRequest(we.FoldingRangeRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onSelectionRanges:y=>i.onRequest(we.SelectionRangeRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),(0, Xe.attachPartialResult)(i,b))),onExecuteCommand:y=>i.onRequest(we.ExecuteCommandRequest.type,(b,N)=>y(b,N,(0, Xe.attachWorkDone)(i,b),void 0)),dispose:()=>i.dispose()};for(let y of h)y.attach(w);return i.onRequest(we.InitializeRequest.type,y=>{t.initialize(y),Gn.string(y.trace)&&(s.trace=we.Trace.fromString(y.trace));for(let b of h)b.initialize(y.capabilities);if(_){let b=_(y,new we.CancellationTokenSource().token,(0, Xe.attachWorkDone)(i,y),void 0);return p(b).then(N=>{if(N instanceof we.ResponseError)return N;let L=N;L||(L={capabilities:{}});let V=L.capabilities;V||(V={},L.capabilities=V),V.textDocumentSync===void 0||V.textDocumentSync===null?V.textDocumentSync=Gn.number(w.__textDocumentSync)?w.__textDocumentSync:we.TextDocumentSyncKind.None:!Gn.number(V.textDocumentSync)&&!Gn.number(V.textDocumentSync.change)&&(V.textDocumentSync.change=Gn.number(w.__textDocumentSync)?w.__textDocumentSync:we.TextDocumentSyncKind.None);for(let Z of h)Z.fillServerCapabilities(V);return L})}else {let b={capabilities:{textDocumentSync:we.TextDocumentSyncKind.None}};for(let N of h)N.fillServerCapabilities(b.capabilities);return b}}),i.onRequest(we.ShutdownRequest.type,()=>{if(t.shutdownReceived=!0,g)return g(new we.CancellationTokenSource().token)}),i.onNotification(we.ExitNotification.type,()=>{try{E&&E();}finally{t.shutdownReceived?t.exit(0):t.exit(1);}}),i.onNotification(we.SetTraceNotification.type,y=>{s.trace=we.Trace.fromString(y.value);}),w}wt.createConnection=Ose;});var L3=I(gn=>{Object.defineProperty(gn,"__esModule",{value:!0});gn.resolveModulePath=gn.FileSystem=gn.resolveGlobalYarnPath=gn.resolveGlobalNodePath=gn.resolve=gn.uriToFilePath=void 0;var kse=he("url"),li=he("path"),NS=he("fs"),LS=he("child_process");function Lse(e){let t=kse.parse(e);if(t.protocol!=="file:"||!t.path)return;let r=t.path.split("/");for(var n=0,i=r.length;n<i;n++)r[n]=decodeURIComponent(r[n]);if(process.platform==="win32"&&r.length>1){let s=r[0],a=r[1];s.length===0&&a.length>1&&a[1]===":"&&r.shift();}return li.normalize(r.join("/"))}gn.uriToFilePath=Lse;function DS(){return process.platform==="win32"}function Tp(e,t,r,n){let i="NODE_PATH",s=["var p = process;","p.on('message',function(m){","if(m.c==='e'){","p.exit(0);","}","else if(m.c==='rs'){","try{","var r=require.resolve(m.a);","p.send({c:'r',s:true,r:r});","}","catch(err){","p.send({c:'r',s:false});","}","}","});"].join("");return new Promise((a,o)=>{let c=process.env,l=Object.create(null);Object.keys(c).forEach(u=>l[u]=c[u]),t&&NS.existsSync(t)&&(l[i]?l[i]=t+li.delimiter+l[i]:l[i]=t,n&&n(`NODE_PATH value is: ${l[i]}`)),l.ELECTRON_RUN_AS_NODE="1";try{let u=(0, LS.fork)("",[],{cwd:r,env:l,execArgv:["-e",s]});if(u.pid===void 0){o(new Error(`Starting process to resolve node module  ${e} failed`));return}u.on("error",h=>{o(h);}),u.on("message",h=>{h.c==="r"&&(u.send({c:"e"}),h.s?a(h.r):o(new Error(`Failed to resolve module: ${e}`)));});let f={c:"rs",a:e};u.send(f);}catch(u){o(u);}})}gn.resolve=Tp;function OS(e){let t="npm",r=Object.create(null);Object.keys(process.env).forEach(s=>r[s]=process.env[s]),r.NO_UPDATE_NOTIFIER="true";let n={encoding:"utf8",env:r};DS()&&(t="npm.cmd",n.shell=!0);let i=()=>{};try{process.on("SIGPIPE",i);let s=(0, LS.spawnSync)(t,["config","get","prefix"],n).stdout;if(!s){e&&e("'npm config get prefix' didn't return a value.");return}let a=s.trim();return e&&e(`'npm config get prefix' value is: ${a}`),a.length>0?DS()?li.join(a,"node_modules"):li.join(a,"lib","node_modules"):void 0}catch{return}finally{process.removeListener("SIGPIPE",i);}}gn.resolveGlobalNodePath=OS;function Bse(e){let t="yarn",r={encoding:"utf8"};DS()&&(t="yarn.cmd",r.shell=!0);let n=()=>{};try{process.on("SIGPIPE",n);let i=(0, LS.spawnSync)(t,["global","dir","--json"],r),s=i.stdout;if(!s){e&&(e("'yarn global dir' didn't return a value."),i.stderr&&e(i.stderr));return}let a=s.trim().split(/\r?\n/);for(let o of a)try{let c=JSON.parse(o);if(c.type==="log")return li.join(c.data,"node_modules")}catch{}return}catch{return}finally{process.removeListener("SIGPIPE",n);}}gn.resolveGlobalYarnPath=Bse;var kS;(function(e){let t;function r(){return t!==void 0||(process.platform==="win32"?t=!1:t=!NS.existsSync(__filename.toUpperCase())||!NS.existsSync(__filename.toLowerCase())),t}e.isCaseSensitive=r;function n(i,s){return r()?li.normalize(s).indexOf(li.normalize(i))===0:li.normalize(s).toLowerCase().indexOf(li.normalize(i).toLowerCase())===0}e.isParent=n;})(kS||(gn.FileSystem=kS={}));function Fse(e,t,r,n){return r?(li.isAbsolute(r)||(r=li.join(e,r)),Tp(t,r,r,n).then(i=>kS.isParent(r,i)?i:Promise.reject(new Error(`Failed to load ${t} from node path location.`))).then(void 0,i=>Tp(t,OS(n),e,n))):Tp(t,OS(n),e,n)}gn.resolveModulePath=Fse;});var BS=I((vme,B3)=>{B3.exports=or();});var F3=I(Ap=>{Object.defineProperty(Ap,"__esModule",{value:!0});Ap.InlineCompletionFeature=void 0;var qse=or(),Mse=e=>class extends e{get inlineCompletion(){return {on:t=>this.connection.onRequest(qse.InlineCompletionRequest.type,(r,n)=>t(r,n,this.attachWorkDoneProgress(r)))}}};Ap.InlineCompletionFeature=Mse;});var U3=I(Ur=>{var Use=Ur&&Ur.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),M3=Ur&&Ur.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Use(t,e,r);};Object.defineProperty(Ur,"__esModule",{value:!0});Ur.ProposedFeatures=Ur.NotebookDocuments=Ur.TextDocuments=Ur.SemanticTokensBuilder=void 0;var $se=vS();Object.defineProperty(Ur,"SemanticTokensBuilder",{enumerable:!0,get:function(){return $se.SemanticTokensBuilder}});var jse=F3();M3(or(),Ur);var Vse=ES();Object.defineProperty(Ur,"TextDocuments",{enumerable:!0,get:function(){return Vse.TextDocuments}});var Hse=CS();Object.defineProperty(Ur,"NotebookDocuments",{enumerable:!0,get:function(){return Hse.NotebookDocuments}});M3(PS(),Ur);var q3;(function(e){e.all={__brand:"features",languages:jse.InlineCompletionFeature};})(q3||(Ur.ProposedFeatures=q3={}));});var K3=I(zn=>{var Wse=zn&&zn.__createBinding||(Object.create?function(e,t,r,n){n===void 0&&(n=r);var i=Object.getOwnPropertyDescriptor(t,r);(!i||("get"in i?!t.__esModule:i.writable||i.configurable))&&(i={enumerable:!0,get:function(){return t[r]}}),Object.defineProperty(e,n,i);}:function(e,t,r,n){n===void 0&&(n=r),e[n]=t[r];}),H3=zn&&zn.__exportStar||function(e,t){for(var r in e)r!=="default"&&!Object.prototype.hasOwnProperty.call(t,r)&&Wse(t,e,r);};Object.defineProperty(zn,"__esModule",{value:!0});zn.createConnection=zn.Files=void 0;var $3=he("util"),qS=hh(),Kse=PS(),el=L3(),La=BS();H3(BS(),zn);H3(U3(),zn);var j3;(function(e){e.uriToFilePath=el.uriToFilePath,e.resolveGlobalNodePath=el.resolveGlobalNodePath,e.resolveGlobalYarnPath=el.resolveGlobalYarnPath,e.resolve=el.resolve,e.resolveModulePath=el.resolveModulePath;})(j3||(zn.Files=j3={}));var iu=!1,W3;function Gse(){let e="--clientProcessId";function t(r){try{let n=parseInt(r);isNaN(n)||(W3=setInterval(()=>{try{process.kill(n,0);}catch{process.exit(iu?0:1);}},3e3));}catch{}}for(let r=2;r<process.argv.length;r++){let n=process.argv[r];if(n===e&&r+1<process.argv.length){t(process.argv[r+1]);return}else {let i=n.split("=");i[0]===e&&t(i[1]);}}}Gse();var zse={initialize:e=>{let t=e.processId;qS.number(t)&&W3===void 0&&setInterval(()=>{try{process.kill(t,0);}catch{process.exit(iu?0:1);}},3e3);},get shutdownReceived(){return iu},set shutdownReceived(e){iu=e;},exit:e=>{process.exit(e);}};function Yse(e,t,r,n){let i,s,a,o;return e!==void 0&&e.__brand==="features"&&(i=e,e=t,t=r,r=n),La.ConnectionStrategy.is(e)||La.ConnectionOptions.is(e)?o=e:(s=e,a=t,o=r),Qse(s,a,o,i)}zn.createConnection=Yse;function Qse(e,t,r,n){let i=!1;if(!e&&!t&&process.argv.length>2){let c,l,u=process.argv.slice(2);for(let f=0;f<u.length;f++){let h=u[f];if(h==="--node-ipc"){e=new La.IPCMessageReader(process),t=new La.IPCMessageWriter(process);break}else if(h==="--stdio"){i=!0,e=process.stdin,t=process.stdout;break}else if(h==="--socket"){c=parseInt(u[f+1]);break}else if(h==="--pipe"){l=u[f+1];break}else {var s=h.split("=");if(s[0]==="--socket"){c=parseInt(s[1]);break}else if(s[0]==="--pipe"){l=s[1];break}}}if(c){let f=(0, La.createServerSocketTransport)(c);e=f[0],t=f[1];}else if(l){let f=(0, La.createServerPipeTransport)(l);e=f[0],t=f[1];}}var a="Use arguments of createConnection or set command line parameters: '--node-ipc', '--stdio' or '--socket={number}'";if(!e)throw new Error("Connection input stream is not set. "+a);if(!t)throw new Error("Connection output stream is not set. "+a);if(qS.func(e.read)&&qS.func(e.on)){let c=e;c.on("end",()=>{process.exit(iu?0:1);}),c.on("close",()=>{process.exit(iu?0:1);});}let o=c=>{let l=(0, La.createProtocolConnection)(e,t,c,r);return i&&Xse(c),l};return (0, Kse.createConnection)(o,zse,n)}function Xse(e){function t(n){return n.map(i=>typeof i=="string"?i:(0, $3.inspect)(i)).join(" ")}let r=new Map;console.assert=function(i,...s){if(!i)if(s.length===0)e.error("Assertion failed");else {let[a,...o]=s;e.error(`Assertion failed: ${a} ${t(o)}`);}},console.count=function(i="default"){let s=String(i),a=r.get(s)??0;a+=1,r.set(s,a),e.log(`${s}: ${s}`);},console.countReset=function(i){i===void 0?r.clear():r.delete(String(i));},console.debug=function(...i){e.log(t(i));},console.dir=function(i,s){e.log((0, $3.inspect)(i,s));},console.log=function(...i){e.log(t(i));},console.error=function(...i){e.error(t(i));},console.trace=function(...i){let s=new Error().stack.replace(/(.+\n){2}/,""),a="Trace";i.length!==0&&(a+=`: ${t(i)}`),e.log(`${a}
${s}`);},console.warn=function(...i){e.warn(t(i));};}});var z3=I((wme,G3)=>{G3.exports=K3();});var ll=new Uint8Array(256),cl=ll.length;function $p(){return cl>ll.length-16&&(jU__default.default.randomFillSync(ll),cl=0),ll.slice(cl,cl+=16)}var Rr=[];for(let e=0;e<256;++e)Rr.push((e+256).toString(16).slice(1));function bE(e,t=0){return Rr[e[t+0]]+Rr[e[t+1]]+Rr[e[t+2]]+Rr[e[t+3]]+"-"+Rr[e[t+4]]+Rr[e[t+5]]+"-"+Rr[e[t+6]]+Rr[e[t+7]]+"-"+Rr[e[t+8]]+Rr[e[t+9]]+"-"+Rr[e[t+10]]+Rr[e[t+11]]+Rr[e[t+12]]+Rr[e[t+13]]+Rr[e[t+14]]+Rr[e[t+15]]}var jp={randomUUID:jU__default.default.randomUUID};function HU(e,t,r){if(jp.randomUUID&&!t&&!e)return jp.randomUUID();e=e||{};let n=e.random||(e.rng||$p)();if(n[6]=n[6]&15|64,n[8]=n[8]&63|128,t){r=r||0;for(let i=0;i<16;++i)t[r+i]=n[i];return t}return bE(n)}var fi=HU;var Aa=ur(Su());var cs={defaultMerge:Symbol("deepmerge-ts: default merge"),skip:Symbol("deepmerge-ts: skip")};function T$(e,t){return t}function yx(e){return typeof e!="object"||e===null?0:Array.isArray(e)?2:I$(e)?1:e instanceof Set?3:e instanceof Map?4:5}function A$(e){let t=new Set;for(let r of e)for(let n of [...Object.keys(r),...Object.getOwnPropertySymbols(r)])t.add(n);return t}function R$(e,t){return typeof e=="object"&&Object.prototype.propertyIsEnumerable.call(e,t)}function _x(e){return {*[Symbol.iterator](){for(let t of e)for(let r of t)yield r;}}}var vx=new Set(["[object Object]","[object Module]"]);function I$(e){if(!vx.has(Object.prototype.toString.call(e)))return !1;let{constructor:t}=e;if(t===void 0)return !0;let r=t.prototype;return !(r===null||typeof r!="object"||!vx.has(Object.prototype.toString.call(r))||!r.hasOwnProperty("isPrototypeOf"))}function P$(e,t,r){let n={};for(let i of A$(e)){let s=[];for(let c of e)R$(c,i)&&s.push(c[i]);if(s.length===0)continue;let a=t.metaDataUpdater(r,{key:i,parents:e}),o=Sx(s,t,a);o!==cs.skip&&(i==="__proto__"?Object.defineProperty(n,i,{value:o,configurable:!0,enumerable:!0,writable:!0}):n[i]=o);}return n}function N$(e){return e.flat()}function D$(e){return new Set(_x(e))}function O$(e){return new Map(_x(e))}function bx(e){return e.at(-1)}var Wg=Object.freeze({__proto__:null,mergeArrays:N$,mergeMaps:O$,mergeOthers:bx,mergeRecords:P$,mergeSets:D$});function Wl(...e){return k$({})(...e)}function k$(e,t){let r=L$(e,n);function n(...i){return Sx(i,r,t)}return n}function L$(e,t){return {defaultMergeFunctions:Wg,mergeFunctions:{...Wg,...Object.fromEntries(Object.entries(e).filter(([r,n])=>Object.hasOwn(Wg,r)).map(([r,n])=>n===!1?[r,bx]:[r,n]))},metaDataUpdater:e.metaDataUpdater??T$,deepmerge:t,useImplicitDefaultMerging:e.enableImplicitDefaultMerging??!1,actions:cs}}function Sx(e,t,r){if(e.length===0)return;if(e.length===1)return Kg(e,t,r);let n=yx(e[0]);if(n!==0&&n!==5){for(let i=1;i<e.length;i++)if(yx(e[i])!==n)return Kg(e,t,r)}switch(n){case 1:return B$(e,t,r);case 2:return F$(e,t,r);case 3:return q$(e,t,r);case 4:return M$(e,t,r);default:return Kg(e,t,r)}}function B$(e,t,r){let n=t.mergeFunctions.mergeRecords(e,t,r);return n===cs.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeRecords!==t.defaultMergeFunctions.mergeRecords?t.defaultMergeFunctions.mergeRecords(e,t,r):n}function F$(e,t,r){let n=t.mergeFunctions.mergeArrays(e,t,r);return n===cs.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeArrays!==t.defaultMergeFunctions.mergeArrays?t.defaultMergeFunctions.mergeArrays(e):n}function q$(e,t,r){let n=t.mergeFunctions.mergeSets(e,t,r);return n===cs.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeSets!==t.defaultMergeFunctions.mergeSets?t.defaultMergeFunctions.mergeSets(e):n}function M$(e,t,r){let n=t.mergeFunctions.mergeMaps(e,t,r);return n===cs.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeMaps!==t.defaultMergeFunctions.mergeMaps?t.defaultMergeFunctions.mergeMaps(e):n}function Kg(e,t,r){let n=t.mergeFunctions.mergeOthers(e,t,r);return n===cs.defaultMerge||t.useImplicitDefaultMerging&&n===void 0&&t.mergeFunctions.mergeOthers!==t.defaultMergeFunctions.mergeOthers?t.defaultMergeFunctions.mergeOthers(e):n}var Eu=e=>{let t=typeof e;return e!==null&&(t==="object"||t==="function")};var Gg=new Set(["__proto__","prototype","constructor"]),U$=new Set("0123456789");function zg(e){let t=[],r="",n="start",i=!1;for(let s of e)switch(s){case"\\":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd")throw new Error("Invalid character after an index");i&&(r+=s),n="property",i=!i;break}case".":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd"){n="property";break}if(i){i=!1,r+=s;break}if(Gg.has(r))return [];t.push(r),r="",n="property";break}case"[":{if(n==="index")throw new Error("Invalid character in an index");if(n==="indexEnd"){n="index";break}if(i){i=!1,r+=s;break}if(n==="property"){if(Gg.has(r))return [];t.push(r),r="";}n="index";break}case"]":{if(n==="index"){t.push(Number.parseInt(r,10)),r="",n="indexEnd";break}if(n==="indexEnd")throw new Error("Invalid character after an index")}default:{if(n==="index"&&!U$.has(s))throw new Error("Invalid character in an index");if(n==="indexEnd")throw new Error("Invalid character after an index");n==="start"&&(n="property"),i&&(i=!1,r+="\\"),r+=s;}}switch(i&&(r+="\\"),n){case"property":{if(Gg.has(r))return [];t.push(r);break}case"index":throw new Error("Index was not closed");case"start":{t.push("");break}}return t}function Ex(e,t){if(typeof t!="number"&&Array.isArray(e)){let r=Number.parseInt(t,10);return Number.isInteger(r)&&e[r]===e[t]}return !1}function wx(e,t){if(Ex(e,t))throw new Error("Cannot use string index")}function Kl(e,t,r){if(!Eu(e)||typeof t!="string")return r===void 0?e:r;let n=zg(t);if(n.length===0)return r;for(let i=0;i<n.length;i++){let s=n[i];if(Ex(e,s)?e=i===n.length-1?void 0:null:e=e[s],e==null){if(i!==n.length-1)return r;break}}return e===void 0?r:e}function Xs(e,t,r){if(!Eu(e)||typeof t!="string")return e;let n=e,i=zg(t);for(let s=0;s<i.length;s++){let a=i[s];wx(e,a),s===i.length-1?e[a]=r:Eu(e[a])||(e[a]=typeof i[s+1]=="number"?[]:{}),e=e[a];}return n}function Gl(e,t){if(!Eu(e)||typeof t!="string")return !1;let r=zg(t);for(let n=0;n<r.length;n++){let i=r[n];if(wx(e,i),n===r.length-1)return delete e[i],!0;if(e=e[i],!Eu(e))return !1}}var $$={"Content-Type":"application/json"};function Zs(e={}){let{fetch:t=globalThis.fetch,querySerializer:r,bodySerializer:n,...i}=e,s=i.baseUrl??"";s.endsWith("/")&&(s=s.slice(0,-1));async function a(o,c){let{fetch:l=t,headers:u,body:f,params:h={},parseAs:p="json",querySerializer:g=r??j$,bodySerializer:_=n??V$,...E}=c||{},w=H$(o,{baseUrl:s,params:h,querySerializer:g}),y=W$($$,e?.headers,u,h.header),b={redirect:"follow",...i,...E,headers:y};f&&(b.body=_(f)),b.body instanceof FormData&&y.delete("Content-Type");let N=await l(w,b);if(N.status===204||N.headers.get("Content-Length")==="0")return N.ok?{data:{},response:N}:{error:{},response:N};if(N.ok){let V;if(p!=="stream"){let Z=N.clone();V=typeof Z[p]=="function"?await Z[p]():await Z.text();}else V=N.clone().body;return {data:V,response:N}}let L={};try{L=await N.clone().json();}catch{L=await N.clone().text();}return {error:L,response:N}}return {async GET(o,...c){return a(o,{...c[0],method:"GET"})},async PUT(o,...c){return a(o,{...c[0],method:"PUT"})},async POST(o,...c){return a(o,{...c[0],method:"POST"})},async DELETE(o,...c){return a(o,{...c[0],method:"DELETE"})},async OPTIONS(o,...c){return a(o,{...c[0],method:"OPTIONS"})},async HEAD(o,...c){return a(o,{...c[0],method:"HEAD"})},async PATCH(o,...c){return a(o,{...c[0],method:"PATCH"})},async TRACE(o,...c){return a(o,{...c[0],method:"TRACE"})}}}function j$(e){let t=new URLSearchParams;if(e&&typeof e=="object")for(let[r,n]of Object.entries(e))n!=null&&t.set(r,n);return t.toString()}function V$(e){return JSON.stringify(e)}function H$(e,t){let r=`${t.baseUrl}${e}`;if(t.params.path)for(let[i,s]of Object.entries(t.params.path))r=r.replace(`{${i}}`,encodeURIComponent(String(s)));let n=t.querySerializer(t.params.query??{});return n&&(r+=`?${n}`),r}function W$(...e){let t=new Headers;for(let r of e){if(!r||typeof r!="object")continue;let n=r instanceof Headers?r.entries():Object.entries(r);for(let[i,s]of n)s===null?t.delete(i):s!==void 0&&t.set(i,s);}return t}var fh=ur(SA());var R0=ur(mf()),hP=ur(Su()),pP=ur(A0());var I0=class extends events.EventEmitter{constructor(r){super();this.filepath=r;this.data={};}async load(){this.data=await R0.default.readJson(P0,{throws:!1})||{};}async save(){await R0.default.outputJson(P0,this.data);}watch(){this.watcher=pP.default.watch(this.filepath,{interval:1e3});let r=async()=>{let n=this.data;await this.load(),(0, hP.default)(n,this.data)||super.emit("updated",this.data);};this.watcher.on("add",r),this.watcher.on("change",r);}},P0=F___default.default.join(PO__default.default.homedir(),".tabby-client","agent","data.json"),N0=new I0(P0);var bP=ur(vP());function Mt(e){let t=e.match(/.*(?:$|\r?\n)/g)?.filter(Boolean)??[];return t.length>0&&t[t.length-1]?.endsWith(`
`)&&t.push(""),t}function st(e){return e.trim().length===0}function mi(e,t){if(t===void 0)return e.match(/^[ \t]*/)?.[0]?.length??0;if(t==="	")return e.match(/^\t*/)?.[0].length??0;if(t.match(/^ *$/))return (e.match(/^ */)?.[0].length??0)/t.length;throw new Error(`Invalid indentation: ${t}`)}function O0(e,t){return t<0||t>=e.length-1?!1:mi(e[t])<mi(e[t+1])}function Bf(e,t){return t<=0||t>e.length-1?!1:mi(e[t-1])>mi(e[t])}var k0=[{open:{chars:"(",reg:/\(/},close:{chars:")",reg:/\)/}},{open:{chars:"[",reg:/\[/},close:{chars:"]",reg:/\]/}},{open:{chars:"{",reg:/\{/},close:{chars:"}",reg:/\}/}},{open:{chars:"<",reg:/<(?=\w)/},close:{chars:"/>",reg:/\/>/}},{open:{chars:"<",reg:/<(?=[/\w])/},close:{chars:">",reg:/>/}},{openOrClose:{chars:'"',reg:/"/}},{openOrClose:{chars:"'",reg:/'/}},{openOrClose:{chars:"`",reg:/`/}}],_P=/^([)\]}>"'`]|(\/>))*$/g;function Ff(e){let t=[],r=0;for(;r<e.length;){let n=e.slice(r),i={index:n.length,found:void 0};if(k0.forEach(s=>{Object.entries(s).forEach(([a,o])=>{let c=n.match(o.reg);c&&c.index!==void 0&&c.index<i.index&&(i={index:c.index,found:{pair:s,pos:a,pattern:o}});});}),!i.found)break;switch(i.found.pos){case"openOrClose":{let s=i.found.pattern.chars;t.length>0&&t.includes(s)?t.splice(t.lastIndexOf(s),t.length-t.lastIndexOf(s)):t.push(s);break}case"open":{t.push(i.found.pattern.chars);break}case"close":{let s=i.found.pair;t.length>0&&"open"in s&&t[t.length-1]===s.open.chars?t.pop():t.push(i.found.pattern.chars);break}}r+=i.index+i.found.pattern.chars.length;}return t}function fo(e,t){return bP.get(e,t)}function Xu(e){let t=new AbortController;for(let r of e){if(r?.aborted)return t.abort(r.reason),r;r?.addEventListener("abort",()=>t.abort(r.reason),{signal:t.signal});}return t.signal}var vr=class extends Error{constructor(r){super(`${r.status} ${r.statusText}`);this.name="HttpError",this.status=r.status,this.statusText=r.statusText,this.response=r;}};function Zu(e){return e instanceof Error&&e.name==="TimeoutError"||e instanceof vr&&[408,499].includes(e.status)}function Vi(e){return e instanceof Error&&e.name==="AbortError"}function L0(e){let t=e.message||e.toString();return e.cause&&(t+=`
Caused by: `+L0(e.cause)),t}function B0(e){this.message=e;}B0.prototype=new Error,B0.prototype.name="InvalidCharacterError";var SP=typeof window<"u"&&window.atob&&window.atob.bind(window)||function(e){var t=String(e).replace(/=+$/,"");if(t.length%4==1)throw new B0("'atob' failed: The string to be decoded is not correctly encoded.");for(var r,n,i=0,s=0,a="";n=t.charAt(s++);~n&&(r=i%4?64*r+n:n,i++%4)?a+=String.fromCharCode(255&r>>(-2*i&6)):0)n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=".indexOf(n);return a};function iz(e){var t=e.replace(/-/g,"+").replace(/_/g,"/");switch(t.length%4){case 0:break;case 2:t+="==";break;case 3:t+="=";break;default:throw "Illegal base64url string!"}try{return function(r){return decodeURIComponent(SP(r).replace(/(.)/g,function(n,i){var s=i.charCodeAt(0).toString(16).toUpperCase();return s.length<2&&(s="0"+s),"%"+s}))}(t)}catch{return SP(t)}}function qf(e){this.message=e;}function sz(e,t){if(typeof e!="string")throw new qf("Invalid token specified");var r=(t=t||{}).header===!0?0:1;try{return JSON.parse(iz(e.split(".")[r]))}catch(n){throw new qf("Invalid token specified: "+n.message)}}qf.prototype=new Error,qf.prototype.name="InvalidTokenError";var Mf=sz;var jD=ur(Su());var od=ur(ID()),UD=ur(FD());var $y=class{constructor(){this.streamOptions={filename:F___default.default.join(PO__default.default.homedir(),".tabby-client","agent","logs","%DATE%"),frequency:"daily",size:"10M",max_logs:"30d",extension:".log",create_symlink:!0};}write(t){this.stream||(this.stream=UD.getStream(this.streamOptions)),this.stream.write(t);}},qD=new $y,MD={serializers:{error:od.default.stdSerializers.err}},ic=qD?(0, od.default)(MD,qD):(0, od.default)(MD);ic.level="silent";var ac=[ic];ic.onChild=e=>{ac.push(e);};function ZZ(e){return (...t)=>{let r=t.shift();if(typeof r=="string")e(r,...t);else {let n=t.shift();typeof n=="string"?e(n,...t,r):e(r,n,...t);}}}function JZ(e,t){return (r,...n)=>{e(`[${t}] ${r??""}`,...n);}}var jy={loggers:[],child(e){let t=r=>ZZ(JZ((...i)=>{let s=i.shift();this.loggers.forEach(a=>a[r](s,...i));},e));return {error:t("error"),warn:t("warn"),info:t("info"),debug:t("debug"),trace:t("trace")}}};function _r(e){let t=ic.child({component:e}),r=jy.child(e),n=[t,r],i=s=>(...a)=>{let o=a.shift();n.forEach(c=>c[s](o,...a));};return {error:i("error"),warn:i("warn"),info:i("info"),debug:i("debug"),trace:i("trace")}}var Vy=class extends Error{constructor(r){super();this.cause=r;this.name="RetryLimitReachedError";}},ud=class e extends events.EventEmitter{constructor(r){super();this.endpoint=r;this.logger=_r("Auth");this.authApi=Zs({baseUrl:"https://app.tabbyml.com/api"});}static{this.authPageUrl="https://app.tabbyml.com/account/device-token";}static{this.tokenStrategy={polling:{interval:5e3,timeout:5*60*1e3},refresh:{interval:15*60*1e3,beforeExpire:30*60*1e3,whenLoaded:{maxTry:5,retryDelay:1e3},whenScheduled:{maxTry:60,retryDelay:30*1e3}}};}async init(r){this.dataStore=r?.dataStore,this.dataStore instanceof events.EventEmitter&&this.dataStore.on("updated",async()=>{let n=this.jwt;await this.load(),(0, jD.default)(n,this.jwt)||super.emit("updated",this.jwt);}),this.scheduleRefreshToken(),await this.load();}get token(){return this.jwt?.token}get user(){return this.jwt?.payload.email}async load(){if(this.dataStore)try{await this.dataStore.load();let r=this.dataStore.data.auth?.[this.endpoint]?.jwt;if(typeof r=="string"&&this.jwt?.token!==r){this.logger.debug({storedJwt:r},"Load jwt from data store.");let n={token:r,payload:Mf(r)};n.payload.exp*1e3-Date.now()<e.tokenStrategy.refresh.beforeExpire?(this.jwt=await this.refreshToken(n,e.tokenStrategy.refresh.whenLoaded),await this.save()):this.jwt=n;}}catch(r){this.logger.debug({error:r},"Error when loading auth");}}async save(){if(this.dataStore)try{if(this.jwt){if(this.dataStore.data.auth?.[this.endpoint]?.jwt===this.jwt.token)return;this.dataStore.data.auth={...this.dataStore.data.auth,[this.endpoint]:{jwt:this.jwt.token}};}else {if(typeof this.dataStore.data.auth?.[this.endpoint]>"u")return;delete this.dataStore.data.auth[this.endpoint];}await this.dataStore.save(),this.logger.debug("Save changes to data store.");}catch(r){this.logger.error({error:r},"Error when saving auth");}}async reset(){this.jwt&&(this.jwt=void 0,await this.save());}async requestAuthUrl(r){try{if(await this.reset(),r?.signal.aborted)throw r.signal.reason;this.logger.debug("Start to request device token");let n=await this.authApi.POST("/device-token",{body:{auth_url:this.endpoint},signal:r?.signal});if(n.error||!n.response.ok)throw new vr(n.response);let i=n.data;this.logger.debug({deviceToken:i},"Request device token response");let s=new URL(e.authPageUrl);return s.searchParams.append("code",i.data.code),{authUrl:s.toString(),code:i.data.code}}catch(n){throw this.logger.error({error:n},"Error when requesting token"),n}}async pollingToken(r,n){return new Promise((i,s)=>{let a=Xu([AbortSignal.timeout(e.tokenStrategy.polling.timeout),n?.signal]),o=setInterval(async()=>{try{let c=await this.authApi.POST("/device-token/accept",{params:{query:{code:r}},signal:a});if(c.error||!c.response.ok)throw new vr(c.response);let l=c.data;this.logger.debug({result:l},"Poll jwt response"),this.jwt={token:l.data.jwt,payload:Mf(l.data.jwt)},super.emit("updated",this.jwt),await this.save(),clearInterval(o),i(!0);}catch(c){c instanceof vr&&[400,401,403,405].includes(c.status)?this.logger.debug({error:c},"Expected error when polling jwt"):this.logger.error({error:c},"Error when polling jwt");}},e.tokenStrategy.polling.interval);a.aborted?(clearInterval(o),s(a.reason)):a.addEventListener("abort",()=>{clearInterval(o),s(a.reason);});})}async refreshToken(r,n={maxTry:1,retryDelay:1e3},i=0){try{this.logger.debug({retry:i},"Start to refresh token");let s=await this.authApi.POST("/device-token/refresh",{headers:{Authorization:`Bearer ${r.token}`}});if(s.error||!s.response.ok)throw new vr(s.response);let a=s.data;return this.logger.debug({refreshedJwt:a},"Refresh token response"),{token:a.data.jwt,payload:Mf(a.data.jwt)}}catch(s){if(s instanceof vr&&[400,401,403,405].includes(s.status))this.logger.debug({error:s},"Error when refreshing jwt");else if(this.logger.error({error:s},"Unknown error when refreshing jwt"),i<n.maxTry)return this.logger.debug(`Retry refreshing jwt after ${n.retryDelay}ms`),await new Promise(a=>setTimeout(a,n.retryDelay)),this.refreshToken(r,n,i+1);throw new Vy(s)}}scheduleRefreshToken(){setInterval(async()=>{if(this.jwt)if(this.jwt.payload.exp*1e3-Date.now()<e.tokenStrategy.refresh.beforeExpire)try{this.jwt=await this.refreshToken(this.jwt,e.tokenStrategy.refresh.whenScheduled),super.emit("updated",this.jwt),await this.save();}catch(r){this.logger.error({error:r},"Error when refreshing jwt");}else this.logger.debug("Check token, still valid");},e.tokenStrategy.refresh.interval);}};var oc={server:{endpoint:"http://localhost:8080",token:"",requestHeaders:{},requestTimeout:12e4},completion:{prompt:{experimentalStripAutoClosingCharacters:!1,maxPrefixLines:20,maxSuffixLines:20,fillDeclarations:{enabled:!0,maxSnippets:5,maxCharsPerSnippet:500},collectSnippetsFromRecentChangedFiles:{enabled:!0,maxSnippets:3,indexing:{checkingChangesInterval:500,changesDebouncingInterval:1e3,prefixLines:20,suffixLines:20,maxChunks:100,chunkSize:500,overlapLines:1}},clipboard:{minChars:3,maxChars:2e3}},debounce:{mode:"adaptive",interval:250}},postprocess:{limitScope:{experimentalSyntax:!1,indentation:{experimentalKeepBlockScopeWhenCompletingLine:!1}},calculateReplaceRange:{experimentalSyntax:!1}},logs:{level:"silent"},tls:{caCerts:"system"},anonymousUsageTracking:{disable:!1}};var Hy=ur(mf()),QD=ur(zD()),XD=ur(A0()),ZD=ur(Su());var YD=`## Tabby agent configuration file

## Online documentation: https://tabby.tabbyml.com/docs/extensions/configurations
## You can uncomment and edit the values below to change the default settings.
## Configurations in this file have lower priority than the IDE settings.

## Server
## You can set the server endpoint here and an optional authentication token if required.
# [server]
# endpoint = "http://localhost:8080" # http or https URL
# token = "your-token-here" # if token is set, request header Authorization = "Bearer $token" will be added automatically

## You can add custom request headers.
# [server.requestHeaders]
# Header1 = "Value1" # list your custom headers here
# Header2 = "Value2" # values can be strings, numbers or booleans

## Logs
## You can set the log level here. The log file is located at ~/.tabby-client/agent/logs/.
# [logs]
# level = "silent" # "silent" or "error" or "debug"

## Anonymous usage tracking
## Tabby collects anonymous usage data and sends it to the Tabby team to help improve our products.
## Your code, generated completions, or any sensitive information is never tracked or sent.
## For more details on data collection, see https://tabby.tabbyml.com/docs/extensions/configurations#usage-collection
## Your contribution is greatly appreciated. However, if you prefer not to participate, you can disable anonymous usage tracking here.
# [anonymousUsageTracking]
# disable = false # set to true to disable

`,aJ={server:"object","server.endpoint":"string","server.token":"string","server.requestHeaders":"object","server.requestTimeout":"number",completion:"object","completion.prompt":"object","completion.prompt.experimentalStripAutoClosingCharacters":"boolean","completion.prompt.maxPrefixLines":"number","completion.prompt.maxSuffixLines":"number","completion.prompt.fillDeclarations":"object","completion.prompt.fillDeclarations.enabled":"boolean","completion.prompt.fillDeclarations.maxSnippets":"number","completion.prompt.fillDeclarations.maxChars":"number","completion.prompt.collectSnippetsFromRecentChangedFiles":"object","completion.prompt.collectSnippetsFromRecentChangedFiles.enabled":"boolean","completion.prompt.collectSnippetsFromRecentChangedFiles.maxSnippets":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing":"object","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.checkingChangesInterval":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.changesDebouncingInterval":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.prefixLines":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.suffixLines":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.maxChunks":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.chunkSize":"number","completion.prompt.collectSnippetsFromRecentChangedFiles.indexing.overlapLines":"number","completion.prompt.clipboard":"object","completion.prompt.clipboard.minChars":"number","completion.prompt.clipboard.maxChars":"number","completion.debounce":"object","completion.debounce.mode":"string","completion.debounce.interval":"number",postprocess:"object","postprocess.limitScopeByIndentation":"object","postprocess.limitScopeByIndentation.experimentalKeepBlockScopeWhenCompletingLine":"boolean",logs:"object","logs.level":"string",tls:"object","tls.caCerts":"string",anonymousUsageTracking:"object","anonymousUsageTracking.disable":"boolean"};function oJ(e){for(let[t,r]of Object.entries(aJ))typeof Kl(e,t)!==r&&Gl(e,t);return e}var Wy=class extends events.EventEmitter{constructor(r){super();this.filepath=r;this.data={};this.logger=_r("ConfigFile");}get config(){return this.data}async load(){try{let r=await Hy.default.readFile(this.filepath,"utf8"),n=QD.default.parse(r);if(Object.keys(n).length===0&&r.trim()!==YD.trim()){await this.createTemplate();return}this.data=oJ(n);}catch(r){r instanceof Error&&"code"in r&&r.code==="ENOENT"?await this.createTemplate():this.logger.error({error:r},"Failed to load config file");}}watch(){this.watcher=XD.default.watch(this.filepath,{interval:1e3});let r=async()=>{let n=this.data;await this.load(),(0, ZD.default)(n,this.data)||super.emit("updated",this.data);};this.watcher.on("add",r),this.watcher.on("change",r);}async createTemplate(){try{await Hy.default.outputFile(this.filepath,YD);}catch(r){this.logger.error({error:r},"Failed to create config template file");}}},uJ=F___default.default.join(PO__default.default.homedir(),".tabby-client","agent","config.toml"),vo=new Wy(uJ);var uc=typeof performance=="object"&&performance&&typeof performance.now=="function"?performance:Date,eO=new Set,Ky=typeof process=="object"&&process?process:{},tO=(e,t,r,n)=>{typeof Ky.emitWarning=="function"?Ky.emitWarning(e,t,r,n):console.error(`[${r}] ${t}: ${e}`);},cd=globalThis.AbortController,JD=globalThis.AbortSignal;if(typeof cd>"u"){JD=class{onabort;_onabort=[];reason;aborted=!1;addEventListener(n,i){this._onabort.push(i);}},cd=class{constructor(){t();}signal=new JD;abort(n){if(!this.signal.aborted){this.signal.reason=n,this.signal.aborted=!0;for(let i of this.signal._onabort)i(n);this.signal.onabort?.(n);}}};let e=Ky.env?.LRU_CACHE_IGNORE_AC_WARNING!=="1",t=()=>{e&&(e=!1,tO("AbortController is not defined. If using lru-cache in node 14, load an AbortController polyfill from the `node-abort-controller` package. A minimal polyfill is provided for use by LRUCache.fetch(), but it should not be relied upon in other contexts (eg, passing it to other APIs that use AbortController/AbortSignal might have undesirable effects). You may disable this with LRU_CACHE_IGNORE_AC_WARNING=1 in the env.","NO_ABORT_CONTROLLER","ENOTSUP",t));};}var cJ=e=>!eO.has(e),ys=e=>e&&e===Math.floor(e)&&e>0&&isFinite(e),rO=e=>ys(e)?e<=Math.pow(2,8)?Uint8Array:e<=Math.pow(2,16)?Uint16Array:e<=Math.pow(2,32)?Uint32Array:e<=Number.MAX_SAFE_INTEGER?_o:null:null,_o=class extends Array{constructor(t){super(t),this.fill(0);}},Gy=class e{heap;length;static#u=!1;static create(t){let r=rO(t);if(!r)return [];e.#u=!0;let n=new e(t,r);return e.#u=!1,n}constructor(t,r){if(!e.#u)throw new TypeError("instantiate Stack using Stack.create(n)");this.heap=new r(t),this.length=0;}push(t){this.heap[this.length++]=t;}pop(){return this.heap[--this.length]}},ld=class e{#u;#f;#v;#p;#I;ttl;ttlResolution;ttlAutopurge;updateAgeOnGet;updateAgeOnHas;allowStale;noDisposeOnSet;noUpdateTTL;maxEntrySize;sizeCalculation;noDeleteOnFetchRejection;noDeleteOnStaleGet;allowStaleOnFetchAbort;allowStaleOnFetchRejection;ignoreFetchAbort;#n;#g;#i;#r;#e;#c;#d;#o;#s;#m;#a;#E;#w;#y;#_;#x;#l;static unsafeExposeInternals(t){return {starts:t.#w,ttls:t.#y,sizes:t.#E,keyMap:t.#i,keyList:t.#r,valList:t.#e,next:t.#c,prev:t.#d,get head(){return t.#o},get tail(){return t.#s},free:t.#m,isBackgroundFetch:r=>t.#t(r),backgroundFetch:(r,n,i,s)=>t.#D(r,n,i,s),moveToTail:r=>t.#R(r),indexes:r=>t.#b(r),rindexes:r=>t.#S(r),isStale:r=>t.#h(r)}}get max(){return this.#u}get maxSize(){return this.#f}get calculatedSize(){return this.#g}get size(){return this.#n}get fetchMethod(){return this.#I}get dispose(){return this.#v}get disposeAfter(){return this.#p}constructor(t){let{max:r=0,ttl:n,ttlResolution:i=1,ttlAutopurge:s,updateAgeOnGet:a,updateAgeOnHas:o,allowStale:c,dispose:l,disposeAfter:u,noDisposeOnSet:f,noUpdateTTL:h,maxSize:p=0,maxEntrySize:g=0,sizeCalculation:_,fetchMethod:E,noDeleteOnFetchRejection:w,noDeleteOnStaleGet:y,allowStaleOnFetchRejection:b,allowStaleOnFetchAbort:N,ignoreFetchAbort:L}=t;if(r!==0&&!ys(r))throw new TypeError("max option must be a nonnegative integer");let V=r?rO(r):Array;if(!V)throw new Error("invalid max value: "+r);if(this.#u=r,this.#f=p,this.maxEntrySize=g||this.#f,this.sizeCalculation=_,this.sizeCalculation){if(!this.#f&&!this.maxEntrySize)throw new TypeError("cannot set sizeCalculation without setting maxSize or maxEntrySize");if(typeof this.sizeCalculation!="function")throw new TypeError("sizeCalculation set to non-function")}if(E!==void 0&&typeof E!="function")throw new TypeError("fetchMethod must be a function if specified");if(this.#I=E,this.#x=!!E,this.#i=new Map,this.#r=new Array(r).fill(void 0),this.#e=new Array(r).fill(void 0),this.#c=new V(r),this.#d=new V(r),this.#o=0,this.#s=0,this.#m=Gy.create(r),this.#n=0,this.#g=0,typeof l=="function"&&(this.#v=l),typeof u=="function"?(this.#p=u,this.#a=[]):(this.#p=void 0,this.#a=void 0),this.#_=!!this.#v,this.#l=!!this.#p,this.noDisposeOnSet=!!f,this.noUpdateTTL=!!h,this.noDeleteOnFetchRejection=!!w,this.allowStaleOnFetchRejection=!!b,this.allowStaleOnFetchAbort=!!N,this.ignoreFetchAbort=!!L,this.maxEntrySize!==0){if(this.#f!==0&&!ys(this.#f))throw new TypeError("maxSize must be a positive integer if specified");if(!ys(this.maxEntrySize))throw new TypeError("maxEntrySize must be a positive integer if specified");this.#q();}if(this.allowStale=!!c,this.noDeleteOnStaleGet=!!y,this.updateAgeOnGet=!!a,this.updateAgeOnHas=!!o,this.ttlResolution=ys(i)||i===0?i:1,this.ttlAutopurge=!!s,this.ttl=n||0,this.ttl){if(!ys(this.ttl))throw new TypeError("ttl must be a positive integer if specified");this.#O();}if(this.#u===0&&this.ttl===0&&this.#f===0)throw new TypeError("At least one of max, maxSize, or ttl is required");if(!this.ttlAutopurge&&!this.#u&&!this.#f){let Z="LRU_CACHE_UNBOUNDED";cJ(Z)&&(eO.add(Z),tO("TTL caching without ttlAutopurge, max, or maxSize can result in unbounded memory consumption.","UnboundedCacheWarning",Z,e));}}getRemainingTTL(t){return this.#i.has(t)?1/0:0}#O(){let t=new _o(this.#u),r=new _o(this.#u);this.#y=t,this.#w=r,this.#k=(s,a,o=uc.now())=>{if(r[s]=a!==0?o:0,t[s]=a,a!==0&&this.ttlAutopurge){let c=setTimeout(()=>{this.#h(s)&&this.delete(this.#r[s]);},a+1);c.unref&&c.unref();}},this.#T=s=>{r[s]=t[s]!==0?uc.now():0;},this.#C=(s,a)=>{if(t[a]){let o=t[a],c=r[a];s.ttl=o,s.start=c,s.now=n||i();let l=s.now-c;s.remainingTTL=o-l;}};let n=0,i=()=>{let s=uc.now();if(this.ttlResolution>0){n=s;let a=setTimeout(()=>n=0,this.ttlResolution);a.unref&&a.unref();}return s};this.getRemainingTTL=s=>{let a=this.#i.get(s);if(a===void 0)return 0;let o=t[a],c=r[a];if(o===0||c===0)return 1/0;let l=(n||i())-c;return o-l},this.#h=s=>t[s]!==0&&r[s]!==0&&(n||i())-r[s]>t[s];}#T=()=>{};#C=()=>{};#k=()=>{};#h=()=>!1;#q(){let t=new _o(this.#u);this.#g=0,this.#E=t,this.#A=r=>{this.#g-=t[r],t[r]=0;},this.#L=(r,n,i,s)=>{if(this.#t(n))return 0;if(!ys(i))if(s){if(typeof s!="function")throw new TypeError("sizeCalculation must be a function");if(i=s(n,r),!ys(i))throw new TypeError("sizeCalculation return invalid (expect positive integer)")}else throw new TypeError("invalid size value (must be positive integer). When maxSize or maxEntrySize is used, sizeCalculation or size must be set.");return i},this.#P=(r,n,i)=>{if(t[r]=n,this.#f){let s=this.#f-t[r];for(;this.#g>s;)this.#N(!0);}this.#g+=t[r],i&&(i.entrySize=n,i.totalCalculatedSize=this.#g);};}#A=t=>{};#P=(t,r,n)=>{};#L=(t,r,n,i)=>{if(n||i)throw new TypeError("cannot set size without setting maxSize or maxEntrySize on cache");return 0};*#b({allowStale:t=this.allowStale}={}){if(this.#n)for(let r=this.#s;!(!this.#B(r)||((t||!this.#h(r))&&(yield r),r===this.#o));)r=this.#d[r];}*#S({allowStale:t=this.allowStale}={}){if(this.#n)for(let r=this.#o;!(!this.#B(r)||((t||!this.#h(r))&&(yield r),r===this.#s));)r=this.#c[r];}#B(t){return t!==void 0&&this.#i.get(this.#r[t])===t}*entries(){for(let t of this.#b())this.#e[t]!==void 0&&this.#r[t]!==void 0&&!this.#t(this.#e[t])&&(yield [this.#r[t],this.#e[t]]);}*rentries(){for(let t of this.#S())this.#e[t]!==void 0&&this.#r[t]!==void 0&&!this.#t(this.#e[t])&&(yield [this.#r[t],this.#e[t]]);}*keys(){for(let t of this.#b()){let r=this.#r[t];r!==void 0&&!this.#t(this.#e[t])&&(yield r);}}*rkeys(){for(let t of this.#S()){let r=this.#r[t];r!==void 0&&!this.#t(this.#e[t])&&(yield r);}}*values(){for(let t of this.#b())this.#e[t]!==void 0&&!this.#t(this.#e[t])&&(yield this.#e[t]);}*rvalues(){for(let t of this.#S())this.#e[t]!==void 0&&!this.#t(this.#e[t])&&(yield this.#e[t]);}[Symbol.iterator](){return this.entries()}find(t,r={}){for(let n of this.#b()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;if(s!==void 0&&t(s,this.#r[n],this))return this.get(this.#r[n],r)}}forEach(t,r=this){for(let n of this.#b()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;s!==void 0&&t.call(r,s,this.#r[n],this);}}rforEach(t,r=this){for(let n of this.#S()){let i=this.#e[n],s=this.#t(i)?i.__staleWhileFetching:i;s!==void 0&&t.call(r,s,this.#r[n],this);}}purgeStale(){let t=!1;for(let r of this.#S({allowStale:!0}))this.#h(r)&&(this.delete(this.#r[r]),t=!0);return t}dump(){let t=[];for(let r of this.#b({allowStale:!0})){let n=this.#r[r],i=this.#e[r],s=this.#t(i)?i.__staleWhileFetching:i;if(s===void 0||n===void 0)continue;let a={value:s};if(this.#y&&this.#w){a.ttl=this.#y[r];let o=uc.now()-this.#w[r];a.start=Math.floor(Date.now()-o);}this.#E&&(a.size=this.#E[r]),t.unshift([n,a]);}return t}load(t){this.clear();for(let[r,n]of t){if(n.start){let i=Date.now()-n.start;n.start=uc.now()-i;}this.set(r,n.value,n);}}set(t,r,n={}){if(r===void 0)return this.delete(t),this;let{ttl:i=this.ttl,start:s,noDisposeOnSet:a=this.noDisposeOnSet,sizeCalculation:o=this.sizeCalculation,status:c}=n,{noUpdateTTL:l=this.noUpdateTTL}=n,u=this.#L(t,r,n.size||0,o);if(this.maxEntrySize&&u>this.maxEntrySize)return c&&(c.set="miss",c.maxEntrySizeExceeded=!0),this.delete(t),this;let f=this.#n===0?void 0:this.#i.get(t);if(f===void 0)f=this.#n===0?this.#s:this.#m.length!==0?this.#m.pop():this.#n===this.#u?this.#N(!1):this.#n,this.#r[f]=t,this.#e[f]=r,this.#i.set(t,f),this.#c[this.#s]=f,this.#d[f]=this.#s,this.#s=f,this.#n++,this.#P(f,u,c),c&&(c.set="add"),l=!1;else {this.#R(f);let h=this.#e[f];if(r!==h){if(this.#x&&this.#t(h)?h.__abortController.abort(new Error("replaced")):a||(this.#_&&this.#v?.(h,t,"set"),this.#l&&this.#a?.push([h,t,"set"])),this.#A(f),this.#P(f,u,c),this.#e[f]=r,c){c.set="replace";let p=h&&this.#t(h)?h.__staleWhileFetching:h;p!==void 0&&(c.oldValue=p);}}else c&&(c.set="update");}if(i!==0&&!this.#y&&this.#O(),this.#y&&(l||this.#k(f,i,s),c&&this.#C(c,f)),!a&&this.#l&&this.#a){let h=this.#a,p;for(;p=h?.shift();)this.#p?.(...p);}return this}pop(){try{for(;this.#n;){let t=this.#e[this.#o];if(this.#N(!0),this.#t(t)){if(t.__staleWhileFetching)return t.__staleWhileFetching}else if(t!==void 0)return t}}finally{if(this.#l&&this.#a){let t=this.#a,r;for(;r=t?.shift();)this.#p?.(...r);}}}#N(t){let r=this.#o,n=this.#r[r],i=this.#e[r];return this.#x&&this.#t(i)?i.__abortController.abort(new Error("evicted")):(this.#_||this.#l)&&(this.#_&&this.#v?.(i,n,"evict"),this.#l&&this.#a?.push([i,n,"evict"])),this.#A(r),t&&(this.#r[r]=void 0,this.#e[r]=void 0,this.#m.push(r)),this.#n===1?(this.#o=this.#s=0,this.#m.length=0):this.#o=this.#c[r],this.#i.delete(n),this.#n--,r}has(t,r={}){let{updateAgeOnHas:n=this.updateAgeOnHas,status:i}=r,s=this.#i.get(t);if(s!==void 0){let a=this.#e[s];if(this.#t(a)&&a.__staleWhileFetching===void 0)return !1;if(this.#h(s))i&&(i.has="stale",this.#C(i,s));else return n&&this.#T(s),i&&(i.has="hit",this.#C(i,s)),!0}else i&&(i.has="miss");return !1}peek(t,r={}){let{allowStale:n=this.allowStale}=r,i=this.#i.get(t);if(i!==void 0&&(n||!this.#h(i))){let s=this.#e[i];return this.#t(s)?s.__staleWhileFetching:s}}#D(t,r,n,i){let s=r===void 0?void 0:this.#e[r];if(this.#t(s))return s;let a=new cd,{signal:o}=n;o?.addEventListener("abort",()=>a.abort(o.reason),{signal:a.signal});let c={signal:a.signal,options:n,context:i},l=(_,E=!1)=>{let{aborted:w}=a.signal,y=n.ignoreFetchAbort&&_!==void 0;if(n.status&&(w&&!E?(n.status.fetchAborted=!0,n.status.fetchError=a.signal.reason,y&&(n.status.fetchAbortIgnored=!0)):n.status.fetchResolved=!0),w&&!y&&!E)return f(a.signal.reason);let b=p;return this.#e[r]===p&&(_===void 0?b.__staleWhileFetching?this.#e[r]=b.__staleWhileFetching:this.delete(t):(n.status&&(n.status.fetchUpdated=!0),this.set(t,_,c.options))),_},u=_=>(n.status&&(n.status.fetchRejected=!0,n.status.fetchError=_),f(_)),f=_=>{let{aborted:E}=a.signal,w=E&&n.allowStaleOnFetchAbort,y=w||n.allowStaleOnFetchRejection,b=y||n.noDeleteOnFetchRejection,N=p;if(this.#e[r]===p&&(!b||N.__staleWhileFetching===void 0?this.delete(t):w||(this.#e[r]=N.__staleWhileFetching)),y)return n.status&&N.__staleWhileFetching!==void 0&&(n.status.returnedStale=!0),N.__staleWhileFetching;if(N.__returned===N)throw _},h=(_,E)=>{let w=this.#I?.(t,s,c);w&&w instanceof Promise&&w.then(y=>_(y),E),a.signal.addEventListener("abort",()=>{(!n.ignoreFetchAbort||n.allowStaleOnFetchAbort)&&(_(),n.allowStaleOnFetchAbort&&(_=y=>l(y,!0)));});};n.status&&(n.status.fetchDispatched=!0);let p=new Promise(h).then(l,u),g=Object.assign(p,{__abortController:a,__staleWhileFetching:s,__returned:void 0});return r===void 0?(this.set(t,g,{...c.options,status:void 0}),r=this.#i.get(t)):this.#e[r]=g,g}#t(t){if(!this.#x)return !1;let r=t;return !!r&&r instanceof Promise&&r.hasOwnProperty("__staleWhileFetching")&&r.__abortController instanceof cd}async fetch(t,r={}){let{allowStale:n=this.allowStale,updateAgeOnGet:i=this.updateAgeOnGet,noDeleteOnStaleGet:s=this.noDeleteOnStaleGet,ttl:a=this.ttl,noDisposeOnSet:o=this.noDisposeOnSet,size:c=0,sizeCalculation:l=this.sizeCalculation,noUpdateTTL:u=this.noUpdateTTL,noDeleteOnFetchRejection:f=this.noDeleteOnFetchRejection,allowStaleOnFetchRejection:h=this.allowStaleOnFetchRejection,ignoreFetchAbort:p=this.ignoreFetchAbort,allowStaleOnFetchAbort:g=this.allowStaleOnFetchAbort,context:_,forceRefresh:E=!1,status:w,signal:y}=r;if(!this.#x)return w&&(w.fetch="get"),this.get(t,{allowStale:n,updateAgeOnGet:i,noDeleteOnStaleGet:s,status:w});let b={allowStale:n,updateAgeOnGet:i,noDeleteOnStaleGet:s,ttl:a,noDisposeOnSet:o,size:c,sizeCalculation:l,noUpdateTTL:u,noDeleteOnFetchRejection:f,allowStaleOnFetchRejection:h,allowStaleOnFetchAbort:g,ignoreFetchAbort:p,status:w,signal:y},N=this.#i.get(t);if(N===void 0){w&&(w.fetch="miss");let L=this.#D(t,N,b,_);return L.__returned=L}else {let L=this.#e[N];if(this.#t(L)){let ee=n&&L.__staleWhileFetching!==void 0;return w&&(w.fetch="inflight",ee&&(w.returnedStale=!0)),ee?L.__staleWhileFetching:L.__returned=L}let V=this.#h(N);if(!E&&!V)return w&&(w.fetch="hit"),this.#R(N),i&&this.#T(N),w&&this.#C(w,N),L;let Z=this.#D(t,N,b,_),z=Z.__staleWhileFetching!==void 0&&n;return w&&(w.fetch=V?"stale":"refresh",z&&V&&(w.returnedStale=!0)),z?Z.__staleWhileFetching:Z.__returned=Z}}get(t,r={}){let{allowStale:n=this.allowStale,updateAgeOnGet:i=this.updateAgeOnGet,noDeleteOnStaleGet:s=this.noDeleteOnStaleGet,status:a}=r,o=this.#i.get(t);if(o!==void 0){let c=this.#e[o],l=this.#t(c);return a&&this.#C(a,o),this.#h(o)?(a&&(a.get="stale"),l?(a&&n&&c.__staleWhileFetching!==void 0&&(a.returnedStale=!0),n?c.__staleWhileFetching:void 0):(s||this.delete(t),a&&n&&(a.returnedStale=!0),n?c:void 0)):(a&&(a.get="hit"),l?c.__staleWhileFetching:(this.#R(o),i&&this.#T(o),c))}else a&&(a.get="miss");}#F(t,r){this.#d[r]=t,this.#c[t]=r;}#R(t){t!==this.#s&&(t===this.#o?this.#o=this.#c[t]:this.#F(this.#d[t],this.#c[t]),this.#F(this.#s,t),this.#s=t);}delete(t){let r=!1;if(this.#n!==0){let n=this.#i.get(t);if(n!==void 0)if(r=!0,this.#n===1)this.clear();else {this.#A(n);let i=this.#e[n];this.#t(i)?i.__abortController.abort(new Error("deleted")):(this.#_||this.#l)&&(this.#_&&this.#v?.(i,t,"delete"),this.#l&&this.#a?.push([i,t,"delete"])),this.#i.delete(t),this.#r[n]=void 0,this.#e[n]=void 0,n===this.#s?this.#s=this.#d[n]:n===this.#o?this.#o=this.#c[n]:(this.#c[this.#d[n]]=this.#c[n],this.#d[this.#c[n]]=this.#d[n]),this.#n--,this.#m.push(n);}}if(this.#l&&this.#a?.length){let n=this.#a,i;for(;i=n?.shift();)this.#p?.(...i);}return r}clear(){for(let t of this.#S({allowStale:!0})){let r=this.#e[t];if(this.#t(r))r.__abortController.abort(new Error("deleted"));else {let n=this.#r[t];this.#_&&this.#v?.(r,n,"delete"),this.#l&&this.#a?.push([r,n,"delete"]);}}if(this.#i.clear(),this.#e.fill(void 0),this.#r.fill(void 0),this.#y&&this.#w&&(this.#y.fill(0),this.#w.fill(0)),this.#E&&this.#E.fill(0),this.#o=0,this.#s=0,this.#m.length=0,this.#g=0,this.#n=0,this.#l&&this.#a){let t=this.#a,r;for(;r=t?.shift();)this.#p?.(...r);}}};var cO=ur(uO());function fJ(e){return e.trimEnd().match(_P)}var pa=class{constructor(t){this.filepath=t.filepath,this.language=t.language,this.text=t.text,this.position=t.position,this.indentation=t.indentation,this.prefix=t.text.slice(0,t.position),this.suffix=t.text.slice(t.position),this.prefixLines=Mt(this.prefix),this.suffixLines=Mt(this.suffix),this.currentLinePrefix=this.prefixLines[this.prefixLines.length-1]??"",this.currentLineSuffix=this.suffixLines[0]??"",this.clipboard=t.clipboard?.trim()??"",this.workspace=t.workspace,this.git=t.git,this.declarations=t.declarations,this.relevantSnippetsFromChangedFiles=t.relevantSnippetsFromChangedFiles;let r=fJ(this.suffixLines[0]??"");this.mode=r?"default":"fill-in-line",this.hash=(0, cO.default)({filepath:this.filepath,language:this.language,text:this.text,position:this.position,clipboard:this.clipboard,declarations:this.declarations,relevantSnippetsFromChangedFiles:this.relevantSnippetsFromChangedFiles});}};var fd=class{constructor(){this.logger=_r("CompletionCache");this.options={maxCount:1e4,prebuildCache:{enabled:!0,perCharacter:{lines:1,max:50},perLine:{max:10},autoClosingPairCheck:{max:3}}};this.cache=new ld({max:this.options.maxCount});}has(t){return this.cache.has(t.hash)}buildCache(t,r){this.logger.debug({key:t,value:r},"Starting to build cache");let n=this.createCacheEntries(t,r);n.forEach(i=>{this.cache.set(i.key.hash,{value:i.value,rebuildFlag:i.rebuildFlag});}),this.logger.debug({newEntries:n.length,cacheSize:this.cache.size},"Cache updated");}get(t){let r=this.cache.get(t.hash);return r?.rebuildFlag&&this.buildCache(t,r?.value),r?.value}createCacheEntries(t,r){let n=[{key:t,value:r,rebuildFlag:!1}];if(this.options.prebuildCache.enabled)for(let s of r.choices){let a=s.text.slice(t.position-s.replaceRange.start),o=this.getPerLinePositions(a);this.logger.trace({completionText:a,perLinePositions:o},"Calculate per-line cache positions");for(let l of o){let u=a.slice(0,l),f=this.generateAutoClosedPrefixes(u);for(let h of [u,...f]){let p={key:new pa({...t,text:t.text.slice(0,t.position)+h+t.text.slice(t.position),position:t.position+l}),value:{...r,choices:[{index:s.index,text:a.slice(l),replaceRange:{start:t.position+l,end:t.position+l}}]},rebuildFlag:!0};this.logger.trace({prefix:h,entry:p},"Build per-line cache entry"),n.push(p);}}let c=this.getPerCharacterPositions(a);this.logger.trace({completionText:a,perCharacterPositions:c},"Calculate per-character cache positions");for(let l of c){let u=l;for(;u>0&&a[u-1]!==`
`;)u--;let f=a.slice(0,l),h=this.generateAutoClosedPrefixes(f);for(let p of [f,...h]){let g={key:new pa({...t,text:t.text.slice(0,t.position)+p+t.text.slice(t.position),position:t.position+l}),value:{...r,choices:[{index:s.index,text:a.slice(u),replaceRange:{start:t.position+u,end:t.position+l}}]},rebuildFlag:!1};this.logger.trace({prefix:p,entry:g},"Build per-character cache entry"),n.push(g);}}}return n.reduce((s,a)=>{let o=s.find(c=>c.key.hash===a.key.hash);return o?(o.value.choices.push(...a.value.choices),o.rebuildFlag=o.rebuildFlag||a.rebuildFlag):s.push(a),s},[])}getPerLinePositions(t){let r=[],n=this.options.prebuildCache,i=Mt(t),s=0,a=0;for(;s<i.length-1&&s<n.perLine.max;){a+=i[s]?.length??0,r.push(a-1),r.push(a);let o=a;for(;o<t.length&&t[o].match(/\s/);)o++;r.push(o),s++;}return r}getPerCharacterPositions(t){let r=[],n=this.options.prebuildCache,i=Mt(t).slice(0,n.perCharacter.lines).join(""),s=0;for(;s<i.length&&s<n.perCharacter.max;)r.push(s),s++;return r}generateAutoClosedPrefixes(t){let r=[],n=Ff(t),i=0,s="";for(;i<n.length&&i<this.options.prebuildCache.autoClosingPairCheck.max;)k0.filter(a=>{let o;return "open"in a?o=a.open:o=a.openOrClose,o.chars===n[n.length-1-i]}).forEach(a=>{let o;"close"in a?o=a.close:o=a.openOrClose,s+=o.chars,r.push(t+s);}),i++;return r}};function Qy(e,t,r){return Math.max(e,Math.min(t,r))}var dd=class{constructor(){this.lastCalledTimeStamp=0;this.baseInterval=200;this.calledIntervalHistory=[];this.options={baseIntervalSlideWindowAvg:{minSize:20,maxSize:100,min:100,max:400},adaptiveRate:{min:1.5,max:3},contextScoreWeights:{triggerCharacter:.5,noSuffixInCurrentLine:.4,noSuffix:.1},requestDelay:{min:100,max:1e3}};}async debounce(t,r){let{request:n,config:i,responseTime:s}=t;if(n.manually)return this.sleep(0,r);if(i.mode==="fixed")return this.sleep(i.interval,r);let a=Date.now();this.updateBaseInterval(a-this.lastCalledTimeStamp),this.lastCalledTimeStamp=a;let o=this.calcContextScore(n),l=(this.options.adaptiveRate.max-(this.options.adaptiveRate.max-this.options.adaptiveRate.min)*o)*this.baseInterval,u=Qy(this.options.requestDelay.min,this.options.requestDelay.max,l-s);return this.sleep(u,r)}async sleep(t,r){return new Promise((n,i)=>{let s=setTimeout(n,Math.min(t,2147483647));r?.signal&&(r.signal.aborted?(clearTimeout(s),i(r.signal.reason)):r.signal.addEventListener("abort",()=>{clearTimeout(s),i(r.signal.reason);}));})}updateBaseInterval(t){if(!(t>this.options.baseIntervalSlideWindowAvg.max)&&(this.calledIntervalHistory.push(t),this.calledIntervalHistory.length>this.options.baseIntervalSlideWindowAvg.maxSize&&this.calledIntervalHistory.shift(),this.calledIntervalHistory.length>this.options.baseIntervalSlideWindowAvg.minSize)){let r=this.calledIntervalHistory.reduce((n,i)=>n+i,0)/this.calledIntervalHistory.length;this.baseInterval=Qy(this.options.baseIntervalSlideWindowAvg.min,this.options.baseIntervalSlideWindowAvg.max,r);}}calcContextScore(t){let r=0,n=this.options.contextScoreWeights,i=t.text[t.position-1]??"";r+=i.match(/^\W*$/)?n.triggerCharacter:0;let s=t.text.slice(t.position)??"",a=Mt(s)[0]??"";return r+=a.match(/^\W*$/)?n.noSuffixInCurrentLine:0,r+=s.match(/^\W*$/)?n.noSuffix:0,r=Qy(0,1,r),r}};Array.prototype.distinct||(Array.prototype.distinct=function(e){return [...new Map(this.map(t=>[e?.(t)??t,t])).values()]});Array.prototype.mapAsync||(Array.prototype.mapAsync=async function(e,t){return await Promise.all(this.map((r,n)=>e.call(t,r,n,this)))});var Lt=_r("Postprocess");function on(e,t){return Xy(async r=>{let n=t.position-r.replaceRange.start,i=r.text.slice(n),s=await e(i,t);return r.text=r.text.slice(0,n)+(s??""),r},t)}function Xy(e,t){return async r=>(r.choices=(await r.choices.mapAsync(async n=>await e(n,t))).filter(n=>!!n&&!!n.text).distinct(n=>n.text),r)}function dJ(e){return /\n(\s*)\n/g}function lO(){return (e,t)=>{let r=e.split(dJ()),n=0,i=2,s=r.length-2;for(;s>=1;){if(st(r[s])){s--;continue}let a=s-1;for(;a>=0&&st(r[a]);)a--;if(a<0)break;let o=r[s].trim(),c=r[a].trim(),l=Math.max(.1*o.length,.1*c.length);if(fo(o,c)<=l)n++,s--;else break}return n>=i?(Lt.debug({inputBlocks:r,repetitionCount:n},"Remove repetitive blocks."),r.slice(0,s+1).join("").trimEnd()):e}}function fO(){return e=>{let t=Mt(e),r=0,n=5,i=t.length-2;for(;i>=1;){if(st(t[i])){i--;continue}let s=i-1;for(;s>=0&&st(t[s]);)s--;if(s<0)break;let a=t[i].trim(),o=t[s].trim(),c=Math.max(.1*a.length,.1*o.length);if(fo(a,o)<=c)r++,i=s;else break}return r>=n?(Lt.debug({inputLines:t,repetitionCount:r},"Remove repetitive lines."),t.slice(0,i+1).join("").trimEnd()):e}}var hJ=[/(.{3,}?)\1{5,}$/g,/(.{10,}?)\1{3,}$/g];function dO(){return e=>{let t=Mt(e),r=t.length-1;for(;r>=0&&st(t[r]);)r--;if(r<0)return e;for(let n of hJ){let i=t[r].match(n);if(i)return Lt.debug({inputLines:t,lineNumber:r,match:i},"Remove line ends with repetition."),r<1?null:t.slice(0,r).join("").trimEnd()}return e}}function hO(){return (e,t)=>{let{suffixLines:r,currentLinePrefix:n}=t,i=Mt(e);if(i.length<2)return e;let s=i.map((l,u)=>u===0?n+l:l);if(!Bf(s,i.length-1))return e;let a=i[i.length-1],o=1;for(;o<r.length&&st(r[o]);)o++;if(o>=r.length)return e;let c=r[o];return a.startsWith(c.trimEnd())||c.startsWith(a.trimEnd())?(Lt.debug({inputLines:i,suffixLines:r},"Removing duplicated block closing line"),i.slice(0,i.length-1).join("").trimEnd()):e}}function pJ(e,t,r,n){let i={indentLevelLimit:0,allowClosingLine:!0},{prefixLines:s,suffixLines:a,currentLinePrefix:o}=r;if(e.length==0||s.length==0)return i;let c=st(o),l=s.length-1;for(;l>=0&&st(s[l]);)l--;if(l<0)return i;let u=s[l],f=mi(u),h=e[0],p=st(h),g=0;for(;g<e.length&&st(e[g]);)g++;if(g>=e.length)return i;let _=e[g],E;p?E=mi(_):E=mi(o+_),!p&&!c?n.experimentalKeepBlockScopeWhenCompletingLine?i.indentLevelLimit=f:(i.indentLevelLimit=f+1,i.allowClosingLine&&=O0(t,0)):E>f?i.indentLevelLimit=f+1:(i.indentLevelLimit=f);let w=1;for(;w<a.length&&st(a[w]);)w++;if(w<a.length){let y=a[w];i.allowClosingLine&&=mi(y)<i.indentLevelLimit;}return i}function pO(e){return (t,r)=>{let{prefixLines:n,suffixLines:i,currentLinePrefix:s}=r,a=Mt(t),o=a.map((u,f)=>f===0?s+u:u),c=pJ(a,o,r,e),l=1;for(;l<a.length;){let u=a[l],f=a[l-1];if(st(u)){l++;continue}if(mi(u)<c.indentLevelLimit){if(Bf(o,l)&&O0(o,l)){l++;continue}c.allowClosingLine&&(r.language!=="python"||!st(f))&&l++;break}l++;}return l<a.length?(Lt.debug({inputLines:a,prefixLines:n,suffixLines:i,scopeLineCount:l},"Remove content out of indent scope"),a.slice(0,l).join("").trimEnd()):t}}var hd=ur(gO());var So={javascript:"tsx",typescript:"tsx",javascriptreact:"tsx",typescriptreact:"tsx",python:"python",go:"go",rust:"rust",ruby:"ruby"},yO=!1;async function gJ(e){yO||(await hd.default.init({locateFile(n,i){let s=[i,"wasm",n];return F___default.default.join(...s)}}),yO=!0);let t=new hd.default,r=[__dirname,"wasm",`tree-sitter-${e}.wasm`];return t.setLanguage(await hd.default.Language.load(F___default.default.join(...r))),t}var vO=new Map;async function pd(e){let t=vO.get(e);return t||(t=await gJ(e),vO.set(e,t)),t}var _O={tsx:[["jsx_element","jsx_self_closing_element","for_statement","for_in_statement","if_statement","while_statement","do_statement","switch_statement","try_statement","with_statement","labeled_statement","class_declaration","abstract_class_declaration","interface_declaration","enum_declaration","type_alias_declaration","function_declaration","generator_function_declaration","ambient_declaration","method_definition","import_statement","export_statement","module"],["expression_statement","lexical_declaration"]],python:[["for_statement","if_statement","while_statement","match_statement","try_statement","with_statement","function_definition","decorated_definition","class_definition","import_statement","import_from_statement"]],go:[["for_statement","if_statement","expression_switch_statement","type_switch_statement","select_statement","labeled_statement","function_declaration","method_declaration","type_declaration","import_declaration","package_clause"]],rust:[["for_expression","if_expression","while_expression","loop_expression","match_expression","try_expression","function_item","type_item","enum_item","struct_item","union_item","trait_item","impl_item","use_declaration"]],ruby:[["for","if","unless","while","until","case","class","singleton_class","method","singleton_method","module"]]};var mJ=Object.keys(So);function yJ(e,t){let r=t-1;for(;r>=0&&e[r]?.match(/\s/);)r--;if(r<0)return 0;let n=e.lastIndexOf(`
`,r);if(n<0)return 0;let s=e.slice(n+1,t).search(/\S/);return n+1+s}function vJ(e,t){let r=t;for(;r<e.length&&e[r]?.match(/\s/);)r++;if(r>=e.length)return e.length;let n=e.indexOf(`
`,r);return n<0?e.length:n}function _J(e,t){for(let r of t){let n=e;for(;n;){if(r.includes(n.type))return n;n=n.parent;}}return e}function bO(){return async(e,t)=>{let{position:r,text:n,language:i,prefix:s,suffix:a}=t;if(!mJ.includes(i))throw new Error(`Language ${i} is not supported`);let o=So[i],c=await pd(o),l=s+e+a,u=c.parse(l),f=yJ(l,r),h=vJ(l,r),p=_J(u.rootNode.namedDescendantForIndex(f,h),_O[o]??[]);if(p.type=="ERROR")throw new Error("Cannot determine syntax scope.");return p.endIndex<r+e.length?(Lt.debug({languageConfig:o,text:n,updatedText:l,position:r,lineBegin:f,lineEnd:h,scope:{type:p.type,start:p.startIndex,end:p.endIndex}},"Remove content out of syntax scope"),e.slice(0,p.endIndex-r)):e}}function SO(e){return async(t,r)=>{if(e.experimentalSyntax)try{return await bO()(t,r)}catch(i){Lt.debug({error:i},"Failed to limit scope by syntax parser");}return pO(e.indentation)(t,r)}}function Zy(e){let t={"	":0,"  ":0,"    ":0};for(let r of e)if(r.match(/^\t/))t["	"]++;else {let n=r.match(/^ */)?.[0].length??0;n>0&&(n%4===0&&t["    "]++,n%2===0&&t["  "]++);}return t["	"]>0?"	":t["  "]>t["    "]?"  ":t["    "]>0?"    ":null}function bJ(e,t){return t==="	"?e.match(/^\t*/)?.[0].length??0:(e.match(/^ */)?.[0].length??0)/t.length}function EO(){return (e,t)=>{let{prefixLines:r,suffixLines:n,currentLinePrefix:i,indentation:s}=t,a=Mt(e);if(!s)return e;let o=st(i)?r.slice(0,r.length-1):r;if(r.length>1&&Zy(o)!==null)return e;let c=n.slice(1);if(n.length>1&&Zy(c)!==null)return e;let l=a.map((h,p)=>p===0?i+h:h),u=Zy(l);if(u===null||u===s)return e;let f=l.map((h,p)=>{let g=bJ(h,u);if(g===0)return a[p];let _=h.slice(u.length*g);return p===0?st(i)?s.repeat(g).slice(i.length)+_:a[0]:s.repeat(g)+_});return Lt.debug({prefixLines:r,suffixLines:n,inputLines:a,formatted:f},"Format indentation."),f.join("")}}function Jy(){return (e,t)=>{let{currentLinePrefix:r,currentLineSuffix:n}=t,i=e;return !st(r)&&r.match(/\s$/)&&(i=i.trimStart()),(st(n)||!st(n)&&n.match(/^\s/))&&(i=i.trimEnd()),i}}function wO(){return (e,t)=>{let r=Mt(e);if(t.mode==="fill-in-line"&&r.length>1){let n=t.currentLineSuffix.trimEnd(),i=r[0].trimEnd();if(i.endsWith(n)){let s=i.slice(0,-n.length);if(s.length>0)return Lt.debug({inputLines:r,trimmedInputLine:s},"Trim content with multiple lines"),s}return Lt.debug({inputLines:r},"Drop content with multiple lines"),null}return e}}function ev(){return (e,t)=>{let{suffixLines:r}=t,n=Mt(e),i=0;for(;i<n.length&&st(n[i]);)i++;let s=0;for(;s<r.length&&st(r[s]);)s++;let a=Math.min(3,n.length-i,r.length-s);if(a<1)return e;let o=n.slice(i,i+a).join("").trim(),c=r.slice(s,s+a).join("").trim(),l=Math.max(1,.05*o.length,.05*c.length),u=fo(o,c);return u<=l?(Lt.debug({inputLines:n,suffixLines:r,inputToCompare:o,suffixToCompare:c,distance:u,threshold:l},"Drop completion due to duplicated."),null):e}}function tv(){return e=>st(e)?null:e}function CO(e,t){let{currentLineSuffix:r}=t,n=r.trimEnd();if(st(n))return e;let i=e.text.slice(t.position-e.replaceRange.start),s=Ff(i).join("");return st(s)||(n.startsWith(s)?(e.replaceRange.end=t.position+s.length,Lt.trace({context:t,completion:e.text,range:e.replaceRange,unpaired:s},"Adjust replace range by bracket stack")):s.startsWith(n)&&(e.replaceRange.end=t.position+n.length,Lt.trace({context:t,completion:e.text,range:e.replaceRange,unpaired:s},"Adjust replace range by bracket stack"))),e}var SJ=Object.keys(So);async function xO(e,t){let{position:r,prefix:n,suffix:i,prefixLines:s,currentLinePrefix:a,currentLineSuffix:o,language:c}=t,l=o.trimEnd();if(st(l))return e;if(!SJ.includes(c))throw new Error(`Language ${c} is not supported`);let u=So[c],f=await pd(u),h=e.text.slice(r-e.replaceRange.start),p=Mt(h),g=0,_=f.parse(n+h+i),E=_.rootNode.namedDescendantForIndex(n.length+h.length,n.length+h.length+l.length-g);for(;E.hasError()&&g<l.length;){g++;let w=s.length-1+p.length-1,y=p[p.length-1]?.length??0;p.length==1&&(y+=a.length),_.edit({startIndex:n.length+h.length,oldEndIndex:n.length+h.length+1,newEndIndex:n.length+h.length,startPosition:{row:w,column:y},oldEndPosition:{row:w,column:y+1},newEndPosition:{row:w,column:y}}),_=f.parse(n+h+i.slice(g),_),E=_.rootNode.namedDescendantForIndex(n.length+h.length,n.length+h.length+l.length-g);}if(E.hasError())throw new Error("Syntax error when parsing completion");return e.replaceRange.end=r+g,Lt.trace({context:t,completion:e.text,range:e.replaceRange},"Adjust replace range by syntax"),e}function TO(e){return async(t,r)=>{if(e.experimentalSyntax)try{return await xO(t,r)}catch(i){Lt.debug({error:i},"Failed to calculate replace range by syntax parser");}return CO(t,r)}}async function AO(e,t,r){return Promise.resolve(r).then(on(wO(),e)).then(on(dO(),e)).then(on(ev(),e)).then(on(Jy(),e)).then(on(tv(),e))}async function RO(e,t,r){return Promise.resolve(r).then(on(lO(),e)).then(on(fO(),e)).then(on(SO(t.limitScope),e)).then(on(hO(),e)).then(on(EO(),e)).then(on(ev(),e)).then(on(Jy(),e)).then(on(tv(),e)).then(Xy(TO(t.calculateReplaceRange),e))}var lc="tabby-agent",fc="1.5.0";var gd=class{constructor(){this.anonymousUsageTrackingApi=Zs({baseUrl:"https://app.tabbyml.com/api"});this.logger=_r("AnonymousUsage");this.systemData={agent:`${lc}, ${fc}`,browser:void 0,node:`${process.version} ${process.platform} ${PO__default.default.arch()} ${PO__default.default.release()}`};this.sessionProperties={};this.userProperties={};this.userPropertiesUpdated=!1;this.emittedUniqueEvent=[];this.disabled=!1;}async init(t){if(this.dataStore=t?.dataStore,this.dataStore)if(typeof this.dataStore.data.anonymousId=="string")this.anonymousId=this.dataStore.data.anonymousId;else {this.anonymousId=fi(),this.dataStore.data.anonymousId=this.anonymousId;try{await this.dataStore.save();}catch(r){this.logger.debug({error:r},"Error when saving anonymousId");}}else this.anonymousId=fi();}setSessionProperties(t,r){Xs(this.sessionProperties,t,r);}setUserProperties(t,r){Xs(this.userProperties,t,r),this.userPropertiesUpdated=!0;}async uniqueEvent(t,r={}){await this.event(t,r,!0);}async event(t,r={},n=!1){if(this.disabled||!this.anonymousId||n&&this.emittedUniqueEvent.includes(t))return;n&&this.emittedUniqueEvent.push(t);let i={...this.systemData,...this.sessionProperties,...r};this.userPropertiesUpdated&&(Xs(i,"$set",this.userProperties),this.userPropertiesUpdated=!1);try{await this.anonymousUsageTrackingApi.POST("/usage",{body:{distinctId:this.anonymousId,event:t,properties:i}});}catch(s){this.logger.error({error:s},"Error when sending anonymous usage data");}}};var sv=ur(kO()),md=class{constructor(){this.sum=0;this.quantity=0;}add(t){this.sum+=t,this.quantity+=1;}mean(){if(this.quantity!==0)return this.sum/this.quantity}count(){return this.quantity}},yd=class{constructor(t){this.values=[];this.maxSize=t;}add(t){this.values.push(t),this.values.length>this.maxSize&&this.values.shift();}getValues(){return this.values}},vd=class{constructor(){this.config={windowSize:10,checks:{disable:!1,healthy:{windowSize:1,latency:3e3},slowResponseTime:{latency:5e3,count:1},highTimeoutRate:{rate:.5,count:1}}};this.autoCompletionCount=0;this.manualCompletionCount=0;this.cacheHitCount=0;this.cacheMissCount=0;this.eventMap=new Map;this.completionRequestLatencyStats=new sv.Univariate;this.completionRequestCanceledStats=new md;this.completionRequestTimeoutCount=0;this.recentCompletionRequestLatencies=new yd(this.config.windowSize);}add(t){let{triggerMode:r,cacheHit:n,aborted:i,requestSent:s,requestLatency:a,requestCanceled:o,requestTimeout:c}=t;i||(r==="auto"?this.autoCompletionCount+=1:this.manualCompletionCount+=1,n?this.cacheHitCount+=1:this.cacheMissCount+=1),s&&(o?this.completionRequestCanceledStats.add(a):c?this.completionRequestTimeoutCount+=1:this.completionRequestLatencyStats.add(a),o||this.recentCompletionRequestLatencies.add(a));}addEvent(t){let r=this.eventMap.get(t)||0;this.eventMap.set(t,r+1);}reset(){this.autoCompletionCount=0,this.manualCompletionCount=0,this.cacheHitCount=0,this.cacheMissCount=0,this.eventMap=new Map,this.completionRequestLatencyStats=new sv.Univariate,this.completionRequestCanceledStats=new md,this.completionRequestTimeoutCount=0;}resetWindowed(){this.recentCompletionRequestLatencies=new yd(this.config.windowSize);}stats(){let t=Object.fromEntries(Array.from(this.eventMap.entries()).map(([r,n])=>["count_"+r,n]));return {completion:{count_auto:this.autoCompletionCount,count_manual:this.manualCompletionCount,cache_hit:this.cacheHitCount,cache_miss:this.cacheMissCount,...t},completion_request:{count:this.completionRequestLatencyStats.count(),latency_avg:this.completionRequestLatencyStats.mean(),latency_p50:this.completionRequestLatencyStats.percentile(50),latency_p95:this.completionRequestLatencyStats.percentile(95),latency_p99:this.completionRequestLatencyStats.percentile(99)},completion_request_canceled:{count:this.completionRequestCanceledStats.count(),latency_avg:this.completionRequestCanceledStats.mean()},completion_request_timeout:{count:this.completionRequestTimeoutCount}}}windowed(){let t=this.recentCompletionRequestLatencies.getValues(),r=t.filter(s=>Number.isNaN(s)),n=t.filter(s=>!Number.isNaN(s)),i=n.reduce((s,a)=>s+a,0)/n.length;return {values:t,stats:{total:t.length,timeouts:r.length,responses:n.length,averageResponseTime:i}}}check(t){if(this.config.checks.disable)return null;let r=this.config.checks,{values:n,stats:{total:i,timeouts:s,responses:a,averageResponseTime:o}}=t;return n.slice(-Math.min(this.config.windowSize,r.healthy.windowSize)).every(c=>c<r.healthy.latency)?"healthy":s/i>r.highTimeoutRate.rate&&s>=r.highTimeoutRate.count?"highTimeoutRate":o>r.slowResponseTime.latency&&a>=r.slowResponseTime.count?"slowResponseTime":null}};var _F=ur(mf()),q_=ur(L_()),bF=ur(mF());var ch=_r("CaCert"),uh=[],B_;function SF(e){B_||(B_=yF__default.default.createSecureContext);let t=e.filter(n=>typeof n=="string"?n.trim().length>0:!0),r=[...uh,...t].distinct();ch.debug(`Loaded ${r.length-uh.length} extra certs.`),uh=r,yF__default.default.createSecureContext=n=>{let i=B_(n);return uh.forEach(s=>{i.context.addCACert(s);}),i};}async function vF(e){ch.debug(`Loading extra certs from ${e}.`);let t=(await e.split(F___default.default.delimiter).mapAsync(async r=>{try{return (await _F.default.readFile(r)).toString()}catch{return null}})).join(`
`).split(/(?=-----BEGIN\sCERTIFICATE-----)/g).distinct();SF(t);}async function EF(e){if(e.caCerts!=="bundled")if(e.caCerts==="system")if(process.platform==="win32")ch.debug("Loading extra certs from win-ca."),q_.default.exe(F___default.default.join("win-ca","roots.exe")),(0, q_.default)({fallback:!0,inject:"+"});else if(process.platform==="darwin"){ch.debug("Loading extra certs from mac-ca.");let t=bF.get();SF(t);}else await vF(F___default.default.join("/etc/ssl/certs/ca-certificates.crt"));else e.caCerts&&await vF(e.caCerts);}var lh=class e extends events.EventEmitter{constructor(){super();this.logger=_r("TabbyAgent");this.anonymousUsageLogger=new gd;this.config=oc;this.userConfig={};this.clientConfig={};this.serverProvidedConfig={};this.status="notInitialized";this.issues=[];this.completionCache=new fd;this.completionDebounce=new dd;this.completionProviderStats=new vd;this.tryingConnectTimer=setInterval(async()=>{this.status==="disconnected"&&(this.logger.debug("Trying to connect..."),await this.healthCheck());},e.tryConnectInterval),this.submitStatsTimer=setInterval(async()=>{await this.submitStats();},e.submitStatsInterval);}static{this.tryConnectInterval=1e3*30;}static{this.submitStatsInterval=1e3*60*60*24;}async applyConfig(){let r=this.config,n=this.status;this.config=Wl(oc,this.userConfig,this.clientConfig,this.serverProvidedConfig),ac.forEach(s=>s.level=this.config.logs.level),this.anonymousUsageLogger.disabled=this.config.anonymousUsageTracking.disable,await EF(this.config.tls),st(this.config.server.token)&&this.config.server.requestHeaders.Authorization===void 0?this.config.server.endpoint!==this.auth?.endpoint&&(this.auth=new ud(this.config.server.endpoint),await this.auth.init({dataStore:this.dataStore}),this.auth.on("updated",()=>{this.setupApi();})):this.auth=void 0,(0, Aa.default)(r.server,this.config.server)||(this.serverHealthState=void 0,this.completionProviderStats.resetWindowed(),this.popIssue("slowCompletionResponseTime"),this.popIssue("highCompletionTimeoutRate"),this.popIssue("connectionFailed"),this.connectionErrorMessage=void 0),(!this.api||!(0, Aa.default)(r.server,this.config.server))&&await this.setupApi(),(0, Aa.default)(r.server,this.config.server)||n==="unauthorized"&&this.status==="unauthorized"&&this.emitAuthRequired();let i={event:"configUpdated",config:this.config};this.logger.debug({event:i},"Config updated"),super.emit("configUpdated",i);}async setupApi(){let r=st(this.config.server.token)?this.auth?.token?`Bearer ${this.auth.token}`:void 0:`Bearer ${this.config.server.token}`;this.api=Zs({baseUrl:this.config.server.endpoint.replace(/\/+$/,""),headers:{Authorization:r,...this.config.server.requestHeaders}}),await this.healthCheck();}changeStatus(r){if(this.status!=r){this.status=r;let n={event:"statusChanged",status:r};this.logger.debug({event:n},"Status changed"),super.emit("statusChanged",n),this.status==="unauthorized"&&this.emitAuthRequired();}}issueFromName(r){switch(r){case"highCompletionTimeoutRate":return {name:"highCompletionTimeoutRate",completionResponseStats:this.completionProviderStats.windowed().stats};case"slowCompletionResponseTime":return {name:"slowCompletionResponseTime",completionResponseStats:this.completionProviderStats.windowed().stats};case"connectionFailed":return {name:"connectionFailed",message:this.connectionErrorMessage}}}pushIssue(r){this.issues.includes(r)||(this.issues.push(r),this.logger.debug({issue:r},"Issues Pushed"),this.emitIssueUpdated());}popIssue(r){let n=this.issues.indexOf(r);n>=0&&(this.issues.splice(n,1),this.logger.debug({issue:r},"Issues Popped"),this.emitIssueUpdated());}emitAuthRequired(){let r={event:"authRequired",server:this.config.server};super.emit("authRequired",r);}emitIssueUpdated(){let r={event:"issuesUpdated",issues:this.issues};super.emit("issuesUpdated",r);}async submitStats(){let r=this.completionProviderStats.stats();r.completion_request.count>0&&(await this.anonymousUsageLogger.event("AgentStats",{stats:r}),this.completionProviderStats.reset(),this.logger.debug({stats:r},"Stats submitted"));}createAbortSignal(r){let n=Math.min(2147483647,r?.timeout||this.config.server.requestTimeout);return Xu([AbortSignal.timeout(n),r?.signal])}async healthCheck(r){let n=fi(),i="/v1/health",s=this.config.server.endpoint+i,a={signal:this.createAbortSignal({signal:r?.signal})};try{if(!this.api)throw new Error("http client not initialized");this.logger.debug({requestId:n,requestOptions:a,url:s},"Health check request");let o;if(r?.method==="POST"?o=await this.api.POST(i,a):o=await this.api.GET(i,a),o.error||!o.response.ok)throw new vr(o.response);this.logger.debug({requestId:n,response:o},"Health check response"),this.popIssue("connectionFailed"),this.connectionErrorMessage=void 0;let c=o.data;typeof c=="object"&&c.model!==void 0&&c.device!==void 0&&(this.serverHealthState=c,this.anonymousUsageLogger.uniqueEvent("AgentConnected",c),this.fetchServerConfig()),this.changeStatus("ready");}catch(o){if(this.serverHealthState=void 0,o instanceof vr&&o.status==405&&r?.method!=="POST")return await this.healthCheck({method:"POST"});if(o instanceof vr&&[401,403].includes(o.status))this.logger.debug({requestId:n,error:o},"Health check error: unauthorized"),this.changeStatus("unauthorized");else {if(Zu(o))this.logger.debug({requestId:n,error:o},"Health check error: timeout"),this.connectionErrorMessage=`GET ${s}: Timed out.`;else if(Vi(o))this.logger.debug({requestId:n,error:o},"Health check error: canceled"),this.connectionErrorMessage=`GET ${s}: Canceled.`;else {this.logger.error({requestId:n,error:o},"Health check error: unknown error");let c=o instanceof Error?L0(o):JSON.stringify(o);this.connectionErrorMessage=`GET ${s}: Request failed: 
${c}`;}this.pushIssue("connectionFailed"),this.changeStatus("disconnected");}}}async fetchServerConfig(){let r=fh.coerce(this.serverHealthState?.version.git_describe);if(r&&fh.lt(r,"0.9.0")){this.logger.debug({version:this.serverHealthState?.version},"Skip fetching server config due to server version");return}let n=fi();try{if(!this.api)throw new Error("http client not initialized");let i="/v1beta/server_setting";this.logger.debug({requestId:n,url:this.config.server.endpoint+i},"Fetch server config request");let s=await this.api.GET(i);if(s.error||!s.response.ok)throw new vr(s.response);this.logger.debug({requestId:n,response:s},"Fetch server config response");let a=s.data,o={};if(a.disable_client_side_telemetry&&(o.anonymousUsageTracking={disable:!0}),!(0, Aa.default)(o,this.serverProvidedConfig)&&(this.serverProvidedConfig=o,await this.applyConfig(),this.dataStore)){this.dataStore.data.serverConfig||(this.dataStore.data.serverConfig={}),this.dataStore.data.serverConfig[this.config.server.endpoint]=this.serverProvidedConfig;try{await this.dataStore.save();}catch(c){this.logger.error({error:c},"Error when saving serverConfig");}}}catch(i){i instanceof vr&&i.status==404?this.logger.debug({requestId:n,error:i},"Fetch server config failed due to server not supported"):i instanceof vr&&[401,403].includes(i.status)?this.logger.debug({requestId:n,error:i},"Fetch server config failed due to unauthorized"):this.logger.error({requestId:n,error:i},"Fetch server config error");}}async createSegments(r){let n=this.config.completion.prompt.maxPrefixLines,i=this.config.completion.prompt.maxSuffixLines,{prefixLines:s,suffixLines:a}=r,o=s.slice(Math.max(s.length-n,0)).join(""),c;if(this.config.completion.prompt.experimentalStripAutoClosingCharacters&&r.mode!=="fill-in-line"?c=`
`+a.slice(1,i).join(""):c=a.slice(0,i).join(""),st(o))return null;let l,u,f,{workspace:h,git:p}=r;if(p&&p.remotes.length>0){let y=p.remotes.find(b=>b.name==="origin")||p.remotes.find(b=>b.name==="upstream")||p.remotes[0];y&&(l=p.root,f=y.url);}!l&&h&&(l=h),l&&(u=F___default.default.relative(l,r.filepath));let g=r.declarations?.map(y=>{let b=y.filepath;return l&&b.startsWith(l)&&(b=F___default.default.relative(l,b)),{filepath:b,body:y.text}}),_=r.relevantSnippetsFromChangedFiles?.filter(y=>!r.declarations?.find(b=>b.filepath===y.filepath&&Math.max(b.offset,y.offset)<=Math.min(b.offset+b.text.length,y.offset+y.text.length))).map(y=>{let b=y.filepath;return l&&b.startsWith(l)&&(b=F___default.default.relative(l,b)),{filepath:b,body:y.text,score:y.score}}).sort((y,b)=>b.score-y.score),E,w=this.config.completion.prompt.clipboard;return r.clipboard.length>=w.minChars&&r.clipboard.length<=w.maxChars&&(E=r.clipboard),{prefix:o,suffix:c,filepath:u,git_url:f,declarations:g,relevant_snippets_from_changed_files:_,clipboard:E}}async initialize(r){if(r.loggers&&(jy.loggers=r.loggers),this.dataStore=r.dataStore??N0,this.dataStore)try{await this.dataStore.load(),"watch"in this.dataStore&&typeof this.dataStore.watch=="function"&&this.dataStore.watch();}catch(n){this.logger.debug({error:n},"No stored data loaded.");}if(await this.anonymousUsageLogger.init({dataStore:this.dataStore}),r.clientProperties){let{user:n,session:i}=r.clientProperties;ac.forEach(s=>s.setBindings?.({...i})),i&&Object.entries(i).forEach(([s,a])=>{this.anonymousUsageLogger.setSessionProperties(s,a);}),n&&Object.entries(n).forEach(([s,a])=>{this.anonymousUsageLogger.setUserProperties(s,a);});}if(vo&&(await vo.load(),this.userConfig=vo.config,vo.on("updated",async n=>{this.userConfig=n,await this.applyConfig();}),vo.watch()),r.config&&(this.clientConfig=r.config),this.dataStore){let n=Wl(oc,this.userConfig,this.clientConfig);this.serverProvidedConfig=this.dataStore?.data.serverConfig?.[n.server.endpoint]??{},this.dataStore instanceof events.EventEmitter&&this.dataStore.on("updated",async()=>{let i=Wl(oc,this.userConfig,this.clientConfig),s=N0?.data.serverConfig?.[i.server.endpoint];(0, Aa.default)(s,this.serverProvidedConfig)||(this.serverProvidedConfig=s??{},await this.applyConfig());});}return await this.applyConfig(),await this.anonymousUsageLogger.uniqueEvent("AgentInitialized"),this.logger.debug({options:r},"Initialized"),this.status!=="notInitialized"}async finalize(){return this.status==="finalized"?!1:(await this.submitStats(),this.tryingConnectTimer&&clearInterval(this.tryingConnectTimer),this.submitStatsTimer&&clearInterval(this.submitStatsTimer),this.changeStatus("finalized"),!0)}async updateClientProperties(r,n,i){switch(r){case"session":ac.forEach(s=>s.setBindings?.(Xs({},n,i))),this.anonymousUsageLogger.setSessionProperties(n,i);break;case"user":this.anonymousUsageLogger.setUserProperties(n,i);break}return !0}async updateConfig(r,n){let i=Kl(this.clientConfig,r);return (0, Aa.default)(i,n)||(n===void 0?Gl(this.clientConfig,r):Xs(this.clientConfig,r,n),await this.applyConfig()),!0}async clearConfig(r){return await this.updateConfig(r,void 0)}getConfig(){return this.config}getStatus(){return this.status}getIssues(){return this.issues}getIssueDetail(r){let n=this.getIssues();return r.index!==void 0&&r.index<n.length?this.issueFromName(n[r.index]):r.name!==void 0&&this.issues.includes(r.name)?this.issueFromName(r.name):null}getServerHealthState(){return this.serverHealthState??null}async requestAuthUrl(r){if(this.status==="notInitialized")throw new Error("Agent is not initialized");return await this.healthCheck(r),this.status!=="unauthorized"||!this.auth?null:await this.auth.requestAuthUrl(r)}async waitForAuthToken(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.status!=="unauthorized"||!this.auth||(await this.auth.pollingToken(r,n),await this.setupApi());}async provideCompletions(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.logger.trace({request:r},"Call provideCompletions"),this.nonParallelProvideCompletionAbortController&&this.nonParallelProvideCompletionAbortController.abort(),this.nonParallelProvideCompletionAbortController=new AbortController;let i=Xu([this.nonParallelProvideCompletionAbortController.signal,n?.signal]),s,a={triggerMode:r.manually?"manual":"auto",cacheHit:!1,aborted:!1,requestSent:!1,requestLatency:0,requestCanceled:!1,requestTimeout:!1},o,c=new pa(r);try{if(this.completionCache.has(c))a.cacheHit=!0,this.logger.debug({context:c},"Completion cache hit"),await this.completionDebounce.debounce({request:r,config:this.config.completion.debounce,responseTime:0},{signal:i}),s=this.completionCache.get(c);else {a.cacheHit=!1;let l=await this.createSegments(c);if(!l)a=void 0,this.logger.debug("Can not build segments, returning empty completion response"),s={id:"agent-"+fi(),choices:[]};else {await this.completionDebounce.debounce({request:r,config:this.config.completion.debounce,responseTime:this.completionProviderStats.windowed().stats.averageResponseTime},n);let u=fi();a.requestSent=!0,o=performance.now();try{if(!this.api)throw new Error("http client not initialized");let f="/v1/completions",h={body:{language:r.language,segments:l,user:this.auth?.user},signal:this.createAbortSignal({signal:i})};this.logger.debug({requestId:u,requestOptions:h,url:this.config.server.endpoint+f},"Completion request");let p=await this.api.POST(f,h);if(p.error||!p.response.ok)throw new vr(p.response);this.logger.debug({requestId:u,response:p},"Completion response");let g=p.data;a.requestLatency=performance.now()-o,s={id:g.id,choices:g.choices.map(_=>({index:_.index,text:_.text,replaceRange:{start:r.position,end:r.position}}))};}catch(f){throw Vi(f)?(this.logger.debug({requestId:u,error:f},"Completion request canceled"),a.requestCanceled=!0,a.requestLatency=performance.now()-o):Zu(f)?(this.logger.debug({requestId:u,error:f},"Completion request timeout"),a.requestTimeout=!0,a.requestLatency=NaN):(this.logger.error({requestId:u,error:f},"Completion request failed with unknown error"),this.healthCheck()),f}if(s=await AO(c,this.config.postprocess,s),i.aborted)throw i.reason;this.completionCache.buildCache(c,JSON.parse(JSON.stringify(s)));}}if(s=await RO(c,this.config.postprocess,s),i.aborted)throw i.reason}catch(l){throw Vi(l)||Zu(l)?a&&(a.aborted=!0):a=void 0,l}finally{if(a&&(this.completionProviderStats.add(a),a.requestSent&&!a.requestCanceled)){let l=this.completionProviderStats.windowed();switch(this.completionProviderStats.check(l)){case"healthy":this.popIssue("slowCompletionResponseTime"),this.popIssue("highCompletionTimeoutRate");break;case"highTimeoutRate":this.popIssue("slowCompletionResponseTime"),this.pushIssue("highCompletionTimeoutRate");break;case"slowResponseTime":this.popIssue("highCompletionTimeoutRate"),this.pushIssue("slowCompletionResponseTime");break}}}return this.logger.trace({context:c,completionResponse:s},"Return from provideCompletions"),s}async postEvent(r,n){if(this.status==="notInitialized")throw new Error("Agent is not initialized");this.completionProviderStats.addEvent(r.type);let i=fi();try{if(!this.api)throw new Error("http client not initialized");let s="/v1/events",a={body:r,params:{query:{select_kind:r.select_kind}},signal:this.createAbortSignal(n),parseAs:"text"};this.logger.debug({requestId:i,requestOptions:a,url:this.config.server.endpoint+s},"Event request");let o=await this.api.POST(s,a);if(o.error||!o.response.ok)throw new vr(o.response);return this.logger.debug({requestId:i,response:o},"Event response"),!0}catch(s){return Zu(s)?this.logger.debug({requestId:i,error:s},"Event request timeout"):Vi(s)?this.logger.debug({requestId:i,error:s},"Event request canceled"):this.logger.error({requestId:i,error:s},"Event request failed with unknown error"),!1}}};var CF=["statusChanged","configUpdated","authRequired","issuesUpdated"];var dh=class{constructor(){this.process=process;this.inStream=process.stdin;this.outStream=process.stdout;this.logger=_r("JsonLineServer");this.abortControllers={};}async handleLine(t){let r;try{r=JSON.parse(t);}catch(i){this.logger.error({error:i},`Failed to parse request: ${t}`);return}this.logger.debug({request:r},"Received request");let n=await this.handleRequest(r);this.sendResponse(n),this.logger.debug({response:n},"Sent response");}async handleRequest(t){let r=0,n=[0,null],i=new AbortController;try{if(!this.agent)throw new Error(`Agent not bound.
`);r=t[0],n[0]=r;let s=t[1].func;if(s==="cancelRequest")n[1]=this.cancelRequest(t);else {let a=this.agent[s];if(!a)throw new Error(`Unknown function: ${s}`);let o=t[1].args;o.length>0&&typeof o[o.length-1]=="object"&&o[o.length-1].signal&&(this.abortControllers[r]=i,o[o.length-1].signal=i.signal),n[1]=await a.apply(this.agent,o);}}catch(s){Vi(s)?this.logger.debug({error:s,request:t},"Request canceled"):this.logger.error({error:s,request:t},"Failed to handle request");}finally{this.abortControllers[r]&&delete this.abortControllers[r];}return n}cancelRequest(t){let r=t[1].args[0],n=this.abortControllers[r];return n?(n.abort(),!0):!1}sendResponse(t){this.outStream.write(JSON.stringify(t)+`
`);}bind(t){this.agent=t;for(let r of CF)this.agent.on(r,n=>{this.sendResponse([0,n]);});}listen(){Bne__default.default.createInterface({input:this.inStream}).on("line",t=>{this.handleLine(t);}),["SIGTERM","SIGINT"].forEach(t=>{this.process.on(t,async()=>{this.agent&&this.agent.getStatus()!=="finalized"&&await this.agent.finalize(),this.process.exit(0);});});}};var Oi=ur(z3());var Ip=class e{constructor(t,r,n,i){this._uri=t,this._languageId=r,this._version=n,this._content=i,this._lineOffsets=void 0;}get uri(){return this._uri}get languageId(){return this._languageId}get version(){return this._version}getText(t){if(t){let r=this.offsetAt(t.start),n=this.offsetAt(t.end);return this._content.substring(r,n)}return this._content}update(t,r){for(let n of t)if(e.isIncremental(n)){let i=Q3(n.range),s=this.offsetAt(i.start),a=this.offsetAt(i.end);this._content=this._content.substring(0,s)+n.text+this._content.substring(a,this._content.length);let o=Math.max(i.start.line,0),c=Math.max(i.end.line,0),l=this._lineOffsets,u=Y3(n.text,!1,s);if(c-o===u.length)for(let h=0,p=u.length;h<p;h++)l[h+o+1]=u[h];else u.length<1e4?l.splice(o+1,c-o,...u):this._lineOffsets=l=l.slice(0,o+1).concat(u,l.slice(c+1));let f=n.text.length-(a-s);if(f!==0)for(let h=o+1+u.length,p=l.length;h<p;h++)l[h]=l[h]+f;}else if(e.isFull(n))this._content=n.text,this._lineOffsets=void 0;else throw new Error("Unknown change event received");this._version=r;}getLineOffsets(){return this._lineOffsets===void 0&&(this._lineOffsets=Y3(this._content,!0)),this._lineOffsets}positionAt(t){t=Math.max(Math.min(t,this._content.length),0);let r=this.getLineOffsets(),n=0,i=r.length;if(i===0)return {line:0,character:t};for(;n<i;){let a=Math.floor((n+i)/2);r[a]>t?i=a:n=a+1;}let s=n-1;return {line:s,character:t-r[s]}}offsetAt(t){let r=this.getLineOffsets();if(t.line>=r.length)return this._content.length;if(t.line<0)return 0;let n=r[t.line],i=t.line+1<r.length?r[t.line+1]:this._content.length;return Math.max(Math.min(n+t.character,i),n)}get lineCount(){return this.getLineOffsets().length}static isIncremental(t){let r=t;return r!=null&&typeof r.text=="string"&&r.range!==void 0&&(r.rangeLength===void 0||typeof r.rangeLength=="number")}static isFull(t){let r=t;return r!=null&&typeof r.text=="string"&&r.range===void 0&&r.rangeLength===void 0}},Pp;(function(e){function t(i,s,a,o){return new Ip(i,s,a,o)}e.create=t;function r(i,s,a){if(i instanceof Ip)return i.update(s,a),i;throw new Error("TextDocument.update: document must be created by TextDocument.create")}e.update=r;function n(i,s){let a=i.getText(),o=MS(s.map(Zse),(u,f)=>{let h=u.range.start.line-f.range.start.line;return h===0?u.range.start.character-f.range.start.character:h}),c=0,l=[];for(let u of o){let f=i.offsetAt(u.range.start);if(f<c)throw new Error("Overlapping edit");f>c&&l.push(a.substring(c,f)),u.newText.length&&l.push(u.newText),c=i.offsetAt(u.range.end);}return l.push(a.substr(c)),l.join("")}e.applyEdits=n;})(Pp||(Pp={}));function MS(e,t){if(e.length<=1)return e;let r=e.length/2|0,n=e.slice(0,r),i=e.slice(r);MS(n,t),MS(i,t);let s=0,a=0,o=0;for(;s<n.length&&a<i.length;)t(n[s],i[a])<=0?e[o++]=n[s++]:e[o++]=i[a++];for(;s<n.length;)e[o++]=n[s++];for(;a<i.length;)e[o++]=i[a++];return e}function Y3(e,t,r=0){let n=t?[r]:[];for(let i=0;i<e.length;i++){let s=e.charCodeAt(i);(s===13||s===10)&&(s===13&&i+1<e.length&&e.charCodeAt(i+1)===10&&i++,n.push(r+i+1));}return n}function Q3(e){let t=e.start,r=e.end;return t.line>r.line||t.line===r.line&&t.character>r.character?{start:r,end:t}:e}function Zse(e){let t=Q3(e.range);return t!==e.range?{newText:e.newText,range:t}:e}var Np=class{constructor(){this.connection=(0, Oi.createConnection)();this.documents=new Oi.TextDocuments(Pp);this.logger=_r("LspServer");this.connection.onInitialize(async t=>await this.initialize(t)),this.connection.onShutdown(async()=>await this.shutdown()),this.connection.onExit(async()=>this.exit()),this.connection.onCompletion(async t=>await this.completion(t));}bind(t){this.agent=t,this.agent.on("statusChanged",r=>{(r.status==="disconnected"||r.status==="unauthorized")&&this.showMessage({type:Oi.MessageType.Warning,message:`Tabby agent status: ${r.status}`});});}listen(){this.documents.listen(this.connection),this.connection.listen();}async initialize(t){if(this.logger.debug({params:t},"LSP: initialize: request"),!this.agent)throw new Error(`Agent not bound.
`);let{clientInfo:r,capabilities:n}=t;return await this.agent.initialize({clientProperties:{session:{client:`${r?.name} ${r?.version??""}`,ide:{name:r?.name,version:r?.version},tabby_plugin:{name:`${lc} (LSP)`,version:fc}}}}),{capabilities:{textDocumentSync:{openClose:!0,change:Oi.TextDocumentSyncKind.Incremental},completionProvider:{}},serverInfo:{name:lc,version:fc}}}async shutdown(){if(this.logger.debug("LSP: shutdown: request"),!this.agent)throw new Error(`Agent not bound.
`);await this.agent.finalize();}exit(){return this.logger.debug("LSP: exit: request"),process.exit(0)}async showMessage(t){this.logger.debug({params:t},"LSP server notification: window/showMessage"),await this.connection.sendNotification("window/showMessage",t);}async completion(t){if(this.logger.debug({params:t},"LSP: textDocument/completion: request"),!this.agent)throw new Error(`Agent not bound.
`);try{let r=this.buildCompletionRequest(t),n=await this.agent.provideCompletions(r),i=this.toCompletionList(n,t);return this.logger.debug({completionList:i},"LSP: textDocument/completion: response"),i}catch(r){Vi(r)?this.logger.debug({error:r},"LSP: textDocument/completion: canceled"):this.logger.error({error:r},"LSP: textDocument/completion: error");}return {isIncomplete:!0,items:[]}}buildCompletionRequest(t,r=!1){let{textDocument:n,position:i}=t,s=this.documents.get(n.uri);return {filepath:s.uri,language:s.languageId,text:s.getText(),position:s.offsetAt(i),manually:r}}toCompletionList(t,r){let{textDocument:n,position:i}=r,s=this.documents.get(n.uri),a=s.getText({start:{line:i.line,character:0},end:i}),o=a.match(/(\w+)$/)?.[0]??"";return {isIncomplete:!0,items:t.choices.map(c=>{let l=c.text.slice(s.offsetAt(i)-c.replaceRange.start),u=Mt(l),f=u[0]||"",h=u[1]||"";return {label:o+f,labelDetails:{detail:h,description:"Tabby"},kind:Oi.CompletionItemKind.Text,documentation:{kind:"markdown",value:`\`\`\`
${a+l}
\`\`\`
 ---
Suggested by Tabby.`},textEdit:{newText:o+l,range:{start:{line:i.line,character:i.character-o.length},end:s.positionAt(c.replaceRange.end)}},data:{completionId:t.id,choiceIndex:c.index}}})}}};var Jse=process.argv.slice(2),Dp;Jse.indexOf("--lsp")>=0?Dp=new Np:Dp=new dh;var eae=new lh;Dp.bind(eae);Dp.listen();
/*! Bundled license information:

normalize-path/index.js:
  (*!
   * normalize-path <https://github.com/jonschlinkert/normalize-path>
   *
   * Copyright (c) 2014-2018, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-extglob/index.js:
  (*!
   * is-extglob <https://github.com/jonschlinkert/is-extglob>
   *
   * Copyright (c) 2014-2016, Jon Schlinkert.
   * Licensed under the MIT License.
   *)

is-glob/index.js:
  (*!
   * is-glob <https://github.com/jonschlinkert/is-glob>
   *
   * Copyright (c) 2014-2017, Jon Schlinkert.
   * Released under the MIT License.
   *)

is-number/index.js:
  (*!
   * is-number <https://github.com/jonschlinkert/is-number>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

to-regex-range/index.js:
  (*!
   * to-regex-range <https://github.com/micromatch/to-regex-range>
   *
   * Copyright (c) 2015-present, Jon Schlinkert.
   * Released under the MIT License.
   *)

fill-range/index.js:
  (*!
   * fill-range <https://github.com/jonschlinkert/fill-range>
   *
   * Copyright (c) 2014-present, Jon Schlinkert.
   * Licensed under the MIT License.
   *)
*/
//# sourceMappingURL=out.js.map
//# sourceMappingURL=cli.js.map